/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/event","vs/base/common/types","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/functional","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/objects","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(B){for(var n=[],P=0,t=B.length;P<t;P++)n[P]=ee[B[P]];return n},Pe=this,Re=typeof global=="object"?global:{},le;(function(B){B.global=Pe;var n=function(){function P(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(P.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),P.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=P._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},P._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},P}();B.Environment=n})(le||(le={}));var le;(function(B){var n=function(){function F(a,A,d){this.type=a,this.detail=A,this.timestamp=d}return F}();B.LoaderEvent=n;var P=function(){function F(a){this._events=[new n(1,"",a)]}return F.prototype.record=function(a,A){this._events.push(new n(a,A,B.Utilities.getHighPerformanceTimestamp()))},F.prototype.getEvents=function(){return this._events},F}();B.LoaderEventRecorder=P;var t=function(){function F(){}return F.prototype.record=function(a,A){},F.prototype.getEvents=function(){return[]},F.INSTANCE=new F,F}();B.NullLoaderEventRecorder=t})(le||(le={}));var le;(function(B){var n=function(){function P(){}return P.fileUriToFilePath=function(t,F){if(F=decodeURI(F).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(F))return F.substr(8);if(/^file:\/\//.test(F))return F.substr(5)}else if(/^file:\/\//.test(F))return F.substr(7);return F},P.startsWith=function(t,F){return t.length>=F.length&&t.substr(0,F.length)===F},P.endsWith=function(t,F){return t.length>=F.length&&t.substr(t.length-F.length)===F},P.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},P.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},P.forEachProperty=function(t,F){if(t){var a=void 0;for(a in t)t.hasOwnProperty(a)&&F(a,t[a])}},P.isEmpty=function(t){var F=!0;return P.forEachProperty(t,function(){F=!1}),F},P.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var F=Array.isArray(t)?[]:{};return P.forEachProperty(t,function(a,A){A&&typeof A=="object"?F[a]=P.recursiveClone(A):F[a]=A}),F},P.generateAnonymousModule=function(){return"===anonymous"+P.NEXT_ANONYMOUS_ID+++"==="},P.isAnonymousModule=function(t){return P.startsWith(t,"===anonymous")},P.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()},P.NEXT_ANONYMOUS_ID=1,P.PERFORMANCE_NOW_PROBED=!1,P.HAS_PERFORMANCE_NOW=!1,P}();B.Utilities=n})(le||(le={}));var le;(function(B){function n(F){if(F instanceof Error)return F;var a=new Error(F.message||String(F)||"Unknown Error");return F.stack&&(a.stack=F.stack),a}B.ensureError=n;var P=function(){function F(){}return F.validateConfigurationOptions=function(a){function A(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory method of "'+o.moduleId+'" has thrown an exception'),console.error(o);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError=="undefined"&&(a.catchError=!1),typeof a.recordStats=="undefined"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=A),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(B.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags=="undefined"&&(a.preferScriptTags=!1),Array.isArray(a.nodeModules)||(a.nodeModules=[]),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){var d=n(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",a.onError(d),a.nodeCachedData=void 0}return a},F.mergeConfigurationOptions=function(a,A){a===void 0&&(a=null),A===void 0&&(A=null);var d=B.Utilities.recursiveClone(A||{});return B.Utilities.forEachProperty(a,function(o,c){o==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules!="undefined"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(c):o==="paths"&&typeof d.paths!="undefined"?B.Utilities.forEachProperty(c,function(N,y){return d.paths[N]=y}):o==="config"&&typeof d.config!="undefined"?B.Utilities.forEachProperty(c,function(N,y){return d.config[N]=y}):d[o]=B.Utilities.recursiveClone(c)}),F.validateConfigurationOptions(d)},F}();B.ConfigurationOptionsUtil=P;var t=function(){function F(a,A){if(this._env=a,this.options=P.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var d=this.options.nodeRequire.main.filename,o=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var d=this.options.nodeMain,o=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,o+1)}}}return F.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0},F.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var a=0,A=this.options.nodeModules;a<A.length;a++){var d=A[a];this.nodeModulesMap[d]=!0}},F.prototype._createSortedPathsRules=function(){var a=this;this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,function(A,d){Array.isArray(d)?a.sortedPathsRules.push({from:A,to:d}):a.sortedPathsRules.push({from:A,to:[d]})}),this.sortedPathsRules.sort(function(A,d){return d.from.length-A.from.length})},F.prototype.cloneAndMerge=function(a){return new F(this._env,P.mergeConfigurationOptions(a,this.options))},F.prototype.getOptionsLiteral=function(){return this.options},F.prototype._applyPaths=function(a){for(var A,d=0,o=this.sortedPathsRules.length;d<o;d++)if(A=this.sortedPathsRules[d],B.Utilities.startsWith(a,A.from)){for(var c=[],N=0,y=A.to.length;N<y;N++)c.push(A.to[N]+a.substr(A.from.length));return c}return[a]},F.prototype._addUrlArgsToUrl=function(a){return B.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs},F.prototype._addUrlArgsIfNecessaryToUrl=function(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a},F.prototype._addUrlArgsIfNecessaryToUrls=function(a){if(this.options.urlArgs)for(var A=0,d=a.length;A<d;A++)a[A]=this._addUrlArgsToUrl(a[A]);return a},F.prototype.moduleIdToPaths=function(a){if(this._env.isNode){var A=this.nodeModulesMap[a]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a);if(A)return this.isBuild()?["empty:"]:["node|"+a]}var d=a,o;if(!B.Utilities.endsWith(d,".js")&&!B.Utilities.isAbsolutePath(d)){o=this._applyPaths(d);for(var c=0,N=o.length;c<N;c++)this.isBuild()&&o[c]==="empty:"||(B.Utilities.isAbsolutePath(o[c])||(o[c]=this.options.baseUrl+o[c]),!B.Utilities.endsWith(o[c],".js")&&!B.Utilities.containsQueryString(o[c])&&(o[c]=o[c]+".js"))}else!B.Utilities.endsWith(d,".js")&&!B.Utilities.containsQueryString(d)&&(d=d+".js"),o=[d];return this._addUrlArgsIfNecessaryToUrls(o)},F.prototype.requireToUrl=function(a){var A=a;return B.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],B.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)},F.prototype.isBuild=function(){return this.options.isBuild},F.prototype.isDuplicateMessageIgnoredFor=function(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)},F.prototype.getConfigForModule=function(a){if(this.options.config)return this.options.config[a]},F.prototype.shouldCatchError=function(){return this.options.catchError},F.prototype.shouldRecordStats=function(){return this.options.recordStats},F.prototype.onError=function(a){this.options.onError(a)},F}();B.Configuration=t})(le||(le={}));var le;(function(B){var n=function(){function o(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(c,N,y,w){var _=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new F;else if(this._env.isElectronRenderer){var e=c.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new P:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new P;var L={callback:y,errorback:w};if(this._callbackMap.hasOwnProperty(N)){this._callbackMap[N].push(L);return}this._callbackMap[N]=[L],this._scriptLoader.load(c,N,function(){return _.triggerCallback(N)},function(C){return _.triggerErrorback(N,C)})},o.prototype.triggerCallback=function(c){var N=this._callbackMap[c];delete this._callbackMap[c];for(var y=0;y<N.length;y++)N[y].callback()},o.prototype.triggerErrorback=function(c,N){var y=this._callbackMap[c];delete this._callbackMap[c];for(var w=0;w<y.length;w++)y[w].errorback(N)},o}(),P=function(){function o(){}return o.prototype.attachListeners=function(c,N,y){var w=function(){c.removeEventListener("load",_),c.removeEventListener("error",e)},_=function(L){w(),N()},e=function(L){w(),y(L)};c.addEventListener("load",_),c.addEventListener("error",e)},o.prototype.load=function(c,N,y,w){if(/^node\|/.test(N)){var _=c.getConfig().getOptionsLiteral(),e=A(c.getRecorder(),_.nodeRequire||B.global.nodeRequire),L=N.split("|"),C=null;try{C=e(L[1])}catch(s){w(s);return}c.enqueueDefineAnonymousModule([],function(){return C}),y()}else{var v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript"),this.attachListeners(v,y,w);var h=c.getConfig().getOptionsLiteral().trustedTypesPolicy;h&&(N=h.createScriptURL(N)),v.setAttribute("src",N);var i=c.getConfig().getOptionsLiteral().cspNonce;i&&v.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(v)}},o}();function t(o){var c=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var N=c?self.eval(c.createScript("","true")):new Function("true");return N.call(self),!0}catch{return!1}}var F=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(c)),this._cachedCanUseEval},o.prototype.load=function(c,N,y,w){if(/^node\|/.test(N)){var _=c.getConfig().getOptionsLiteral(),e=A(c.getRecorder(),_.nodeRequire||B.global.nodeRequire),L=N.split("|"),C=null;try{C=e(L[1])}catch(i){w(i);return}c.enqueueDefineAnonymousModule([],function(){return C}),y()}else{var v=c.getConfig().getOptionsLiteral().trustedTypesPolicy,h=/^((http:)|(https:)|(file:))/.test(N)&&N.substring(0,self.origin.length)!==self.origin;if(!h&&this._canUseEval(c)){fetch(N).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+N;var s=v?self.eval(v.createScript("",i)):new Function(i);s.call(self),y()}).then(void 0,w);return}try{v&&(N=v.createScriptURL(N)),importScripts(N),y()}catch(i){w(i)}}},o}(),a=function(){function o(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},o.prototype._initNodeRequire=function(c,N){var y=N.getConfig().getOptionsLiteral().nodeCachedData;if(!y||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,_=c("module");function e(L){var C=L.constructor,v=function(i){try{return L.require(i)}finally{}};return v.resolve=function(i,s){return C._resolveFilename(i,L,!1,s)},v.resolve.paths=function(i){return C._resolveLookupPaths(i,L)},v.main=process.mainModule,v.extensions=C._extensions,v.cache=C._cache,v}_.prototype._compile=function(L,C){var v=_.wrap(L.replace(/^#!.*/,"")),h=N.getRecorder(),i=w._getCachedDataPath(y,C),s={filename:C},f;try{var b=w._fs.readFileSync(i);f=b.slice(0,16),s.cachedData=b.slice(16),h.record(60,i)}catch{h.record(61,i)}var p=new w._vm.Script(v,s),m=p.runInThisContext(s),l=w._path.dirname(C),g=e(this),u=[this.exports,g,this,C,l,process,Re,Buffer],M=m.apply(this.exports,u);return w._handleCachedData(p,v,i,!s.cachedData,N),w._verifyCachedData(p,v,i,f,N),M}},o.prototype.load=function(c,N,y,w){var _=this,e=c.getConfig().getOptionsLiteral(),L=A(c.getRecorder(),e.nodeRequire||B.global.nodeRequire),C=e.nodeInstrumenter||function(m){return m};this._init(L),this._initNodeRequire(L,c);var v=c.getRecorder();if(/^node\|/.test(N)){var h=N.split("|"),i=null;try{i=L(h[1])}catch(m){w(m);return}c.enqueueDefineAnonymousModule([],function(){return i}),y()}else{N=B.Utilities.fileUriToFilePath(this._env.isWindows,N);var s=this._path.normalize(N),f=this._getElectronRendererScriptPathOrUri(s),b=Boolean(e.nodeCachedData),p=b?this._getCachedDataPath(e.nodeCachedData,N):void 0;this._readSourceAndCachedData(s,p,v,function(m,l,g,u){if(m){w(m);return}var M;l.charCodeAt(0)===o._BOM?M=o._PREFIX+l.substring(1)+o._SUFFIX:M=o._PREFIX+l+o._SUFFIX,M=C(M,s);var S={filename:f,cachedData:g},R=_._createAndEvalScript(c,M,S,y,w);_._handleCachedData(R,M,p,b&&!g,c),_._verifyCachedData(R,M,p,u,c)})}},o.prototype._createAndEvalScript=function(c,N,y,w,_){var e=c.getRecorder();e.record(31,y.filename);var L=new this._vm.Script(N,y),C=L.runInThisContext(y),v=c.getGlobalAMDDefineFunc(),h=!1,i=function(){return h=!0,v.apply(null,arguments)};return i.amd=v.amd,C.call(B.global,c.getGlobalAMDRequireFunc(),i,y.filename,this._path.dirname(y.filename)),e.record(32,y.filename),h?w():_(new Error("Didn't receive define call in "+y.filename+"!")),L},o.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var N=c.match(/^([a-z])\:(.*)/i);return N?"file:///"+(N[1].toUpperCase()+":"+N[2]).replace(/\\/g,"/"):"file://"+c},o.prototype._getCachedDataPath=function(c,N){var y=this._crypto.createHash("md5").update(N,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(N).replace(/\.js$/,"");return this._path.join(c.path,w+"-"+y+".code")},o.prototype._handleCachedData=function(c,N,y,w,_){var e=this;c.cachedDataRejected?this._fs.unlink(y,function(L){_.getRecorder().record(62,y),e._createAndWriteCachedData(c,N,y,_),L&&_.getConfig().onError(L)}):w&&this._createAndWriteCachedData(c,N,y,_)},o.prototype._createAndWriteCachedData=function(c,N,y,w){var _=this,e=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,C=0,v=void 0,h=function(){setTimeout(function(){v||(v=_._crypto.createHash("md5").update(N,"utf8").digest());var i=c.createCachedData();if(!(i.length===0||i.length===L||C>=5)){if(i.length<L){h();return}L=i.length,_._fs.writeFile(y,Buffer.concat([v,i]),function(s){s&&w.getConfig().onError(s),w.getRecorder().record(63,y),h()})}},e*Math.pow(4,C++))};h()},o.prototype._readSourceAndCachedData=function(c,N,y,w){if(!N)this._fs.readFile(c,{encoding:"utf8"},w);else{var _=void 0,e=void 0,L=void 0,C=2,v=function(h){h?w(h):--C==0&&w(void 0,_,e,L)};this._fs.readFile(c,{encoding:"utf8"},function(h,i){_=i,v(h)}),this._fs.readFile(N,function(h,i){!h&&i&&i.length>0?(L=i.slice(0,16),e=i.slice(16),y.record(60,N)):y.record(61,N),v()})}},o.prototype._verifyCachedData=function(c,N,y,w,_){var e=this;!w||c.cachedDataRejected||setTimeout(function(){var L=e._crypto.createHash("md5").update(N,"utf8").digest();w.equals(L)||(_.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+y+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(y,function(C){C&&_.getConfig().onError(C)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function A(o,c){if(c.__$__isRecorded)return c;var N=function(w){o.record(33,w);try{return c(w)}finally{o.record(34,w)}};return N.__$__isRecorded=!0,N}B.ensureRecordedNodeRequire=A;function d(o){return new n(o)}B.createScriptLoader=d})(le||(le={}));var le;(function(B){var n=function(){function d(o){var c=o.lastIndexOf("/");c!==-1?this.fromModulePath=o.substr(0,c+1):this.fromModulePath=""}return d._normalizeModuleId=function(o){var c=o,N;for(N=/\/\.\//;N.test(c);)c=c.replace(N,"/");for(c=c.replace(/^\.\//g,""),N=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;N.test(c);)c=c.replace(N,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},d.prototype.resolveModule=function(o){var c=o;return B.Utilities.isAbsolutePath(c)||(B.Utilities.startsWith(c,"./")||B.Utilities.startsWith(c,"../"))&&(c=d._normalizeModuleId(this.fromModulePath+c)),c},d.ROOT=new d(""),d}();B.ModuleIdResolver=n;var P=function(){function d(o,c,N,y,w,_){this.id=o,this.strId=c,this.dependencies=N,this._callback=y,this._errorback=w,this.moduleIdResolver=_,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return d._safeInvokeFunction=function(o,c){try{return{returnedValue:o.apply(B.global,c),producedError:null}}catch(N){return{returnedValue:null,producedError:N}}},d._invokeFactory=function(o,c,N,y){return o.isBuild()&&!B.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:o.shouldCatchError()?this._safeInvokeFunction(N,y):{returnedValue:N.apply(B.global,y),producedError:null}},d.prototype.complete=function(o,c,N){this._isComplete=!0;var y=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var w=d._invokeFactory(c,this.strId,this._callback,N);y=w.producedError,o.record(22,this.strId),!y&&typeof w.returnedValue!="undefined"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=w.returnedValue)}else this.exports=this._callback;if(y){var _=B.ensureError(y);_.phase="factory",_.moduleId=this.strId,this.error=_,c.onError(_)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},d.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},d.prototype.isComplete=function(){return this._isComplete},d}();B.Module=P;var t=function(){function d(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return d.prototype.getMaxModuleId=function(){return this._nextId},d.prototype.getModuleId=function(o){var c=this._strModuleIdToIntModuleId.get(o);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(o,c),this._intModuleIdToStrModuleId[c]=o),c},d.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},d}(),F=function(){function d(o){this.id=o}return d.EXPORTS=new d(0),d.MODULE=new d(1),d.REQUIRE=new d(2),d}();B.RegularDependency=F;var a=function(){function d(o,c,N){this.id=o,this.pluginId=c,this.pluginParam=N}return d}();B.PluginDependency=a;var A=function(){function d(o,c,N,y,w){w===void 0&&(w=0),this._env=o,this._scriptLoader=c,this._loaderAvailableTimestamp=w,this._defineFunc=N,this._requireFunc=y,this._moduleIdProvider=new t,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return d.prototype.reset=function(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},d.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},d.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},d._findRelevantLocationInStack=function(o,c){for(var N=function(s){return s.replace(/\\/g,"/")},y=N(o),w=c.split(/\n/),_=0;_<w.length;_++){var e=w[_].match(/(.*):(\d+):(\d+)\)?$/);if(e){var L=e[1],C=e[2],v=e[3],h=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(h),L=N(L),L===y){var i={line:parseInt(C,10),col:parseInt(v,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+o)},d.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],c=0,N=0,y=this._modules2.length;N<y;N++){var w=this._modules2[N];if(!!w){var _=this._buildInfoPath[w.id]||null,e=this._buildInfoDefineStack[w.id]||null,L=this._buildInfoDependencies[w.id];o[c++]={id:w.strId,path:_,defineLocation:_&&e?d._findRelevantLocationInStack(_,e):null,dependencies:L,shim:null,exports:w.exports}}}return o},d.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder},d.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},d.prototype.enqueueDefineAnonymousModule=function(o,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var N=null;this._config.isBuild()&&(N=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:N,dependencies:o,callback:c}},d.prototype.defineModule=function(o,c,N,y,w,_){var e=this;_===void 0&&(_=new n(o));var L=this._moduleIdProvider.getModuleId(o);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var C=new P(L,o,this._normalizeDependencies(c,_),N,y,_);this._modules2[L]=C,this._config.isBuild()&&(this._buildInfoDefineStack[L]=w,this._buildInfoDependencies[L]=(C.dependencies||[]).map(function(v){return e._moduleIdProvider.getStrModuleId(v.id)})),this._resolve(C)},d.prototype._normalizeDependency=function(o,c){if(o==="exports")return F.EXPORTS;if(o==="module")return F.MODULE;if(o==="require")return F.REQUIRE;var N=o.indexOf("!");if(N>=0){var y=c.resolveModule(o.substr(0,N)),w=c.resolveModule(o.substr(N+1)),_=this._moduleIdProvider.getModuleId(y+"!"+w),e=this._moduleIdProvider.getModuleId(y);return new a(_,e,w)}return new F(this._moduleIdProvider.getModuleId(c.resolveModule(o)))},d.prototype._normalizeDependencies=function(o,c){for(var N=[],y=0,w=0,_=o.length;w<_;w++)N[y++]=this._normalizeDependency(o[w],c);return N},d.prototype._relativeRequire=function(o,c,N,y){if(typeof c=="string")return this.synchronousRequire(c,o);this.defineModule(B.Utilities.generateAnonymousModule(),c,N,y,null,o)},d.prototype.synchronousRequire=function(o,c){c===void 0&&(c=new n(o));var N=this._normalizeDependency(o,c),y=this._modules2[N.id];if(!y)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!y.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(y.error)throw y.error;return y.exports},d.prototype.configure=function(o,c){var N=this._config.shouldRecordStats();c?this._config=new B.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!N&&(this._recorder=null)},d.prototype.getConfig=function(){return this._config},d.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),c.dependencies,c.callback,null,c.stack)}},d.prototype._createLoadError=function(o,c){var N=this,y=this._moduleIdProvider.getStrModuleId(o),w=(this._inverseDependencies2[o]||[]).map(function(e){return N._moduleIdProvider.getStrModuleId(e)}),_=B.ensureError(c);return _.phase="loading",_.moduleId=y,_.neededBy=w,_},d.prototype._onLoadError=function(o,c){var N=this._createLoadError(o,c);this._modules2[o]||(this._modules2[o]=new P(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var y=[],w=0,_=this._moduleIdProvider.getMaxModuleId();w<_;w++)y[w]=!1;var e=!1,L=[];for(L.push(o),y[o]=!0;L.length>0;){var C=L.shift(),v=this._modules2[C];v&&(e=v.onDependencyError(N)||e);var h=this._inverseDependencies2[C];if(h)for(var w=0,_=h.length;w<_;w++){var i=h[w];y[i]||(L.push(i),y[i]=!0)}}e||this._config.onError(N)},d.prototype._hasDependencyPath=function(o,c){var N=this._modules2[o];if(!N)return!1;for(var y=[],w=0,_=this._moduleIdProvider.getMaxModuleId();w<_;w++)y[w]=!1;var e=[];for(e.push(N),y[o]=!0;e.length>0;){var L=e.shift(),C=L.dependencies;if(C)for(var w=0,_=C.length;w<_;w++){var v=C[w];if(v.id===c)return!0;var h=this._modules2[v.id];h&&!y[v.id]&&(y[v.id]=!0,e.push(h))}}return!1},d.prototype._findCyclePath=function(o,c,N){if(o===c||N===50)return[o];var y=this._modules2[o];if(!y)return null;var w=y.dependencies;if(w)for(var _=0,e=w.length;_<e;_++){var L=this._findCyclePath(w[_].id,c,N+1);if(L!==null)return L.push(o),L}return null},d.prototype._createRequire=function(o){var c=this,N=function(y,w,_){return c._relativeRequire(o,y,w,_)};return N.toUrl=function(y){return c._config.requireToUrl(o.resolveModule(y))},N.getStats=function(){return c.getLoaderEvents()},N.hasDependencyCycle=function(){return c._hasDependencyCycle},N.config=function(y,w){w===void 0&&(w=!1),c.configure(y,w)},N.__$__nodeRequire=B.global.nodeRequire,N},d.prototype._loadModule=function(o){var c=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var N=this._moduleIdProvider.getStrModuleId(o),y=this._config.moduleIdToPaths(N),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(N.indexOf("/")===-1||w.test(N))&&y.push("node|"+N);var _=-1,e=function(L){if(_++,_>=y.length)c._onLoadError(o,L);else{var C=y[_],v=c.getRecorder();if(c._config.isBuild()&&C==="empty:"){c._buildInfoPath[o]=C,c.defineModule(c._moduleIdProvider.getStrModuleId(o),[],null,null,null),c._onLoad(o);return}v.record(10,C),c._scriptLoader.load(c,C,function(){c._config.isBuild()&&(c._buildInfoPath[o]=C),v.record(11,C),c._onLoad(o)},function(h){v.record(12,C),e(h)})}};e(null)}},d.prototype._loadPluginDependency=function(o,c){var N=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var y=function(w){N.defineModule(N._moduleIdProvider.getStrModuleId(c.id),[],w,null,null)};y.error=function(w){N._config.onError(N._createLoadError(c.id,w))},o.load(c.pluginParam,this._createRequire(n.ROOT),y,this._config.getOptionsLiteral())}},d.prototype._resolve=function(o){var c=this,N=o.dependencies;if(N)for(var y=0,w=N.length;y<w;y++){var _=N[y];if(_===F.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(_===F.MODULE){o.unresolvedDependenciesCount--;continue}if(_===F.REQUIRE){o.unresolvedDependenciesCount--;continue}var e=this._modules2[_.id];if(e&&e.isComplete()){if(e.error){o.onDependencyError(e.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(_.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(_.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var L=this._findCyclePath(_.id,o.id,0)||[];L.reverse(),L.push(_.id),console.warn(L.map(function(h){return c._moduleIdProvider.getStrModuleId(h)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[_.id]=this._inverseDependencies2[_.id]||[],this._inverseDependencies2[_.id].push(o.id),_ instanceof a){var C=this._modules2[_.pluginId];if(C&&C.isComplete()){this._loadPluginDependency(C.exports,_);continue}var v=this._inversePluginDependencies2.get(_.pluginId);v||(v=[],this._inversePluginDependencies2.set(_.pluginId,v)),v.push(_),this._loadModule(_.pluginId);continue}this._loadModule(_.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},d.prototype._onModuleComplete=function(o){var c=this,N=this.getRecorder();if(!o.isComplete()){var y=o.dependencies,w=[];if(y)for(var _=0,e=y.length;_<e;_++){var L=y[_];if(L===F.EXPORTS){w[_]=o.exports;continue}if(L===F.MODULE){w[_]={id:o.strId,config:function(){return c._config.getConfigForModule(o.strId)}};continue}if(L===F.REQUIRE){w[_]=this._createRequire(o.moduleIdResolver);continue}var C=this._modules2[L.id];if(C){w[_]=C.exports;continue}w[_]=null}o.complete(N,this._config,w);var v=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,v)for(var _=0,e=v.length;_<e;_++){var h=v[_],i=this._modules2[h];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var s=this._inversePluginDependencies2.get(o.id);if(s){this._inversePluginDependencies2.delete(o.id);for(var _=0,e=s.length;_<e;_++)this._loadPluginDependency(o.exports,s[_])}}},d}();B.ModuleManager=A})(le||(le={}));var J,le;(function(B){var n=new B.Environment,P=null,t=function(d,o,c){typeof d!="string"&&(c=o,o=d,d=null),(typeof o!="object"||!Array.isArray(o))&&(c=o,o=null),o||(o=["require","exports","module"]),d?P.defineModule(d,o,c,null,null):P.enqueueDefineAnonymousModule(o,c)};t.amd={jQuery:!0};var F=function(d,o){o===void 0&&(o=!1),P.configure(d,o)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){F(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=F,a.getConfig=function(){return P.getConfig().getOptionsLiteral()},a.reset=function(){P=P.reset()},a.getBuildInfo=function(){return P.getBuildInfo()},a.getStats=function(){return P.getLoaderEvents()},a.define=t;function A(){if(typeof B.global.require!="undefined"||typeof require!="undefined"){var d=B.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){var o=B.ensureRecordedNodeRequire(P.getRecorder(),d);B.global.nodeRequire=o,a.nodeRequire=o,a.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=a,require=a):(n.isElectronRenderer||(B.global.define=t),B.global.require=a)}B.init=A,(typeof B.global.define!="function"||!B.global.define.amd)&&(P=new B.ModuleManager(n,B.createScriptLoader(n),t,a,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require!="undefined"&&typeof B.global.require!="function"&&a.config(B.global.require),J=function(){return t.apply(null,arguments)},J.amd=t.amd,typeof doNotInitLoader=="undefined"&&A())})(le||(le={}));var Se=this,ye;(function(B){var n=Se||{},P=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,t=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function F(c,N){var y;return N.length===0?y=c:y=c.replace(/\{(\d+)\}/g,function(w,_){var e=_[0];return typeof N[e]!="undefined"?N[e]:w}),t&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function a(c,N){var y=c[N];return y||(y=c["*"],y)?y:null}function A(c,N){for(var y=[],w=0;w<arguments.length-2;w++)y[w]=arguments[w+2];return F(N,y)}function d(c){return function(N,y){var w=Array.prototype.slice.call(arguments,2);return F(c[N],w)}}var o=function(){function c(){this.localize=A}return c.prototype.setPseudoTranslation=function(N){t=N},c.prototype.create=function(N,y){return{localize:d(y[N])}},c.prototype.load=function(N,y,w,_){if(_=_||{},!N||N.length===0)w({localize:A});else{var e=void 0;if(P&&P.getString)e=".nls.keys",y([N+e],function(v){w({localize:function(h,i){if(!v[h])return"NLS error: unknown key "+h;var s=v[h].keys;if(i>=s.length)return"NLS error unknown index "+i;var f=s[i],b=[];b[0]=h+"_"+f;for(var p=0;p<arguments.length-2;p++)b[p+1]=arguments[p+2];return P.getString.apply(P,b)}})});else if(_.isBuild)y([N+".nls",N+".nls.keys"],function(v,h){c.BUILD_MAP[N]=v,c.BUILD_MAP_KEYS[N]=h,w(v)});else{var L=_["vs/nls"]||{},C=L.availableLanguages?a(L.availableLanguages,N):null;e=".nls",C!==null&&C!==c.DEFAULT_TAG&&(e=e+"."+C),y([N+e],function(v){Array.isArray(v)?v.localize=d(v):v.localize=d(v[N]),w(v)})}}},c.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},c.prototype.write=function(N,y,w){var _=w.getEntryPoint(),e=this._getEntryPointsMap();e[_]=e[_]||[],e[_].push(y),y!==_&&w.asModule(N+"!"+y,"define(['vs/nls', 'vs/nls!"+_+`'], function(nls, data) { return nls.create("`+y+'", data); });')},c.prototype.writeFile=function(N,y,w,_,e){var L=this._getEntryPointsMap();if(L.hasOwnProperty(y)){for(var C=w.toUrl(y+".nls.js"),v=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],h=L[y],i={},s=0;s<h.length;s++)i[h[s]]=c.BUILD_MAP[h[s]];v.push('define("'+y+'.nls", '+JSON.stringify(i,null,"	")+");"),_(C,v.join(`\r
`))}},c.prototype.finishBuild=function(N){N("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();B.NLSPlugin=o,function(){J("vs/nls",new o)}()})(ye||(ye={})),J(ee[18],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function P(A){return A?A.replace(/\$\((.*?)\)/g,(d,o)=>` ${o} `).trim():""}n.getCodiconAriaLabel=P;class t{constructor(d,o,c){this.id=d,this.definition=o,this.description=c,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function F(A,d){const o=["codicon","codicon-"+A];return d&&o.push("codicon-modifier-"+d),o}n.getClassNamesArray=F;var a;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function o(y){if(y instanceof t)return["codicon","codicon-"+y.id];const w=d.exec(y.id);if(!w)return o(t.error);let[,_,e]=w;const L=["codicon","codicon-"+_];return e&&L.push("codicon-modifier-"+e.substr(1)),L}A.asClassNameArray=o;function c(y){return o(y).join(" ")}A.asClassName=c;function N(y){return"."+o(y).join(".")}A.asCSSSelector=N})(a=n.CSSIcon||(n.CSSIcon={}))}),J(ee[19],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class P{constructor(F,a,A,d){this.originalStart=F,this.originalLength=a,this.modifiedStart=A,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=P}),J(ee[8],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(f=>{f(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}n.ErrorHandler=P,n.errorHandler=new P;function t(i){n.errorHandler.setUnexpectedErrorHandler(i)}n.setUnexpectedErrorHandler=t;function F(i){o(i)||n.errorHandler.onUnexpectedError(i)}n.onUnexpectedError=F;function a(i){o(i)||n.errorHandler.onUnexpectedExternalError(i)}n.onUnexpectedExternalError=a;function A(i){if(i instanceof Error){let{name:s,message:f}=i;const b=i.stacktrace||i.stack;return{$isError:!0,name:s,message:f,stack:b}}return i}n.transformErrorForSerialization=A;const d="Canceled";function o(i){return i instanceof c?!0:i instanceof Error&&i.name===d&&i.message===d}n.isCancellationError=o;class c extends Error{constructor(){super(d);this.name=this.message}}n.CancellationError=c;function N(){const i=new Error(d);return i.name=i.message,i}n.canceled=N;function y(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}n.illegalArgument=y;function w(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}n.illegalState=w;function _(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=_;function e(i){const s=new Error(`${i} has been disposed`);return s.name="DISPOSED",s}n.disposed=e;function L(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}n.getErrorMessage=L;class C extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}n.NotImplementedError=C;class v extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}n.NotSupportedError=v;class h extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=h}),J(ee[20],te([0,1,8]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function t(I,T=0){return I[I.length-(1+T)]}n.tail=t;function F(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=F;function a(I,T,U=(W,z)=>W===z){if(I===T)return!0;if(!I||!T||I.length!==T.length)return!1;for(let W=0,z=I.length;W<z;W++)if(!U(I[W],T[W]))return!1;return!0}n.equals=a;function A(I,T,U){let W=0,z=I.length-1;for(;W<=z;){const ne=(W+z)/2|0,re=U(I[ne],T);if(re<0)W=ne+1;else if(re>0)z=ne-1;else return ne}return-(W+1)}n.binarySearch=A;function d(I,T){let U=0,W=I.length;if(W===0)return 0;for(;U<W;){const z=Math.floor((U+W)/2);T(I[z])?W=z:U=z+1}return U}n.findFirstInSorted=d;function o(I,T,U){if(I=I|0,I>=T.length)throw new TypeError("invalid index");let W=T[Math.floor(T.length*Math.random())],z=[],ne=[],re=[];for(let ue of T){const oe=U(ue,W);oe<0?z.push(ue):oe>0?ne.push(ue):re.push(ue)}return I<z.length?o(I,z,U):I<z.length+re.length?re[0]:o(I-(z.length+re.length),ne,U)}n.quickSelect=o;function c(I,T){const U=[];let W;for(const z of I.slice(0).sort(T))!W||T(W[0],z)!==0?(W=[z],U.push(W)):W.push(z);return U}n.groupBy=c;function N(I,T,U){const W=[];function z(ue,oe,fe){if(oe===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===ue?(he.deleteCount+=oe,he.toInsert.push(...fe)):W.push({start:ue,deleteCount:oe,toInsert:fe})}let ne=0,re=0;for(;;){if(ne===I.length){z(ne,0,T.slice(re));break}if(re===T.length){z(ne,I.length-ne,[]);break}const ue=I[ne],oe=T[re],fe=U(ue,oe);fe===0?(ne+=1,re+=1):fe<0?(z(ne,1,[]),ne+=1):fe>0&&(z(ne,0,[oe]),re+=1)}return W}n.sortedDiff=N;function y(I,T,U){const W=N(I,T,U),z=[],ne=[];for(const re of W)z.push(...I.slice(re.start,re.start+re.deleteCount)),ne.push(...re.toInsert);return{removed:z,added:ne}}n.delta=y;function w(I,T,U){if(U===0)return[];const W=I.slice(0,U).sort(T);return e(I,T,W,U,I.length),W}n.top=w;function _(I,T,U,W,z){return U===0?Promise.resolve([]):new Promise((ne,re)=>{(async()=>{const ue=I.length,oe=I.slice(0,U).sort(T);for(let fe=U,he=Math.min(U+W,ue);fe<ue;fe=he,he=Math.min(he+W,ue)){if(fe>U&&await new Promise(Ae=>setTimeout(Ae)),z&&z.isCancellationRequested)throw(0,P.canceled)();e(I,T,oe,fe,he)}return oe})().then(ne,re)})}n.topAsync=_;function e(I,T,U,W,z){for(const ne=U.length;W<z;W++){const re=I[W];if(T(re,U[ne-1])<0){U.pop();const ue=d(U,oe=>T(re,oe)<0);U.splice(ue,0,re)}}}function L(I){return I.filter(T=>!!T)}n.coalesce=L;function C(I){let T=0;for(let U=0;U<I.length;U++)I[U]&&(I[T]=I[U],T+=1);I.length=T}n.coalesceInPlace=C;function v(I,T,U){I.splice(U,0,I.splice(T,1)[0])}n.move=v;function h(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=h;function i(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=i;function s(I,T=U=>U){const U=new Set;return I.filter(W=>{const z=T(W);return U.has(z)?!1:(U.add(z),!0)})}n.distinct=s;function f(I){const T=new Set;return U=>{const W=I(U);return T.has(W)?!1:(T.add(W),!0)}}n.uniqueFilter=f;function b(I,T){const U=p(I,T);if(U!==-1)return I[U]}n.findLast=b;function p(I,T){for(let U=I.length-1;U>=0;U--){const W=I[U];if(T(W))return U}return-1}n.lastIndex=p;function m(I,T){return I.length>0?I[0]:T}n.firstOrDefault=m;function l(I,T,U=(W,z)=>W===z){let W=0;for(let z=0,ne=Math.min(I.length,T.length);z<ne&&U(I[z],T[z]);z++)W++;return W}n.commonPrefixLength=l;function g(I){return[].concat(...I)}n.flatten=g;function u(I,T){let U=typeof T=="number"?I:0;typeof T=="number"?U=I:(U=0,T=I);const W=[];if(U<=T)for(let z=U;z<T;z++)W.push(z);else for(let z=U;z>T;z--)W.push(z);return W}n.range=u;function M(I,T,U){return I.reduce((W,z)=>(W[T(z)]=U?U(z):z,W),Object.create(null))}n.index=M;function S(I,T){return I.push(T),()=>R(I,T)}n.insert=S;function R(I,T){const U=I.indexOf(T);if(U>-1)return I.splice(U,1),T}n.remove=R;function q(I,T,U){const W=I.slice(0,T),z=I.slice(T);return W.concat(U,z)}n.arrayInsert=q;function H(I,T){let U;if(typeof T=="number"){let W=T;U=()=>{const z=Math.sin(W++)*179426549;return z-Math.floor(z)}}else U=Math.random;for(let W=I.length-1;W>0;W-=1){const z=Math.floor(U()*(W+1)),ne=I[W];I[W]=I[z],I[z]=ne}}n.shuffle=H;function j(I,T){const U=I.indexOf(T);U>-1&&(I.splice(U,1),I.unshift(T))}n.pushToStart=j;function E(I,T){const U=I.indexOf(T);U>-1&&(I.splice(U,1),I.push(T))}n.pushToEnd=E;function O(I,T){return Array.isArray(I)?I.map(T):T(I)}n.mapArrayOrNot=O;function K(I){return Array.isArray(I)?I:[I]}n.asArray=K;function $(I){return I[Math.floor(Math.random()*I.length)]}n.getRandomElement=$;function Y(I,T){for(const U of I){const W=T(U);if(W!==void 0)return W}}n.mapFind=Y;function r(I,T,U){const W=ge(I,T),z=I.length,ne=U.length;I.length=z+ne;for(let re=z-1;re>=W;re--)I[re+ne]=I[re];for(let re=0;re<ne;re++)I[re+W]=U[re]}n.insertInto=r;function se(I,T,U,W){const z=ge(I,T),ne=I.splice(z,U);return r(I,z,W),ne}n.splice=se;function ge(I,T){return T<0?Math.max(T+I.length,0):Math.min(T,I.length)}function ve(I,T){return(U,W)=>T(I(U),I(W))}n.compareBy=ve;const Le=(I,T)=>I-T;n.numberComparator=Le;function pe(I,T){if(I.length===0)return;let U=I[0];for(let W=1;W<I.length;W++){const z=I[W];T(z,U)>0&&(U=z)}return U}n.findMaxBy=pe;function x(I,T){if(I.length===0)return;let U=I[0];for(let W=1;W<I.length;W++){const z=I[W];T(z,U)>=0&&(U=z)}return U}n.findLastMaxBy=x;function Q(I,T){return pe(I,(U,W)=>-T(U,W))}n.findMinBy=Q;class Z{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let U=this.firstIdx;for(;U<this.items.length&&T(this.items[U]);)U++;const W=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,W}takeFromEndWhile(T){let U=this.lastIdx;for(;U>=0&&T(this.items[U]);)U--;const W=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,W}peek(){return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const U=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,U}}n.ArrayQueue=Z}),J(ee[11],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function P(t){const F=this;let a=!1,A;return function(){return a||(a=!0,A=t.apply(F,arguments)),A}}n.once=P}),J(ee[21],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var P;(function(t){function F(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=F;const a=Object.freeze([]);function A(){return a}t.empty=A;function*d(f){yield f}t.single=d;function o(f){return f||a}t.from=o;function c(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=c;function N(f){return f[Symbol.iterator]().next().value}t.first=N;function y(f,b){for(const p of f)if(b(p))return!0;return!1}t.some=y;function w(f,b){for(const p of f)if(b(p))return p}t.find=w;function*_(f,b){for(const p of f)b(p)&&(yield p)}t.filter=_;function*e(f,b){let p=0;for(const m of f)yield b(m,p++)}t.map=e;function*L(...f){for(const b of f)for(const p of b)yield p}t.concat=L;function*C(f){for(const b of f)for(const p of b)yield p}t.concatNested=C;function v(f,b,p){let m=p;for(const l of f)m=b(m,l);return m}t.reduce=v;function*h(f,b,p=f.length){for(b<0&&(b+=f.length),p<0?p+=f.length:p>f.length&&(p=f.length);b<p;b++)yield f[b]}t.slice=h;function i(f,b=Number.POSITIVE_INFINITY){const p=[];if(b===0)return[p,f];const m=f[Symbol.iterator]();for(let l=0;l<b;l++){const g=m.next();if(g.done)return[p,t.empty()];p.push(g.value)}return[p,{[Symbol.iterator](){return m}}]}t.consume=i;function s(f,b,p=(m,l)=>m===l){const m=f[Symbol.iterator](),l=b[Symbol.iterator]();for(;;){const g=m.next(),u=l.next();if(g.done!==u.done)return!1;if(g.done)return!0;if(!p(g.value,u.value))return!1}}t.equals=s})(P=n.Iterable||(n.Iterable={}))}),J(ee[22],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(P=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class F{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,C){this._keyCodeToStr[L]=C,this._strToKeyCode[C.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||0}}const a=new F,A=new F,d=new F;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const o=[],c=Object.create(null),N=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>N[e]||0,toEnum:e=>c[e]||0,toString:e=>o[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",L=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let C=[],v=[];for(const h of L){const[i,s,f,b,p,m,l,g,u,M]=h;if(v[f]||(v[f]=!0,o[f]=b,c[b]=f,N[b.toLowerCase()]=f,s&&(n.IMMUTABLE_CODE_TO_KEY_CODE[f]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[p]=f))),!C[p]){if(C[p]=!0,!m)throw new Error(`String representation missing for key code ${p} around scan code ${b}`);a.define(p,m),A.define(p,u||m),d.define(p,M||u||m)}l&&(n.EVENT_KEY_CODE_MAP[l]=p),g&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[g]=p)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var y;(function(e){function L(f){return a.keyCodeToStr(f)}e.toString=L;function C(f){return a.strToKeyCode(f)}e.fromString=C;function v(f){return A.keyCodeToStr(f)}e.toUserSettingsUS=v;function h(f){return d.keyCodeToStr(f)}e.toUserSettingsGeneral=h;function i(f){return A.strToKeyCode(f)||d.strToKeyCode(f)}e.fromUserSettings=i;function s(f){if(f>=93&&f<=108)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return a.keyCodeToStr(f)}e.toElectronAccelerator=s})(y=n.KeyCodeUtils||(n.KeyCodeUtils={}));var w;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(w=n.KeyMod||(n.KeyMod={}));function _(e,L){const C=(L&65535)<<16>>>0;return(e|C)>>>0}n.KeyChord=_}),J(ee[23],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class P{constructor(F){this.executor=F,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(F){this._error=F}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(F){return new P(()=>F(this.getValue()))}}n.Lazy=P}),J(ee[9],te([0,1,11,21]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const F=!1;let a=null;function A(g){a=g}if(n.setDisposableTracker=A,F){const g="__is_disposable_tracked__";A(new class{trackDisposable(u){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[g]||console.log(M)},3e3)}setParent(u,M){if(u&&u!==h.None)try{u[g]=!0}catch{}}markAsDisposed(u){if(u&&u!==h.None)try{u[g]=!0}catch{}}markAsSingleton(u){}})}function d(g){return a?.trackDisposable(g),g}function o(g){a?.markAsDisposed(g)}function c(g,u){a?.setParent(g,u)}function N(g,u){if(!!a)for(const M of g)a.setParent(M,u)}function y(g){return a?.markAsSingleton(g),g}n.markAsSingleton=y;class w extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}n.MultiDisposeError=w;function _(g){return typeof g.dispose=="function"&&g.dispose.length===0}n.isDisposable=_;function e(g){if(t.Iterable.is(g)){let u=[];for(const M of g)if(M)try{M.dispose()}catch(S){u.push(S)}if(u.length===1)throw u[0];if(u.length>1)throw new w(u);return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}n.dispose=e;function L(...g){const u=C(()=>e(g));return N(g,u),u}n.combinedDisposable=L;function C(g){const u=d({dispose:(0,P.once)(()=>{o(u),g()})});return u}n.toDisposable=C;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,d(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return c(u,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}n.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new v,d(this),c(this._store,this)}dispose(){o(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}n.Disposable=h,h.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&c(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&c(u,null),u}}n.MutableDisposable=i;class s{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=s;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(u){let M=u;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,o(this))},this}}n.SafeDisposable=f;class b{constructor(){this.references=new Map}acquire(u,...M){let S=this.references.get(u);S||(S={counter:0,object:this.createReferencedObject(u,...M)},this.references.set(u,S));const{object:R}=S,q=(0,P.once)(()=>{--S.counter==0&&(this.destroyReferencedObject(u,S.object),this.references.delete(u))});return S.counter++,{object:R,dispose:q}}}n.ReferenceCollection=b;class p{constructor(u){this.referenceCollection=u}async acquire(u,...M){const S=this.referenceCollection.acquire(u,...M);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(R){throw S.dispose(),R}}}n.AsyncReferenceCollection=p;class m{constructor(u){this.object=u}dispose(){}}n.ImmortalReference=m;function l(g){const u=new v;try{g(u)}finally{u.dispose()}}n.disposeOnReturn=l}),J(ee[24],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class P{constructor(a){this.element=a,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class t{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let a=this._first;for(;a!==P.Undefined;){const A=a.next;a.prev=P.Undefined,a.next=P.Undefined,a=A}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(a){return this._insert(a,!1)}push(a){return this._insert(a,!0)}_insert(a,A){const d=new P(a);if(this._first===P.Undefined)this._first=d,this._last=d;else if(A){const c=this._last;this._last=d,d.prev=c,c.next=d}else{const c=this._first;this._first=d,d.next=c,c.prev=d}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(d))}}shift(){if(this._first!==P.Undefined){const a=this._first.element;return this._remove(this._first),a}}pop(){if(this._last!==P.Undefined){const a=this._last.element;return this._remove(this._last),a}}_remove(a){if(a.prev!==P.Undefined&&a.next!==P.Undefined){const A=a.prev;A.next=a.next,a.next.prev=A}else a.prev===P.Undefined&&a.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):a.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):a.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let a=this._first;for(;a!==P.Undefined;)yield a.element,a=a.next}}n.LinkedList=t}),J(ee[5],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.isElectronSandboxed=n.globals=void 0;const P="en";let t=!1,F=!1,a=!1,A=!1,d=!1,o=!1,c=!1,N=!1,y=!1,w,_=P,e,L;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?C=n.globals.vscode.process:typeof process!="undefined"&&(C=process);const v=typeof C?.versions?.electron=="string",h=v&&C?.type==="renderer";if(n.isElectronSandboxed=h&&C?.sandboxed,typeof navigator=="object"&&!h)L=navigator.userAgent,t=L.indexOf("Windows")>=0,F=L.indexOf("Macintosh")>=0,N=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=L.indexOf("Linux")>=0,o=!0,w=navigator.language,_=w;else if(typeof C=="object"){t=C.platform==="win32",F=C.platform==="darwin",a=C.platform==="linux",A=a&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,c=v,y=!!C.env.CI||!!C.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=P,_=P;const u=C.env.VSCODE_NLS_CONFIG;if(u)try{const M=JSON.parse(u),S=M.availableLanguages["*"];w=M.locale,_=S||P,e=M._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var i;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(i=n.Platform||(n.Platform={}));function s(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=s;let f=0;F?f=1:t?f=3:a&&(f=2),n.isWindows=t,n.isMacintosh=F,n.isLinux=a,n.isLinuxSnap=A,n.isNative=d,n.isElectron=c,n.isWeb=o,n.isWebWorker=o&&typeof n.globals.importScripts=="function",n.isIOS=N,n.isCI=y,n.platform=f,n.userAgent=L,n.language=_;var b;(function(u){function M(){return n.language}u.value=M;function S(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}u.isDefaultVariant=S;function R(){return n.language==="en"}u.isDefault=R})(b=n.Language||(n.Language={})),n.locale=w,n.translationsConfigFile=e,n.setTimeout0=(()=>{if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let u=[];n.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let R=0,q=u.length;R<q;R++){const H=u[R];if(H.id===S.data.vscodeScheduleAsyncWork){u.splice(R,1),H.callback();return}}});let M=0;return S=>{const R=++M;u.push({id:R,callback:S}),n.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return u=>setTimeout(u)})();var p;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(p=n.OperatingSystem||(n.OperatingSystem={})),n.OS=F||N?2:t?1:3;let m=!0,l=!1;function g(){if(!l){l=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,m=new Uint16Array(u.buffer)[0]===(2<<8)+1}return m}n.isLittleEndian=g,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),J(ee[25],te([0,1,5]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const F=P.globals.vscode.process;t={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),J(ee[26],te([0,1,25]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,F=97,a=90,A=122,d=46,o=47,c=92,N=58,y=63;class w extends Error{constructor(s,f,b){let p;typeof f=="string"&&f.indexOf("not ")===0?(p="must not be",f=f.replace(/^not /,"")):p="must be";const m=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${m} ${p} of type ${f}`;l+=`. Received type ${typeof b}`;super(l);this.code="ERR_INVALID_ARG_TYPE"}}function _(i,s){if(typeof i!="string")throw new w(s,"string",i)}function e(i){return i===o||i===c}function L(i){return i===o}function C(i){return i>=t&&i<=a||i>=F&&i<=A}function v(i,s,f,b){let p="",m=0,l=-1,g=0,u=0;for(let M=0;M<=i.length;++M){if(M<i.length)u=i.charCodeAt(M);else{if(b(u))break;u=o}if(b(u)){if(!(l===M-1||g===1))if(g===2){if(p.length<2||m!==2||p.charCodeAt(p.length-1)!==d||p.charCodeAt(p.length-2)!==d){if(p.length>2){const S=p.lastIndexOf(f);S===-1?(p="",m=0):(p=p.slice(0,S),m=p.length-1-p.lastIndexOf(f)),l=M,g=0;continue}else if(p.length!==0){p="",m=0,l=M,g=0;continue}}s&&(p+=p.length>0?`${f}..`:"..",m=2)}else p.length>0?p+=`${f}${i.slice(l+1,M)}`:p=i.slice(l+1,M),m=M-l-1;l=M,g=0}else u===d&&g!==-1?++g:g=-1}return p}function h(i,s){if(s===null||typeof s!="object")throw new w("pathObject","Object",s);const f=s.dir||s.root,b=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${b}`:`${f}${i}${b}`:b}n.win32={resolve(...i){let s="",f="",b=!1;for(let p=i.length-1;p>=-1;p--){let m;if(p>=0){if(m=i[p],_(m,"path"),m.length===0)continue}else s.length===0?m=P.cwd():(m=P.env[`=${s}`]||P.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===c)&&(m=`${s}\\`));const l=m.length;let g=0,u="",M=!1;const S=m.charCodeAt(0);if(l===1)e(S)&&(g=1,M=!0);else if(e(S))if(M=!0,e(m.charCodeAt(1))){let R=2,q=R;for(;R<l&&!e(m.charCodeAt(R));)R++;if(R<l&&R!==q){const H=m.slice(q,R);for(q=R;R<l&&e(m.charCodeAt(R));)R++;if(R<l&&R!==q){for(q=R;R<l&&!e(m.charCodeAt(R));)R++;(R===l||R!==q)&&(u=`\\\\${H}\\${m.slice(q,R)}`,g=R)}}}else g=1;else C(S)&&m.charCodeAt(1)===N&&(u=m.slice(0,2),g=2,l>2&&e(m.charCodeAt(2))&&(M=!0,g=3));if(u.length>0)if(s.length>0){if(u.toLowerCase()!==s.toLowerCase())continue}else s=u;if(b){if(s.length>0)break}else if(f=`${m.slice(g)}\\${f}`,b=M,M&&s.length>0)break}return f=v(f,!b,"\\",e),b?`${s}\\${f}`:`${s}${f}`||"."},normalize(i){_(i,"path");const s=i.length;if(s===0)return".";let f=0,b,p=!1;const m=i.charCodeAt(0);if(s===1)return L(m)?"\\":i;if(e(m))if(p=!0,e(i.charCodeAt(1))){let g=2,u=g;for(;g<s&&!e(i.charCodeAt(g));)g++;if(g<s&&g!==u){const M=i.slice(u,g);for(u=g;g<s&&e(i.charCodeAt(g));)g++;if(g<s&&g!==u){for(u=g;g<s&&!e(i.charCodeAt(g));)g++;if(g===s)return`\\\\${M}\\${i.slice(u)}\\`;g!==u&&(b=`\\\\${M}\\${i.slice(u,g)}`,f=g)}}}else f=1;else C(m)&&i.charCodeAt(1)===N&&(b=i.slice(0,2),f=2,s>2&&e(i.charCodeAt(2))&&(p=!0,f=3));let l=f<s?v(i.slice(f),!p,"\\",e):"";return l.length===0&&!p&&(l="."),l.length>0&&e(i.charCodeAt(s-1))&&(l+="\\"),b===void 0?p?`\\${l}`:l:p?`${b}\\${l}`:`${b}${l}`},isAbsolute(i){_(i,"path");const s=i.length;if(s===0)return!1;const f=i.charCodeAt(0);return e(f)||s>2&&C(f)&&i.charCodeAt(1)===N&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,f;for(let m=0;m<i.length;++m){const l=i[m];_(l,"path"),l.length>0&&(s===void 0?s=f=l:s+=`\\${l}`)}if(s===void 0)return".";let b=!0,p=0;if(typeof f=="string"&&e(f.charCodeAt(0))){++p;const m=f.length;m>1&&e(f.charCodeAt(1))&&(++p,m>2&&(e(f.charCodeAt(2))?++p:b=!1))}if(b){for(;p<s.length&&e(s.charCodeAt(p));)p++;p>=2&&(s=`\\${s.slice(p)}`)}return n.win32.normalize(s)},relative(i,s){if(_(i,"from"),_(s,"to"),i===s)return"";const f=n.win32.resolve(i),b=n.win32.resolve(s);if(f===b||(i=f.toLowerCase(),s=b.toLowerCase(),i===s))return"";let p=0;for(;p<i.length&&i.charCodeAt(p)===c;)p++;let m=i.length;for(;m-1>p&&i.charCodeAt(m-1)===c;)m--;const l=m-p;let g=0;for(;g<s.length&&s.charCodeAt(g)===c;)g++;let u=s.length;for(;u-1>g&&s.charCodeAt(u-1)===c;)u--;const M=u-g,S=l<M?l:M;let R=-1,q=0;for(;q<S;q++){const j=i.charCodeAt(p+q);if(j!==s.charCodeAt(g+q))break;j===c&&(R=q)}if(q!==S){if(R===-1)return b}else{if(M>S){if(s.charCodeAt(g+q)===c)return b.slice(g+q+1);if(q===2)return b.slice(g+q)}l>S&&(i.charCodeAt(p+q)===c?R=q:q===2&&(R=3)),R===-1&&(R=0)}let H="";for(q=p+R+1;q<=m;++q)(q===m||i.charCodeAt(q)===c)&&(H+=H.length===0?"..":"\\..");return g+=R,H.length>0?`${H}${b.slice(g,u)}`:(b.charCodeAt(g)===c&&++g,b.slice(g,u))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const s=n.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===c){if(s.charCodeAt(1)===c){const f=s.charCodeAt(2);if(f!==y&&f!==d)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(C(s.charCodeAt(0))&&s.charCodeAt(1)===N&&s.charCodeAt(2)===c)return`\\\\?\\${s}`;return i},dirname(i){_(i,"path");const s=i.length;if(s===0)return".";let f=-1,b=0;const p=i.charCodeAt(0);if(s===1)return e(p)?i:".";if(e(p)){if(f=b=1,e(i.charCodeAt(1))){let g=2,u=g;for(;g<s&&!e(i.charCodeAt(g));)g++;if(g<s&&g!==u){for(u=g;g<s&&e(i.charCodeAt(g));)g++;if(g<s&&g!==u){for(u=g;g<s&&!e(i.charCodeAt(g));)g++;if(g===s)return i;g!==u&&(f=b=g+1)}}}}else C(p)&&i.charCodeAt(1)===N&&(f=s>2&&e(i.charCodeAt(2))?3:2,b=f);let m=-1,l=!0;for(let g=s-1;g>=b;--g)if(e(i.charCodeAt(g))){if(!l){m=g;break}}else l=!1;if(m===-1){if(f===-1)return".";m=f}return i.slice(0,m)},basename(i,s){s!==void 0&&_(s,"ext"),_(i,"path");let f=0,b=-1,p=!0,m;if(i.length>=2&&C(i.charCodeAt(0))&&i.charCodeAt(1)===N&&(f=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let l=s.length-1,g=-1;for(m=i.length-1;m>=f;--m){const u=i.charCodeAt(m);if(e(u)){if(!p){f=m+1;break}}else g===-1&&(p=!1,g=m+1),l>=0&&(u===s.charCodeAt(l)?--l==-1&&(b=m):(l=-1,b=g))}return f===b?b=g:b===-1&&(b=i.length),i.slice(f,b)}for(m=i.length-1;m>=f;--m)if(e(i.charCodeAt(m))){if(!p){f=m+1;break}}else b===-1&&(p=!1,b=m+1);return b===-1?"":i.slice(f,b)},extname(i){_(i,"path");let s=0,f=-1,b=0,p=-1,m=!0,l=0;i.length>=2&&i.charCodeAt(1)===N&&C(i.charCodeAt(0))&&(s=b=2);for(let g=i.length-1;g>=s;--g){const u=i.charCodeAt(g);if(e(u)){if(!m){b=g+1;break}continue}p===-1&&(m=!1,p=g+1),u===d?f===-1?f=g:l!==1&&(l=1):f!==-1&&(l=-1)}return f===-1||p===-1||l===0||l===1&&f===p-1&&f===b+1?"":i.slice(f,p)},format:h.bind(null,"\\"),parse(i){_(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const f=i.length;let b=0,p=i.charCodeAt(0);if(f===1)return e(p)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(e(p)){if(b=1,e(i.charCodeAt(1))){let R=2,q=R;for(;R<f&&!e(i.charCodeAt(R));)R++;if(R<f&&R!==q){for(q=R;R<f&&e(i.charCodeAt(R));)R++;if(R<f&&R!==q){for(q=R;R<f&&!e(i.charCodeAt(R));)R++;R===f?b=R:R!==q&&(b=R+1)}}}}else if(C(p)&&i.charCodeAt(1)===N){if(f<=2)return s.root=s.dir=i,s;if(b=2,e(i.charCodeAt(2))){if(f===3)return s.root=s.dir=i,s;b=3}}b>0&&(s.root=i.slice(0,b));let m=-1,l=b,g=-1,u=!0,M=i.length-1,S=0;for(;M>=b;--M){if(p=i.charCodeAt(M),e(p)){if(!u){l=M+1;break}continue}g===-1&&(u=!1,g=M+1),p===d?m===-1?m=M:S!==1&&(S=1):m!==-1&&(S=-1)}return g!==-1&&(m===-1||S===0||S===1&&m===g-1&&m===l+1?s.base=s.name=i.slice(l,g):(s.name=i.slice(l,m),s.base=i.slice(l,g),s.ext=i.slice(m,g))),l>0&&l!==b?s.dir=i.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let s="",f=!1;for(let b=i.length-1;b>=-1&&!f;b--){const p=b>=0?i[b]:P.cwd();_(p,"path"),p.length!==0&&(s=`${p}/${s}`,f=p.charCodeAt(0)===o)}return s=v(s,!f,"/",L),f?`/${s}`:s.length>0?s:"."},normalize(i){if(_(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===o,f=i.charCodeAt(i.length-1)===o;return i=v(i,!s,"/",L),i.length===0?s?"/":f?"./":".":(f&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return _(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let s;for(let f=0;f<i.length;++f){const b=i[f];_(b,"path"),b.length>0&&(s===void 0?s=b:s+=`/${b}`)}return s===void 0?".":n.posix.normalize(s)},relative(i,s){if(_(i,"from"),_(s,"to"),i===s||(i=n.posix.resolve(i),s=n.posix.resolve(s),i===s))return"";const f=1,b=i.length,p=b-f,m=1,l=s.length-m,g=p<l?p:l;let u=-1,M=0;for(;M<g;M++){const R=i.charCodeAt(f+M);if(R!==s.charCodeAt(m+M))break;R===o&&(u=M)}if(M===g)if(l>g){if(s.charCodeAt(m+M)===o)return s.slice(m+M+1);if(M===0)return s.slice(m+M)}else p>g&&(i.charCodeAt(f+M)===o?u=M:M===0&&(u=0));let S="";for(M=f+u+1;M<=b;++M)(M===b||i.charCodeAt(M)===o)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(m+u)}`},toNamespacedPath(i){return i},dirname(i){if(_(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===o;let f=-1,b=!0;for(let p=i.length-1;p>=1;--p)if(i.charCodeAt(p)===o){if(!b){f=p;break}}else b=!1;return f===-1?s?"/":".":s&&f===1?"//":i.slice(0,f)},basename(i,s){s!==void 0&&_(s,"ext"),_(i,"path");let f=0,b=-1,p=!0,m;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let l=s.length-1,g=-1;for(m=i.length-1;m>=0;--m){const u=i.charCodeAt(m);if(u===o){if(!p){f=m+1;break}}else g===-1&&(p=!1,g=m+1),l>=0&&(u===s.charCodeAt(l)?--l==-1&&(b=m):(l=-1,b=g))}return f===b?b=g:b===-1&&(b=i.length),i.slice(f,b)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===o){if(!p){f=m+1;break}}else b===-1&&(p=!1,b=m+1);return b===-1?"":i.slice(f,b)},extname(i){_(i,"path");let s=-1,f=0,b=-1,p=!0,m=0;for(let l=i.length-1;l>=0;--l){const g=i.charCodeAt(l);if(g===o){if(!p){f=l+1;break}continue}b===-1&&(p=!1,b=l+1),g===d?s===-1?s=l:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||b===-1||m===0||m===1&&s===b-1&&s===f+1?"":i.slice(s,b)},format:h.bind(null,"/"),parse(i){_(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const f=i.charCodeAt(0)===o;let b;f?(s.root="/",b=1):b=0;let p=-1,m=0,l=-1,g=!0,u=i.length-1,M=0;for(;u>=b;--u){const S=i.charCodeAt(u);if(S===o){if(!g){m=u+1;break}continue}l===-1&&(g=!1,l=u+1),S===d?p===-1?p=u:M!==1&&(M=1):p!==-1&&(M=-1)}if(l!==-1){const S=m===0&&f?1:m;p===-1||M===0||M===1&&p===l-1&&p===m+1?s.base=s.name=i.slice(S,l):(s.name=i.slice(S,p),s.base=i.slice(S,l),s.ext=i.slice(p,l))}return m>0?s.dir=i.slice(0,m-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=P.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=P.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=P.platform==="win32"?n.win32.join:n.posix.join,n.resolve=P.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=P.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=P.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=P.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=P.platform==="win32"?n.win32.extname:n.posix.extname,n.format=P.platform==="win32"?n.win32.format:n.posix.format,n.parse=P.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=P.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=P.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=P.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),J(ee[12],te([0,1,5]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=P.globals.performance&&typeof P.globals.performance.now=="function";class F{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new F(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}n.StopWatch=F}),J(ee[6],te([0,1,8,11,9,24,12]),function(B,n,P,t,F,a,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;let d=!1,o=!1;var c;(function(m){m.None=()=>F.Disposable.None;function l(x){if(o){const{onListenerDidAdd:Q}=x,Z=e.create();let I=0;x.onListenerDidAdd=()=>{++I==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),Q?.()}}}function g(x){return(Q,Z=null,I)=>{let T=!1,U;return U=x(W=>{if(!T)return U?U.dispose():T=!0,Q.call(Z,W)},null,I),T&&U.dispose(),U}}m.once=g;function u(x,Q,Z){return j((I,T=null,U)=>x(W=>I.call(T,Q(W)),null,U),Z)}m.map=u;function M(x,Q,Z){return j((I,T=null,U)=>x(W=>{Q(W),I.call(T,W)},null,U),Z)}m.forEach=M;function S(x,Q,Z){return j((I,T=null,U)=>x(W=>Q(W)&&I.call(T,W),null,U),Z)}m.filter=S;function R(x){return x}m.signal=R;function q(...x){return(Q,Z=null,I)=>(0,F.combinedDisposable)(...x.map(T=>T(U=>Q.call(Z,U),null,I)))}m.any=q;function H(x,Q,Z,I){let T=Z;return u(x,U=>(T=Q(T,U),T),I)}m.reduce=H;function j(x,Q){let Z;const I={onFirstListenerAdd(){Z=x(T.fire,T)},onLastListenerRemove(){Z.dispose()}};Q||l(I);const T=new C(I);return Q&&Q.add(T),T.event}function E(x,Q,Z=100,I=!1,T,U){let W,z,ne,re=0;const ue={leakWarningThreshold:T,onFirstListenerAdd(){W=x(fe=>{re++,z=Q(z,fe),I&&!ne&&(oe.fire(z),z=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=z;z=void 0,ne=void 0,(!I||re>1)&&oe.fire(he),re=0},Z)})},onLastListenerRemove(){W.dispose()}};U||l(ue);const oe=new C(ue);return U&&U.add(oe),oe.event}m.debounce=E;function O(x,Q=(I,T)=>I===T,Z){let I=!0,T;return S(x,U=>{const W=I||!Q(U,T);return I=!1,T=U,W},Z)}m.latch=O;function K(x,Q,Z){return[m.filter(x,Q,Z),m.filter(x,I=>!Q(I),Z)]}m.split=K;function $(x,Q=!1,Z=[]){let I=Z.slice(),T=x(z=>{I?I.push(z):W.fire(z)});const U=()=>{I&&I.forEach(z=>W.fire(z)),I=null},W=new C({onFirstListenerAdd(){T||(T=x(z=>W.fire(z)))},onFirstListenerDidAdd(){I&&(Q?setTimeout(U):U())},onLastListenerRemove(){T&&T.dispose(),T=null}});return W.event}m.buffer=$;class Y{constructor(Q){this.event=Q}map(Q){return new Y(u(this.event,Q))}forEach(Q){return new Y(M(this.event,Q))}filter(Q){return new Y(S(this.event,Q))}reduce(Q,Z){return new Y(H(this.event,Q,Z))}latch(){return new Y(O(this.event))}debounce(Q,Z=100,I=!1,T){return new Y(E(this.event,Q,Z,I,T))}on(Q,Z,I){return this.event(Q,Z,I)}once(Q,Z,I){return g(this.event)(Q,Z,I)}}function r(x){return new Y(x)}m.chain=r;function se(x,Q,Z=I=>I){const I=(...z)=>W.fire(Z(...z)),T=()=>x.on(Q,I),U=()=>x.removeListener(Q,I),W=new C({onFirstListenerAdd:T,onLastListenerRemove:U});return W.event}m.fromNodeEventEmitter=se;function ge(x,Q,Z=I=>I){const I=(...z)=>W.fire(Z(...z)),T=()=>x.addEventListener(Q,I),U=()=>x.removeEventListener(Q,I),W=new C({onFirstListenerAdd:T,onLastListenerRemove:U});return W.event}m.fromDOMEventEmitter=ge;function ve(x){return new Promise(Q=>g(x)(Q))}m.toPromise=ve;function Le(x,Q){return Q(void 0),x(Z=>Q(Z))}m.runAndSubscribe=Le;function pe(x,Q){let Z=null;function I(U){Z?.dispose(),Z=new F.DisposableStore,Q(U,Z)}I(void 0);const T=x(U=>I(U));return(0,F.toDisposable)(()=>{T.dispose(),Z?.dispose()})}m.runAndSubscribeWithStore=pe})(c=n.Event||(n.Event={}));class N{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${N._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}N._idPool=0;let y=-1;function w(m){const l=y;return y=m,{dispose(){y=l}}}n.setGlobalLeakWarningThreshold=w;class _{constructor(l,g=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,g){let u=y;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||g<u)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let S,R=0;for(const[q,H]of this._stacks)(!S||R<H)&&(S=q,R=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${R}):`),console.warn(S)}return()=>{const S=this._stacks.get(l.value)||0;this._stacks.set(l.value,S-1)}}}class e{constructor(l){this.value=l}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class L{constructor(l,g,u){this.callback=l,this.callbackThis=g,this.stack=u,this.subscription=new F.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class C{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=y>0?new _(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new N(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(d){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const g of l)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,g,u)=>{this._listeners||(this._listeners=new a.LinkedList);const M=this._listeners.isEmpty();M&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let S,R;this._leakageMon&&this._listeners.size>=30&&(R=e.create(),S=this._leakageMon.check(R,this._listeners.size+1)),d&&(R=R??e.create());const q=new L(l,g,R),H=this._listeners.push(q);M&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,g);const j=q.subscription.set(()=>{S&&S(),this._disposed||(H(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof F.DisposableStore?u.add(j):Array.isArray(u)&&u.push(j),j}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new a.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,u]=this._deliveryQueue.shift();try{g.invoke(u)}catch(M){(0,P.onUnexpectedError)(M)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=C;class v extends C{async fireAsync(l,g,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new a.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,l]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[M,S]=this._asyncDeliveryQueue.shift(),R=[],q={...S,token:g,waitUntil:H=>{if(Object.isFrozen(R))throw new Error("waitUntil can NOT be called asynchronous");u&&(H=u(H,M.callback)),R.push(H)}};try{M.invoke(q)}catch(H){(0,P.onUnexpectedError)(H);continue}Object.freeze(R),await Promise.allSettled(R).then(H=>{for(const j of H)j.status==="rejected"&&(0,P.onUnexpectedError)(j.reason)})}}}}n.AsyncEmitter=v;class h extends C{constructor(l){super(l);this._isPaused=0,this._eventQueue=new a.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}n.PauseableEmitter=h;class i extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}n.DebounceEmitter=i;class s extends C{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]})}}n.MicrotaskEmitter=s;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const g={event:l,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const u=()=>{this.hasListeners&&this.unhook(g);const M=this.events.indexOf(g);this.events.splice(M,1)};return(0,F.toDisposable)((0,t.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(g=>this.emitter.fire(g))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=f;class b{constructor(){this.buffers=[]}wrapEvent(l){return(g,u,M)=>l(S=>{const R=this.buffers[this.buffers.length-1];R?R.push(()=>g.call(u,S)):g.call(u,S)},void 0,M)}bufferEvents(l){const g=[];this.buffers.push(g);const u=l();return this.buffers.pop(),g.forEach(M=>M()),u}}n.EventBufferer=b;class p{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=F.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=p}),J(ee[13],te([0,1,6]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(d,o){const c=setTimeout(d.bind(o),0);return{dispose(){clearTimeout(c)}}});var F;(function(d){function o(c){return c===d.None||c===d.Cancelled||c instanceof a?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}d.isCancellationToken=o,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(F=n.CancellationToken||(n.CancellationToken={}));class a{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new a),this._token}cancel(){this._token?this._token instanceof a&&this._token.cancel():this._token=F.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof a&&this._token.dispose():this._token=F.None}}n.CancellationTokenSource=A}),J(ee[27],te([0,1,13]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LRUCachedComputed=n.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new P.CancellationTokenSource,d=this.task(A.token);return this.result={promise:d,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}n.Cache=t;class F{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const d=JSON.stringify(A);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.computeFn(A)),this.lastCache}}n.LRUCachedComputed=F}),J(ee[2],te([0,1,27,23]),function(B,n,P,t){"use strict";var F;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function a(D){return!D||typeof D!="string"?!0:D.trim().length===0}n.isFalsyOrWhitespace=a;const A=/{(\d+)}/g;function d(D,...k){return k.length===0?D:D.replace(A,function(V,G){const X=parseInt(G,10);return isNaN(X)||X<0||X>=k.length?V:k[X]})}n.format=d;const o=/{([^}]+)}/g;function c(D,k){return D.replace(o,(V,G)=>k[G]??V)}n.format2=c;function N(D){return D.replace(/[<>&]/g,function(k){switch(k){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return k}})}n.escape=N;function y(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=y;function w(D,k){let V=0;const G=k.charCodeAt(0);for(let X=D.length-1;X>=0;X--)D.charCodeAt(X)===G&&V++;return V}n.count=w;function _(D,k,V="\u2026"){return D.length<=k?D:`${D.substr(0,k)}${V}`}n.truncate=_;function e(D,k=" "){const V=L(D,k);return C(V,k)}n.trim=e;function L(D,k){if(!D||!k)return D;const V=k.length;if(V===0||D.length===0)return D;let G=0;for(;D.indexOf(k,G)===G;)G=G+V;return D.substring(G)}n.ltrim=L;function C(D,k){if(!D||!k)return D;const V=k.length,G=D.length;if(V===0||G===0)return D;let X=G,ie=-1;for(;ie=D.lastIndexOf(k,X-1),!(ie===-1||ie+V!==X);){if(ie===0)return"";X=ie}return D.substring(0,X)}n.rtrim=C;function v(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=v;function h(D){return D.replace(/\*/g,"")}n.stripWildcards=h;function i(D,k,V={}){if(!D)throw new Error("Cannot create regex from empty string");k||(D=y(D)),V.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let G="";return V.global&&(G+="g"),V.matchCase||(G+="i"),V.multiline&&(G+="m"),V.unicode&&(G+="u"),new RegExp(D,G)}n.createRegExp=i;function s(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}n.regExpLeadsToEndlessLoop=s;function f(D){return!!D.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=f;function b(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}n.regExpFlags=b;function p(D){return D.split(/\r\n|\r|\n/)}n.splitLines=p;function m(D){for(let k=0,V=D.length;k<V;k++){const G=D.charCodeAt(k);if(G!==32&&G!==9)return k}return-1}n.firstNonWhitespaceIndex=m;function l(D,k=0,V=D.length){for(let G=k;G<V;G++){const X=D.charCodeAt(G);if(X!==32&&X!==9)return D.substring(k,G)}return D.substring(k,V)}n.getLeadingWhitespace=l;function g(D,k=D.length-1){for(let V=k;V>=0;V--){const G=D.charCodeAt(V);if(G!==32&&G!==9)return V}return-1}n.lastNonWhitespaceIndex=g;function u(D,k){return D<k?-1:D>k?1:0}n.compare=u;function M(D,k,V=0,G=D.length,X=0,ie=k.length){for(;V<G&&X<ie;V++,X++){let _e=D.charCodeAt(V),ae=k.charCodeAt(X);if(_e<ae)return-1;if(_e>ae)return 1}const ce=G-V,Ce=ie-X;return ce<Ce?-1:ce>Ce?1:0}n.compareSubstring=M;function S(D,k){return R(D,k,0,D.length,0,k.length)}n.compareIgnoreCase=S;function R(D,k,V=0,G=D.length,X=0,ie=k.length){for(;V<G&&X<ie;V++,X++){let _e=D.charCodeAt(V),ae=k.charCodeAt(X);if(_e===ae)continue;if(_e>=128||ae>=128)return M(D.toLowerCase(),k.toLowerCase(),V,G,X,ie);q(_e)&&(_e-=32),q(ae)&&(ae-=32);const de=_e-ae;if(de!==0)return de}const ce=G-V,Ce=ie-X;return ce<Ce?-1:ce>Ce?1:0}n.compareSubstringIgnoreCase=R;function q(D){return D>=97&&D<=122}n.isLowerAsciiLetter=q;function H(D){return D>=65&&D<=90}n.isUpperAsciiLetter=H;function j(D,k){return D.length===k.length&&R(D,k)===0}n.equalsIgnoreCase=j;function E(D,k){const V=k.length;return k.length>D.length?!1:R(D,k,0,V)===0}n.startsWithIgnoreCase=E;function O(D,k){let V,G=Math.min(D.length,k.length);for(V=0;V<G;V++)if(D.charCodeAt(V)!==k.charCodeAt(V))return V;return G}n.commonPrefixLength=O;function K(D,k){let V,G=Math.min(D.length,k.length);const X=D.length-1,ie=k.length-1;for(V=0;V<G;V++)if(D.charCodeAt(X-V)!==k.charCodeAt(ie-V))return V;return G}n.commonSuffixLength=K;function $(D){return 55296<=D&&D<=56319}n.isHighSurrogate=$;function Y(D){return 56320<=D&&D<=57343}n.isLowSurrogate=Y;function r(D,k){return(D-55296<<10)+(k-56320)+65536}n.computeCodePoint=r;function se(D,k,V){const G=D.charCodeAt(V);if($(G)&&V+1<k){const X=D.charCodeAt(V+1);if(Y(X))return r(G,X)}return G}n.getNextCodePoint=se;function ge(D,k){const V=D.charCodeAt(k-1);if(Y(V)&&k>1){const G=D.charCodeAt(k-2);if($(G))return r(G,V)}return V}class ve{constructor(k,V=0){this._str=k,this._len=k.length,this._offset=V}get offset(){return this._offset}setOffset(k){this._offset=k}prevCodePoint(){const k=ge(this._str,this._offset);return this._offset-=k>=65536?2:1,k}nextCodePoint(){const k=se(this._str,this._len,this._offset);return this._offset+=k>=65536?2:1,k}eol(){return this._offset>=this._len}}n.CodePointIterator=ve;class Le{constructor(k,V=0){this._iterator=new ve(k,V)}get offset(){return this._iterator.offset}nextGraphemeLength(){const k=we.getInstance(),V=this._iterator,G=V.offset;let X=k.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ie=V.offset,ce=k.getGraphemeBreakType(V.nextCodePoint());if(De(X,ce)){V.setOffset(ie);break}X=ce}return V.offset-G}prevGraphemeLength(){const k=we.getInstance(),V=this._iterator,G=V.offset;let X=k.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ie=V.offset,ce=k.getGraphemeBreakType(V.prevCodePoint());if(De(ce,X)){V.setOffset(ie);break}X=ce}return G-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Le;function pe(D,k){return new Le(D,k).nextGraphemeLength()}n.nextCharLength=pe;function x(D,k){return new Le(D,k).prevGraphemeLength()}n.prevCharLength=x;function Q(D,k){k>0&&Y(D.charCodeAt(k))&&k--;const V=k+pe(D,k);return[V-x(D,V),V]}n.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function I(D){return Z.test(D)}n.containsRTL=I;const T=/^[\t\n\r\x20-\x7E]*$/;function U(D){return T.test(D)}n.isBasicASCII=U,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(D){return n.UNUSUAL_LINE_TERMINATORS.test(D)}n.containsUnusualLineTerminators=W;function z(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}n.isFullWidthCharacter=z;function ne(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}n.isEmojiImprecise=ne;function re(D,k){if(D.length<k)return D;const V=/\b/g;let G=0;for(;V.test(D)&&!(D.length-V.lastIndex<k);)G=V.lastIndex,V.lastIndex+=1;return D.substring(G).replace(/^\s/,"")}n.lcut=re;const ue=/\x1B\x5B[12]?K/g,oe=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function he(D){return D&&(D=D.replace(ue,""),D=D.replace(oe,""),D=D.replace(fe,"")),D}n.removeAnsiEscapeCodes=he,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}n.startsWithUTF8BOM=Ae;function Ie(D){return Ae(D)?D.substr(1):D}n.stripUTF8BOM=Ie;function ke(D,k){if(!D||!k||D.length<k.length)return!1;const V=k.length,G=D.toLowerCase();let X=0,ie=-1;for(;X<V;){const ce=G.indexOf(k[X],ie+1);if(ce<0)return!1;ie=ce,X++}return!0}n.fuzzyContains=ke;function Te(D,k=!1){return D?(k&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}n.containsUppercaseCharacter=Te;function Ue(D){return D.charAt(0).toUpperCase()+D.slice(1)}n.uppercaseFirstLetter=Ue;function Oe(D,k=1){if(k===0)return"";let V=-1;do V=D.indexOf(`
`,V+1),k--;while(k>0&&V>=0);return V===-1?D:(D[V-1]==="\r"&&V--,D.substr(0,V))}n.getNLines=Oe;function Be(D){const k=90-65+1;return D=D%(2*k),D<k?String.fromCharCode(97+D):String.fromCharCode(65+D-k)}n.singleLetterHash=Be;function Ve(D){return we.getInstance().getGraphemeBreakType(D)}n.getGraphemeBreakType=Ve;function De(D,k){return D===0?k!==5&&k!==7:D===2&&k===3?!1:D===4||D===2||D===3||k===4||k===2||k===3?!0:!(D===8&&(k===8||k===9||k===11||k===12)||(D===11||D===9)&&(k===9||k===10)||(D===12||D===10)&&k===10||k===5||k===13||k===7||D===1||D===13&&k===14||D===6&&k===6)}var We;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(We=n.GraphemeBreakType||(n.GraphemeBreakType={}));class we{constructor(){this._data=qe()}static getInstance(){return we._INSTANCE||(we._INSTANCE=new we),we._INSTANCE}getGraphemeBreakType(k){if(k<32)return k===10?3:k===13?2:4;if(k<127)return 0;const V=this._data,G=V.length/3;let X=1;for(;X<=G;)if(k<V[3*X])X=2*X;else if(k>V[3*X+1])X=2*X+1;else return V[3*X+2];return 0}}we._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(D,k){if(D===0)return 0;const V=ze(D,k);if(V!==void 0)return V;const G=new ve(k,D);return G.prevCodePoint(),G.offset}n.getLeftDeleteOffset=He;function ze(D,k){const V=new ve(k,D);let G=V.prevCodePoint();for(;je(G)||G===65039||G===8419;){if(V.offset===0)return;G=V.prevCodePoint()}if(!ne(G))return;let X=V.offset;return X>0&&V.prevCodePoint()===8205&&(X=V.offset),X}function je(D){return 127995<=D&&D<=127999}var Fe;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),n.noBreakWhitespace="\xA0";class me{constructor(k){this.confusableDictionary=k}static getInstance(k){return me.cache.get(Array.from(k))}static getLocales(){return me._locales.getValue()}isAmbiguous(k){return this.confusableDictionary.has(k)}getPrimaryConfusable(k){return this.confusableDictionary.get(k)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=me,F=me,me.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.cache=new P.LRUCachedComputed(D=>{function k(ae){const de=new Map;for(let be=0;be<ae.length;be+=2)de.set(ae[be],ae[be+1]);return de}function V(ae,de){const be=new Map(ae);for(const[Ee,Me]of de)be.set(Ee,Me);return be}function G(ae,de){if(!ae)return de;const be=new Map;for(const[Ee,Me]of ae)de.has(Ee)&&be.set(Ee,Me);return be}const X=F.ambiguousCharacterData.getValue();let ie=D.filter(ae=>!ae.startsWith("_")&&ae in X);ie.length===0&&(ie=["_default"]);let ce;for(const ae of ie){const de=k(X[ae]);ce=G(ce,de)}const Ce=k(X._common),_e=V(Ce,ce);return new me(_e)}),me._locales=new t.Lazy(()=>Object.keys(me.ambiguousCharacterData.getValue()).filter(D=>!D.startsWith("_")));class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(k){return Ne.getData().has(k)}static get codePoints(){return Ne.getData()}}n.InvisibleCharacters=Ne,Ne._data=void 0}),J(ee[28],te([0,1,2]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(v){return F(v,0)}n.hash=t;function F(v,h){switch(typeof v){case"object":return v===null?a(349,h):Array.isArray(v)?o(v,h):c(v,h);case"string":return d(v,h);case"boolean":return A(v,h);case"number":return a(v,h);case"undefined":return a(937,h);default:return a(617,h)}}n.doHash=F;function a(v,h){return(h<<5)-h+v|0}n.numberHash=a;function A(v,h){return a(v?433:863,h)}function d(v,h){h=a(149417,h);for(let i=0,s=v.length;i<s;i++)h=a(v.charCodeAt(i),h);return h}n.stringHash=d;function o(v,h){return h=a(104579,h),v.reduce((i,s)=>F(s,i),h)}function c(v,h){return h=a(181387,h),Object.keys(v).sort().reduce((i,s)=>(i=d(s,i),F(v[s],i)),h)}class N{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=F(h,this._value),this._value}}n.Hasher=N;var y;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(v,h,i=32){const s=i-h,f=~((1<<s)-1);return(v<<h|(f&v)>>>s)>>>0}function _(v,h=0,i=v.byteLength,s=0){for(let f=0;f<i;f++)v[h+f]=s}function e(v,h,i="0"){for(;v.length<h;)v=i+v;return v}function L(v,h=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((v>>>0).toString(16),h/4)}n.toHexString=L;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const i=h.length;if(i===0)return;const s=this._buff;let f=this._buffLen,b=this._leftoverHighSurrogate,p,m;for(b!==0?(p=b,m=-1,b=0):(p=h.charCodeAt(0),m=0);;){let l=p;if(P.isHighSurrogate(p))if(m+1<i){const g=h.charCodeAt(m+1);P.isLowSurrogate(g)?(m++,l=P.computeCodePoint(p,g)):l=65533}else{b=p;break}else P.isLowSurrogate(p)&&(l=65533);if(f=this._push(s,f,l),m++,m<i)p=h.charCodeAt(m);else break}this._buffLen=f,this._leftoverHighSurrogate=b}_push(h,i,s){return s<128?h[i++]=s:s<2048?(h[i++]=192|(s&1984)>>>6,h[i++]=128|(s&63)>>>0):s<65536?(h[i++]=224|(s&61440)>>>12,h[i++]=128|(s&4032)>>>6,h[i++]=128|(s&63)>>>0):(h[i++]=240|(s&1835008)>>>18,h[i++]=128|(s&258048)>>>12,h[i++]=128|(s&4032)>>>6,h[i++]=128|(s&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),L(this._h0)+L(this._h1)+L(this._h2)+L(this._h3)+L(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=C._bigBlock32,i=this._buffDV;for(let M=0;M<64;M+=4)h.setUint32(M,i.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)h.setUint32(M,w(h.getUint32(M-12,!1)^h.getUint32(M-32,!1)^h.getUint32(M-56,!1)^h.getUint32(M-64,!1),1),!1);let s=this._h0,f=this._h1,b=this._h2,p=this._h3,m=this._h4,l,g,u;for(let M=0;M<80;M++)M<20?(l=f&b|~f&p,g=1518500249):M<40?(l=f^b^p,g=1859775393):M<60?(l=f&b|f&p|b&p,g=2400959708):(l=f^b^p,g=3395469782),u=w(s,5)+l+m+g+h.getUint32(M*4,!1)&4294967295,m=p,p=b,b=w(f,30),f=s,s=u;this._h0=this._h0+s&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+b&4294967295,this._h3=this._h3+p&4294967295,this._h4=this._h4+m&4294967295}}n.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),J(ee[14],te([0,1,19,28]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class F{constructor(w){this.source=w}getElements(){const w=this.source,_=new Int32Array(w.length);for(let e=0,L=w.length;e<L;e++)_[e]=w.charCodeAt(e);return _}}n.StringDiffSequence=F;function a(y,w,_){return new N(new F(y),new F(w)).ComputeDiff(_).changes}n.stringDiff=a;class A{static Assert(w,_){if(!w)throw new Error(_)}}n.Debug=A;class d{static Copy(w,_,e,L,C){for(let v=0;v<C;v++)e[L+v]=w[_+v]}static Copy2(w,_,e,L,C){for(let v=0;v<C;v++)e[L+v]=w[_+v]}}n.MyArray=d;var o;(function(y){y[y.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(w,_){this.m_originalStart=Math.min(this.m_originalStart,w),this.m_modifiedStart=Math.min(this.m_modifiedStart,_),this.m_originalCount++}AddModifiedElement(w,_){this.m_originalStart=Math.min(this.m_originalStart,w),this.m_modifiedStart=Math.min(this.m_modifiedStart,_),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class N{constructor(w,_,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=w,this._modifiedSequence=_;const[L,C,v]=N._getElements(w),[h,i,s]=N._getElements(_);this._hasStrings=v&&s,this._originalStringElements=L,this._originalElementsOrHash=C,this._modifiedStringElements=h,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(w){return w.length>0&&typeof w[0]=="string"}static _getElements(w){const _=w.getElements();if(N._isStringArray(_)){const e=new Int32Array(_.length);for(let L=0,C=_.length;L<C;L++)e[L]=(0,t.stringHash)(_[L],0);return[_,e,!0]}return _ instanceof Int32Array?[[],_,!1]:[[],new Int32Array(_),!1]}ElementsAreEqual(w,_){return this._originalElementsOrHash[w]!==this._modifiedElementsOrHash[_]?!1:this._hasStrings?this._originalStringElements[w]===this._modifiedStringElements[_]:!0}ElementsAreStrictEqual(w,_){if(!this.ElementsAreEqual(w,_))return!1;const e=N._getStrictElement(this._originalSequence,w),L=N._getStrictElement(this._modifiedSequence,_);return e===L}static _getStrictElement(w,_){return typeof w.getStrictElement=="function"?w.getStrictElement(_):null}OriginalElementsAreEqual(w,_){return this._originalElementsOrHash[w]!==this._originalElementsOrHash[_]?!1:this._hasStrings?this._originalStringElements[w]===this._originalStringElements[_]:!0}ModifiedElementsAreEqual(w,_){return this._modifiedElementsOrHash[w]!==this._modifiedElementsOrHash[_]?!1:this._hasStrings?this._modifiedStringElements[w]===this._modifiedStringElements[_]:!0}ComputeDiff(w){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,w)}_ComputeDiff(w,_,e,L,C){const v=[!1];let h=this.ComputeDiffRecursive(w,_,e,L,v);return C&&(h=this.PrettifyChanges(h)),{quitEarly:v[0],changes:h}}ComputeDiffRecursive(w,_,e,L,C){for(C[0]=!1;w<=_&&e<=L&&this.ElementsAreEqual(w,e);)w++,e++;for(;_>=w&&L>=e&&this.ElementsAreEqual(_,L);)_--,L--;if(w>_||e>L){let b;return e<=L?(A.Assert(w===_+1,"originalStart should only be one more than originalEnd"),b=[new P.DiffChange(w,0,e,L-e+1)]):w<=_?(A.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),b=[new P.DiffChange(w,_-w+1,e,0)]):(A.Assert(w===_+1,"originalStart should only be one more than originalEnd"),A.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),b=[]),b}const v=[0],h=[0],i=this.ComputeRecursionPoint(w,_,e,L,v,h,C),s=v[0],f=h[0];if(i!==null)return i;if(!C[0]){const b=this.ComputeDiffRecursive(w,s,e,f,C);let p=[];return C[0]?p=[new P.DiffChange(s+1,_-(s+1)+1,f+1,L-(f+1)+1)]:p=this.ComputeDiffRecursive(s+1,_,f+1,L,C),this.ConcatenateChanges(b,p)}return[new P.DiffChange(w,_-w+1,e,L-e+1)]}WALKTRACE(w,_,e,L,C,v,h,i,s,f,b,p,m,l,g,u,M,S){let R=null,q=null,H=new c,j=_,E=e,O=m[0]-u[0]-L,K=-1073741824,$=this.m_forwardHistory.length-1;do{const Y=O+w;Y===j||Y<E&&s[Y-1]<s[Y+1]?(b=s[Y+1],l=b-O-L,b<K&&H.MarkNextChange(),K=b,H.AddModifiedElement(b+1,l),O=Y+1-w):(b=s[Y-1]+1,l=b-O-L,b<K&&H.MarkNextChange(),K=b-1,H.AddOriginalElement(b,l+1),O=Y-1-w),$>=0&&(s=this.m_forwardHistory[$],w=s[0],j=1,E=s.length-1)}while(--$>=-1);if(R=H.getReverseChanges(),S[0]){let Y=m[0]+1,r=u[0]+1;if(R!==null&&R.length>0){const se=R[R.length-1];Y=Math.max(Y,se.getOriginalEnd()),r=Math.max(r,se.getModifiedEnd())}q=[new P.DiffChange(Y,p-Y+1,r,g-r+1)]}else{H=new c,j=v,E=h,O=m[0]-u[0]-i,K=1073741824,$=M?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Y=O+C;Y===j||Y<E&&f[Y-1]>=f[Y+1]?(b=f[Y+1]-1,l=b-O-i,b>K&&H.MarkNextChange(),K=b+1,H.AddOriginalElement(b+1,l+1),O=Y+1-C):(b=f[Y-1],l=b-O-i,b>K&&H.MarkNextChange(),K=b,H.AddModifiedElement(b+1,l+1),O=Y-1-C),$>=0&&(f=this.m_reverseHistory[$],C=f[0],j=1,E=f.length-1)}while(--$>=-1);q=H.getChanges()}return this.ConcatenateChanges(R,q)}ComputeRecursionPoint(w,_,e,L,C,v,h){let i=0,s=0,f=0,b=0,p=0,m=0;w--,e--,C[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=_-w+(L-e),g=l+1,u=new Int32Array(g),M=new Int32Array(g),S=L-e,R=_-w,q=w-e,H=_-L,E=(R-S)%2==0;u[S]=w,M[R]=_,h[0]=!1;for(let O=1;O<=l/2+1;O++){let K=0,$=0;f=this.ClipDiagonalBound(S-O,O,S,g),b=this.ClipDiagonalBound(S+O,O,S,g);for(let r=f;r<=b;r+=2){r===f||r<b&&u[r-1]<u[r+1]?i=u[r+1]:i=u[r-1]+1,s=i-(r-S)-q;const se=i;for(;i<_&&s<L&&this.ElementsAreEqual(i+1,s+1);)i++,s++;if(u[r]=i,i+s>K+$&&(K=i,$=s),!E&&Math.abs(r-R)<=O-1&&i>=M[r])return C[0]=i,v[0]=s,se<=M[r]&&1447>0&&O<=1447+1?this.WALKTRACE(S,f,b,q,R,p,m,H,u,M,i,_,C,s,L,v,E,h):null}const Y=(K-w+($-e)-O)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(K,Y))return h[0]=!0,C[0]=K,v[0]=$,Y>0&&1447>0&&O<=1447+1?this.WALKTRACE(S,f,b,q,R,p,m,H,u,M,i,_,C,s,L,v,E,h):(w++,e++,[new P.DiffChange(w,_-w+1,e,L-e+1)]);p=this.ClipDiagonalBound(R-O,O,R,g),m=this.ClipDiagonalBound(R+O,O,R,g);for(let r=p;r<=m;r+=2){r===p||r<m&&M[r-1]>=M[r+1]?i=M[r+1]-1:i=M[r-1],s=i-(r-R)-H;const se=i;for(;i>w&&s>e&&this.ElementsAreEqual(i,s);)i--,s--;if(M[r]=i,E&&Math.abs(r-S)<=O&&i<=u[r])return C[0]=i,v[0]=s,se>=u[r]&&1447>0&&O<=1447+1?this.WALKTRACE(S,f,b,q,R,p,m,H,u,M,i,_,C,s,L,v,E,h):null}if(O<=1447){let r=new Int32Array(b-f+2);r[0]=S-f+1,d.Copy2(u,f,r,1,b-f+1),this.m_forwardHistory.push(r),r=new Int32Array(m-p+2),r[0]=R-p+1,d.Copy2(M,p,r,1,m-p+1),this.m_reverseHistory.push(r)}}return this.WALKTRACE(S,f,b,q,R,p,m,H,u,M,i,_,C,s,L,v,E,h)}PrettifyChanges(w){for(let _=0;_<w.length;_++){const e=w[_],L=_<w.length-1?w[_+1].originalStart:this._originalElementsOrHash.length,C=_<w.length-1?w[_+1].modifiedStart:this._modifiedElementsOrHash.length,v=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<L&&e.modifiedStart+e.modifiedLength<C&&(!v||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const s=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!s)break;e.originalStart++,e.modifiedStart++}let i=[null];if(_<w.length-1&&this.ChangesOverlap(w[_],w[_+1],i)){w[_]=i[0],w.splice(_+1,1),_--;continue}}for(let _=w.length-1;_>=0;_--){const e=w[_];let L=0,C=0;if(_>0){const b=w[_-1];L=b.originalStart+b.originalLength,C=b.modifiedStart+b.modifiedLength}const v=e.originalLength>0,h=e.modifiedLength>0;let i=0,s=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let b=1;;b++){const p=e.originalStart-b,m=e.modifiedStart-b;if(p<L||m<C||v&&!this.OriginalElementsAreEqual(p,p+e.originalLength)||h&&!this.ModifiedElementsAreEqual(m,m+e.modifiedLength))break;const g=(p===L&&m===C?5:0)+this._boundaryScore(p,e.originalLength,m,e.modifiedLength);g>s&&(s=g,i=b)}e.originalStart-=i,e.modifiedStart-=i;const f=[null];if(_>0&&this.ChangesOverlap(w[_-1],w[_],f)){w[_-1]=f[0],w.splice(_,1),_++;continue}}if(this._hasStrings)for(let _=1,e=w.length;_<e;_++){const L=w[_-1],C=w[_],v=C.originalStart-L.originalStart-L.originalLength,h=L.originalStart,i=C.originalStart+C.originalLength,s=i-h,f=L.modifiedStart,b=C.modifiedStart+C.modifiedLength,p=b-f;if(v<5&&s<20&&p<20){const m=this._findBetterContiguousSequence(h,s,f,p,v);if(m){const[l,g]=m;(l!==L.originalStart+L.originalLength||g!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=l-L.originalStart,L.modifiedLength=g-L.modifiedStart,C.originalStart=l+v,C.modifiedStart=g+v,C.originalLength=i-C.originalStart,C.modifiedLength=b-C.modifiedStart)}}}return w}_findBetterContiguousSequence(w,_,e,L,C){if(_<C||L<C)return null;const v=w+_-C+1,h=e+L-C+1;let i=0,s=0,f=0;for(let b=w;b<v;b++)for(let p=e;p<h;p++){const m=this._contiguousSequenceScore(b,p,C);m>0&&m>i&&(i=m,s=b,f=p)}return i>0?[s,f]:null}_contiguousSequenceScore(w,_,e){let L=0;for(let C=0;C<e;C++){if(!this.ElementsAreEqual(w+C,_+C))return 0;L+=this._originalStringElements[w+C].length}return L}_OriginalIsBoundary(w){return w<=0||w>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[w])}_OriginalRegionIsBoundary(w,_){if(this._OriginalIsBoundary(w)||this._OriginalIsBoundary(w-1))return!0;if(_>0){const e=w+_;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(w){return w<=0||w>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[w])}_ModifiedRegionIsBoundary(w,_){if(this._ModifiedIsBoundary(w)||this._ModifiedIsBoundary(w-1))return!0;if(_>0){const e=w+_;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(w,_,e,L){const C=this._OriginalRegionIsBoundary(w,_)?1:0,v=this._ModifiedRegionIsBoundary(e,L)?1:0;return C+v}ConcatenateChanges(w,_){let e=[];if(w.length===0||_.length===0)return _.length>0?_:w;if(this.ChangesOverlap(w[w.length-1],_[0],e)){const L=new Array(w.length+_.length-1);return d.Copy(w,0,L,0,w.length-1),L[w.length-1]=e[0],d.Copy(_,1,L,w.length,_.length-1),L}else{const L=new Array(w.length+_.length);return d.Copy(w,0,L,0,w.length),d.Copy(_,0,L,w.length,_.length),L}}ChangesOverlap(w,_,e){if(A.Assert(w.originalStart<=_.originalStart,"Left change is not less than or equal to right change"),A.Assert(w.modifiedStart<=_.modifiedStart,"Left change is not less than or equal to right change"),w.originalStart+w.originalLength>=_.originalStart||w.modifiedStart+w.modifiedLength>=_.modifiedStart){const L=w.originalStart;let C=w.originalLength;const v=w.modifiedStart;let h=w.modifiedLength;return w.originalStart+w.originalLength>=_.originalStart&&(C=_.originalStart+_.originalLength-w.originalStart),w.modifiedStart+w.modifiedLength>=_.modifiedStart&&(h=_.modifiedStart+_.modifiedLength-w.modifiedStart),e[0]=new P.DiffChange(L,C,v,h),!0}else return e[0]=null,!1}ClipDiagonalBound(w,_,e,L){if(w>=0&&w<L)return w;const C=e,v=L-e-1,h=_%2==0;if(w<0){const i=C%2==0;return h===i?0:1}else{const i=v%2==0;return h===i?L-1:L-2}}}n.LcsDiff=N}),J(ee[7],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function P(u){return Array.isArray(u)}n.isArray=P;function t(u){return typeof u=="string"}n.isString=t;function F(u){return Array.isArray(u)&&u.every(M=>t(M))}n.isStringArray=F;function a(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}n.isObject=a;function A(u){return typeof u=="number"&&!isNaN(u)}n.isNumber=A;function d(u){return!!u&&typeof u[Symbol.iterator]=="function"}n.isIterable=d;function o(u){return u===!0||u===!1}n.isBoolean=o;function c(u){return typeof u=="undefined"}n.isUndefined=c;function N(u){return!y(u)}n.isDefined=N;function y(u){return c(u)||u===null}n.isUndefinedOrNull=y;function w(u,M){if(!u)throw new Error(M?`Unexpected type, expected '${M}'`:"Unexpected type")}n.assertType=w;function _(u){if(y(u))throw new Error("Assertion Failed: argument is undefined or null");return u}n.assertIsDefined=_;function e(...u){const M=[];for(let S=0;S<u.length;S++){const R=u[S];if(y(R))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);M.push(R)}return M}n.assertAllDefined=e;const L=Object.prototype.hasOwnProperty;function C(u){if(!a(u))return!1;for(let M in u)if(L.call(u,M))return!1;return!0}n.isEmptyObject=C;function v(u){return typeof u=="function"}n.isFunction=v;function h(...u){return u.length>0&&u.every(v)}n.areFunctions=h;function i(u,M){const S=Math.min(u.length,M.length);for(let R=0;R<S;R++)s(u[R],M[R])}n.validateConstraints=i;function s(u,M){if(t(M)){if(typeof u!==M)throw new Error(`argument does not match constraint: typeof ${M}`)}else if(v(M)){try{if(u instanceof M)return}catch{}if(!y(u)&&u.constructor===M||M.length===1&&M.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=s;function f(u){let M=[],S=Object.getPrototypeOf(u);for(;Object.prototype!==S;)M=M.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return M}n.getAllPropertyNames=f;function b(u){const M=[];for(const S of f(u))typeof u[S]=="function"&&M.push(S);return M}n.getAllMethodNames=b;function p(u,M){const S=q=>function(){const H=Array.prototype.slice.call(arguments,0);return M(q,H)};let R={};for(const q of u)R[q]=S(q);return R}n.createProxyObject=p;function m(u){return u===null?void 0:u}n.withNullAsUndefined=m;function l(u){return typeof u=="undefined"?null:u}n.withUndefinedAsNull=l;function g(u,M="Unreachable"){throw new Error(M)}n.assertNever=g}),J(ee[29],te([0,1,7]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.filter=n.getCaseInsensitive=n.distinct=n.getOrDefault=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const C=Array.isArray(L)?[]:{};return Object.keys(L).forEach(v=>{L[v]&&typeof L[v]=="object"?C[v]=t(L[v]):C[v]=L[v]}),C}n.deepClone=t;function F(L){if(!L||typeof L!="object")return L;const C=[L];for(;C.length>0;){const v=C.shift();Object.freeze(v);for(const h in v)if(a.call(v,h)){const i=v[h];typeof i=="object"&&!Object.isFrozen(i)&&C.push(i)}}return L}n.deepFreeze=F;const a=Object.prototype.hasOwnProperty;function A(L,C){return d(L,C,new Set)}n.cloneAndChange=A;function d(L,C,v){if((0,P.isUndefinedOrNull)(L))return L;const h=C(L);if(typeof h!="undefined")return h;if((0,P.isArray)(L)){const i=[];for(const s of L)i.push(d(s,C,v));return i}if((0,P.isObject)(L)){if(v.has(L))throw new Error("Cannot clone recursive data-structure");v.add(L);const i={};for(let s in L)a.call(L,s)&&(i[s]=d(L[s],C,v));return v.delete(L),i}return L}function o(L,C,v=!0){return(0,P.isObject)(L)?((0,P.isObject)(C)&&Object.keys(C).forEach(h=>{h in L?v&&((0,P.isObject)(L[h])&&(0,P.isObject)(C[h])?o(L[h],C[h],v):L[h]=C[h]):L[h]=C[h]}),L):C}n.mixin=o;function c(L,C){if(L===C)return!0;if(L==null||C===null||C===void 0||typeof L!=typeof C||typeof L!="object"||Array.isArray(L)!==Array.isArray(C))return!1;let v,h;if(Array.isArray(L)){if(L.length!==C.length)return!1;for(v=0;v<L.length;v++)if(!c(L[v],C[v]))return!1}else{const i=[];for(h in L)i.push(h);i.sort();const s=[];for(h in C)s.push(h);if(s.sort(),!c(i,s))return!1;for(v=0;v<i.length;v++)if(!c(L[i[v]],C[i[v]]))return!1}return!0}n.equals=c;function N(L){const C=new Set;return JSON.stringify(L,(v,h)=>{if((0,P.isObject)(h)||Array.isArray(h)){if(C.has(h))return"[Circular]";C.add(h)}return h})}n.safeStringify=N;function y(L,C,v){const h=C(L);return typeof h=="undefined"?v:h}n.getOrDefault=y;function w(L,C){const v=Object.create(null);return!L||!C||Object.keys(C).forEach(i=>{const s=L[i],f=C[i];c(s,f)||(v[i]=f)}),v}n.distinct=w;function _(L,C){const v=C.toLowerCase(),h=Object.keys(L).find(i=>i.toLowerCase()===v);return h?L[h]:L[C]}n.getCaseInsensitive=_;function e(L,C){const v=Object.create(null);for(const[h,i]of Object.entries(L))C(h,i)&&(v[h]=i);return v}n.filter=e}),J(ee[15],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var P;(function(a){a[a.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",a[a.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",a[a.MAX_UINT_8=255]="MAX_UINT_8",a[a.MAX_UINT_16=65535]="MAX_UINT_16",a[a.MAX_UINT_32=4294967295]="MAX_UINT_32",a[a.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=n.Constants||(n.Constants={}));function t(a){return a<0?0:a>255?255:a|0}n.toUint8=t;function F(a){return a<0?0:a>4294967295?4294967295:a|0}n.toUint32=F}),J(ee[10],te([0,1,26,5]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const F=/^\w[\w\d+.-]*$/,a=/^\//,A=/^\/\//;function d(m,l){if(!m.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!F.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!a.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(m,l){return!m&&!l?"file":m}function c(m,l){switch(m){case"https":case"http":case"file":l?l[0]!==y&&(l=y+l):l=y;break}return l}const N="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{constructor(l,g,u,M,S,R=!1){typeof l=="object"?(this.scheme=l.scheme||N,this.authority=l.authority||N,this.path=l.path||N,this.query=l.query||N,this.fragment=l.fragment||N):(this.scheme=o(l,R),this.authority=g||N,this.path=c(this.scheme,u||N),this.query=M||N,this.fragment=S||N,d(this,R))}static isUri(l){return l instanceof _?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return i(this,!1)}with(l){if(!l)return this;let{scheme:g,authority:u,path:M,query:S,fragment:R}=l;return g===void 0?g=this.scheme:g===null&&(g=N),u===void 0?u=this.authority:u===null&&(u=N),M===void 0?M=this.path:M===null&&(M=N),S===void 0?S=this.query:S===null&&(S=N),R===void 0?R=this.fragment:R===null&&(R=N),g===this.scheme&&u===this.authority&&M===this.path&&S===this.query&&R===this.fragment?this:new L(g,u,M,S,R)}static parse(l,g=!1){const u=w.exec(l);return u?new L(u[2]||N,p(u[4]||N),p(u[5]||N),p(u[7]||N),p(u[9]||N),g):new L(N,N,N,N,N)}static file(l){let g=N;if(t.isWindows&&(l=l.replace(/\\/g,y)),l[0]===y&&l[1]===y){const u=l.indexOf(y,2);u===-1?(g=l.substring(2),l=y):(g=l.substring(2,u),l=l.substring(u)||y)}return new L("file",g,l,N,N)}static from(l){const g=new L(l.scheme,l.authority,l.path,l.query,l.fragment);return d(g,!0),g}static joinPath(l,...g){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&l.scheme==="file"?u=_.file(P.win32.join(i(l,!0),...g)).path:u=P.posix.join(l.path,...g),l.with({path:u})}toString(l=!1){return s(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof _)return l;{const g=new L(l);return g._formatted=l.external,g._fsPath=l._sep===e?l.fsPath:null,g}}else return l}}n.URI=_;const e=t.isWindows?1:void 0;class L extends _{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(l=!1){return l?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=e),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(m,l){let g,u=-1;for(let M=0;M<m.length;M++){const S=m.charCodeAt(M);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||l&&S===47)u!==-1&&(g+=encodeURIComponent(m.substring(u,M)),u=-1),g!==void 0&&(g+=m.charAt(M));else{g===void 0&&(g=m.substr(0,M));const R=C[S];R!==void 0?(u!==-1&&(g+=encodeURIComponent(m.substring(u,M)),u=-1),g+=R):u===-1&&(u=M)}}return u!==-1&&(g+=encodeURIComponent(m.substring(u))),g!==void 0?g:m}function h(m){let l;for(let g=0;g<m.length;g++){const u=m.charCodeAt(g);u===35||u===63?(l===void 0&&(l=m.substr(0,g)),l+=C[u]):l!==void 0&&(l+=m[g])}return l!==void 0?l:m}function i(m,l){let g;return m.authority&&m.path.length>1&&m.scheme==="file"?g=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?l?g=m.path.substr(1):g=m.path[1].toLowerCase()+m.path.substr(2):g=m.path,t.isWindows&&(g=g.replace(/\//g,"\\")),g}n.uriToFsPath=i;function s(m,l){const g=l?h:v;let u="",{scheme:M,authority:S,path:R,query:q,fragment:H}=m;if(M&&(u+=M,u+=":"),(S||M==="file")&&(u+=y,u+=y),S){let j=S.indexOf("@");if(j!==-1){const E=S.substr(0,j);S=S.substr(j+1),j=E.indexOf(":"),j===-1?u+=g(E,!1):(u+=g(E.substr(0,j),!1),u+=":",u+=g(E.substr(j+1),!1)),u+="@"}S=S.toLowerCase(),j=S.indexOf(":"),j===-1?u+=g(S,!1):(u+=g(S.substr(0,j),!1),u+=S.substr(j))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const j=R.charCodeAt(1);j>=65&&j<=90&&(R=`/${String.fromCharCode(j+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const j=R.charCodeAt(0);j>=65&&j<=90&&(R=`${String.fromCharCode(j+32)}:${R.substr(2)}`)}u+=g(R,!0)}return q&&(u+="?",u+=g(q,!1)),H&&(u+="#",u+=l?H:v(H,!1)),u}function f(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+f(m.substr(3)):m}}const b=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function p(m){return m.match(b)?m.replace(b,l=>f(l)):m}}),J(ee[44],te([0,1,8,6,9,5,7,2]),function(B,n,P,t,F,a,A,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let c=!1;function N(m){!a.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(m.message))}n.logOnceWebWorkerWarning=N;var y;(function(m){m[m.Request=0]="Request",m[m.Reply=1]="Reply",m[m.SubscribeEvent=2]="SubscribeEvent",m[m.Event=3]="Event",m[m.UnsubscribeEvent=4]="UnsubscribeEvent"})(y||(y={}));class w{constructor(l,g,u,M){this.vsWorker=l,this.req=g,this.method=u,this.args=M,this.type=0}}class _{constructor(l,g,u,M){this.vsWorker=l,this.seq=g,this.res=u,this.err=M,this.type=1}}class e{constructor(l,g,u,M){this.vsWorker=l,this.req=g,this.eventName=u,this.arg=M,this.type=2}}class L{constructor(l,g,u){this.vsWorker=l,this.req=g,this.event=u,this.type=3}}class C{constructor(l,g){this.vsWorker=l,this.req=g,this.type=4}}class v{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,g){const u=String(++this._lastSentReq);return new Promise((M,S)=>{this._pendingReplies[u]={resolve:M,reject:S},this._send(new w(this._workerId,u,l,g))})}listen(l,g){let u=null;const M=new t.Emitter({onFirstListenerAdd:()=>{u=String(++this._lastSentReq),this._pendingEmitters.set(u,M),this._send(new e(this._workerId,u,l,g))},onLastListenerRemove:()=>{this._pendingEmitters.delete(u),this._send(new C(this._workerId,u)),u=null}});return M.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}let g=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let u=l.err;l.err.$isError&&(u=new Error,u.name=l.err.name,u.message=l.err.message,u.stack=l.err.stack),g.reject(u);return}g.resolve(l.res)}_handleRequestMessage(l){let g=l.req;this._handler.handleMessage(l.method,l.args).then(M=>{this._send(new _(this._workerId,g,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,P.transformErrorForSerialization)(M.detail)),this._send(new _(this._workerId,g,void 0,(0,P.transformErrorForSerialization)(M)))})}_handleSubscribeEventMessage(l){const g=l.req,u=this._handler.handleEvent(l.eventName,l.arg)(M=>{this._send(new L(this._workerId,g,M))});this._pendingEvents.set(g,u)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){let g=[];if(l.type===0)for(let u=0;u<l.args.length;u++)l.args[u]instanceof ArrayBuffer&&g.push(l.args[u]);else l.type===1&&l.res instanceof ArrayBuffer&&g.push(l.res);this._handler.sendMessage(l,g)}}class h extends F.Disposable{constructor(l,g,u){super();let M=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",j=>{this._protocol.handleMessage(j)},j=>{M&&M(j)})),this._protocol=new v({sendMessage:(j,E)=>{this._worker.postMessage(j,E)},handleMessage:(j,E)=>{if(typeof u[j]!="function")return Promise.reject(new Error("Missing method "+j+" on main thread host."));try{return Promise.resolve(u[j].apply(u,E))}catch(O){return Promise.reject(O)}},handleEvent:(j,E)=>{if(s(j)){const O=u[j].call(u,E);if(typeof O!="function")throw new Error(`Missing dynamic event ${j} on main thread host.`);return O}if(i(j)){const O=u[j];if(typeof O!="function")throw new Error(`Missing event ${j} on main thread host.`);return O}throw new Error(`Malformed event name ${j}`)}}),this._protocol.setWorkerId(this._worker.getId());let S=null;typeof a.globals.require!="undefined"&&typeof a.globals.require.getConfig=="function"?S=a.globals.require.getConfig():typeof a.globals.requirejs!="undefined"&&(S=a.globals.requirejs.s.contexts._.config);const R=A.getAllMethodNames(u);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(S)),g,R]);const q=(j,E)=>this._request(j,E),H=(j,E)=>this._protocol.listen(j,E);this._lazyProxy=new Promise((j,E)=>{M=E,this._onModuleLoaded.then(O=>{j(f(O,q,H))},O=>{E(O),this._onError("Worker failed to load "+g,O)})})}getProxyObject(){return this._lazyProxy}_request(l,g){return new Promise((u,M)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,g).then(u,M)},M)})}_onError(l,g){console.error(l),console.info(g)}}n.SimpleWorkerClient=h;function i(m){return m[0]==="o"&&m[1]==="n"&&d.isUpperAsciiLetter(m.charCodeAt(2))}function s(m){return/^onDynamic/.test(m)&&d.isUpperAsciiLetter(m.charCodeAt(9))}function f(m,l,g){const u=R=>function(){const q=Array.prototype.slice.call(arguments,0);return l(R,q)},M=R=>function(q){return g(R,q)};let S={};for(const R of m){if(s(R)){S[R]=M(R);continue}if(i(R)){S[R]=g(R,void 0);continue}S[R]=u(R)}return S}class b{constructor(l,g){this._requestHandlerFactory=g,this._requestHandler=null,this._protocol=new v({sendMessage:(u,M)=>{l(u,M)},handleMessage:(u,M)=>this._handleMessage(u,M),handleEvent:(u,M)=>this._handleEvent(u,M)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,g){if(l===o)return this.initialize(g[0],g[1],g[2],g[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,g))}catch(u){return Promise.reject(u)}}_handleEvent(l,g){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(l)){const u=this._requestHandler[l].call(this._requestHandler,g);if(typeof u!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return u}if(i(l)){const u=this._requestHandler[l];if(typeof u!="function")throw new Error(`Missing event ${l} on request handler.`);return u}throw new Error(`Malformed event name ${l}`)}initialize(l,g,u,M){this._protocol.setWorkerId(l);const q=f(M,(H,j)=>this._protocol.sendMessage(H,j),(H,j)=>this._protocol.listen(H,j));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(q),Promise.resolve(A.getAllMethodNames(this._requestHandler))):(g&&(typeof g.baseUrl!="undefined"&&delete g.baseUrl,typeof g.paths!="undefined"&&typeof g.paths.vs!="undefined"&&delete g.paths.vs,typeof g.trustedTypesPolicy!==void 0&&delete g.trustedTypesPolicy,g.catchError=!0,a.globals.require.config(g)),new Promise((H,j)=>{(a.globals.require||B)([u],O=>{if(this._requestHandler=O.create(q),!this._requestHandler){j(new Error("No RequestHandler!"));return}H(A.getAllMethodNames(this._requestHandler))},j)}))}}n.SimpleWorkerServer=b;function p(m){return new b(m,null)}n.create=p}),J(ee[16],te([0,1,15]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(d){const o=(0,P.toUint8)(d);this._defaultValue=o,this._asciiMap=t._createAsciiMap(o),this._map=new Map}static _createAsciiMap(d){const o=new Uint8Array(256);for(let c=0;c<256;c++)o[c]=d;return o}set(d,o){const c=(0,P.toUint8)(o);d>=0&&d<256?this._asciiMap[d]=c:this._map.set(d,c)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}}n.CharacterClassifier=t;var F;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(F||(F={}));class a{constructor(){this._actual=new t(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}}n.CharacterSet=a}),J(ee[3],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class P{constructor(F,a){this.lineNumber=F,this.column=a}with(F=this.lineNumber,a=this.column){return F===this.lineNumber&&a===this.column?this:new P(F,a)}delta(F=0,a=0){return this.with(this.lineNumber+F,this.column+a)}equals(F){return P.equals(this,F)}static equals(F,a){return!F&&!a?!0:!!F&&!!a&&F.lineNumber===a.lineNumber&&F.column===a.column}isBefore(F){return P.isBefore(this,F)}static isBefore(F,a){return F.lineNumber<a.lineNumber?!0:a.lineNumber<F.lineNumber?!1:F.column<a.column}isBeforeOrEqual(F){return P.isBeforeOrEqual(this,F)}static isBeforeOrEqual(F,a){return F.lineNumber<a.lineNumber?!0:a.lineNumber<F.lineNumber?!1:F.column<=a.column}static compare(F,a){const A=F.lineNumber|0,d=a.lineNumber|0;if(A===d){const o=F.column|0,c=a.column|0;return o-c}return A-d}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(F){return new P(F.lineNumber,F.column)}static isIPosition(F){return F&&typeof F.lineNumber=="number"&&typeof F.column=="number"}}n.Position=P}),J(ee[4],te([0,1,3]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(a,A,d,o){a>d||a===d&&A>o?(this.startLineNumber=d,this.startColumn=o,this.endLineNumber=a,this.endColumn=A):(this.startLineNumber=a,this.startColumn=A,this.endLineNumber=d,this.endColumn=o)}isEmpty(){return t.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return t.containsPosition(this,a)}static containsPosition(a,A){return!(A.lineNumber<a.startLineNumber||A.lineNumber>a.endLineNumber||A.lineNumber===a.startLineNumber&&A.column<a.startColumn||A.lineNumber===a.endLineNumber&&A.column>a.endColumn)}static strictContainsPosition(a,A){return!(A.lineNumber<a.startLineNumber||A.lineNumber>a.endLineNumber||A.lineNumber===a.startLineNumber&&A.column<=a.startColumn||A.lineNumber===a.endLineNumber&&A.column>=a.endColumn)}containsRange(a){return t.containsRange(this,a)}static containsRange(a,A){return!(A.startLineNumber<a.startLineNumber||A.endLineNumber<a.startLineNumber||A.startLineNumber>a.endLineNumber||A.endLineNumber>a.endLineNumber||A.startLineNumber===a.startLineNumber&&A.startColumn<a.startColumn||A.endLineNumber===a.endLineNumber&&A.endColumn>a.endColumn)}strictContainsRange(a){return t.strictContainsRange(this,a)}static strictContainsRange(a,A){return!(A.startLineNumber<a.startLineNumber||A.endLineNumber<a.startLineNumber||A.startLineNumber>a.endLineNumber||A.endLineNumber>a.endLineNumber||A.startLineNumber===a.startLineNumber&&A.startColumn<=a.startColumn||A.endLineNumber===a.endLineNumber&&A.endColumn>=a.endColumn)}plusRange(a){return t.plusRange(this,a)}static plusRange(a,A){let d,o,c,N;return A.startLineNumber<a.startLineNumber?(d=A.startLineNumber,o=A.startColumn):A.startLineNumber===a.startLineNumber?(d=A.startLineNumber,o=Math.min(A.startColumn,a.startColumn)):(d=a.startLineNumber,o=a.startColumn),A.endLineNumber>a.endLineNumber?(c=A.endLineNumber,N=A.endColumn):A.endLineNumber===a.endLineNumber?(c=A.endLineNumber,N=Math.max(A.endColumn,a.endColumn)):(c=a.endLineNumber,N=a.endColumn),new t(d,o,c,N)}intersectRanges(a){return t.intersectRanges(this,a)}static intersectRanges(a,A){let d=a.startLineNumber,o=a.startColumn,c=a.endLineNumber,N=a.endColumn,y=A.startLineNumber,w=A.startColumn,_=A.endLineNumber,e=A.endColumn;return d<y?(d=y,o=w):d===y&&(o=Math.max(o,w)),c>_?(c=_,N=e):c===_&&(N=Math.min(N,e)),d>c||d===c&&o>N?null:new t(d,o,c,N)}equalsRange(a){return t.equalsRange(this,a)}static equalsRange(a,A){return!!a&&!!A&&a.startLineNumber===A.startLineNumber&&a.startColumn===A.startColumn&&a.endLineNumber===A.endLineNumber&&a.endColumn===A.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(a){return new P.Position(a.endLineNumber,a.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(a){return new P.Position(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,A){return new t(this.startLineNumber,this.startColumn,a,A)}setStartPosition(a,A){return new t(a,A,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(a){return new t(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}static fromPositions(a,A=a){return new t(a.lineNumber,a.column,A.lineNumber,A.column)}static lift(a){return a?new t(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,A){return!(a.endLineNumber<A.startLineNumber||a.endLineNumber===A.startLineNumber&&a.endColumn<A.startColumn||A.endLineNumber<a.startLineNumber||A.endLineNumber===a.startLineNumber&&A.endColumn<a.startColumn)}static areIntersecting(a,A){return!(a.endLineNumber<A.startLineNumber||a.endLineNumber===A.startLineNumber&&a.endColumn<=A.startColumn||A.endLineNumber<a.startLineNumber||A.endLineNumber===a.startLineNumber&&A.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,A){if(a&&A){const c=a.startLineNumber|0,N=A.startLineNumber|0;if(c===N){const y=a.startColumn|0,w=A.startColumn|0;if(y===w){const _=a.endLineNumber|0,e=A.endLineNumber|0;if(_===e){const L=a.endColumn|0,C=A.endColumn|0;return L-C}return _-e}return y-w}return c-N}return(a?1:0)-(A?1:0)}static compareRangesUsingEnds(a,A){return a.endLineNumber===A.endLineNumber?a.endColumn===A.endColumn?a.startLineNumber===A.startLineNumber?a.startColumn-A.startColumn:a.startLineNumber-A.startLineNumber:a.endColumn-A.endColumn:a.endLineNumber-A.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}n.Range=t}),J(ee[30],te([0,1,3,4]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var F;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(F=n.SelectionDirection||(n.SelectionDirection={}));class a extends t.Range{constructor(d,o,c,N){super(d,o,c,N);this.selectionStartLineNumber=d,this.selectionStartColumn=o,this.positionLineNumber=c,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return a.selectionsEqual(this,d)}static selectionsEqual(d,o){return d.selectionStartLineNumber===o.selectionStartLineNumber&&d.selectionStartColumn===o.selectionStartColumn&&d.positionLineNumber===o.positionLineNumber&&d.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,o){return this.getDirection()===0?new a(this.startLineNumber,this.startColumn,d,o):new a(d,o,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,o){return this.getDirection()===0?new a(d,o,this.endLineNumber,this.endColumn):new a(this.endLineNumber,this.endColumn,d,o)}static fromPositions(d,o=d){return new a(d.lineNumber,d.column,o.lineNumber,o.column)}static fromRange(d,o){return o===0?new a(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new a(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new a(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,o){if(d&&!o||!d&&o)return!1;if(!d&&!o)return!0;if(d.length!==o.length)return!1;for(let c=0,N=d.length;c<N;c++)if(!this.selectionsEqual(d[c],o[c]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,o,c,N,y){return y===0?new a(d,o,c,N):new a(c,N,d,o)}}n.Selection=a}),J(ee[31],te([0,1,16]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class F extends P.CharacterClassifier{constructor(d){super(0);for(let o=0,c=d.length;o<c;o++)this.set(d.charCodeAt(o),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=F;function a(A){const d={};return o=>(d.hasOwnProperty(o)||(d[o]=A(o)),d[o])}n.getMapForWordSeparators=a(A=>new F(A))}),J(ee[17],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(d=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const c of n.USUAL_WORD_SEPARATORS)d.indexOf(c)>=0||(o+="\\"+c);return o+="\\s]+)",new RegExp(o,"g")}n.DEFAULT_WORD_REGEXP=P();function t(d){let o=n.DEFAULT_WORD_REGEXP;if(d&&d instanceof RegExp)if(d.global)o=d;else{let c="g";d.ignoreCase&&(c+="i"),d.multiline&&(c+="m"),d.unicode&&(c+="u"),o=new RegExp(d.source,c)}return o.lastIndex=0,o}n.ensureValidWordDefinition=t;const F={maxLen:1e3,windowSize:15,timeBudget:150};function a(d,o,c,N,y=F){if(c.length>y.maxLen){let C=d-y.maxLen/2;return C<0?C=0:N+=C,c=c.substring(C,d+y.maxLen/2),a(d,o,c,N,y)}const w=Date.now(),_=d-1-N;let e=-1,L=null;for(let C=1;!(Date.now()-w>=y.timeBudget);C++){const v=_-y.windowSize*C;o.lastIndex=Math.max(0,v);const h=A(o,c,_,e);if(!h&&L||(L=h,v<=0))break;e=v}if(L){const C={word:L[0],startColumn:N+1+L.index,endColumn:N+1+L.index+L[0].length};return o.lastIndex=0,C}return null}n.getWordAtText=a;function A(d,o,c,N){let y;for(;y=d.exec(o);){const w=y.index||0;if(w<=c&&d.lastIndex>=c)return y;if(N>0&&w>N)return null}return null}}),J(ee[32],te([0,1,14,2]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const F=3;function a(L,C,v,h){return new P.LcsDiff(L,C,v).ComputeDiff(h)}class A{constructor(C){const v=[],h=[];for(let i=0,s=C.length;i<s;i++)v[i]=w(C[i],1),h[i]=_(C[i],1);this.lines=C,this._startColumns=v,this._endColumns=h}getElements(){const C=[];for(let v=0,h=this.lines.length;v<h;v++)C[v]=this.lines[v].substring(this._startColumns[v]-1,this._endColumns[v]-1);return C}getStrictElement(C){return this.lines[C]}getStartLineNumber(C){return C+1}getEndLineNumber(C){return C+1}createCharSequence(C,v,h){const i=[],s=[],f=[];let b=0;for(let p=v;p<=h;p++){const m=this.lines[p],l=C?this._startColumns[p]:1,g=C?this._endColumns[p]:m.length+1;for(let u=l;u<g;u++)i[b]=m.charCodeAt(u-1),s[b]=p+1,f[b]=u,b++}return new d(i,s,f)}}class d{constructor(C,v,h){this._charCodes=C,this._lineNumbers=v,this._columns=h}getElements(){return this._charCodes}getStartLineNumber(C){return this._lineNumbers[C]}getStartColumn(C){return this._columns[C]}getEndLineNumber(C){return this._lineNumbers[C]}getEndColumn(C){return this._columns[C]+1}}class o{constructor(C,v,h,i,s,f,b,p){this.originalStartLineNumber=C,this.originalStartColumn=v,this.originalEndLineNumber=h,this.originalEndColumn=i,this.modifiedStartLineNumber=s,this.modifiedStartColumn=f,this.modifiedEndLineNumber=b,this.modifiedEndColumn=p}static createFromDiffChange(C,v,h){let i,s,f,b,p,m,l,g;return C.originalLength===0?(i=0,s=0,f=0,b=0):(i=v.getStartLineNumber(C.originalStart),s=v.getStartColumn(C.originalStart),f=v.getEndLineNumber(C.originalStart+C.originalLength-1),b=v.getEndColumn(C.originalStart+C.originalLength-1)),C.modifiedLength===0?(p=0,m=0,l=0,g=0):(p=h.getStartLineNumber(C.modifiedStart),m=h.getStartColumn(C.modifiedStart),l=h.getEndLineNumber(C.modifiedStart+C.modifiedLength-1),g=h.getEndColumn(C.modifiedStart+C.modifiedLength-1)),new o(i,s,f,b,p,m,l,g)}}function c(L){if(L.length<=1)return L;const C=[L[0]];let v=C[0];for(let h=1,i=L.length;h<i;h++){const s=L[h],f=s.originalStart-(v.originalStart+v.originalLength),b=s.modifiedStart-(v.modifiedStart+v.modifiedLength);Math.min(f,b)<F?(v.originalLength=s.originalStart+s.originalLength-v.originalStart,v.modifiedLength=s.modifiedStart+s.modifiedLength-v.modifiedStart):(C.push(s),v=s)}return C}class N{constructor(C,v,h,i,s){this.originalStartLineNumber=C,this.originalEndLineNumber=v,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=i,this.charChanges=s}static createFromDiffResult(C,v,h,i,s,f,b){let p,m,l,g,u;if(v.originalLength===0?(p=h.getStartLineNumber(v.originalStart)-1,m=0):(p=h.getStartLineNumber(v.originalStart),m=h.getEndLineNumber(v.originalStart+v.originalLength-1)),v.modifiedLength===0?(l=i.getStartLineNumber(v.modifiedStart)-1,g=0):(l=i.getStartLineNumber(v.modifiedStart),g=i.getEndLineNumber(v.modifiedStart+v.modifiedLength-1)),f&&v.originalLength>0&&v.originalLength<20&&v.modifiedLength>0&&v.modifiedLength<20&&s()){const M=h.createCharSequence(C,v.originalStart,v.originalStart+v.originalLength-1),S=i.createCharSequence(C,v.modifiedStart,v.modifiedStart+v.modifiedLength-1);let R=a(M,S,s,!0).changes;b&&(R=c(R)),u=[];for(let q=0,H=R.length;q<H;q++)u.push(o.createFromDiffChange(R[q],M,S))}return new N(p,m,l,g,u)}}class y{constructor(C,v,h){this.shouldComputeCharChanges=h.shouldComputeCharChanges,this.shouldPostProcessCharChanges=h.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=h.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=h.shouldMakePrettyDiff,this.originalLines=C,this.modifiedLines=v,this.original=new A(C),this.modified=new A(v),this.continueLineDiff=e(h.maxComputationTime),this.continueCharDiff=e(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const C=a(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),v=C.changes,h=C.quitEarly;if(this.shouldIgnoreTrimWhitespace){const b=[];for(let p=0,m=v.length;p<m;p++)b.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,v[p],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:h,changes:b}}const i=[];let s=0,f=0;for(let b=-1,p=v.length;b<p;b++){const m=b+1<p?v[b+1]:null,l=m?m.originalStart:this.originalLines.length,g=m?m.modifiedStart:this.modifiedLines.length;for(;s<l&&f<g;){const u=this.originalLines[s],M=this.modifiedLines[f];if(u!==M){{let S=w(u,1),R=w(M,1);for(;S>1&&R>1;){const q=u.charCodeAt(S-2),H=M.charCodeAt(R-2);if(q!==H)break;S--,R--}(S>1||R>1)&&this._pushTrimWhitespaceCharChange(i,s+1,1,S,f+1,1,R)}{let S=_(u,1),R=_(M,1);const q=u.length+1,H=M.length+1;for(;S<q&&R<H;){const j=u.charCodeAt(S-1),E=u.charCodeAt(R-1);if(j!==E)break;S++,R++}(S<q||R<H)&&this._pushTrimWhitespaceCharChange(i,s+1,S,q,f+1,R,H)}}s++,f++}m&&(i.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,m,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),s+=m.originalLength,f+=m.modifiedLength)}return{quitEarly:h,changes:i}}_pushTrimWhitespaceCharChange(C,v,h,i,s,f,b){if(this._mergeTrimWhitespaceCharChange(C,v,h,i,s,f,b))return;let p;this.shouldComputeCharChanges&&(p=[new o(v,h,v,i,s,f,s,b)]),C.push(new N(v,v,s,s,p))}_mergeTrimWhitespaceCharChange(C,v,h,i,s,f,b){const p=C.length;if(p===0)return!1;const m=C[p-1];return m.originalEndLineNumber===0||m.modifiedEndLineNumber===0?!1:m.originalEndLineNumber+1===v&&m.modifiedEndLineNumber+1===s?(m.originalEndLineNumber=v,m.modifiedEndLineNumber=s,this.shouldComputeCharChanges&&m.charChanges&&m.charChanges.push(new o(v,h,v,i,s,f,s,b)),!0):!1}}n.DiffComputer=y;function w(L,C){const v=t.firstNonWhitespaceIndex(L);return v===-1?C:v+1}function _(L,C){const v=t.lastNonWhitespaceIndex(L);return v===-1?C:v+2}function e(L){if(L===0)return()=>!0;const C=Date.now();return()=>Date.now()-C<L}}),J(ee[33],te([0,1,16]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class F{constructor(e,L,C){const v=new Uint8Array(e*L);for(let h=0,i=e*L;h<i;h++)v[h]=C;this._data=v,this.rows=e,this.cols=L}get(e,L){return this._data[e*this.cols+L]}set(e,L,C){this._data[e*this.cols+L]=C}}n.Uint8Matrix=F;class a{constructor(e){let L=0,C=0;for(let h=0,i=e.length;h<i;h++){const[s,f,b]=e[h];f>L&&(L=f),s>C&&(C=s),b>C&&(C=b)}L++,C++;const v=new F(C,L,0);for(let h=0,i=e.length;h<i;h++){const[s,f,b]=e[h];v.set(s,f,b)}this._states=v,this._maxCharCode=L}nextState(e,L){return L<0||L>=this._maxCharCode?0:this._states.get(e,L)}}n.StateMachine=a;let A=null;function d(){return A===null&&(A=new a([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var o;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let c=null;function N(){if(c===null){c=new P.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<_.length;L++)c.set(_.charCodeAt(L),1);const e=".,;";for(let L=0;L<e.length;L++)c.set(e.charCodeAt(L),2)}return c}class y{static _createLink(e,L,C,v,h){let i=h-1;do{const s=L.charCodeAt(i);if(e.get(s)!==2)break;i--}while(i>v);if(v>0){const s=L.charCodeAt(v-1),f=L.charCodeAt(i);(s===40&&f===41||s===91&&f===93||s===123&&f===125)&&i--}return{range:{startLineNumber:C,startColumn:v+1,endLineNumber:C,endColumn:i+2},url:L.substring(v,i+1)}}static computeLinks(e,L=d()){const C=N(),v=[];for(let h=1,i=e.getLineCount();h<=i;h++){const s=e.getLineContent(h),f=s.length;let b=0,p=0,m=0,l=1,g=!1,u=!1,M=!1,S=!1;for(;b<f;){let R=!1;const q=s.charCodeAt(b);if(l===13){let H;switch(q){case 40:g=!0,H=0;break;case 41:H=g?0:1;break;case 91:M=!0,u=!0,H=0;break;case 93:M=!1,H=u?0:1;break;case 123:S=!0,H=0;break;case 125:H=S?0:1;break;case 39:H=m===34||m===96?0:1;break;case 34:H=m===39||m===96?0:1;break;case 96:H=m===39||m===34?0:1;break;case 42:H=m===42?1:0;break;case 124:H=m===124?1:0;break;case 32:H=M?0:1;break;default:H=C.get(q)}H===1&&(v.push(y._createLink(C,s,h,p,b)),R=!0)}else if(l===12){let H;q===91?(u=!0,H=0):H=C.get(q),H===1?R=!0:l=13}else l=L.nextState(l,q),l===0&&(R=!0);R&&(l=1,g=!1,u=!1,S=!1,p=b+1,m=q),b++}l===13&&v.push(y._createLink(C,s,h,p,f))}return v}}n.LinkComputer=y;function w(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:y.computeLinks(_)}n.computeLinks=w}),J(ee[34],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(F,a,A,d,o){if(F&&a){const c=this.doNavigateValueSet(a,o);if(c)return{range:F,value:c}}if(A&&d){const c=this.doNavigateValueSet(d,o);if(c)return{range:A,value:c}}return null}doNavigateValueSet(F,a){const A=this.numberReplace(F,a);return A!==null?A:this.textReplace(F,a)}numberReplace(F,a){const A=Math.pow(10,F.length-(F.lastIndexOf(".")+1));let d=Number(F),o=parseFloat(F);return!isNaN(d)&&!isNaN(o)&&d===o?d===0&&!a?null:(d=Math.floor(d*A),d+=a?A:-A,String(d/A)):null}textReplace(F,a){return this.valueSetsReplace(this._defaultValueSet,F,a)}valueSetsReplace(F,a,A){let d=null;for(let o=0,c=F.length;d===null&&o<c;o++)d=this.valueSetReplace(F[o],a,A);return d}valueSetReplace(F,a,A){let d=F.indexOf(a);return d>=0?(d+=A?1:-1,d<0?d=F.length-1:d%=F.length,F[d]):null}}n.BasicInplaceReplace=P,P.INSTANCE=new P}),J(ee[35],te([0,1,29]),function(B,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var F;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(F=n.MinimapPosition||(n.MinimapPosition={}));var a;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(a=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var A;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=n.EndOfLinePreference||(n.EndOfLinePreference={}));var d;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(d=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var o;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(o=n.EndOfLineSequence||(n.EndOfLineSequence={}));class c{constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),this.indentSize=i.tabSize|0,this.insertSpaces=Boolean(i.insertSpaces),this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=Boolean(i.trimAutoWhitespace),this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}n.TextModelResolvedOptions=c;class N{constructor(i,s){this._findMatchBrand=void 0,this.range=i,this.matches=s}}n.FindMatch=N;var y;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var w;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None"})(w=n.PositionAffinity||(n.PositionAffinity={}));var _;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(_=n.ModelConstants||(n.ModelConstants={}));class e{constructor(i,s,f,b,p,m){this.identifier=i,this.range=s,this.text=f,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=p,this._isTracked=m}}n.ValidAnnotatedEditOperation=e;class L{constructor(i,s,f){this.regex=i,this.wordSeparators=s,this.simpleSearch=f}}n.SearchData=L;class C{constructor(i,s,f){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}n.ApplyEditsResult=C;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}n.shouldSynchronizeModel=v}),J(ee[36],te([0,1,20,15]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class F{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(o,c){o=(0,t.toUint32)(o);const N=this.values,y=this.prefixSum,w=c.length;return w===0?!1:(this.values=new Uint32Array(N.length+w),this.values.set(N.subarray(0,o),0),this.values.set(N.subarray(o),o+w),this.values.set(c,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,c){return o=(0,t.toUint32)(o),c=(0,t.toUint32)(c),this.values[o]===c?!1:(this.values[o]=c,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,c){o=(0,t.toUint32)(o),c=(0,t.toUint32)(c);const N=this.values,y=this.prefixSum;if(o>=N.length)return!1;const w=N.length-o;return c>=w&&(c=w),c===0?!1:(this.values=new Uint32Array(N.length-c),this.values.set(N.subarray(0,o),0),this.values.set(N.subarray(o+c),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,t.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let c=this.prefixSumValidIndex[0]+1;c===0&&(this.prefixSum[0]=this.values[0],c++),o>=this.values.length&&(o=this.values.length-1);for(let N=c;N<=o;N++)this.prefixSum[N]=this.prefixSum[N-1]+this.values[N];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let c=0,N=this.values.length-1,y=0,w=0,_=0;for(;c<=N;)if(y=c+(N-c)/2|0,w=this.prefixSum[y],_=w-this.values[y],o<_)N=y-1;else if(o>=w)c=y+1;else break;return new A(y,o-_)}}n.PrefixSumComputer=F;class a{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const c=this._indexBySum[o],N=c>0?this._prefixSum[c-1]:0;return new A(c,o-N)}removeValues(o,c){this._values.splice(o,c),this._invalidate(o)}insertValues(o,c){this._values=(0,P.arrayInsert)(this._values,o,c),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,c=this._values.length;o<c;o++){const N=this._values[o],y=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=y+N;for(let w=0;w<N;w++)this._indexBySum[y+w]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,c){this._values[o]!==c&&(this._values[o]=c,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=a;class A{constructor(o,c){this.index=o,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=c}}n.PrefixSumIndexOfResult=A}),J(ee[37],te([0,1,2,3,36]),function(B,n,P,t,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class a{constructor(d,o,c,N){this._uri=d,this._lines=o,this._eol=c,this._versionId=N,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const o=d.changes;for(const c of o)this._acceptDeleteRange(c.range),this._acceptInsertText(new t.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,o=this._lines.length,c=new Uint32Array(o);for(let N=0;N<o;N++)c[N]=this._lines[N].length+d;this._lineStarts=new F.PrefixSumComputer(c)}}_setLineText(d,o){this._lines[d]=o,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,o){if(o.length===0)return;const c=(0,P.splitLines)(o);if(c.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+c[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}c[c.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+c[0]);const N=new Uint32Array(c.length-1);for(let y=1;y<c.length;y++)this._lines.splice(d.lineNumber+y-1,0,c[y]),N[y-1]=c[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,N)}}n.MirrorTextModel=a}),J(ee[38],te([0,1,2,31,3,4,35]),function(B,n,P,t,F,a,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const d=999;class o{constructor(h,i,s,f){this.searchString=h,this.isRegex=i,this.matchCase=s,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=c(this.searchString):h=this.searchString.indexOf(`
`)>=0;let i=null;try{i=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!h;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new A.SearchData(i,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=o;function c(v){if(!v||v.length===0)return!1;for(let h=0,i=v.length;h<i;h++)if(v.charCodeAt(h)===92){if(h++,h>=i)break;const f=v.charCodeAt(h);if(f===110||f===114||f===87)return!0}return!1}n.isMultilineRegexSource=c;function N(v,h,i){if(!i)return new A.FindMatch(v,null);const s=[];for(let f=0,b=h.length;f<b;f++)s[f]=h[f];return new A.FindMatch(v,s)}n.createFindMatch=N;class y{constructor(h){const i=[];let s=0;for(let f=0,b=h.length;f<b;f++)h.charCodeAt(f)===10&&(i[s++]=f);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(h){const i=this._lineFeedsOffsets;let s=0,f=i.length-1;if(f===-1||h<=i[0])return 0;for(;s<f;){const b=s+((f-s)/2>>0);i[b]>=h?f=b-1:i[b+1]>=h?(s=b,f=b):s=b+1}return s+1}}class w{static findMatches(h,i,s,f,b){const p=i.parseSearchRequest();return p?p.regex.multiline?this._doFindMatchesMultiline(h,s,new C(p.wordSeparators,p.regex),f,b):this._doFindMatchesLineByLine(h,s,p,f,b):[]}static _getMultilineMatchRange(h,i,s,f,b,p){let m,l=0;f?(l=f.findLineFeedCountBeforeOffset(b),m=i+b+l):m=i+b;let g;if(f){const R=f.findLineFeedCountBeforeOffset(b+p.length)-l;g=m+p.length+R}else g=m+p.length;const u=h.getPositionAt(m),M=h.getPositionAt(g);return new a.Range(u.lineNumber,u.column,M.lineNumber,M.column)}static _doFindMatchesMultiline(h,i,s,f,b){const p=h.getOffsetAt(i.getStartPosition()),m=h.getValueInRange(i,1),l=h.getEOL()===`\r
`?new y(m):null,g=[];let u=0,M;for(s.reset(0);M=s.next(m);)if(g[u++]=N(this._getMultilineMatchRange(h,p,m,l,M.index,M[0]),M,f),u>=b)return g;return g}static _doFindMatchesLineByLine(h,i,s,f,b){const p=[];let m=0;if(i.startLineNumber===i.endLineNumber){const g=h.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return m=this._findMatchesInLine(s,g,i.startLineNumber,i.startColumn-1,m,p,f,b),p}const l=h.getLineContent(i.startLineNumber).substring(i.startColumn-1);m=this._findMatchesInLine(s,l,i.startLineNumber,i.startColumn-1,m,p,f,b);for(let g=i.startLineNumber+1;g<i.endLineNumber&&m<b;g++)m=this._findMatchesInLine(s,h.getLineContent(g),g,0,m,p,f,b);if(m<b){const g=h.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);m=this._findMatchesInLine(s,g,i.endLineNumber,0,m,p,f,b)}return p}static _findMatchesInLine(h,i,s,f,b,p,m,l){const g=h.wordSeparators;if(!m&&h.simpleSearch){const S=h.simpleSearch,R=S.length,q=i.length;let H=-R;for(;(H=i.indexOf(S,H+R))!==-1;)if((!g||L(g,i,q,H,R))&&(p[b++]=new A.FindMatch(new a.Range(s,H+1+f,s,H+1+R+f),null),b>=l))return b;return b}const u=new C(h.wordSeparators,h.regex);let M;u.reset(0);do if(M=u.next(i),M&&(p[b++]=N(new a.Range(s,M.index+1+f,s,M.index+1+M[0].length+f),M,m),b>=l))return b;while(M);return b}static findNextMatch(h,i,s,f){const b=i.parseSearchRequest();if(!b)return null;const p=new C(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(h,s,p,f):this._doFindNextMatchLineByLine(h,s,p,f)}static _doFindNextMatchMultiline(h,i,s,f){const b=new F.Position(i.lineNumber,1),p=h.getOffsetAt(b),m=h.getLineCount(),l=h.getValueInRange(new a.Range(b.lineNumber,b.column,m,h.getLineMaxColumn(m)),1),g=h.getEOL()===`\r
`?new y(l):null;s.reset(i.column-1);let u=s.next(l);return u?N(this._getMultilineMatchRange(h,p,l,g,u.index,u[0]),u,f):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(h,new F.Position(1,1),s,f):null}static _doFindNextMatchLineByLine(h,i,s,f){const b=h.getLineCount(),p=i.lineNumber,m=h.getLineContent(p),l=this._findFirstMatchInLine(s,m,p,i.column,f);if(l)return l;for(let g=1;g<=b;g++){const u=(p+g-1)%b,M=h.getLineContent(u+1),S=this._findFirstMatchInLine(s,M,u+1,1,f);if(S)return S}return null}static _findFirstMatchInLine(h,i,s,f,b){h.reset(f-1);const p=h.next(i);return p?N(new a.Range(s,p.index+1,s,p.index+1+p[0].length),p,b):null}static findPreviousMatch(h,i,s,f){const b=i.parseSearchRequest();if(!b)return null;const p=new C(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(h,s,p,f):this._doFindPreviousMatchLineByLine(h,s,p,f)}static _doFindPreviousMatchMultiline(h,i,s,f){const b=this._doFindMatchesMultiline(h,new a.Range(1,1,i.lineNumber,i.column),s,f,10*d);if(b.length>0)return b[b.length-1];const p=h.getLineCount();return i.lineNumber!==p||i.column!==h.getLineMaxColumn(p)?this._doFindPreviousMatchMultiline(h,new F.Position(p,h.getLineMaxColumn(p)),s,f):null}static _doFindPreviousMatchLineByLine(h,i,s,f){const b=h.getLineCount(),p=i.lineNumber,m=h.getLineContent(p).substring(0,i.column-1),l=this._findLastMatchInLine(s,m,p,f);if(l)return l;for(let g=1;g<=b;g++){const u=(b+p-g-1)%b,M=h.getLineContent(u+1),S=this._findLastMatchInLine(s,M,u+1,f);if(S)return S}return null}static _findLastMatchInLine(h,i,s,f){let b=null,p;for(h.reset(0);p=h.next(i);)b=N(new a.Range(s,p.index+1,s,p.index+1+p[0].length),p,f);return b}}n.TextModelSearch=w;function _(v,h,i,s,f){if(s===0)return!0;const b=h.charCodeAt(s-1);if(v.get(b)!==0||b===13||b===10)return!0;if(f>0){const p=h.charCodeAt(s);if(v.get(p)!==0)return!0}return!1}function e(v,h,i,s,f){if(s+f===i)return!0;const b=h.charCodeAt(s+f);if(v.get(b)!==0||b===13||b===10)return!0;if(f>0){const p=h.charCodeAt(s+f-1);if(v.get(p)!==0)return!0}return!1}function L(v,h,i,s,f){return _(v,h,i,s,f)&&e(v,h,i,s,f)}n.isValidMatch=L;class C{constructor(h,i){this._wordSeparators=h,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const i=h.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(h),!s))return null;const f=s.index,b=s[0].length;if(f===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){P.getNextCodePoint(h,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=f,this._prevMatchLength=b,!this._wordSeparators||L(this._wordSeparators,h,i,f,b))return s}while(s);return null}}n.Searcher=C}),J(ee[39],te([0,1,4,38,2,7,17]),function(B,n,P,t,F,a,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class d{static computeUnicodeHighlights(e,L,C){const v=C?C.startLineNumber:1,h=C?C.endLineNumber:e.getLineCount(),i=new N(L),s=i.getCandidateCodePoints();let f;s==="allNonBasicAscii"?f=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):f=new RegExp(`${o(Array.from(s))}`,"g");const b=new t.Searcher(null,f),p=[];let m=!1,l,g=0,u=0,M=0;e:for(let S=v,R=h;S<=R;S++){const q=e.getLineContent(S),H=q.length;b.reset(0);do if(l=b.next(q),l){let j=l.index,E=l.index+l[0].length;if(j>0){const Y=q.charCodeAt(j-1);F.isHighSurrogate(Y)&&j--}if(E+1<H){const Y=q.charCodeAt(E-1);F.isHighSurrogate(Y)&&E++}const O=q.substring(j,E),K=(0,A.getWordAtText)(j+1,A.DEFAULT_WORD_REGEXP,q,0),$=i.shouldHighlightNonBasicASCII(O,K?K.word:null);if($!==0){$===3?g++:$===2?u++:$===1?M++:(0,a.assertNever)($);const Y=1e3;if(p.length>=Y){m=!0;break e}p.push(new P.Range(S,j+1,S,E+1))}}while(l)}return{ranges:p,hasMore:m,ambiguousCharacterCount:g,invisibleCharacterCount:u,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,L){const C=new N(L);switch(C.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const h=e.codePointAt(0),i=C.ambiguousCharacters.getPrimaryConfusable(h),s=F.AmbiguousCharacters.getLocales().filter(f=>!F.AmbiguousCharacters.getInstance(new Set([...L.allowedLocales,f])).isAmbiguous(h));return{kind:0,confusableWith:String.fromCodePoint(i),notAmbiguousInLocales:s}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=d;function o(_,e){return`[${F.escapeRegExpCharacters(_.map(C=>String.fromCodePoint(C)).join(""))}]`}var c;(function(_){_[_.Ambiguous=0]="Ambiguous",_[_.Invisible=1]="Invisible",_[_.NonBasicAscii=2]="NonBasicAscii"})(c=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class N{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=F.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const L of F.InvisibleCharacters.codePoints)y(String.fromCodePoint(L))||e.add(L);if(this.options.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.allowedCodePoints)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const C=e.codePointAt(0);if(this.allowedCodePoints.has(C))return 0;if(this.options.nonBasicASCII)return 1;let v=!1;if(L)for(let h of L){const i=h.codePointAt(0);!F.isBasicASCII(h)&&!this.ambiguousCharacters.isAmbiguous(i)&&!F.InvisibleCharacters.isInvisibleCharacter(i)&&(v=!0)}return v?0:this.options.invisibleCharacters&&!y(e)&&F.InvisibleCharacters.isInvisibleCharacter(C)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(C)?3:0}}function y(_){return _===" "||_===`
`||_==="	"}var w;(function(_){_[_.None=0]="None",_[_.NonBasicASCII=1]="NonBasicASCII",_[_.Invisible=2]="Invisible",_[_.Ambiguous=3]="Ambiguous"})(w||(w={}))}),J(ee[40],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var P;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(P=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(t=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var F;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(F=n.CompletionItemKind||(n.CompletionItemKind={}));var a;(function(r){r[r.Deprecated=1]="Deprecated"})(a=n.CompletionItemTag||(n.CompletionItemTag={}));var A;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var d;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(d=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var o;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(o=n.CursorChangeReason||(n.CursorChangeReason={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var N;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(N=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var y;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(y=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var w;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.emptySelectionClipboard=32]="emptySelectionClipboard",r[r.extraEditorClassName=33]="extraEditorClassName",r[r.fastScrollSensitivity=34]="fastScrollSensitivity",r[r.find=35]="find",r[r.fixedOverflowWidgets=36]="fixedOverflowWidgets",r[r.folding=37]="folding",r[r.foldingStrategy=38]="foldingStrategy",r[r.foldingHighlight=39]="foldingHighlight",r[r.foldingImportsByDefault=40]="foldingImportsByDefault",r[r.foldingMaximumRegions=41]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=43]="fontFamily",r[r.fontInfo=44]="fontInfo",r[r.fontLigatures=45]="fontLigatures",r[r.fontSize=46]="fontSize",r[r.fontWeight=47]="fontWeight",r[r.formatOnPaste=48]="formatOnPaste",r[r.formatOnType=49]="formatOnType",r[r.glyphMargin=50]="glyphMargin",r[r.gotoLocation=51]="gotoLocation",r[r.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",r[r.hover=53]="hover",r[r.inDiffEditor=54]="inDiffEditor",r[r.inlineSuggest=55]="inlineSuggest",r[r.letterSpacing=56]="letterSpacing",r[r.lightbulb=57]="lightbulb",r[r.lineDecorationsWidth=58]="lineDecorationsWidth",r[r.lineHeight=59]="lineHeight",r[r.lineNumbers=60]="lineNumbers",r[r.lineNumbersMinChars=61]="lineNumbersMinChars",r[r.linkedEditing=62]="linkedEditing",r[r.links=63]="links",r[r.matchBrackets=64]="matchBrackets",r[r.minimap=65]="minimap",r[r.mouseStyle=66]="mouseStyle",r[r.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=68]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",r[r.multiCursorModifier=70]="multiCursorModifier",r[r.multiCursorPaste=71]="multiCursorPaste",r[r.occurrencesHighlight=72]="occurrencesHighlight",r[r.overviewRulerBorder=73]="overviewRulerBorder",r[r.overviewRulerLanes=74]="overviewRulerLanes",r[r.padding=75]="padding",r[r.parameterHints=76]="parameterHints",r[r.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",r[r.quickSuggestions=79]="quickSuggestions",r[r.quickSuggestionsDelay=80]="quickSuggestionsDelay",r[r.readOnly=81]="readOnly",r[r.renameOnType=82]="renameOnType",r[r.renderControlCharacters=83]="renderControlCharacters",r[r.renderFinalNewline=84]="renderFinalNewline",r[r.renderLineHighlight=85]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=87]="renderValidationDecorations",r[r.renderWhitespace=88]="renderWhitespace",r[r.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",r[r.roundedSelection=90]="roundedSelection",r[r.rulers=91]="rulers",r[r.scrollbar=92]="scrollbar",r[r.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=94]="scrollBeyondLastLine",r[r.scrollPredominantAxis=95]="scrollPredominantAxis",r[r.selectionClipboard=96]="selectionClipboard",r[r.selectionHighlight=97]="selectionHighlight",r[r.selectOnLineNumbers=98]="selectOnLineNumbers",r[r.showFoldingControls=99]="showFoldingControls",r[r.showUnused=100]="showUnused",r[r.snippetSuggestions=101]="snippetSuggestions",r[r.smartSelect=102]="smartSelect",r[r.smoothScrolling=103]="smoothScrolling",r[r.stickyTabStops=104]="stickyTabStops",r[r.stopRenderingLineAfter=105]="stopRenderingLineAfter",r[r.suggest=106]="suggest",r[r.suggestFontSize=107]="suggestFontSize",r[r.suggestLineHeight=108]="suggestLineHeight",r[r.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",r[r.suggestSelection=110]="suggestSelection",r[r.tabCompletion=111]="tabCompletion",r[r.tabIndex=112]="tabIndex",r[r.unicodeHighlighting=113]="unicodeHighlighting",r[r.unusualLineTerminators=114]="unusualLineTerminators",r[r.useShadowDOM=115]="useShadowDOM",r[r.useTabStops=116]="useTabStops",r[r.wordSeparators=117]="wordSeparators",r[r.wordWrap=118]="wordWrap",r[r.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=121]="wordWrapColumn",r[r.wordWrapOverride1=122]="wordWrapOverride1",r[r.wordWrapOverride2=123]="wordWrapOverride2",r[r.wrappingIndent=124]="wrappingIndent",r[r.wrappingStrategy=125]="wrappingStrategy",r[r.showDeprecated=126]="showDeprecated",r[r.inlayHints=127]="inlayHints",r[r.editorClassName=128]="editorClassName",r[r.pixelRatio=129]="pixelRatio",r[r.tabFocusMode=130]="tabFocusMode",r[r.layoutInfo=131]="layoutInfo",r[r.wrappingInfo=132]="wrappingInfo"})(w=n.EditorOption||(n.EditorOption={}));var _;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(_=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var L;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(L=n.IndentAction||(n.IndentAction={}));var C;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(C=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var v;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(v=n.InlayHintKind||(n.InlayHintKind={}));var h;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(h=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var i;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(i=n.KeyCode||(n.KeyCode={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s=n.MarkerSeverity||(n.MarkerSeverity={}));var f;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(f=n.MarkerTag||(n.MarkerTag={}));var b;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(b=n.MinimapPosition||(n.MinimapPosition={}));var p;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(p=n.MouseTargetType||(n.MouseTargetType={}));var m;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(m=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var l;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(l=n.OverviewRulerLane||(n.OverviewRulerLane={}));var g;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None"})(g=n.PositionAffinity||(n.PositionAffinity={}));var u;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(u=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var M;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(M=n.RenderMinimap||(n.RenderMinimap={}));var S;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(S=n.ScrollType||(n.ScrollType={}));var R;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(R=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var q;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(q=n.SelectionDirection||(n.SelectionDirection={}));var H;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(H=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var j;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(j=n.SymbolKind||(n.SymbolKind={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E=n.SymbolTag||(n.SymbolTag={}));var O;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(O=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var K;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(K=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var $;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var Y;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(Y=n.WrappingIndent||(n.WrappingIndent={}))}),J(ee[41],te([0,1,6,9]),function(B,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class F{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(d){this._onDidChange.fire({changedLanguages:d,changedColorMap:!1})}register(d,o){return this._map.set(d,o),this.fire([d]),(0,t.toDisposable)(()=>{this._map.get(d)===o&&(this._map.delete(d),this.fire([d]))})}registerFactory(d,o){this._factories.get(d)?.dispose();const c=new a(this,d,o);return this._factories.set(d,c),(0,t.toDisposable)(()=>{const N=this._factories.get(d);!N||N!==c||(this._factories.delete(d),N.dispose())})}async getOrCreate(d){const o=this.get(d);if(o)return o;const c=this._factories.get(d);return!c||c.isResolved?null:(await c.resolve(),this.get(d))}get(d){return this._map.get(d)||null}isResolved(d){if(this.get(d))return!0;const c=this._factories.get(d);return!!(!c||c.isResolved)}setColorMap(d){this._colorMap=d,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=F;class a extends t.Disposable{constructor(d,o,c){super();this._registry=d,this._languageId=o,this._factory=c,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const d=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,d&&!this._isDisposed&&this._register(this._registry.register(this._languageId,d))}}}),J(ee[42],te([0,1,10,4,41,18]),function(B,n,P,t,F,a){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=n.TokenMetadata=n.MetadataConsts=n.StandardTokenType=n.ColorId=n.FontStyle=n.LanguageId=void 0;var A;(function(E){E[E.Null=0]="Null",E[E.PlainText=1]="PlainText"})(A=n.LanguageId||(n.LanguageId={}));var d;(function(E){E[E.NotSet=-1]="NotSet",E[E.None=0]="None",E[E.Italic=1]="Italic",E[E.Bold=2]="Bold",E[E.Underline=4]="Underline",E[E.Strikethrough=8]="Strikethrough"})(d=n.FontStyle||(n.FontStyle={}));var o;(function(E){E[E.None=0]="None",E[E.DefaultForeground=1]="DefaultForeground",E[E.DefaultBackground=2]="DefaultBackground"})(o=n.ColorId||(n.ColorId={}));var c;(function(E){E[E.Other=0]="Other",E[E.Comment=1]="Comment",E[E.String=2]="String",E[E.RegEx=3]="RegEx"})(c=n.StandardTokenType||(n.StandardTokenType={}));var N;(function(E){E[E.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",E[E.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",E[E.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",E[E.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",E[E.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",E[E.ITALIC_MASK=1024]="ITALIC_MASK",E[E.BOLD_MASK=2048]="BOLD_MASK",E[E.UNDERLINE_MASK=4096]="UNDERLINE_MASK",E[E.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",E[E.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",E[E.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",E[E.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",E[E.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",E[E.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",E[E.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",E[E.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",E[E.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",E[E.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",E[E.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",E[E.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(N=n.MetadataConsts||(n.MetadataConsts={}));class y{static getLanguageId(O){return(O&255)>>>0}static getTokenType(O){return(O&768)>>>8}static getFontStyle(O){return(O&15360)>>>10}static getForeground(O){return(O&8372224)>>>14}static getBackground(O){return(O&4286578688)>>>23}static getClassNameFromMetadata(O){const K=this.getForeground(O);let $="mtk"+K;const Y=this.getFontStyle(O);return Y&1&&($+=" mtki"),Y&2&&($+=" mtkb"),Y&4&&($+=" mtku"),Y&8&&($+=" mtks"),$}static getInlineStyleFromMetadata(O,K){const $=this.getForeground(O),Y=this.getFontStyle(O);let r=`color: ${K[$]};`;Y&1&&(r+="font-style: italic;"),Y&2&&(r+="font-weight: bold;");let se="";return Y&4&&(se+=" underline"),Y&8&&(se+=" line-through"),se&&(r+=`text-decoration:${se};`),r}static getPresentationFromMetadata(O){const K=this.getForeground(O),$=this.getFontStyle(O);return{foreground:K,italic:Boolean($&1),bold:Boolean($&2),underline:Boolean($&4),strikethrough:Boolean($&8)}}}n.TokenMetadata=y;class w{constructor(O,K,$){this._tokenBrand=void 0,this.offset=O,this.type=K,this.language=$}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=w;class _{constructor(O,K){this._tokenizationResultBrand=void 0,this.tokens=O,this.endState=K}}n.TokenizationResult=_;class e{constructor(O,K){this._encodedTokenizationResultBrand=void 0,this.tokens=O,this.endState=K}}n.EncodedTokenizationResult=e;var L;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(L=n.CompletionItemKind||(n.CompletionItemKind={}));var C;(function(E){const O=new Map;O.set(0,a.Codicon.symbolMethod),O.set(1,a.Codicon.symbolFunction),O.set(2,a.Codicon.symbolConstructor),O.set(3,a.Codicon.symbolField),O.set(4,a.Codicon.symbolVariable),O.set(5,a.Codicon.symbolClass),O.set(6,a.Codicon.symbolStruct),O.set(7,a.Codicon.symbolInterface),O.set(8,a.Codicon.symbolModule),O.set(9,a.Codicon.symbolProperty),O.set(10,a.Codicon.symbolEvent),O.set(11,a.Codicon.symbolOperator),O.set(12,a.Codicon.symbolUnit),O.set(13,a.Codicon.symbolValue),O.set(15,a.Codicon.symbolEnum),O.set(14,a.Codicon.symbolConstant),O.set(15,a.Codicon.symbolEnum),O.set(16,a.Codicon.symbolEnumMember),O.set(17,a.Codicon.symbolKeyword),O.set(27,a.Codicon.symbolSnippet),O.set(18,a.Codicon.symbolText),O.set(19,a.Codicon.symbolColor),O.set(20,a.Codicon.symbolFile),O.set(21,a.Codicon.symbolReference),O.set(22,a.Codicon.symbolCustomColor),O.set(23,a.Codicon.symbolFolder),O.set(24,a.Codicon.symbolTypeParameter),O.set(25,a.Codicon.account),O.set(26,a.Codicon.issues);function K(r){let se=O.get(r);return se||(console.info("No codicon found for CompletionItemKind "+r),se=a.Codicon.symbolProperty),se}E.toIcon=K;const $=new Map;$.set("method",0),$.set("function",1),$.set("constructor",2),$.set("field",3),$.set("variable",4),$.set("class",5),$.set("struct",6),$.set("interface",7),$.set("module",8),$.set("property",9),$.set("event",10),$.set("operator",11),$.set("unit",12),$.set("value",13),$.set("constant",14),$.set("enum",15),$.set("enum-member",16),$.set("enumMember",16),$.set("keyword",17),$.set("snippet",27),$.set("text",18),$.set("color",19),$.set("file",20),$.set("reference",21),$.set("customcolor",22),$.set("folder",23),$.set("type-parameter",24),$.set("typeParameter",24),$.set("account",25),$.set("issue",26);function Y(r,se){let ge=$.get(r);return typeof ge=="undefined"&&!se&&(ge=9),ge}E.fromString=Y})(C=n.CompletionItemKinds||(n.CompletionItemKinds={}));var v;(function(E){E[E.Deprecated=1]="Deprecated"})(v=n.CompletionItemTag||(n.CompletionItemTag={}));var h;(function(E){E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(h=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var i;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(i=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var s;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(s=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var f;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(f=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var b;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(b=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var p;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(p=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function m(E){return E&&P.URI.isUri(E.uri)&&t.Range.isIRange(E.range)&&(t.Range.isIRange(E.originSelectionRange)||t.Range.isIRange(E.targetSelectionRange))}n.isLocationLink=m;var l;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(l=n.SymbolKind||(n.SymbolKind={}));var g;(function(E){E[E.Deprecated=1]="Deprecated"})(g=n.SymbolTag||(n.SymbolTag={}));var u;(function(E){const O=new Map;O.set(0,a.Codicon.symbolFile),O.set(1,a.Codicon.symbolModule),O.set(2,a.Codicon.symbolNamespace),O.set(3,a.Codicon.symbolPackage),O.set(4,a.Codicon.symbolClass),O.set(5,a.Codicon.symbolMethod),O.set(6,a.Codicon.symbolProperty),O.set(7,a.Codicon.symbolField),O.set(8,a.Codicon.symbolConstructor),O.set(9,a.Codicon.symbolEnum),O.set(10,a.Codicon.symbolInterface),O.set(11,a.Codicon.symbolFunction),O.set(12,a.Codicon.symbolVariable),O.set(13,a.Codicon.symbolConstant),O.set(14,a.Codicon.symbolString),O.set(15,a.Codicon.symbolNumber),O.set(16,a.Codicon.symbolBoolean),O.set(17,a.Codicon.symbolArray),O.set(18,a.Codicon.symbolObject),O.set(19,a.Codicon.symbolKey),O.set(20,a.Codicon.symbolNull),O.set(21,a.Codicon.symbolEnumMember),O.set(22,a.Codicon.symbolStruct),O.set(23,a.Codicon.symbolEvent),O.set(24,a.Codicon.symbolOperator),O.set(25,a.Codicon.symbolTypeParameter);function K($){let Y=O.get($);return Y||(console.info("No codicon found for SymbolKind "+$),Y=a.Codicon.symbolProperty),Y}E.toIcon=K})(u=n.SymbolKinds||(n.SymbolKinds={}));class M{constructor(O){this.value=O}}n.FoldingRangeKind=M,M.Comment=new M("comment"),M.Imports=new M("imports"),M.Region=new M("region");var S;(function(E){function O(K){return!K||typeof K!="object"?!1:typeof K.id=="string"&&typeof K.title=="string"}E.is=O})(S=n.Command||(n.Command={}));var R;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(R=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var q;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(q=n.CommentMode||(n.CommentMode={}));var H;(function(E){E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(H=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new F.TokenizationRegistry;var j;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(j=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),J(ee[43],te([0,1,13,6,22,10,3,4,30,42,40]),function(B,n,P,t,F,a,A,d,o,c,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class y{static chord(e,L){return(0,F.KeyChord)(e,L)}}n.KeyMod=y,y.CtrlCmd=2048,y.Shift=1024,y.Alt=512,y.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:t.Emitter,KeyCode:N.KeyCode,KeyMod:y,Position:A.Position,Range:d.Range,Selection:o.Selection,SelectionDirection:N.SelectionDirection,MarkerSeverity:N.MarkerSeverity,MarkerTag:N.MarkerTag,Uri:a.URI,Token:c.Token}}n.createMonacoBaseAPI=w}),J(ee[45],te([0,1,14,5,10,3,4,32,37,17,33,34,43,7,12,39]),function(B,n,P,t,F,a,A,d,o,c,N,y,w,_,e,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class C extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(s){return this._lines[s-1]}getWordAtPosition(s,f){const b=(0,c.getWordAtText)(s.column,(0,c.ensureValidWordDefinition)(f),this._lines[s.lineNumber-1],0);return b?new A.Range(s.lineNumber,b.startColumn,s.lineNumber,b.endColumn):null}getWordUntilPosition(s,f){const b=this.getWordAtPosition(s,f);return b?{word:this._lines[s.lineNumber-1].substring(b.startColumn-1,s.column-1),startColumn:b.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const f=this._lines,b=this._wordenize.bind(this);let p=0,m="",l=0,g=[];return{*[Symbol.iterator](){for(;;)if(l<g.length){const u=m.substring(g[l].start,g[l].end);l+=1,yield u}else if(p<f.length)m=f[p],g=b(m,s),l=0,p+=1;else break}}}getLineWords(s,f){const b=this._lines[s-1],p=this._wordenize(b,f),m=[];for(const l of p)m.push({word:b.substring(l.start,l.end),startColumn:l.start+1,endColumn:l.end+1});return m}_wordenize(s,f){const b=[];let p;for(f.lastIndex=0;(p=f.exec(s))&&p[0].length!==0;)b.push({start:p.index,end:p.index+p[0].length});return b}getValueInRange(s){if(s=this._validateRange(s),s.startLineNumber===s.endLineNumber)return this._lines[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const f=this._eol,b=s.startLineNumber-1,p=s.endLineNumber-1,m=[];m.push(this._lines[b].substring(s.startColumn-1));for(let l=b+1;l<p;l++)m.push(this._lines[l]);return m.push(this._lines[p].substring(0,s.endColumn-1)),m.join(f)}offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(s),b=this._lines[f.index].length;return{lineNumber:1+f.index,column:1+Math.min(f.remainder,b)}}_validateRange(s){const f=this._validatePosition({lineNumber:s.startLineNumber,column:s.startColumn}),b=this._validatePosition({lineNumber:s.endLineNumber,column:s.endColumn});return f.lineNumber!==s.startLineNumber||f.column!==s.startColumn||b.lineNumber!==s.endLineNumber||b.column!==s.endColumn?{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:b.lineNumber,endColumn:b.column}:s}_validatePosition(s){if(!a.Position.isIPosition(s))throw new Error("bad position");let{lineNumber:f,column:b}=s,p=!1;if(f<1)f=1,b=1,p=!0;else if(f>this._lines.length)f=this._lines.length,b=this._lines[f-1].length+1,p=!0;else{const m=this._lines[f-1].length+1;b<1?(b=1,p=!0):b>m&&(b=m,p=!0)}return p?{lineNumber:f,column:b}:s}}n.MirrorModel=C;class v{constructor(s,f){this._host=s,this._models=Object.create(null),this._foreignModuleFactory=f,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(s){return this._models[s]}_getModels(){const s=[];return Object.keys(this._models).forEach(f=>s.push(this._models[f])),s}acceptNewModel(s){this._models[s.url]=new C(F.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,f){if(!this._models[s])return;this._models[s].onEvents(f)}acceptRemovedModel(s){!this._models[s]||delete this._models[s]}async computeUnicodeHighlights(s,f,b){const p=this._getModel(s);return p?L.UnicodeTextModelHighlighter.computeUnicodeHighlights(p,f,b):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(s,f,b,p){const m=this._getModel(s),l=this._getModel(f);if(!m||!l)return null;const g=m.getLinesContent(),u=l.getLinesContent(),S=new d.DiffComputer(g,u,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:b,shouldMakePrettyDiff:!0,maxComputationTime:p}).computeDiff(),R=S.changes.length>0?!1:this._modelsAreIdentical(m,l);return{quitEarly:S.quitEarly,identical:R,changes:S.changes}}_modelsAreIdentical(s,f){const b=s.getLineCount(),p=f.getLineCount();if(b!==p)return!1;for(let m=1;m<=b;m++){const l=s.getLineContent(m),g=f.getLineContent(m);if(l!==g)return!1}return!0}async computeDirtyDiff(s,f,b){const p=this._getModel(s),m=this._getModel(f);if(!p||!m)return null;const l=p.getLinesContent(),g=m.getLinesContent();return new d.DiffComputer(l,g,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:b,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(s,f){const b=this._getModel(s);if(!b)return f;const p=[];let m;f=f.slice(0).sort((l,g)=>{if(l.range&&g.range)return A.Range.compareRangesUsingStarts(l.range,g.range);const u=l.range?0:1,M=g.range?0:1;return u-M});for(let{range:l,text:g,eol:u}of f){if(typeof u=="number"&&(m=u),A.Range.isEmpty(l)&&!g)continue;const M=b.getValueInRange(l);if(g=g.replace(/\r\n|\n|\r/g,b.eol),M===g)continue;if(Math.max(g.length,M.length)>v._diffLimit){p.push({range:l,text:g});continue}const S=(0,P.stringDiff)(M,g,!1),R=b.offsetAt(A.Range.lift(l).getStartPosition());for(const q of S){const H=b.positionAt(R+q.originalStart),j=b.positionAt(R+q.originalStart+q.originalLength),E={text:g.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:j.lineNumber,endColumn:j.column}};b.getValueInRange(E.range)!==E.text&&p.push(E)}}return typeof m=="number"&&p.push({eol:m,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),p}async computeLinks(s){const f=this._getModel(s);return f?(0,N.computeLinks)(f):null}async textualSuggest(s,f,b,p){const m=new e.StopWatch(!0),l=new RegExp(b,p),g=new Set;e:for(let u of s){const M=this._getModel(u);if(!!M){for(let S of M.words(l))if(!(S===f||!isNaN(Number(S)))&&(g.add(S),g.size>v._suggestionsLimit))break e}}return{words:Array.from(g),duration:m.elapsed()}}async computeWordRanges(s,f,b,p){const m=this._getModel(s);if(!m)return Object.create(null);const l=new RegExp(b,p),g=Object.create(null);for(let u=f.startLineNumber;u<f.endLineNumber;u++){const M=m.getLineWords(u,l);for(const S of M){if(!isNaN(Number(S.word)))continue;let R=g[S.word];R||(R=[],g[S.word]=R),R.push({startLineNumber:u,startColumn:S.startColumn,endLineNumber:u,endColumn:S.endColumn})}}return g}async navigateValueSet(s,f,b,p,m){const l=this._getModel(s);if(!l)return null;const g=new RegExp(p,m);f.startColumn===f.endColumn&&(f={startLineNumber:f.startLineNumber,startColumn:f.startColumn,endLineNumber:f.endLineNumber,endColumn:f.endColumn+1});const u=l.getValueInRange(f),M=l.getWordAtPosition({lineNumber:f.startLineNumber,column:f.startColumn},g);if(!M)return null;const S=l.getValueInRange(M);return y.BasicInplaceReplace.INSTANCE.navigateValueSet(f,u,M,S,b)}loadForeignModule(s,f,b){const p=(g,u)=>this._host.fhr(g,u),l={host:_.createProxyObject(b,p),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(l,f),Promise.resolve(_.getAllMethodNames(this._foreignModule))):new Promise((g,u)=>{B([s],M=>{this._foreignModule=M.create(l,f),g(_.getAllMethodNames(this._foreignModule))},u)})}fmr(s,f){if(!this._foreignModule||typeof this._foreignModule[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._foreignModule[s].apply(this._foreignModule,f))}catch(b){return Promise.reject(b)}}}n.EditorSimpleWorker=v,v._diffLimit=1e5,v._suggestionsLimit=1e4;function h(i){return new v(i,null)}n.create=h,typeof importScripts=="function"&&(t.globals.monaco=(0,w.createMonacoBaseAPI)())}),function(){const B=self.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:o=>o,createScript:(o,...c)=>{const N=c.slice(0,-1).join(","),y=c.pop().toString();return`(function anonymous(${N}) {
${y}
})`}}):void 0;function t(){try{return(P?self.eval(P.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function F(){return new Promise((o,c)=>{if(typeof self.define=="function"&&self.define.amd)return o();const N=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(N)&&N.substring(0,self.origin.length)!==self.origin)&&t()){fetch(N).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${N}`,(P?self.eval(P.createScript("",w)):new Function(w)).call(self),o()}).then(void 0,c);return}P?importScripts(P.createScriptURL(N)):importScripts(N),o()})}const a=function(o){F().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//}),require([o],function(c){setTimeout(function(){let N=c.create((y,w)=>{self.postMessage(y,w)},null);for(self.onmessage=y=>N.onmessage(y.data,y.ports);d.length>0;)self.onmessage(d.shift())},0)})})};let A=!0,d=[];self.onmessage=o=>{if(!A){d.push(o);return}A=!1,a(o.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f90f60e956e725f98732c33dec3029087d0f19e4/core/vs/base/worker/workerMain.js.map
