/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/process","os","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/shellEnv","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(Y){for(var e=[],k=0,t=Y.length;k<t;k++)e[k]=te[Y[k]];return e};define(te[99],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,L){if(!t)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=k}),define(te[48],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(R,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(R,C,b){this.id=R,this.definition=C,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function L(A,R){const C=["codicon","codicon-"+A];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function C(E){if(E instanceof t)return["codicon","codicon-"+E.id];const f=R.exec(E.id);if(!f)return C(t.error);let[,p,h]=f;const m=["codicon","codicon-"+p];return h&&m.push("codicon-modifier-"+h.substr(1)),m}A.asClassNameArray=C;function b(E){return C(E).join(" ")}A.asClassName=b;function P(E){return"."+C(E).join(".")}A.asCSSSelector=P})(T=e.CSSIcon||(e.CSSIcon={}))}),define(te[68],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function t(P){const E=[];for(let f in P)k.call(P,f)&&E.push(P[f]);return E}e.values=t;function L(P,E){for(let f in P)if(k.call(P,f)&&E({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=L;function T(P,E){const f=Object.create(null);for(const p of P){const h=E(p);let m=f[h];m||(m=f[h]=[]),m.push(p)}return f}e.groupBy=T;function A(P){const E=Object.create(null);return P&&P.forEach((f,p)=>{E[p]=f}),E}e.fromMap=A;function R(P,E){const f=[],p=[];for(let h of P)E.has(h)||f.push(h);for(let h of E)P.has(h)||p.push(h);return{removed:f,added:p}}e.diffSets=R;function C(P,E){const f=[],p=[];for(let[h,m]of P)E.has(h)||f.push(m);for(let[h,m]of E)P.has(h)||p.push(m);return{removed:f,added:p}}e.diffMaps=C;class b{constructor(){this.map=new Map}add(E,f){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(f)}delete(E,f){const p=this.map.get(E);!p||(p.delete(f),p.size===0&&this.map.delete(E))}forEach(E,f){const p=this.map.get(E);!p||p.forEach(f)}}e.SetMap=b}),define(te[54],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(R,C,b)=>{let P=null,E=null;if(typeof b.value=="function"?(P="value",E=b.value):typeof b.get=="function"&&(P="get",E=b.get),!E)throw new Error("not supported");b[P]=A(E,C)}}e.createDecorator=k;function t(A,R,C){let b=null,P=null;if(typeof C.value=="function"?(b="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(b="get",P=C.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;C[b]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[E]}}e.memoize=t;function L(A,R,C){return k((b,P)=>{const E=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...p){this[f]||(this[f]=C?C():void 0),clearTimeout(this[E]),R&&(this[f]=R(this[f],...p),p=[this[f]]),this[E]=setTimeout(()=>{b.apply(this,p),this[f]=C?C():void 0},A)}})}e.debounce=L;function T(A,R,C){return k((b,P)=>{const E=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...m){if(this[f]||(this[f]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...m)),this[h])return;const v=this[p]+A;v<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[f]]),this[f]=C?C():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),b.apply(this,[this[f]]),this[f]=C?C():void 0},v-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(y){setTimeout(()=>{throw y.stack?new Error(y.message+`

`+y.stack):y},0)}}addListener(y){return this.listeners.push(y),()=>{this._removeListener(y)}}emit(y){this.listeners.forEach(d=>{d(y)})}_removeListener(y){this.listeners.splice(this.listeners.indexOf(y),1)}setUnexpectedErrorHandler(y){this.unexpectedErrorHandler=y}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(y){this.unexpectedErrorHandler(y),this.emit(y)}onUnexpectedExternalError(y){this.unexpectedErrorHandler(y)}}e.ErrorHandler=k,e.errorHandler=new k;function t(S){e.errorHandler.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=t;function L(S){C(S)||e.errorHandler.onUnexpectedError(S)}e.onUnexpectedError=L;function T(S){C(S)||e.errorHandler.onUnexpectedExternalError(S)}e.onUnexpectedExternalError=T;function A(S){if(S instanceof Error){let{name:y,message:d}=S;const i=S.stacktrace||S.stack;return{$isError:!0,name:y,message:d,stack:i}}return S}e.transformErrorForSerialization=A;const R="Canceled";function C(S){return S instanceof b?!0:S instanceof Error&&S.name===R&&S.message===R}e.isCancellationError=C;class b extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=b;function P(){const S=new Error(R);return S.name=S.message,S}e.canceled=P;function E(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.illegalArgument=E;function f(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.illegalState=f;function p(S){return S?new Error(`readonly property '${S} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(S){const y=new Error(`${S} has been disposed`);return y.name="DISPOSED",y}e.disposed=h;function m(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.getErrorMessage=m;class v extends Error{constructor(y){super("NotImplemented");y&&(this.message=y)}}e.NotImplementedError=v;class l extends Error{constructor(y){super("NotSupported");y&&(this.message=y)}}e.NotSupportedError=l;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w}),define(te[16],ne([0,1,9]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(W,F=0){return W[W.length-(1+F)]}e.tail=t;function L(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=L;function T(W,F,N=($,V)=>$===V){if(W===F)return!0;if(!W||!F||W.length!==F.length)return!1;for(let $=0,V=W.length;$<V;$++)if(!N(W[$],F[$]))return!1;return!0}e.equals=T;function A(W,F,N){let $=0,V=W.length-1;for(;$<=V;){const ee=($+V)/2|0,se=N(W[ee],F);if(se<0)$=ee+1;else if(se>0)V=ee-1;else return ee}return-($+1)}e.binarySearch=A;function R(W,F){let N=0,$=W.length;if($===0)return 0;for(;N<$;){const V=Math.floor((N+$)/2);F(W[V])?$=V:N=V+1}return N}e.findFirstInSorted=R;function C(W,F,N){if(W=W|0,W>=F.length)throw new TypeError("invalid index");let $=F[Math.floor(F.length*Math.random())],V=[],ee=[],se=[];for(let ae of F){const de=N(ae,$);de<0?V.push(ae):de>0?ee.push(ae):se.push(ae)}return W<V.length?C(W,V,N):W<V.length+se.length?se[0]:C(W-(V.length+se.length),ee,N)}e.quickSelect=C;function b(W,F){const N=[];let $;for(const V of W.slice(0).sort(F))!$||F($[0],V)!==0?($=[V],N.push($)):$.push(V);return N}e.groupBy=b;function P(W,F,N){const $=[];function V(ae,de,ge){if(de===0&&ge.length===0)return;const Ee=$[$.length-1];Ee&&Ee.start+Ee.deleteCount===ae?(Ee.deleteCount+=de,Ee.toInsert.push(...ge)):$.push({start:ae,deleteCount:de,toInsert:ge})}let ee=0,se=0;for(;;){if(ee===W.length){V(ee,0,F.slice(se));break}if(se===F.length){V(ee,W.length-ee,[]);break}const ae=W[ee],de=F[se],ge=N(ae,de);ge===0?(ee+=1,se+=1):ge<0?(V(ee,1,[]),ee+=1):ge>0&&(V(ee,0,[de]),se+=1)}return $}e.sortedDiff=P;function E(W,F,N){const $=P(W,F,N),V=[],ee=[];for(const se of $)V.push(...W.slice(se.start,se.start+se.deleteCount)),ee.push(...se.toInsert);return{removed:V,added:ee}}e.delta=E;function f(W,F,N){if(N===0)return[];const $=W.slice(0,N).sort(F);return h(W,F,$,N,W.length),$}e.top=f;function p(W,F,N,$,V){return N===0?Promise.resolve([]):new Promise((ee,se)=>{(async()=>{const ae=W.length,de=W.slice(0,N).sort(F);for(let ge=N,Ee=Math.min(N+$,ae);ge<ae;ge=Ee,Ee=Math.min(Ee+$,ae)){if(ge>N&&await new Promise(Se=>setTimeout(Se)),V&&V.isCancellationRequested)throw(0,k.canceled)();h(W,F,de,ge,Ee)}return de})().then(ee,se)})}e.topAsync=p;function h(W,F,N,$,V){for(const ee=N.length;$<V;$++){const se=W[$];if(F(se,N[ee-1])<0){N.pop();const ae=R(N,de=>F(se,de)<0);N.splice(ae,0,se)}}}function m(W){return W.filter(F=>!!F)}e.coalesce=m;function v(W){let F=0;for(let N=0;N<W.length;N++)W[N]&&(W[F]=W[N],F+=1);W.length=F}e.coalesceInPlace=v;function l(W,F,N){W.splice(N,0,W.splice(F,1)[0])}e.move=l;function w(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=w;function S(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=S;function y(W,F=N=>N){const N=new Set;return W.filter($=>{const V=F($);return N.has(V)?!1:(N.add(V),!0)})}e.distinct=y;function d(W){const F=new Set;return N=>{const $=W(N);return F.has($)?!1:(F.add($),!0)}}e.uniqueFilter=d;function i(W,F){const N=c(W,F);if(N!==-1)return W[N]}e.findLast=i;function c(W,F){for(let N=W.length-1;N>=0;N--){const $=W[N];if(F($))return N}return-1}e.lastIndex=c;function r(W,F){return W.length>0?W[0]:F}e.firstOrDefault=r;function n(W,F,N=($,V)=>$===V){let $=0;for(let V=0,ee=Math.min(W.length,F.length);V<ee&&N(W[V],F[V]);V++)$++;return $}e.commonPrefixLength=n;function o(W){return[].concat(...W)}e.flatten=o;function s(W,F){let N=typeof F=="number"?W:0;typeof F=="number"?N=W:(N=0,F=W);const $=[];if(N<=F)for(let V=N;V<F;V++)$.push(V);else for(let V=N;V>F;V--)$.push(V);return $}e.range=s;function a(W,F,N){return W.reduce(($,V)=>($[F(V)]=N?N(V):V,$),Object.create(null))}e.index=a;function u(W,F){return W.push(F),()=>g(W,F)}e.insert=u;function g(W,F){const N=W.indexOf(F);if(N>-1)return W.splice(N,1),F}e.remove=g;function I(W,F,N){const $=W.slice(0,F),V=W.slice(F);return $.concat(N,V)}e.arrayInsert=I;function _(W,F){let N;if(typeof F=="number"){let $=F;N=()=>{const V=Math.sin($++)*179426549;return V-Math.floor(V)}}else N=Math.random;for(let $=W.length-1;$>0;$-=1){const V=Math.floor(N()*($+1)),ee=W[$];W[$]=W[V],W[V]=ee}}e.shuffle=_;function O(W,F){const N=W.indexOf(F);N>-1&&(W.splice(N,1),W.unshift(F))}e.pushToStart=O;function M(W,F){const N=W.indexOf(F);N>-1&&(W.splice(N,1),W.push(F))}e.pushToEnd=M;function D(W,F){return Array.isArray(W)?W.map(F):F(W)}e.mapArrayOrNot=D;function U(W){return Array.isArray(W)?W:[W]}e.asArray=U;function z(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=z;function B(W,F){for(const N of W){const $=F(N);if($!==void 0)return $}}e.mapFind=B;function q(W,F,N){const $=re(W,F),V=W.length,ee=N.length;W.length=V+ee;for(let se=V-1;se>=$;se--)W[se+ee]=W[se];for(let se=0;se<ee;se++)W[se+$]=N[se]}e.insertInto=q;function G(W,F,N,$){const V=re(W,F),ee=W.splice(V,N);return q(W,V,$),ee}e.splice=G;function re(W,F){return F<0?Math.max(F+W.length,0):Math.min(F,W.length)}function H(W,F){return(N,$)=>F(W(N),W($))}e.compareBy=H;const j=(W,F)=>W-F;e.numberComparator=j;function Q(W,F){if(W.length===0)return;let N=W[0];for(let $=1;$<W.length;$++){const V=W[$];F(V,N)>0&&(N=V)}return N}e.findMaxBy=Q;function x(W,F){if(W.length===0)return;let N=W[0];for(let $=1;$<W.length;$++){const V=W[$];F(V,N)>=0&&(N=V)}return N}e.findLastMaxBy=x;function J(W,F){return Q(W,(N,$)=>-F(N,$))}e.findMinBy=J;class Z{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let N=this.firstIdx;for(;N<this.items.length&&F(this.items[N]);)N++;const $=N===this.firstIdx?null:this.items.slice(this.firstIdx,N);return this.firstIdx=N,$}takeFromEndWhile(F){let N=this.lastIdx;for(;N>=0&&F(this.items[N]);)N--;const $=N===this.lastIdx?null:this.items.slice(N+1,this.lastIdx+1);return this.lastIdx=N,$}peek(){return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const N=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,N}}e.ArrayQueue=Z}),define(te[69],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const L=this;let T=!1,A;return function(){return T||(T=!0,A=t.apply(L,arguments)),A}}e.once=k}),define(te[55],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function L(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=L;const T=Object.freeze([]);function A(){return T}t.empty=A;function*R(d){yield d}t.single=R;function C(d){return d||T}t.from=C;function b(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=b;function P(d){return d[Symbol.iterator]().next().value}t.first=P;function E(d,i){for(const c of d)if(i(c))return!0;return!1}t.some=E;function f(d,i){for(const c of d)if(i(c))return c}t.find=f;function*p(d,i){for(const c of d)i(c)&&(yield c)}t.filter=p;function*h(d,i){let c=0;for(const r of d)yield i(r,c++)}t.map=h;function*m(...d){for(const i of d)for(const c of i)yield c}t.concat=m;function*v(d){for(const i of d)for(const c of i)yield c}t.concatNested=v;function l(d,i,c){let r=c;for(const n of d)r=i(r,n);return r}t.reduce=l;function*w(d,i,c=d.length){for(i<0&&(i+=d.length),c<0?c+=d.length:c>d.length&&(c=d.length);i<c;i++)yield d[i]}t.slice=w;function S(d,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,d];const r=d[Symbol.iterator]();for(let n=0;n<i;n++){const o=r.next();if(o.done)return[c,t.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return r}}]}t.consume=S;function y(d,i,c=(r,n)=>r===n){const r=d[Symbol.iterator](),n=i[Symbol.iterator]();for(;;){const o=r.next(),s=n.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!c(o.value,s.value))return!1}}t.equals=y})(k=e.Iterable||(e.Iterable={}))}),define(te[35],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,c=!1){let r=0,n=i.length,o="",s=0,a=16,u=0;function g(z){let B=0,q=0;for(;B<z;){const G=i.charCodeAt(r);if(G>=48&&G<=57)q=q*16+G-48;else if(G>=65&&G<=70)q=q*16+G-65+10;else if(G>=97&&G<=102)q=q*16+G-97+10;else break;r++,B++}return B<z&&(q=-1),q}function I(z){r=z,o="",s=0,a=16,u=0}function _(){const z=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&b(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&b(i.charCodeAt(r)))for(r++;r<i.length&&b(i.charCodeAt(r));)r++;else return u=3,i.substring(z,r);let B=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&b(i.charCodeAt(r))){for(r++;r<i.length&&b(i.charCodeAt(r));)r++;B=r}else u=3;return i.substring(z,B)}function O(){let z="",B=r;for(;;){if(r>=n){z+=i.substring(B,r),u=2;break}const q=i.charCodeAt(r);if(q===34){z+=i.substring(B,r),r++;break}if(q===92){if(z+=i.substring(B,r),r++,r>=n){u=2;break}switch(i.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const re=g(4);re>=0?z+=String.fromCharCode(re):u=4;break}default:u=5}B=r;continue}if(q>=0&&q<=31)if(C(q)){z+=i.substring(B,r),u=2;break}else u=6;r++}return z}function M(){if(o="",u=0,s=r,r>=n)return s=n,a=17;let z=i.charCodeAt(r);if(R(z)){do r++,o+=String.fromCharCode(z),z=i.charCodeAt(r);while(R(z));return a=15}if(C(z))return r++,o+=String.fromCharCode(z),z===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),a=14;switch(z){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,o=O(),a=10;case 47:{const B=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!C(i.charCodeAt(r));)r++;return o=i.substring(B,r),a=12}if(i.charCodeAt(r+1)===42){r+=2;const q=n-1;let G=!1;for(;r<q;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,u=1),o=i.substring(B,r),a=13}return o+=String.fromCharCode(z),r++,a=16}case 45:if(o+=String.fromCharCode(z),r++,r===n||!b(i.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;r<n&&D(z);)r++,z=i.charCodeAt(r);if(s!==r){switch(o=i.substring(s,r),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(z),r++,a=16}}function D(z){if(R(z)||C(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=M();while(z>=12&&z<=15);return z}return{setPosition:I,getPosition:()=>r,scan:c?U:M,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>u}}e.createScanner=A;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function E(i,c){const r=[],n=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(g,I,_,O){s.value=g,s.offset=I,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{S(i,{onObjectBegin:(g,I)=>{if(c<=g)throw n;o=void 0,a=c>g,r.push("")},onObjectProperty:(g,I,_)=>{if(c<I||(u(g,I,_,"property"),r[r.length-1]=g,c<=I+_))throw n},onObjectEnd:(g,I)=>{if(c<=g)throw n;o=void 0,r.pop()},onArrayBegin:(g,I)=>{if(c<=g)throw n;o=void 0,r.push(0)},onArrayEnd:(g,I)=>{if(c<=g)throw n;o=void 0,r.pop()},onLiteralValue:(g,I,_)=>{if(c<I||(u(g,I,_,d(g)),c<=I+_))throw n},onSeparator:(g,I,_)=>{if(c<=I)throw n;if(g===":"&&o&&o.type==="property")o.colonOffset=I,a=!1,o=void 0;else if(g===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(a=!0,r[r.length-1]=""),o=void 0}}})}catch(g){if(g!==n)throw g}return{path:r,previousNode:o,isAtPropertyKey:a,matches:g=>{let I=0;for(let _=0;I<g.length&&_<r.length;_++)if(g[I]===r[_]||g[I]==="*")I++;else if(g[I]!=="**")return!1;return I===g.length}}}e.getLocation=E;function f(i,c=[],r=T.DEFAULT){let n=null,o=[];const s=[];function a(g){Array.isArray(o)?o.push(g):n!==null&&(o[n]=g)}return S(i,{onObjectBegin:()=>{const g={};a(g),s.push(o),o=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const g=[];a(g),s.push(o),o=g,n=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(g,I,_)=>{c.push({error:g,offset:I,length:_})}},r),o[0]}e.parse=f;function p(i,c=[],r=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function s(g){return n.children.push(g),g}S(i,{onObjectBegin:g=>{n=s({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,I,_)=>{n=s({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:I,length:_,parent:n})},onObjectEnd:(g,I)=>{n.length=g+I-n.offset,n=n.parent,o(g+I)},onArrayBegin:(g,I)=>{n=s({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,I)=>{n.length=g+I-n.offset,n=n.parent,o(g+I)},onLiteralValue:(g,I,_)=>{s({type:d(g),offset:I,length:_,parent:n,value:g}),o(I+_)},onSeparator:(g,I,_)=>{n.type==="property"&&(g===":"?n.colonOffset=I:g===","&&o(I))},onError:(g,I,_)=>{c.push({error:g,offset:I,length:_})}},r);const u=n.children[0];return u&&delete u.parent,u}e.parseTree=p;function h(i,c){if(!i)return;let r=i;for(let n of c)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===n){r=s.children[1],o=!0;break}if(!o)return}else{const o=n;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=h;function m(i){if(!i.parent||!i.parent.children)return[];const c=m(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;c.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&c.push(r)}return c}e.getNodePath=m;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const c=Object.create(null);for(let r of i.children){const n=r.children[1];n&&(c[r.children[0].value]=v(n))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function l(i,c,r=!1){return c>=i.offset&&c<i.offset+i.length||r&&c===i.offset+i.length}e.contains=l;function w(i,c,r=!1){if(l(i,c,r)){const n=i.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const s=w(n[o],c,r);if(s)return s}return i}}e.findNodeAtOffset=w;function S(i,c,r=T.DEFAULT){const n=A(i,!1);function o(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(Z){return Z?W=>Z(W,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(c.onObjectBegin),u=s(c.onObjectProperty),g=o(c.onObjectEnd),I=o(c.onArrayBegin),_=o(c.onArrayEnd),O=s(c.onLiteralValue),M=s(c.onSeparator),D=o(c.onComment),U=s(c.onError),z=r&&r.disallowComments,B=r&&r.allowTrailingComma;function q(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:z||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Z){case 12:case 13:z?G(10):D();break;case 16:G(1);break;case 15:case 14:break;default:return Z}}}function G(Z,W=[],F=[]){if(U(Z),W.length+F.length>0){let N=n.getToken();for(;N!==17;){if(W.indexOf(N)!==-1){q();break}else if(F.indexOf(N)!==-1)break;N=q()}}}function re(Z){const W=n.getTokenValue();return Z?O(W):u(W),q(),!0}function H(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(G(2),Z=0)}catch{G(2)}O(Z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return q(),!0}function j(){return n.getToken()!==10?(G(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(M(":"),q(),J()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function Q(){a(),q();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||G(4,[],[]),M(","),q(),n.getToken()===2&&B)break}else Z&&G(6,[],[]);j()||G(4,[],[2,5]),Z=!0}return g(),n.getToken()!==2?G(7,[2],[]):q(),!0}function x(){I(),q();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||G(4,[],[]),M(","),q(),n.getToken()===4&&B)break}else Z&&G(6,[],[]);J()||G(4,[],[4,5]),Z=!0}return _(),n.getToken()!==4?G(8,[4],[]):q(),!0}function J(){switch(n.getToken()){case 3:return x();case 1:return Q();case 10:return re(!0);default:return H()}}return q(),n.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):J()?(n.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=S;function y(i,c){let r=A(i),n=[],o,s=0,a;do switch(a=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:s!==a&&n.push(i.substring(s,a)),c!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,c)),s=r.getPosition();break}while(o!==17);return n.join("")}e.stripComments=y;function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(te[49],ne([0,1,35]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(b,P,E){let f,p,h,m,v;if(P){for(m=P.offset,v=m+P.length,h=m;h>0&&!C(b,h-1);)h--;let a=v;for(;a<b.length&&!C(b,a);)a++;p=b.substring(h,a),f=A(p,E)}else p=b,f=0,h=0,m=0,v=b.length;const l=R(E,b);let w=!1,S=0,y;E.insertSpaces?y=T(" ",E.tabSize||4):y="	";const d=(0,k.createScanner)(p,!1);let i=!1;function c(){return l+T(y,f+S)}function r(){let a=d.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=d.scan();return i=a===16||d.getTokenError()!==0,a}const n=[];function o(a,u,g){!i&&u<v&&g>m&&b.substring(u,g)!==a&&n.push({offset:u,length:g-u,content:a})}let s=r();if(s!==17){const a=d.getTokenOffset()+h,u=T(y,f);o(u,h,a)}for(;s!==17;){let a=d.getTokenOffset()+d.getTokenLength()+h,u=r(),g="";for(;!w&&(u===12||u===13);){const _=d.getTokenOffset()+h;o(" ",a,_),a=d.getTokenOffset()+d.getTokenLength()+h,g=u===12?c():"",u=r()}if(u===2)s!==1&&(S--,g=c());else if(u===4)s!==3&&(S--,g=c());else{switch(s){case 3:case 1:S++,g=c();break;case 5:case 12:g=c();break;case 13:w?g=c():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(i=!0);break;case 16:i=!0;break}w&&(u===12||u===13)&&(g=c())}const I=d.getTokenOffset()+h;o(g,a,I),s=u}return n}e.format=t;function L(b,P){const E=JSON.stringify(b,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.toFormattedString=L;function T(b,P){let E="";for(let f=0;f<P;f++)E+=b;return E}function A(b,P){let E=0,f=0;const p=P.tabSize||4;for(;E<b.length;){const h=b.charAt(E);if(h===" ")f++;else if(h==="	")f+=p;else break;E++}return Math.floor(f/p)}function R(b,P){for(let E=0;E<P.length;E++){const f=P.charAt(E);if(f==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=R;function C(b,P){return`\r
`.indexOf(b.charAt(P))!==-1}e.isEOL=C}),define(te[70],ne([0,1,35,49]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(b,P,E){return T(b,P,void 0,E)}e.removeProperty=L;function T(b,P,E,f,p){const h=P.slice(),m=[],v=(0,k.parseTree)(b,m);let l,w;for(;h.length>0&&(w=h.pop(),l=(0,k.findNodeAtLocation)(v,h),l===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(l)if(l.type==="object"&&typeof w=="string"&&Array.isArray(l.children)){const S=(0,k.findNodeAtLocation)(l,[w]);if(S!==void 0)if(E===void 0){if(!S.parent)throw new Error("Malformed AST");const y=l.children.indexOf(S.parent);let d,i=S.parent.offset+S.parent.length;if(y>0){const c=l.children[y-1];d=c.offset+c.length}else d=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return A(b,{offset:d,length:i-d,content:""},f)}else return A(b,{offset:S.offset,length:S.length,content:JSON.stringify(E)},f);else{if(E===void 0)return[];const y=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,d=p?p(l.children.map(c=>c.children[0].value)):l.children.length;let i;if(d>0){const c=l.children[d-1];i={offset:c.offset+c.length,length:0,content:","+y}}else l.children.length===0?i={offset:l.offset+1,length:0,content:y}:i={offset:l.offset+1,length:0,content:y+","};return A(b,i,f)}}else if(l.type==="array"&&typeof w=="number"&&Array.isArray(l.children))if(E!==void 0){const S=`${JSON.stringify(E)}`;let y;if(l.children.length===0||w===0)y={offset:l.offset+1,length:0,content:l.children.length===0?S:S+","};else{const d=w===-1||w>l.children.length?l.children.length:w,i=l.children[d-1];y={offset:i.offset+i.length,length:0,content:","+S}}return A(b,y,f)}else{const S=w,y=l.children[S];let d;if(l.children.length===1)d={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===S){const i=l.children[S-1],c=i.offset+i.length,r=l.offset+l.length;d={offset:c,length:r-2-c,content:""}}else d={offset:y.offset,length:l.children[S+1].offset-y.offset,content:""};return A(b,d,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(b,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},f)}}e.setProperty=T;function A(b,P,E){let f=R(b,P),p=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,t.isEOL)(f,p-1);)p--;for(;h<f.length&&!(0,t.isEOL)(f,h);)h++}const m=(0,t.format)(f,{offset:p,length:h-p},E);for(let l=m.length-1;l>=0;l--){const w=m[l];f=R(f,w),p=Math.min(p,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=b.length-(f.length-h)-p;return[{offset:p,length:v,content:f.substring(p,h)}]}e.withFormatting=A;function R(b,P){return b.substring(0,P.offset)+P.content+b.substring(P.offset+P.length)}e.applyEdit=R;function C(b,P){let E=P.slice(0).sort((p,h)=>{const m=p.offset-h.offset;return m===0?p.length-h.length:m}),f=b.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=f)b=R(b,h);else throw new Error("Overlapping edit");f=h.offset}return b}e.applyEdits=C}),define(te[100],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new k(()=>L(this.getValue()))}}e.Lazy=k}),define(te[2],ne([0,1,69,55]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(o){T=o}if(e.setDisposableTracker=A,L){const o="__is_disposable_tracked__";A(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function R(o){return T?.trackDisposable(o),o}function C(o){T?.markAsDisposed(o)}function b(o,s){T?.setParent(o,s)}function P(o,s){if(!!T)for(const a of o)T.setParent(a,s)}function E(o){return T?.markAsSingleton(o),o}e.markAsSingleton=E;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function h(o){if(t.Iterable.is(o)){let s=[];for(const a of o)if(a)try{a.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=h;function m(...o){const s=v(()=>h(o));return P(o,s),s}e.combinedDisposable=m;function v(o){const s=R({dispose:(0,k.once)(()=>{C(s),o()})});return s}e.toDisposable=v;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new l,R(this),b(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=S;class y{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=y;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,C(this))},this}}e.SafeDisposable=d;class i{constructor(){this.references=new Map}acquire(s,...a){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,u));const{object:g}=u,I=(0,k.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:g,dispose:I}}}e.ReferenceCollection=i;class c{constructor(s){this.referenceCollection=s}async acquire(s,...a){const u=this.referenceCollection.acquire(s,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=c;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function n(o){const s=new l;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(T){this.element=T,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let T=this._first;for(;T!==k.Undefined;){const A=T.next;T.prev=k.Undefined,T.next=k.Undefined,T=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const R=new k(T);if(this._first===k.Undefined)this._first=R,this._last=R;else if(A){const b=this._last;this._last=R,R.prev=b,b.next=R}else{const b=this._first;this._first=R,R.next=b,b.prev=R}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==k.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==k.Undefined&&T.next!==k.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===k.Undefined&&T.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):T.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):T.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==k.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(){function Y(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(C){T.push(C,Date.now())}function R(){const C=[];for(let b=0;b<T.length;b+=2)C.push({name:T[b],startTime:T[b+1]});return C}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function k(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),define(te[4],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let t=!1,L=!1,T=!1,A=!1,R=!1,C=!1,b=!1,P=!1,E=!1,f,p=k,h,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const l=typeof v?.versions?.electron=="string",w=l&&v?.type==="renderer";if(e.isElectronSandboxed=w&&v?.sandboxed,typeof navigator=="object"&&!w)m=navigator.userAgent,t=m.indexOf("Windows")>=0,L=m.indexOf("Macintosh")>=0,P=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=m.indexOf("Linux")>=0,C=!0,f=navigator.language,p=f;else if(typeof v=="object"){t=v.platform==="win32",L=v.platform==="darwin",T=v.platform==="linux",A=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,b=l,E=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=k,p=k;const s=v.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),u=a.availableLanguages["*"];f=a.locale,p=u||k,h=a._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var S;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let d=0;L?d=1:t?d=3:T&&(d=2),e.isWindows=t,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=R,e.isElectron=b,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=E,e.platform=d,e.userAgent=m,e.language=p;var i;(function(s){function a(){return e.language}s.value=a;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function g(){return e.language==="en"}s.isDefault=g})(i=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=h,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let g=0,I=s.length;g<I;g++){const _=s[g];if(_.id===u.data.vscodeScheduleAsyncWork){s.splice(g,1),_.callback();return}}});let a=0;return u=>{const g=++a;s.push({id:g,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return s=>setTimeout(s)})();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:t?1:3;let r=!0,n=!1;function o(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[33],ne([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const L=k.globals.vscode.process;t={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[10],ne([0,1,33]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,L=97,T=90,A=122,R=46,C=47,b=92,P=58,E=63;class f extends Error{constructor(y,d,i){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const r=y.indexOf(".")!==-1?"property":"argument";let n=`The "${y}" ${r} ${c} of type ${d}`;n+=`. Received type ${typeof i}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function p(S,y){if(typeof S!="string")throw new f(y,"string",S)}function h(S){return S===C||S===b}function m(S){return S===C}function v(S){return S>=t&&S<=T||S>=L&&S<=A}function l(S,y,d,i){let c="",r=0,n=-1,o=0,s=0;for(let a=0;a<=S.length;++a){if(a<S.length)s=S.charCodeAt(a);else{if(i(s))break;s=C}if(i(s)){if(!(n===a-1||o===1))if(o===2){if(c.length<2||r!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const u=c.lastIndexOf(d);u===-1?(c="",r=0):(c=c.slice(0,u),r=c.length-1-c.lastIndexOf(d)),n=a,o=0;continue}else if(c.length!==0){c="",r=0,n=a,o=0;continue}}y&&(c+=c.length>0?`${d}..`:"..",r=2)}else c.length>0?c+=`${d}${S.slice(n+1,a)}`:c=S.slice(n+1,a),r=a-n-1;n=a,o=0}else s===R&&o!==-1?++o:o=-1}return c}function w(S,y){if(y===null||typeof y!="object")throw new f("pathObject","Object",y);const d=y.dir||y.root,i=y.base||`${y.name||""}${y.ext||""}`;return d?d===y.root?`${d}${i}`:`${d}${S}${i}`:i}e.win32={resolve(...S){let y="",d="",i=!1;for(let c=S.length-1;c>=-1;c--){let r;if(c>=0){if(r=S[c],p(r,"path"),r.length===0)continue}else y.length===0?r=k.cwd():(r=k.env[`=${y}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==y.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${y}\\`));const n=r.length;let o=0,s="",a=!1;const u=r.charCodeAt(0);if(n===1)h(u)&&(o=1,a=!0);else if(h(u))if(a=!0,h(r.charCodeAt(1))){let g=2,I=g;for(;g<n&&!h(r.charCodeAt(g));)g++;if(g<n&&g!==I){const _=r.slice(I,g);for(I=g;g<n&&h(r.charCodeAt(g));)g++;if(g<n&&g!==I){for(I=g;g<n&&!h(r.charCodeAt(g));)g++;(g===n||g!==I)&&(s=`\\\\${_}\\${r.slice(I,g)}`,o=g)}}}else o=1;else v(u)&&r.charCodeAt(1)===P&&(s=r.slice(0,2),o=2,n>2&&h(r.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(y.length>0){if(s.toLowerCase()!==y.toLowerCase())continue}else y=s;if(i){if(y.length>0)break}else if(d=`${r.slice(o)}\\${d}`,i=a,a&&y.length>0)break}return d=l(d,!i,"\\",h),i?`${y}\\${d}`:`${y}${d}`||"."},normalize(S){p(S,"path");const y=S.length;if(y===0)return".";let d=0,i,c=!1;const r=S.charCodeAt(0);if(y===1)return m(r)?"\\":S;if(h(r))if(c=!0,h(S.charCodeAt(1))){let o=2,s=o;for(;o<y&&!h(S.charCodeAt(o));)o++;if(o<y&&o!==s){const a=S.slice(s,o);for(s=o;o<y&&h(S.charCodeAt(o));)o++;if(o<y&&o!==s){for(s=o;o<y&&!h(S.charCodeAt(o));)o++;if(o===y)return`\\\\${a}\\${S.slice(s)}\\`;o!==s&&(i=`\\\\${a}\\${S.slice(s,o)}`,d=o)}}}else d=1;else v(r)&&S.charCodeAt(1)===P&&(i=S.slice(0,2),d=2,y>2&&h(S.charCodeAt(2))&&(c=!0,d=3));let n=d<y?l(S.slice(d),!c,"\\",h):"";return n.length===0&&!c&&(n="."),n.length>0&&h(S.charCodeAt(y-1))&&(n+="\\"),i===void 0?c?`\\${n}`:n:c?`${i}\\${n}`:`${i}${n}`},isAbsolute(S){p(S,"path");const y=S.length;if(y===0)return!1;const d=S.charCodeAt(0);return h(d)||y>2&&v(d)&&S.charCodeAt(1)===P&&h(S.charCodeAt(2))},join(...S){if(S.length===0)return".";let y,d;for(let r=0;r<S.length;++r){const n=S[r];p(n,"path"),n.length>0&&(y===void 0?y=d=n:y+=`\\${n}`)}if(y===void 0)return".";let i=!0,c=0;if(typeof d=="string"&&h(d.charCodeAt(0))){++c;const r=d.length;r>1&&h(d.charCodeAt(1))&&(++c,r>2&&(h(d.charCodeAt(2))?++c:i=!1))}if(i){for(;c<y.length&&h(y.charCodeAt(c));)c++;c>=2&&(y=`\\${y.slice(c)}`)}return e.win32.normalize(y)},relative(S,y){if(p(S,"from"),p(y,"to"),S===y)return"";const d=e.win32.resolve(S),i=e.win32.resolve(y);if(d===i||(S=d.toLowerCase(),y=i.toLowerCase(),S===y))return"";let c=0;for(;c<S.length&&S.charCodeAt(c)===b;)c++;let r=S.length;for(;r-1>c&&S.charCodeAt(r-1)===b;)r--;const n=r-c;let o=0;for(;o<y.length&&y.charCodeAt(o)===b;)o++;let s=y.length;for(;s-1>o&&y.charCodeAt(s-1)===b;)s--;const a=s-o,u=n<a?n:a;let g=-1,I=0;for(;I<u;I++){const O=S.charCodeAt(c+I);if(O!==y.charCodeAt(o+I))break;O===b&&(g=I)}if(I!==u){if(g===-1)return i}else{if(a>u){if(y.charCodeAt(o+I)===b)return i.slice(o+I+1);if(I===2)return i.slice(o+I)}n>u&&(S.charCodeAt(c+I)===b?g=I:I===2&&(g=3)),g===-1&&(g=0)}let _="";for(I=c+g+1;I<=r;++I)(I===r||S.charCodeAt(I)===b)&&(_+=_.length===0?"..":"\\..");return o+=g,_.length>0?`${_}${i.slice(o,s)}`:(i.charCodeAt(o)===b&&++o,i.slice(o,s))},toNamespacedPath(S){if(typeof S!="string")return S;if(S.length===0)return"";const y=e.win32.resolve(S);if(y.length<=2)return S;if(y.charCodeAt(0)===b){if(y.charCodeAt(1)===b){const d=y.charCodeAt(2);if(d!==E&&d!==R)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(v(y.charCodeAt(0))&&y.charCodeAt(1)===P&&y.charCodeAt(2)===b)return`\\\\?\\${y}`;return S},dirname(S){p(S,"path");const y=S.length;if(y===0)return".";let d=-1,i=0;const c=S.charCodeAt(0);if(y===1)return h(c)?S:".";if(h(c)){if(d=i=1,h(S.charCodeAt(1))){let o=2,s=o;for(;o<y&&!h(S.charCodeAt(o));)o++;if(o<y&&o!==s){for(s=o;o<y&&h(S.charCodeAt(o));)o++;if(o<y&&o!==s){for(s=o;o<y&&!h(S.charCodeAt(o));)o++;if(o===y)return S;o!==s&&(d=i=o+1)}}}}else v(c)&&S.charCodeAt(1)===P&&(d=y>2&&h(S.charCodeAt(2))?3:2,i=d);let r=-1,n=!0;for(let o=y-1;o>=i;--o)if(h(S.charCodeAt(o))){if(!n){r=o;break}}else n=!1;if(r===-1){if(d===-1)return".";r=d}return S.slice(0,r)},basename(S,y){y!==void 0&&p(y,"ext"),p(S,"path");let d=0,i=-1,c=!0,r;if(S.length>=2&&v(S.charCodeAt(0))&&S.charCodeAt(1)===P&&(d=2),y!==void 0&&y.length>0&&y.length<=S.length){if(y===S)return"";let n=y.length-1,o=-1;for(r=S.length-1;r>=d;--r){const s=S.charCodeAt(r);if(h(s)){if(!c){d=r+1;break}}else o===-1&&(c=!1,o=r+1),n>=0&&(s===y.charCodeAt(n)?--n==-1&&(i=r):(n=-1,i=o))}return d===i?i=o:i===-1&&(i=S.length),S.slice(d,i)}for(r=S.length-1;r>=d;--r)if(h(S.charCodeAt(r))){if(!c){d=r+1;break}}else i===-1&&(c=!1,i=r+1);return i===-1?"":S.slice(d,i)},extname(S){p(S,"path");let y=0,d=-1,i=0,c=-1,r=!0,n=0;S.length>=2&&S.charCodeAt(1)===P&&v(S.charCodeAt(0))&&(y=i=2);for(let o=S.length-1;o>=y;--o){const s=S.charCodeAt(o);if(h(s)){if(!r){i=o+1;break}continue}c===-1&&(r=!1,c=o+1),s===R?d===-1?d=o:n!==1&&(n=1):d!==-1&&(n=-1)}return d===-1||c===-1||n===0||n===1&&d===c-1&&d===i+1?"":S.slice(d,c)},format:w.bind(null,"\\"),parse(S){p(S,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return y;const d=S.length;let i=0,c=S.charCodeAt(0);if(d===1)return h(c)?(y.root=y.dir=S,y):(y.base=y.name=S,y);if(h(c)){if(i=1,h(S.charCodeAt(1))){let g=2,I=g;for(;g<d&&!h(S.charCodeAt(g));)g++;if(g<d&&g!==I){for(I=g;g<d&&h(S.charCodeAt(g));)g++;if(g<d&&g!==I){for(I=g;g<d&&!h(S.charCodeAt(g));)g++;g===d?i=g:g!==I&&(i=g+1)}}}}else if(v(c)&&S.charCodeAt(1)===P){if(d<=2)return y.root=y.dir=S,y;if(i=2,h(S.charCodeAt(2))){if(d===3)return y.root=y.dir=S,y;i=3}}i>0&&(y.root=S.slice(0,i));let r=-1,n=i,o=-1,s=!0,a=S.length-1,u=0;for(;a>=i;--a){if(c=S.charCodeAt(a),h(c)){if(!s){n=a+1;break}continue}o===-1&&(s=!1,o=a+1),c===R?r===-1?r=a:u!==1&&(u=1):r!==-1&&(u=-1)}return o!==-1&&(r===-1||u===0||u===1&&r===o-1&&r===n+1?y.base=y.name=S.slice(n,o):(y.name=S.slice(n,r),y.base=S.slice(n,o),y.ext=S.slice(r,o))),n>0&&n!==i?y.dir=S.slice(0,n-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...S){let y="",d=!1;for(let i=S.length-1;i>=-1&&!d;i--){const c=i>=0?S[i]:k.cwd();p(c,"path"),c.length!==0&&(y=`${c}/${y}`,d=c.charCodeAt(0)===C)}return y=l(y,!d,"/",m),d?`/${y}`:y.length>0?y:"."},normalize(S){if(p(S,"path"),S.length===0)return".";const y=S.charCodeAt(0)===C,d=S.charCodeAt(S.length-1)===C;return S=l(S,!y,"/",m),S.length===0?y?"/":d?"./":".":(d&&(S+="/"),y?`/${S}`:S)},isAbsolute(S){return p(S,"path"),S.length>0&&S.charCodeAt(0)===C},join(...S){if(S.length===0)return".";let y;for(let d=0;d<S.length;++d){const i=S[d];p(i,"path"),i.length>0&&(y===void 0?y=i:y+=`/${i}`)}return y===void 0?".":e.posix.normalize(y)},relative(S,y){if(p(S,"from"),p(y,"to"),S===y||(S=e.posix.resolve(S),y=e.posix.resolve(y),S===y))return"";const d=1,i=S.length,c=i-d,r=1,n=y.length-r,o=c<n?c:n;let s=-1,a=0;for(;a<o;a++){const g=S.charCodeAt(d+a);if(g!==y.charCodeAt(r+a))break;g===C&&(s=a)}if(a===o)if(n>o){if(y.charCodeAt(r+a)===C)return y.slice(r+a+1);if(a===0)return y.slice(r+a)}else c>o&&(S.charCodeAt(d+a)===C?s=a:a===0&&(s=0));let u="";for(a=d+s+1;a<=i;++a)(a===i||S.charCodeAt(a)===C)&&(u+=u.length===0?"..":"/..");return`${u}${y.slice(r+s)}`},toNamespacedPath(S){return S},dirname(S){if(p(S,"path"),S.length===0)return".";const y=S.charCodeAt(0)===C;let d=-1,i=!0;for(let c=S.length-1;c>=1;--c)if(S.charCodeAt(c)===C){if(!i){d=c;break}}else i=!1;return d===-1?y?"/":".":y&&d===1?"//":S.slice(0,d)},basename(S,y){y!==void 0&&p(y,"ext"),p(S,"path");let d=0,i=-1,c=!0,r;if(y!==void 0&&y.length>0&&y.length<=S.length){if(y===S)return"";let n=y.length-1,o=-1;for(r=S.length-1;r>=0;--r){const s=S.charCodeAt(r);if(s===C){if(!c){d=r+1;break}}else o===-1&&(c=!1,o=r+1),n>=0&&(s===y.charCodeAt(n)?--n==-1&&(i=r):(n=-1,i=o))}return d===i?i=o:i===-1&&(i=S.length),S.slice(d,i)}for(r=S.length-1;r>=0;--r)if(S.charCodeAt(r)===C){if(!c){d=r+1;break}}else i===-1&&(c=!1,i=r+1);return i===-1?"":S.slice(d,i)},extname(S){p(S,"path");let y=-1,d=0,i=-1,c=!0,r=0;for(let n=S.length-1;n>=0;--n){const o=S.charCodeAt(n);if(o===C){if(!c){d=n+1;break}continue}i===-1&&(c=!1,i=n+1),o===R?y===-1?y=n:r!==1&&(r=1):y!==-1&&(r=-1)}return y===-1||i===-1||r===0||r===1&&y===i-1&&y===d+1?"":S.slice(y,i)},format:w.bind(null,"/"),parse(S){p(S,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return y;const d=S.charCodeAt(0)===C;let i;d?(y.root="/",i=1):i=0;let c=-1,r=0,n=-1,o=!0,s=S.length-1,a=0;for(;s>=i;--s){const u=S.charCodeAt(s);if(u===C){if(!o){r=s+1;break}continue}n===-1&&(o=!1,n=s+1),u===R?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}if(n!==-1){const u=r===0&&d?1:r;c===-1||a===0||a===1&&c===n-1&&c===r+1?y.base=y.name=S.slice(u,n):(y.name=S.slice(u,c),y.base=S.slice(u,n),y.ext=S.slice(c,n))}return r>0?y.dir=S.slice(0,r-1):d&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1,10]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex",E.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const f=(0,k.extname)(E),p=L[f.toLowerCase()];return p!==void 0?p:R(E)}e.getMediaOrTextMime=A;function R(E){const f=(0,k.extname)(E);return T[f.toLowerCase()]}e.getMediaMime=R;function C(E){for(const f in T)if(T[f]===E)return f}e.getExtensionForMimeType=C;const b=/^(.+)\/(.+?)(;.+)?$/;function P(E,f){const p=b.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:f?void 0:E}e.normalizeMimeType=P}),define(te[103],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var t;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const R=A.reduce((P,E)=>(P[E]=!0,P),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(P=>!R[P]).forEach(P=>{for(let E=0;E<C.length;E++)if(P.search(C[E])!==-1){delete T[P];break}})}e.sanitizeProcessEnvironment=L}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:Y)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function k(t){if(e[t])return e[t].exports;var L=e[t]={i:t,l:!1,exports:{}};return Y[t].call(L.exports,L,L.exports,k),L.l=!0,L.exports}return k.m=Y,k.c=e,k.d=function(t,L,T){k.o(t,L)||Object.defineProperty(t,L,{enumerable:!0,get:T})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,L){if(1&L&&(t=k(t)),8&L||4&L&&typeof t=="object"&&t&&t.__esModule)return t;var T=Object.create(null);if(k.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:t}),2&L&&typeof t!="string")for(var A in t)k.d(T,A,function(R){return t[R]}.bind(null,A));return T},k.n=function(t){var L=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(L,"a",L),L},k.o=function(t,L){return Object.prototype.hasOwnProperty.call(t,L)},k.p="",k(k.s=0)}([function(Y,e,k){(function(t){var L;e=Y.exports=F,L=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],b=0,P=b++;C[P]="0|[1-9]\\d*";var E=b++;C[E]="[0-9]+";var f=b++;C[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;C[p]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var h=b++;C[h]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var m=b++;C[m]="(?:"+C[P]+"|"+C[f]+")";var v=b++;C[v]="(?:"+C[E]+"|"+C[f]+")";var l=b++;C[l]="(?:-("+C[m]+"(?:\\."+C[m]+")*))";var w=b++;C[w]="(?:-?("+C[v]+"(?:\\."+C[v]+")*))";var S=b++;C[S]="[0-9A-Za-z-]+";var y=b++;C[y]="(?:\\+("+C[S]+"(?:\\."+C[S]+")*))";var d=b++,i="v?"+C[p]+C[l]+"?"+C[y]+"?";C[d]="^"+i+"$";var c="[v=\\s]*"+C[h]+C[w]+"?"+C[y]+"?",r=b++;C[r]="^"+c+"$";var n=b++;C[n]="((?:<|>)?=?)";var o=b++;C[o]=C[E]+"|x|X|\\*";var s=b++;C[s]=C[P]+"|x|X|\\*";var a=b++;C[a]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[l]+")?"+C[y]+"?)?)?";var u=b++;C[u]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[w]+")?"+C[y]+"?)?)?";var g=b++;C[g]="^"+C[n]+"\\s*"+C[a]+"$";var I=b++;C[I]="^"+C[n]+"\\s*"+C[u]+"$";var _=b++;C[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;C[O]="(?:~>?)";var M=b++;C[M]="(\\s*)"+C[O]+"\\s+",R[M]=new RegExp(C[M],"g");var D=b++;C[D]="^"+C[O]+C[a]+"$";var U=b++;C[U]="^"+C[O]+C[u]+"$";var z=b++;C[z]="(?:\\^)";var B=b++;C[B]="(\\s*)"+C[z]+"\\s+",R[B]=new RegExp(C[B],"g");var q=b++;C[q]="^"+C[z]+C[a]+"$";var G=b++;C[G]="^"+C[z]+C[u]+"$";var re=b++;C[re]="^"+C[n]+"\\s*("+c+")$|^$";var H=b++;C[H]="^"+C[n]+"\\s*("+i+")$|^$";var j=b++;C[j]="(\\s*)"+C[n]+"\\s*("+c+"|"+C[a]+")",R[j]=new RegExp(C[j],"g");var Q=b++;C[Q]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var x=b++;C[x]="^\\s*("+C[u]+")\\s+-\\s+("+C[u]+")\\s*$";var J=b++;C[J]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)L(Z,C[Z]),R[Z]||(R[Z]=new RegExp(C[Z]));function W(ie,ce){if(ie instanceof F)return ie;if(typeof ie!="string"||ie.length>T||!(ce?R[r]:R[d]).test(ie))return null;try{return new F(ie,ce)}catch{return null}}function F(ie,ce){if(ie instanceof F){if(ie.loose===ce)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof F))return new F(ie,ce);L("SemVer",ie,ce),this.loose=ce;var ue=ie.trim().match(ce?R[r]:R[d]);if(!ue)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var be=+we;if(be>=0&&be<A)return be}return we}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=W,e.valid=function(ie,ce){var ue=W(ie,ce);return ue?ue.version:null},e.clean=function(ie,ce){var ue=W(ie.trim().replace(/^[=v]+/,""),ce);return ue?ue.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(ie){return L("SemVer.compare",this.version,this.loose,ie),ie instanceof F||(ie=new F(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},F.prototype.compareMain=function(ie){return ie instanceof F||(ie=new F(ie,this.loose)),$(this.major,ie.major)||$(this.minor,ie.minor)||$(this.patch,ie.patch)},F.prototype.comparePre=function(ie){if(ie instanceof F||(ie=new F(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ce=0;do{var ue=this.prerelease[ce],we=ie.prerelease[ce];if(L("prerelease compare",ce,ue,we),ue===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(ue===void 0)return-1;if(ue!==we)return $(ue,we)}while(++ce)},F.prototype.inc=function(ie,ce){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ce,ue,we){typeof ue=="string"&&(we=ue,ue=void 0);try{return new F(ie,ue).inc(ce,we).version}catch{return null}},e.diff=function(ie,ce){if(ae(ie,ce))return null;var ue=W(ie),we=W(ce);if(ue.prerelease.length||we.prerelease.length){for(var be in ue)if((be==="major"||be==="minor"||be==="patch")&&ue[be]!==we[be])return"pre"+be;return"prerelease"}for(var be in ue)if((be==="major"||be==="minor"||be==="patch")&&ue[be]!==we[be])return be},e.compareIdentifiers=$;var N=/^[0-9]+$/;function $(ie,ce){var ue=N.test(ie),we=N.test(ce);return ue&&we&&(ie=+ie,ce=+ce),ue&&!we?-1:we&&!ue?1:ie<ce?-1:ie>ce?1:0}function V(ie,ce,ue){return new F(ie,ue).compare(new F(ce,ue))}function ee(ie,ce,ue){return V(ie,ce,ue)>0}function se(ie,ce,ue){return V(ie,ce,ue)<0}function ae(ie,ce,ue){return V(ie,ce,ue)===0}function de(ie,ce,ue){return V(ie,ce,ue)!==0}function ge(ie,ce,ue){return V(ie,ce,ue)>=0}function Ee(ie,ce,ue){return V(ie,ce,ue)<=0}function Se(ie,ce,ue,we){var be;switch(ce){case"===":typeof ie=="object"&&(ie=ie.version),typeof ue=="object"&&(ue=ue.version),be=ie===ue;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof ue=="object"&&(ue=ue.version),be=ie!==ue;break;case"":case"=":case"==":be=ae(ie,ue,we);break;case"!=":be=de(ie,ue,we);break;case">":be=ee(ie,ue,we);break;case">=":be=ge(ie,ue,we);break;case"<":be=se(ie,ue,we);break;case"<=":be=Ee(ie,ue,we);break;default:throw new TypeError("Invalid operator: "+ce)}return be}function pe(ie,ce){if(ie instanceof pe){if(ie.loose===ce)return ie;ie=ie.value}if(!(this instanceof pe))return new pe(ie,ce);L("comparator",ie,ce),this.loose=ce,this.parse(ie),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ie,ce){return $(ce,ie)},e.major=function(ie,ce){return new F(ie,ce).major},e.minor=function(ie,ce){return new F(ie,ce).minor},e.patch=function(ie,ce){return new F(ie,ce).patch},e.compare=V,e.compareLoose=function(ie,ce){return V(ie,ce,!0)},e.rcompare=function(ie,ce,ue){return V(ce,ie,ue)},e.sort=function(ie,ce){return ie.sort(function(ue,we){return e.compare(ue,we,ce)})},e.rsort=function(ie,ce){return ie.sort(function(ue,we){return e.rcompare(ue,we,ce)})},e.gt=ee,e.lt=se,e.eq=ae,e.neq=de,e.gte=ge,e.lte=Ee,e.cmp=Se,e.Comparator=pe;var Ie={};function Ce(ie,ce){if(ie instanceof Ce)return ie.loose===ce?ie:new Ce(ie.raw,ce);if(ie instanceof pe)return new Ce(ie.value,ce);if(!(this instanceof Ce))return new Ce(ie,ce);if(this.loose=ce,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function De(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Ue(ie,ce,ue,we,be,Fe,Te,Oe,_e,X,oe,le,fe){return((ce=De(ue)?"":De(we)?">="+ue+".0.0":De(be)?">="+ue+"."+we+".0":">="+ce)+" "+(Oe=De(_e)?"":De(X)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+X+1)+".0":le?"<="+_e+"."+X+"."+oe+"-"+le:"<="+Oe)).trim()}function je(ie,ce){for(var ue=0;ue<ie.length;ue++)if(!ie[ue].test(ce))return!1;if(ce.prerelease.length){for(ue=0;ue<ie.length;ue++)if(L(ie[ue].semver),ie[ue].semver!==Ie&&ie[ue].semver.prerelease.length>0){var we=ie[ue].semver;if(we.major===ce.major&&we.minor===ce.minor&&we.patch===ce.patch)return!0}return!1}return!0}function Ge(ie,ce,ue){try{ce=new Ce(ce,ue)}catch{return!1}return ce.test(ie)}function Be(ie,ce,ue,we){var be,Fe,Te,Oe,_e;switch(ie=new F(ie,we),ce=new Ce(ce,we),ue){case">":be=ee,Fe=Ee,Te=se,Oe=">",_e=">=";break;case"<":be=se,Fe=ge,Te=ee,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(ie,ce,we))return!1;for(var X=0;X<ce.set.length;++X){var oe=ce.set[X],le=null,fe=null;if(oe.forEach(function(me){me.semver===Ie&&(me=new pe(">=0.0.0")),le=le||me,fe=fe||me,be(me.semver,le.semver,we)?le=me:Te(me.semver,fe.semver,we)&&(fe=me)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Fe(ie,fe.semver)||fe.operator===_e&&Te(ie,fe.semver))return!1}return!0}pe.prototype.parse=function(ie){var ce=this.loose?R[re]:R[H],ue=ie.match(ce);if(!ue)throw new TypeError("Invalid comparator: "+ie);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new F(ue[2],this.loose):this.semver=Ie},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ie){return L("Comparator.test",ie,this.loose),this.semver===Ie||(typeof ie=="string"&&(ie=new F(ie,this.loose)),Se(ie,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ie,ce){if(!(ie instanceof pe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ce(ie.value,ce),Ge(this.value,ue,ce);if(ie.operator==="")return ue=new Ce(this.value,ce),Ge(ie.semver,ue,ce);var we=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Fe=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Oe=Se(this.semver,"<",ie.semver,ce)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),_e=Se(this.semver,">",ie.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return we||be||Fe&&Te||Oe||_e},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(ie){var ce=this.loose;ie=ie.trim(),L("range",ie,ce);var ue=ce?R[x]:R[Q];ie=ie.replace(ue,Ue),L("hyphen replace",ie),ie=ie.replace(R[j],"$1$2$3"),L("comparator trim",ie,R[j]),ie=(ie=(ie=ie.replace(R[M],"$1~")).replace(R[B],"$1^")).split(/\s+/).join(" ");var we=ce?R[re]:R[H],be=ie.split(" ").map(function(Fe){return function(Te,Oe){return L("comp",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var me=fe?R[G]:R[q];return le.replace(me,function(Le,ye,Re,ke,Pe){var Ae;return L("caret",le,Le,ye,Re,ke,Pe),De(ye)?Ae="":De(Re)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(ke)?Ae=ye==="0"?">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+".0 <"+(+ye+1)+".0.0":Pe?(L("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+Re+"."+(+ke+1):">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+ke+Pe+" <"+(+ye+1)+".0.0"):(L("no pr"),Ae=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+ke+" <"+ye+"."+Re+"."+(+ke+1):">="+ye+"."+Re+"."+ke+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+ke+" <"+(+ye+1)+".0.0"),L("caret return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var me=fe?R[U]:R[D];return le.replace(me,function(Le,ye,Re,ke,Pe){var Ae;return L("tilde",le,Le,ye,Re,ke,Pe),De(ye)?Ae="":De(Re)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(ke)?Ae=">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":Pe?(L("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+(+Re+1)+".0"):Ae=">="+ye+"."+Re+"."+ke+" <"+ye+"."+(+Re+1)+".0",L("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,X){return L("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var me=fe?R[I]:R[g];return le.replace(me,function(Le,ye,Re,ke,Pe,Ae){L("xRange",le,Le,ye,Re,ke,Pe,Ae);var Ne=De(Re),We=Ne||De(ke),qe=We||De(Pe);return ye==="="&&qe&&(ye=""),Ne?Le=ye===">"||ye==="<"?"<0.0.0":"*":ye&&qe?(We&&(ke=0),qe&&(Pe=0),ye===">"?(ye=">=",We?(Re=+Re+1,ke=0,Pe=0):qe&&(ke=+ke+1,Pe=0)):ye==="<="&&(ye="<",We?Re=+Re+1:ke=+ke+1),Le=ye+Re+"."+ke+"."+Pe):We?Le=">="+Re+".0.0 <"+(+Re+1)+".0.0":qe&&(Le=">="+Re+"."+ke+".0 <"+Re+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,X)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,X){return L("replaceStars",_e,X),_e.trim().replace(R[J],"")}(Te,Oe),L("stars",Te),Te}(Fe,ce)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Fe){return!!Fe.match(we)})),be=be.map(function(Fe){return new pe(Fe,ce)})},Ce.prototype.intersects=function(ie,ce){if(!(ie instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(we){return ie.set.some(function(be){return be.every(function(Fe){return we.intersects(Fe,ce)})})})})},e.toComparators=function(ie,ce){return new Ce(ie,ce).set.map(function(ue){return ue.map(function(we){return we.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new F(ie,this.loose));for(var ce=0;ce<this.set.length;ce++)if(je(this.set[ce],ie))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(ie,ce,ue){var we=null,be=null;try{var Fe=new Ce(ce,ue)}catch{return null}return ie.forEach(function(Te){Fe.test(Te)&&(we&&be.compare(Te)!==-1||(be=new F(we=Te,ue)))}),we},e.minSatisfying=function(ie,ce,ue){var we=null,be=null;try{var Fe=new Ce(ce,ue)}catch{return null}return ie.forEach(function(Te){Fe.test(Te)&&(we&&be.compare(Te)!==1||(be=new F(we=Te,ue)))}),we},e.validRange=function(ie,ce){try{return new Ce(ie,ce).range||"*"}catch{return null}},e.ltr=function(ie,ce,ue){return Be(ie,ce,"<",ue)},e.gtr=function(ie,ce,ue){return Be(ie,ce,">",ue)},e.outside=Be,e.prerelease=function(ie,ce){var ue=W(ie,ce);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(ie,ce,ue){return ie=new Ce(ie,ue),ce=new Ce(ce,ue),ie.intersects(ce)},e.coerce=function(ie){if(ie instanceof F)return ie;if(typeof ie!="string")return null;var ce=ie.match(R[_]);return ce==null?null:W((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,k(1))},function(Y,e){var k,t,L=Y.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(v){if(k===setTimeout)return setTimeout(v,0);if((k===T||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:T}catch{k=T}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var C,b=[],P=!1,E=-1;function f(){P&&C&&(P=!1,C.length?b=C.concat(b):E=-1,b.length&&p())}function p(){if(!P){var v=R(f);P=!0;for(var l=b.length;l;){for(C=b,b=[];++E<l;)C&&C[E].run();E=-1,l=b.length}C=null,P=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(v)}}function h(v,l){this.fun=v,this.array=l}function m(){}L.nextTick=function(v){var l=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)l[w-1]=arguments[w];b.push(new h(v,l)),b.length!==1||P||R(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=m,L.addListener=m,L.once=m,L.off=m,L.removeListener=m,L.removeAllListeners=m,L.emit=m,L.prependListener=m,L.prependOnceListener=m,L.listeners=function(v){return[]},L.binding=function(v){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(v){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(Y,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(R,C,b){this.level=R,this.key=C,this.value=b,this.forward=[]}}const L=void 0;class T{constructor(R,C=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new t(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,L,L)}has(R){return Boolean(T._search(this,R,this.comparator))}get(R){return T._search(this,R,this.comparator)?.value}set(R,C){return T._insert(this,R,C,this.comparator)&&(this._size+=1),this}delete(R){const C=T._delete(this,R,this.comparator);return C&&(this._size-=1),C}forEach(R,C){let b=this._header.forward[0];for(;b;)R.call(C,b.value,b.key,this),b=b.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this._header.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static _search(R,C,b){let P=R._header;for(let E=R._level-1;E>=0;E--)for(;P.forward[E]&&b(P.forward[E].key,C)<0;)P=P.forward[E];if(P=P.forward[0],P&&b(P.key,C)===0)return P}static _insert(R,C,b,P){let E=[],f=R._header;for(let p=R._level-1;p>=0;p--){for(;f.forward[p]&&P(f.forward[p].key,C)<0;)f=f.forward[p];E[p]=f}if(f=f.forward[0],f&&P(f.key,C)===0)return f.value=b,!1;{let p=T._randomLevel(R);if(p>R._level){for(let h=R._level;h<p;h++)E[h]=R._header;R._level=p}f=new t(p,C,b);for(let h=0;h<p;h++)f.forward[h]=E[h].forward[h],E[h].forward[h]=f;return!0}}static _randomLevel(R,C=.5){let b=1;for(;Math.random()<C&&b<R._maxLevel;)b+=1;return b}static _delete(R,C,b){let P=[],E=R._header;for(let f=R._level-1;f>=0;f--){for(;E.forward[f]&&b(E.forward[f].key,C)<0;)E=E.forward[f];P[f]=E}if(E=E.forward[0],!E||b(E.key,C)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===E;f++)P[f].forward[f]=E.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=T}),define(te[105],ne([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class L{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=L}),define(te[3],ne([0,1,9,69,2,101,105]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let R=!1,C=!1;var b;(function(r){r.None=()=>L.Disposable.None;function n(x){if(C){const{onListenerDidAdd:J}=x,Z=h.create();let W=0;x.onListenerDidAdd=()=>{++W==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),J?.()}}}function o(x){return(J,Z=null,W)=>{let F=!1,N;return N=x($=>{if(!F)return N?N.dispose():F=!0,J.call(Z,$)},null,W),F&&N.dispose(),N}}r.once=o;function s(x,J,Z){return O((W,F=null,N)=>x($=>W.call(F,J($)),null,N),Z)}r.map=s;function a(x,J,Z){return O((W,F=null,N)=>x($=>{J($),W.call(F,$)},null,N),Z)}r.forEach=a;function u(x,J,Z){return O((W,F=null,N)=>x($=>J($)&&W.call(F,$),null,N),Z)}r.filter=u;function g(x){return x}r.signal=g;function I(...x){return(J,Z=null,W)=>(0,L.combinedDisposable)(...x.map(F=>F(N=>J.call(Z,N),null,W)))}r.any=I;function _(x,J,Z,W){let F=Z;return s(x,N=>(F=J(F,N),F),W)}r.reduce=_;function O(x,J){let Z;const W={onFirstListenerAdd(){Z=x(F.fire,F)},onLastListenerRemove(){Z.dispose()}};J||n(W);const F=new v(W);return J&&J.add(F),F.event}function M(x,J,Z=100,W=!1,F,N){let $,V,ee,se=0;const ae={leakWarningThreshold:F,onFirstListenerAdd(){$=x(ge=>{se++,V=J(V,ge),W&&!ee&&(de.fire(V),V=void 0),clearTimeout(ee),ee=setTimeout(()=>{const Ee=V;V=void 0,ee=void 0,(!W||se>1)&&de.fire(Ee),se=0},Z)})},onLastListenerRemove(){$.dispose()}};N||n(ae);const de=new v(ae);return N&&N.add(de),de.event}r.debounce=M;function D(x,J=(W,F)=>W===F,Z){let W=!0,F;return u(x,N=>{const $=W||!J(N,F);return W=!1,F=N,$},Z)}r.latch=D;function U(x,J,Z){return[r.filter(x,J,Z),r.filter(x,W=>!J(W),Z)]}r.split=U;function z(x,J=!1,Z=[]){let W=Z.slice(),F=x(V=>{W?W.push(V):$.fire(V)});const N=()=>{W&&W.forEach(V=>$.fire(V)),W=null},$=new v({onFirstListenerAdd(){F||(F=x(V=>$.fire(V)))},onFirstListenerDidAdd(){W&&(J?setTimeout(N):N())},onLastListenerRemove(){F&&F.dispose(),F=null}});return $.event}r.buffer=z;class B{constructor(J){this.event=J}map(J){return new B(s(this.event,J))}forEach(J){return new B(a(this.event,J))}filter(J){return new B(u(this.event,J))}reduce(J,Z){return new B(_(this.event,J,Z))}latch(){return new B(D(this.event))}debounce(J,Z=100,W=!1,F){return new B(M(this.event,J,Z,W,F))}on(J,Z,W){return this.event(J,Z,W)}once(J,Z,W){return o(this.event)(J,Z,W)}}function q(x){return new B(x)}r.chain=q;function G(x,J,Z=W=>W){const W=(...V)=>$.fire(Z(...V)),F=()=>x.on(J,W),N=()=>x.removeListener(J,W),$=new v({onFirstListenerAdd:F,onLastListenerRemove:N});return $.event}r.fromNodeEventEmitter=G;function re(x,J,Z=W=>W){const W=(...V)=>$.fire(Z(...V)),F=()=>x.addEventListener(J,W),N=()=>x.removeEventListener(J,W),$=new v({onFirstListenerAdd:F,onLastListenerRemove:N});return $.event}r.fromDOMEventEmitter=re;function H(x){return new Promise(J=>o(x)(J))}r.toPromise=H;function j(x,J){return J(void 0),x(Z=>J(Z))}r.runAndSubscribe=j;function Q(x,J){let Z=null;function W(N){Z?.dispose(),Z=new L.DisposableStore,J(N,Z)}W(void 0);const F=x(N=>W(N));return(0,L.toDisposable)(()=>{F.dispose(),Z?.dispose()})}r.runAndSubscribeWithStore=Q})(b=e.Event||(e.Event={}));class P{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${P._idPool++}`}start(n){this._stopWatch=new A.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let E=-1;function f(r){const n=E;return E=r,{dispose(){E=n}}}e.setGlobalLeakWarningThreshold=f;class p{constructor(n,o=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,o){let s=E;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||o<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let u,g=0;for(const[I,_]of this._stacks)(!u||g<_)&&(u=I,g=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${g}):`),console.warn(u)}return()=>{const u=this._stacks.get(n.value)||0;this._stacks.set(n.value,u-1)}}}class h{constructor(n){this.value=n}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(n,o,s){this.callback=n,this.callbackThis=o,this.stack=s,this.subscription=new L.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class v{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=E>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(R){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const o of n)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,o,s)=>{this._listeners||(this._listeners=new T.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let u,g;this._leakageMon&&this._listeners.size>=30&&(g=h.create(),u=this._leakageMon.check(g,this._listeners.size+1)),R&&(g=g??h.create());const I=new m(n,o,g),_=this._listeners.push(I);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,o);const O=I.subscription.set(()=>{u&&u(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof L.DisposableStore?s.add(O):Array.isArray(s)&&s.push(O),O}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,n]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,s]=this._deliveryQueue.shift();try{o.invoke(s)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class l extends v{async fireAsync(n,o,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,n]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[a,u]=this._asyncDeliveryQueue.shift(),g=[],I={...u,token:o,waitUntil:_=>{if(Object.isFrozen(g))throw new Error("waitUntil can NOT be called asynchronous");s&&(_=s(_,a.callback)),g.push(_)}};try{a.invoke(I)}catch(_){(0,k.onUnexpectedError)(_);continue}Object.freeze(g),await Promise.allSettled(g).then(_=>{for(const O of _)O.status==="rejected"&&(0,k.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=l;class w extends v{constructor(n){super(n);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=w;class S extends w{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=S;class y extends v{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const o={event:n,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const s=()=>{this.hasListeners&&this.unhook(o);const a=this.events.indexOf(o);this.events.splice(a,1)};return(0,L.toDisposable)((0,t.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(o=>this.emitter.fire(o))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class i{constructor(){this.buffers=[]}wrapEvent(n){return(o,s,a)=>n(u=>{const g=this.buffers[this.buffers.length-1];g?g.push(()=>o.call(s,u)):o.call(s,u)},void 0,a)}bufferEvents(n){const o=[];this.buffers.push(o);const s=n();return this.buffers.pop(),o.forEach(a=>a()),s}}e.EventBufferer=i;class c{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=L.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(te[25],ne([0,1,3]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(R,C){const b=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(b)}}});var L;(function(R){function C(b){return b===R.None||b===R.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(te[106],ne([0,1,25]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new k.CancellationTokenSource,R=this.task(A.token);return this.result={promise:R,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=t;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const R=JSON.stringify(A);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(te[40],ne([0,1,9,2]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(S){const y=S;return y?[y.on,y.pause,y.resume,y.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=L;function T(S){const y=S;return y?L(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(S,y){return new R(S,y)}e.newWriteableStream=A;class R{constructor(y,d){this.reducer=y,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(y){if(!this.state.destroyed){if(this.state.flowing)this.emitData(y);else if(this.buffer.data.push(y),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(y){this.state.destroyed||(this.state.flowing?this.emitError(y):this.buffer.error.push(y))}end(y){this.state.destroyed||(typeof y!="undefined"&&this.write(y),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(y){this.listeners.data.slice(0).forEach(d=>d(y))}emitError(y){this.listeners.error.length===0?(0,k.onUnexpectedError)(y):this.listeners.error.slice(0).forEach(d=>d(y))}emitEnd(){this.listeners.end.slice(0).forEach(y=>y())}on(y,d){if(!this.state.destroyed)switch(y){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(y,d){if(this.state.destroyed)return;let i;switch(y){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const c=i.indexOf(d);c>=0&&i.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const y=this.reducer(this.buffer.data);this.emitData(y),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const y of this.buffer.error)this.emitError(y);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(S,y){const d=[];let i;for(;(i=S.read())!==null;)d.push(i);return y(d)}e.consumeReadable=C;function b(S,y,d){const i=[];let c;for(;(c=S.read())!==null&&i.length<d;)i.push(c);return c===null&&i.length>0?y(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c!="undefined"){const r=c;return c=void 0,r}return S.read()}}}e.peekReadable=b;function P(S,y){return new Promise((d,i)=>{const c=[];E(S,{onData:r=>{y&&c.push(r)},onError:r=>{y?i(r):d(void 0)},onEnd:()=>{d(y?y(c):void 0)}})})}e.consumeStream=P;function E(S,y){let d=!1;return S.on("error",i=>{d||y.onError(i)}),S.on("end",()=>{d||y.onEnd()}),S.on("data",i=>{d||y.onData(i)}),(0,t.toDisposable)(()=>d=!0)}e.listenStream=E;function f(S,y){return new Promise((d,i)=>{const c=new t.DisposableStore,r=[],n=a=>{if(r.push(a),r.length>y)return c.dispose(),S.pause(),d({stream:S,buffer:r,ended:!1})},o=a=>i(a),s=()=>d({stream:S,buffer:r,ended:!0});c.add((0,t.toDisposable)(()=>S.removeListener("error",o))),S.on("error",o),c.add((0,t.toDisposable)(()=>S.removeListener("end",s))),S.on("end",s),c.add((0,t.toDisposable)(()=>S.removeListener("data",n))),S.on("data",n)})}e.peekStream=f;function p(S,y){const d=A(y);return d.end(S),d}e.toStream=p;function h(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=h;function m(S){let y=!1;return{read:()=>y?null:(y=!0,S)}}e.toReadable=m;function v(S,y,d){const i=A(d);return E(S,{onData:c=>i.write(y.data(c)),onError:c=>i.error(y.error?y.error(c):c),onEnd:()=>i.end()}),i}e.transform=v;function l(S,y,d){let i=!1;return{read:()=>{const c=y.read();return i?c:(i=!0,c!==null?d([S,c]):S)}}}e.prefixedReadable=l;function w(S,y,d){let i=!1;const c=A(d);return E(y,{onData:r=>i?c.write(r):(i=!0,c.write(d([S,r]))),onError:r=>c.error(r),onEnd:()=>{i||(i=!0,c.write(S)),c.end()}}),c}e.prefixedStream=w}),define(te[17],ne([0,1,40]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let L,T;class A{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new A(Buffer.allocUnsafe(u)):new A(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new A(u)}static fromString(u,g){return!(g?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(u)):(L||(L=new TextEncoder),new A(L.encode(u)))}static fromByteArray(u){const g=A.alloc(u.length);for(let I=0,_=u.length;I<_;I++)g.buffer[I]=u[I];return g}static concat(u,g){if(typeof g=="undefined"){g=0;for(let O=0,M=u.length;O<M;O++)g+=u[O].byteLength}const I=A.alloc(g);let _=0;for(let O=0,M=u.length;O<M;O++){const D=u[O];I.set(D,_),_+=D.byteLength}return I}clone(){const u=A.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(u,g){return new A(this.buffer.subarray(u,g))}set(u,g){if(u instanceof A)this.buffer.set(u.buffer,g);else if(u instanceof Uint8Array)this.buffer.set(u,g);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),g);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return b(this.buffer,u)}writeUInt32BE(u,g){P(this.buffer,u,g)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,g){f(this.buffer,u,g)}readUInt8(u){return p(this.buffer,u)}writeUInt8(u,g){h(this.buffer,u,g)}}e.VSBuffer=A;function R(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=R;function C(a,u,g){a[g+0]=u&255,u=u>>>8,a[g+1]=u&255}e.writeUInt16LE=C;function b(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=b;function P(a,u,g){a[g+3]=u,u=u>>>8,a[g+2]=u,u=u>>>8,a[g+1]=u,u=u>>>8,a[g]=u}e.writeUInt32BE=P;function E(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=E;function f(a,u,g){a[g+0]=u&255,u=u>>>8,a[g+1]=u&255,u=u>>>8,a[g+2]=u&255,u=u>>>8,a[g+3]=u&255}e.writeUInt32LE=f;function p(a,u){return a[u]}e.readUInt8=p;function h(a,u,g){a[g]=u}e.writeUInt8=h;function m(a){return k.consumeReadable(a,u=>A.concat(u))}e.readableToBuffer=m;function v(a){return k.toReadable(a)}e.bufferToReadable=v;function l(a){return k.consumeStream(a,u=>A.concat(u))}e.streamToBuffer=l;async function w(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=w;function S(a){return k.toStream(a,u=>A.concat(u))}e.bufferToStream=S;function y(a){return k.transform(a,{data:u=>typeof u=="string"?A.fromString(u):A.wrap(u)},u=>A.concat(u))}e.streamToBufferReadableStream=y;function d(a){return k.newWriteableStream(u=>A.concat(u),a)}e.newWriteableBufferStream=d;function i(a,u){return k.prefixedReadable(a,u,g=>A.concat(g))}e.prefixedBufferReadable=i;function c(a,u){return k.prefixedStream(a,u,g=>A.concat(g))}e.prefixedBufferStream=c;function r(a){let u=0,g=0,I=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=D=>{switch(g){case 3:_[I++]=u|D,g=0;break;case 2:_[I++]=u|D>>>2,u=D<<6,g=3;break;case 1:_[I++]=u|D>>>4,u=D<<4,g=2;break;default:u=D<<2,g=1}};for(let D=0;D<a.length;D++){const U=a.charCodeAt(D);if(U>=65&&U<=90)O(U-65);else if(U>=97&&U<=122)O(U-97+26);else if(U>=48&&U<=57)O(U-48+52);else if(U===43||U===45)O(62);else if(U===47||U===95)O(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${a[D]}`)}}const M=I;for(;g>0;)O(0);return A.wrap(_).slice(0,M)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},u=!0,g=!1){const I=g?o:n;let _="";const O=a.byteLength%3;let M=0;for(;M<a.byteLength-O;M+=3){const D=a[M+0],U=a[M+1],z=a[M+2];_+=I[D>>>2],_+=I[(D<<4|U>>>4)&63],_+=I[(U<<2|z>>>6)&63],_+=I[z&63]}if(O===1){const D=a[M+0];_+=I[D>>>2],_+=I[D<<4&63],u&&(_+="==")}else if(O===2){const D=a[M+0],U=a[M+1];_+=I[D>>>2],_+=I[(D<<4|U>>>4)&63],_+=I[U<<2&63],u&&(_+="=")}return _}e.encodeBase64=s}),define(te[26],ne([0,1,106,100]),function(Y,e,k,t){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function R(X,...oe){return oe.length===0?X:X.replace(A,function(le,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?le:oe[me]})}e.format=R;const C=/{([^}]+)}/g;function b(X,oe){return X.replace(C,(le,fe)=>oe[fe]??le)}e.format2=b;function P(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function E(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function f(X,oe){let le=0;const fe=oe.charCodeAt(0);for(let me=X.length-1;me>=0;me--)X.charCodeAt(me)===fe&&le++;return le}e.count=f;function p(X,oe,le="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${le}`}e.truncate=p;function h(X,oe=" "){const le=m(X,oe);return v(le,oe)}e.trim=h;function m(X,oe){if(!X||!oe)return X;const le=oe.length;if(le===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+le;return X.substring(fe)}e.ltrim=m;function v(X,oe){if(!X||!oe)return X;const le=oe.length,fe=X.length;if(le===0||fe===0)return X;let me=fe,Le=-1;for(;Le=X.lastIndexOf(oe,me-1),!(Le===-1||Le+le!==me);){if(Le===0)return"";me=Le}return X.substring(0,me)}e.rtrim=v;function l(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function w(X){return X.replace(/\*/g,"")}e.stripWildcards=w;function S(X,oe,le={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=E(X)),le.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=S;function y(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function d(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function i(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=i;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function r(X){for(let oe=0,le=X.length;oe<le;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function n(X,oe=0,le=X.length){for(let fe=oe;fe<le;fe++){const me=X.charCodeAt(fe);if(me!==32&&me!==9)return X.substring(oe,fe)}return X.substring(oe,le)}e.getLeadingWhitespace=n;function o(X,oe=X.length-1){for(let le=oe;le>=0;le--){const fe=X.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function s(X,oe){return X<oe?-1:X>oe?1:0}e.compare=s;function a(X,oe,le=0,fe=X.length,me=0,Le=oe.length){for(;le<fe&&me<Le;le++,me++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(me);if(ke<Pe)return-1;if(ke>Pe)return 1}const ye=fe-le,Re=Le-me;return ye<Re?-1:ye>Re?1:0}e.compareSubstring=a;function u(X,oe){return g(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=u;function g(X,oe,le=0,fe=X.length,me=0,Le=oe.length){for(;le<fe&&me<Le;le++,me++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(me);if(ke===Pe)continue;if(ke>=128||Pe>=128)return a(X.toLowerCase(),oe.toLowerCase(),le,fe,me,Le);I(ke)&&(ke-=32),I(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const ye=fe-le,Re=Le-me;return ye<Re?-1:ye>Re?1:0}e.compareSubstringIgnoreCase=g;function I(X){return X>=97&&X<=122}e.isLowerAsciiLetter=I;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function O(X,oe){return X.length===oe.length&&g(X,oe)===0}e.equalsIgnoreCase=O;function M(X,oe){const le=oe.length;return oe.length>X.length?!1:g(X,oe,0,le)===0}e.startsWithIgnoreCase=M;function D(X,oe){let le,fe=Math.min(X.length,oe.length);for(le=0;le<fe;le++)if(X.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=D;function U(X,oe){let le,fe=Math.min(X.length,oe.length);const me=X.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(X.charCodeAt(me-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=U;function z(X){return 55296<=X&&X<=56319}e.isHighSurrogate=z;function B(X){return 56320<=X&&X<=57343}e.isLowSurrogate=B;function q(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=q;function G(X,oe,le){const fe=X.charCodeAt(le);if(z(fe)&&le+1<oe){const me=X.charCodeAt(le+1);if(B(me))return q(fe,me)}return fe}e.getNextCodePoint=G;function re(X,oe){const le=X.charCodeAt(oe-1);if(B(le)&&oe>1){const fe=X.charCodeAt(oe-2);if(z(fe))return q(fe,le)}return le}class H{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=re(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=H;class j{constructor(oe,le=0){this._iterator=new H(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ce.getInstance(),le=this._iterator,fe=le.offset;let me=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,ye=oe.getGraphemeBreakType(le.nextCodePoint());if(Be(me,ye)){le.setOffset(Le);break}me=ye}return le.offset-fe}prevGraphemeLength(){const oe=ce.getInstance(),le=this._iterator,fe=le.offset;let me=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,ye=oe.getGraphemeBreakType(le.prevCodePoint());if(Be(ye,me)){le.setOffset(Le);break}me=ye}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function Q(X,oe){return new j(X,oe).nextGraphemeLength()}e.nextCharLength=Q;function x(X,oe){return new j(X,oe).prevGraphemeLength()}e.prevCharLength=x;function J(X,oe){oe>0&&B(X.charCodeAt(oe))&&oe--;const le=oe+Q(X,oe);return[le-x(X,le),le]}e.getCharContainingOffset=J;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(X){return Z.test(X)}e.containsRTL=W;const F=/^[\t\n\r\x20-\x7E]*$/;function N(X){return F.test(X)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=$;function V(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=V;function ee(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=ee;function se(X,oe){if(X.length<oe)return X;const le=/\b/g;let fe=0;for(;le.test(X)&&!(X.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ae=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(X){return X&&(X=X.replace(ae,""),X=X.replace(de,""),X=X.replace(ge,"")),X}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function pe(X){return Se(X)?X.substr(1):X}e.stripUTF8BOM=pe;function Ie(X,oe){if(!X||!oe||X.length<oe.length)return!1;const le=oe.length,fe=X.toLowerCase();let me=0,Le=-1;for(;me<le;){const ye=fe.indexOf(oe[me],Le+1);if(ye<0)return!1;Le=ye,me++}return!0}e.fuzzyContains=Ie;function Ce(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ce;function De(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=De;function Ue(X,oe=1){if(oe===0)return"";let le=-1;do le=X.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?X:(X[le-1]==="\r"&&le--,X.substr(0,le))}e.getNLines=Ue;function je(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=je;function Ge(X){return ce.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ge;function Be(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var ie;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ce{constructor(){this._data=ue()}static getInstance(){return ce._INSTANCE||(ce._INSTANCE=new ce),ce._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let me=1;for(;me<=fe;)if(oe<le[3*me])me=2*me;else if(oe>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ce._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(X,oe){if(X===0)return 0;const le=be(X,oe);if(le!==void 0)return le;const fe=new H(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=we;function be(X,oe){const le=new H(oe,X);let fe=le.prevCodePoint();for(;Fe(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!ee(fe))return;let me=le.offset;return me>0&&le.prevCodePoint()===8205&&(me=le.offset),me}function Fe(X){return 127995<=X&&X<=127999}var Te;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new k.LRUCachedComputed(X=>{function oe(Pe){const Ae=new Map;for(let Ne=0;Ne<Pe.length;Ne+=2)Ae.set(Pe[Ne],Pe[Ne+1]);return Ae}function le(Pe,Ae){const Ne=new Map(Pe);for(const[We,qe]of Ae)Ne.set(We,qe);return Ne}function fe(Pe,Ae){if(!Pe)return Ae;const Ne=new Map;for(const[We,qe]of Pe)Ae.has(We)&&Ne.set(We,qe);return Ne}const me=L.ambiguousCharacterData.getValue();let Le=X.filter(Pe=>!Pe.startsWith("_")&&Pe in me);Le.length===0&&(Le=["_default"]);let ye;for(const Pe of Le){const Ae=oe(me[Pe]);ye=fe(ye,Ae)}const Re=oe(me._common),ke=le(Re,ye);return new Oe(ke)}),Oe._locales=new t.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(te[71],ne([0,1,26]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(l){return L(l,0)}e.hash=t;function L(l,w){switch(typeof l){case"object":return l===null?T(349,w):Array.isArray(l)?C(l,w):b(l,w);case"string":return R(l,w);case"boolean":return A(l,w);case"number":return T(l,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=L;function T(l,w){return(w<<5)-w+l|0}e.numberHash=T;function A(l,w){return T(l?433:863,w)}function R(l,w){w=T(149417,w);for(let S=0,y=l.length;S<y;S++)w=T(l.charCodeAt(S),w);return w}e.stringHash=R;function C(l,w){return w=T(104579,w),l.reduce((S,y)=>L(y,S),w)}function b(l,w){return w=T(181387,w),Object.keys(l).sort().reduce((S,y)=>(S=R(y,S),L(l[y],S)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=P;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f(l,w,S=32){const y=S-w,d=~((1<<y)-1);return(l<<w|(d&l)>>>y)>>>0}function p(l,w=0,S=l.byteLength,y=0){for(let d=0;d<S;d++)l[w+d]=y}function h(l,w,S="0"){for(;l.length<w;)l=S+l;return l}function m(l,w=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(S=>S.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),w/4)}e.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const S=w.length;if(S===0)return;const y=this._buff;let d=this._buffLen,i=this._leftoverHighSurrogate,c,r;for(i!==0?(c=i,r=-1,i=0):(c=w.charCodeAt(0),r=0);;){let n=c;if(k.isHighSurrogate(c))if(r+1<S){const o=w.charCodeAt(r+1);k.isLowSurrogate(o)?(r++,n=k.computeCodePoint(c,o)):n=65533}else{i=c;break}else k.isLowSurrogate(c)&&(n=65533);if(d=this._push(y,d,n),r++,r<S)c=w.charCodeAt(r);else break}this._buffLen=d,this._leftoverHighSurrogate=i}_push(w,S,y){return y<128?w[S++]=y:y<2048?(w[S++]=192|(y&1984)>>>6,w[S++]=128|(y&63)>>>0):y<65536?(w[S++]=224|(y&61440)>>>12,w[S++]=128|(y&4032)>>>6,w[S++]=128|(y&63)>>>0):(w[S++]=240|(y&1835008)>>>18,w[S++]=128|(y&258048)>>>12,w[S++]=128|(y&4032)>>>6,w[S++]=128|(y&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,S=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,S.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,f(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let y=this._h0,d=this._h1,i=this._h2,c=this._h3,r=this._h4,n,o,s;for(let a=0;a<80;a++)a<20?(n=d&i|~d&c,o=1518500249):a<40?(n=d^i^c,o=1859775393):a<60?(n=d&i|d&c|i&c,o=2400959708):(n=d^i^c,o=3395469782),s=f(y,5)+n+r+o+w.getUint32(a*4,!1)&4294967295,r=c,c=i,i=f(d,30),d=y,y=s;this._h0=this._h0+y&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(Y,e,k,t,L){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?L.call(Y,k):L?L.value=k:e.set(Y,k),k},He=this&&this.__classPrivateFieldGet||function(Y,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(Y):t?t.value:e.get(Y)};define(te[39],ne([0,1,16,26]),function(Y,e,k,t){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(r,n,o){let s=r.get(n);return s===void 0&&(s=o,r.set(n,s)),s}e.getOrSet=R;function C(r){const n=[];return r.forEach((o,s)=>{n.push(`${s} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=C;function b(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=b;class P{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class f{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(v||(v={}));class l{constructor(n){this._iter=n}static forUris(n=()=>!1){return new l(new h(n))}static forPaths(n=!1){return new l(new f(void 0,!n))}static forStrings(){return new l(new P)}static forConfigKeys(){return new l(new E)}clear(){this._root=void 0}fill(n,o){if(o){const s=o.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a,n)}else{const s=n.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(n,o){const s=this._iter.reset(n);let a;this._root||(this._root=new m,this._root.segment=s.value());const u=[];for(a=this._root;;){const I=s.cmp(a.segment);if(I>0)a.left||(a.left=new m,a.left.segment=s.value()),u.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new m,a.right.segment=s.value()),u.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new m,a.mid.segment=s.value()),u.push([0,a]),a=a.mid;else break}const g=a.value;a.value=o,a.key=n;for(let I=u.length-1;I>=0;I--){const _=u[I][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const M=u[I][0],D=u[I+1][0];if(M===1&&D===1)u[I][1]=_.rotateLeft();else if(M===-1&&D===-1)u[I][1]=_.rotateRight();else if(M===1&&D===-1)_.right=u[I+1][1]=u[I+1][1].rotateRight(),u[I][1]=_.rotateLeft();else if(M===-1&&D===1)_.left=u[I+1][1]=u[I+1][1].rotateLeft(),u[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(u[I-1][0]){case-1:u[I-1][1].left=u[I][1];break;case 1:u[I-1][1].right=u[I][1];break;case 0:u[I-1][1].mid=u[I][1];break}else this._root=u[0][1]}}return g}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const s=this._iter.reset(n),a=[];let u=this._root;for(;u;){const g=s.cmp(u.segment);if(g>0)a.push([-1,u]),u=u.left;else if(g<0)a.push([1,u]),u=u.right;else if(s.hasNext())s.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(o?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this._min(u.right),{key:I,value:_,segment:O}=g;this._delete(g.key,!1),u.key=I,u.value=_,u.segment=O}else{const g=u.left??u.right;if(a.length>0){const[I,_]=a[a.length-1];switch(I){case-1:_.left=g;break;case 0:_.mid=g;break;case 1:_.right=g;break}}else this._root=g}for(let g=a.length-1;g>=0;g--){const I=a[g][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[g][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[g][1]=I.rotateRight()),g>0)switch(a[g-1][0]){case-1:a[g-1][1].left=a[g][1];break;case 1:a[g-1][1].right=a[g][1];break;case 0:a[g-1][1].mid=a[g][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let s=this._root,a;for(;s;){const u=o.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(o.hasNext())o.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(n){const o=this._iter.reset(n);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[o,s]of this)n(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=l;class w{constructor(n,o){this.uri=n,this.value=o}}class S{constructor(n,o){this[L]="ResourceMap",n instanceof S?(this.map=new Map(n.map),this.toKey=o??S.defaultToKey):(this.map=new Map,this.toKey=n??S.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new w(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[s,a]of this.map)n(a.value,a.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=S,S.defaultToKey=r=>r.toString();var y;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class d{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const s=this._map.get(n);if(!!s)return o!==0&&this.touch(s,o),s.value}set(n,o,s=0){let a=this._map.get(n);if(a)a.value=o,s!==0&&this.touch(a,s);else{switch(a={key:n,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const s=this._state;let a=this._head;for(;a;){if(o?n.bind(o)(a.value,a.key,this):n(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.key,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}values(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.value,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}entries(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:[s.key,s.value],done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>n;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,s=n.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const s=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const s=n.next,a=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,s)=>{n.push([s,o])}),n}fromJSON(n){this.clear();for(const[o,s]of n)this.set(o,s)}}e.LinkedMap=d;class i extends d{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class c{constructor(n){A.set(this,void 0),It(this,A,n,"f")}get size(){return He(this,A,"f").size}forEach(n,o){He(this,A,"f").forEach(n,o)}get(n){return He(this,A,"f").get(n)}has(n){return He(this,A,"f").has(n)}entries(){return He(this,A,"f").entries()}keys(){return He(this,A,"f").keys()}values(){return He(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return He(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(te[72],ne([0,1,39]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function L(b){return C(b,"NFC",t)}e.normalizeNFC=L;const T=new k.LRUCache(1e4);function A(b){return C(b,"NFD",T)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function C(b,P,E){if(!b)return b;const f=E.get(b);if(f)return f;let p;return R.test(b)?p=b.normalize(P):p=b,E.set(b,p),p}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(P){return A(P).replace(b,"")}}()}),define(te[11],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(s){return Array.isArray(s)}e.isArray=k;function t(s){return typeof s=="string"}e.isString=t;function L(s){return Array.isArray(s)&&s.every(a=>t(a))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function C(s){return s===!0||s===!1}e.isBoolean=C;function b(s){return typeof s=="undefined"}e.isUndefined=b;function P(s){return!E(s)}e.isDefined=P;function E(s){return b(s)||s===null}e.isUndefinedOrNull=E;function f(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=f;function p(s){if(E(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=p;function h(...s){const a=[];for(let u=0;u<s.length;u++){const g=s[u];if(E(g))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(g)}return a}e.assertAllDefined=h;const m=Object.prototype.hasOwnProperty;function v(s){if(!T(s))return!1;for(let a in s)if(m.call(s,a))return!1;return!0}e.isEmptyObject=v;function l(s){return typeof s=="function"}e.isFunction=l;function w(...s){return s.length>0&&s.every(l)}e.areFunctions=w;function S(s,a){const u=Math.min(s.length,a.length);for(let g=0;g<u;g++)y(s[g],a[g])}e.validateConstraints=S;function y(s,a){if(t(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(l(a)){try{if(s instanceof a)return}catch{}if(!E(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function d(s){let a=[],u=Object.getPrototypeOf(s);for(;Object.prototype!==u;)a=a.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return a}e.getAllPropertyNames=d;function i(s){const a=[];for(const u of d(s))typeof s[u]=="function"&&a.push(u);return a}e.getAllMethodNames=i;function c(s,a){const u=I=>function(){const _=Array.prototype.slice.call(arguments,0);return a(I,_)};let g={};for(const I of s)g[I]=u(I);return g}e.createProxyObject=c;function r(s){return s===null?void 0:s}e.withNullAsUndefined=r;function n(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=n;function o(s,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(te[41],ne([0,1,10,4,26,11]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function R(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function C(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=C;function b(o,s=k.posix.sep){if(!o)return"";const a=o.length,u=o.charCodeAt(0);if(A(u)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let I=3;const _=I;for(;I<a&&!A(o.charCodeAt(I));I++);if(_!==I&&!A(o.charCodeAt(I+1))){for(I+=1;I<a;I++)if(A(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,s)}}return s}else if(l(u)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(A(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=b;function P(o){if(!t.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const u=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(u===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=P;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,s=t.isWindows){const a=s?E:f;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&p.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function m(o,s,a){const u=o===s;return!a||u?u:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=m;function v(o,s,a,u=k.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let I=s.length;return s.charAt(s.length-1)===u&&I--,o.charAt(I)===u}return s.charAt(s.length-1)!==u&&(s+=u),o.indexOf(s)===0}e.isEqualOrParent=v;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function w(o,s){return t.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(s,o)),o=(0,k.normalize)(o),t.isWindows?(o=(0,L.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,L.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=w;function S(o){const s=(0,k.normalize)(o);return t.isWindows?o.length>3?!1:y(s)&&(o.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=S;function y(o,s){return(s!==void 0?s:t.isWindows)?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function d(o){return y(o)?o[0]:void 0}e.getDriveLetter=d;function i(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=i;function c(o){const s=o.split(":");let a,u,g;for(const I of s){const _=Number(I);(0,T.isNumber)(_)?u===void 0?u=_:g===void 0&&(g=_):a=a?[a,I].join(":"):I}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:g!==void 0?g:u!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,s,a=8){let u="";for(let I=0;I<a;I++)u+=r.charAt(Math.floor(Math.random()*r.length));let g;return s?g=`${s}-${u}`:g=u,o?(0,k.join)(o,g):g}e.randomPath=n}),define(te[28],ne([0,1,11]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(l=>{m[l]&&typeof m[l]=="object"?v[l]=t(m[l]):v[l]=m[l]}),v}e.deepClone=t;function L(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const l=v.shift();Object.freeze(l);for(const w in l)if(T.call(l,w)){const S=l[w];typeof S=="object"&&!Object.isFrozen(S)&&v.push(S)}}return m}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(m,v){return R(m,v,new Set)}e.cloneAndChange=A;function R(m,v,l){if((0,k.isUndefinedOrNull)(m))return m;const w=v(m);if(typeof w!="undefined")return w;if((0,k.isArray)(m)){const S=[];for(const y of m)S.push(R(y,v,l));return S}if((0,k.isObject)(m)){if(l.has(m))throw new Error("Cannot clone recursive data-structure");l.add(m);const S={};for(let y in m)T.call(m,y)&&(S[y]=R(m[y],v,l));return l.delete(m),S}return m}function C(m,v,l=!0){return(0,k.isObject)(m)?((0,k.isObject)(v)&&Object.keys(v).forEach(w=>{w in m?l&&((0,k.isObject)(m[w])&&(0,k.isObject)(v[w])?C(m[w],v[w],l):m[w]=v[w]):m[w]=v[w]}),m):v}e.mixin=C;function b(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let l,w;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(l=0;l<m.length;l++)if(!b(m[l],v[l]))return!1}else{const S=[];for(w in m)S.push(w);S.sort();const y=[];for(w in v)y.push(w);if(y.sort(),!b(S,y))return!1;for(l=0;l<S.length;l++)if(!b(m[S[l]],v[S[l]]))return!1}return!0}e.equals=b;function P(m){const v=new Set;return JSON.stringify(m,(l,w)=>{if((0,k.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=P;function E(m,v,l){const w=v(m);return typeof w=="undefined"?l:w}e.getOrDefault=E;function f(m,v){const l=Object.create(null);return!m||!v||Object.keys(v).forEach(S=>{const y=m[S],d=v[S];b(y,d)||(l[S]=d)}),l}e.distinct=f;function p(m,v){const l=v.toLowerCase(),w=Object.keys(m).find(S=>S.toLowerCase()===l);return w?m[w]:m[v]}e.getCaseInsensitive=p;function h(m,v){const l=Object.create(null);for(const[w,S]of Object.entries(m))v(w,S)&&(l[w]=S);return l}e.filter=h}),define(te[7],ne([0,1,10,4]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function R(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!L.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(r,n){return!r&&!n?"file":r}function b(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const P="",E="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,o,s,a,u,g=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=C(n,g),this.authority=o||P,this.path=b(this.scheme,s||P),this.query=a||P,this.fragment=u||P,R(this,g))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return S(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:s,path:a,query:u,fragment:g}=n;return o===void 0?o=this.scheme:o===null&&(o=P),s===void 0?s=this.authority:s===null&&(s=P),a===void 0?a=this.path:a===null&&(a=P),u===void 0?u=this.query:u===null&&(u=P),g===void 0?g=this.fragment:g===null&&(g=P),o===this.scheme&&s===this.authority&&a===this.path&&u===this.query&&g===this.fragment?this:new m(o,s,a,u,g)}static parse(n,o=!1){const s=f.exec(n);return s?new m(s[2]||P,c(s[4]||P),c(s[5]||P),c(s[7]||P),c(s[9]||P),o):new m(P,P,P,P,P)}static file(n){let o=P;if(t.isWindows&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const s=n.indexOf(E,2);s===-1?(o=n.substring(2),n=E):(o=n.substring(2,s),n=n.substring(s)||E)}return new m("file",o,n,P,P)}static from(n){const o=new m(n.scheme,n.authority,n.path,n.query,n.fragment);return R(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&n.scheme==="file"?s=p.file(k.win32.join(S(n,!0),...o)).path:s=k.posix.join(n.path,...o),n.with({path:s})}toString(n=!1){return y(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const o=new m(n);return o._formatted=n.external,o._fsPath=n._sep===h?n.fsPath:null,o}}else return n}}e.URI=p;const h=t.isWindows?1:void 0;class m extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(n=!1){return n?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(r,n){let o,s=-1;for(let a=0;a<r.length;a++){const u=r.charCodeAt(a);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||n&&u===47)s!==-1&&(o+=encodeURIComponent(r.substring(s,a)),s=-1),o!==void 0&&(o+=r.charAt(a));else{o===void 0&&(o=r.substr(0,a));const g=v[u];g!==void 0?(s!==-1&&(o+=encodeURIComponent(r.substring(s,a)),s=-1),o+=g):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(r.substring(s))),o!==void 0?o:r}function w(r){let n;for(let o=0;o<r.length;o++){const s=r.charCodeAt(o);s===35||s===63?(n===void 0&&(n=r.substr(0,o)),n+=v[s]):n!==void 0&&(n+=r[o])}return n!==void 0?n:r}function S(r,n){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=S;function y(r,n){const o=n?w:l;let s="",{scheme:a,authority:u,path:g,query:I,fragment:_}=r;if(a&&(s+=a,s+=":"),(u||a==="file")&&(s+=E,s+=E),u){let O=u.indexOf("@");if(O!==-1){const M=u.substr(0,O);u=u.substr(O+1),O=M.indexOf(":"),O===-1?s+=o(M,!1):(s+=o(M.substr(0,O),!1),s+=":",s+=o(M.substr(O+1),!1)),s+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?s+=o(u,!1):(s+=o(u.substr(0,O),!1),s+=u.substr(O))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const O=g.charCodeAt(1);O>=65&&O<=90&&(g=`/${String.fromCharCode(O+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const O=g.charCodeAt(0);O>=65&&O<=90&&(g=`${String.fromCharCode(O+32)}:${g.substr(2)}`)}s+=o(g,!0)}return I&&(s+="?",s+=o(I,!1)),_&&(s+="#",s+=n?_:l(_,!1)),s}function d(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+d(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(r){return r.match(i)?r.replace(i,n=>d(n)):r}}),define(te[107],ne([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=t;function L(b){const P=[];let E;try{const f=JSON.parse(b.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),E=p.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:E}}e.parse=L;function T(b){if(typeof b!="string")return T(L(b).stack);const P=b;if(P){const E=A(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:k.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function R(b,P){const{args:E,stack:f}=L(b),p=typeof E[0]=="string"&&E.length===1;let h=A(f);h&&(h=`(${h.trim()})`);let m=[];if(typeof E[0]=="string"?h&&p?m=[`%c[${P}] %c${E[0]} %c${h}`,C("blue"),C(""),C("grey")]:m=[`%c[${P}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:m=[`%c[${P}]%`,C("blue"),...E],h&&!p&&m.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}e.log=R;function C(b){return`color: ${b}`}}),define(te[108],ne([0,1,17,26,7]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(b){return JSON.stringify(b,R)}e.stringify=T;function A(b){let P=JSON.parse(b);return P=C(P),P}e.parse=A;function R(b,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,t.regExpFlags)(P)}:P}function C(b,P=0){if(!b||P>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return L.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof k.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let E=0;E<b.length;++E)b[E]=C(b[E],P+1);else for(const E in b)Object.hasOwnProperty.call(b,E)&&(b[E]=C(b[E],P+1))}return b}e.revive=C}),define(te[18],ne([0,1,4,7]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,b,P){this._hosts[C]=b,this._ports[C]=P}setConnectionToken(C,b){this._connectionTokens[C]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const b=C.authority;let P=this._hosts[b];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const E=this._ports[b],f=this._connectionTokens[b];let p=`path=${encodeURIComponent(C.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class A{asBrowserUri(C,b){t.URI.isUri(C)&&k.isWebWorker&&console.warn("FileAccess.asBrowserUri should not be used in the web worker!");const P=this.toUri(C,b);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(C,b){const P=this.toUri(C,b);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==A.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(C,b){return t.URI.isUri(C)?C:t.URI.parse(b.toUrl(C))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[20],ne([0,1,41,18,10,4,26,7]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=C;class b{constructor(h){this._ignorePathCasing=h}compare(h,m,v=!1){return h===m?0:(0,A.compare)(this.getComparisonKey(h,v),this.getComparisonKey(m,v))}isEqual(h,m,v=!1){return h===m?!0:!h||!m?!1:this.getComparisonKey(h,v)===this.getComparisonKey(m,v)}getComparisonKey(h,m=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,m,v=!1){if(h.scheme===m.scheme){if(h.scheme===t.Schemas.file)return k.isEqualOrParent(C(h),C(m),this._ignorePathCasing(h))&&h.query===m.query&&(v||h.fragment===m.fragment);if((0,e.isEqualAuthority)(h.authority,m.authority))return k.isEqualOrParent(h.path,m.path,this._ignorePathCasing(h),"/")&&h.query===m.query&&(v||h.fragment===m.fragment)}return!1}joinPath(h,...m){return R.URI.joinPath(h,...m)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let m;return h.scheme===t.Schemas.file?m=R.URI.file(L.dirname(C(h))).path:(m=L.posix.dirname(h.path),h.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),m="/")),h.with({path:m})}normalizePath(h){if(!h.path.length)return h;let m;return h.scheme===t.Schemas.file?m=R.URI.file(L.normalize(C(h))).path:m=L.posix.normalize(h.path),h.with({path:m})}relativePath(h,m){if(h.scheme!==m.scheme||!(0,e.isEqualAuthority)(h.authority,m.authority))return;if(h.scheme===t.Schemas.file){const w=L.relative(C(h),C(m));return T.isWindows?k.toSlashes(w):w}let v=h.path||"/",l=m.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const S=Math.min(v.length,l.length);w<S&&!(v.charCodeAt(w)!==l.charCodeAt(w)&&v.charAt(w).toLowerCase()!==l.charAt(w).toLowerCase());w++);v=l.substr(0,w)+v.substr(w)}return L.posix.relative(v,l)}resolvePath(h,m){if(h.scheme===t.Schemas.file){const v=R.URI.file(L.resolve(C(h),m));return h.with({authority:v.authority,path:v.path})}return m=k.toPosixPath(m),h.with({path:L.posix.resolve(h.path,m)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,m){return h===m||h!==void 0&&m!==void 0&&(0,A.equalsIgnoreCase)(h,m)}hasTrailingPathSeparator(h,m=L.sep){if(h.scheme===t.Schemas.file){const v=C(h);return v.length>k.getRoot(v).length&&v[v.length-1]===m}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,m=L.sep){return(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,m=L.sep){let v=!1;if(h.scheme===t.Schemas.file){const l=C(h);v=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===m}else{m="/";const l=h.path;v=l.length===1&&l.charCodeAt(l.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(p=>p.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,h){const m=[];for(let v=0;v<p.length;v++){const l=h(p[v]);p.some((w,S)=>S===v?!1:(0,e.isEqualOrParent)(l,h(w)))||m.push(p[v])}return m}e.distinctParents=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(m){const v=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(S=>{const[y,d]=S.split(":");y&&d&&v.set(y,d)});const w=m.path.substring(0,m.path.indexOf(";"));return w&&v.set(p.META_DATA_MIME,w),v}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function f(p,h,m){if(h){let v=p.path;return v&&v[0]!==L.posix.sep&&(v=L.posix.sep+v),p.with({scheme:m,authority:h,path:v})}return p.with({scheme:m})}e.toLocalResource=f}),define(te[5],ne([0,1,25,9,3,2,20,4]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function b(W){const F=new k.CancellationTokenSource,N=W(F.token),$=new Promise((V,ee)=>{const se=F.token.onCancellationRequested(()=>{se.dispose(),F.dispose(),ee(new t.CancellationError)});Promise.resolve(N).then(ae=>{se.dispose(),F.dispose(),V(ae)},ae=>{se.dispose(),F.dispose(),ee(ae)})});return new class{cancel(){F.cancel()}then(V,ee){return $.then(V,ee)}catch(V){return this.then(void 0,V)}finally(V){return $.finally(V)}}}e.createCancelablePromise=b;function P(W,F,N){return new Promise(($,V)=>{const ee=F.onCancellationRequested(()=>{ee.dispose(),$(N)});W.then($,V).finally(()=>ee.dispose())})}e.raceCancellation=P;function E(W,F){return new Promise((N,$)=>{const V=F.onCancellationRequested(()=>{V.dispose(),$(new t.CancellationError)});W.then(N,$).finally(()=>V.dispose())})}e.raceCancellationError=E;async function f(W){let F=-1;const N=W.map((V,ee)=>V.then(se=>(F=ee,se))),$=await Promise.race(N);return W.forEach((V,ee)=>{ee!==F&&V.cancel()}),$}e.raceCancellablePromises=f;function p(W,F,N){let $;const V=setTimeout(()=>{$?.(void 0),N?.()},F);return Promise.race([W.finally(()=>clearTimeout(V)),new Promise(ee=>$=ee)])}e.raceTimeout=p;function h(W){return new Promise((F,N)=>{const $=W();C($)?$.then(F,N):F($)})}e.asPromise=h;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(N,N).then($)})}return new Promise((N,$)=>{this.queuedPromise.then(N,$)})}return this.activePromise=F(),new Promise((N,$)=>{this.activePromise.then(V=>{this.activePromise=null,N(V)},V=>{this.activePromise=null,$(V)})})}}e.Throttler=m;class v{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=v;class l{constructor(){this.promiseMap=new Map}queue(F,N){const V=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(F)===V&&this.promiseMap.delete(F)});return this.promiseMap.set(F,V),V}}e.SequencerByKey=l;const w=(W,F)=>{let N=!0;const $=setTimeout(()=>{N=!1,F()},W);return{isTriggered:()=>N,dispose:()=>{clearTimeout($),N=!1}}},S=W=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,W())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class y{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,N=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,ee)=>{this.doResolve=V,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?S($):w(N,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=y;class d{constructor(F){this.delayer=new y(F),this.throttler=new m}trigger(F,N){return this.delayer.trigger(()=>this.throttler.queue(F),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class i{constructor(){this._isOpen=!1,this._promise=new Promise((F,N)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class c extends i{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function r(W,F){return F?new Promise((N,$)=>{const V=setTimeout(()=>{ee.dispose(),N()},W),ee=F.onCancellationRequested(()=>{clearTimeout(V),ee.dispose(),$(new t.CancellationError)})}):b(N=>r(W,N))}e.timeout=r;function n(W,F=0){const N=setTimeout(W,F);return(0,T.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=n;function o(W){const F=[];let N=0;const $=W.length;function V(){return N<$?W[N++]():null}function ee(se){se!=null&&F.push(se);const ae=V();return ae?ae.then(ee):Promise.resolve(F)}return Promise.resolve(null).then(ee)}e.sequence=o;function s(W,F=$=>!!$,N=null){let $=0;const V=W.length,ee=()=>{if($>=V)return Promise.resolve(N);const se=W[$++];return Promise.resolve(se()).then(de=>F(de)?Promise.resolve(de):ee())};return ee()}e.first=s;function a(W,F=$=>!!$,N=null){if(W.length===0)return Promise.resolve(N);let $=W.length;const V=()=>{$=-1;for(const ee of W)ee.cancel?.()};return new Promise((ee,se)=>{for(const ae of W)ae.then(de=>{--$>=0&&F(de)?(V(),ee(de)):$===0&&ee(N)}).catch(de=>{--$>=0&&(V(),se(de))})})}e.firstParallel=a;class u{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((N,$)=>{this.outstandingPromises.push({factory:F,c:N,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const N=F.factory();N.then(F.c,F.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class g extends u{constructor(){super(1)}}e.Queue=g;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new H;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,N=A.extUri){const $=N.getComparisonKey(F);let V=this.queues.get($);return V||(V=new g,L.Event.once(V.onFinished)(()=>{V?.dispose(),this.queues.delete($),this.onDidQueueFinish()}),this.queues.set($,V)),V}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(F,N){this._token=-1,typeof F=="function"&&typeof N=="number"&&this.setIfNotSet(F,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},N)}setIfNotSet(F,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},N))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,N){this.cancel(),this._token=setInterval(()=>{F()},N)}}e.IntervalTimer=O;class M{constructor(F,N){this.timeoutToken=-1,this.runner=F,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class D{constructor(F,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class U extends M{constructor(F,N){super(F,N);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class z extends T.Disposable{constructor(F,N){super();this.options=F,this.handler=N,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if(F)return;const N=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(W,F)=>{const N=requestIdleCallback(W,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(N))}}}}();class B{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function q(W,F,N){let $;for(let V=0;V<N;V++)try{return await W()}catch(ee){$=ee,await r(F)}throw $}e.retry=q;class G{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,N,$){return this._pending={taskId:F,cancel:()=>$?.(),promise:N},N.then(()=>this.donePending(F),()=>this.donePending(F)),N}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let N,$;const V=new Promise((ee,se)=>{N=ee,$=se});this._next={run:F,promise:V,promiseResolve:N,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=G;class re{constructor(F,N=()=>Date.now()){this.interval=F,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=re;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,N)=>{this.completeCallback=F,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(N=>{this.completeCallback(F),this.resolved=!0,N()})}error(F){return new Promise(N=>{this.errorCallback(F),this.rejected=!0,N()})}cancel(){new Promise(F=>{this.errorCallback(new t.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=H;var j;(function(W){async function F($){let V;const ee=await Promise.all($.map(se=>se.then(ae=>ae,ae=>{V||(V=ae)})));if(typeof V!="undefined")throw V;return ee}W.settled=F;function N($){return new Promise(async(V,ee)=>{try{await $(V,ee)}catch(se){ee(se)}})}W.withAsyncBody=N})(j=e.Promises||(e.Promises={}));var Q;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(Q||(Q={}));class x{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const N={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(F(N)),this.resolve()}catch($){this.reject($)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(F){return new x(N=>{N.emitMany(F)})}static fromPromise(F){return new x(async N=>{N.emitMany(await F)})}static fromPromises(F){return new x(async N=>{await Promise.all(F.map(async $=>N.emitOne(await $)))})}static merge(F){return new x(async N=>{await Promise.all(F.map(async $=>{for await(const V of $)N.emitOne(V)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,N){return new x(async $=>{for await(const V of F)$.emitOne(N(V))})}map(F){return x.map(this,F)}static filter(F,N){return new x(async $=>{for await(const V of F)N(V)&&$.emitOne(V)})}filter(F){return x.filter(this,F)}static coalesce(F){return x.filter(F,N=>!!N)}coalesce(){return x.coalesce(this)}static async toPromise(F){const N=[];for await(const $ of F)N.push($);return N}toPromise(){return x.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=x,x.EMPTY=x.fromArray([]);class J extends x{constructor(F,N){super(N);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function Z(W){const F=new k.CancellationTokenSource,N=W(F.token);return new J(F,async $=>{const V=F.token.onCancellationRequested(()=>{V.dispose(),F.dispose(),$.reject(new t.CancellationError)});try{for await(const ee of N){if(F.token.isCancellationRequested)return;$.emitOne(ee)}V.dispose(),F.dispose()}catch(ee){V.dispose(),F.dispose(),$.reject(ee)}})}e.createCancelableAsyncIterable=Z}),define(te[109],ne([0,1,5,41,39,10,4,26]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",P="[^/\\\\]",E=/\//g;function f(H){switch(H){case 0:return"";case 1:return`${P}*?`;default:return`(?:${b}|${P}+${b}|${b}${P}+)*?`}}function p(H,j){if(!H)return[];const Q=[];let x=!1,J=!1,Z="";for(const W of H){switch(W){case j:if(!x&&!J){Q.push(Z),Z="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":J=!0;break;case"]":J=!1;break}Z+=W}return Z&&Q.push(Z),Q}e.splitGlobAware=p;function h(H){if(!H)return"";let j="";const Q=p(H,e.GLOB_SPLIT);if(Q.every(x=>x===e.GLOBSTAR))j=".*";else{let x=!1;Q.forEach((J,Z)=>{if(J===e.GLOBSTAR){x||(j+=f(2),x=!0);return}let W=!1,F="",N=!1,$="";for(const V of J){if(V!=="}"&&W){F+=V;continue}if(N&&(V!=="]"||!$)){let ee;V==="-"?ee=V:(V==="^"||V==="!")&&!$?ee="^":V===e.GLOB_SPLIT?ee="":ee=(0,R.escapeRegExpCharacters)(V),$+=ee;continue}switch(V){case"{":W=!0;continue;case"[":N=!0;continue;case"}":{j+=`(?:${p(F,",").map(ae=>h(ae)).join("|")})`,W=!1,F="";break}case"]":j+="["+$+"]",N=!1,$="";break;case"?":j+=P;continue;case"*":j+=f(1);continue;default:j+=(0,R.escapeRegExpCharacters)(V)}}Z<Q.length-1&&(Q[Z+1]!==e.GLOBSTAR||Z+2<Q.length)&&(j+=b),x=!1})}return j}const m=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,d=new L.LRUCache(1e4),i=function(){return!1},c=function(){return null};function r(H,j){if(!H)return c;let Q;typeof H!="string"?Q=H.pattern:Q=H,Q=Q.trim();const x=`${Q}_${!!j.trimForExclusions}`;let J=d.get(x);if(J)return n(J,H);let Z;if(m.test(Q)){const W=Q.substr(4);J=function(F,N){return typeof F=="string"&&F.endsWith(W)?Q:null}}else(Z=v.exec(o(Q,j)))?J=s(Z[1],Q):(j.trimForExclusions?w:l).test(Q)?J=a(Q,j):(Z=S.exec(o(Q,j)))?J=u(Z[1].substr(1),Q,!0):(Z=y.exec(o(Q,j)))?J=u(Z[1],Q,!1):J=g(Q);return d.set(x,J),n(J,H)}function n(H,j){return typeof j=="string"?H:function(Q,x){return(0,t.isEqualOrParent)(Q,j.base,!A.isLinux)?H(Q.substr(j.base.length+1),x):null}}function o(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function s(H,j){const Q=`/${H}`,x=`\\${H}`,J=function(W,F){return typeof W!="string"?null:F?F===H?j:null:W===H||W.endsWith(Q)||W.endsWith(x)?j:null},Z=[H];return J.basenames=Z,J.patterns=[j],J.allBasenames=Z,J}function a(H,j){const Q=re(H.slice(1,-1).split(",").map(F=>r(F,j)).filter(F=>F!==c),H),x=Q.length;if(!x)return c;if(x===1)return Q[0];const J=function(F,N){for(let $=0,V=Q.length;$<V;$++)if(Q[$](F,N))return H;return null},Z=Q.find(F=>!!F.allBasenames);Z&&(J.allBasenames=Z.allBasenames);const W=Q.reduce((F,N)=>N.allPaths?F.concat(N.allPaths):F,[]);return W.length&&(J.allPaths=W),J}function u(H,j,Q){const x=T.sep===T.posix.sep,J=x?H:H.replace(E,T.sep),Z=T.sep+J,W=T.posix.sep+H,F=Q?function(N,$){return typeof N=="string"&&(N===J||N.endsWith(Z)||!x&&(N===H||N.endsWith(W)))?j:null}:function(N,$){return typeof N=="string"&&(N===J||!x&&N===H)?j:null};return F.allPaths=[(Q?"*/":"./")+H],F}function g(H){try{const j=new RegExp(`^${h(H)}$`);return function(Q){return j.lastIndex=0,typeof Q=="string"&&j.test(Q)?H:null}}catch{return c}}function I(H,j,Q){return!H||typeof j!="string"?!1:_(H)(j,void 0,Q)}e.match=I;function _(H,j={}){if(!H)return i;if(typeof H=="string"||U(H)){const Q=r(H,j);if(Q===c)return i;const x=function(J,Z){return!!Q(J,Z)};return Q.allBasenames&&(x.allBasenames=Q.allBasenames),Q.allPaths&&(x.allPaths=Q.allPaths),x}return q(H,j)}e.parse=_;function O(H){if(!H)return;let j;return Q=>(j||(j=(H()||Promise.resolve([])).then(x=>x?D(x):{})),j.then(x=>!!x[Q]))}e.hasSiblingPromiseFn=O;function M(H){if(!H)return;let j;return Q=>{if(!j){const x=H();j=x?D(x):{}}return!!j[Q]}}e.hasSiblingFn=M;function D(H){const j={};for(const Q of H)j[Q]=!0;return j}function U(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=U;function z(H){return H.allBasenames||[]}e.getBasenameTerms=z;function B(H){return H.allPaths||[]}e.getPathTerms=B;function q(H,j){const Q=re(Object.getOwnPropertyNames(H).map(F=>G(F,H[F],j)).filter(F=>F!==c)),x=Q.length;if(!x)return c;if(!Q.some(F=>!!F.requiresSiblings)){if(x===1)return Q[0];const F=function(V,ee){for(let se=0,ae=Q.length;se<ae;se++){const de=Q[se](V,ee);if(de)return de}return null},N=Q.find(V=>!!V.allBasenames);N&&(F.allBasenames=N.allBasenames);const $=Q.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return $.length&&(F.allPaths=$),F}const J=function(F,N,$){let V;for(let ee=0,se=Q.length;ee<se;ee++){const ae=Q[ee];ae.requiresSiblings&&$&&(N||(N=(0,T.basename)(F)),V||(V=N.substr(0,N.length-(0,T.extname)(F).length)));const de=ae(F,N,V,$);if(de)return de}return null},Z=Q.find(F=>!!F.allBasenames);Z&&(J.allBasenames=Z.allBasenames);const W=Q.reduce((F,N)=>N.allPaths?F.concat(N.allPaths):F,[]);return W.length&&(J.allPaths=W),J}function G(H,j,Q){if(j===!1)return c;const x=r(H,Q);if(x===c)return c;if(typeof j=="boolean")return x;if(j){const J=j.when;if(typeof J=="string"){const Z=(W,F,N,$)=>{if(!$||!x(W,F))return null;const V=J.replace("$(basename)",N),ee=$(V);return(0,k.isThenable)(ee)?ee.then(se=>se?H:null):ee?H:null};return Z.requiresSiblings=!0,Z}}return x}function re(H,j){const Q=H.filter(F=>!!F.basenames);if(Q.length<2)return H;const x=Q.reduce((F,N)=>{const $=N.basenames;return $?F.concat($):F},[]);let J;if(j){J=[];for(let F=0,N=x.length;F<N;F++)J.push(j)}else J=Q.reduce((F,N)=>{const $=N.patterns;return $?F.concat($):F},[]);const Z=function(F,N){if(typeof F!="string")return null;if(!N){let V;for(V=F.length;V>0;V--){const ee=F.charCodeAt(V-1);if(ee===47||ee===92)break}N=F.substr(V)}const $=x.indexOf(N);return $!==-1?J[$]:null};Z.basenames=x,Z.patterns=J,Z.allBasenames=x;const W=H.filter(F=>!F.basenames);return W.push(Z),W}}),define(te[110],ne([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(P){return P.toJSON()}class L{constructor(E){this._uriTransformer=E}transformIncoming(E){const f=this._uriTransformer.transformIncoming(E);return f===E?E:t(k.URI.from(f))}transformOutgoing(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:t(k.URI.from(f))}transformOutgoingURI(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:k.URI.from(f)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,E,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof k.URI)return E.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const h=T(P[p],E,f+1);h!==null&&(P[p]=h)}}return null}function A(P,E){const f=T(P,E,0);return f===null?P:f}e.transformOutgoingURIs=A;function R(P,E,f,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?k.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const m=R(P[h],E,f,p+1);m!==null&&(P[h]=m)}}return null}function C(P,E){const f=R(P,E,!1,0);return f===null?P:f}e.transformIncomingURIs=C;function b(P,E){const f=R(P,E,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=b}),define(te[29],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return k.test(C)}e.isUUID=t;const L=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(C){for(let b=0;b<C.length;b++)C[b]=Math.floor(Math.random()*256);return C};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let C=0,b="";return b+=T[L[C++]],b+=T[L[C++]],b+=T[L[C++]],b+=T[L[C++]],b+="-",b+=T[L[C++]],b+=T[L[C++]],b+="-",b+=T[L[C++]],b+=T[L[C++]],b+="-",b+=T[L[C++]],b+=T[L[C++]],b+="-",b+=T[L[C++]],b+=T[L[C++]],b+=T[L[C++]],b+=T[L[C++]],b+=T[L[C++]],b+=T[L[C++]],b}e.generateUuid=R}),define(te[111],ne([0,1,252]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new k.StringDecoder(T),this.remaining=null}write(T){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return A;let C=0,b,P=C;for(;P<R.length;)if(b=R.charCodeAt(P),b===13||b===10){if(A.push(R.substring(C,P)),P++,P<R.length){const E=b;b=R.charCodeAt(P),(E===13&&b===10||E===10&&b===13)&&P++}C=P}else P++;return this.remaining=C<R.length?R.substr(C):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(te[112],ne([0,1,34]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const R=A.replace(/\-/g,":").toLowerCase();return!t.has(R)}function T(){const A=(0,k.networkInterfaces)();for(let R in A){const C=A[R];if(C){for(const{mac:b}of C)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(te[113],ne([0,1,34,9,39,29,112]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,E=0;const f=(0,k.networkInterfaces)();for(let p in f){const h=f[p];if(h)for(const{mac:m,internal:v}of h)v||(E+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(P+=1))}this._value=E>0?P/E:0}return this._value}};let R;async function C(){return R||(R=(async()=>await b()||T.generateUuid())()),R}e.getMachineId=C;async function b(){try{const P=await new Promise((f,p)=>{Y(["crypto"],f,p)}),E=(0,A.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){t.onUnexpectedError(P);return}}}),define(te[22],ne([0,1,50,34,253,5,41,72,10,4,20,7]),function(Y,e,k,t,L,T,A,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p(z,B=f.UNLINK){if((0,A.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return B===f.UNLINK?m(z):h(z)}async function h(z){try{const B=(0,A.randomPath)((0,t.tmpdir)());try{await k.promises.rename(z,B)}catch{return m(z)}m(B).catch(q=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function m(z){return(0,L.promisify)(k.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function v(z){if((0,A.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function l(z,B){return y(await(B?w(z):(0,L.promisify)(k.readdir)(z)))}async function w(z){try{return await(0,L.promisify)(k.readdir)(z,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const B=[],q=await l(z);for(const G of q){let re=!1,H=!1,j=!1;try{const Q=await e.Promises.lstat((0,C.join)(z,G));re=Q.isFile(),H=Q.isDirectory(),j=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}B.push({name:G,isFile:()=>re,isDirectory:()=>H,isSymbolicLink:()=>j})}return B}function S(z){return y(k.readdirSync(z))}e.readdirSync=S;function y(z){return z.map(B=>typeof B=="string"?b.isMacintosh?(0,R.normalizeNFC)(B):B:(B.name=b.isMacintosh?(0,R.normalizeNFC)(B.name):B.name,B))}async function d(z){const B=await l(z),q=[];for(const G of B)await c.existsDirectory((0,C.join)(z,G))&&q.push(G);return q}function i(z,B=1e3){return new Promise(q=>{let G=!1;const re=setInterval(()=>{G||(G=!0,k.access(z,H=>{G=!1,H&&(clearInterval(re),q(void 0))}))},B)})}e.whenDeleted=i;var c;(function(z){async function B(re){let H;try{if(H=await e.Promises.lstat(re),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(re),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(b.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(re)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw Q}throw j}}z.stat=B;async function q(re){try{const{stat:H,symbolicLink:j}=await z.stat(re);return H.isFile()&&j?.dangling!==!0}catch{}return!1}z.existsFile=q;async function G(re){try{const{stat:H,symbolicLink:j}=await z.stat(re);return H.isDirectory()&&j?.dangling!==!0}catch{}return!1}z.existsDirectory=G})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function n(z,B,q){return r.queueFor(E.URI.file(z),P.extUriBiasedIgnorePathCase).queue(()=>{const G=u(q);return new Promise((re,H)=>s(z,B,G,j=>j?H(j):re()))})}let o=!0;function s(z,B,q,G){if(!o)return k.writeFile(z,B,{mode:q.mode,flag:q.flag},G);k.open(z,q.flag,q.mode,(re,H)=>{if(re)return G(re);k.writeFile(H,B,j=>{if(j)return k.close(H,()=>G(j));k.fdatasync(H,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),o=!1),k.close(H,x=>G(x))))})})}function a(z,B,q){const G=u(q);if(!o)return k.writeFileSync(z,B,{mode:G.mode,flag:G.flag});const re=k.openSync(z,G.flag,G.mode);try{k.writeFileSync(re,B);try{k.fdatasyncSync(re)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),o=!1}}finally{k.closeSync(re)}}e.writeFileSync=a;function u(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function g(z,B){if(z!==B)try{await e.Promises.rename(z,B)}catch(q){if(z.toLowerCase()!==B.toLowerCase()&&q.code==="EXDEV"||z.endsWith("."))await I(z,B,{preserveSymlinks:!1}),await p(z,f.MOVE);else throw q}}async function I(z,B,q){return O(z,B,{root:{source:z,target:B},options:q,handledSourcePaths:new Set})}const _=511;async function O(z,B,q){if(q.handledSourcePaths.has(z))return;q.handledSourcePaths.add(z);const{stat:G,symbolicLink:re}=await c.stat(z);if(re){if(q.options.preserveSymlinks)try{return await U(z,B,q)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(re.dangling)return}return G.isDirectory()?M(z,B,G.mode&_,q):D(z,B,G.mode&_)}async function M(z,B,q,G){await e.Promises.mkdir(B,{recursive:!0,mode:q});const re=await l(z);for(const H of re)await O((0,C.join)(z,H),(0,C.join)(B,H),G)}async function D(z,B,q){await e.Promises.copyFile(z,B),await e.Promises.chmod(B,q)}async function U(z,B,q){let G=await e.Promises.readlink(z);(0,A.isEqualOrParent)(G,q.root.source,!b.isLinux)&&(G=(0,C.join)(q.root.target,G.substr(q.root.source.length+1))),await e.Promises.symlink(G,B)}e.Promises=new class{get access(){return(0,L.promisify)(k.access)}get stat(){return(0,L.promisify)(k.stat)}get lstat(){return(0,L.promisify)(k.lstat)}get utimes(){return(0,L.promisify)(k.utimes)}get read(){return(z,B,q,G,re)=>new Promise((H,j)=>{k.read(z,B,q,G,re,(Q,x,J)=>Q?j(Q):H({bytesRead:x,buffer:J}))})}get readFile(){return(0,L.promisify)(k.readFile)}get write(){return(z,B,q,G,re)=>new Promise((H,j)=>{k.write(z,B,q,G,re,(Q,x,J)=>Q?j(Q):H({bytesWritten:x,buffer:J}))})}get appendFile(){return(0,L.promisify)(k.appendFile)}get fdatasync(){return(0,L.promisify)(k.fdatasync)}get truncate(){return(0,L.promisify)(k.truncate)}get rename(){return(0,L.promisify)(k.rename)}get copyFile(){return(0,L.promisify)(k.copyFile)}get open(){return(0,L.promisify)(k.open)}get close(){return(0,L.promisify)(k.close)}get symlink(){return(0,L.promisify)(k.symlink)}get readlink(){return(0,L.promisify)(k.readlink)}get chmod(){return(0,L.promisify)(k.chmod)}get mkdir(){return(0,L.promisify)(k.mkdir)}get unlink(){return(0,L.promisify)(k.unlink)}get rmdir(){return(0,L.promisify)(k.rmdir)}get realpath(){return(0,L.promisify)(k.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return d}get writeFile(){return n}get rm(){return p}get move(){return g}get copy(){return I}}}),define(te[114],ne([0,1,50,10,4,26,22]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const h=((0,t.basename)(f)||f).toLowerCase();try{const v=(0,A.readdirSync)(p).filter(l=>l.toLowerCase()===h);if(v.length===1){const l=R(p);if(l)return(0,t.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(h);if(l>=0){const w=R(p);if(w)return(0,t.join)(w,v[l])}}}catch{}return null}e.realcaseSync=R;async function C(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const h=((0,t.basename)(f)||f).toLowerCase();try{const v=(await A.Promises.readdir(p)).filter(l=>l.toLowerCase()===h);if(v.length===1){const l=await C(p);if(l)return(0,t.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(h);if(l>=0){const w=await C(p);if(w)return(0,t.join)(w,v[l])}}}catch{}return null}e.realcase=C;async function b(f){try{return await A.Promises.realpath(f)}catch{const h=E(f);return await A.Promises.access(h,k.constants.R_OK),h}}e.realpath=b;function P(f){try{return k.realpathSync(f)}catch{const h=E(f);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=P;function E(f){return(0,T.rtrim)((0,t.normalize)(f),t.sep)}}),define(te[115],ne([0,1,56]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(R,C,b,P=1){let E=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!E)return E=!0,f(0)},b);L(R,C,P,h=>{if(!E)return E=!0,clearTimeout(p),f(h)})})}e.findFreePort=t;function L(R,C,b,P){if(C===0)return P(0);const E=new k.Socket;E.once("connect",()=>(A(E),L(R+b,C-1,b,P))),E.once("data",()=>{}),E.once("error",f=>(A(E),f.code!=="ECONNREFUSED"?L(R+b,C-1,b,P):P(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,C,b){let P=!1,E,f=1;const p=k.createServer({pauseOnConnect:!0});function h(m,v){P||(P=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),v(m))}return new Promise(m=>{E=setTimeout(()=>{h(0,m)},b),p.on("listening",()=>{h(R,m)}),p.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&f<C?(R++,f++,p.listen(R,"127.0.0.1")):h(0,m)}),p.on("close",()=>{h(0,m)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(te[73],ne([0,1,34,10,22]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(C||(C={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(d,i,c){this.exePath=d,this.displayName=i,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:y=!1}={}){return y?b===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:y=!1,findPreview:d=!1}={}){const i=f({useAlternateBitness:y});if(!i)return null;const c=t.join(i,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(c))return null;let r=-1,n=null;for(const a of await L.Promises.readdir(c)){let u=-1;if(d){const I=a.indexOf("-");if(I<0)continue;const _=a.substring(0,I);if(!T.test(_)||a.substring(I+1)!=="preview")continue;u=parseInt(_,10)}else{if(!T.test(a))continue;u=parseInt(a,10)}if(u<=r)continue;const g=t.join(c,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(g)||(n=g,r=u)}if(!n)return null;const o=i.includes("x86")?" (x86)":"",s=d?" Preview":"";return new E(n,`PowerShell${s}${o}`,!0)}async function h({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const d=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:i,pwshMsixName:c}=y?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await L.Promises.readdir(d))if(i.test(r)){const n=t.join(d,r,"pwsh.exe");return new E(n,c)}return null}function m(){const y=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(y,".NET Core PowerShell Global Tool")}function v(){const y=t.join(process.env.windir,b===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(y,"Windows PowerShell",!0)}async function*l(){let y=await p();y&&(yield y),y=await p({useAlternateBitness:!0}),y&&(yield y),y=await h(),y&&(yield y),y=m(),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await h({findPreview:!0}),y&&(yield y),y=await p({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=v(),y&&(yield y)}async function*w(){for await(const y of l())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=w;async function S(){for await(const y of w())return y;return null}e.getFirstAvailablePowerShellInstallation=S}),define(te[116],ne([0,1,46,18]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,C)=>{let b;const P=new Map;function E(p,h,m,v,l){const w=P.get(h);if(p===A||w){const S={name:f(m),cmd:m,pid:p,ppid:h,load:v,mem:l};P.set(p,S),p===A&&(b=S),w&&(w.children||(w.children=[]),w.children.push(S),w.children.length>1&&(w.children=w.children.sort((y,d)=>y.pid-d.pid)))}}function f(p){const h=/--vscode-window-kind=shared-process/,m=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,w=/--crashes-directory/,S=/\\pipe\\winpty-control/,y=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(S.exec(p))return"winpty-process";if(y.exec(p))return"console-window-host (Windows internal process)";let i=d.exec(p);if(i&&i.length===2)return i[1]==="renderer"?h.exec(p)?"shared-process":m.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window":i[1]==="utility"&&l.exec(p)?"utility-network-service":i[1];const c=/[a-zA-Z-]+\.js/g;let r="";do i=c.exec(p),i&&(r+=i+" ");while(i);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,m)=>{Y(["windows-process-tree"],h,m)}).then(h=>{h.getProcessList(A,m=>{h.getProcessCpuUsage(m,v=>{const l=new Map;v.forEach(w=>{const S=p(w.commandLine||"");l.set(w.pid,{name:f(S),cmd:S,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=l.get(A),b?(l.forEach(w=>{const S=l.get(w.ppid);S&&(S.children||(S.children=[]),S.children.push(w))}),l.forEach(w=>{w.children&&(w.children=w.children.sort((S,y)=>S.pid-y.pid))}),R(b)):C(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[b];const m=[];for(;h.length;){const l=h.shift();l&&(m.push(l.pid),l.children&&(h=h.concat(l.children)))}let v=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);v+=" "+m.join(" "),(0,k.exec)(v,{},(l,w,S)=>{if(l||S)C(l||new Error(S.toString()));else{const y=w.toString().split(`
`);for(let d=0;d<m.length;d++){const i=P.get(m[d]);i.load=parseFloat(y[d])}if(!b){C(new Error(`Root process ${A} not found`));return}R(b)}})};(0,k.exec)("which ps",{},(h,m,v)=>{if(h||v)if(process.platform!=="linux")C(h||new Error(v.toString()));else{const l=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,k.exec)(l,{},(w,S,y)=>{w||y?C(w||new Error(y.toString())):(T(S,E),p())})}else{const l=m.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,y,d)=>{S||d&&!d.includes("screen size is bogus")?C(S||new Error(d.toString())):(T(y,E),process.platform==="linux"?p():b?R(b):C(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=A.toString().split(`
`);for(const P of b){const E=C.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var he=this&&this.__decorate||function(Y,e,k,t){var L=arguments.length,T=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Y,e,k,t);else for(var R=Y.length-1;R>=0;R--)(A=Y[R])&&(T=(L<3?A(T):L>3?A(e,k,T):A(e,k))||T);return L>3&&T&&Object.defineProperty(e,k,T),T};define(te[36],ne([0,1,16,5,17,25,54,9,3,2,108,26,11]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function v(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Q=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Q.byteLength,Q}}class S{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var y;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(y||(y={}));function d(H){const j=L.VSBuffer.alloc(4);return j.writeUInt32BE(H,0),j}function i(H){return H.read(4).readUInt32BE(0)}function c(H){const j=L.VSBuffer.alloc(1);return j.writeUInt8(H,0),j}const r={Undefined:c(y.Undefined),String:c(y.String),Buffer:c(y.Buffer),VSBuffer:c(y.VSBuffer),Array:c(y.Array),Object:c(y.Object)},n=typeof Buffer!="undefined";function o(H,j){if(typeof j=="undefined")H.write(r.Undefined);else if(typeof j=="string"){const Q=L.VSBuffer.fromString(j);H.write(r.String),H.write(d(Q.byteLength)),H.write(Q)}else if(n&&Buffer.isBuffer(j)){const Q=L.VSBuffer.wrap(j);H.write(r.Buffer),H.write(d(Q.byteLength)),H.write(Q)}else if(j instanceof L.VSBuffer)H.write(r.VSBuffer),H.write(d(j.byteLength)),H.write(j);else if(Array.isArray(j)){H.write(r.Array),H.write(d(j.length));for(const Q of j)o(H,Q)}else{const Q=L.VSBuffer.fromString(JSON.stringify(j));H.write(r.Object),H.write(d(Q.byteLength)),H.write(Q)}}function s(H){switch(H.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return H.read(i(H)).toString();case y.Buffer:return H.read(i(H)).buffer;case y.VSBuffer:return H.read(i(H));case y.Array:{const Q=i(H),x=[];for(let J=0;J<Q;J++)x.push(s(H));return x}case y.Object:return JSON.parse(H.read(i(H)).toString())}}class a{constructor(j,Q,x=null,J=1e3){this.protocol=j,this.ctx=Q,this.logger=x,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(j,Q){this.channels.set(j,Q),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Q=this.send([j.type]);this.logger?.logOutgoing(Q,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(Q,j.id,1,v(j.type),j.data);return}}}send(j,Q=void 0){const x=new S;return o(x,j),o(x,Q),this.sendBuffer(x.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const Q=new w(j),x=s(Q),J=s(Q),Z=x[0];switch(Z){case 100:return this.logger?.logIncoming(j.byteLength,x[1],1,`${h(Z)}: ${x[2]}.${x[3]}`,J),this.onPromise({type:Z,id:x[1],channelName:x[2],name:x[3],arg:J});case 102:return this.logger?.logIncoming(j.byteLength,x[1],1,`${h(Z)}: ${x[2]}.${x[3]}`,J),this.onEventListen({type:Z,id:x[1],channelName:x[2],name:x[3],arg:J});case 101:return this.logger?.logIncoming(j.byteLength,x[1],1,`${h(Z)}`),this.disposeActiveRequest({type:Z,id:x[1]});case 103:return this.logger?.logIncoming(j.byteLength,x[1],1,`${h(Z)}`),this.disposeActiveRequest({type:Z,id:x[1]})}}onPromise(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const x=new T.CancellationTokenSource;let J;try{J=Q.call(this.ctx,j.name,j.arg,x.token)}catch(F){J=Promise.reject(F)}const Z=j.id;J.then(F=>{this.sendResponse({id:Z,data:F,type:201}),this.activeRequests.delete(j.id)},F=>{F instanceof Error?this.sendResponse({id:Z,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:Z,data:F,type:203}),this.activeRequests.delete(j.id)});const W=(0,b.toDisposable)(()=>x.cancel());this.activeRequests.set(j.id,W)}onEventListen(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const x=j.id,Z=Q.listen(this.ctx,j.name,j.arg)(W=>this.sendResponse({id:x,data:W,type:204}));this.activeRequests.set(j.id,Z)}disposeActiveRequest(j){const Q=this.activeRequests.get(j.id);Q&&(Q.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Q=this.pendingRequests.get(j.channelName);Q||(Q=[],this.pendingRequests.set(j.channelName,Q));const x=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:j,timeoutTimer:x})}flushPendingRequests(j){const Q=this.pendingRequests.get(j);if(Q){for(const x of Q)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var u;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(j,Q=null){this.protocol=j,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=Q}getChannel(j){const Q=this;return{call(x,J,Z){return Q.isDisposed?Promise.reject(R.canceled()):Q.requestPromise(j,x,J,Z)},listen(x,J){return Q.isDisposed?C.Event.None:Q.requestEvent(j,x,J)}}}requestPromise(j,Q,x,J=T.CancellationToken.None){const Z=this.lastRequestId++,F={id:Z,type:100,channelName:j,name:Q,arg:x};if(J.isCancellationRequested)return Promise.reject(R.canceled());let N;return new Promise((V,ee)=>{if(J.isCancellationRequested)return ee(R.canceled());const se=()=>{const Ee=Se=>{switch(Se.type){case 201:this.handlers.delete(Z),V(Se.data);break;case 202:{this.handlers.delete(Z);const pe=new Error(Se.data.message);pe.stack=Se.data.stack,pe.name=Se.data.name,ee(pe);break}case 203:this.handlers.delete(Z),ee(Se.data);break}};this.handlers.set(Z,Ee),this.sendRequest(F)};let ae=null;this.state===l.Idle?se():(ae=(0,t.createCancelablePromise)(Ee=>this.whenInitialized()),ae.then(()=>{ae=null,se()}));const de=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:Z,type:101}),ee(R.canceled())},ge=J.onCancellationRequested(de);N=(0,b.combinedDisposable)((0,b.toDisposable)(de),ge),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(j,Q,x){const J=this.lastRequestId++,W={id:J,type:102,channelName:j,name:Q,arg:x};let F=null;const N=new C.Emitter({onFirstListenerAdd:()=>{F=(0,t.createCancelablePromise)(V=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(N),this.sendRequest(W)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(N),this.sendRequest({id:J,type:103}))}}),$=V=>N.fire(V.data);return this.handlers.set(J,$),N.event}sendRequest(j){switch(j.type){case 100:case 102:{const Q=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Q,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Q=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Q,j.id,0,h(j.type));return}}}send(j,Q=void 0){const x=new S;return o(x,j),o(x,Q),this.sendBuffer(x.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const Q=new w(j),x=s(Q),J=s(Q),Z=x[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(Z)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,x[1],0,v(Z),J),this.onResponse({type:x[0],id:x[1],data:J})}}onResponse(j){if(j.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(j.id);Q&&Q(j)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([A.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class I{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Q,onDidClientDisconnect:x})=>{C.Event.once(Q.onMessage)(Z=>{const W=new w(Z),F=s(W),N=new a(Q,F),$=new g(Q);this.channels.forEach((ee,se)=>N.registerChannel(se,ee));const V={channelServer:N,channelClient:$,ctx:F};this._connections.add(V),this._onDidAddConnection.fire(V),x(()=>{N.dispose(),$.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const j=[];return this._connections.forEach(Q=>j.push(Q)),j}getChannel(j,Q){const x=this;return{call(J,Z,W){let F;if((0,f.isFunction)(Q)){let $=(0,k.getRandomElement)(x.connections.filter(Q));F=$?Promise.resolve($):C.Event.toPromise(C.Event.filter(x.onDidAddConnection,Q))}else F=Q.routeCall(x,J,Z);const N=F.then($=>$.channelClient.getChannel(j));return O(N).call(J,Z,W)},listen(J,Z){if((0,f.isFunction)(Q))return x.getMulticastEvent(j,Q,J,Z);const W=Q.routeEvent(x,J,Z).then(F=>F.channelClient.getChannel(j));return O(W).listen(J,Z)}}}getMulticastEvent(j,Q,x,J){const Z=this;let W=new b.DisposableStore;const F=new C.Emitter({onFirstListenerAdd:()=>{W=new b.DisposableStore;const N=new C.EventMultiplexer,$=new Map,V=se=>{const de=se.channelClient.getChannel(j).listen(x,J),ge=N.add(de);$.set(se,ge)},ee=se=>{const ae=$.get(se);!ae||(ae.dispose(),$.delete(se))};Z.connections.filter(Q).forEach(V),C.Event.filter(Z.onDidAddConnection,Q)(V,void 0,W),Z.onDidRemoveConnection(ee,void 0,W),N.event(F.fire,F,W),W.add(N)},onLastListenerRemove:()=>{W.dispose()}});return F.event}registerChannel(j,Q){this.channels.set(j,Q),this._connections.forEach(x=>{x.channelServer.registerChannel(j,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(j,Q,x=null){const J=new S;o(J,Q),j.send(J.buffer),this.channelClient=new g(j,x),this.channelServer=new a(j,Q,x)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Q){this.channelServer.registerChannel(j,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(H){return{call(j,Q,x){return H.then(J=>J.call(j,Q,x))},listen(j,Q){const x=new C.Relay;return H.then(J=>x.input=J.listen(j,Q)),x.event}}}e.getDelayedChannel=O;function M(H){let j=!1;return{call(Q,x,J){return j?H.call(Q,x,J):(0,t.timeout)(0).then(()=>j=!0).then(()=>H.call(Q,x,J))},listen(Q,x){if(j)return H.listen(Q,x);const J=new C.Relay;return(0,t.timeout)(0).then(()=>j=!0).then(()=>J.input=H.listen(Q,x)),J.event}}}e.getNextTickChannel=M;class D{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Q of j.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await C.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=D;var U;(function(H){function j(Z,W){const F=Z,N=W&&W.disableMarshalling,$=new Map;for(const V in F)x(V)&&$.set(V,C.Event.buffer(F[V],!0));return new class{listen(V,ee,se){const ae=$.get(ee);if(ae)return ae;if(J(ee)){const de=F[ee];if(typeof de=="function")return de.call(F,se)}throw new Error(`Event not found: ${ee}`)}call(V,ee,se){const ae=F[ee];if(typeof ae=="function"){if(!N&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,P.revive)(se[de]);return ae.apply(F,se)}throw new Error(`Method not found: ${ee}`)}}}H.fromService=j;function Q(Z,W){const F=W&&W.disableMarshalling;return new Proxy({},{get(N,$){if(typeof $=="string")return W?.properties?.has($)?W.properties.get($):J($)?function(V){return Z.listen($,V)}:x($)?Z.listen($):async function(...V){let ee;W&&!(0,f.isUndefinedOrNull)(W.context)?ee=[W.context,...V]:ee=V;const se=await Z.call($,ee);return F?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String($)}`)}})}H.toService=Q;function x(Z){return Z[0]==="o"&&Z[1]==="n"&&E.isUpperAsciiLetter(Z.charCodeAt(2))}function J(Z){return/^onDynamic/.test(Z)&&E.isUpperAsciiLetter(Z.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let j=H.toString();if(j!=="[object Object]")return j}return H}function q(H){return Array.isArray(H)?H.map(B):B(H)}function G(H,j,Q,x,J,Z,W){W=q(W);const F=z[J],N=F[x%F.length];let $=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(Z)?($=$.concat(W),$.push(")")):$.push(W),console.log.apply(console,$)}e.logWithColors=G;class re{constructor(j,Q){this._outgoingPrefix=j,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Q,x,J,Z){this._totalOutgoing+=j,G(this._outgoingPrefix,this._totalOutgoing,j,Q,x,J,Z)}logIncoming(j,Q,x,J,Z){this._totalIncoming+=j,G(this._incomingPrefix,this._totalIncoming,j,Q,x,J,Z)}}e.IPCLogger=re}),define(te[117],ne([0,1,17,3,36]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(C){this.port=C,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",b=>k.VSBuffer.wrap(b.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(C,b){const P=new T(C);super(P,b);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[74],ne([0,1,17,3,2,36]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let s=0;function a(g,I){if(!o.has(g)){const _=String(++s);o.set(g,_)}return o.get(g)}function u(g,I,_,O){if(!n.enableDiagnostics)return;const M=a(g,I);if(O instanceof k.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const D=k.VSBuffer.alloc(O.byteLength);D.set(O),n.records.push({timestamp:Date.now(),id:M,label:I,type:_,buff:D})}else n.records.push({timestamp:Date.now(),id:M,label:I,type:_,data:O})}n.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function P(){return b||(b=k.VSBuffer.alloc(0)),b}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return P();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const I=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),I}if(this._chunks[0].byteLength>o){const I=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),I}let a=k.VSBuffer.alloc(o),u=0,g=0;for(;o>0;){const I=this._chunks[g];if(I.byteLength>o){const _=I.slice(0,o);a.set(_,u),u+=o,s&&(this._chunks[g]=I.slice(o),this._totalLength-=o),o-=o}else a.set(I,u),u+=I.byteLength,s?(this._chunks.shift(),this._totalLength-=I.byteLength):g++,o-=I.byteLength}return a}}e.ChunkStream=E;var f;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(f||(f={}));function p(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,s,a,u){this.type=o,this.id=s,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends L.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,u=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new m(a,u,g,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class l{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new l(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=w;class S extends T.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new S(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=S;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class d{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new d(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<c._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=c._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),s=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<c._HISTORY_LENGTH;u++)o-this.lastRuns[u]<=s&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class r{constructor(o,s=null,a=c.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new l(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,P());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new m(7,0,0,P());this._socketWriter.write(o)}sendResume(){const o=new m(8,0,0,P());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new l(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,P());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,u=s.length;a<u;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new m(6,0,0,P())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,u=s.length;a<u;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new m(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-s,2e4-a,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,P());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(te[118],ne([0,1,75,3,36,117]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const C=t.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(b,P)=>P);return t.Event.map(C,b=>{const{port1:P,port2:E}=new MessageChannel,p={protocol:new T.Protocol(P),onDidClientDisconnect:t.Event.fromDOMEventEmitter(P,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[E]),p})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function t(T){return T instanceof L?!0:T instanceof Error&&T.name===k&&T.message===k}e.isOfflineError=t;class L extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=L}),define(te[120],ne([0,1,17,9,119]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(C,b){if(!navigator.onLine)throw new L.OfflineError;C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((E,f)=>{P.open(C.type||"GET",C.url||"",!0,C.user,C.password),A(P,C),P.responseType="arraybuffer",P.onerror=p=>f(new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed")),P.onload=p=>{E({res:{statusCode:P.status,headers:R(P)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=p=>f(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(P.timeout=C.timeout),P.send(C.data),b.onCancellationRequested(()=>{P.abort(),f((0,t.canceled)())})})}e.request=T;function A(C,b){if(b.headers){e:for(let P in b.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(P,b.headers[P])}}}function R(C){const b=Object.create(null);for(const P of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const E=P.indexOf(":");b[P.substr(0,E).trim().toLowerCase()]=P.substr(E+1).trim()}return b}}),define(te[76],ne([0,1,5,3,2,11]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function R(E){const f=E;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(C||(C={}));class b extends L.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,h)=>this.accept(h,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===C.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(p)?h=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const h=this.cache.get(f);return(0,T.isUndefinedOrNull)(h)?p:h}getBoolean(f,p){const h=this.get(f);return(0,T.isUndefinedOrNull)(h)?p:h==="true"}getNumber(f,p){const h=this.get(f);return(0,T.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(f,p){if(this.state===C.Closed)return;if((0,T.isUndefinedOrNull)(p))return this.delete(f);const h=String(p);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===C.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,h)=>this.items.set(h,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[121],ne([12,13]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(te[57],ne([0,1,121]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,L=t*60,T=L*24,A=T*7,R=T*30,C=T*365;function b(E,f,p){typeof E!="number"&&(E=E.getTime());const h=Math.round((new Date().getTime()-E)/1e3);if(h<-30)return(0,k.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,k.localize)(1,null);let m;return h<t?(m=h,f?m===1?p?(0,k.localize)(2,null,m):(0,k.localize)(3,null,m):p?(0,k.localize)(4,null,m):(0,k.localize)(5,null,m):m===1?p?(0,k.localize)(6,null,m):(0,k.localize)(7,null,m):p?(0,k.localize)(8,null,m):(0,k.localize)(9,null,m)):h<L?(m=Math.floor(h/t),f?m===1?p?(0,k.localize)(10,null,m):(0,k.localize)(11,null,m):p?(0,k.localize)(12,null,m):(0,k.localize)(13,null,m):m===1?p?(0,k.localize)(14,null,m):(0,k.localize)(15,null,m):p?(0,k.localize)(16,null,m):(0,k.localize)(17,null,m)):h<T?(m=Math.floor(h/L),f?m===1?p?(0,k.localize)(18,null,m):(0,k.localize)(19,null,m):p?(0,k.localize)(20,null,m):(0,k.localize)(21,null,m):m===1?p?(0,k.localize)(22,null,m):(0,k.localize)(23,null,m):p?(0,k.localize)(24,null,m):(0,k.localize)(25,null,m)):h<A?(m=Math.floor(h/T),f?m===1?(0,k.localize)(26,null,m):(0,k.localize)(27,null,m):m===1?(0,k.localize)(28,null,m):(0,k.localize)(29,null,m)):h<R?(m=Math.floor(h/A),f?m===1?p?(0,k.localize)(30,null,m):(0,k.localize)(31,null,m):p?(0,k.localize)(32,null,m):(0,k.localize)(33,null,m):m===1?p?(0,k.localize)(34,null,m):(0,k.localize)(35,null,m):p?(0,k.localize)(36,null,m):(0,k.localize)(37,null,m)):h<C?(m=Math.floor(h/R),f?m===1?p?(0,k.localize)(38,null,m):(0,k.localize)(39,null,m):p?(0,k.localize)(40,null,m):(0,k.localize)(41,null,m):m===1?p?(0,k.localize)(42,null,m):(0,k.localize)(43,null,m):p?(0,k.localize)(44,null,m):(0,k.localize)(45,null,m)):(m=Math.floor(h/C),f?m===1?p?(0,k.localize)(46,null,m):(0,k.localize)(47,null,m):p?(0,k.localize)(48,null,m):(0,k.localize)(49,null,m):m===1?p?(0,k.localize)(50,null,m):(0,k.localize)(51,null,m):p?(0,k.localize)(52,null,m):(0,k.localize)(53,null,m))}e.fromNow=b;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[122],ne([12,13]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,16,11,122]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(E,f){return f&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function C(E=null,f=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const p=k.coalesce(E),h=C(p[0],f);return p.length>1?L.localize(4,null,h,p.length):h}if(t.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return T(p.error,f);if(p.exception)return T(p.exception,f)}return E.stack?T(E,f):E.message?E.message:L.localize(5,null)}e.toErrorMessage=C;function b(E){const f=E;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=b;function P(E,f=Object.create(null)){const p=new Error(E);return f.actions&&(p.actions=f.actions),p}e.createErrorWithActions=P}),define(te[123],ne([12,13]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(te[77],ne([0,1,46,41,18,28,10,4,33,103,11,111,22,123]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(i,c){if(R.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};c&&(r.cwd=c);const n=k.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],r);return new Promise(o=>{n.once("error",s=>{o({success:!1,error:s})}),n.once("exit",(s,a)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(R.isLinux||R.isMacintosh)try{const r=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(n=>{k.execFile(r,[i.pid.toString()],{encoding:"utf8",shell:!0},(o,s,a)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function v(i){!i||(delete i.DEBUG,R.isMacintosh&&delete i.DYLD_LIBRARY_PATH,R.isLinux&&delete i.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function l(i=C.env){return i.comspec||"cmd.exe"}e.getWindowsShell=l;class w{constructor(c,r,n,o){if(r!==void 0&&n!==void 0&&o!==void 0)this.cmd=c,this.args=r,this.shell=n,this.options=o;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(C.env).forEach(a=>{s[a]=C.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const r=c.lastIndexOf(A.sep);return r!==-1&&(c=c.substring(r+1)),w.WellKnowCommands[c]?c:"other"}start(c){return R.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(C.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let n,o;const s=new Promise((a,u)=>{n=a,o=u});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(u,g,I)=>{this.childProcess=null;const _=u;_&&_.killed?o({killed:this.terminateRequested,stdout:g.toString(),stderr:I.toString()}):this.handleExec(n,c,u,g,I)})}else{let a=null;const u=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,n,c,o);const I={terminated:this.terminateRequested};P.isNumber(g)&&(I.cmdCode=g),n(I)};if(this.shell&&R.isWindows){const g=T.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let I=!1,_=!1;const O=[];let M=this.ensureQuotes(this.cmd);O.push(M.value),I=M.quoted,this.args&&this.args.forEach(U=>{M=this.ensureQuotes(U),O.push(M.value),_=_&&M.quoted});const D=["/s","/c"];I?_?D.push('"'+O.join(" ")+'"'):O.length>1?D.push('"'+O[0]+'" '+O.slice(1).join(" ")):D.push('"'+O[0]+'"'):D.push(O.join(" ")),a=k.spawn(l(),D,g)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(P.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",g=>{this.childProcess=null,o({terminated:this.terminateRequested,error:g})}),a.pid&&(this.childProcess.on("close",u),this.handleSpawn(a,n,c,o,!0)))}return s})}handleClose(c,r,n,o){}ensureQuotes(c){return w.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,m(c,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!R.isWindows)return c(!1);const r=k.spawn(l(),["/s","/c"]);r.on("error",n=>c(!0)),r.on("exit",n=>c(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class S extends w{constructor(c,r,n,o){super(c,r,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,r,n,o,s){[o,s].forEach((a,u)=>{const g=new E.LineDecoder;g.write(a).forEach(O=>{r({line:O,source:u===0?0:1})});const _=g.end();_&&r({line:_,source:u===0?0:1})}),c({terminated:this.terminateRequested,error:n})}handleSpawn(c,r,n,o,s){const a=new E.LineDecoder,u=new E.LineDecoder;c.stdout.on("data",g=>{a.write(g).forEach(_=>n({line:_,source:0}))}),c.stderr.on("data",g=>{u.write(g).forEach(_=>n({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=u}handleClose(c,r,n,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&n({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}e.LineProcess=S;function y(i){let c=[],r=!1;const n=function(o){if(r){c.push(o);return}(!i.send(o,a=>{if(a&&console.error(a),r=!1,c.length>0){const u=c.slice(0);c=[],u.forEach(g=>n(g))}})||R.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=y;var d;(function(i){async function c(r,n,o){if(A.isAbsolute(r))return r;if(n===void 0&&(n=C.cwd()),A.dirname(r)!=="."||(o===void 0&&P.isString(C.env.PATH)&&(o=C.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(n,r);async function a(u){if(await f.Promises.exists(u)){let g;try{g=await f.Promises.stat(u)}catch(I){I.message.startsWith("EACCES")&&(g=await f.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(let u of o){let g;if(A.isAbsolute(u)?g=A.join(u,r):g=A.join(n,u,r),await a(g))return g;let I=g+".com";if(await a(I)||(I=g+".exe",await a(I)))return I}return A.join(n,r)}i.findExecutable=c})(d=e.win32||(e.win32={}))}),define(te[124],ne([0,1,34,4,73,77]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(p,h){return p===1?t.isWindows?E():T.getWindowsShell(h):b(p,h)}e.getSystemShell=A;function R(p,h){return p===1?t.isWindows?f(h):T.getWindowsShell(h):b(p,h)}e.getSystemShellSync=R;let C=null;function b(p,h){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!C){let m;if(t.isWindows)m="/bin/bash";else{if(m=h.SHELL,!m)try{m=(0,k.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}C=m}return C}let P=null;async function E(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(p){if(P)return P;const h=t.isWindows&&parseFloat((0,k.release)())>=10,m=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?v:T.getWindowsShell(p)}}),define(te[58],ne([0,1,46,5,17,25,107,9,3,2,28,77,36]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(v){super({send:l=>{try{process.send&&process.send(l.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",l=>L.VSBuffer.wrap(Buffer.from(l,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(v,l){this.modulePath=v,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new t.Delayer(w),this.child=null,this._client=null}getChannel(v){const l=this;return{call(w,S,y){return l.requestPromise(v,w,S,y)},listen(w,S){return l.requestEvent(v,w,S)}}}requestPromise(v,l,w,S=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const y=this.getCachedChannel(v),d=(0,t.createCancelablePromise)(r=>y.call(l,w,r)),i=S.onCancellationRequested(()=>d.cancel()),c=(0,b.toDisposable)(()=>d.cancel());return this.activeRequests.add(c),d.finally(()=>{i.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),d}requestEvent(v,l,w){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let S;const y=new C.Emitter({onFirstListenerAdd:()=>{S=this.getCachedChannel(v).listen(l,w)(y.fire,y),this.activeRequests.add(S)},onLastListenerRemove:()=>{this.activeRequests.delete(S),S.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return y.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(l.env={...l.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,E.removeDangerousEnvVariables)(l.env),this.child=(0,k.fork)(this.modulePath,v,l);const w=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,A.isRemoteConsoleLog)(n)){(0,A.log)(n,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(n,"base64")))});const y=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,d=n=>this.child&&this.child.connected&&y.send(n.buffer.toString("base64")),i=w.event,c={send:d,onMessage:i};this._client=new f.ChannelClient(c);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(s=>(0,b.dispose)(s)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(v){let l=this.channels.get(v);return l||(l=this.client.getChannel(v),this.channels.set(v,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([12,13]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(te[138],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(te[139],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([12,13]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(te[141],ne([12,13]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([12,13]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([12,13]),function(Y,e){return Y.create("vs/platform/terminal/node/shellEnv",e)}),define(te[144],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var t;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(t=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(R,C,b,P){this.version=R,this.appName=C,this.machineId=b,this.targetPopulation=P}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return k.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,C=Object.values(L);for(let b of C)R.set(b,this.getFilterValue(b));return R}}e.AssignmentFilterProvider=T}),define(te[78],ne([0,1,57,54,18,10,33,20,7]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(m,v,l){this._args=m,this.paths=v,this.productService=l}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?C.URI.file((0,T.join)(m,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,T.resolve)(m):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,T.resolve)(m):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,T.resolve)(m);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const l=A.env.VSCODE_PORTABLE;return l?(0,T.join)(l,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(v=>/^[^:/?#]+?:\/\//.test(v)?C.URI.parse(v):C.URI.file((0,T.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?C.URI.parse(m):C.URI.file((0,T.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([t.memoize],b.prototype,"appRoot",null),he([t.memoize],b.prototype,"userHome",null),he([t.memoize],b.prototype,"userDataPath",null),he([t.memoize],b.prototype,"appSettingsHome",null),he([t.memoize],b.prototype,"tmpDir",null),he([t.memoize],b.prototype,"cacheHome",null),he([t.memoize],b.prototype,"userRoamingDataHome",null),he([t.memoize],b.prototype,"settingsResource",null),he([t.memoize],b.prototype,"userDataSyncHome",null),he([t.memoize],b.prototype,"userDataSyncLogResource",null),he([t.memoize],b.prototype,"sync",null),he([t.memoize],b.prototype,"machineSettingsResource",null),he([t.memoize],b.prototype,"globalStorageHome",null),he([t.memoize],b.prototype,"workspaceStorageHome",null),he([t.memoize],b.prototype,"keybindingsResource",null),he([t.memoize],b.prototype,"keyboardLayoutResource",null),he([t.memoize],b.prototype,"argvResource",null),he([t.memoize],b.prototype,"snippetsHome",null),he([t.memoize],b.prototype,"isExtensionDevelopment",null),he([t.memoize],b.prototype,"untitledWorkspacesHome",null),he([t.memoize],b.prototype,"installSourcePath",null),he([t.memoize],b.prototype,"builtinExtensionsPath",null),he([t.memoize],b.prototype,"extensionsPath",null),he([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([t.memoize],b.prototype,"extensionDevelopmentKind",null),he([t.memoize],b.prototype,"extensionTestsLocationURI",null),he([t.memoize],b.prototype,"debugExtensionHost",null),he([t.memoize],b.prototype,"serviceMachineIdResource",null),he([t.memoize],b.prototype,"telemetryLogResource",null),he([t.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function P(h,m){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,m,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function E(h,m){return p(h["inspect-search"],h["inspect-brk-search"],5876,m,h.extensionEnvironment)}e.parseSearchPort=E;function f(h,m){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,m,h.extensionEnvironment)}e.parsePtyHostPort=f;function p(h,m,v,l,w,S){const d=Number(m||h)||(l?null:v),i=d?Boolean(!!m):!1;let c;if(S)try{c=JSON.parse(S)}catch{}return{port:d,break:i,debugId:w,env:c}}}),define(te[151],ne([0,1,254,4,127]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,m,v=A){const l={},w=[],S=[];for(let c in m){const r=m[c];r.alias&&(l[c]=r.alias),r.type==="string"||r.type==="string[]"?(w.push(c),r.deprecates&&w.push(...r.deprecates)):r.type==="boolean"&&(S.push(c),r.deprecates&&S.push(...r.deprecates))}const y=k(h,{string:w,boolean:S,alias:l}),d={},i=y;d._=y._.map(c=>String(c)).filter(c=>c.length>0),delete i._;for(let c in m){const r=m[c];r.alias&&delete i[r.alias];let n=i[c];if(r.deprecates)for(const o of r.deprecates)i.hasOwnProperty(o)&&(n||(n=i[o],n&&v.onDeprecatedOption(o,r.deprecationMessage||(0,L.localize)(33,null))),delete i[o]);typeof n!="undefined"&&(r.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):r.type==="string"&&Array.isArray(n)&&(n=n.pop(),v.onMultipleValues(c,n)),d[c]=n,r.deprecationMessage&&v.onDeprecatedOption(c,r.deprecationMessage)),delete i[c]}for(let c in i)v.onUnknownOption(c);return d}e.parseArgs=R;function C(h,m){let v="";return m.args&&(Array.isArray(m.args)?v=` <${m.args.join("> <")}>`:v=` <${m.args}>`),m.alias?`-${m.alias} --${h}${v}`:`--${h}${v}`}function b(h,m){let v=0,l=[];for(const d in h){const i=h[d],c=C(d,i);v=Math.max(v,c.length),l.push([c,i.description])}let w=v+2+1;if(m-w<25)return l.reduce((d,i)=>d.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let S=m-w-1,y=[];for(const d of l){let i=d[0],c=E(d[1],S),r=P(w-i.length-2);y.push("  "+i+r+c[0]);for(let n=1;n<c.length;n++)y.push(P(w)+c[n])}return y}e.formatOptions=b;function P(h){return" ".repeat(h)}function E(h,m){let v=[];for(;h.length;){let l=h.length<m?h.length:h.lastIndexOf(" ",m),w=h.slice(0,l).trim();h=h.slice(l),v.push(w)}return v}function f(h,m,v,l,w){const S=process.stdout.isTTY&&process.stdout.columns||80,y=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",d=[`${h} ${v}`];d.push(""),d.push(`${(0,L.localize)(35,null)}: ${m} [${(0,L.localize)(36,null)}]${y}`),d.push(""),w?.noPipe!==!0&&(t.isWindows?d.push((0,L.localize)(37,null,m)):d.push((0,L.localize)(38,null,m)),d.push(""));const i={};for(const c in l){const r=l[c];if(r.description&&r.cat){let n=i[r.cat];n||(i[r.cat]=n={}),n[c]=r}}for(let c in i){const r=c;let n=i[r];n&&(d.push(T[r]),d.push(...b(n,S)),d.push(""))}return d.join(`
`)}e.buildHelpMessage=f;function p(h,m){return`${h||(0,L.localize)(39,null)}
${m||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(te[152],ne([0,1,255,128,151]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(f,p){const h={onUnknownOption:v=>{console.warn((0,t.localize)(0,null,v))},onMultipleValues:(v,l)=>{console.warn((0,t.localize)(1,null,v,l))},onDeprecatedOption:(v,l)=>{console.warn((0,t.localize)(2,null,v,l))}},m=(0,L.parseArgs)(f,L.OPTIONS,p?h:void 0);return m.goto&&m._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,t.localize)(3,null))),m["max-memory"]&&k(parseInt(m["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),m}function R(f){const p=f.findIndex(h=>!/^-/.test(h));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function C(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!E(process.env);return A(p,h)}e.parseMainProcessArgv=C;function b(f){const[,,...p]=f;return A(p,!0)}e.parseCLIProcessArgv=b;function P(f,...p){const h=f.indexOf("--");return h===-1?f.push(...p):f.splice(h,0,...p),f}e.addArg=P;function E(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function Y(e,k,t,L){function T(R){const C=A(R),b=[C];return e.isAbsolute(C)||b.unshift(L),e.resolve(...b)}function A(R){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,t);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(E,"AppData","Roaming")}break;case"darwin":b=e.join(k.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,t)}return{getUserDataPath:T}}if(typeof define=="function")define(te[153],ne([0,256,34,18,20,33]),function(e,k,t,L,T,A){const R=T.dirname(L.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return Y(k,t,C.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=Y(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,34,78,153]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends t.AbstractNativeEnvironmentService{constructor(R,C){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},C)}}e.NativeEnvironmentService=T}),define(te[155],ne([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(v){const l=v.match(A);return l?l[1]:null}function P(v){if(v.indexOf("://")===-1){const l=v.match(t);return l?b(l[2]):null}try{const l=k.URI.parse(v);if(l.authority)return b(l.authority)}catch{}return null}function E(v,l){const w=new Set;let S;for(;S=R.exec(v);){const d=P(S[1]);d&&w.add(d)}const y=new Set(l);return Array.from(w).map(d=>y.has(d)?d:d.replace(C,"a"))}e.getDomainsOfRemotes=E;function f(v){const l=v.match(T);return l?l[2]:null}function p(v,l,w){return v&&l?(w&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${v}${l}`:`${v}/${l}`):null}function h(v,l){if(v.indexOf("://")===-1){const w=v.match(L);if(w)return p(w[2],w[3],l)}try{const w=k.URI.parse(v);if(w.authority)return p(f(w.authority),w.path,l)}catch{}return null}function m(v,l=!1){const w=[];let S;for(;S=R.exec(v);){const y=h(S[1],l);y&&w.push(y)}return w}e.getRemotes=m}),define(te[156],ne([0,1,28]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function L(T,A){const R=C=>{if(typeof C!="string")return;const b=t.exec(C);if(!b)return;const P=A[b[1]]??C;return typeof P=="string"?P:typeof P.message=="string"?P.message:C};return(0,k.cloneAndChange)(T,R)}e.localizeManifest=L}),define(te[157],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,R,C){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,R,C])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class t{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(te[79],ne([0,1,135]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||t.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(t);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function R(f){if(!f)return null;let p=f.majorBase,h=f.majorMustEqual,m=f.minorBase,v=f.minorMustEqual,l=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(p===0||(v=!1),w=!1);let S=0;if(f.preRelease){const y=L.exec(f.preRelease);if(y){const[,d,i,c]=y;S=Date.UTC(Number(d),Number(i)-1,Number(c))}}return{majorBase:p,majorMustEqual:h,minorBase:m,minorMustEqual:v,patchBase:l,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:S}}e.normalizeVersion=R;function C(f,p,h){let m;typeof f=="string"?m=R(A(f)):m=f;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let l;if(typeof h=="string"?l=R(A(h)):l=h,!m||!l)return!1;let w=m.majorBase,S=m.minorBase,y=m.patchBase,d=l.majorBase,i=l.minorBase,c=l.patchBase,r=l.notBefore,n=l.majorMustEqual,o=l.minorMustEqual,s=l.patchMustEqual;return l.isMinimum?w>d?!0:w<d?!1:S>i?!0:S<i||v&&v<r?!1:y>=c:(w===1&&d===0&&(!n||!o||!s)&&(d=1,i=0,c=0,n=!0,o=!1,s=!1),w<d?!1:w>d?!n:S<i?!1:S>i?!o:y<c?!1:y>c?!s:!(v&&v<r))}e.isValidVersion=C;function b(f,p,h,m){return h.isBuiltin||typeof h.main=="undefined"?!0:E(f,p,h.engines.vscode,m)}e.isValidExtensionVersion=b;function P(f,p,h){return f==="*"||E(p,h,f)}e.isEngineValid=P;function E(f,p,h,m=[]){let v=R(A(h));if(!v)return m.push(k.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return m.push(k.localize(1,null,h)),!1}else if(!v.majorMustEqual)return m.push(k.localize(2,null,h)),!1;return C(f,p,v)?!0:(m.push(k.localize(3,null,f,h)),!1)}}),define(te[47],ne([0,1,17,29]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,R){let C=R&&R.get("storage.serviceMachineId",0)||null;if(C)return C;try{const P=(await A.readFile(T.serviceMachineIdResource)).value.toString();C=(0,t.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,t.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,k.VSBuffer.fromString(C))}catch{}}return R&&R.store("storage.serviceMachineId",C,0,1),C}e.getServiceMachineId=L}),define(te[51],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(te[80],ne([0,1,51]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function L(A,R,C){R instanceof k.SyncDescriptor||(R=new k.SyncDescriptor(R,[],C)),t.push([A,R])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(te[158],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=k;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const R=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),C),C.incoming.set(this._hashFn(T),R)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let R=this._nodes.get(A);return R||(R=new k(T),this._nodes.set(A,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,R]of this._nodes)T.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const R=new Set([T]),C=this._findCycle(A,R);if(C)return C}}_findCycle(T,A){for(let[R,C]of T.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const b=this._findCycle(C,A);if(b)return b;A.delete(R)}}}e.Graph=t}),define(te[6],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function t(A,R,C){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:A,index:C}):(R[k.DI_DEPENDENCIES]=[{id:A,index:C}],R[k.DI_TARGET]=R)}function L(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const R=function(C,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(R,C,P)};return R.toString=()=>A,k.serviceIds.set(A,R),R}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(te[159],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[19],ne([0,1,11,7,6]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationOverrides=T;function A(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||k.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var R;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function b(v,l){const w=Object.create(null);for(let S in v)P(w,S,v[S],l);return w}e.toValuesTree=b;function P(v,l,w,S){const y=l.split("."),d=y.pop();let i=v;for(let c=0;c<y.length;c++){let r=y[c],n=i[r];switch(typeof n){case"undefined":n=i[r]=Object.create(null);break;case"object":break;default:S(`Ignoring ${l} as ${y.slice(0,c+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[d]=w}catch{S(`Ignoring ${l} as ${y.join(".")} is ${JSON.stringify(i)}`)}else S(`Ignoring ${l} as ${y.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function E(v,l){const w=l.split(".");f(v,w)}e.removeFromValueTree=E;function f(v,l){const w=l.shift();if(l.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const S=v[w];typeof S=="object"&&!Array.isArray(S)&&(f(S,l),Object.keys(S).length===0&&delete v[w])}}function p(v,l,w){function S(i,c){let r=i;for(const n of c){if(typeof r!="object"||r===null)return;r=r[n]}return r}const y=l.split("."),d=S(v,y);return typeof d=="undefined"?w:d}e.getConfigurationValue=p;function h(v,l,w){Object.keys(l).forEach(S=>{S!=="__proto__"&&(S in v?k.isObject(v[S])&&k.isObject(l[S])?h(v[S],l[S],w):w&&(v[S]=l[S]):v[S]=l[S])})}e.merge=h;function m(v,l,w){const S=v.inspect(l),y=v.inspect(w);return typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:S.defaultValue}e.getMigratedSettingValue=m}),define(te[160],ne([0,1,4,26,6]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",k.isEdge),T.set("isFirefox",k.isFirefox),T.set("isChrome",k.isChrome),T.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var R;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return E.INSTANCE}static true(){return f.INSTANCE}static has(D){return p.create(D)}static equals(D,U){return h.create(D,U)}static notEquals(D,U){return l.create(D,U)}static regex(D,U){return r.create(D,U)}static in(D,U){return m.create(D,U)}static not(D){return w.create(D)}static and(...D){return s.create(D,null)}static or(...D){return a.create(D,null,!0)}static greater(D,U){return y.create(D,U)}static greaterEquals(D,U){return d.create(D,U)}static smaller(D,U){return i.create(D,U)}static smallerEquals(D,U){return c.create(D,U)}static deserialize(D,U=!1){if(!!D)return this._deserializeOrExpression(D,U)}static _deserializeOrExpression(D,U){let z=D.split("||");return a.create(z.map(B=>this._deserializeAndExpression(B,U)),null,!0)}static _deserializeAndExpression(D,U){let z=D.split("&&");return s.create(z.map(B=>this._deserializeOne(B,U)),null)}static _deserializeOne(D,U){if(D=D.trim(),D.indexOf("!=")>=0){let z=D.split("!=");return l.create(z[0].trim(),this._deserializeValue(z[1],U))}if(D.indexOf("==")>=0){let z=D.split("==");return h.create(z[0].trim(),this._deserializeValue(z[1],U))}if(D.indexOf("=~")>=0){let z=D.split("=~");return r.create(z[0].trim(),this._deserializeRegexValue(z[1],U))}if(D.indexOf(" in ")>=0){let z=D.split(" in ");return m.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const z=D.split(">=");return d.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const z=D.split(">");return y.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const z=D.split("<=");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const z=D.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(D)?w.create(D.substr(1).trim()):p.create(D)}static _deserializeValue(D,U){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let z=/^'([^']*)'$/.exec(D);return z?z[1].trim():D}static _deserializeRegexValue(D,U){if((0,t.isFalsyOrWhitespace)(D)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=D.indexOf("/"),B=D.lastIndexOf("/");if(z===B||z<0){if(U)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let q=D.slice(z+1,B),G=D[B+1]==="i"?"i":"";try{return new RegExp(q,G)}catch(re){if(U)throw new Error(`bad regexp-value '${D}', parse error: ${re}`);return console.warn(`bad regexp-value '${D}', parse error: ${re}`),null}}}e.ContextKeyExpr=C;function b(M,D){const U=M?M.substituteConstants():void 0,z=D?D.substituteConstants():void 0;return!U&&!z?!0:!U||!z?!1:U.equals(z)}e.expressionsAreEqualWithConstantSubstitution=b;function P(M,D){return M.cmp(D)}class E{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class f{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{constructor(D,U){this.key=D,this.negated=U,this.type=2}static create(D,U=null){const z=T.get(D);return typeof z=="boolean"?z?f.INSTANCE:E.INSTANCE:new p(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?f.INSTANCE:E.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class h{constructor(D,U,z){this.key=D,this.value=U,this.negated=z,this.type=4}static create(D,U,z=null){if(typeof U=="boolean")return U?p.create(D,z):w.create(D,z);const B=T.get(D);return typeof B=="boolean"?U===(B?"true":"false")?f.INSTANCE:E.INSTANCE:new h(D,U,z)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const U=D?"true":"false";return this.value===U?f.INSTANCE:E.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class m{constructor(D,U){this.key=D,this.valueKey=U,this.type=10,this.negated=null}static create(D,U){return new m(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const U=D.getValue(this.valueKey),z=D.getValue(this.key);return Array.isArray(U)?U.indexOf(z)>=0:typeof z=="string"&&typeof U=="object"&&U!==null?A.call(U,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=m;class v{constructor(D){this._actual=D,this.type=11}static create(D){return new v(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new v(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class l{constructor(D,U,z){this.key=D,this.value=U,this.negated=z,this.type=5}static create(D,U,z=null){if(typeof U=="boolean")return U?w.create(D,z):p.create(D,z);const B=T.get(D);return typeof B=="boolean"?U===(B?"true":"false")?E.INSTANCE:f.INSTANCE:new l(D,U,z)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const U=D?"true":"false";return this.value===U?E.INSTANCE:f.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=l;class w{constructor(D,U){this.key=D,this.negated=U,this.type=3}static create(D,U=null){const z=T.get(D);return typeof z=="boolean"?z?E.INSTANCE:f.INSTANCE:new w(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?E.INSTANCE:f.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function S(M,D){if(typeof M=="string"){const U=parseFloat(M);isNaN(U)||(M=U)}return typeof M=="string"||typeof M=="number"?D(M):E.INSTANCE}class y{constructor(D,U,z){this.key=D,this.value=U,this.negated=z,this.type=12}static create(D,U,z=null){return S(U,B=>new y(D,B,z))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=y;class d{constructor(D,U,z){this.key=D,this.value=U,this.negated=z,this.type=13}static create(D,U,z=null){return S(U,B=>new d(D,B,z))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class i{constructor(D,U,z){this.key=D,this.value=U,this.negated=z,this.type=14}static create(D,U,z=null){return S(U,B=>new i(D,B,z))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class c{constructor(D,U,z){this.key=D,this.value=U,this.negated=z,this.type=15}static create(D,U,z=null){return S(U,B=>new c(D,B,z))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class r{constructor(D,U){this.key=D,this.regexp=U,this.type=7,this.negated=null}static create(D,U){return new r(D,U)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const U=this.regexp?this.regexp.source:"",z=D.regexp?D.regexp.source:"";return U<z?-1:U>z?1:0}equals(D){if(D.type===this.type){const U=this.regexp?this.regexp.source:"",z=D.regexp?D.regexp.source:"";return this.key===D.key&&U===z}return!1}substituteConstants(){return this}evaluate(D){let U=D.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(D){this._actual=D,this.type=8}static create(D){return new n(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(M){let D=null;for(let U=0,z=M.length;U<z;U++){const B=M[U].substituteConstants();if(M[U]!==B&&D===null){D=[];for(let q=0;q<U;q++)D[q]=M[q]}D!==null&&(D[U]=B)}return D===null?M:D}class s{constructor(D,U){this.expr=D,this.negated=U,this.type=6}static create(D,U){return s._normalizeArr(D,U)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const B=P(this.expr[U],D.expr[U]);if(B!==0)return B}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(D.expr[U]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:s.create(D,this.negated)}evaluate(D){for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].evaluate(D))return!1;return!0}static _normalizeArr(D,U){const z=[];let B=!1;for(const q of D)if(!!q){if(q.type===1){B=!0;continue}if(q.type===0)return E.INSTANCE;if(q.type===6){z.push(...q.expr);continue}z.push(q)}if(z.length===0&&B)return f.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(P);for(let q=1;q<z.length;q++)z[q-1].equals(z[q])&&(z.splice(q,1),q--);if(z.length===1)return z[0];for(;z.length>1;){const q=z[z.length-1];if(q.type!==9)break;z.pop();const G=z.pop(),re=z.length===0,H=a.create(q.expr.map(j=>s.create([j,G],null)),null,re);H&&(z.push(H),z.sort(P))}return z.length===1?z[0]:new s(z,U)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let U of this.expr)D.push(...U.keys());return D}map(D){return new s(this.expr.map(U=>U.map(D)),null)}negate(){if(!this.negated){const D=[];for(let U of this.expr)D.push(U.negate());this.negated=a.create(D,this,!0)}return this.negated}}class a{constructor(D,U){this.expr=D,this.negated=U,this.type=9}static create(D,U,z){return a._normalizeArr(D,U,z)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const B=P(this.expr[U],D.expr[U]);if(B!==0)return B}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(D.expr[U]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:a.create(D,this.negated,!1)}evaluate(D){for(let U=0,z=this.expr.length;U<z;U++)if(this.expr[U].evaluate(D))return!0;return!1}static _normalizeArr(D,U,z){let B=[],q=!1;if(D){for(let G=0,re=D.length;G<re;G++){const H=D[G];if(!!H){if(H.type===0){q=!0;continue}if(H.type===1)return f.INSTANCE;if(H.type===9){B=B.concat(H.expr);continue}B.push(H)}}if(B.length===0&&q)return E.INSTANCE;B.sort(P)}if(B.length!==0){if(B.length===1)return B[0];for(let G=1;G<B.length;G++)B[G-1].equals(B[G])&&(B.splice(G,1),G--);if(B.length===1)return B[0];if(z){for(let G=0;G<B.length;G++)for(let re=G+1;re<B.length;re++)_(B[G],B[re])&&(B.splice(re,1),re--);if(B.length===1)return B[0]}return new a(B,U)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let U of this.expr)D.push(...U.keys());return D}map(D){return new a(this.expr.map(U=>U.map(D)),null)}negate(){if(!this.negated){let D=[];for(let U of this.expr)D.push(U.negate());for(;D.length>1;){const U=D.shift(),z=D.shift(),B=[];for(const G of O(U))for(const re of O(z))B.push(s.create([G,re],null));const q=D.length===0;D.unshift(a.create(B,null,q))}this.negated=D[0]}return this.negated}}class u extends p{constructor(D,U,z){super(D,null);this._defaultValue=U,typeof z=="object"?u._info.push({...z,key:D}):z!==!0&&u._info.push({key:D,description:z,type:U!=null?typeof U:void 0})}static all(){return u._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return h.create(this.key,D)}notEqualsTo(D){return l.create(this.key,D)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(M,D){return M<D?-1:M>D?1:0}function I(M,D,U,z){return M<U?-1:M>U?1:D<z?-1:D>z?1:0}function _(M,D){if(D.type===6&&M.type!==9&&M.type!==6){for(const B of D.expr)if(M.equals(B))return!0}const U=M.negate(),z=O(U).concat(O(D));z.sort(P);for(let B=0;B<z.length;B++){const G=z[B].negate();for(let re=B+1;re<z.length;re++){const H=z[re];if(G.equals(H))return!0}}return!1}e.implies=_;function O(M){return M.type===9?M.expr:[M]}}),define(te[81],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t}),define(te[82],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[14],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[83],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[15],ne([0,1,39,10,26,11,7,137,6]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function b(q){return q.create===!0}e.isFileOpenForWriteOptions=b;var P;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var E;(function(q){q[q.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var f;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=p;function h(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=h;function m(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function v(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=v;function l(q){return p(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=l;var w;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(G,re){super(G);this.code=re}}e.FileSystemProviderError=S;function y(q,G){const re=new S(q.toString(),G);return i(re,G),re}e.createFileSystemProviderError=y;function d(q){return q||y((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=d;function i(q,G){return q.name=G?`${G} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=i;function c(q){if(!q)return w.Unknown;if(q instanceof S)return q.code;const G=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=c;function r(q){if(q instanceof g)return q.fileOperationResult;switch(c(q)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(G,re,H){this.resource=G,this.operation=re,this.target=H}isOperation(G){return this.operation===G}}e.FileOperationEvent=o;var s;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(G,re){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const H=new Map;for(const j of G){const Q=H.get(j.type);switch(Q?Q.push([j.resource,j]):H.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,Q]of H)switch(j){case 1:this.added=k.TernarySearchTree.forUris(()=>re),this.added.fill(Q);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>re),this.updated.fill(Q);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>re),this.deleted.fill(Q);break}}contains(G,...re){return this.doContains(G,{includeChildren:!1},...re)}affects(G,...re){return this.doContains(G,{includeChildren:!0},...re)}doContains(G,re,...H){if(!G)return!1;const j=H.length>0;return!!((!j||H.includes(1))&&(this.added?.get(G)||re.includeChildren&&this.added?.findSuperstr(G))||(!j||H.includes(0))&&(this.updated?.get(G)||re.includeChildren&&this.updated?.findSuperstr(G))||(!j||H.includes(2))&&(this.deleted?.findSubstr(G)||re.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function u(q,G,re){return!q||!G||q===G||G.length>q.length?!1:(G.charAt(G.length-1)!==t.sep&&(G+=t.sep),re?(0,L.startsWithIgnoreCase)(q,G):q.indexOf(G)===0)}e.isParent=u;class g extends Error{constructor(G,re,H){super(G);this.fileOperationResult=re,this.options=H}}e.FileOperationError=g;class I extends g{constructor(G,re,H){super(G,2,H);this.stat=re}}e.NotModifiedSinceFileOperationError=I;var _;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=M;async function D(q,G){if(!G.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(re=>{const H=G.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===q.scheme&&j.added&&(H.dispose(),re())})})}e.whenProviderRegistered=D,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(G){return(0,T.isNumber)(G)||(G=0),G<U.KB?(0,R.localize)(1,null,G.toFixed(0)):G<U.MB?(0,R.localize)(2,null,(G/U.KB).toFixed(2)):G<U.GB?(0,R.localize)(3,null,(G/U.MB).toFixed(2)):G<U.TB?(0,R.localize)(4,null,(G/U.GB).toFixed(2)):(0,R.localize)(5,null,(G/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function B(q){return{maxFileSize:q===0?300*U.MB:16*U.GB,maxHeapSize:q===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=B});var K=this&&this.__param||function(Y,e){return function(k,t){e(k,t,Y)}};define(te[161],ne([0,1,84,40,15]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const C=(await this.fileService.readFileStream(R)).value;return new Promise((b,P)=>{const E=(0,k.createHash)("md5");(0,t.listenStream)(C,{onData:f=>E.update(f.buffer),onError:f=>P(f),onEnd:()=>b(E.digest("base64").replace(/=+$/,""))})})}};T=he([K(0,L.IFileService)],T),e.ChecksumService=T}),define(te[162],ne([0,1,17,37,9,3,2,40,7,29,15]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(p,h){super();this.channel=p,this.extraCapabilities=h,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,h){const{buffer:m}=await this.channel.call("readFile",[p,h]);return m}readFileStream(p,h,m){const v=(0,R.newWriteableStream)(w=>k.VSBuffer.concat(w.map(S=>k.VSBuffer.wrap(S))).buffer),l=this.channel.listen("readFileStream",[p,h])(w=>{if(w instanceof k.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let S=w;S instanceof Error||(S=(0,P.createFileSystemProviderError)((0,t.toErrorMessage)(S),P.FileSystemProviderErrorCode.Unknown)),v.error(S),v.end()}l.dispose()}});return m.onCancellationRequested(()=>{v.error((0,L.canceled)()),v.end(),l.dispose()}),v}writeFile(p,h,m){return this.channel.call("writeFile",[p,k.VSBuffer.wrap(h),m])}open(p,h){return this.channel.call("open",[p,h])}close(p){return this.channel.call("close",[p])}async read(p,h,m,v,l){const[w,S]=await this.channel.call("read",[p,h,l]);return m.set(w.buffer.slice(0,S),v),S}write(p,h,m,v,l){return this.channel.call("write",[p,h,k.VSBuffer.wrap(m),v,l])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,h){return this.channel.call("delete",[p,h])}rename(p,h,m){return this.channel.call("rename",[p,h,m])}copy(p,h,m){return this.channel.call("copy",[p,h,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const h=p;this._onDidChange.fire(h.map(m=>({resource:C.URI.revive(m.resource),type:m.type})))}else{const h=p;this._onDidWatchError.fire(h)}}))}watch(p,h){const m=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,m,p,h]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,m]))}}e.DiskFileSystemProviderClient=E}),define(te[85],ne([0,1,17,9,138,15]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(P,E,f,p,h,m){let v;try{await R(P,E,f,p,h,m)}catch(l){v=l}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}e.readFileIntoStream=A;async function R(P,E,f,p,h,m){C(m);const v=await P.open(E,{create:!1});try{C(m);let l=0,w=0,S=h&&typeof h.length=="number"?h.length:void 0,y=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof S=="number"?S:h.bufferSize)),d=h&&typeof h.position=="number"?h.position:0,i=0;do w=await P.read(v,d,y.buffer,i,y.byteLength-i),d+=w,i+=w,l+=w,typeof S=="number"&&(S-=w),i===y.byteLength&&(await f.write(p(y)),y=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof S=="number"?S:h.bufferSize)),i=0);while(w>0&&(typeof S!="number"||S>0)&&C(m)&&b(l,h));if(i>0){let c=i;typeof S=="number"&&(c=Math.min(i,S)),f.write(p(y.slice(0,c)))}}catch(l){throw(0,T.ensureFileSystemProviderError)(l)}finally{await P.close(v)}}function C(P){if(P.isCancellationRequested)throw(0,t.canceled)();return!0}function b(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[52],ne([0,1,2,4,7,15]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(p){return p.recursive===!0}e.isRecursiveWatchRequest=A;class R extends k.Disposable{constructor(h,m,v,l){super();this.onFileChanges=h,this.onLogMessage=m,this.verboseLogging=v,this.options=l,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new k.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),h.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),h.add(this.watcher.onDidError(m=>this.onError(m)))}onError(h){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class C extends R{constructor(h,m,v){super(h,m,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class b extends R{constructor(h,m,v){super(h,m,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function P(p){return p.map(h=>({type:h.type,resource:L.URI.file(h.path)}))}e.toFileChanges=P;function E(p){const h=new f;for(const m of p)h.processEvent(m);return h.coalesce()}e.coalesceEvents=E;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return t.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const m=this.mapPathToChange.get(this.toKey(h));let v=!1;if(m){const l=m.type,w=h.type;m.path!==h.path&&(h.type===2||h.type===1)?v=!0:l===1&&w===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(m)):l===2&&w===1?m.type=0:l===1&&w===0||(m.type=w)}else v=!0;v&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],m=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(h.push(v),!1):!0).sort((v,l)=>v.path.length-l.path.length).filter(v=>m.some(l=>(0,T.isParent)(v.path,l,!t.isLinux))?!1:(m.push(v.path),!0)).concat(h)}}}),define(te[163],ne([0,1,50,5,25,41,109,2,72,10,4,114,22,52]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends R.Disposable{constructor(l,w,S,y){super();this.request=l,this.onDidFilesChange=w,this.onLogMessage=S,this.verboseLogging=y,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(d=>(0,A.parse)(d)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const l=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(l);this._register(await this.doWatch(l,w.isDirectory()))}catch(l){l.code!=="ENOENT"?this.error(l):this.trace(l)}}async normalizePath(l){let w=l.path;try{w=await f.Promises.realpath(l.path),l.path===w&&(w=await(0,E.realcase)(l.path)??l.path),l.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${w})`)}catch{}return w}async doWatch(l,w){if(P.isMacintosh&&(0,T.isEqualOrParent)(l,"/Volumes/",!0))return this.error(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const S=new L.CancellationTokenSource(this.cts.token);let y=new R.DisposableStore;try{const d=(0,b.basename)(l),i=(0,k.watch)(l);y.add((0,R.toDisposable)(()=>{i.removeAllListeners(),i.close()})),this.trace(`Started watching: '${l}'`);const c=new Set;if(w)try{for(const n of await f.Promises.readdir(l))c.add(n)}catch(n){this.error(n)}const r=new Map;y.add((0,R.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),i.on("error",(n,o)=>{this.error(`Failed to watch ${l} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),i.on("change",(n,o)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${o}`);let s="";if(o&&(s=o.toString(),P.isMacintosh&&(s=(0,C.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(w)if(n==="rename"){r.get(s)?.dispose();const a=setTimeout(async()=>{if(r.delete(s),s===d&&!await f.Promises.exists(l)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,b.join)(l,s));if(S.token.isCancellationRequested)return;let g;u?c.has(s)?g=0:(g=1,c.add(s)):(c.delete(s),g=2),this.onFileChange({path:(0,b.join)(this.request.path,s),type:g})},h.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(s)?a=0:(a=1,c.add(s)),this.onFileChange({path:(0,b.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==d){const a=setTimeout(async()=>{const u=await f.Promises.exists(l);S.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),y.add(await this.doWatch(l,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);y.clear(),y.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await f.Promises.exists(l)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${l} for changes using fs.watch() (${d.toString()})`)}return(0,R.toDisposable)(()=>{S.dispose(!0),y.dispose()})}async onFileChange(l,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`),!w&&this.excludes.some(S=>S(l.path))?this.verboseLogging&&this.trace(` >> ignored ${l.path}`):this.fileChangesBuffer.push(l);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,p.coalesceEvents)(S);if(y.length>0){if(this.verboseLogging)for(const i of y)this.trace(`>> normalized ${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.path}`);this.throttledFileChangesWorker.work(y)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${y.length}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(l){if(P.isLinux)return f.Promises.exists(l);try{const w=(0,b.basename)(l);return(await f.Promises.readdir((0,b.dirname)(l))).some(y=>y===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(l){this.verboseLogging=l}error(l){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}warn(l){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}trace(l){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function m(v,l,w,S,y=512){const d=await f.Promises.open(v,"r"),i=Buffer.allocUnsafe(y),c=new L.CancellationTokenSource(S);let r,n=!1;const o={path:v,excludes:[],recursive:!1},s=new h(o,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(n)return;n=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:g}=await f.Promises.read(d,i,0,y,null);if(!g||c.token.isCancellationRequested)break;l(i.slice(0,g))}}catch(g){r=new Error(g),c.dispose(!0)}finally{n=!1}}})()});return await s.ready,w(),new Promise((a,u)=>{c.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(d)}catch(g){r=new Error(g)}r?u(r):a()})})}e.watchFileContents=m}),define(te[164],ne([0,1,16,3,2,4,163]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const P=this.normalizeRequests(b),E=P.filter(p=>{const h=this.watchers.get(p.path);return h?!(0,k.equals)(h.request.excludes,p.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:p})=>!P.find(h=>h.path===p.path&&(0,k.equals)(h.excludes,p.excludes))).map(({request:p})=>p.path);E.length&&this.trace(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const p of f)this.stopWatching(p);for(const p of E)this.startWatching(p)}startWatching(b){const P=new A.NodeJSFileWatcherLibrary(b,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),E={request:b,instance:P};this.watchers.set(b.path,E)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const P=this.watchers.get(b);P&&(this.watchers.delete(b),P.instance.dispose())}normalizeRequests(b){const P=new Map;for(const E of b){const f=T.isLinux?E.path:E.path.toLowerCase();P.set(f,E)}return Array.from(P.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,P]of this.watchers)P.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,P){return P?`[File Watcher (node.js)] ${b} (path: ${P.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=R}),define(te[165],ne([0,1,52,164]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends k.AbstractNonRecursiveWatcherClient{constructor(A,R,C){super(A,R,C);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(te[166],ne([0,1,18,36,58,52]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(C,b,P){super(C,b,P);this.init()}createWatcher(C){const b=C.add(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(b.onDidProcessExit(({code:P,signal:E})=>this.onError(`terminated by itself with code ${P}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[86],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=k}),define(te[167],ne([0,1,5,9,51,158,6,86]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new R.ServiceCollection,m=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=m,this._parent=v,this._services.set(A.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...m){let v=f.traceInvocation(h),l=!1;try{return h({get:S=>{if(l)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(S,v);if(!y)throw new Error(`[invokeFunction] unknown service '${S}'`);return y}},...m)}finally{l=!0,v.stop()}}createInstance(h,...m){let v,l;return h instanceof L.SyncDescriptor?(v=f.traceCreation(h.ctor),l=this._createInstance(h.ctor,h.staticArguments.concat(m),v)):(v=f.traceCreation(h),l=this._createInstance(h,m,v)),v.stop(),l}_createInstance(h,m=[],v){let l=A._util.getServiceDependencies(h).sort((y,d)=>y.index-d.index),w=[];for(const y of l){let d=this._getOrCreateServiceInstance(y.id,v);d||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${y.id}.`,!1),w.push(d)}let S=l.length>0?l[0].index:m.length;if(m.length!==S){console.warn(`[createInstance] First service dependency of ${h.name} at position ${S+1} conflicts with ${m.length} static arguments`);let y=S-m.length;y>0?m=m.concat(new Array(y)):m=m.slice(0,S)}return new h(...[...m,...w])}_setServiceInstance(h,m){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,m);else if(this._parent)this._parent._setServiceInstance(h,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let m=this._services.get(h);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):m}_getOrCreateServiceInstance(h,m){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,m.branch(h,!0)):(m.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,m,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,m,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,m,v){const l=new T.Graph(y=>y.id.toString());let w=0;const S=[{id:h,desc:m,_trace:v}];for(;S.length;){const y=S.pop();if(l.lookupOrInsertNode(y),w++>1e3)throw new b(l);for(let d of A._util.getServiceDependencies(y.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(d.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${d.id} which is NOT registered.`,!0),i instanceof L.SyncDescriptor){const c={id:d.id,desc:i,_trace:y._trace.branch(d.id,!0)};l.insertEdge(y,c),S.push(c)}}}for(;;){const y=l.roots();if(y.length===0){if(!l.isEmpty())throw new b(l);break}for(const{data:d}of y){if(this._getServiceInstanceOrDescriptor(d.id)instanceof L.SyncDescriptor){const c=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,c)}l.removeNode(d)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,m,v=[],l,w){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(m,v,l,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,m,v,l,w);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(h,m=[],v,l){if(v){const w=new k.IdleValue(()=>this._createInstance(h,m,l));return new Proxy(Object.create(null),{get(S,y){if(y in S)return S[y];let d=w.value,i=d[y];return typeof i!="function"||(i=i.bind(d),S[y]=i),i},set(S,y,d){return w.value[y]=d,!0}})}else return this._createInstance(h,m,l)}_throwIfStrict(h,m){if(m&&console.warn(m),this._strict)throw new Error(h)}}e.InstantiationService=P;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class f{constructor(h,m){this.type=h,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return C?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return C?new f(0,h.name):f._None}branch(h,m){let v=new f(2,h.toString());return this._dep.push([h,m,v]),v}stop(){let h=Date.now()-this._start;f._totals+=h;let m=!1;function v(w,S){let y=[],d=new Array(w+1).join("	");for(const[i,c,r]of S._dep)if(c&&r){m=!0,y.push(`${d}CREATES -> ${i}`);let n=v(w+1,r);n&&y.push(n)}else y.push(`${d}uses -> ${i}`);return y.join(`
`)}let l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||m)&&console.log(l.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[168],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=k}),define(te[169],ne([0,1,36,51,80,6]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(p,h,m){const v=m.getChannel(p);return R(h)?new h.channelClientCtor(v):k.ProxyChannel.toService(v,h?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let C=class extends A{constructor(p,h,m){super(p,h,m)}};C=he([K(2,e.IMainProcessService)],C);function b(f,p,h){(0,L.registerSingleton)(f,new t.SyncDescriptor(C,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let P=class extends A{constructor(p,h,m){super(p,h,m)}};P=he([K(2,e.ISharedProcessService)],P);function E(f,p,h){(0,L.registerSingleton)(f,new t.SyncDescriptor(P,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[59],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function t(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=t}),define(te[170],ne([0,1,2,59]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=he([K(0,t.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(te[8],ne([0,1,37,3,2,4,6]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function R(){return new Date().toISOString()}var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(c,r,n){switch(r){case C.Trace:c.trace(n);break;case C.Debug:c.debug(n);break;case C.Info:c.info(n);break;case C.Warning:c.warn(n);break;case C.Error:c.error(n);break;case C.Critical:c.critical(n);break;default:throw new Error("Invalid log level")}}e.log=b;function P(c){let r="";for(let n=0;n<c.length;n++){let o=c[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}r+=(n>0?" ":"")+o}return r}e.format=P;class E extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class f extends E{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(C.Trace)&&this.log(C.Trace,P([r,...n]))}debug(r,...n){this.checkLogLevel(C.Debug)&&this.log(C.Debug,P([r,...n]))}info(r,...n){this.checkLogLevel(C.Info)&&this.log(C.Info,P([r,...n]))}warn(r,...n){this.checkLogLevel(C.Warning)&&this.log(C.Warning,P([r,...n]))}error(r,...n){if(this.checkLogLevel(C.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(C.Error,P(o))}else this.log(C.Error,P([r,...n]))}critical(r,...n){this.checkLogLevel(C.Critical)&&this.log(C.Critical,P([r,...n]))}flush(){}}e.AbstractMessageLogger=f;class p extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...n){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}debug(r,...n){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}info(r,...n){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}warn(r,...n){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,r,...n):console.warn(`[main ${R()}]`,r,...n))}error(r,...n){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,r,...n):console.error(`[main ${R()}]`,r,...n))}critical(r,...n){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,r,...n):console.error(`[main ${R()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...n){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class m extends E{constructor(r,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,k.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class v extends E{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const o of this.logServices)o.trace(r,...n)}debug(r,...n){for(const o of this.logServices)o.debug(r,...n)}info(r,...n){for(const o of this.logServices)o.info(r,...n)}warn(r,...n){for(const o of this.logServices)o.warn(r,...n)}error(r,...n){for(const o of this.logServices)o.error(r,...n)}critical(r,...n){for(const o of this.logServices)o.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class l extends L.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=l;class w extends L.Disposable{constructor(r,n){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,n?.always?C.Trace:this.logLevel,n),this.loggers.set(r.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class S{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=S;function y(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const r=d(c.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function d(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=d;function i(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=i}),define(te[171],ne([0,1,5,9,2,10,22,14,8]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends L.Disposable{constructor(E,f){super();this.environmentService=E,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),m=(await A.Promises.readdir(f)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==E),v=m.slice(0,Math.max(0,m.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(l=>A.Promises.rm((0,T.join)(f,l)))))}catch(E){(0,t.onUnexpectedError)(E)}}};b=he([K(0,R.IEnvironmentService),K(1,C.ILogService)],b),e.LogsDataCleaner=b}),define(te[172],ne([0,1,5,9,2,10,22,14,8]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class gt extends L.Disposable{constructor(E,f,p){super();this.backupWorkspacesPath=E,this.environmentService=f,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(m=>m.backupFolder),h=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async m=>{m.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||m===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(m)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${m}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,m)))}))}catch(E){(0,t.onUnexpectedError)(E)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=he([K(1,R.INativeEnvironmentService),K(2,C.ILogService)],b),e.StorageDataCleaner=b}),define(te[173],ne([0,1,46,5,37,3,2,18,10,22,14,8]),function(Y,e,k,t,L,T,A,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(h,m){super();this.environmentService=h,this.logService=m,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const m=this.parseScript(h,"uninstall");return m&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${v}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(h,m){const v=`vscode:${m}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const l=h.manifest.scripts[v].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,C.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(h,m,v,l,w){return new Promise((S,y)=>{const d=this.start(h,m,v,w);let i;const c=r=>{i&&(clearTimeout(i),i=null),r?y(r):S(void 0)};d.on("error",r=>{c((0,L.toErrorMessage)(r)||"Unknown")}),d.on("exit",(r,n)=>{c(r?`post-${m} process exited with code ${r}`:void 0)}),l&&(i=setTimeout(()=>{i=null,d.kill(),y("timed out")},5e3))})}start(h,m,v,l){const w={silent:!0,execArgv:void 0},S=(0,k.fork)(h,[`--type=extension-post-${m}`,...v],w);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const y=T.Event.fromNodeEventEmitter(S.stdout,"data"),d=T.Event.fromNodeEventEmitter(S.stderr,"data");y(r=>this.logService.info(l.identifier.id,l.manifest.version,`post-${m}`,r)),d(r=>this.logService.error(l.identifier.id,l.manifest.version,`post-${m}`,r));const i=T.Event.any(T.Event.map(y,r=>({data:`%c${r}`,format:[""]})),T.Event.map(d,r=>({data:`%c${r}`,format:["color: red"]})));return T.Event.debounce(i,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(l.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),S}getExtensionStoragePath(h){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=he([K(0,P.IEnvironmentService),K(1,E.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[174],ne([0,1,16,5,9,3,2,10,52,8]),function(Y,e,k,t,L,T,A,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends A.Disposable{constructor(f,p){super();this.logService=f,this.options=p,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(f,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,p):this.watchNonRecursive(f,p)}watchUniversal(f,p){const h={path:this.toFilePath(f),excludes:p.excludes,recursive:p.recursive},m=(0,k.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,C.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const p of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const p of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(p)&&f.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,p){const h={path:this.toFilePath(f),excludes:p.excludes,recursive:!1},m=(0,k.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,C.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[175],ne([0,1,16,5,17,25,3,71,55,2,39,18,176,20,40,136,15,85,8]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends b.Disposable{constructor(d){super();this.logService=d,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(d,i){if(this.provider.has(d))throw new Error(`A filesystem provider for the scheme '${d}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${d}`);const c=new b.DisposableStore;return this.provider.set(d,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:d,provider:i}),c.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new v.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&c.add(i.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),c.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:d}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:d,provider:i}),this.provider.delete(d),(0,b.dispose)(c)})}getProvider(d){return this.provider.get(d)}async activateProvider(d){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:d,join(c){i.push(c)}}),!this.provider.has(d)&&await t.Promises.settled(i)}async canHandleResource(d){return await this.activateProvider(d.scheme),this.hasProvider(d)}hasProvider(d){return this.provider.has(d.scheme)}hasCapability(d,i){const c=this.provider.get(d.scheme);return!!(c&&c.capabilities&i)}listCapabilities(){return C.Iterable.map(this.provider,([d,i])=>({scheme:d,capabilities:i.capabilities}))}async withProvider(d){if(!(0,p.isAbsolutePath)(d))throw new v.FileOperationError((0,m.localize)(0,null,this.resourceForError(d)),8);await this.activateProvider(d.scheme);const i=this.provider.get(d.scheme);if(!i){const c=new Error;throw c.name="ENOPRO",c.message=(0,m.localize)(1,null,d.toString()),c}return i}async withReadProvider(d){const i=await this.withProvider(d);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i)||(0,v.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(d){const i=await this.withProvider(d);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(d,i){try{return await this.doResolveFile(d,i)}catch(c){throw(0,v.toFileSystemProviderErrorCode)(c)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,m.localize)(2,null,this.resourceForError(d)),1):(0,v.ensureFileSystemProviderError)(c)}}async doResolveFile(d,i){const c=await this.withProvider(d),r=this.isPathCaseSensitive(c),n=i?.resolveTo,o=i?.resolveSingleChildDescendants,s=i?.resolveMetadata,a=await c.stat(d);let u;return this.toFileStat(c,d,a,void 0,!!s,(g,I)=>(u||(u=P.TernarySearchTree.forUris(()=>!r),u.set(d,!0),n&&u.fill(!0,n)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?I===1:!1))}async toFileStat(d,i,c,r,n,o){const{providerExtUri:s}=this.getExtUri(d),a={resource:i,name:s.basename(i),isFile:(c.type&v.FileType.File)!=0,isDirectory:(c.type&v.FileType.Directory)!=0,isSymbolicLink:(c.type&v.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&v.FilePermission.Readonly)||Boolean(d.capabilities&2048),etag:(0,v.etag)({mtime:c.mtime,size:c.size}),children:void 0};if(a.isDirectory&&o(a,r)){try{const u=await d.readdir(i),g=await t.Promises.settled(u.map(async([I,_])=>{try{const O=s.joinPath(i,I),M=n?await d.stat(O):{type:_};return await this.toFileStat(d,O,M,u.length,n,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,k.coalesce)(g)}catch(u){this.logService.trace(u),a.children=[]}return a}return a}async resolveAll(d){return t.Promises.settled(d.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async stat(d){const i=await this.withProvider(d),c=await i.stat(d);return this.toFileStat(i,d,c,void 0,!0,()=>!1)}async exists(d){const i=await this.withProvider(d);try{return!!await i.stat(d)}catch{return!1}}async canCreateFile(d,i){try{await this.doValidateCreateFile(d,i)}catch(c){return c}return!0}async doValidateCreateFile(d,i){if(!i?.overwrite&&await this.exists(d))throw new v.FileOperationError((0,m.localize)(3,null,this.resourceForError(d)),3,i)}async createFile(d,i=L.VSBuffer.fromString(""),c){await this.doValidateCreateFile(d,c);const r=await this.writeFile(d,i);return this._onDidRunOperation.fire(new v.FileOperationEvent(d,0,r)),r}async writeFile(d,i,c){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,d,c)||await this.mkdirp(r,n.dirname(d));let s;if((0,v.hasReadWriteCapability)(r)&&!(i instanceof L.VSBuffer))if((0,h.isReadableStream)(i)){const a=await(0,h.peekStream)(i,3);a.ended?s=L.VSBuffer.concat(a.buffer):s=a}else s=(0,h.peekReadable)(i,a=>L.VSBuffer.concat(a),3);else s=i;!(0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasReadWriteCapability)(r)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(r,d,c,s):await this.doWriteBuffered(r,d,c,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s),this._onDidRunOperation.fire(new v.FileOperationEvent(d,4))}catch(o){throw new v.FileOperationError((0,m.localize)(4,null,this.resourceForError(d),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),c)}return this.resolve(d,{resolveMetadata:!0})}async validateWriteFile(d,i,c){if(!!c?.unlock&&!(d.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(i)));let n;try{n=await d.stat(i)}catch{return}if((n.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,m.localize)(6,null,this.resourceForError(i)),0,c);if(this.throwIfFileIsReadonly(i,n),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==v.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&c.mtime<n.mtime&&c.etag!==(0,v.etag)({mtime:c.mtime,size:n.size}))throw new v.FileOperationError((0,m.localize)(7,null),3,c);return n}async readFile(d,i,c){const r=await this.withReadProvider(d);return i?.atomic?this.doReadFileAtomic(r,d,i,c):this.doReadFile(r,d,i,c)}async doReadFileAtomic(d,i,c,r){return new Promise((n,o)=>{this.writeQueue.queueFor(i,this.getExtUri(d).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(d,i,c,r);n(s)}catch(s){o(s)}})})}async doReadFile(d,i,c,r){const n=await this.doReadFileStream(d,i,{...c,preferUnbuffered:!0},r);return{...n,value:await(0,L.streamToBuffer)(n.value)}}async readFileStream(d,i,c){const r=await this.withReadProvider(d);return this.doReadFileStream(r,d,i,c)}async doReadFileStream(d,i,c,r){const n=new T.CancellationTokenSource(r),o=this.validateReadFile(i,c).then(a=>a,a=>{throw n.cancel(),a});let s;try{return typeof c?.etag=="string"&&c.etag!==v.ETAG_DISABLED&&await o,c?.atomic&&(0,v.hasFileAtomicReadCapability)(d)||!((0,v.hasOpenReadWriteCloseCapability)(d)||(0,v.hasFileReadStreamCapability)(d))||(0,v.hasReadWriteCapability)(d)&&c?.preferUnbuffered?s=this.readFileUnbuffered(d,i,c):(0,v.hasFileReadStreamCapability)(d)?s=this.readFileStreamed(d,i,n.token,c):s=this.readFileBuffered(d,i,n.token,c),{...await o,value:s}}catch(a){s&&await(0,h.consumeStream)(s);const u=(0,m.localize)(8,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(a).toString());throw a instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(u,a.stat,c):new v.FileOperationError(u,(0,v.toFileOperationResult)(a),c)}}readFileStreamed(d,i,c,r=Object.create(null)){const n=d.readFileStream(i,r,c);return(0,h.transform)(n,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,m.localize)(9,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),r)},o=>L.VSBuffer.concat(o))}readFileBuffered(d,i,c,r=Object.create(null)){const n=(0,L.newWriteableBufferStream)();return(0,l.readFileIntoStream)(d,i,n,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,m.localize)(10,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),r)},c),n}readFileUnbuffered(d,i,c){const r=(0,h.newWriteableStream)(n=>L.VSBuffer.concat(n));return(async()=>{try{let n;c?.atomic&&(0,v.hasFileAtomicReadCapability)(d)?n=await d.readFile(i,{atomic:!0}):n=await d.readFile(i),typeof c?.position=="number"&&(n=n.slice(c.position)),typeof c?.length=="number"&&(n=n.slice(0,c.length)),this.validateReadFileLimits(i,n.byteLength,c),r.end(L.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(d,i){const c=await this.resolve(d,{resolveMetadata:!0});if(c.isDirectory)throw new v.FileOperationError((0,m.localize)(11,null,this.resourceForError(d)),0,i);if(typeof i?.etag=="string"&&i.etag!==v.ETAG_DISABLED&&i.etag===c.etag)throw new v.NotModifiedSinceFileOperationError((0,m.localize)(12,null),c,i);return this.validateReadFileLimits(d,c.size,i),c}validateReadFileLimits(d,i,c){if(c?.limits){let r;if(typeof c.limits.memory=="number"&&i>c.limits.memory&&(r=9),typeof c.limits.size=="number"&&i>c.limits.size&&(r=7),typeof r=="number")throw new v.FileOperationError((0,m.localize)(13,null,this.resourceForError(d)),r)}}async canMove(d,i,c){return this.doCanMoveCopy(d,i,"move",c)}async canCopy(d,i,c){return this.doCanMoveCopy(d,i,"copy",c)}async doCanMoveCopy(d,i,c,r){if(d.toString()!==i.toString())try{const n=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d):await this.withReadProvider(d),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,d,o,i,c,r)}catch(n){return n}return!0}async move(d,i,c){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(r,d,n,i,"move",!!c),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(d,o==="move"?2:3,s)),s}async copy(d,i,c){const r=await this.withReadProvider(d),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(r,d,n,i,"copy",!!c),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(d,o==="copy"?3:2,s)),s}async doMoveCopy(d,i,c,r,n,o){if(i.toString()===r.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(d,i,c,r,n,o);if(s&&!a&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(r)),n==="copy"){if(d===c&&(0,v.hasFileFolderCopyCapability)(d))await d.copy(i,r,{overwrite:o});else{const u=await this.resolve(i);u.isDirectory?await this.doCopyFolder(d,u,c,r):await this.doCopyFile(d,i,c,r)}return n}else return d===c?(await d.rename(i,r,{overwrite:o}),n):(await this.doMoveCopy(d,i,c,r,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(d,i,c,r){if((0,v.hasOpenReadWriteCloseCapability)(d)&&(0,v.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(d,i,c,r);if((0,v.hasOpenReadWriteCloseCapability)(d)&&(0,v.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(d,i,c,r);if((0,v.hasReadWriteCapability)(d)&&(0,v.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(d,i,c,r);if((0,v.hasReadWriteCapability)(d)&&(0,v.hasReadWriteCapability)(c))return this.doPipeUnbuffered(d,i,c,r)}async doCopyFolder(d,i,c,r){await c.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async n=>{const o=this.getExtUri(c).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(d,await this.resolve(n.resource),c,o):this.doCopyFile(d,n.resource,c,o)}))}async doValidateMoveCopy(d,i,c,r,n,o){let s=!1;if(d===c){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(d);if(g||(s=u.isEqual(i,r)),s&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(i),this.resourceForError(r)));if(!s&&u.isEqualOrParent(r,i))throw new Error((0,m.localize)(15,null,this.resourceForError(i),this.resourceForError(r)))}const a=await this.exists(r);if(a&&!s){if(!o)throw new v.FileOperationError((0,m.localize)(16,null,this.resourceForError(i),this.resourceForError(r)),4);if(d===c){const{providerExtUri:u}=this.getExtUri(d);if(u.isEqualOrParent(i,r))throw new Error((0,m.localize)(17,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(d){const i=this.isPathCaseSensitive(d);return{providerExtUri:i?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(d){return!!(d.capabilities&1024)}async createFolder(d){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);await this.mkdirp(i,d);const c=await this.resolve(d,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(d,0,c)),c}async mkdirp(d,i){const c=[],{providerExtUri:r}=this.getExtUri(d);for(;!r.isEqual(i,r.dirname(i));)try{if(((await d.stat(i)).type&v.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,v.toFileSystemProviderErrorCode)(n)!==v.FileSystemProviderErrorCode.FileNotFound)throw n;c.push(r.basename(i)),i=r.dirname(i)}for(let n=c.length-1;n>=0;n--){i=r.joinPath(i,c[n]);try{await d.mkdir(i)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(d,i){try{await this.doValidateDelete(d,i)}catch(c){return c}return!0}async doValidateDelete(d,i){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);if(!!i?.useTrash&&!(c.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(d)));let n;try{n=await c.stat(d)}catch{}if(n)this.throwIfFileIsReadonly(d,n);else throw new v.FileOperationError((0,m.localize)(20,null,this.resourceForError(d)),1);if(!!!i?.recursive){const s=await this.resolve(d);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(d)))}return c}async del(d,i){const c=await this.doValidateDelete(d,i),r=!!i?.useTrash,n=!!i?.recursive;await c.delete(d,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new v.FileOperationEvent(d,1))}watch(d,i={recursive:!1,excludes:[]}){const c=new b.DisposableStore;let r=!1,n=()=>{r=!0};return c.add((0,b.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(d,i);r?(0,b.dispose)(o):n=()=>(0,b.dispose)(o)}catch(o){this.logService.error(o)}})(),c}async doWatch(d,i){const c=await this.withProvider(d),r=(0,R.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(d),i]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:c.watch(d,i)},this.activeWatchers.set(r,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,d]of this.activeWatchers)(0,b.dispose)(d.disposable);this.activeWatchers.clear()}async doWriteBuffered(d,i,c,r){return this.writeQueue.queueFor(i,this.getExtUri(d).providerExtUri).queue(async()=>{const n=await d.open(i,{create:!0,unlock:c?.unlock??!1});try{(0,h.isReadableStream)(r)||(0,h.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(d,n,r):await this.doWriteReadableBufferedQueued(d,n,r)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await d.close(n)}})}async doWriteStreamBufferedQueued(d,i,c){let r=0,n;if((0,h.isReadableBufferedStream)(c)){if(c.buffer.length>0){const o=L.VSBuffer.concat(c.buffer);await this.doWriteBuffer(d,i,o,o.byteLength,r,0),r+=o.byteLength}if(c.ended)return;n=c.stream}else n=c;return new Promise((o,s)=>{(0,h.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(d,i,a,a.byteLength,r,0)}catch(u){return s(u)}r+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(d,i,c){let r=0,n;for(;(n=c.read())!==null;)await this.doWriteBuffer(d,i,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(d,i,c,r,n,o){let s=0;for(;s<r;)s+=await d.write(i,n+s,c.buffer,o+s,r-s)}async doWriteUnbuffered(d,i,c,r){return this.writeQueue.queueFor(i,this.getExtUri(d).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(d,i,c,r))}async doWriteUnbufferedQueued(d,i,c,r){let n;r instanceof L.VSBuffer?n=r:(0,h.isReadableStream)(r)?n=await(0,L.streamToBuffer)(r):(0,h.isReadableBufferedStream)(r)?n=await(0,L.bufferedStreamToBuffer)(r):n=(0,L.readableToBuffer)(r),await d.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(d,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(d,i,c,r))}async doPipeBufferedQueued(d,i,c,r){let n,o;try{n=await d.open(i,{create:!1}),o=await c.open(r,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,u=0,g=0;do g=await d.read(n,a,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(c,o,s,g,a,u),a+=g,u+=g,u===s.byteLength&&(u=0);while(g>0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof n=="number"?d.close(n):Promise.resolve(),typeof o=="number"?c.close(o):Promise.resolve()])}}async doPipeUnbuffered(d,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(d,i,c,r))}async doPipeUnbufferedQueued(d,i,c,r){return c.writeFile(r,await d.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(d,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(d,i,c,r))}async doPipeUnbufferedToBufferedQueued(d,i,c,r){const n=await c.open(r,{create:!0,unlock:!1});try{const o=await d.readFile(i);await this.doWriteBuffer(c,n,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await c.close(n)}}async doPipeBufferedToUnbuffered(d,i,c,r){const n=await(0,L.streamToBuffer)(this.readFileBuffered(d,i,T.CancellationToken.None));await this.doWriteUnbuffered(c,r,void 0,n)}throwIfFileSystemIsReadonly(d,i){if(d.capabilities&2048)throw new v.FileOperationError((0,m.localize)(22,null,this.resourceForError(i)),6);return d}throwIfFileIsReadonly(d,i){if((i.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,m.localize)(23,null,this.resourceForError(d)),6)}resourceForError(d){return d.scheme===E.Schemas.file?d.fsPath:d.toString(!0)}};S=he([K(0,w.ILogService)],S),e.FileService=S}),define(te[177],ne([0,1,50,257,5,39,17,3,41,2,10,4,20,40,22,139,15,85,174,37,166,165]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(c){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(c)}`)}})();class i extends w.AbstractDiskFileSystemProvider{constructor(r,n){super(r,n);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(r){try{const n=await h.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,f.joinPath)(r,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(r,n){let o;return n?.dangling?o=v.FileType.Unknown:r.isFile()?o=v.FileType.File:r.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,n&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(r){const n=this.toFilePath(r);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const s=new L.Barrier;return this.resourceLocks.set(r,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(r)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),s.open()})}async readFile(r,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),o=await this.createResourceLock(r));const s=this.toFilePath(r);return await h.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(r,n,o){const s=(0,p.newWriteableStream)(a=>A.VSBuffer.concat(a.map(u=>A.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,r,s,a=>a.buffer,{...n,bufferSize:256*1024},o),s}async writeFile(r,n,o){let s;try{const a=this.toFilePath(r);if(!o.create||!o.overwrite){if(await h.Promises.exists(a)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,m.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,m.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(r,{create:!0,unlock:o.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(r,a)}finally{typeof s=="number"&&await this.close(s)}}async open(r,n){const o=this.toFilePath(r);let s;(0,v.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(r));let a;try{if((0,v.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:g}=await h.SymlinkSupport.stat(o);g.mode&128||await h.Promises.chmod(o,g.mode|128)}catch(g){this.logService.trace(g)}let u;if((0,v.isFileOpenForWriteOptions)(n)){if(E.isWindows)try{await h.Promises.truncate(o,0),u="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}u||(u="w")}else u="r";a=await h.Promises.open(o,u)}catch(u){throw s?.dispose(),(0,v.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(r,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(a,0),(0,v.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,r),s){const u=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,s),u&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),u.dispose())}return a}async close(r){const n=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await h.Promises.fdatasync(r)}catch(o){this.canFlush=!1,this.logService.error(o)}return await h.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(r)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,o,s,a){const u=this.normalizePos(r,n);let g=null;try{g=(await h.Promises.read(r,o,s,a,u)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(r,u,g)}return g}normalizePos(r,n){return n===this.mapHandleToPos.get(r)?null:n}updatePos(r,n,o){const s=this.mapHandleToPos.get(r);typeof s=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(r,s+o):this.mapHandleToPos.delete(r)))}async write(r,n,o,s,a){return(0,L.retry)(()=>this.doWrite(r,n,o,s,a),100,3)}async doWrite(r,n,o,s,a){const u=this.normalizePos(r,n);let g=null;try{g=(await h.Promises.write(r,o,s,a,u)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),I)}finally{this.updatePos(r,u,g)}return g}async mkdir(r){try{await h.Promises.mkdir(this.toFilePath(r))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(r,n){try{const o=this.toFilePath(r);n.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(r,n,o){const s=this.toFilePath(r),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(r,n,"move",o.overwrite),await h.Promises.move(s,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,m.localize)(2,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(r,n,o){const s=this.toFilePath(r),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(r,n,"copy",o.overwrite),await h.Promises.copy(s,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,m.localize)(3,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(r,n,o,s){const a=this.toFilePath(r),u=this.toFilePath(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,C.isEqual)(a,u,!0)),g&&o==="copy")throw(0,v.createFileSystemProviderError)((0,m.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!g&&await h.Promises.exists(u)){if(!s)throw(0,v.createFileSystemProviderError)((0,m.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,n,o){return new y.UniversalWatcherClient(s=>r(s),s=>n(s),o)}createNonRecursiveWatcher(r,n,o){return new d.NodeJSWatcherClient(s=>r(s),s=>n(s),o)}toFileSystemProviderError(r){if(r instanceof v.FileSystemProviderError)return r;let n;switch(r.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(r,n){let o=this.toFileSystemProviderError(n);if(r&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await h.SymlinkSupport.stat(this.toFilePath(r));s.mode&128||(o=(0,v.createFileSystemProviderError)(n,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=i}),define(te[87],ne([0,1,3,7,8]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=k.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=A;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let h=console.log;switch(f){case L.LogLevel.Error:h=console.error;break;case L.LogLevel.Warning:h=console.warn;break;case L.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(f,p){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[m,v]of p)(0,L.log)(h,m,v)}}e.LoggerChannel=R;class C extends L.AbstractLoggerService{constructor(f,p,h){super(f,p);this.channel=h}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,h){return new b(this.channel,f,p,h)}}e.LoggerChannelClient=C;class b extends L.AbstractMessageLogger{constructor(f,p,h,m){super(m?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const h=[[f,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends L.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(te[60],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[88],ne([0,1,18,4,33,20]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const R=t.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const R=(0,T.dirname)(k.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const C=Y.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:C.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[27],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[178],ne([0,1,5,9,2,10,22,8,27]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends L.Disposable{constructor(E,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,T.dirname)(E),h=(0,T.basename)(E),m=await A.Promises.readdir(p);await Promise.all(m.map(async v=>{if(v===h)return;const l=(0,T.join)(p,v),w=await A.Promises.stat(l);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),A.Promises.rm(l)}))}catch(f){(0,t.onUnexpectedError)(f)}}};b=he([K(1,C.IProductService),K(2,R.ILogService)],b),e.CodeCacheCleaner=b}),define(te[179],ne([0,1,5,9,2,10,22,14,8,27]),function(Y,e,k,t,L,T,A,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(f,p,h){super();this.environmentService=f,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const S=p[w];f[`${S.hash}.${w}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const v=await A.Promises.readdir(h);for(const w of v){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,T.join)(h,w))}const l=Date.now();for(const w of Object.keys(f)){const S=(0,T.join)(h,w),y=await A.Promises.readdir(S);for(const d of y){if(d==="tcf.json")continue;const i=(0,T.join)(S,d),c=await A.Promises.stat(i);c.isDirectory()&&l-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,d)}`),await A.Promises.rm(i))}}}catch(f){(0,t.onUnexpectedError)(f)}}};P=he([K(0,R.INativeEnvironmentService),K(1,C.ILogService),K(2,b.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(te[180],ne([0,1,10,6]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(R,C="noAbsolutePaths"){for(const b of R.nodes)b.callFrame&&b.callFrame.url&&((0,k.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(b.callFrame.url))&&(b.callFrame.url=(0,k.join)(C,(0,k.basename)(b.callFrame.url)));return R}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(te[181],ne([0,1,29]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((b,P)=>{Y(["v8-inspect-profiler"],b,P)})).startProfiling({port:T.port,checkForPaused:!0}),C=(0,k.generateUuid)();return this._sessions.set(C,R),C}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const R=await A.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=t}),define(te[38],ne([0,1,99,11]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){k.ok(t.isString(A)),k.ok(t.isObject(R)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(te[89],ne([0,1,3,38]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,b){this.schemasById[L(C)]=b,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;t.Registry.add(e.Extensions.JSONContribution,A)}),define(te[42],ne([0,1,16,3,11,126,89,38]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(A.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(d,i=!0){this.registerConfigurations([d],i)}registerConfigurations(d,i=!0){const c=this.doRegisterConfigurations(d,i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(d){const i=this.doDeregisterConfigurations(d);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:d,remove:i}){const c=[];c.push(...this.doDeregisterConfigurations(i)),c.push(...this.doRegisterConfigurations(d,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(c)})}registerDefaultConfigurations(d){const i=[],c=[];for(const{overrides:r,source:n}of d)for(const o in r)if(i.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:s});const a={type:"object",default:s,description:T.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(n)?void 0:n};c.push(...h(o)),this.configurationProperties[o]=a,this.defaultLanguageConfigurationOverridesNode.properties[o]=a}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:n});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(d){const i=[];for(const{overrides:c,source:r}of d)for(const n in c){const o=this.configurationDefaultsOverrides.get(n),s=L.isString(r)?r:r?.id,a=L.isString(o?.source)?o?.source:o?.source?.id;if(s===a)if(i.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const i of d)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,i){const c=[];return d.forEach(r=>{c.push(...this.validateAndRegisterProperties(r,i,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),c}doDeregisterConfigurations(d){const i=[],c=r=>{if(r.properties)for(const n in r.properties)i.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n]);r.allOf&&r.allOf.forEach(n=>c(n))};for(const r of d){c(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}return i}validateAndRegisterProperties(d,i=!0,c,r,n=3){n=L.isUndefinedOrNull(d.scope)?n:d.scope;let o=[],s=d.properties;if(s)for(let u in s){if(i&&w(u)){delete s[u];continue}const g=s[u];if(g.source=c,g.defaultDefaultValue=s[u].default,this.updatePropertyDefaultValue(u,g),e.OVERRIDE_PROPERTY_REGEX.test(u)?g.scope=void 0:(g.scope=L.isUndefinedOrNull(g.scope)?n:g.scope,g.restricted=L.isUndefinedOrNull(g.restricted)?!!r?.includes(u):g.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),o.push(u)}let a=d.allOf;if(a)for(let u of a)o.push(...this.validateAndRegisterProperties(u,i,c,r,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(d){const i=c=>{let r=c.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let n=c.allOf;n&&n.forEach(i)};i(d)}updateSchema(d,i){switch(e.allSettings.properties[d]=i,i.scope){case 1:e.applicationSettings.properties[d]=i;break;case 2:e.machineSettings.properties[d]=i;break;case 6:e.machineOverridableSettings.properties[d]=i;break;case 3:e.windowSettings.properties[d]=i;break;case 4:e.resourceSettings.properties[d]=i;break;case 5:e.resourceSettings.properties[d]=i,this.resourceLanguageSettingsSchema.properties[d]=i;break}}removeFromSchema(d,i){switch(delete e.allSettings.properties[d],i.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d],delete this.resourceLanguageSettingsSchema.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const i=`[${d}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,c),e.allSettings.properties[i]=c,e.applicationSettings.properties[i]=c,e.machineSettings.properties[i]=c,e.machineOverridableSettings.properties[i]=c,e.windowSettings.properties[i]=c,e.resourceSettings.properties[i]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const d={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,i){const c=this.configurationDefaultsOverrides.get(d);let r=c?.value,n=c?.source;L.isUndefined(r)&&(r=i.defaultDefaultValue,n=void 0),L.isUndefined(r)&&(r=v(i.type)),i.default=r,i.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(y){const d=[];if(e.OVERRIDE_PROPERTY_REGEX.test(y)){let i=p.exec(y);for(;i?.length;){const c=i[1].trim();c&&d.push(c),i=p.exec(y)}}return(0,k.distinct)(d)}e.overrideIdentifiersFromKey=h;function m(y){return y.reduce((d,i)=>`${d}[${i}]`,"")}e.keyFromOverrideIdentifiers=m;function v(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const l=new E;R.Registry.add(e.Extensions.Configuration,l);function w(y){return y.trim()?e.OVERRIDE_PROPERTY_REGEX.test(y)?T.localize(7,null,y):l.getConfigurationProperties()[y]!==void 0?T.localize(8,null,y):null:T.localize(6,null)}e.validateProperty=w;function S(){const y=[],d=l.getConfigurationProperties();for(const i of Object.keys(d))y.push([i,d[i].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=S}),define(te[90],ne([0,1,16,3,35,2,39,28,11,7,19,42,38]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},n=[],o=[]){this._contents=r,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const o=this.getContentsForOverrideIdentifer(n);return o?r?(0,P.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return k.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const a of r){this.mergeContents(n,a.contents);for(const u of a.overrides){const[g]=o.filter(I=>k.equals(I.identifiers,u.identifiers));g?(this.mergeContents(g.contents,u.contents),g.keys.push(...u.keys),g.keys=k.distinct(g.keys)):o.push(R.deepClone(u))}for(const u of a.keys)s.indexOf(u)===-1&&s.push(u)}return new p(n,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s],u=n[s];u&&(typeof a=="object"&&typeof u=="object"?(a=R.deepClone(a),this.mergeContents(a,u)):a=u),o[s]=a}return new p(o,this.keys,this.overrides)}mergeContents(r,n){for(const o of Object.keys(n)){if(o in r&&C.isObject(r[o])&&C.isObject(n[o])){this.mergeContents(r[o],n[o]);continue}r[o]=R.deepClone(n[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?R.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=R.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[r])?n=a.contents:a.identifiers.includes(r)&&s(a.contents);return s(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,P.addToValueTree)(this.contents,r,n,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let o=0;o<n;o++)r.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,r)}removeKey(r){let n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(r={}){const n=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),s=Object.create(null),a=[];for(const u in n){const g=r[u],I=g!==void 0?g:n[u].default;(0,P.addToValueTree)(s,u,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(s))E.OVERRIDE_PROPERTY_REGEX.test(u)&&a.push({identifiers:(0,E.overrideIdentifiersFromKey)(u),keys:Object.keys(s[u]),contents:(0,P.toValuesTree)(s[u],g=>console.error(`Conflict in default settings file: ${g}`))});super(s,o,a)}}e.DefaultConfigurationModel=h;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!C.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:o,keys:s,overrides:a,restricted:u}=this.doParseRaw(r,n);this._configurationModel=new p(o,s,a),this._restrictedConfigurations=u||[]}doParseContent(r){let n={},o=null,s=[],a=[],u=[];function g(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let I={onObjectBegin:()=>{let _={};g(_),a.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let _=[];g(_),a.push(s),s=_,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:g,onError:(_,O,M)=>{u.push({error:_,offset:O,length:M})}};if(r)try{L.visit(r,I),n=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return n}doParseRaw(r,n){const o=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,n);r=s.raw;const a=(0,P.toValuesTree)(r,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),u=Object.keys(r),g=this.toOverrides(r,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:a,keys:u,overrides:g,restricted:s.restricted}}filter(r,n,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[]};const a={},u=[];for(let g in r)if(E.OVERRIDE_PROPERTY_REGEX.test(g)&&o){const I=this.filter(r[g],n,!1,s);a[g]=I.raw,u.push(...I.restricted)}else{const I=n[g],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&u.push(g),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&I?.restricted||(a[g]=r[g]))}return{raw:a,restricted:u}}toOverrides(r,n){const o=[];for(const s of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const u in r[s])a[u]=r[s][u];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=m;class v extends T.Disposable{constructor(r,n,o,s){super();this.userSettingsResource=r,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class l{constructor(r,n,o=new p,s=new p,a=new A.ResourceMap,u=new p,g=new A.ResourceMap,I=!0){this._defaultConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=g,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(r)}updateValue(r,n,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new p,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(r):s.setValue(r,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,o){const s=this.getConsolidateConfigurationModel(n,o),a=this.getFolderConfigurationModelForResource(n.resource,o),u=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),_=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),M=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,D=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,U=n.overrideIdentifier?u.override(n.overrideIdentifier).getValue(r):u.getValue(r),z=s.getValue(r),B=k.distinct(k.flatten(s.overrides.map(q=>q.identifiers))).filter(q=>s.getOverrideValue(r,q)!==void 0);return{defaultValue:g,userValue:I,userLocalValue:_,userRemoteValue:O,workspaceValue:M,workspaceFolderValue:D,memoryValue:U,value:z,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:a?.freeze().getValue(r),override:n.overrideIdentifier?a?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:u.getValue(r),override:n.overrideIdentifier?u.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:s,updated:a,removed:u}=d(this._defaultConfiguration,r);n=[...s,...a,...u]}for(const s of n)for(const a of(0,E.overrideIdentifiersFromKey)(s)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=r.getKeysForOverrideIdentifier(a),I=[...g.filter(_=>u.indexOf(_)===-1),...u.filter(_=>g.indexOf(_)===-1),...u.filter(_=>!R.equals(this._defaultConfiguration.override(a).getValue(_),r.override(a).getValue(_)))];o.push([a,I])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:s,overrides:a}=d(this.localUserConfiguration,r),u=[...n,...o,...s];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:s,overrides:a}=d(this.remoteUserConfiguration,r);let u=[...n,...o,...s];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:s,overrides:a}=d(this.workspaceConfiguration,r);let u=[...n,...o,...s];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(r,n){const o=this.folderConfigurations.get(r),{added:s,updated:a,removed:u,overrides:g}=d(o,n);let I=[...s,...a,...u];return(I.length||!o)&&this.updateFolderConfiguration(r,n),{keys:I,overrides:g}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:a,overrides:u}=d(n,void 0);return{keys:[...o,...s,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,n){let o=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const s=n.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(r);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(n=o.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=o}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(n);return r.push([n,{contents:o,overrides:s,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((u,g)=>(u.set(b.URI.revive(g[0]),this.parseConfigurationModel(g[1])),u),new A.ResourceMap);return new l(n,o,new p,s,a,new p,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,n=new Map;for(const s of c)s.keys.forEach(a=>r.add(a)),s.overrides.forEach(([a,u])=>{const g=(0,A.getOrSet)(n,a,new Set);u.forEach(I=>g.add(I))});const o=[];return n.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=w;class S{constructor(r,n,o,s){this.change=r,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(g=>a.add(g)),r.overrides.forEach(([,g])=>g.forEach(I=>a.add(I))),this.affectedKeys=[...a.values()];const u=new p;this.affectedKeys.forEach(g=>u.setValue(g,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let o=(0,P.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=S;class y extends S{constructor(r,n,o,s){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=y;function d(c,r){const{added:n,removed:o,updated:s}=i(r,c),a=[],u=c?.getAllOverrideIdentifiers()||[],g=r?.getAllOverrideIdentifiers()||[];if(r){const I=g.filter(_=>!u.includes(_));for(const _ of I)a.push([_,r.getKeysForOverrideIdentifier(_)])}if(c){const I=u.filter(_=>!g.includes(_));for(const _ of I)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(r&&c){for(const I of u)if(g.includes(I)){const _=i({contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)},{contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)});a.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:n,removed:o,updated:s,overrides:a}}function i(c,r){const n=c?r?c.keys.filter(a=>r.keys.indexOf(a)===-1):[...c.keys]:[],o=r?c?r.keys.filter(a=>c.keys.indexOf(a)===-1):[...r.keys]:[],s=[];if(c&&r){for(const a of r.keys)if(c.keys.indexOf(a)!==-1){const u=(0,P.getConfigurationValue)(r.contents,a),g=(0,P.getConfigurationValue)(c.contents,a);R.equals(u,g)||s.push(a)}}return{added:n,removed:o,updated:s}}}),define(te[182],ne([0,1,5,3,2,20,19,90,42,38]),function(Y,e,k,t,L,T,A,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const h=typeof f=="string"?f:void 0,m=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,m,void 0)}updateValue(f,p,h,m){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(h,p,6)}trigger(f,p,h){const m=new R.ConfigurationChangeEvent(f,{data:p},this.configuration);m.source=h,m.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[183],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,R=t.Unknown,C){super(A);this._message=A,this._code=R,this._detail=C,this.isHandled=R===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(te[184],ne([0,1,5,17,25,9,3,2,29,74,183]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(x){const J=new L.CancellationTokenSource;return setTimeout(()=>J.cancel(),x),J.token}function m(x,J){if(x.isCancellationRequested||J.isCancellationRequested)return L.CancellationToken.Cancelled;const Z=new L.CancellationTokenSource;return x.onCancellationRequested(()=>Z.cancel()),J.onCancellationRequested(()=>Z.cancel()),Z.token}class v{constructor(J){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((Z,W)=>{this._resolvePromise=Z,this._rejectPromise=W}),J.isCancellationRequested?this._timeout():this._disposables.add(J.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(J){this._state==="pending"?this._disposables.add(J):J.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(J))}reject(J){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(J))}}function l(x,J){const Z=new v(J);return Z.registerDisposable(x.onControlMessage(W=>{const F=JSON.parse(W.toString()),N=G(F);N?Z.reject(N):Z.resolve(F)})),Z.promise}function w(x,J,Z,W,F,N,$){const V=new v($);return J.connect(Z,W,F,N,(ee,se)=>{V.didTimeout?(ee&&x.error(ee),se?.dispose()):ee||!se?V.reject(ee):V.resolve(se)}),V.promise}function S(x,J){const Z=new v(J);return x.then(W=>{Z.didTimeout||Z.resolve(W)},W=>{Z.didTimeout||Z.reject(W)}),Z.promise}async function y(x,J,Z,W){const F=j(x,J);x.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let N;try{N=await w(x.logService,x.socketFactory,x.host,x.port,`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,`renderer-${p(J)}-${x.reconnectionToken}`,W)}catch(ae){throw x.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),x.logService.error(ae),ae}x.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let $,V;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(N,null),$=x.reconnectionProtocol,V=!1):($=new b.PersistentProtocol(N,null),V=!0),x.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ee=await S(x.signService.createNewMessage((0,C.generateUuid)()),W),se={type:"auth",auth:x.connectionToken||"00000000000000000000",data:ee.data};$.sendControl(t.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await l($,m(W,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(x.logService.trace(`${F} 4/6. received SignRequest control message.`),!await S(x.signService.validate(ee,ae.signedData),W)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ge=await S(x.signService.sign(ae.data),W),Ee={type:"connectionType",commit:x.commit,signedData:ge,desiredConnectionType:J};return Z&&(Ee.args=Z),x.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(t.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:$,ownsProtocol:V}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(x.logService.error(`${F} the handshake timed out. Error:`),x.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${F} received error control message when negotiating connection. Error:`),x.logService.error(ae)),V&&q($),ae}}async function d(x,J,Z,W){const F=Date.now(),N=j(x,J),{protocol:$,ownsProtocol:V}=await y(x,J,Z,W),ee=new v(W);return ee.registerDisposable($.onControlMessage(se=>{const ae=JSON.parse(se.toString()),de=G(ae);de?(x.logService.error(`${N} received error control message when negotiating connection. Error:`),x.logService.error(de),V&&q($),ee.reject(de)):(x.reconnectionProtocol&&x.reconnectionProtocol.endAcceptReconnection(),x.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${Q(F)}!`),ee.resolve({protocol:$,firstMessage:ae}))})),ee.promise}async function i(x,J){const{protocol:Z}=await d(x,1,void 0,J);return{protocol:Z}}async function c(x,J,Z){const{protocol:W,firstMessage:F}=await d(x,2,J,Z),N=F&&F.debugPort;return{protocol:W,debugPort:N}}async function r(x,J,Z){const W=Date.now(),F=j(x,3),{protocol:N}=await y(x,3,J,Z);return x.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${Q(W)}!`),N}async function n(x,J,Z){const{host:W,port:F,connectionToken:N}=await x.addressProvider.getAddress();return{commit:x.commit,host:W,port:F,connectionToken:N,reconnectionToken:J,reconnectionProtocol:Z,socketFactory:x.socketFactory,signService:x.signService,logService:x.logService}}async function o(x,J,Z){try{const W=(0,C.generateUuid)(),F=await n(x,W,null),{protocol:N}=await i(F,L.CancellationToken.None);return new z(x,J,Z,W,N)}catch(W){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(W),U.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=o;async function s(x,J){try{const Z=(0,C.generateUuid)(),W=await n(x,Z,null),{protocol:F,debugPort:N}=await c(W,J,L.CancellationToken.None);return new B(x,J,Z,F,N)}catch(Z){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(Z),U.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=s;async function a(x,J,Z){const W=await n(x,(0,C.generateUuid)(),null);return await r(W,{host:J,port:Z},L.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function u(x){return(0,k.createCancelablePromise)(J=>new Promise((Z,W)=>{const F=setTimeout(Z,x*1e3);J.onCancellationRequested(()=>{clearTimeout(F),Z()})}))}var g;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(g=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(J,Z){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(J,Z,W,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.durationSeconds=W,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(J,Z,W){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=O;class M{constructor(J,Z,W){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.attempt=W,this.type=4}}e.ConnectionGainEvent=M;class D{constructor(J,Z,W,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.attempt=W,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=D;class U extends R.Disposable{constructor(J,Z,W,F){super();this._connectionType=J,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Z,this.reconnectionToken=W,this.protocol=F,this._isReconnecting=!1,this._onDidStateChange.fire(new M(this.reconnectionToken,0,0)),this._register(F.onSocketClose(N=>{const $=H(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(()=>{const N=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} received socket timeout event.`),this._beginReconnecting()})),U._instances.push(this),U._permanentFailure&&this._gotoPermanentFailure(U._permanentFailureMillisSinceLastIncomingData,U._permanentFailureAttempt,U._permanentFailureHandled)}static triggerPermanentFailure(J,Z,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=J,this._permanentFailureAttempt=Z,this._permanentFailureHandled=W,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(J=>J._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(J=>J._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(U._permanentFailure)return;const J=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const F=W<Z.length?Z[W]:Z[Z.length-1];try{if(F>0){const $=u(F);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,$)),this._options.logService.info(`${J} waiting for ${F} seconds before reconnecting...`);try{await $}catch{}}if(U._permanentFailure){this._options.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${J} resolving connection...`);const N=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${J} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,h(E)),this._options.logService.info(`${J} reconnected!`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,T.isCancellationError)(N)){this._options.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,P.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!U._permanentFailure)}_gotoPermanentFailure(J,Z,W){this._onDidStateChange.fire(new D(this.reconnectionToken,J,Z,W)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=U,U._permanentFailure=!1,U._permanentFailureMillisSinceLastIncomingData=0,U._permanentFailureAttempt=0,U._permanentFailureHandled=!1,U._instances=[];class z extends U{constructor(J,Z,W,F,N){super(1,J,F,N);this.client=this._register(new b.Client(N,{remoteAuthority:Z,clientId:W},J.ipcLogger))}async _reconnect(J,Z){await i(J,Z)}}e.ManagementPersistentConnection=z;class B extends U{constructor(J,Z,W,F,N){super(2,J,W,F);this._startArguments=Z,this.debugPort=N}async _reconnect(J,Z){await c(J,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=B;function q(x){try{x.acceptDisconnect();const J=x.getSocket();x.dispose(),J.dispose()}catch(J){(0,T.onUnexpectedError)(J)}}function G(x){if(x&&x.type==="error"){const J=new Error(`Connection error: ${x.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function re(x,J){for(;x.length<J;)x+=" ";return x}function H(x,J,Z){return`[remote-connection][${re(p(x),13)}][${J.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function j(x,J){return`${H(J,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.host}:${x.port}]`}function Q(x){return`${Date.now()-x} ms`}}),define(te[185],ne([0,1,18]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===k.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function L(T){if(!T)return;const A=T.indexOf("+");return A<0?T:T.substr(0,A)}e.getRemoteName=L}),define(te[61],ne([0,1,26,6,185]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let m=typeof p=="string"?p:p.value,v=typeof h=="string"?h:h.value;return k.equalsIgnoreCase(m,v)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function b(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function E(f,p){if(p){const h=`onResolveRemoteAuthority:${(0,L.getRemoteName)(p)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,26,61]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(h,m){return h.uuid&&m.uuid?h.uuid===m.uuid:h.id===m.id?!0:(0,k.compareIgnoreCase)(h.id,m.id)===0}e.areSameExtensions=L;class T{constructor(m,v){this.version=v,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof T?L(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(h,m){return`${h}.${m}`}e.getExtensionId=A;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function C(h,m){return R(A(h,m))}e.getGalleryExtensionId=C;function b(h,m){const v=[],l=w=>{for(const S of v)if(S.some(y=>L(m(y),m(w))))return S;return null};for(const w of h){const S=l(w);S?S.push(w):v.push([w])}return v}e.groupByExtension=b;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function f(h){const m=new Set;if(h.malicious)for(const v of h.malicious)m.add(v.id);return m}e.getMaliciousExtensionsSet=f;function p(h,m){const v=[],l=m.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const w=l.shift();if(w&&v.every(S=>!L(S.identifier,{id:w}))){const S=h.filter(y=>L(y.identifier,{id:w}));S.length===1&&(v.push(S[0]),l.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p}),define(te[30],ne([0,1,18,130,31,6]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function R(i){const c=A.exec(i);return c&&c[1]?[(0,L.adoptToGalleryExtensionId)(c[1]),c[2]]:[(0,L.adoptToGalleryExtensionId)(i),void 0]}e.getIdAndVersion=R;var C;(function(i){i.WIN32_X64="win32-x64",i.WIN32_IA32="win32-ia32",i.WIN32_ARM64="win32-arm64",i.LINUX_X64="linux-x64",i.LINUX_ARM64="linux-arm64",i.LINUX_ARMHF="linux-armhf",i.ALPINE_X64="alpine-x64",i.ALPINE_ARM64="alpine-arm64",i.DARWIN_X64="darwin-x64",i.DARWIN_ARM64="darwin-arm64",i.WEB="web",i.UNIVERSAL="universal",i.UNKNOWN="unknown",i.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function b(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function E(i,c){switch(i){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function f(i,c){return c==="web"&&!i.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function p(i,c,r){return f(c,r)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===r?!0:h(r).includes(i)}e.isTargetPlatformCompatible=p;function h(i){switch(i){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=m;var v;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var l;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(l=e.SortOrder||(e.SortOrder={}));var w;(function(i){i.Install="install",i.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var S;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var y;(function(i){i.Unsupported="Unsupported",i.UnsupportedPreRelease="UnsupportedPreRelease",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatiblePreRelease="IncompatiblePreRelease",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(c,r){super(c);this.code=r,this.name=r}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(te[186],ne([0,1,3,2,28,7,110,30]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(m,v){return T.URI.revive(v?v.transformIncoming(m):m)}function b(m,v){return v?v.transformOutgoingURI(m):m}function P(m,v){v=v||A.DefaultURITransformer;const l=m.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...m,manifest:void 0},v),manifest:l}}function E(m,v){return v?(0,L.cloneAndChange)(m,l=>l instanceof T.URI?v.transformOutgoingURI(l):void 0):m}class f{constructor(v,l){this.service=v,this.getUriTransformer=l,this.onInstallExtension=k.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,l){const w=this.getUriTransformer(v);switch(l){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,S=>S.map(y=>({...y,local:y.local?E(y.local,w):y.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,l,w){const S=this.getUriTransformer(v);switch(l){case"zip":return this.service.zip(P(w[0],S)).then(y=>b(y,S));case"unzip":return this.service.unzip(C(w[0],S));case"install":return this.service.install(C(w[0],S),w[1]);case"getManifest":return this.service.getManifest(C(w[0],S));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],S),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],S));case"getInstalled":return this.service.getInstalled(w[0]).then(y=>y.map(d=>E(d,S)));case"updateMetadata":return this.service.updateMetadata(P(w[0],S),w[1]).then(y=>E(y,S));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],S),w[1]).then(y=>E(y,S));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends t.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(l=>this._onInstallExtension.fire({identifier:l.identifier,source:this.isUriComponents(l.source)?T.URI.revive(l.source):l.source}))),this._register(this.channel.listen("onDidInstallExtensions")(l=>this._onDidInstallExtensions.fire(l.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(l=>this._onUninstallExtension.fire(l))),this._register(this.channel.listen("onDidUninstallExtension")(l=>this._onDidUninstallExtension.fire(l)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const l=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,v.allTargetPlatforms,l))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(l=>T.URI.revive(l)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,l){return Promise.resolve(this.channel.call("install",[v,l])).then(w=>P(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,l){return Promise.resolve(this.channel.call("installFromGallery",[v,l])).then(w=>P(w,null))}uninstall(v,l){return Promise.resolve(this.channel.call("uninstall",[v,l]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(l=>l.map(w=>P(w,null)))}updateMetadata(v,l){return Promise.resolve(this.channel.call("updateMetadata",[v,l])).then(w=>P(w,null))}updateExtensionScope(v,l){return Promise.resolve(this.channel.call("updateExtensionScope",[v,l])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(v){this.service=v}listen(v,l){throw new Error("Invalid listen")}call(v,l,w){switch(l){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[187],ne([0,1,25,31]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,R,C,b){try{const P=await T.getExtensionsControlManifest();if(!P.unsupportedPreReleaseExtensions)return;const E=await T.getInstalled(1);for(const[f,{id:p,migrateStorage:h}]of Object.entries(P.unsupportedPreReleaseExtensions)){const m=E.find(l=>(0,t.areSameExtensions)(l.identifier,{id:f}));if(!m)continue;const v=(await A.getExtensions([{id:p,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!v){b.info(`Skipping migrating '${m.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{b.info(`Migrating '${m.identifier.id}' extension to '${p}' extension...`);const l=!C.getDisabledExtensions().some(S=>(0,t.areSameExtensions)(S,m.identifier));await T.uninstall(m),b.info(`Uninstalled the unsupported extension '${m.identifier.id}'`);let w=E.find(S=>(0,t.areSameExtensions)(S.identifier,{id:p}));(!w||!w.isPreReleaseVersion&&l)&&(w=await T.installFromGallery(v,{installPreReleaseVersion:!0,isMachineScoped:m.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${w.identifier.id}'`),l||(await C.disableExtension(w.identifier),b.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${m.identifier.id}' is disabled`)),h&&(R.addToMigrationList((0,t.getExtensionId)(m.manifest.publisher,m.manifest.name),(0,t.getExtensionId)(w.manifest.publisher,w.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${m.identifier.id}' extension to '${p}' extension.`)}catch(l){b.error(l)}}}catch(P){b.error(P)}}e.migrateUnsupportedExtensions=L}),define(te[188],ne([0,1,5,9,2,4,20,62,7,29,22,14,30,31,15,8]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let l=class extends L.Disposable{constructor(S,y,d,i){super();this.fileService=y,this.extensionGalleryService=d,this.logService=i,this.extensionsDownloadDir=C.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,y){await this.cleanUpPromise;const d=this.getName(S),i=(0,A.joinPath)(this.extensionsDownloadDir,d);if(!await this.fileService.exists(i)){const c=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(c)||await this.extensionGalleryService.download(S,c,y);try{await this.rename(c,i,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(c)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,c.path),r}}return i}async delete(S){await this.cleanUpPromise,await this.fileService.del(S)}async rename(S,y,d){try{await P.Promises.rename(S.fsPath,y.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${S} to ${y} with 'EPERM' error. Trying again...`),this.rename(S,y,d);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const y=[],d=[];for(const r of S.children){const n=this.parse(r.name);n&&d.push([n,r])}const i=(0,p.groupByExtension)(d,([r])=>r),c=[];for(const r of i)r.sort((n,o)=>R.rcompare(n[0].version,o[0].version)),y.push(...r.slice(1).map(n=>n[1].resource)),c.push(r[0][1]);c.sort((r,n)=>r.mtime-n.mtime),y.push(...c.slice(0,Math.max(0,c.length-this.cache)).map(r=>r.resource)),await k.Promises.settled(y.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?`${new p.ExtensionIdentifierWithVersion(S.identifier,S.version).key().toLowerCase()}${S.properties.targetPlatform!=="undefined"?`-${S.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(S){const y=v.exec(S);return y&&y[1]&&y[2]?new p.ExtensionIdentifierWithVersion({id:y[1]},y[2]):null}};l=he([K(0,E.INativeEnvironmentService),K(1,h.IFileService),K(2,f.IExtensionGalleryService),K(3,m.ILogService)],l),e.ExtensionsDownloader=l}),define(te[189],ne([0,1,2,10,22,61]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(C,b){super();this.environmentService=C,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(b.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[190],ne([0,1,84,16,5,2,18,10,22,14,30,31,59,8]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(l,w,S){super();this.extensionManagementService=l,this.logService=S,this.cache=this._register(new m(w,S)),this.extensionManagementService.registerParticipant({postInstall:async y=>this.postInstallExtension(y),postUninstall:async y=>this.postUninstallExtension(y)})}async getLanguageIds(){const l=await this.cache.getLanguagePacks(),w=["en",...Object.keys(l)];return(0,t.distinct)(w)}async postInstallExtension(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",l.identifier.id),await this.update())}async postUninstallExtension(l){const w=await this.cache.getLanguagePacks();Object.keys(w).some(S=>w[S]&&w[S].extensions.some(y=>(0,E.areSameExtensions)(y.extensionIdentifier,l.identifier)))&&(this.logService.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(w);return!(0,t.equals)(Object.keys(l),Object.keys(S))}};h=he([K(0,P.IExtensionManagementService),K(1,b.INativeEnvironmentService),K(2,p.ILogService)],h),e.LocalizationsService=h;let m=class extends T.Disposable{constructor(l,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(l.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(l){return this.withLanguagePacks(w=>{Object.keys(w).forEach(S=>delete w[S]),this.createLanguagePacksFromExtensions(w,...l)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(l,...w){for(const S of w)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(l,S);Object.keys(l).forEach(S=>this.updateHash(l[S]))}createLanguagePacksFromExtension(l,w){const S=w.identifier,y=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const d of y)if(w.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(d)){let i=l[d.languageId];i||(i={hash:"",extensions:[],translations:{}},l[d.languageId]=i);let c=i.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,S))[0];c?c.version=w.manifest.version:i.extensions.push({extensionIdentifier:S,version:w.manifest.version});for(const r of d.translations)i.translations[r.id]=(0,R.join)(w.location.fsPath,r.path)}}updateHash(l){if(l){const w=(0,k.createHash)("md5");for(const S of l.extensions)w.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);l.hash=w.digest("hex")}}withLanguagePacks(l=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(w=l(S),S)).then(S=>{for(const d of Object.keys(S))S[d]||delete S[d];this.languagePacks=S,this.initializedCache=!0;const y=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",y),C.Promises.writeFile(this.languagePacksFilePath,y)}).then(()=>w,S=>this.logService.error(S))})}};m=he([K(0,b.INativeEnvironmentService),K(1,p.ILogService)],m)}),define(te[191],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[192],ne([0,1,120,19,8]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,C){this.configurationService=R,this.logService=C}request(R,C){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(R,C)}async resolveProxy(R){}};T=he([K(0,t.IConfigurationService),K(1,L.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,17,140,42,6,38]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function C(h){return h.res.statusCode===204}async function b(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return C(h)?null:(await(0,k.streamToBuffer)(h.stream)).toString()}e.asText=b;async function P(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(C(h))return null;const v=(await(0,k.streamToBuffer)(h.stream)).toString();try{return JSON.parse(v)}catch(l){throw l.message+=`:
`+v,l}}e.asJson=P;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let f;function p(h){const m=A.Registry.as(L.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[f],remove:v?[v]:[]})}p(2)}),define(te[193],ne([0,1,25,18,15,43]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(C,b){this.requestService=C,this.fileService=b}async download(C,b,P=k.CancellationToken.None){if(C.scheme===t.Schemas.file||C.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(C,b);return}const E={type:"GET",url:C.toString()},f=await this.requestService.request(E,P);if(f.res.statusCode===200)await this.fileService.writeFile(b,f.stream);else{const p=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};A=he([K(0,T.IRequestService),K(1,L.IFileService)],A),e.DownloadService=A}),define(te[194],ne([0,1,16,25,68,2,20,155,15,8,27,43]),function(Y,e,k,t,L,T,A,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(h,m,v,l){super();this.fileService=h,this.productService=m,this.requestService=v,this.logService=l,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const m=[];for(const[v,l]of this.allConfigBasedTips)if(!(l.configScheme&&l.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(h,v)),S=new Map;(0,L.forEach)(l.recommendations,({key:d,value:i})=>{if((0,k.isNonEmptyArray)(i.remotes))for(const c of i.remotes)S.set(c,{extensionId:d,extensionName:i.name,configName:l.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled});else m.push({extensionId:d,extensionName:i.name,configName:l.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})});const y=(0,R.getDomainsOfRemotes)(w.value.toString(),[...S.keys()]);for(const d of y){const i=S.get(d);i&&m.push(i)}}catch{}return m}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(h.res.statusCode!==200)return[];const m=await(0,E.asJson)(h);return m?m.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=he([K(0,C.IFileService),K(1,P.IProductService),K(2,E.IRequestService),K(3,b.ILogService)],f),e.ExtensionTipsService=f}),define(te[91],ne([0,1,71,6]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,k.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[195],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[196],ne([0,1,75,5,25,3,2,18,29,8,91,195]),function(Y,e,k,t,L,T,A,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(m){this.logService=m,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(m){const v=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const l=(0,P.hash)(m);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(m));const w=new L.CancellationTokenSource;let S,y,d;this.processeDisposables.set(l,n=>{w.dispose(!0),S?.terminate(m,L.CancellationToken.None),y?.close(),d?.close(),this.processeDisposables.delete(l);const o=this.processResolvers.get(l);o&&(this.processResolvers.delete(l),o({reason:n}))}),S=await this.getOrCreateWebWorker(m);const i=new Promise(n=>{this.processResolvers.set(l,n)});if(w.token.isCancellationRequested)return i;const{port1:c,port2:r}=new MessageChannel;return y=c,d=r,await S.spawn(m,d,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",m,[y])),i}getOrCreateWebWorker(m){let v=this.workers.get(m.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${m.process.moduleId})`);const l=new p(m.process.type,this.logService);v=l.init(),l.onDidProcessSelfTerminate(({configuration:w,reason:S})=>{this.doDisposeWorker(w,S)}),this.workers.set(m.process.moduleId,v)}return v}async disposeWorker(m){return this.doDisposeWorker(m)}doDisposeWorker(m,v){const l=this.processeDisposables.get((0,P.hash)(m));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),l(v))}};f=he([K(0,b.ILogService)],f),e.SharedProcessWorkerService=f;class p extends A.Disposable{constructor(m,v){super();this.type=m,this.logService=v,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const m=new t.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},v.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},v.onmessage=l=>{const{id:w,message:S,configuration:y,nonce:d}=l.data;switch(w){case E.SharedProcessWorkerMessages.Ready:m.complete(v);break;case E.SharedProcessWorkerMessages.Ack:if(d){const i=this.mapMessageNonceToPendingMessageResolve.get(d);i&&(this.mapMessageNonceToPendingMessageResolve.delete(d),i())}break;case E.SharedProcessWorkerMessages.SelfTerminated:y&&S&&this._onDidProcessSelfTerminate.fire({configuration:y,reason:JSON.parse(S)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,S);break;case E.SharedProcessWorkerMessages.Info:S&&this.logService.info(S);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,S);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,S);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),m.p}async send(m,v,l){const w=await this.workerReady;if(!v.isCancellationRequested)return new Promise(S=>{const y=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(y,S);const d={...m,nonce:y};l?w.postMessage(d,[l]):w.postMessage(d),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(y)&&S()})})}spawn(m,v,l){const w={id:E.SharedProcessWorkerMessages.Spawn,configuration:m,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath}};return this.send(w,l,v)}terminate(m,v){const l={id:E.SharedProcessWorkerMessages.Terminate,configuration:m};return this.send(l,v)}}}),define(te[197],ne([0,1,54,18,154]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.userData})}}he([k.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(te[92],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[198],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>Y(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const R=String(k._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,176,11,76,6]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(l={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=l,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(l,w){w===b?(l===0?this._globalKeyTargets=void 0:l===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:l})):this._onDidChangeValue.fire({scope:l,key:w,target:this.getKeyTargets(l)[w]})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}get(l,w,S){return this.getStorage(w)?.get(l,S)}getBoolean(l,w,S){return this.getStorage(w)?.getBoolean(l,S)}getNumber(l,w,S){return this.getStorage(w)?.getNumber(l,S)}store(l,w,S,y){if((0,A.isUndefinedOrNull)(w)){this.remove(l,S);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,S,y),this.getStorage(S)?.set(l,w)})}remove(l,w){this.withPausedEmitters(()=>{this.updateKeyTarget(l,w,void 0),this.getStorage(w)?.delete(l)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,w){const S=[],y=this.getKeyTargets(l);for(const d of Object.keys(y))y[d]===w&&S.push(d);return S}updateKeyTarget(l,w,S){const y=this.getKeyTargets(w);typeof S=="number"?y[l]!==S&&(y[l]=S,this.getStorage(w)?.set(b,JSON.stringify(y))):typeof y[l]=="number"&&(delete y[l],this.getStorage(w)?.set(b,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(l){return l===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(l){const w=this.get(b,l);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(l){return this.getBoolean(e.IS_NEW_KEY,l)===!0}async flush(l=P.NONE){this._onWillSaveState.fire({reason:l});const w=this.getStorage(0),S=this.getStorage(1);switch(l){case P.NONE:await k.Promises.settled([w?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([w?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve()]);break}}async logStorage(){const l=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return m(l,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l))),this._register(this.globalStorage.onDidChangeStorage(l=>this.emitDidChangeValue(0,l)))}getStorage(l){return l===0?this.globalStorage:this.workspaceStorage}getLogDetails(l){return l===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(l){}}e.InMemoryStorageService=h;async function m(v,l,w,S){const y=s=>{try{return JSON.parse(s)}catch{return s}},d=new Map,i=new Map;v.forEach((s,a)=>{d.set(a,s),i.set(a,y(s))});const c=new Map,r=new Map;l.forEach((s,a)=>{c.set(a,s),r.set(a,y(s))}),console.group(`Storage: Global (path: ${w})`);let n=[];d.forEach((s,a)=>{n.push({key:a,value:s})}),console.table(n),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${S})`);let o=[];c.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=m}),define(te[199],ne([0,1,3,2,11,30,31,23]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends t.Disposable{constructor(E,f){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(E)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(f.onDidInstallExtensions(p=>p.forEach(({local:h,operation:m})=>{h&&m===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(E,f){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}async disableExtension(E,f){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let f=this.getDisabledExtensions();return f.every(p=>!(0,A.areSameExtensions)(p,E))?(f.push(E),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(E){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const h=f[p];if((0,A.areSameExtensions)(h,E))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(E){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,f){this.storageManger.set(E,f,0)}};C=he([K(0,R.IStorageService),K(1,T.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class b extends t.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(E,f){let p;return f===0?((0,L.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,f)),p=this.storage[E]):p=this._get(E,f),JSON.parse(p)}set(E,f,p){let h=JSON.stringify(f.map(({id:v,uuid:l})=>({id:v,uuid:l})));this._get(E,p)!==h&&(p===0&&(f.length?this.storage[E]=h:delete this.storage[E]),this._set(E,f.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),m=p.filter(l=>!h.some(w=>(0,A.areSameExtensions)(l,w))),v=h.filter(l=>!p.some(w=>(0,A.areSameExtensions)(w,l)));(m.length||v.length)&&this._onDidChange.fire([...m,...v])}}_get(E,f){return this.storageService.get(E,f,"[]")}_set(E,f,p){f?this.storageService.store(E,f,p,1):this.storageService.remove(E,p)}}e.StorageManager=b}),define(te[63],ne([0,1,6,3,2,23,31,27,16,8,11]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class tt extends L.Disposable{constructor(h,m,v){super();this.storageService=h,this.productService=m,this.logService=v,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(l=>this.onDidChangeStorageValue(l)))}static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const m=E.exec(h);if(m&&m[1])return{id:m[1],version:m[2]}}initialize(){const h=this.storageService.keys(0,1);for(const m of h){const v=tt.fromKey(m);v&&this.extensionsWithKeysForSync.add(v.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const m=tt.fromKey(h.key);if(m){this.extensionsWithKeysForSync.add(m.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(h){if((0,P.isString)(h))return h;const m=h.manifest?h.manifest.publisher:h.publisher,v=h.manifest?h.manifest.name:h.name;return(0,A.getExtensionId)(m,v)}getExtensionState(h,m){const v=this.getExtensionId(h),l=this.storageService.get(v,m?0:1);if(l)try{return JSON.parse(l)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${m}): ${w}`)}}setExtensionState(h,m,v){const l=this.getExtensionId(h);m===void 0?this.storageService.remove(l,v?0:1):this.storageService.store(l,JSON.stringify(m),v?0:1,1)}setKeysForSync(h,m){this.storageService.store(tt.toKey(h),JSON.stringify(m),0,1)}getKeysForSync(h){const m=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],v=this.storageService.get(tt.toKey(h),0),l=v?JSON.parse(v):void 0;return l&&m?(0,C.distinct)([...l,...m]):l||m}addToMigrationList(h,m){if(h!==m){const v=this.migrationList.filter(l=>!l.includes(h)&&!l.includes(m));v.push([h,m]),this.migrationList=v}}getSourceExtensionToMigrate(h){const m=this.migrationList.find(([,v])=>h===v);return m?m[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const m=JSON.parse(h);if((0,P.isArray)(m))return m}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=he([K(0,T.IStorageService),K(1,R.IProductService),K(2,b.ILogService)],f),e.ExtensionStorageService=f}),define(te[200],ne([0,1,2,30,63,187,8]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends k.Disposable{constructor(b,P,E,f,p){super();b.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(b,P,E,f,p)}};R=he([K(0,t.IExtensionManagementService),K(1,t.IExtensionGalleryService),K(2,L.IExtensionStorageService),K(3,t.IGlobalExtensionEnablementService),K(4,A.ILogService)],R),e.ExtensionsCleaner=R}),define(te[201],ne([0,1,3,2]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends t.Disposable{constructor(b,P){super();this.channel=b,this.workspace=P}async getItems(){const b={workspace:this.workspace},P=await this.channel.call("getItems",b);return new Map(P)}updateItems(b){const P={workspace:this.workspace};return b.insert&&(P.insert=Array.from(b.insert.entries())),b.delete&&(P.delete=Array.from(b.delete.values())),this.channel.call("updateItems",P)}}class T extends L{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(b,P){super(b,P);this.onDidChangeItemsExternal=k.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class R extends t.Disposable{constructor(b,P){super();this.channel=b,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[202],ne([0,1,5,2,20,76,23,201]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends A.AbstractStorageService{constructor(P,E,f){super();this.mainProcessService=E,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new t.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new T.Storage(P.globalStorage);return this._register(E.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),E}createWorkspaceStorage(P){const E=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(E.workspaceStorage){const f=new T.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const E=this.workspaceStorage,f=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,h]of f)this.workspaceStorage.set(p,h)}}e.NativeStorageService=C}),define(te[203],ne([0,1,4,33,7,29]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(k.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function R(b,P,E,f,p,h,m,v,l,w){const S=Object.create(null);S["common.machineId"]=m,S.sessionID=(0,T.generateUuid)()+Date.now(),S.commitHash=p,S.version=h,S["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,k.PlatformToString)(k.platform),S["common.nodePlatform"]=t.platform,S["common.nodeArch"]=f,S["common.product"]=w||"desktop";const y=C(v||[]);y&&(S["common.msftInternal"]=y);let d=0;const i=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),k.isLinuxSnap&&(S["common.snap"]="true");const c=A(E);c&&(S["common.platformDetail"]=c);try{const r=await b.readFile(L.URI.file(l));S["common.source"]=r.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=R;function C(b){const P=t.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return b.some(f=>E===f)}e.verifyMicrosoftInternalDomain=C}),define(te[21],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,34,55,5,35,18,10,4,7,113,22,116,81,15,27,21]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const l=new Map;async function w(c,r,n){const o=`${c}::${r.join(":")}`;console.log(o);const s=l.get(o);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,g=new Map,I=n??2e4;function _(M,D,U,z){const B=D.substring(M.length+1);return L.Promises.withAsyncBody(async q=>{let G;try{G=await E.Promises.readdir(D,{withFileTypes:!0})}catch{q();return}if(z.count>=I){z.count+=G.length,z.maxReached=!0,q();return}let re=G.length;if(re===0){q();return}let H=G;z.count+G.length>I&&(z.maxReached=!0,re=I-z.count,H=G.slice(0,re)),z.count+=G.length;for(const j of H)if(j.isDirectory()){if(U.includes(j.name)||await _(M,(0,R.join)(D,j.name),U,z),--re==0){q();return}}else{const Q=j.name.lastIndexOf(".");if(Q>=0){const x=j.name.substring(Q+1);x&&u.set(x,(u.get(x)??0)+1)}for(const x of a)x.relativePathPattern?.test(B)!==!1&&x.filePattern.test(j.name)&&g.set(x.tag,(g.get(x.tag)??0)+1);if(--re==0){q();return}}})}const O=L.Promises.withAsyncBody(async M=>{const D={count:0,maxReached:!1};await _(c,c,r,D);const U=await d(c);M({configFiles:S(g),fileTypes:S(u),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:U})});return l.set(o,O),O}e.collectWorkspaceStats=w;function S(c){return[...t.Iterable.map(c.entries(),([r,n])=>({name:r,count:n}))].sort((r,n)=>n.count-r.count)}function y(){const c={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},r=k.cpus();return r&&r.length>0&&(c.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),c}e.getMachineInfo=y;async function d(c){try{const r=new Map,n=(0,R.join)(c,".vscode","launch.json"),o=await E.Promises.readFile(n),s=[],a=(0,T.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const u of a.configurations){const g=u.type;g&&(r.has(g)?r.set(g,r.get(g)+1):r.set(g,1))}return S(r)}catch{return[]}}e.collectLaunchConfigs=d;let i=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const o=k.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||n.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,f.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[s,a]=o,u=this.formatProcessList(r,s);return n.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,a+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(r,g.processes)}`),g.workspaceMetadata){a+=`
|  Remote: ${g.hostName}`;for(const I of Object.keys(g.workspaceMetadata)){const _=g.workspaceMetadata[I];let O=`${_.fileCount} files`;_.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${I}): ${O}`,a+=this.formatWorkspaceStats(_)}}}),{processInfo:u,workspaceInfo:a}})}async getSystemInfo(r,n){const{memory:o,vmHint:s,os:a,cpus:u}=y(),g={os:a,memory:o,cpus:u,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return C.isWindows||(g.load=`${k.loadavg().map(I=>Math.round(I)).join(", ")}`),C.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(r,n){const o=[];return(0,f.listProcesses)(r.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,s)),r.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),n.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(r,a.processes)),a.workspaceMetadata)for(const u of Object.keys(a.workspaceMetadata)){const g=a.workspaceMetadata[u];let I=`${g.fileCount} files`;g.maxFilesReached&&(I=`more than ${I}`),o.push(`Folder (${u}): ${I}`),o.push(this.formatWorkspaceStats(g))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const n=[],o=60;let s=0;const a=(_,O)=>{const M=` ${_}(${O})`;s+M.length>o?(n.push(u),u="|                 ",s=u.length):s+=M.length,u+=M};let u="|      File types:";const g=10;let I=r.fileTypes.length>g?g:r.fileTypes.length;for(let _=0;_<I;_++){const O=r.fileTypes[_];a(O.name,O.count)}if(n.push(u),r.configFiles.length>=0&&(u="|      Conf files:",s=0,r.configFiles.forEach(_=>{a(_.name,_.count)}),n.push(u)),r.launchConfigFiles.length>0){let _="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{_+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(_)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],o=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const u=b.URI.revive(a);if(u.scheme===A.Schemas.file){const g=u.fsPath;o.push(w(g,["node_modules",".git"]).then(I=>{let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),n.push(`|    Folder (${(0,R.basename)(g)}): ${_}`),n.push(this.formatWorkspaceStats(I))}).catch(I=>{n.push(`|      Error: Unable to collect workspace stats for folder ${g} (${I.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,n){const o=new Map;r.windows.forEach(a=>o.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,o,s,n,0),s.join(`
`)}formatProcessItem(r,n,o,s,a){const u=a===0;let g;u?g=s.pid===r?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(g=`${g} (${n.get(s.pid)})`));const I=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(_=>this.formatProcessItem(r,n,o,_,a+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:o}of r.folders){const s=b.URI.revive(o);if(s.scheme!==A.Schemas.file)continue;const a=s.fsPath;try{(await w(a,["node_modules",".git"],1e3)).fileTypes.forEach(g=>n.add(g.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const o=b.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{const a=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),a.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:u.name,count:u.count})}),a.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:u.name,count:u.count})}),a.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};i=he([K(0,v.ITelemetryService),K(1,m.IProductService)],i),e.DiagnosticsService=i}),define(te[205],ne([0,1,16,5,25,9,3,2,4,11,7,129,30,31,8,27,21]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let l=class extends R.Disposable{constructor(c,r,n,o){super();this.galleryService=c,this.telemetryService=r,this.logService=n,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const r=await this.getTargetPlatform();return c.allTargetPlatforms.some(n=>(0,f.isTargetPlatformCompatible)(n,c.allTargetPlatforms,r))}async installFromGallery(c,r={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(E.localize(0,null),f.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(c,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,r)}catch(n){throw y(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(c),void 0,n),this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(n),S(n)}}async uninstall(c,r={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,r)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const r=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...c.identifier,preRelease:c.preRelease}],{targetPlatform:r,compatible:!0},L.CancellationToken.None);if(!n)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtension(c,r,n){if(!P.URI.isUri(r)){let g=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(g)return this.logService.info("Extensions is already requested to install",r.identifier.id),g.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],a=this.createInstallExtensionTask(c,r,n);P.URI.isUri(r)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:r}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:c});let u=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:_,manifest:O}of I)if(u=u||!!O.extensionDependencies?.some(M=>(0,p.areSameExtensions)({id:M},a.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const M=this.createInstallExtensionTask(O,_,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(M.identifier,O.version).key(),M),this._onInstallExtension.fire({identifier:M.identifier,source:_}),this.logService.info("Installing extension:",M.identifier.id),o.push({task:M,manifest:O})}}catch(I){if(P.URI.isUri(a.source))(0,k.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,I.message),(0,k.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),I}const g=o.reduce((I,{task:_,manifest:O})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),I),new Map);for(;g.size;){let I;const _=[...g.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(M=>g.has(M.toLowerCase())));_.length?I=g.size===1?_:_.filter(({task:O})=>!(O===a&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),I=[...g.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const M=new Date().getTime(),D=(0,b.isUndefined)(n.operation)?O.operation:n.operation;try{const U=await O.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(U,O.source,n,L.CancellationToken.None))),!P.URI.isUri(O.source)&&(y(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,void 0),C.isWeb&&D!==3))try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}s.push({local:U,identifier:O.identifier,operation:D,source:O.source})}catch(U){throw P.URI.isUri(O.source)||y(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,U),this.logService.error("Error while installing the extension:",O.identifier.id),U}finally{g.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:I})=>(0,p.areSameExtensions)(I,a.identifier))[0].local}catch(g){if(o.forEach(({task:I})=>I.cancel()),s.length)try{const I=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const O=I[_],{identifier:M}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,T.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(I),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),g}finally{for(const{task:g,manifest:I}of o)if(!P.URI.isUri(g.source)){const _=new p.ExtensionIdentifierWithVersion(g.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(c){const r=[],n=[],o=await Promise.allSettled(c);for(const s of o)s.status==="fulfilled"?r.push(s.value):n.push(s.reason);if(n.length)throw w(n);return r}async getAllDepsAndPackExtensionsToInstall(c,r,n,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[c,...s.map(I=>I.identifier)],u=[],g=async(I,_)=>{const O=_.extensionDependencies||[],M=[...O];if(_.extensionPack){const D=n?s.find(U=>(0,p.areSameExtensions)(U.identifier,I)):void 0;for(const U of _.extensionPack)D&&D.manifest.extensionPack&&D.manifest.extensionPack.some(z=>(0,p.areSameExtensions)({id:z},{id:U}))||M.every(z=>!(0,p.areSameExtensions)({id:z},{id:U}))&&M.push(U)}if(M.length){const D=[...a,...u.map(z=>z.gallery.identifier)],U=M.filter(z=>D.every(B=>!(0,p.areSameExtensions)(B,{id:z})));if(U.length){const z=await this.galleryService.getExtensions(U.map(B=>({id:B,preRelease:o})),L.CancellationToken.None);for(const B of z){if(D.find(re=>(0,p.areSameExtensions)(re,B.identifier)))continue;const q=O.some(re=>(0,p.areSameExtensions)({id:re},B.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(B,!0,o)}catch(re){if(re instanceof f.ExtensionManagementError&&re.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.logService.info("Skipping the packed extension as it cannot be installed",B.identifier.id);continue}else throw re}u.push({gallery:G.extension,manifest:G.manifest}),await g(G.extension.identifier,G.manifest)}}}};return await g(c,r),s=await this.getInstalled(),u.filter(I=>!s.some(_=>(0,p.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(c,r,n){const o=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(o).has(c.identifier.id))throw new f.ExtensionManagementError(E.localize(3,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[c.identifier.id])throw new f.ExtensionManagementError(E.localize(4,null,c.identifier.id,o.unsupportedPreReleaseExtensions[c.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(c)){const u=await this.getTargetPlatform();throw new f.ExtensionManagementError(E.localize(5,null,c.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(u)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(c,r,n);if(s){if(n&&r&&c.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(E.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(E.localize(7,null,c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(E.localize(8,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const a=await this.galleryService.getManifest(s,L.CancellationToken.None);if(a===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(a.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:a}}async getCompatibleVersion(c,r,n){const o=await this.getTargetPlatform();let s=null;return r&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==n&&(s=(await this.galleryService.getExtensions([{...c.identifier,preRelease:n}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(c,n,o)&&(s=c),!s&&r&&(s=await this.galleryService.getCompatibleExtension(c,n,o)),s}async unininstallExtension(c,r){const n=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),n.waitUntilTaskIsFinished();const o=(g,I)=>{const _=this.createUninstallExtensionTask(g,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),_},s=(g,I)=>{I?this.logService.error("Failed to uninstall extension:",g.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(g),void 0,I),this._onDidUninstallExtension.fire({identifier:g.identifier,error:I?.code})},a=[],u=[];try{a.push(o(c,{}));const g=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(c,g);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(o(_,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(I=>I.extension),g,c),await this.joinAllSettled(a.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,r,L.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}s(I.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(I.extension,O),O}finally{u.push(I)}}))}catch(g){const I=g instanceof f.ExtensionManagementError?g:new f.ExtensionManagementError((0,T.getErrorMessage)(g),f.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}u.includes(_)||s(_.extension,I)}throw I}finally{for(const g of a)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(c,r,n){for(const o of c){const s=this.getDependents(o,r);if(s.length){const a=s.filter(u=>!c.some(g=>(0,p.areSameExtensions)(g.identifier,u.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,n))}}}getDependentsErrorMessage(c,r,n){return n===c?r.length===1?E.localize(9,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(12,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(13,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(14,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(c,r,n=[]){if(n.indexOf(c)!==-1)return[];n.push(c);const o=c.manifest.extensionPack?c.manifest.extensionPack:[];if(o.length){const s=r.filter(u=>!u.isBuiltin&&o.some(g=>(0,p.areSameExtensions)({id:g},u.identifier))),a=[];for(const u of s)a.push(...this.getAllPackExtensionsToUninstall(u,r,n));return[...s,...a]}return[]}getDependents(c,r){return r.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(o=>(0,p.areSameExtensions)({id:o},c.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",c),c}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};l=he([K(0,f.IExtensionGalleryService),K(1,v.ITelemetryService),K(2,h.ILogService),K(3,m.IProductService)],l),e.AbstractExtensionManagementService=l;function w(i){const c=Array.isArray(i)?i:[i];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((r,n)=>new Error(`${r.message}${r.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=w;function S(i){if(i instanceof f.ExtensionManagementError)return i;const c=new f.ExtensionManagementError(i.message,f.ExtensionManagementErrorCode.Internal);return c.stack=i.stack,c}function y(i,c,r,n,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;i.publicLogError(c,{...r,success:!o,duration:n,errorcode:s})}e.reportTelemetry=y;class d{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>new Promise((r,n)=>{const o=c.onCancellationRequested(()=>{o.dispose(),n((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=d}),define(te[206],ne([0,1,16,5,68,3,10,4,33,7,131,14,30,31,194,83,15,8,60,27,43,23,21]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const c="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends h.ExtensionTipsService{constructor(s,a,u,g,I,_,O,M,D,U){super(O,M,D,U);this.environmentService=s,this.telemetryService=a,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=I,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,M.exeBasedExtensionTips&&(0,L.forEach)(M.exeBasedExtensionTips,({key:z,value:B})=>{const q=[],G=[],re=[];(0,L.forEach)(B.recommendations,({key:H,value:j})=>{j.important?B.important?q.push({extensionId:H,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):G.push({extensionId:H,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):re.push({extensionId:H,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),q.length&&this.highImportanceExecutableTips.set(z,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:q}),G.length&&this.mediumImportanceExecutableTips.set(z,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:G}),re.length&&this.allOtherExecutableTips.set(z,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:re})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,u)}groupImportantTipsByExe(s,a){const u=new Map;s.forEach(M=>u.set(M.extensionId.toLowerCase(),M));const{installed:g,uninstalled:I}=this.groupByInstalled([...u.keys()],a);for(const M of g){const D=u.get(M);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:M,exeName:D.exeName})}for(const M of I){const D=u.get(M);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:M,exeName:D.exeName})}const _=this.getPromptedExecutableTips(),O=new Map;for(const M of I){const D=u.get(M);if(D&&(!_[D.exeName]||!_[D.exeName].includes(D.extensionId))){let U=O.get(D.exeName);U||(U=[],O.set(D.exeName,U)),U.push(D)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,t.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),a=Date.now()-s,u=7*24*60*60*1e3;if(a<u){const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u-a));return}const[g,I]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(I).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(I[0].exeName,I);const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const a=await this.extensionManagementService.getInstalled(1),u=s.filter(I=>!I.whenNotInstalled||I.whenNotInstalled.every(_=>a.every(O=>!(0,p.areSameExtensions)(O.identifier,{id:_})))).map(({extensionId:I})=>I.toLowerCase()),g=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,g,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(r,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(r,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(c,0,"{}"))}addToRecommendedExecutables(s,a){const u=this.getPromptedExecutableTips();u[s]=a.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(c,JSON.stringify(u),0,0)}groupByInstalled(s,a){const u=[],g=[],I=a.reduce((_,O)=>(_.add(O.identifier.id.toLowerCase()),_),new Set);return s.forEach(_=>{I.has(_.toLowerCase())?u.push(_):g.push(_)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const a=[],u=new Map;for(const g of s.keys()){const I=s.get(g);if(!I||!(0,k.isNonEmptyArray)(I.recommendations))continue;const _=[];R.isWindows?I.windowsPath&&_.push(I.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(_.push((0,A.join)("/usr/local/bin",g)),_.push((0,A.join)("/usr/bin",g)),_.push((0,A.join)(this.environmentService.userHome.fsPath,g)));for(const O of _){let M=u.get(O);if(M===void 0&&(M=await this.fileService.exists(b.URI.file(O)),u.set(O,M)),M)for(const{extensionId:D,extensionName:U,isExtensionPack:z,whenNotInstalled:B}of I.recommendations)a.push({extensionId:D,extensionName:U,isExtensionPack:z,exeName:g,exeFriendlyName:I.exeFriendlyName,windowsPath:I.windowsPath,whenNotInstalled:B})}}return a}};n=he([K(0,E.INativeEnvironmentService),K(1,i.ITelemetryService),K(2,f.IExtensionManagementService),K(3,d.IStorageService),K(4,w.INativeHostService),K(5,m.IExtensionRecommendationNotificationService),K(6,v.IFileService),K(7,S.IProductService),K(8,y.IRequestService),K(9,l.ILogService)],n),e.ExtensionTipsService=n}),define(te[93],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:R,data:C}){return this.appenders.forEach(b=>b.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class t{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[44],ne([0,1,28,11,19,21]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,w){return Promise.resolve(void 0)}publicLog2(l,w){return this.publicLog(l,w)}publicLogError(l,w){return Promise.resolve(void 0)}publicLogError2(l,w){return this.publicLogError(l,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class R{async publicLog(l,w,S){}async publicLogError(l,w,S){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(v,l){return l.onDidChangeConfiguration(w=>{w.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=C;function b(v,l){return!(l.disableTelemetry||!v.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=b;function P(v){const l=v.getValue(T.TELEMETRY_SETTING_ID),w=v.getValue("telemetry.enableCrashReporter");if(v.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function E(v){const l=Object.create(null),w=Object.create(null),S=Object.create(null);p(v,S);for(let y in S){y=y.length>150?y.substr(y.length-149):y;const d=S[y];typeof d=="number"?w[y]=d:typeof d=="boolean"?w[y]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${d.length}`),l[y]=d.substring(0,8191)):typeof d!="undefined"&&d!==null&&(l[y]=d)}return{properties:l,measurements:w}}e.validateTelemetryData=E;function f(v){if(!v)return"none";let l="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{v.indexOf(`${S}+`)===0&&(l=S)}),l}e.cleanRemoteAuthority=f;function p(v,l,w=0,S){if(!!v)for(let y of Object.getOwnPropertyNames(v)){const d=v[y],i=S?S+y:y;Array.isArray(d)?l[i]=(0,k.safeStringify)(d):d instanceof Date?l[i]=d.toISOString():(0,t.isObject)(d)?w<2?p(d,l,w+1,i+"."):l[i]=(0,k.safeStringify)(d):l[i]=d}}function h(v){if(!v)return[];const l=[];return m(l,"",v),l}function m(v,l,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(S=>m(v,l?`${l}.${S}`:S,w[S])):v.push(l)}}),define(te[207],ne([0,1,44,150]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(C,b){}postEvent(C,b){}}class T{constructor(C,b,P,E,f){this.getMachineId=C,this.configurationService=b,this.productService=P,this.telemetry=E,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(m=>setTimeout(m,h))}get experimentsEnabled(){return!0}async getTreatment(C){await this.overrideInitDelay;const b=this.configurationService.getValue("experiments.override."+C);if(b!==void 0)return b;if(!this.tasClient||!this.experimentsEnabled)return;let P;const E=await this.tasClient;return this.networkInitialized?P=E.getTreatmentVariable("vscode",C):P=await E.getTreatmentVariableAsync("vscode",C,!0),P=E.getTreatmentVariable("vscode",C),P}async setupTASClient(){const C=this.productService.quality==="stable"?t.TargetPopulation.Public:t.TargetPopulation.Insiders,b=await this.getMachineId(),P=new t.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,b,C),E=this.productService.tasConfig,f=new(await new Promise((p,h)=>{Y(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:t.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:t.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(C,b,P){super(()=>Promise.resolve(C),b,P,new L)}}e.AssignmentService=A}),define(te[208],ne([0,1,47,44]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,R,C,b,P){const E={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},f=await(0,k.getServiceMachineId)(R,b,P);return(0,t.supportsTelemetry)(A,R)&&(0,t.getTelemetryLevel)(C)===3&&(E["X-Market-User-Id"]=f),E}e.resolveMarketplaceHeaders=L}),define(te[209],ne([0,1,16,25,9,28,4,33,11,7,19,14,30,31,79,15,8,27,43,208,23,21]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,R.arch);var c;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(c||(c={}));function r(...N){return String(N.reduce(($,V)=>$|V,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class g{constructor($=u){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,V=this.state.pageSize){return new g({...this.state,pageNumber:$,pageSize:V})}withFilter($,...V){const ee=[...this.state.criteria,...V.length?V.map(se=>({filterType:$,value:se})):[{filterType:$}]];return new g({...this.state,criteria:ee})}withSortBy($){return new g({...this.state,sortBy:$})}withSortOrder($){return new g({...this.state,sortOrder:$})}withFlags(...$){return new g({...this.state,flags:$.reduce((V,ee)=>V|ee,0)})}withAssetTypes(...$){return new g({...this.state,assetTypes:$})}get raw(){const{criteria:$,pageNumber:V,pageSize:ee,sortBy:se,sortOrder:ae,flags:de,assetTypes:ge}=this.state;return{filters:[{criteria:$,pageNumber:V,pageSize:ee,sortBy:se,sortOrder:ae}],assetTypes:ge,flags:de}}get searchText(){const $=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function I(N,$){const V=(N||[]).filter(ee=>ee.statisticName===$)[0];return V?V.value:0}function _(N){const $="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(ee=>ee.assetType.indexOf($)===0).reduce((ee,se)=>{const ae=U(N,se.assetType);return ae&&ee.push([se.assetType.substring($.length),ae]),ee},[])}function O(N){if(N.properties){const $=N.properties.filter(se=>se.key===o.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=$.filter(se=>V.test(se.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return U(N,o.Repository)}function M(N){return{uri:`${N.fallbackAssetUri}/${o.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${o.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function D(N){const $=U(N,o.Icon);if($)return $;const V=f.DefaultIconPath;return{uri:V,fallbackUri:V}}function U(N,$){return N.files.filter(ee=>ee.assetType===$)[0]?{uri:`${N.assetUri}/${$}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${$}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function z(N,$){const V=N.properties?N.properties.filter(se=>se.key===$):[],ee=V.length>0&&V[0].value;return ee?ee.split(",").map(se=>(0,p.adoptToGalleryExtensionId)(se)):[]}function B(N){const $=N.properties?N.properties.filter(V=>V.key===s.Engine):[];return $.length>0&&$[0].value||""}function q(N){const $=N.properties?N.properties.filter(V=>V.key===s.PreRelease):[];return $.length>0&&$[0].value==="true"}function G(N){const $=N.properties?N.properties.filter(ee=>ee.key===s.LocalizedLanguages):[],V=$.length>0&&$[0].value||"";return V?V.split(","):[]}function re(N){return N.indexOf("preview")!==-1}function H(N){return N.targetPlatform?(0,f.toTargetPlatform)(N.targetPlatform):"undefined"}function j(N){const $=(0,k.distinct)(N.versions.map(H)),V=!!N.tags?.includes(f.WEB_EXTENSION_TAG),ee=$.indexOf("web");return V?ee===-1&&$.push("web"):ee!==-1&&$.splice(ee,1),$}function Q(N,$){const V=(0,f.getFallbackTargetPlarforms)($);for(let ee=0;ee<N.length;ee++){const se=N[ee];if(se.version===N[ee-1]?.version){let ae=ee;const de=H(se);if(de===$)for(;ae>0&&N[ae-1].version===se.version;)ae--;else if(V.includes(de))for(;ae>0&&N[ae-1].version===se.version&&H(N[ae-1])!==$;)ae--;ae!==ee&&(N.splice(ee,1),N.splice(ae,0,se))}}return N}e.sortExtensionVersions=Q;function x(N,$,V){N.telemetryData={index:$,querySource:V}}function J(N,$,V){const ee=N.versions[0],se={manifest:U($,o.Manifest),readme:U($,o.Details),changelog:U($,o.Changelog),license:U($,o.License),repository:O($),download:M($),icon:D($),coreTranslations:_($)};return{identifier:{id:(0,p.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:$.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:I(N.statistics,"install"),rating:I(N.statistics,"averagerating"),ratingCount:I(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:V,assets:se,properties:{dependencies:z($,s.Dependency),extensionPack:z($,s.ExtensionPack),engine:B($),localizedLanguages:G($),targetPlatform:H($),isPreReleaseVersion:q($)},hasPreReleaseVersion:q(ee),hasReleaseVersion:!0,preview:re(N.flags)}}let Z=class{constructor($,V,ee,se,ae,de,ge,Ee){this.requestService=V,this.logService=ee,this.environmentService=se,this.telemetryService=ae,this.fileService=de,this.productService=ge,this.configurationService=Ee;const Se=ge.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,S.resolveMarketplaceHeaders)(ge.version,ge,this.environmentService,this.configurationService,this.fileService,$)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,V,ee){const se=t.CancellationToken.isCancellationToken(V)?{}:V,ae=t.CancellationToken.isCancellationToken(V)?V:ee,de=[],ge=[],Ee=[],Se=[];let pe=!0;for(const De of $){De.uuid?ge.push(De.uuid):de.push(De.id);const Ue=!!(De.version||De.preRelease);Ee.push({id:De.id,uuid:De.uuid,includePreRelease:Ue}),De.version&&Se.push({id:De.id,uuid:De.uuid,version:De.version}),pe=pe&&!!De.hasPreRelease&&!Ue}if(!ge.length&&!de.length)return[];let Ie=new g().withPage(1,$.length);ge.length&&(Ie=Ie.withFilter(n.ExtensionId,...ge)),de.length&&(Ie=Ie.withFilter(n.ExtensionName,...de)),(se.queryAllVersions||pe)&&(Ie=Ie.withFlags(Ie.flags,c.IncludeVersions));const{extensions:Ce}=await this.queryGalleryExtensions(Ie,{targetPlatform:se.targetPlatform??i,includePreRelease:Ee,versions:Se,compatible:!!se.compatible},ae);return se.source&&Ce.forEach((De,Ue)=>x(De,Ue,se.source)),Ce}async getCompatibleExtension($,V,ee){if((0,f.isNotWebExtensionInWebTargetPlatform)($.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible($,V,ee))return $;const se=new g().withFlags(c.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,$.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(se,{targetPlatform:ee,compatible:!0,includePreRelease:V},t.CancellationToken.None);return ae[0]||null}async isExtensionCompatible($,V,ee){if(!(0,f.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,ee)||!V&&$.properties.isPreReleaseVersion)return!1;let se=$.properties.engine;if(!se){const ae=await this.getManifest($,t.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");se=ae.engines.vscode}return(0,h.isEngineValid)(se,this.productService.version,this.productService.date)}async isValidVersion($,V,ee,se,ae){if(!(0,f.isTargetPlatformCompatible)(H($),se,ae)||V!=="any"&&q($)!==(V==="prerelease"))return!1;if(ee){const de=await this.getEngine($);if(!(0,h.isEngineValid)(de,this.productService.version,this.productService.date))return!1}return!0}async query($,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ee=$.text||"";const se=(0,T.getOrDefault)($,pe=>pe.pageSize,50);let ae=new g().withPage(1,se);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ie,Ce)=>(ae=ae.withFilter(n.Category,Ce||Ie),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ie,Ce)=>(ae=ae.withFilter(n.Tag,Ce||Ie),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),ae=ae.withFilter(n.SearchText,ee)),ae=ae.withSortBy(0)):$.ids?ae=ae.withFilter(n.ExtensionId,...$.ids):$.names?ae=ae.withFilter(n.ExtensionName,...$.names):ae=ae.withSortBy(4),typeof $.sortBy=="number"&&(ae=ae.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(ae=ae.withSortOrder($.sortOrder));const de=async(pe,Ie)=>{const{extensions:Ce,total:De}=await this.queryGalleryExtensions(pe,{targetPlatform:i,compatible:!1,includePreRelease:!!$.includePreRelease},Ie);return Ce.forEach((Ue,je)=>x(Ue,(pe.pageNumber-1)*pe.pageSize+je,$.source)),{extensions:Ce,total:De}},{extensions:ge,total:Ee}=await de(ae,V),Se=async(pe,Ie)=>{if(Ie.isCancellationRequested)throw new L.CancellationError;const{extensions:Ce}=await de(ae.withPage(pe+1),Ie);return Ce};return{firstPage:ge,total:Ee,pageSize:ae.pageSize,getPage:Se}}async queryGalleryExtensions($,V,ee){const se=$.flags;!!($.flags&c.IncludeLatestVersionOnly)&&!!($.flags&c.IncludeVersions)&&($=$.withFlags($.flags&~c.IncludeVersions,c.IncludeLatestVersionOnly)),!($.flags&c.IncludeLatestVersionOnly)&&!($.flags&c.IncludeVersions)&&($=$.withFlags($.flags,c.IncludeLatestVersionOnly)),V.versions?.length&&($=$.withFlags($.flags&~c.IncludeLatestVersionOnly,c.IncludeVersions)),$=$.withFlags($.flags,c.IncludeAssetUri,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeStatistics,c.IncludeVersionProperties);const{galleryExtensions:ae,total:de}=await this.queryRawGalleryExtensions($,ee);if(!($.flags&c.IncludeLatestVersionOnly)){const pe=[];for(const Ie of ae){const Ce=await this.toGalleryExtensionWithCriteria(Ie,V,!0);Ce&&pe.push(Ce)}return{extensions:pe,total:de}}const Ee=[],Se=new Map;for(let pe=0;pe<ae.length;pe++){const Ie=ae[pe],Ce={id:(0,p.getGalleryExtensionId)(Ie.publisher.publisherName,Ie.extensionName),uuid:Ie.extensionId},De=(0,C.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(je=>(0,p.areSameExtensions)(je,Ce))?.includePreRelease;let Ue=await this.toGalleryExtensionWithCriteria(Ie,V,!1);!Ue||Ue.properties.isPreReleaseVersion&&(!De||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==V.targetPlatform&&Ue.hasPreReleaseVersion?Se.set(Ie.extensionId,pe):Ee.push([pe,Ue])}if(Se.size){const pe=new Date().getTime(),Ie=new g().withFlags(se&~c.IncludeLatestVersionOnly,c.IncludeVersions).withPage(1,Se.size).withFilter(n.ExtensionId,...Se.keys()),{extensions:Ce}=await this.queryGalleryExtensions(Ie,V,ee);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:Se.size});for(const De of Ce){const Ue=Se.get(De.identifier.uuid);Ee.push([Ue,De])}}return{extensions:Ee.sort((pe,Ie)=>pe[0]-Ie[0]).map(([,pe])=>pe),total:de}}async toGalleryExtensionWithCriteria($,V,ee){const se={id:(0,p.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},ae=V.versions?.find(Se=>(0,p.areSameExtensions)(Se,se))?.version,de=(0,C.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Se=>(0,p.areSameExtensions)(Se,se))?.includePreRelease,ge=j($),Ee=Q($.versions,V.targetPlatform);if(V.compatible&&ee&&(0,f.isNotWebExtensionInWebTargetPlatform)(ge,V.targetPlatform))return null;for(let Se=0;Se<Ee.length;Se++){const pe=Ee[Se];if(!(ae&&pe.version!==ae)){if(await this.isValidVersion(pe,de?"any":"release",V.compatible,ge,V.targetPlatform))return J($,pe,ge);if(ae&&pe.version===ae)return null}}return ae||V.compatible?null:J($,$.versions[0],ge)}async queryRawGalleryExtensions($,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,c.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(c.Unpublished));const ee=await this.commonHeadersPromise,se=JSON.stringify($.raw),ae={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},de=new Date().getTime();let ge,Ee,Se=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:se,headers:ae},V),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Se};const pe=await(0,w.asJson)(ge);if(pe){const Ie=pe.results[0],Ce=Ie.extensions,De=Ie.resultMetadata&&Ie.resultMetadata.filter(Ue=>Ue.metadataType==="ResultCount")[0];return Se=De&&De.metadataItems.filter(Ue=>Ue.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:Se}}return{galleryExtensions:[],total:Se}}catch(pe){throw Ee=pe,pe}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-de,success:!!ge&&(0,w.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:Ee?(0,L.isCancellationError)(Ee)?"canceled":(0,L.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic($,V,ee,se){if(!this.isEnabled())return;const ae=A.isWeb?this.api(`/itemName/${$}.${V}/version/${ee}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${V}/${ee}/stats?statType=${se}`),de=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:ae,headers:Ee},t.CancellationToken.None)}catch{}}async download($,V,ee){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const se=(0,p.getGalleryExtensionTelemetryData)($),ae=new Date().getTime(),de=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:pe}),ge=ee===2?"install":ee===3?"update":"",Ee=ge?{uri:`${$.assets.download.uri}${b.URI.parse($.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${$.assets.download.fallbackUri}${b.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:$.assets.download,Se=await this.getAsset(Ee);await this.fileService.writeFile(V,Se.stream),de(new Date().getTime()-ae)}async getReadme($,V){if($.assets.readme){const ee=await this.getAsset($.assets.readme,{},V);return await(0,w.asText)(ee)||""}return""}async getManifest($,V){if($.assets.manifest){const ee=await this.getAsset($.assets.manifest,{},V),se=await(0,w.asText)(ee);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion($,V){const ee=U($,o.Manifest);if(!ee)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},ae=await this.getAsset(ee,{headers:se});return await(0,w.asJson)(ae)}async getCoreTranslation($,V){const ee=$.assets.coreTranslations.filter(se=>se[0]===V.toUpperCase())[0];if(ee){const se=await this.getAsset(ee[1]),ae=await(0,w.asText)(se);return ae?JSON.parse(ae):null}return null}async getChangelog($,V){if($.assets.changelog){const ee=await this.getAsset($.assets.changelog,{},V);return await(0,w.asText)(ee)||""}return""}async getAllCompatibleVersions($,V,ee){let se=new g().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?se=se.withFilter(n.ExtensionId,$.identifier.uuid):se=se.withFilter(n.ExtensionName,$.identifier.id);const{galleryExtensions:ae}=await this.queryRawGalleryExtensions(se,t.CancellationToken.None);if(!ae.length)return[];const de=j(ae[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(de,ee))return[];const ge=[],Ee=new Set;return await Promise.all(ae[0].versions.map(async Se=>{try{if(Ee.has(Se.version))return;await this.isValidVersion(Se,V?"any":"release",!0,de,ee)&&(ge.push({version:Se.version,date:Se.lastUpdated,isPreReleaseVersion:q(Se)}),Ee.add(Se.version))}catch{}})),ge}async getAsset($,V={},ee=t.CancellationToken.None){const se=await this.commonHeadersPromise,ae={type:"GET"},de={...se,...V.headers||{}};V={...V,...ae,headers:de};const ge=$.uri,Ee=$.fallbackUri,Se={...V,url:ge};try{const pe=await this.requestService.request(Se,ee);if(pe.res.statusCode===200)return pe;const Ie=await(0,w.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${Ie}`)}catch(pe){if((0,L.isCancellationError)(pe))throw pe;const Ie=(0,L.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:Ie});const Ce={...V,url:Ee};return this.requestService.request(Ce,ee)}}async getEngine($){let V=B($);if(!V){const ee=await this.getManifestFromRawExtensionVersion($,t.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");V=ee.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,w.asJson)($),ee=[],se={};if(V){for(const ae of V.malicious)ee.push({id:ae});if(V.unsupported)for(const ae of Object.keys(V.unsupported)){const de=V.unsupported[ae];(0,C.isBoolean)(de)||(se[ae.toLowerCase()]=de.preReleaseExtension)}if(V.migrateToPreRelease)for(const[ae,de]of Object.entries(V.migrateToPreRelease))(!de.engine||(0,h.isEngineValid)(de.engine,this.productService.version,this.productService.date))&&(se[ae.toLowerCase()]=de)}return{malicious:ee,unsupportedPreReleaseExtensions:se}}};Z=he([K(1,w.IRequestService),K(2,v.ILogService),K(3,E.IEnvironmentService),K(4,d.ITelemetryService),K(5,m.IFileService),K(6,l.IProductService),K(7,P.IConfigurationService)],Z);let W=class extends Z{constructor($,V,ee,se,ae,de,ge,Ee){super($,V,ee,se,ae,de,ge,Ee)}};W=he([K(0,y.IStorageService),K(1,w.IRequestService),K(2,v.ILogService),K(3,E.IEnvironmentService),K(4,d.ITelemetryService),K(5,m.IFileService),K(6,l.IProductService),K(7,P.IConfigurationService)],W),e.ExtensionGalleryService=W;let F=class extends Z{constructor($,V,ee,se,ae,de,ge){super(void 0,$,V,ee,se,ae,de,ge)}};F=he([K(0,w.IRequestService),K(1,v.ILogService),K(2,E.IEnvironmentService),K(3,d.ITelemetryService),K(4,m.IFileService),K(5,l.IProductService),K(6,P.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F}),define(te[94],ne([0,1,2,14,8,44]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(C,b,P=""){super();this.prefix=P;const E=C.getLogger(b.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(C.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,b){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,T.validateTelemetryData)(b))}};A=he([K(0,L.ILoggerService),K(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[95],ne([0,1,2,28,4,26,141,19,42,88,38,21,44]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(v,l){this._configurationService=l,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,l){this._experimentProperties[v]=l}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let l=v.sessionID,w=v["common.machineId"],S=v["common.firstSessionDate"],y=v["common.msftInternal"];return{sessionId:l,machineId:w,firstSessionDate:S,msftInternal:y}}dispose(){this._disposables.dispose()}_log(v,l,w,S){return this.telemetryLevel<l?Promise.resolve(void 0):this._commonProperties.then(y=>{w=(0,t.mixin)(w,y),w=(0,t.mixin)(w,this._experimentProperties),w=(0,t.cloneAndChange)(w,d=>{if(typeof d=="string")return this._cleanupInfo(d,S)}),this._appenders.forEach(d=>d.log(v,w))},y=>{console.error(y)})}publicLog(v,l,w){return this._log(v,3,l,w)}publicLog2(v,l,w){return this.publicLog(v,l,w)}publicLogError(v,l){return this.sendErrorTelemetry?this._log(v,2,l,!0):Promise.resolve(void 0)}publicLogError2(v,l){return this.publicLogError(v,l)}_anonymizeFilePaths(v){let l=v;const w=[];for(let i of this._cleanupPatterns)for(;;){const c=i.exec(v);if(!c)break;w.push([c.index,i.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(l="";;){const i=y.exec(v);if(!i)break;!S.test(i[0])&&w.every(([c,r])=>i.index<c||i.index>=r)&&(l+=v.substring(d,i.index)+"<REDACTED: user-file-path>",d=y.lastIndex)}return d<v.length&&(l+=v.substr(d)),l}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const l=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,S=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,y=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return S.test(l)?"<REDACTED: secret>":w.test(l)?"<REDACTED: email>":y.test(l)?"<REDACTED: token>":v}_cleanupInfo(v,l){let w=v;l&&(w=this._anonymizeFilePaths(w));for(let S of this._cleanupPatterns)w=w.replace(S,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([K(1,R.IConfigurationService)],p),e.TelemetryService=p;function h(){const m=(0,A.localize)(0,null,b.default.nameLong),v=b.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=L.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),S=(0,A.localize)(5,null),y=(0,A.localize)(6,null),d=(0,A.localize)(7,null),i=`
|       | ${w} | ${S} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${m} ${v} ${l}

&nbsp;

${d}
${i}

&nbsp;

${c}
`}P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,A.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,A.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[210],ne([0,1,9,28,44]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R,C){const b=await new Promise((E,f)=>{Y(["applicationinsights"],E,f)});let P;return b.defaultClient?(P=new b.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(b.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=b.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=C?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class A{constructor(C,b,P,E,f){this._eventPrefix=C,this._defaultData=b,this.testCollector=E,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(C){if(!!this._aiClient){if(typeof this._aiClient!="string"){C(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{C(b)},b=>{(0,k.onUnexpectedError)(b),console.error(b)})}}log(C,b){if(!!this._aiClient){b=(0,t.mixin)(b,this._defaultData),b=(0,L.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+C,properties:b.properties,measurements:b.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(C=>{this._withAIClient(b=>{try{b.flush({callback:()=>{this._aiClient=void 0,C(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[211],ne([0,1,18,58,19,14,8,21,93,94,95]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,m,v){this.configurationService=p,this.telemetryService=h,this.loggerService=m,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:m}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=h,v["common.vscodesessionid"]=m;const l=[p.id,JSON.stringify(v),p.aiKey],S=new t.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:l,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),y=[new C.TelemetryAppenderClient(S),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:y,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,m){await(await this.getCustomTelemetryService(p)).publicLog(h,m)}async publicLogError(p,h,m){await(await this.getCustomTelemetryService(p)).publicLogError(h,m)}};E=he([K(0,L.IConfigurationService),K(1,R.ITelemetryService),K(2,A.ILoggerService),K(3,T.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[212],ne([0,1,5,25,3,2,8]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(b,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((P,E)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...b});const p=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>E(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>p.cancel())])})}acceptReply(b,P){const E=this._pendingRequests.get(b);E?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),E(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};R=he([K(1,A.ILogService)],R),e.RequestStore=R}),define(te[96],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCommandIconError=e.TerminalCommandIcon=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(l){l.Shell="terminal.integrated.shell.",l.ShellArgs="terminal.integrated.shellArgs.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(l){l.ShellLinux="terminal.integrated.shell.linux",l.ShellMacOs="terminal.integrated.shell.osx",l.ShellWindows="terminal.integrated.shell.windows",l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationShellLinux="terminal.integrated.automationShell.linux",l.AutomationShellMacOs="terminal.integrated.automationShell.osx",l.AutomationShellWindows="terminal.integrated.automationShell.windows",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ShellArgsLinux="terminal.integrated.shellArgs.linux",l.ShellArgsMacOs="terminal.integrated.shellArgs.osx",l.ShellArgsWindows="terminal.integrated.shellArgs.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationCommandIcon="terminal.integrated.shellIntegration.commandIcon",l.ShellIntegrationCommandIconError="terminal.integrated.shellIntegration.commandIconError",l.ShellIntegrationCommandIconDefault="terminal.integrated.shellIntegration.commandIconDefault",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.Log="log",l.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(l){l.TerminalView="view",l.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(l){l.TriangleRight="triangle-right",l.ChevronRight="chevron-right"})(f=e.TerminalCommandIcon||(e.TerminalCommandIcon={}));var p;(function(l){l.TriangleRight="triangle-right",l.ChevronRight="chevron-right",l.X="x"})(p=e.TerminalCommandIconError||(e.TerminalCommandIconError={}));var h;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(te[213],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[214],ne([0,1,46,10,143,25,37,9,4,29,124,152,5]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let h;async function m(l,w,S){return w["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(S)&&!w["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(S)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(y,d)=>{const i=new T.CancellationTokenSource,c=setTimeout(()=>{i.dispose(!0),d(new Error((0,L.localize)(0,null)))},p);try{y(await v(l,i.token))}catch(r){!(0,R.isCancellationError)(r)&&!i.token.isCancellationRequested?d(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(r)))):y({})}finally{clearTimeout(c),i.dispose()}})),h)}e.getResolvedShellEnv=m;async function v(l,w){const S=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",S);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",y);const d=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(d+"(.*)"+d),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",c);const r=await(0,P.getSystemShell)(C.OS,c);return l.trace("getUnixShellEnvironment#shell",r),new Promise((n,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,t.basename)(r);let a,u;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${g} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${g} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,s==="tcsh"?u=["-ic"]:u=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const I=(0,k.spawn)(r,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});w.onCancellationRequested(()=>(I.kill(),o((0,R.canceled)()))),I.on("error",M=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(M)),o(M)});const _=[];I.stdout.on("data",M=>_.push(M));const O=[];I.stderr.on("data",M=>O.push(M)),I.on("close",(M,D)=>{const U=Buffer.concat(_).toString("utf8");l.trace("getUnixShellEnvironment#raw",U);const z=Buffer.concat(O).toString("utf8");if(z.trim()&&l.trace("getUnixShellEnvironment#stderr",z),M||D)return o(new Error((0,L.localize)(2,null,M,D)));const B=i.exec(U),q=B?B[1]:"{}";try{const G=JSON.parse(q);S?G.ELECTRON_RUN_AS_NODE=S:delete G.ELECTRON_RUN_AS_NODE,y?G.ELECTRON_NO_ATTACH_CONSOLE=y:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",G),n(G)}catch(G){l.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(G)),o(G)}})})}}),define(te[215],ne([0,1,34,28,10,4,33,11,22]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let f=0;return E&&E.length===4&&(f=parseInt(E[3])),f}e.getWindowsBuildNumber=b;async function P(E,f,p,h=A.env,m=C.Promises.exists){if(L.isAbsolute(E))return await m(E)?E:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(E)!=="."){const S=L.join(f,E);return await m(S)?S:void 0}const l=(0,t.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,R.isString)(l)&&(p=l.split(L.delimiter)),p===void 0||p.length===0){const S=L.join(f,E);return await m(S)?S:void 0}for(let S of p){let y;if(L.isAbsolute(S)?y=L.join(S,E):y=L.join(f,S,E),await m(y))return y;if(T.isWindows){let d=y+".com";if(await m(d)||(d=y+".exe",await m(d)))return d}}const w=L.join(f,E);return await m(w)?w:void 0}e.findExecutable=P}),define(te[216],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,48,3,2,6,38,216]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(v){function l(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=l})(C=e.ThemeColor||(e.ThemeColor={}));function b(v){return{id:v}}e.themeColorFromId=b;var P;(function(v){function l(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}v.isThemeIcon=l;const w=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function S(n){const o=w.exec(n);if(!o)return;let[,s]=o;return{id:s}}v.fromString=S;function y(n){return{id:n}}v.fromId=y;function d(n,o){let s=n.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}v.modify=d;function i(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}v.getModifier=i;function c(n,o){return n.id===o.id&&n.color?.id===o.color?.id}v.isEqual=c;function r(n,o){return{id:n.id,color:o?b(o):void 0}}v.asThemeIcon=r,v.asClassNameArray=k.CSSIcon.asClassNameArray,v.asClassName=k.CSSIcon.asClassName,v.asCSSSelector=k.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(v){switch(v){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(l){return this.themingParticipants.push(l),this.onThemingParticipantAddedEmitter.fire(l),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(l);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;A.Registry.add(e.Extensions.ThemingContribution,p);function h(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=h;class m extends L.Disposable{constructor(l){super();this.themeService=l,this.theme=l.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(l){this.theme=l,this.updateStyles()}updateStyles(){}getColor(l,w){let S=this.theme.getColor(l);return S&&w&&(S=w(S,this.theme)),S?S.toString():null}}e.Themable=m}),define(te[217],ne([0,1,48,7,97]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(E,f){const p=E.map(h=>({name:h.profileName,description:A(h)}));return f&&p.push(...f.map(h=>({name:h.title,description:R(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=T;function A(E){let f=`$(${L.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?f+=`
- args: "${E.args}"`:f+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(f+=`
- overrideName: ${E.overrideName}`),E.color&&(f+=`
- color: ${E.color}`),E.env&&(f+=`
- env: ${JSON.stringify(E.env)}`),f}function R(E){return`$(${L.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function C(E,f){if(!E&&!f)return!0;if(typeof E=="string"&&typeof f=="string")return E===f;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function b(E,f){if(!E&&!f)return!0;if(!E||!f)return!1;if(L.ThemeIcon.isThemeIcon(E)&&L.ThemeIcon.isThemeIcon(f))return E.id===f.id&&E.color===f.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=E,h=f;if((t.URI.isUri(p.light)||P(p.light))&&(t.URI.isUri(p.dark)||P(p.dark))&&(t.URI.isUri(h.light)||P(h.light))&&(t.URI.isUri(h.dark)||P(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(t.URI.isUri(E)&&t.URI.isUri(f)||P(E)||P(f)){const p=E,h=f;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=b;function P(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=P}),define(te[218],ne([0,1,48,142,42,38,217]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),y=>y.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),y=>`$(${y.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),m=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(v),S()}e.registerTerminalPlatformConfiguration=l;let w;function S(y,d){const i=T.Registry.as(L.Extensions.Configuration);let c;y&&(c=(0,A.createProfileSchemaEnums)(y?.profiles,d));const r=w;w={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:y?.os===3?c?.values:void 0,markdownEnumDescriptions:y?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:y?.os===2?c?.values:void 0,markdownEnumDescriptions:y?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:y?.os===1?c?.values:void 0,markdownEnumDescriptions:y?.os===1?c?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[w],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(te[219],ne([0,1,46,48,10,4,22,73,215,97]),function(Y,e,k,t,L,T,A,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,E=!0;function f(c,r,n,o,s=process.env,a,u,g,I){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?p(n,a,s,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:o.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:o.getValue("terminal.integrated.defaultProfile.windows"),I,g):y(a,u,n,c&&typeof c=="object"?{...c}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,g,s)}e.detectAvailableProfiles=f;async function p(c,r,n,o,s,a,u,g,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let M=!1;(0,C.getWindowsBuildNumber)()>=16299&&(M=!0),await v(g);const D=new Map;c&&(D.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),d(a,D);const U=await h(D.entries(),u,r,n,o,I);if(c||!c&&s)try{const z=await w(`${O}\\${M?"wsl":"bash"}.exe`,u);for(const B of z)(!a||!(B.profileName in a))&&U.push(B)}catch{E&&(o?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return U}async function h(c,r,n,o=process.env,s,a){const u=[];for(const[g,I]of c){if(I===null)continue;let _,O,M;if("source"in I){const z=P?.get(I.source);if(!z)continue;_=z.paths,O=I.args||z.args,I.icon?M=m(I.icon):z.icon&&(M=z.icon)}else _=Array.isArray(I.path)?I.path:[I.path],O=T.isWindows||Array.isArray(I.args)?I.args:void 0,M=m(I.icon);const D=await a?.(_)||_.slice(),U=await i(g,r,D,n,o,O,I.env,I.overrideName,I.isAutoDetected,s);U?(U.isAutoDetected=I.isAutoDetected,U.icon=M,U.color=I.color,u.push(U)):s?.trace("profile not validated",g,_)}return u}function m(c){return typeof c=="string"?{id:c}:c}async function v(c){P&&!c||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:c||await l(),icon:b.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function l(){const c=[];for await(const r of(0,R.enumeratePowerShellInstallations)())c.push(r.exePath);return c}async function w(c,r){const n=[],o=await new Promise((u,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return g("Problem occurred when getting wsl distros");u(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),a=o.split(s).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const g=`${u} (WSL)`,I={profileName:g,path:c,args:["-d",`${u}`],isDefault:g===r,icon:S(u),isAutoDetected:!1};n.push(I)}return n}function S(c){return c.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):c.includes("Debian")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function y(c,r,n,o,s,a,u,g){const I=new Map;if(n){const _=(await c.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),M=new Map;for(const D of O){let U=(0,L.basename)(D),z=M.get(U)||0;z++,z>1&&(U=`${U} (${z})`),M.set(U,z),I.set(U,{path:D,isAutoDetected:!0})}}return d(o,I),await h(I.entries(),s,c,g,r,u)}function d(c,r){if(!!c)for(const[n,o]of Object.entries(c))o===null||!("path"in o)&&!("source"in o)?r.delete(n):(o.icon=o.icon||r.get(n)?.icon,r.set(n,o))}async function i(c,r,n,o,s,a,u,g,I,_){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return i(c,r,n,o,s,a,u,g,I);const M={profileName:c,path:O,args:a,env:u,overrideName:g,isAutoDetected:I,isDefault:c===r};if((0,L.basename)(O)===O){const U=s.PATH?s.PATH.split(L.delimiter):void 0,z=await(0,C.findExecutable)(O,void 0,U,void 0,o.existsFile);return z?(M.path=z,M.isFromPath=!0,M):i(c,r,n,o,s,a)}return await o.existsFile((0,L.normalize)(O))?M:i(c,r,n,o,s,a,u,g,I)}}),define(te[220],ne([0,1,3,2,18,4,36,58,19,14,78,214,8,87,212,96,218,219]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let S=0,y=class extends t.Disposable{constructor(i,c,r,n){super();this._reconnectConstants=i,this._configurationService=c,this._environmentService=r,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:S,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},c=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);c&&(c.break&&c.port?i.debugBrk=c.port:!c.break&&c.port&&(i.debug=c.port));const r=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,i);this._onPtyHostStart.fire(),A.ProxyChannel.toService(r.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(r.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=r.getChannel(m.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const s=A.ProxyChannel.toService(r.getChannel(m.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(a=>this._onProcessData.fire(a))),this._register(s.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(s.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(s.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(s.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(s.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(s.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[r,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,c,r,n,o,s,a,u,g,I,_){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),m.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(i,c,r,n,o,s,a,u,g,I,_);return clearTimeout(O),S=Math.max(S,M),M}updateTitle(i,c,r){return this._proxy.updateTitle(i,c,r)}updateIcon(i,c,r){return this._proxy.updateIcon(i,c,r)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i){return this._proxy.detachFromProcess(i)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,c){return this._proxy.shutdown(i,c)}input(i,c){return this._proxy.input(i,c)}processBinary(i,c){return this._proxy.processBinary(i,c)}resize(i,c,r){return this._proxy.resize(i,c,r)}acknowledgeDataEvent(i,c){return this._proxy.acknowledgeDataEvent(i,c)}setUnicodeVersion(i,c){return this._proxy.setUnicodeVersion(i,c)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,c){return this._proxy.installAutoReply(i,c)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,c,r,n=!1){const o=await this._shellEnv;return(0,l.detectAvailableProfiles)(c,r,n,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,c){return this._proxy.requestDetachInstance(i,c)}async acceptDetachInstanceReply(i,c){return this._proxy.acceptDetachInstanceReply(i,c)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,c){return this._proxy.reviveTerminalProcesses(i,c)}async refreshProperty(i,c){return this._proxy.refreshProperty(i,c)}async updateProperty(i,c,r){return this._proxy.updateProperty(i,c,r)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,c){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:c})}async acceptPtyHostResolvedVariables(i,c){this._resolveVariablesRequestStore.acceptReply(i,c)}};y=he([K(1,C.IConfigurationService),K(2,b.IEnvironmentService),K(3,f.ILogService)],y),e.PtyHostService=y}),define(te[64],ne([0,1,3,4,6,8]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function f(h,m){return m?m!==1&&h<1024:!t.isWindows&&h<1024}e.isPortPrivileged=f;let p=class{constructor(m){this.logService=m,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],v=Array.from(this._tunnels.values());for(let l of v){const w=Array.from(l.values());for(let S of w){const y=await S.value;y&&m.push(y)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:v}of m.values())await v.then(l=>l?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,v,l,w,S=!1,y=R.Private,d){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${l} on local port ${w}.`),!m)return;v||(v="localhost");const i=this.retainOrCreateTunnel(m,v,l,w,S,y,d);return i?i.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,l);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(c);return(c.tunnelRemoteHost!==v||c.tunnelRemotePort!==l)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const v=this._tunnels.get(m.tunnelRemoteHost);if(v){const l=v.get(m.tunnelRemotePort);l&&(l.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,l))}}}}async tryDisposeTunnel(m,v,l){if(l.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${v}.`);const w=l.value.then(async S=>{S&&(await S.dispose(!0),this._onTunnelClosed.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(v),w}}async closeTunnel(m,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${v} `);const l=this._tunnels.get(m);if(l&&l.has(v)){const w=l.get(v);w.refcount=0,await this.tryDisposeTunnel(m,v,w)}}addTunnelToMap(m,v,l){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(v,{refcount:1,value:l})}async removeEmptyTunnelFromMap(m,v){const l=this._tunnels.get(m);l&&(await l.get(v)||l.delete(v),l.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,v){let l=[m];P(m)?(l.push(...e.LOCALHOST_ADDRESSES),l.push(...e.ALL_INTERFACES_ADDRESSES)):E(m)&&l.push(...e.ALL_INTERFACES_ADDRESSES);const w=l.map(S=>this._tunnels.get(S));for(const S of w){const y=S?.get(v);if(y)return y}}canTunnel(m){return!!b(m)}createWithProvider(m,v,l,w,S,y,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${l} on local port ${w}.`);const c={elevationRequired:S?f(w===void 0?l:w):!1},r={remoteAddress:{host:v,port:l},localAddressPort:w,privacy:y,public:y!==R.Private,protocol:d},n=m.forwardPort(r,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(v,l,n),n}};p=he([K(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(te[221],ne([0,1,8,64,2,9,5]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class Ct extends L.Disposable{constructor(P,E){super();this._tunnelService=P,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,E,f,p,h,m){const v=new R,l=await Promise.resolve(this._tunnelService.openTunnel(P,v,f,p,h,m));if(!l)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await l.dispose(),(0,T.canceled)();return v.setTunnel(l),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${l.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(P,E){const f=this._tunnels.get(P);!f||f.setAddress(E)}async destroyTunnel(P){const E=this._tunnels.get(P);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await E.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=he([K(0,t.ISharedTunnelsService),K(1,k.ILogService)],C),e.SharedProcessTunnelService=C}),define(te[32],ne([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[222],ne([0,1,3,2,7,14,31,15,8,32]),function(Y,e,k,t,L,T,A,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends t.Disposable{constructor(f,p,h,m,v){super();this.extensionsManagementService=f,this.logService=m,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const l=L.URI.file(h.extensionsPath);this._register(p.watch(l)),this._register(k.Event.filter(p.onDidFilesChange,w=>w.rawChanges.some(S=>this.doesChangeAffects(S,l)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,A.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,A.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,A.areSameExtensions)(v,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),h=this.installedExtensions.filter(m=>this.installingExtensions.some(v=>(0,A.areSameExtensions)(v,m))?!1:f.every(v=>!(0,A.areSameExtensions)(v.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=f.map(m=>m.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};P=he([K(1,R.IFileService),K(2,T.INativeEnvironmentService),K(3,C.ILogService),K(4,b.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(te[223],ne([0,1,32,80,15,20,104,3,2]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(f){this.uri=f,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new C.DisposableStore,this._limit=2**16;const p=new Map,h=m=>{let v=p.get(m.scheme);return v===void 0&&(v=f.hasProvider(m)&&!this._fileService.hasCapability(m,1024),p.set(m.scheme,v)),v};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(m=>{p.delete(m.scheme)})),this.extUri=new T.ExtUri(h),this._canonicalUris=new A.SkipList((m,v)=>this.extUri.compare(m,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new b(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,m)=>h[1].touch<m[1].touch?1:h[1].touch>m[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};P=he([K(0,L.IFileService)],P),e.UriIdentityService=P,(0,t.registerSingleton)(k.IUriIdentityService,P,!0)}),define(te[224],ne([0,1,3,2,40,39,17]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends t.Disposable{constructor(b,P,E,f){super();this.fileSystemScheme=b,this.fileSystemProvider=P,this.userDataScheme=E,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(b,P){this.watchResources.set(b,b);const E=this.fileSystemProvider.watch(this.toFileSystemResource(b),P);return(0,t.toDisposable)(()=>{this.watchResources.delete(b),E.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,P,E){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(P),E)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,P,E){const f=(0,L.newWriteableStream)(p=>A.VSBuffer.concat(p.map(h=>A.VSBuffer.wrap(h))).buffer);return(async()=>{try{const p=await this.readFile(b);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,P,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),P,E)}delete(b,P){return this.fileSystemProvider.delete(this.toFileSystemResource(b),P)}handleFileChanges(b){const P=[];for(const E of b){if(E.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(E.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:E.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(te[53],ne([0,1,70]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,R,C,b){const P=(0,k.setProperty)(A,R,C,b)[0];return P&&(A=A.substring(0,P.offset)+P.content+A.substring(P.offset+P.length)),A}e.edit=t;function L(A,R,C){let b=C;for(;b>=0;){if(A.charAt(b)===R.charAt(R.length-1)&&R.length===1)return b+1;if(b--,R.length===2&&b>=0&&A.charAt(b)===R.charAt(0))return b+2}return 0}e.getLineStartOffset=L;function T(A,R,C){let b=C;for(;b>=0;)if(A.charAt(b)===R.charAt(R.length-1)&&R.length===1||(b++,R.length===2&&b>=0&&A.charAt(b)===R.charAt(1)))return b;return A.length-1}e.getLineEndOffset=T}),define(te[225],ne([0,1,28,62,11]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,p,h,m,v){const l=[],w=[],S=[];if(!p){const O=f.filter(({identifier:M})=>v.every(D=>D.toLowerCase()!==M.id.toLowerCase()));return{local:{added:l,removed:w,updated:S},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(P),p=p.map(P),h=h?h.map(P):null;const y=new Map,d=O=>{O.uuid&&y.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>d(O)),p.forEach(({identifier:O})=>d(O)),h&&h.forEach(({identifier:O})=>d(O));const i=O=>{const M=O.identifier.uuid||y.get(O.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${O.identifier.id.toLowerCase()}`},c=(O,M)=>(O.set(i(M),M),O),r=f.reduce(c,new Map),n=p.reduce(c,new Map),o=p.reduce((O,M)=>{const D=i(M);M=(0,k.deepClone)(M);const U=r.get(D);return U&&(U.installed&&(M.installed=!0),M.version||(M.version=U.version)),c(O,M)},new Map),s=h?h.reduce(c,new Map):null,a=m.reduce(c,new Map),u=v.reduce((O,M)=>{const D=y.get(M.toLowerCase());return O.add(D?`uuid:${D}`:`id:${M.toLowerCase()}`)},new Set),g=A(r,n,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const O=A(s,r,u),M=A(s,n,u),D=(U,z)=>{const B=r.get(U);if(B){const q=n.get(U),G=z?q:B;return{...G,version:q.version&&(!B.installed||t.gt(q.version,B.version))?q.version:B.version,state:R(B,q,s?.get(U)),preRelease:(0,L.isUndefined)(G.preRelease)?B.preRelease:B.installed?G.preRelease:q.preRelease}}};for(const U of M.removed.values()){const z=r.get(U);z&&w.push(z.identifier)}for(const U of M.added.values())if(O.added.has(U)){if(g.updated.has(U)){const z=D(U,!0);z&&(S.push(E(z,U)),o.set(U,z))}}else{const z=n.get(U);z.installed&&l.push(E(z,U))}for(const U of M.updated.values()){const z=D(U,!0);z&&(S.push(E(z,U)),o.set(U,z))}for(const U of O.added.values())M.added.has(U)||o.set(U,r.get(U));for(const U of O.updated.values())if(!M.removed.has(U)&&!M.updated.has(U)){const z=D(U,!1);z&&(o.get(U)?.installed&&(z.installed=!0),o.set(U,z))}for(const U of O.removed.values())!a.has(U)&&!M.updated.has(U)&&s?.get(U)?.installed&&o.delete(U)}const I=[],_=A(n,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,M)=>I.push(E(O,M))),{local:{added:l,removed:w,updated:S},remote:I.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>n.get(O)),all:I}:null}}e.merge=T;function A(f,p,h,{checkInstalledProperty:m,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const l=f?[...f.keys()].filter(i=>!h.has(i)):[],w=[...p.keys()].filter(i=>!h.has(i)),S=w.filter(i=>l.indexOf(i)===-1).reduce((i,c)=>(i.add(c),i),new Set),y=l.filter(i=>w.indexOf(i)===-1).reduce((i,c)=>(i.add(c),i),new Set),d=new Set;for(const i of l){if(y.has(i))continue;const c=f.get(i),r=p.get(i);(!r||c.disabled!==r.disabled||c.installed&&r.installed&&c.preRelease!==r.preRelease||!b(c.state,r.state)||v&&c.version!==r.version||m&&c.installed!==r.installed)&&d.add(i)}return{added:S,removed:y,updated:d}}function R(f,p,h){const m=f.state,v=p.state,l=h?.state;if(!p.version||m&&t.gt(f.version,p.version))return m;if(v&&t.gt(p.version,f.version)||!m)return v;if(!v)return m;const w=(0,k.deepClone)(m),S=l?C(l,v):{added:Object.keys(v).reduce((d,i)=>(d.add(i),d),new Set),removed:new Set,updated:new Set},y=l?C(l,m):{added:Object.keys(m).reduce((d,i)=>(d.add(i),d),new Set),removed:new Set,updated:new Set};for(const d of[...S.added.values(),...S.updated.values()])w[d]=v[d];for(const d of S.removed.values())y.updated.has(d)||delete w[d];return w}function C(f,p){const h=Object.keys(f),m=Object.keys(p),v=m.filter(S=>h.indexOf(S)===-1).reduce((S,y)=>(S.add(y),S),new Set),l=h.filter(S=>m.indexOf(S)===-1).reduce((S,y)=>(S.add(y),S),new Set),w=new Set;for(const S of h){if(l.has(S))continue;const y=f[S],d=p[S];(0,k.equals)(y,d)||w.add(S)}return{added:v,removed:l,updated:w}}function b(f={},p={}){const{added:h,removed:m,updated:v}=C(f,p);return h.size===0&&m.size===0&&v.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function E(f,p){const h={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(h.version=f.version),f.disabled&&(h.disabled=!0),f.installed&&(h.installed=!0),f.state&&(h.state=f.state),h}}),define(te[98],ne([0,1,16,19,6]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==R&&P!==`-${R}`),C&&b.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(R,C){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==R&&P!==`-${R}`),C&&b.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(R){const C=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],E=[];if(Array.isArray(b))for(const f of b)f.startsWith("-")?E.push(f.substring(1)):P.push(f);return(0,k.distinct)([...C,...P].filter(f=>E.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};T=he([K(0,t.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[226],ne([0,1,16,35,28,160,53]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(y){return(0,t.parse)(y)||[]}e.parseKeybindings=R;async function C(y,d,i,c,r){const n=R(y),o=R(d),s=i?R(i):null,a=[...n,...o,...s||[]].map(q=>q.key),u=await r.resolveUserBindings(a);let g=P(n,o,s,u);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:y,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};const I=f(n),_=f(o),O=s?f(s):null,M=h(I,_,u),D=O?h(O,I,u):{added:[...I.keys()].reduce((q,G)=>(q.add(G),q),new Set),removed:new Set,updated:new Set},U=O?h(O,_,u):{added:[..._.keys()].reduce((q,G)=>(q.add(G),q),new Set),removed:new Set,updated:new Set},z=b(M,D,U);let B=y;for(const q of z.removed.values())z.conflicts.has(q)||(B=w(B,q,c));for(const q of z.added.values()){if(z.conflicts.has(q))continue;const G=_.get(q);if(G.some(re=>re.command!==`-${q}`&&g.conflicts.has(u[re.key]))){z.conflicts.add(q);continue}B=l(B,G,c)}for(const q of z.updated.values()){if(z.conflicts.has(q))continue;const G=_.get(q);if(G.some(re=>re.command!==`-${q}`&&g.conflicts.has(u[re.key]))){z.conflicts.add(q);continue}B=S(B,q,G,c)}return{mergeContent:B,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=C;function b(y,d,i){const c=new Set,r=new Set,n=new Set,o=new Set;for(const s of d.removed.values())i.updated.has(s)&&o.add(s);for(const s of i.removed.values())o.has(s)||(d.updated.has(s)?o.add(s):r.add(s));for(const s of d.added.values())o.has(s)||i.added.has(s)&&y.updated.has(s)&&o.add(s);for(const s of i.added.values())o.has(s)||(d.added.has(s)?y.updated.has(s)&&o.add(s):c.add(s));for(const s of d.updated.values())o.has(s)||i.updated.has(s)&&y.updated.has(s)&&o.add(s);for(const s of i.updated.values())o.has(s)||(d.updated.has(s)?y.updated.has(s)&&o.add(s):n.add(s));return{added:c,removed:r,updated:n,conflicts:o}}function P(y,d,i,c){const r=new Set,n=E(y,c),o=E(d,c),s=i?E(i,c):null,a=p(n,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const u=s?p(s,n):{added:[...n.keys()].reduce((D,U)=>(D.add(U),D),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const g=s?p(s,o):{added:[...o.keys()].reduce((D,U)=>(D.add(U),D),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:I,removed:_,updated:O,conflicts:M}=b(a,u,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:O,conflicts:M}}function E(y,d){const i=new Map;for(const c of y){const r=d[c.key];let n=i.get(r);n||(n=[],i.set(r,n)),n.push(c)}return i}function f(y){const d=new Map;for(const i of y){const c=i.command[0]==="-"?i.command.substring(1):i.command;let r=d.get(c);r||(r=[],d.set(c,r)),r.push(i)}return d}function p(y,d){const i=[...y.keys()],c=[...d.keys()],r=c.filter(s=>i.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),n=i.filter(s=>c.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),o=new Set;for(const s of i){if(n.has(s))continue;const a=y.get(s).map(g=>({...g,key:s})),u=d.get(s).map(g=>({...g,key:s}));(0,k.equals)(a,u,(g,I)=>v(g,I))||o.add(s)}return{added:r,removed:n,updated:o}}function h(y,d,i){const c=[...y.keys()],r=[...d.keys()],n=r.filter(a=>c.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=c.filter(a=>r.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),s=new Set;for(const a of c){if(o.has(a))continue;const u=y.get(a).map(I=>({...I,key:i[I.key]})),g=d.get(a).map(I=>({...I,key:i[I.key]}));m(u,g)||s.add(a)}return{added:n,removed:o,updated:s}}function m(y,d){return!(!(0,k.equals)(y.filter(({command:i})=>i[0]!=="-"),d.filter(({command:i})=>i[0]!=="-"),(i,c)=>v(i,c))||!(0,k.equals)(y.filter(({command:i})=>i[0]==="-"),d.filter(({command:i})=>i[0]==="-"),(i,c)=>v(i,c)))}function v(y,d){if(y.command!==d.command||y.key!==d.key)return!1;const i=T.ContextKeyExpr.deserialize(y.when),c=T.ContextKeyExpr.deserialize(d.when);return!(i&&!c||!i&&c||i&&c&&!i.equals(c)||!L.equals(y.args,d.args))}function l(y,d,i){for(const c of d)y=A.edit(y,[-1],c,i);return y}function w(y,d,i){const c=R(y);for(let r=c.length-1;r>=0;r--)(c[r].command===d||c[r].command===`-${d}`)&&(y=A.edit(y,[r],void 0,i));return y}function S(y,d,i,c){const r=R(y),n=r.findIndex(o=>o.command===d||o.command===`-${d}`);for(let o=r.length-1;o>=0;o--)(r[o].command===d||r[o].command===`-${d}`)&&(y=A.edit(y,[o],void 0,c));for(let o=i.length-1;o>=0;o--)y=A.edit(y,[n],i[o],c);return y}}),define(te[227],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(T,A,R){const C={},b={},P=new Set;if(!A)return{local:{added:C,updated:b,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const E=t(T,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:b,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=t(R,T),p=t(R,A),h={},m={},v=new Set,l=new Set;for(const w of f.removed.values())p.updated.has(w)?C[w]=A[w]:v.add(w);for(const w of p.removed.values())l.has(w)||(f.updated.has(w)?l.add(w):P.add(w));for(const w of f.updated.values())l.has(w)||(p.updated.has(w)?E.updated.has(w)&&l.add(w):m[w]=T[w]);for(const w of p.updated.values())l.has(w)||(f.updated.has(w)?E.updated.has(w)&&l.add(w):T[w]!==void 0&&(b[w]=A[w]));for(const w of f.added.values())l.has(w)||(p.added.has(w)?E.updated.has(w)&&l.add(w):h[w]=T[w]);for(const w of p.added.values())l.has(w)||(f.added.has(w)?E.updated.has(w)&&l.add(w):C[w]=A[w]);return{local:{added:C,removed:[...P.values()],updated:b},remote:{added:h,removed:[...v.values()],updated:m},conflicts:[...l.values()]}}e.merge=k;function t(T,A){const R=T?Object.keys(T):[],C=A?Object.keys(A):[],b=C.filter(f=>R.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),P=R.filter(f=>C.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),E=new Set;for(const f of R){if(P.has(f))continue;const p=T[f],h=A[f];p!==h&&E.add(f)}return{added:b,removed:P,updated:E}}function L(T,A){const{added:R,removed:C,updated:b}=t(T,A);return R.size===0&&C.size===0&&b.size===0}e.areSame=L}),define(te[24],ne([0,1,16,20,11,148,42,30,6,89,38]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function f(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(I=>!!s[I].ignoreSync),u=Object.keys(s).filter(I=>s[I].scope===2||s[I].scope===6),g=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...u,...g])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",a=P.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=P.Registry.as(b.Extensions.JSONContribution),g=()=>{const I=E(),_=f().filter(U=>U!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(U=>_.indexOf(U)===-1),M=_.filter(U=>I.indexOf(U)===-1),D={items:{type:"string",enum:[...O,...M.map(U=>`-${U}`)]}};u.registerSchema(s,D)};return a.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=p;function h(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=h;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function v(s,a,u){return u.joinPath(a.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=l;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class S extends Error{constructor(a,u,g,I){super(a);this.code=u,this.resource=g,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=S;class y extends S{constructor(a,u,g,I,_){super(a,g,void 0,_);this.url=u,this.serverCode=I}}e.UserDataSyncStoreError=y;class d extends S{constructor(a,u){super(a,u)}}e.UserDataAutoSyncError=d,function(s){function a(u){if(u instanceof s)return u;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(g&&g[1]){const I=g[2]==="unknown"?void 0:g[2],_=g[3]==="unknown"?void 0:g[3];return new s(u.message,g[1],I,_)}return new s(u.message,"Unknown")}s.toUserDataSyncError=a}(S=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var c;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var r;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,a){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,t.isEqualOrParent)(s,(0,t.joinPath)(a.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[45],ne([0,1,16,5,17,25,3,35,2,26,11,7,144,19,14,15,8,47,23,21,32,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=i;let c=class extends C.Disposable{constructor(a,u,g,I,_,O,M,D,U,z,B){super();this.resource=a,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=M,this.telemetryService=D,this.logService=U,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=B.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,d.PREVIEW_DIR_NAME),this.lastSyncResource=(0,d.getLastSyncResourceUri)(a,g,this.extUri),this.currentMachineIdPromise=(0,l.getServiceMachineId)(g,u,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const u=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,u={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),u)}async preview(a,u,g={}){return this._sync(a,!1,u,g)}async apply(a,u={}){try{this.syncHeaders={...u};const g=await this.doApply(a);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,u,g,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(M,O,u,g),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const u=await this.resolveContent(a);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(_),M=await this.generateSyncPreview({ref:_.ref,syncData:g},I,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),D=[];for(const U of M){const z=await this.getAcceptResult(U,U.remoteResource,void 0,T.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,T.CancellationToken.None);D.push([U,{...z,remoteChange:B!==0?B:2}])}await this.applyResult(_,I,D,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const u=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===u}async getLatestRemoteUserData(a,u){if(u){const g=a&&a.latest?a.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(a,u,g,I){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new d.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,u,g,I)}catch(_){if(_ instanceof d.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,u,g,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(a,u,g,I)}throw _}}async doSync(a,u,g,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,u,g,I,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async u=>{const g=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(g?.content||""));const I=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=I,u.mergeState=g.hasConflicts?"conflict":I?"accepted":"preview",u.localChange=I?I.localChange:g.localChange,u.remoteChange=I?I.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(a,u){return await this.updateSyncResourcePreview(a,async g=>{const I=await this.getAcceptResult(g,a,u,T.CancellationToken.None);return g.acceptResult=I,g.mergeState="accepted",g.localChange=I.localChange,g.remoteChange=I.remoteChange,g}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async u=>{const g=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(a,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const I=g.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:M})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(M,a));I!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const O=[...g.resourcePreviews];return O[I]=await u(O[I]),{...g,resourcePreviews:O}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const u=a.filter(({mergeState:g})=>g==="conflict");(0,k.equals)(this._conflicts,u,(g,I)=>this.extUri.isEqual(g.previewResource,I.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(a){return E.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return E.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(a){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(a,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(a){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,a))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,a))return g.remoteContent;if(this.extUri.isEqual(g.localResource,a))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,u,g,I,_){const O=await this.isRemoteDataFromCurrentMachine(a),M=await this.generateSyncPreview(a,u,O,I,_),D=[];for(const U of M){const z=U.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)D.push({...U,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const B=g?await this.getMergeResult(U,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,L.VSBuffer.fromString(B?.content||""));const q=B&&!B.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,_):void 0;D.push({...U,acceptResult:q,mergeState:B?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:B?B.localChange:U.localChange,remoteChange:q?q.remoteChange:B?B.remoteChange:U.remoteChange})}}return{remoteUserData:a,lastSyncUserData:u,resourcePreviews:D,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(a.value.toString()),g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const I=u;if(I.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(I.content);if(i(_))return{...u,syncData:_,content:void 0}}catch(a){a instanceof m.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(a){const{ref:u,content:g}=await this.getUserData(a);let I=null;return g!==null&&(I=this.parseSyncData(g)),{ref:u,syncData:I}}parseSyncData(a){try{const u=JSON.parse(a);if(i(u))return u}catch(u){this.logService.error(u)}throw new d.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,P.isString)(a)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:u}}else{const u=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(a,u){const g=await this.currentMachineIdPromise,I={version:this.version,machineId:g,content:a};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),u,this.syncHeaders),{ref:u,syncData:I}}async backupLocal(a){const u={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=he([K(1,m.IFileService),K(2,h.IEnvironmentService),K(3,w.IStorageService),K(4,d.IUserDataSyncStoreService),K(5,d.IUserDataSyncBackupStoreService),K(6,d.IUserDataSyncEnablementService),K(7,S.ITelemetryService),K(8,d.IUserDataSyncLogService),K(9,p.IConfigurationService),K(10,y.IUriIdentityService)],c),e.AbstractSynchroniser=c;let r=class extends c{constructor(a,u,g,I,_,O,M,D,U,z,B,q){super(u,g,I,_,O,M,D,U,z,B,q);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,u,g){try{u?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a),g?void 0:u):await this.fileService.createFile(this.file,L.VSBuffer.fromString(a),{overwrite:g})}catch(I){throw I instanceof m.FileOperationError&&I.fileOperationResult===1||I instanceof m.FileOperationError&&I.fileOperationResult===3?new d.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};r=he([K(2,m.IFileService),K(3,h.IEnvironmentService),K(4,w.IStorageService),K(5,d.IUserDataSyncStoreService),K(6,d.IUserDataSyncBackupStoreService),K(7,d.IUserDataSyncEnablementService),K(8,S.ITelemetryService),K(9,d.IUserDataSyncLogService),K(10,p.IConfigurationService),K(11,y.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(a,u,g,I,_,O,M,D,U,z,B,q,G){super(a,u,g,I,_,O,M,D,U,z,q,G);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(a){const u=[];return(0,R.parse)(a,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=he([K(2,m.IFileService),K(3,h.IEnvironmentService),K(4,w.IStorageService),K(5,d.IUserDataSyncStoreService),K(6,d.IUserDataSyncBackupStoreService),K(7,d.IUserDataSyncEnablementService),K(8,S.ITelemetryService),K(9,d.IUserDataSyncLogService),K(10,d.IUserDataSyncUtilService),K(11,p.IConfigurationService),K(12,y.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n;let o=class{constructor(a,u,g,I,_){this.resource=a,this.environmentService=u,this.logService=g,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,d.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:a,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!!g)try{await this.doInitialize({ref:a,syncData:g})}catch(I){this.logService.error(I)}}parseSyncData(a){try{const u=JSON.parse(a);if(i(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,u={}){const g={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(g)))}};o=he([K(1,h.IEnvironmentService),K(2,v.ILogService),K(3,m.IFileService),K(4,y.IUriIdentityService)],o),e.AbstractInitializer=o}),define(te[228],ne([0,1,5,25,9,3,49,26,7,19,14,30,31,63,15,8,23,21,32,45,225,98,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(o,s){const a=JSON.parse(o.content);if(o.version===1||o.version===2){const u=(await s.getInstalled(0)).filter(g=>g.isBuiltin);for(const g of a)o.version===1&&(g.enabled===!1&&(g.disabled=!0),delete g.enabled),o.version===2&&u.every(I=>!(0,f.areSameExtensions)(I.identifier,g.identifier))&&(g.installed=!0)}return a}let r=class mt extends S.AbstractSynchroniser{constructor(s,a,u,g,I,_,O,M,D,U,z,B,q,G,re){super("extensions",a,s,u,g,I,B,q,D,z,re);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=M,this.extensionGalleryService=U,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,H=>H.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,H=>!H.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a){const u=s.syncData?await c(s.syncData,this.extensionManagementService):null,g=a?.skippedExtensions||[],I=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:D,remote:U}=(0,y.merge)(O,u,I,g,M),z={local:D,remote:U,content:this.getPreviewContent(O,D.added,D.updated,D.removed),localChange:D.added.length>0||D.removed.length>0||D.updated.length>0?2:0,remoteChange:U!==null?2:0};return[{skippedExtensions:g,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const a=s.syncData?await c(s.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),g=this.getLocalExtensions(u),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,y.merge)(g,a,a,s.skippedExtensions||[],I);return _!==null}getPreviewContent(s,a,u,g){const I=[...a,...u],_=new Set,O=M=>{_.add(M.id.toLowerCase()),M.uuid&&_.add(M.uuid)};I.forEach(({identifier:M})=>O(M)),g.forEach(O);for(const M of s)_.has(M.identifier.id.toLowerCase())||M.identifier.uuid&&_.has(M.identifier.uuid)||I.push(M);return this.stringify(I,!1)}async getMergeResult(s,a){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,a,u,g){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(a,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(s){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),g=(0,y.merge)(s.localExtensions,null,null,s.skippedExtensions,u),{local:I,remote:_}=g;return{content:s.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),g=s.remoteContent?JSON.parse(s.remoteContent):null;if(g!==null){const I=(0,y.merge)(s.localExtensions,g,s.localExtensions,[],u),{local:_,remote:O}=I;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,a,u,g){let{skippedExtensions:I,localExtensions:_}=u[0][0],{local:O,remote:M,localChange:D,remoteChange:U}=u[0][1];if(D===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),D!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(O.added,O.removed,O.updated,I)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const z=JSON.stringify(M.all);s=await this.updateRemoteUserData(z,g?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${M.added.length?` Added: ${JSON.stringify(M.added.map(B=>B.identifier.id))}.`:""}${M.updated.length?` Updated: ${JSON.stringify(M.updated.map(B=>B.identifier.id))}.`:""}${M.removed.length?` Removed: ${JSON.stringify(M.removed.map(B=>B.identifier.id))}.`:""}`)}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map(z=>z.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),I=this.getLocalExtensions(u).filter(_=>!g.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const u=await this.resolvePreviewContent(s);return u&&this.stringify(JSON.parse(u),!0)}let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const u=this.parseSyncData(a);if(u)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(s,a){return s.sort((u,g)=>!u.identifier.uuid&&g.identifier.uuid?-1:u.identifier.uuid&&!g.identifier.uuid?1:(0,R.compare)(u.identifier.id,g.identifier.id)),a?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,a,u,g){const I=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const D=O.filter(({identifier:U,isBuiltin:z})=>!z&&a.some(B=>(0,f.areSameExtensions)(U,B)));await k.Promises.settled(D.map(async U=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,U.identifier.id),await this.extensionManagementService.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,U.identifier.id),I.push(U.identifier)}))}(s.length||u.length)&&await k.Promises.settled([...s,...u].map(async D=>{const U=O.find(B=>(0,f.areSameExtensions)(B.identifier,D.identifier));if(U&&U.isBuiltin){D.state&&U.manifest.version===D.version&&this.updateExtensionState(D.state,U,U.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(q=>(0,f.areSameExtensions)(q,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id),await this.extensionEnablementService.disableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id),await this.extensionEnablementService.enableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id))),I.push(D.identifier);return}const z=(await this.extensionGalleryService.getExtensions([{...D.identifier,preRelease:D.preRelease}],t.CancellationToken.None))[0];if(D.state&&(U?U.manifest.version===D.version:!!z)&&this.updateExtensionState(D.state,U||z,U?.manifest.version),z)try{this.extensionEnablementService.getDisabledExtensions().some(q=>(0,f.areSameExtensions)(q,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id,z.version),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id,z.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id,z.version),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id,z.version))),(!U||U.preRelease!==D.preRelease)&&(await this.extensionManagementService.canInstall(z)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,D.identifier.id,z.version),await this.extensionManagementService.installFromGallery(z,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:D.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,D.identifier.id,z.version),I.push(z.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,z.displayName||z.identifier.id),_.push(D)))}catch(B){_.push(D),B instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(B.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):(this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,z.displayName||z.identifier.id))}else _.push(D),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}));const M=[];for(const D of g)I.some(U=>(0,f.areSameExtensions)(U,D.identifier))||M.push(D);for(const D of _)M.some(U=>(0,f.areSameExtensions)(U.identifier,D.identifier))||M.push(D);return M}updateExtensionState(s,a,u){const g=this.extensionStorageService.getExtensionState(a,!0)||{},I=u?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:u}):void 0;I?I.forEach(_=>{g[_]=s[_]}):Object.keys(s).forEach(_=>g[_]=s[_]),this.extensionStorageService.setExtensionState(a,g,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const a=this.extensionEnablementService.getDisabledExtensions();return s.map(u=>{const{identifier:g,isBuiltin:I,manifest:_,preRelease:O}=u,M={identifier:g,preRelease:O,version:_.version};a.some(D=>(0,f.areSameExtensions)(D,g))&&(M.disabled=!0),I||(M.installed=!0);try{const D=this.extensionStorageService.getKeysForSync({id:g.id,version:_.version});if(D){const U=this.extensionStorageService.getExtensionState(u,!0)||{};M.state=Object.keys(U).reduce((z,B)=>(D.includes(B)&&(z[B]=U[B]),z),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(D))}return M})}};r.EXTENSIONS_DATA_URI=C.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([K(0,P.IEnvironmentService),K(1,h.IFileService),K(2,v.IStorageService),K(3,i.IUserDataSyncStoreService),K(4,i.IUserDataSyncBackupStoreService),K(5,E.IExtensionManagementService),K(6,E.IGlobalExtensionEnablementService),K(7,d.IIgnoredExtensionsManagementService),K(8,i.IUserDataSyncLogService),K(9,E.IExtensionGalleryService),K(10,b.IConfigurationService),K(11,i.IUserDataSyncEnablementService),K(12,l.ITelemetryService),K(13,p.IExtensionStorageService),K(14,w.IUriIdentityService)],r),e.ExtensionsSynchroniser=r;let n=class extends S.AbstractInitializer{constructor(s,a,u,g,I,_){super("extensions",g,I,u,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=a}async parseExtensions(s){return s.syncData?await c(s.syncData,this.extensionManagementService):null}generatePreview(s,a){const u=[],g=[],I=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(M=>(0,f.areSameExtensions)(M.identifier,_.identifier));O?(u.push(O),_.disabled&&I.push(_.identifier)):_.installed&&(g.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&I.push(_.identifier))}return{installedExtensions:u,newExtensions:g,disabledExtensions:I,remoteExtensions:s}}};n=he([K(0,E.IExtensionManagementService),K(1,d.IIgnoredExtensionsManagementService),K(2,h.IFileService),K(3,P.IEnvironmentService),K(4,m.ILogService),K(5,w.IUriIdentityService)],n),e.AbstractExtensionsInitializer=n}),define(te[229],ne([0,1,28,24]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,C,b,P,E){if(!C)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=T(R,C);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=b?T(b,C):{added:Object.keys(C).reduce((w,S)=>(w.add(S),w),new Set),removed:new Set,updated:new Set},h=b?T(b,R):{added:Object.keys(R).reduce((w,S)=>(w.add(S),w),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},v=k.deepClone(C),l=!b;for(const w of h.added.values())w!==t.SYNC_SERVICE_URL_TYPE&&l&&p.added.has(w)||(v[w]=R[w]);for(const w of h.updated.values())v[w]=R[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete v[w];for(const w of p.added.values()){const S=C[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(w))continue;const y=R[w];y&&y.value===S.value||w===t.SYNC_SERVICE_URL_TYPE&&l&&h.added.has(w)||(y?m.updated[w]=S:m.added[w]=S)}for(const w of p.updated.values()){const S=C[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const y=R[w];y&&y.value===S.value||(m.updated[w]=S)}for(const w of p.removed.values()){if(P.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||m.removed.push(w)}return{local:m,remote:A(v,C)?null:v}}e.merge=L;function T(R,C){const b=Object.keys(R),P=Object.keys(C),E=P.filter(h=>b.indexOf(h)===-1).reduce((h,m)=>(h.add(m),h),new Set),f=b.filter(h=>P.indexOf(h)===-1).reduce((h,m)=>(h.add(m),h),new Set),p=new Set;for(const h of b){if(f.has(h))continue;const m=R[h],v=C[h];k.equals(m,v)||p.add(h)}return{added:E,removed:f,updated:p}}function A(R,C){const{added:b,removed:P,updated:E}=T(R,C);return b.size===0&&P.size===0&&E.size===0}}),define(te[230],ne([0,1,17,9,3,35,49,4,7,29,19,14,15,8,47,23,21,32,45,53,229,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",c=["locale"];function r(u,g){const I=u.storage?Object.keys(u.storage).sort():[],_={};return I.forEach(O=>_[O]=u.storage[O]),u.storage=_,g?(0,A.toFormattedString)(u,{}):JSON.stringify(u)}const n=1;let o=class vt extends w.AbstractSynchroniser{constructor(g,I,_,O,M,D,U,z,B,q){super("globalState",g,M,B,I,_,D,U,O,z,q);this.storageService=B,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(B.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:B.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,I,_){const O=g.syncData?JSON.parse(g.syncData.content):null;I=I===null&&_?g:I;const M=I&&I.syncData?JSON.parse(I.syncData.content):null,D=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const U=this.getStorageKeys(M),{local:z,remote:B}=(0,y.merge)(D.storage,O?O.storage:null,M?M.storage:null,U,this.logService),q={content:null,local:z,remote:B,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:B!==null?2:0};return[{localResource:this.localResource,localContent:r(D,!1),localUserData:D,remoteResource:this.remoteResource,remoteContent:O?r(O,!1):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:U}]}async hasRemoteChanged(g){const I=g.syncData?JSON.parse(g.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:M}=(0,y.merge)(_.storage,I.storage,I.storage,O,this.logService);return M!==null}async getMergeResult(g,I){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,I,_,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(I,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const I=JSON.parse(g.remoteContent),{local:_,remote:O}=(0,y.merge)(g.localUserData.storage,I.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,I,_,O){let{localUserData:M}=_[0][0],{local:D,remote:U,localChange:z,remoteChange:B}=_[0][1];if(z===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.writeLocalGlobalState(D),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const q=JSON.stringify({storage:U});g=await this.updateRemoteUserData(q,O?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_,!0)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)){const _=await this.resolvePreviewContent(g);return _&&r(JSON.parse(_),!0)}let I=await super.resolveContent(g);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(g)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const g={},I=await this.getLocalArgvContent(),_=(0,T.parse)(I);for(const O of c)_[O]!==void 0&&(g[`${i}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const M=this.storageService.get(O,0);M&&(g[O]={version:1,value:M})}return{storage:g}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const g=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),g.value.toString()}catch(g){this.logService.debug((0,t.getErrorMessage)(g))}return"{}"}async writeLocalGlobalState({added:g,removed:I,updated:_}){const O={},M={},D=(z,B)=>{for(const q of z){if(q.startsWith(i)){O[q.substring(i.length)]=B?B[q].value:void 0;continue}if(B){const G=B[q];G.value!==String(this.storageService.get(q,0))&&(M[q]=G.value)}else this.storageService.get(q,0)!==void 0&&(M[q]=void 0)}};if(D(Object.keys(g),g),D(Object.keys(_),_),D(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(M).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(M))this.storageService.store(z,M[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(M))}}async updateArgv(g){const I=await this.getLocalArgvContent();let _=I;for(const O of Object.keys(g))_=(0,S.edit)(_,[O],g[O],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...I,..._],M=g?.storage?Object.keys(g.storage).filter(D=>!D.startsWith(i)&&!O.includes(D)&&this.storageService.get(D,0)!==void 0):[];if(!R.isWeb){const D=[...d.ALL_SYNC_RESOURCES.map(U=>(0,d.getEnablementKey)(U)),d.SYNC_SERVICE_URL_TYPE];M.push(...D),_.push(...D)}return{user:I,machine:_,unregistered:M}}};o.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([K(0,f.IFileService),K(1,d.IUserDataSyncStoreService),K(2,d.IUserDataSyncBackupStoreService),K(3,d.IUserDataSyncLogService),K(4,E.IEnvironmentService),K(5,d.IUserDataSyncEnablementService),K(6,v.ITelemetryService),K(7,P.IConfigurationService),K(8,m.IStorageService),K(9,l.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(g,I,_,O,M){super("globalState",_,O,I,M);this.storageService=g}async doInitialize(g){const I=g.syncData?JSON.parse(g.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const M of Object.keys(I.storage))M.startsWith(i)?_[M.substring(i.length)]=I.storage[M].value:this.storageService.get(M,0)===void 0&&(O[M]=I.storage[M].value);if(Object.keys(_).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const D of Object.keys(_))M=(0,S.edit)(M,[D],_[D],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(M))}if(Object.keys(O).length)for(const M of Object.keys(O))this.storageService.store(M,O[M],0,0)}};s=he([K(0,m.IStorageService),K(1,f.IFileService),K(2,E.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,l.IUriIdentityService)],s),e.GlobalStateInitializer=s;let a=class{constructor(g,I,_,O,M){this.userDataSyncStoreClient=g,this.storageService=I,this.environmentService=_,this.fileService=O,this.logService=M}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[d.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const I=(0,d.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(g,I)}catch(_){if(_ instanceof d.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,I)}throw _}}async doSync(g,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(_)||{storage:{}};O.storage[d.SYNC_SERVICE_URL_TYPE]={value:g,version:n};const M=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),D={version:n,machineId:M,content:r(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(D),_.ref,I)}parseGlobalState({content:g}){if(!g)return null;const I=JSON.parse(g);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};a=he([K(1,m.IStorageService),K(2,E.IEnvironmentService),K(3,f.IFileService),K(4,p.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(te[231],ne([0,1,16,17,3,35,4,11,145,19,14,15,23,21,32,45,226,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(d,i,c){try{const r=JSON.parse(d);if(!i)return(0,R.isUndefined)(r.all)?null:r.all;switch(A.OS){case 2:return(0,R.isUndefined)(r.mac)?null:r.mac;case 3:return(0,R.isUndefined)(r.linux)?null:r.linux;case 1:return(0,R.isUndefined)(r.windows)?null:r.windows}}catch(r){return c.error(r),null}}e.getKeybindingsContentFromSyncContent=w;let S=class extends m.AbstractJsonFileSynchroniser{constructor(i,c,r,n,o,s,a,u,g,I,_){super(a.keybindingsResource,"keybindings",s,a,u,i,c,o,I,r,g,n,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(n.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,c,r,n){const o=i.syncData?w(i.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&r?i:c;const s=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),u=await this.getFormattingOptions();let g=null,I=!1,_=!1,O=!1;if(o){let D=a?a.value.toString():"[]";if(D=D||"[]",this.hasErrors(D))throw new l.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==D||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const U=await(0,v.merge)(D,o,s,u,this.userDataSyncUtilService);U.hasChanges&&(g=U.mergeContent,O=U.hasConflicts,I=O||U.mergeContent!==D,_=O||U.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=a.value.toString(),_=!0);const M={content:g,localChange:I?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const c=this.getKeybindingsContentFromLastSyncUserData(i);if(c===null)return!0;const r=await this.getLocalFileContent(),n=r?r.value.toString():"",o=await this.getFormattingOptions(),s=await(0,v.merge)(n||"[]",c,c,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==c}async getMergeResult(i,c){return i.previewResult}async getAcceptResult(i,c,r,n){if(this.extUri.isEqual(c,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(i,c,r,n){const{fileContent:o}=r[0][0];let{content:s,localChange:a,remoteChange:u}=r[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new l.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(s||"[]",i.syncData?.content);i=await this.updateRemoteUserData(g,n?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const c=(0,T.parse)(i.value.toString());if((0,k.isNonEmptyArray)(c))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:c}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let c=await super.resolveContent(i);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(i)),c){const r=this.parseSyncData(c);if(r)switch(this.extUri.basename(i)){case"keybindings.json":return w(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,c){let r={};try{r=JSON.parse(c||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=i,A.OS){case 2:r.mac=i;break;case 3:r.linux=i;break;case 1:r.windows=i;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};S=he([K(0,l.IUserDataSyncStoreService),K(1,l.IUserDataSyncBackupStoreService),K(2,l.IUserDataSyncLogService),K(3,b.IConfigurationService),K(4,l.IUserDataSyncEnablementService),K(5,E.IFileService),K(6,P.IEnvironmentService),K(7,f.IStorageService),K(8,l.IUserDataSyncUtilService),K(9,p.ITelemetryService),K(10,h.IUriIdentityService)],S),e.KeybindingsSynchroniser=S;let y=class extends m.AbstractInitializer{constructor(i,c,r,n){super("keybindings",c,r,i,n)}async doInitialize(i){const c=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,t.VSBuffer.fromString(c)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,T.parse)(i.value.toString());return!(0,k.isNonEmptyArray)(c)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return w(i,!0,this.logService)}catch(c){return this.logService.error(c),null}}};y=he([K(0,E.IFileService),K(1,P.IEnvironmentService),K(2,l.IUserDataSyncLogService),K(3,h.IUriIdentityService)],y),e.KeybindingsInitializer=y}),define(te[232],ne([0,1,16,35,70,49,28,53,24]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(s,a,u){let g=[];u?g=E(u):g=P(a);const I=[],_=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(g))for(const O of g)O.startsWith("-")?_.push(O.substring(1)):I.push(O);return(0,k.distinct)([...s,...I].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=b;function P(s){let a=s.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=s.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:s.getValue("settingsSync.ignoredSettings")||[]}function E(s){const a=(0,t.parse)(s);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function f(s,a,u,g){if(u.length){const I=o(a),_=(0,t.parse)(a),O=(0,t.parse)(s),M=[];for(const D of u){const U=_[D],z=O[D];U===void 0?s=R.edit(s,[D],void 0,g):z!==void 0?s=R.edit(s,[D],U,g):M.push(d(D,I))}M.sort((D,U)=>D.startOffset-U.startOffset),M.forEach(D=>s=l(D.setting.key,a,s,g))}return s}e.updateIgnoredSettings=f;function p(s,a,u,g,I,_){const O=f(s,a,g,_),M=u!==O,D=u!==a;if(!M&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!D)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(D&&!M)return{conflictsSettings:[],localContent:f(a,s,g,_),remoteContent:null,hasConflicts:!1};if(u===null&&m(s)){const $=h(s,a,g)?null:f(a,s,g,_);return{conflictsSettings:[],localContent:$,remoteContent:null,hasConflicts:!1}}let U=s,z=a;const B=(0,t.parse)(s),q=(0,t.parse)(a),G=u?(0,t.parse)(u):null,re=g.reduce(($,V)=>($.add(V),$),new Set),H=v(B,q,re),j=v(G,B,re),Q=v(G,q,re),x=new Map,J=new Set,Z=$=>{J.add($);const V=I.filter(({key:ee})=>ee===$)[0];V?(U=R.edit(U,[$],V.value,_),z=R.edit(z,[$],V.value,_)):x.set($,{key:$,localValue:B[$],remoteValue:q[$]})};for(const $ of j.removed.values())Q.updated.has($)?Z($):z=R.edit(z,[$],void 0,_);for(const $ of Q.removed.values())J.has($)||(j.updated.has($)?Z($):U=R.edit(U,[$],void 0,_));for(const $ of j.updated.values())J.has($)||(Q.updated.has($)?H.updated.has($)&&Z($):z=R.edit(z,[$],B[$],_));for(const $ of Q.updated.values())J.has($)||(j.updated.has($)?H.updated.has($)&&Z($):U=R.edit(U,[$],q[$],_));for(const $ of j.added.values())J.has($)||(Q.added.has($)?H.updated.has($)&&Z($):z=l($,U,z,_));for(const $ of Q.added.values())J.has($)||(j.added.has($)?H.updated.has($)&&Z($):U=l($,z,U,_));const W=x.size>0||!h(U,z,g),F=W||!h(U,s,[]),N=W||!h(z,a,[]);return{localContent:F?U:null,remoteContent:N?z:null,conflictsSettings:[...x.values()],hasConflicts:W}}e.merge=p;function h(s,a,u){if(s===a)return!0;const g=(0,t.parse)(s),I=(0,t.parse)(a),_=u.reduce((D,U)=>(D.add(U),D),new Set),O=o(s).filter(D=>!(D.setting&&_.has(D.setting.key))),M=o(a).filter(D=>!(D.setting&&_.has(D.setting.key)));if(O.length!==M.length)return!1;for(let D=0;D<O.length;D++){const U=O[D],z=M[D];if(U.setting&&z.setting){if(U.setting.key!==z.setting.key||!A.equals(g[U.setting.key],I[U.setting.key]))return!1}else if(!U.setting&&!z.setting){if(U.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function m(s){return s?o(s).length===0:!0}e.isEmpty=m;function v(s,a,u){const g=s?Object.keys(s).filter(D=>!u.has(D)):[],I=Object.keys(a).filter(D=>!u.has(D)),_=I.filter(D=>g.indexOf(D)===-1).reduce((D,U)=>(D.add(U),D),new Set),O=g.filter(D=>I.indexOf(D)===-1).reduce((D,U)=>(D.add(U),D),new Set),M=new Set;if(s)for(const D of g){if(O.has(D))continue;const U=s[D],z=a[D];A.equals(U,z)||M.add(D)}return{added:_,removed:O,updated:M}}function l(s,a,u,g){const I=(0,t.parse)(a),_=o(a),O=o(u),M=w(s,_,O);return S(u,s,I[s],M,O,g)}e.addSetting=l;function w(s,a,u){const g=a.findIndex(_=>_.setting?.key===s),I=a[g-1];if(I){if(I.setting){const O=d(I.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!0}}else{const O=i(g,a);if(O){const M=d(O.setting.key,u);if(M){const D=c(u.indexOf(M),u),U=r(a,O,a[g]);if(D){const z=r(u,M,D),B=n(U,z);return B?{index:u.indexOf(B),insertAfter:!0}:{index:u.indexOf(D),insertAfter:!1}}else{const z=r(u,M,u[u.length-1]),B=n(U,z);return B?{index:u.indexOf(B),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=a[g+1];if(_)if(_.setting){const O=d(_.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!1}}else{const O=c(g,a);if(O){const M=d(O.setting.key,u);if(M){const D=i(u.indexOf(M),u),U=r(a,a[g],O);if(D){const z=r(u,D,M),B=n(U.reverse(),z.reverse());return B?{index:u.indexOf(B),insertAfter:!1}:{index:u.indexOf(D),insertAfter:!0}}else{const z=r(u,u[0],M),B=n(U.reverse(),z.reverse());return B?{index:u.indexOf(B),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function S(s,a,u,g,I,_){let O;return g.index===-1?O=(0,L.setProperty)(s,[a],u,_):O=y(s,a,u,g,I,_).map(M=>(0,L.withFormatting)(s,M,_)[0]),(0,L.applyEdits)(s,O)}function y(s,a,u,g,I,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(u)}`,M=(0,T.getEOL)(_,s),D=I[g.index];if(g.insertAfter){const U=[];if(D.setting)U.push({offset:D.endOffset,length:0,content:","+O});else{const z=c(g.index,I),B=i(g.index,I),q=B?.setting?.commaOffset;B&&q===void 0&&U.push({offset:B.endOffset,length:0,content:","});const G=q!==void 0&&q>D.endOffset;U.push({offset:G?q+1:D.endOffset,length:0,content:z?M+O+",":M+O})}return U}else{if(D.setting)return[{offset:D.startOffset,length:0,content:O+","}];const U=(I[g.index-1]&&!I[g.index-1].setting?M:"")+O+(c(g.index,I)?",":"")+M;return[{offset:D.startOffset,length:0,content:U}]}}function d(s,a){return a.filter(u=>u.setting?.key===s)[0]}function i(s,a){for(let u=s-1;u>=0;u--)if(a[u].setting)return a[u]}function c(s,a){for(let u=s+1;u<a.length;u++)if(a[u].setting)return a[u]}function r(s,a,u){const g=s.indexOf(a),I=s.indexOf(u);return s.filter((_,O)=>g<O&&O<I)}function n(s,a){if(s.length&&a.length){let u=0;for(;u<a.length&&u<s.length;u++)if(s[u].value!==a[u].value)return a[u-1];return a[u-1]}}function o(s){const a=[];let u=-1,g,I;const _={onObjectBegin:O=>{u++},onObjectProperty:(O,M,D)=>{u===0&&(g=M,I=O)},onObjectEnd:(O,M)=>{u--,u===0&&a.push({startOffset:g,endOffset:O+M,value:s.substring(g,O+M),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,M)=>{u++},onArrayEnd:(O,M)=>{u--,u===0&&a.push({startOffset:g,endOffset:O+M,value:s.substring(g,O+M),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,M,D)=>{u===0&&a.push({startOffset:g,endOffset:M+D,value:s.substring(g,M+D),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,M,D)=>{if(u===0&&O===","){let U=a.length-1;for(;U>=0&&!a[U].setting;U--);const z=a[U];z&&a.splice(U,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:M}})}},onComment:(O,M)=>{u===0&&a.push({startOffset:O,endOffset:O+M,value:s.substring(O,O+M)})}};return(0,t.visit)(s,_),a}}),define(te[233],ne([0,1,17,3,146,19,90,14,30,15,23,21,32,45,53,232,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function l(d){return d&&d.settings&&typeof d.settings=="string"&&Object.keys(d).length===1}function w(d){const i=JSON.parse(d);return l(i)?i:{settings:d}}e.parseSettingsSyncContent=w;let S=class extends p.AbstractJsonFileSynchroniser{constructor(i,c,r,n,o,s,a,u,g,I,_,O){super(c.settingsResource,"settings",i,c,r,n,o,g,I,s,a,u,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const c=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(i,c),n=this.getSettingsSyncContent(r),o=new A.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return n?.settings&&o.parse(n.settings),o.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,c,r){const n=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(i);c=c===null&&r?i:c;const a=c?this.getSettingsSyncContent(c):null,u=await this.getIgnoredSettings();let g=null,I=!1,_=!1,O=!1;if(s){let D=n?n.value.toString().trim():"{}";D=D||"{}",this.validateContent(D),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const U=(0,m.merge)(D,s.settings,a?a.settings:null,u,[],o);g=U.localContent||U.remoteContent,I=U.localContent!==null,_=U.remoteContent!==null,O=U.hasConflicts}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=n.value.toString(),_=!0);const M={content:g,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:n,localResource:this.localResource,localContent:n?n.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const c=this.getSettingsSyncContent(i);if(c===null)return!0;const r=await this.getLocalFileContent(),n=r?r.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,m.merge)(n||"{}",c.settings,c.settings,o,[],s).remoteContent!==null}async getMergeResult(i,c){const r=await this.getFormattingOptions(),n=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,m.updateIgnoredSettings)(i.previewResult.content,"{}",n,r):null}}async getAcceptResult(i,c,r,n){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:i.fileContent?(0,m.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:i.remoteContent!==null?(0,m.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r!==null?(0,m.updateIgnoredSettings)(r,i.fileContent?i.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(i,c,r,n){const{fileContent:o}=r[0][0];let{content:s,localChange:a,remoteChange:u}=r[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,n),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const g=await this.getFormattingOptions(),I=this.getSettingsSyncContent(i),_=await this.getIgnoredSettings(s);s=(0,m.updateIgnoredSettings)(s,I?I.settings:"{}",_,g),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),n?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const c=await this.getFormattingOptions(),r=(0,h.edit)(i.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,m.isEmpty)(r)}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"settings.json"),comparableResource:c}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let c=await super.resolveContent(i);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(i)),c){const r=this.parseSyncData(c);if(r){const n=this.parseSettingsSyncContent(r.content);if(n)switch(this.extUri.basename(i)){case"settings.json":return n.settings}}}return null}async resolvePreviewContent(i){let c=await super.resolvePreviewContent(i);if(c){const r=await this.getFormattingOptions(),n=await this.getIgnoredSettings();c=(0,m.updateIgnoredSettings)(c,"{}",n,r)}return c}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return w(i)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,n=>n.some(({local:o})=>!!o)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,n=>!n.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(c,this.configurationService,i)}validateContent(i){if(this.hasErrors(i))throw new v.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};S=he([K(0,b.IFileService),K(1,R.IEnvironmentService),K(2,P.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncBackupStoreService),K(5,v.IUserDataSyncLogService),K(6,v.IUserDataSyncUtilService),K(7,T.IConfigurationService),K(8,v.IUserDataSyncEnablementService),K(9,E.ITelemetryService),K(10,C.IExtensionManagementService),K(11,f.IUriIdentityService)],S),e.SettingsSynchroniser=S;let y=class extends p.AbstractInitializer{constructor(i,c,r,n){super("settings",c,r,i,n)}async doInitialize(i){const c=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return w(i)}catch(c){this.logService.error(c)}return null}};y=he([K(0,b.IFileService),K(1,R.IEnvironmentService),K(2,v.IUserDataSyncLogService),K(3,f.IUriIdentityService)],y),e.SettingsInitializer=y}),define(te[234],ne([0,1,17,3,28,19,14,15,23,21,32,45,227,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(l,w,S,y,d,i,c,r,n,o){super("snippets",w,l,S,y,d,r,n,i,c,o);this.version=1,this.snippetsFolder=l.snippetsHome,this._register(this.fileService.watch(l.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(l,w,S){const y=await this.getSnippetsFileContents(),d=this.toSnippetsContents(y),i=l.syncData?this.parseSnippets(l.syncData):null;w=w===null&&S?l:w;const c=w&&w.syncData?this.parseSnippets(w.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(d,i,c);return this.getResourcePreviews(r,y,i||{})}async hasRemoteChanged(l){const w=l.syncData?this.parseSnippets(l.syncData):null;if(w===null)return!0;const S=await this.getSnippetsFileContents(),y=this.toSnippetsContents(S),d=(0,f.merge)(y,w,w);return Object.keys(d.remote.added).length>0||Object.keys(d.remote.updated).length>0||d.remote.removed.length>0||d.conflicts.length>0}async getMergeResult(l,w){return l.previewResult}async getAcceptResult(l,w,S,y){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return S===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:S,localChange:S===null?l.fileContent!==null?3:0:2,remoteChange:S===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(l,w,S,y){const d=S.map(([i,c])=>({...i,acceptResult:c}));d.every(({localChange:i,remoteChange:c})=>i===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),d.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(d),await this.updateLocalSnippets(d,y)),d.some(({remoteChange:i})=>i!==0)&&(l=await this.updateRemoteSnippets(d,l,y)),w?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(l),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of d)try{await this.fileService.del(i)}catch{}}getResourcePreviews(l,w,S){const y=new Map;for(const d of Object.keys(l.local.added)){const i={content:l.local.added[d],hasConflicts:!1,localChange:1,remoteChange:0};y.set(d,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(l.local.updated)){const i={content:l.local.updated[d],hasConflicts:!1,localChange:2,remoteChange:0};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of l.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(l.remote.added)){const i={content:l.remote.added[d],hasConflicts:!1,localChange:0,remoteChange:1};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(l.remote.updated)){const i={content:l.remote.updated[d],hasConflicts:!1,localChange:0,remoteChange:2};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of l.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of l.conflicts){const i={content:w[d]?w[d].value.toString():null,hasConflicts:!0,localChange:w[d]?2:1,remoteChange:S[d]?2:1};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d]||null,localContent:w[d]?w[d].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[d]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(w))if(!y.has(d)){const i={content:w[d]?w[d].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d]||null,localContent:w[d]?w[d].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[d]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:l}){let w=await super.resolveContent(l);if(w){const S=this.parseSyncData(w);if(S){const y=this.parseSnippets(S),d=[];for(const i of Object.keys(y)){const c=this.extUri.joinPath(l,i),r=this.extUri.joinPath(this.snippetsFolder,i),n=await this.fileService.exists(r);d.push({resource:c,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return d}}return[]}async resolveContent(l){if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(l);let w=await super.resolveContent(l);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(l)),w){const S=this.parseSyncData(w);if(S)return this.parseSnippets(S)[this.extUri.basename(l)]||null}return null}async hasLocalData(){try{const l=await this.getSnippetsFileContents();if(Object.keys(l).length)return!0}catch{}return!1}async updateLocalBackup(l){const w={};for(const S of l)S.fileContent&&(w[this.extUri.basename(S.localResource)]=S.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(l,w){for(const{fileContent:S,acceptResult:y,localResource:d,remoteResource:i,localChange:c}of l)if(c!==0){const r=i?this.extUri.basename(i):this.extUri.basename(d),n=this.extUri.joinPath(this.snippetsFolder,r);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,k.VSBuffer.fromString(y.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,k.VSBuffer.fromString(y.content),w?void 0:S),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(l,w,S){const y=w.syncData?this.parseSnippets(w.syncData):{},d=(0,L.deepClone)(y);for(const{acceptResult:i,localResource:c,remoteResource:r,remoteChange:n}of l)if(n!==0){const o=c?this.extUri.basename(c):this.extUri.basename(r);n===3?delete d[o]:d[o]=i.content}return(0,f.areSame)(y,d)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(d),S?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(l){return JSON.parse(l.content)}toSnippetsContents(l){const w={};for(const S of Object.keys(l))w[S]=l[S].value.toString();return w}async getSnippetsFileContents(){const l={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(S){if(S instanceof R.FileOperationError&&S.fileOperationResult===1)return l;throw S}for(const S of w.children||[]){const y=S.resource,d=this.extUri.extname(y);if(d===".json"||d===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,y),c=await this.fileService.readFile(y);l[i]=c}}return l}};h=he([K(0,A.IEnvironmentService),K(1,R.IFileService),K(2,C.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncBackupStoreService),K(5,p.IUserDataSyncLogService),K(6,T.IConfigurationService),K(7,p.IUserDataSyncEnablementService),K(8,b.ITelemetryService),K(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let m=class extends E.AbstractInitializer{constructor(l,w,S,y){super("snippets",w,S,l,y)}async doInitialize(l){const w=l.syncData?JSON.parse(l.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(w)){const d=w[y];if(d){const i=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(i,k.VSBuffer.fromString(d)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(l)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};m=he([K(0,R.IFileService),K(1,A.IEnvironmentService),K(2,p.IUserDataSyncLogService),K(3,P.IUriIdentityService)],m),e.SnippetsInitializer=m}),define(te[235],ne([0,1,17,19,14,15,23,21,32,45,24]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function E(m,v){try{return JSON.parse(m).tasks}catch(l){return v.error(l),null}}e.getTasksContentFromSyncContent=E;let f=class extends b.AbstractFileSynchroniser{constructor(v,l,w,S,y,d,i,c,r,n){super(n.extUri.joinPath(n.extUri.dirname(i.settingsResource),"tasks.json"),"tasks",d,i,c,v,l,y,r,w,S,n);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(v,l,w,S){const y=v.syncData?E(v.syncData.content,this.logService):null;l=l===null&&w?v:l;const d=l?.syncData?E(l.syncData.content,this.logService):null,i=await this.getLocalFileContent();let c=null,r=!1,n=!1,o=!1;if(y){const a=i?i.value.toString():null;if(!d||d!==a||d!==y){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const u=h(a,y,d);c=u.content,o=u.hasConflicts,r=u.hasLocalChanged,n=u.hasRemoteChanged}}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),c=i.value.toString(),n=!0);const s={content:c,localChange:r?i?2:1:0,remoteChange:n?2:0,hasConflicts:o};return[{fileContent:i,localResource:this.localResource,localContent:i?i.value.toString():null,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:y,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(v){const l=v?.syncData?E(v.syncData.content,this.logService):null;if(l===null)return!0;const w=await this.getLocalFileContent(),S=w?w.value.toString():null,y=h(S,l,l);return y.hasLocalChanged||y.hasRemoteChanged}async getMergeResult(v,l){return v.previewResult}async getAcceptResult(v,l,w,S){if(this.extUri.isEqual(l,this.localResource))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(l,this.remoteResource))return{content:v.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(l,this.previewResource))return w===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:w,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(v,l,w,S){const{fileContent:y}=w[0][0];let{content:d,localChange:i,remoteChange:c}=w[0][1];if(i===0&&c===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),i!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),y&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(y.value.toString()))),await this.updateLocalFileContent(d||"{}",y,S),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),c!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(d||"{}"));v=await this.updateRemoteUserData(r,S?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}l?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:v}){const l=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(v,"tasks.json"),comparableResource:l}]}async resolveContent(v){if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let l=await super.resolveContent(v);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(v)),l){const w=this.parseSyncData(l);if(w)switch(this.extUri.basename(v)){case"tasks.json":return E(w.content,this.logService)}}return null}toTasksSyncContent(v){return{tasks:v}}};f=he([K(0,P.IUserDataSyncStoreService),K(1,P.IUserDataSyncBackupStoreService),K(2,P.IUserDataSyncLogService),K(3,t.IConfigurationService),K(4,P.IUserDataSyncEnablementService),K(5,T.IFileService),K(6,L.IEnvironmentService),K(7,A.IStorageService),K(8,R.ITelemetryService),K(9,C.IUriIdentityService)],f),e.TasksSynchroniser=f;let p=class extends b.AbstractInitializer{constructor(v,l,w,S){super("tasks",l,w,v,S);this.uriIdentityService=S,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(v){const l=v.syncData?E(v.syncData.content,this.logService):null;if(!l){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(l)),await this.updateLastSyncUserData(v)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};p=he([K(0,T.IFileService),K(1,L.IEnvironmentService),K(2,P.IUserDataSyncLogService),K(3,C.IUriIdentityService)],p),e.TasksInitializer=p;function h(m,v,l){if(m===null&&v===null&&l===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(m===v)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const w=l!==m,S=l!==v;return!w&&!S?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:w&&!S?{content:m,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:S&&!w?{content:v,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:m,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(te[65],ne([0,1,3,2,6,24]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(C,b){super();this.userDataSyncStoreService=C,this.logService=b,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};A=he([K(0,T.IUserDataSyncStoreService),K(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(te[236],ne([0,1,5,17,57,2,20,19,14,15,24]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends T.Disposable{constructor(p,h,m,v){super();this.environmentService=p,this.fileService=h,this.configurationService=m,this.logService=v,P.ALL_SYNC_RESOURCES.forEach(l=>this.cleanUpBackup(l))}async getAllRefs(p){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),m=await this.fileService.resolve(h);return m.children?m.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort().reverse().map(l=>({ref:l.name,created:this.getCreationTime(l)})):[]}async resolveContent(p,h){if(!h){const m=await this.getAllRefs(p);m.length&&(h=m[m.length-1].ref)}if(h){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(m)).value.toString()}return null}async backup(p,h){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),v=(0,A.joinPath)(m,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,t.VSBuffer.fromString(h))}catch(l){this.logService.error(l)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch{return}const m=await this.fileService.resolve(h);if(m.children){const v=m.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort(),l=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(y=>Date.now()-this.getCreationTime(y)>l);const S=v.length-w.length;S<10&&(w=w.slice(10-S)),await k.Promises.settled(w.map(async y=>{this.logService.info("Deleting from backup",y.resource.path),await this.fileService.del(y.resource)}))}}catch(m){this.logService.error(m)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=he([K(0,C.IEnvironmentService),K(1,b.IFileService),K(2,R.IConfigurationService),K(3,P.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[237],ne([0,1,3,2,4,14,23,21,24]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let P=class extends t.Disposable{constructor(f,p,h,m){super();this.storageService=f,this.telemetryService=p,this.environmentService=h,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:f}),this.storageService.store(b,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,C.getEnablementKey)(f),0,!0)}setResourceEnablement(f,p){if(this.isResourceEnabled(f)!==p){const h=(0,C.getEnablementKey)(f);this.storeResourceEnablement(h,p)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,p){this.storageService.store(f,p,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(b===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=C.ALL_SYNC_RESOURCES.filter(h=>(0,C.getEnablementKey)(h)===f.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=he([K(0,A.IStorageService),K(1,R.ITelemetryService),K(2,T.IEnvironmentService),K(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(te[238],ne([0,1,2,7]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class b{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class P extends k.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:t.URI.revive(f.url),type:f.type,defaultUrl:t.URI.revive(f.defaultUrl),insidersUrl:t.URI.revive(f.insidersUrl),stableUrl:t.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(te[239],ne([0,1,14,8]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends t.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=he([K(0,t.ILoggerService),K(1,k.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(te[66],ne([0,1,3,2,4,26,149,14,15,6,27,47,23,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",m="Safari",v="Chrome",l="Edge",w="Firefox",S="Android";function y(c){switch(c){case m:case v:case l:case w:case S:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=y;function d(){return L.isSafari?m:L.isChrome?v:L.isEdge?l:L.isFirefox?w:L.isAndroid?S:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let i=class Ze extends t.Disposable{constructor(r,n,o,s,a,u){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=a,this.productService=u,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(r,n,o)}async getMachines(r){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(r)).machines.map(s=>({...s,isCurrent:s.id===n}))}async addCurrentMachine(r){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(r);o.machines.some(({id:s})=>s===n)||(o.machines.push({id:n,name:this.computeCurrentMachineName(o.machines),platform:d()}),await this.writeMachinesData(o))}async removeCurrentMachine(r){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(r),s=o.machines.filter(({id:a})=>a!==n);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(r,n,o){const s=await this.readMachinesData(o),a=s.machines.find(({id:u})=>u===r);if(a){a.name=n,await this.writeMachinesData(s);const u=await this.currentMachineIdPromise;r===u&&this.storageService.store(h,n,0,1)}}async setEnablements(r){const n=await this.readMachinesData();for(const[o,s]of r){const a=n.machines.find(u=>u.id===o);a&&(a.disabled=s?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(r){const n=this.storageService.get(h,0);if(n)return n;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${d()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const u of r){const g=s.exec(u.name),I=g?parseInt(g[1]):0;a=I>a?I:a}return`${o} #${a+1}`}async readMachinesData(r){this.userData=await this.readUserData(r);const n=this.parse(this.userData);if(n.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(r){const n=JSON.stringify(r),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,n,this.userData?.ref||null);this.userData={ref:o,content:n},this._onDidChange.fire()}async readUserData(r){if(this.userData){const n=r&&r.latest?r.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(r){if(r.content!==null)try{return JSON.parse(r.content)}catch(n){this.logService.error(n)}return{version:Ze.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=he([K(0,R.IEnvironmentService),K(1,C.IFileService),K(2,f.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncLogService),K(5,P.IProductService)],i),e.UserDataSyncMachinesService=i}),define(te[240],ne([0,1,5,57,37,9,3,2,4,20,7,147,27,23,21,24,65,66]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",S="sync.sessionId",y="sync.storeUrl",d="sync.productQuality";let i=class extends R.Disposable{constructor(n,o,s,a,u,g,I,_,O,M){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=u,this.logService=g,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=M,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(u.onDidChangeLocal(D=>this.triggerSync([D],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,D])=>D)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const n=this.storageService.get(y,0);return n?P.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(y,n.toString(),0,1):this.storageService.remove(y,0)}get productQuality(){return this.storageService.get(d,0)}set productQuality(n){n?this.storageService.store(d,n,0,1):this.storageService.remove(d,0)}updateAutoSync(){const{enabled:n,message:o}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(S,0),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const o=m.UserDataSyncError.toUserDataSyncError(n);o instanceof m.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?C.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(n,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=he([K(0,f.IProductService),K(1,m.IUserDataSyncStoreManagementService),K(2,m.IUserDataSyncStoreService),K(3,m.IUserDataSyncEnablementService),K(4,m.IUserDataSyncService),K(5,m.IUserDataSyncLogService),K(6,v.IUserDataSyncAccountService),K(7,h.ITelemetryService),K(8,l.IUserDataSyncMachinesService),K(9,p.IStorageService)],i),e.UserDataAutoSyncService=i;class c extends R.Disposable{constructor(n,o,s,a,u,g,I,_){super();this.lastSyncUrl=n,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=u,this.userDataSyncMachinesService=g,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(n,o){const s=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,T.isCancellationError)(u))return}return this.doSync(n,o,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!n&&(!(0,b.isEqual)(o.defaultUrl,n.defaultUrl)||!(0,b.isEqual)(o.insidersUrl,n.insidersUrl)||!(0,b.isEqual)(o.stableUrl,n.stableUrl))}async doSync(n,o,s){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new m.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const u=this.storageService.get(S,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new m.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const g=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const I=g.find(_=>_.isCurrent);if(I?.disabled)throw new m.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new m.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof m.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(S,this.manifest.session,0,1),s.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),a=u}this._onDidFinishSync.fire(a)}register(n){return super._register(n)}}c.INTERVAL_SYNCING="Interval"}),define(te[241],ne([0,1,16,5,37,3,2,20,11,29,19,30,6,23,21,228,230,231,233,234,235,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let c=class extends A.Disposable{constructor(a,u,g,I,_,O,M,D){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=u,this.instantiationService=g,this.configurationService=I,this.logService=_,this.telemetryService=O,this.storageService=M,this.userDataSyncEnablementService=D,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(i,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,u){this.checkEnablement();const g=(0,b.generateUuid)();try{const D=(0,d.createSyncHeaders)(g);u&&(D["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,D)}catch(D){const U=d.UserDataSyncError.toUserDataSyncError(D);throw this.reportUserDataSyncError(U,g),U}let I=!1;const _=this,O=this.getEnabledSynchronizers();let M;return{manifest:a,async run(){if(I)throw new Error("Can run a task only once");return M=(0,t.createCancelablePromise)(D=>_.sync(O,a,g,D)),M.finally(()=>M=void 0)},async stop(){if(M&&M.cancel(),_.status!=="idle")return _.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new d.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,b.generateUuid)(),u=(0,d.createSyncHeaders)(a);let g;try{g=await this.userDataSyncStoreService.manifest(null,u)}catch(O){const M=d.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(M,a),M}await this.resetLocal();const I=this.getEnabledSynchronizers(),_=async()=>{await this.stop(I),await this.resetLocal()};return new r(a,g,u,I,_,this.configurationService,this.logService)}async sync(a,u,g,I){if(I.isCancellationRequested||!a.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,d.createSyncHeaders)(g);for(const M of a){if(I.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(M.resource))return;try{await M.sync(u,O)}catch(D){let U=!1;if(D instanceof d.UserDataSyncError)switch(D.code){case"TooLarge":D=new d.UserDataSyncError(D.message,D.code,M.resource),U=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":U=!0;break}const z=d.UserDataSyncError.toUserDataSyncError(D);if(this.reportUserDataSyncError(z,g),U)throw z;this.logService.error(D),this.logService.error(`${M.resource}: ${(0,L.toErrorMessage)(D)}`),this._syncErrors.push([M.resource,z])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(O){const M=d.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(M,g),M}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const u of a)try{u.status!=="idle"&&await u.stop()}catch(g){this.logService.error(g)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(a))return!0})}async accept(a,u,g,I){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===a)return await _.accept(u,g),I&&await _.apply(!1,(0,d.createSyncHeaders)((0,b.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async u=>{const g=await u.resolveContent(a);if(g)return g})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async g=>{if(g.resource===a)return g.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async g=>{if(g.resource===a)return g.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,u){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return I.getAssociatedResources(u)})||[]}async getMachineId(a,u){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return await I.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(i,0),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(u){this.logService.error(`${a.resource}: ${(0,L.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const u=new A.DisposableStore;try{const g=this.synchronizers.value||u.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),I=[...g.enabled,...g.disabled.map(_=>u.add(g.createSynchronizer(_)))];for(const _ of I){const O=await a(_);if(!(0,C.isUndefined)(O))return O}return null}finally{u.dispose()}}setStatus(a){const u=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const u=this.computeStatus(a);this.setStatus(u)}updateConflicts(a){const u=this.computeConflicts(a);(0,k.equals)(this._conflicts,u,([g,I],[_,O])=>g===g&&(0,k.equals)(I,O,(M,D)=>(0,R.isEqual)(M.previewResource,D.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(u))}computeConflicts(a){return a.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(u=>u.status==="hasConflicts")?"hasConflicts":a.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,u){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof d.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof d.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([K(0,d.IUserDataSyncStoreService),K(1,d.IUserDataSyncStoreManagementService),K(2,f.IInstantiationService),K(3,P.IConfigurationService),K(4,d.IUserDataSyncLogService),K(5,h.ITelemetryService),K(6,p.IStorageService),K(7,d.IUserDataSyncEnablementService)],c),e.UserDataSyncService=c;class r extends A.Disposable{constructor(a,u,g,I,_,O,M){super();this.id=a,this.manifest=u,this.syncHeaders=g,this.synchronisers=I,this.onStop=_,this.configurationService=O,this.logService=M,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,u){try{return await this.performAction(a,g=>g.accept(a,u))}catch(g){throw this.logService.error(g),g}}async merge(a){try{return a?await this.performAction(a,u=>u.merge(a)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(a){try{return await this.performAction(a,u=>u.discard(a))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,u]of this.previews)for(const g of u.resourcePreviews)g.mergeState==="conflict"&&a.push(g.previewResource);for(const u of a)await this.discard(u);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[u,g]of this.previews){this.synchronizingResources.push([u,g.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(O=>O.resource===u);for(const O of g.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await I.merge(O.previewResource);const _=await I.apply(!1,this.syncHeaders);_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(I=>I.resource===a);for(const I of u.resourcePreviews)await g.accept(I.remoteResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(I=>I.resource===a);for(const I of u.resourcePreviews)await g.accept(I.localResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const g=this.previews.findIndex(([,B])=>B.resourcePreviews.some(({localResource:q,previewResource:G,remoteResource:re})=>(0,R.isEqual)(a,q)||(0,R.isEqual)(a,G)||(0,R.isEqual)(a,re)));if(g===-1)return this.previews;const[I,_]=this.previews[g],O=_.resourcePreviews.find(({localResource:B,remoteResource:q,previewResource:G})=>(0,R.isEqual)(B,a)||(0,R.isEqual)(q,a)||(0,R.isEqual)(G,a));if(!O)return this.previews;let M=this.synchronizingResources.find(B=>B[0]===I);M||(M=[I,[]],this.synchronizingResources.push(M)),M[1].some(B=>(0,R.isEqual)(B,O.localResource))||(M[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const D=this.synchronisers.find(B=>B.resource===this.previews[g][0]),U=await u(D);U?this.previews.splice(g,1,this.toSyncResourcePreview(D.resource,U)):this.previews.splice(g,1);const z=this.synchronizingResources.findIndex(B=>B[0]===I);return this.synchronizingResources[z][1].splice(M[1].findIndex(B=>(0,R.isEqual)(B,O.localResource)),1),M[1].length||(this.synchronizingResources.splice(z,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[u,g]of this.previews){this.synchronizingResources.push([u,g.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(O=>O.resource===u);let _=g;for(const O of g.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(_=await I.merge(O.previewResource));_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const u=[],g=await this.getUserDataSyncConfiguration();for(const I of this.synchronisers){if(a.isCancellationRequested)return[];const _=await I.preview(this.manifest,g,this.syncHeaders);_&&u.push(this.toSyncResourcePreview(I.resource,_))}return u}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=this.synchronisers.find(g=>g instanceof w.SettingsSynchroniser);if(u){const g=await u.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...g}}return a}toSyncResourcePreview(a,u){return[a,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends A.Disposable{constructor(a,u,g,I,_,O,M){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=u,this.onDidChangeLocal=g,this.userDataSyncEnablementService=I,this.instantiationService=_,this.extensionGalleryService=O,this.logService=M,this._enabled=[],this._register(I.onDidChangeResourceEnablement(([D,U])=>this.onDidChangeResourceEnablement(D,U))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,D])=>D.dispose())));for(const D of d.ALL_SYNC_RESOURCES)I.isResourceEnabled(D)&&this.registerSynchronizer(D)}get enabled(){return this._enabled.sort((a,u)=>a[1]-u[1]).map(([a])=>a)}get disabled(){return d.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,u){u?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([_])=>_.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new A.DisposableStore,g=u.add(this.createSynchronizer(a));u.add(g.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(g.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(g.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const I=this.getOrder(a);this._enabled.push([g,I,u])}deRegisterSynchronizer(a){const u=this._enabled.findIndex(([g])=>g.resource===a);if(u!==-1){const g=this._enabled.splice(u,1);for(const[I,,_]of g){if(I.status!=="idle"){const O=I.conflicts.length>0;I.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(l.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(S.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(y.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(m.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};n=he([K(3,d.IUserDataSyncEnablementService),K(4,f.IInstantiationService),K(5,E.IExtensionGalleryService),K(6,d.IUserDataSyncLogService)],n);function o(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[242],ne([0,1,3,2,11,7,24]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(E,f){this.service=E,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(E,f,p){try{return await this._call(E,f,p)}catch(h){throw this.logService.error(h),h}}async _call(E,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],T.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),m=p[0],v=this.getManualSyncTask(m);switch(p=p.slice(1),h){case"preview":return v.preview();case"accept":return v.accept(T.URI.revive(p[0]),p[1]);case"merge":return v.merge(T.URI.revive(p[0]));case"discard":return v.discard(T.URI.revive(p[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const f=this.manualSyncTasks.get(this.createKey(E));if(!f)throw new Error(`Manual sync taks not found: ${E}`);return f.manualSyncTask}async createManualSyncTask(){const E=new t.DisposableStore,f=E.add(await this.service.createManualSyncTask());return E.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:E}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(E){E.dispose();const f=this.createKey(E.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=R;class C extends t.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,h){return E.call(f,p,h).then(null,m=>{throw A.UserDataSyncError.toUserDataSyncError(m)})},listen(f,p){return E.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,h])=>{this.updateStatus(f),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(m=>this.updateStatus(m))),this._register(this.channel.listen("onDidChangeLastSyncTime")(m=>this.updateLastSyncTime(m)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,h])=>[p,A.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),h=this,m=new b(E,f,p,{async call(v,l,w){return h.channel.call(`manualSync/${v}`,[E,...(0,L.isArray)(l)?l:[l]],w)},listen(v,l){return k.Event.map(k.Event.filter(h.channel.listen(`manualSync/${v}`,l),w=>!m.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return m}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,f,p,h){return this.channel.call("accept",[E,f,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:T.URI.revive(h)}))}async getAssociatedResources(E,f){return(await this.channel.call("getAssociatedResources",[E,f])).map(({resource:h,comparableResource:m})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(m)}))}async getMachineId(E,f){return this.channel.call("getMachineId",[E,f])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([f,p])=>[f,p.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=C;class b extends t.Disposable{constructor(E,f,p,h){super();this.id=E,this.manifest=f,this._disposed=!1,this._status=p;const m=this;this.channel={async call(v,l,w){try{const S=await h.call(v,l,w);return m.isDiposed()||(m._status=await h.call("_getStatus")),S}catch(S){throw A.UserDataSyncError.toUserDataSyncError(S)}},listen(v,l){return h.listen(v,l)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,f){const p=await this.channel.call("accept",[E,f]);return this.deserializePreviews(p)}async merge(E){const f=await this.channel.call("merge",[E]);return this.deserializePreviews(f)}async discard(E){const f=await this.channel.call("discard",[E]);return this.deserializePreviews(f)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[243],ne([0,1,5,25,9,3,2,102,4,20,11,7,29,19,14,15,27,43,47,23,24]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const d="sync.previous.store",i="sync.donot-make-requests-until",c="sync.user-session-id",r="sync.machine-session-id",n=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(O,M,D){super();this.productService=O,this.configurationService=M,this.storageService=D,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(D.onDidChangeValue,U=>U.key===y.SYNC_SERVICE_URL_TYPE&&U.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(y.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(y.SYNC_SERVICE_URL_TYPE,O,0,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[y.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(y.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,M){O=C.isWeb&&O?.web?{...O,...O.web}:O;const D={...O||{},...M||{}};if(D&&(0,P.isString)(D.url)&&(0,P.isObject)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(U=>(0,P.isArray)(D.authenticationProviders[U].scopes))){const U=D,z=!!U.canSwitch&&!M?.url,B=U.url===U.insidersUrl?"insiders":"stable",q=(z?this.userDataSyncStoreType:void 0)||B,G=M?.url||(q==="insiders"?U.insidersUrl:q==="stable"?U.stableUrl:U.url);return{url:E.URI.parse(G),type:q,defaultType:B,defaultUrl:E.URI.parse(U.url),stableUrl:E.URI.parse(U.stableUrl),insidersUrl:E.URI.parse(U.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(U.authenticationProviders).reduce((re,H)=>(re.push({id:H,scopes:U.authenticationProviders[H].scopes}),re),[])}}}};s=he([K(0,v.IProductService),K(1,p.IConfigurationService),K(2,S.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(O,M,D){super(O,M,D);const U=this.storageService.get(d,0);U&&(this.previousConfigurationSyncStore=JSON.parse(U));const z=this.productService[y.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(d,JSON.stringify(z),0,1):this.storageService.remove(d,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=he([K(0,v.IProductService),K(1,p.IConfigurationService),K(2,S.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends A.Disposable{constructor(O,M,D,U,z,B,q){super();this.requestService=D,this.logService=U,this.storageService=q,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(z,B,q).then(G=>{const re={"X-Client-Name":`${M.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(re["X-Client-Commit"]=M.commit),re}),this.session=new I(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,M){this.authToken={token:O,type:M}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(M=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),D={},U=await this.request(M.toString(),{type:"GET",headers:D},[],t.CancellationToken.None);return(await(0,l.asJson)(U)||[]).map(({url:B,created:q})=>({ref:(0,b.relativePath)(M,M.with({path:B})),created:q*1e3}))}async resolveContent(O,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,M).toString(),U={};U["Cache-Control"]="no-cache";const z=await this.request(D,{type:"GET",headers:U},[],t.CancellationToken.None);return await(0,l.asText)(z)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),D={};await this.request(M,{type:"DELETE",headers:D},[],t.CancellationToken.None)}async read(O,M,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();D={...D},D["Cache-Control"]="no-cache",M&&(D["If-None-Match"]=M.ref);const z=await this.request(U,{type:"GET",headers:D},[304],t.CancellationToken.None);let B=null;if(z.res.statusCode===304&&(B=M),B===null){const q=z.res.headers.etag;if(!q)throw new y.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",z.res.statusCode,z.res.headers[y.HEADER_OPERATION_ID]);const G=await(0,l.asText)(z);if(!G&&z.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",U,"EmptyResponse",z.res.statusCode,z.res.headers[y.HEADER_OPERATION_ID]);B={ref:q,content:G}}return B}async write(O,M,D,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();U={...U},U["Content-Type"]=R.Mimes.text,D&&(U["If-Match"]=D);const B=await this.request(z,{type:"POST",data:M,headers:U},[],t.CancellationToken.None),q=B.res.headers.etag;if(!q)throw new y.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",B.res.statusCode,B.res.headers[y.HEADER_OPERATION_ID]);return q}async manifest(O,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const U=await this.request(D,{type:"GET",headers:M},[304],t.CancellationToken.None);let z=null;if(U.res.statusCode===304&&(z=O),!z){const q=U.res.headers.etag;if(!q)throw new y.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",U.res.statusCode,U.res.headers[y.HEADER_OPERATION_ID]);const G=await(0,l.asText)(U);if(!G&&U.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",D,"EmptyResponse",U.res.statusCode,U.res.headers[y.HEADER_OPERATION_ID]);G&&(z={...JSON.parse(G),ref:q})}const B=this.storageService.get(c,0);return B&&z&&B!==z.session&&this.clearSession(),z===null&&B&&this.clearSession(),z&&this.storageService.store(c,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:M},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(r,0)}async request(O,M,D,U){if(!this.authToken)throw new y.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;M.headers={...M.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let B;try{B=await this.session.request(O,M,U)}catch(H){if(!(H instanceof y.UserDataSyncStoreError)){let j="RequestFailed";const Q=(0,L.getErrorMessage)(H).toLowerCase();Q.includes("xhr timeout")?j="RequestTimeout":Q.includes("protocol")&&Q.includes("not supported")?j="RequestProtocolNotSupported":Q.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Q.includes("headers must be an object")?j="RequestHeadersNotObject":(0,L.isCancellationError)(H)&&(j="RequestCanceled"),H=new y.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,j,void 0,void 0)}throw this.logService.info("Request failed",O),H}const q=B.res.headers[y.HEADER_OPERATION_ID],G={url:O,status:B.res.statusCode,"execution-id":M.headers[y.HEADER_EXECUTION_ID],"operation-id":q},re=(0,l.isSuccess)(B)||B.res.statusCode&&D.indexOf(B.res.statusCode)!==-1;if(re?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),B.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new y.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",B.res.statusCode,q);if(this._onTokenSucceed.fire(),B.res.statusCode===409)throw new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",B.res.statusCode,q);if(B.res.statusCode===410)throw new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",B.res.statusCode,q);if(B.res.statusCode===412)throw new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",B.res.statusCode,q);if(B.res.statusCode===413)throw new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",B.res.statusCode,q);if(B.res.statusCode===426)throw new y.UserDataSyncStoreError(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",B.res.statusCode,q);if(B.res.statusCode===429){const H=B.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",B.res.statusCode,q)):new y.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",B.res.statusCode,q)}if(!re)throw new y.UserDataSyncStoreError("Server returned "+B.res.statusCode,O,"Unknown",B.res.statusCode,q);return B}addSessionHeaders(O){let M=this.storageService.get(r,0);M===void 0&&(M=(0,f.generateUuid)(),this.storageService.store(r,M,0,1)),O["X-Machine-Session-Id"]=M;const D=this.storageService.get(c,0);D!==void 0&&(O["X-User-Session-Id"]=D)}};u=he([K(1,v.IProductService),K(2,l.IRequestService),K(3,y.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,m.IFileService),K(6,S.IStorageService)],u),e.UserDataSyncStoreClient=u;let g=class extends u{constructor(O,M,D,U,z,B,q){super(O.userDataSyncStore?.url,M,D,U,z,B,q);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};g=he([K(0,y.IUserDataSyncStoreManagementService),K(1,v.IProductService),K(2,l.IRequestService),K(3,y.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,m.IFileService),K(6,S.IStorageService)],g),e.UserDataSyncStoreService=g;class I{constructor(O,M,D,U){this.limit=O,this.interval=M,this.requestService=D,this.logService=U,this.requests=[],this.startTime=void 0}request(O,M,D){if(this.isExpired()&&this.reset(),M.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new y.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(M,D)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(te[244],ne([0,1,3,60,27,23,21,240,24,65,66]),function(Y,e,k,t,L,T,A,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(p,h,m,v,l,w,S,y,d,i,c){super(p,h,m,v,l,S,y,d,i,c);this._register(k.Event.debounce(k.Event.any(k.Event.map(w.onDidFocusWindow,()=>"windowFocus"),k.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(r,n)=>r?[...r,n]:[n],1e3)(r=>this.triggerSync(r,!0,!1)))}};E=he([K(0,L.IProductService),K(1,C.IUserDataSyncStoreManagementService),K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncEnablementService),K(4,C.IUserDataSyncService),K(5,t.INativeHostService),K(6,C.IUserDataSyncLogService),K(7,b.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,P.IUserDataSyncMachinesService),K(10,T.IStorageService)],E),e.UserDataAutoSyncService=E}),define(te[245],ne([0,1,5,3,2]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:b}){super();this.disposables=this._register(new L.DisposableStore),t.Event.latch(t.Event.any(R,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>b()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[67],ne([0,1,50,5,10,11,22,125,258,259]),function(Y,e,k,t,L,T,A,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(i,c){let r=c.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=i,this.cause=c}}e.ExtractError=P;function E(d){const i=d.externalFileAttributes>>16||33188;return[448,56,7].map(c=>i&c).reduce((c,r)=>c+r,i&61440)}function f(d){if(d instanceof P)return d;let i;return/end of central directory record signature not found/.test(d.message)&&(i="CorruptZip"),new P(i,d)}function p(d,i,c,r,n,o){const s=L.dirname(i),a=L.join(r,s);if(!a.startsWith(r))return Promise.reject(new Error(R.localize(0,null,i)));const u=L.join(r,i);let g;return o.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!o.isCancellationRequested)try{g=(0,k.createWriteStream)(u,{mode:c}),g.once("close",()=>I()),g.once("error",_),d.once("error",_),d.pipe(g)}catch(O){_(O)}}))}function h(d,i,c,r){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),o=0;return r.onCancellationRequested(()=>{n.cancel(),d.close()}),new Promise((s,a)=>{const u=new t.Sequencer,g=I=>{I.isCancellationRequested||(o++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{r.isCancellationRequested||d.entryCount===o?s():a(new P("Incomplete",new Error(R.localize(1,null,o,d.entryCount))))},a)),d.readEntry(),d.on("entry",I=>{if(r.isCancellationRequested)return;if(!c.sourcePathRegex.test(I.fileName)){g(r);return}const _=I.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const D=L.join(i,_);n=(0,t.createCancelablePromise)(U=>A.Promises.mkdir(D,{recursive:!0}).then(()=>g(U)).then(void 0,a));return}const O=v(d,I),M=E(I);n=(0,t.createCancelablePromise)(D=>u.queue(()=>O.then(U=>p(U,_,M,i,c,D).then(()=>g(D)))).then(null,a))})})}function m(d,i=!1){return new Promise((c,r)=>{(0,C.open)(d,i?{lazyEntries:!0}:void 0,(n,o)=>{n?r(f(n)):c((0,T.assertIsDefined)(o))})})}function v(d,i){return new Promise((c,r)=>{d.openReadStream(i,(n,o)=>{n?r(f(n)):c((0,T.assertIsDefined)(o))})})}function l(d,i){return new Promise((c,r)=>{const n=new b.ZipFile;i.forEach(s=>{s.contents?n.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&n.addFile(s.localPath,s.path)}),n.end();const o=(0,k.createWriteStream)(d);n.outputStream.pipe(o),n.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>c(d))})}e.zip=l;function w(d,i,c={},r){const n=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let o=m(d,!0);return c.overwrite&&(o=o.then(s=>A.Promises.rm(i).then(()=>s))),o.then(s=>h(s,i,{sourcePathRegex:n},r))}e.extract=w;function S(d,i){return m(d).then(c=>new Promise((r,n)=>{c.on("entry",o=>{o.fileName===i&&v(c,o).then(s=>r(s),s=>n(s))}),c.once("close",()=>n(new Error(R.localize(2,null,i))))}))}function y(d,i){return S(d,i).then(c=>new Promise((r,n)=>{const o=[];c.once("error",n),c.on("data",s=>o.push(s)),c.on("end",()=>r(Buffer.concat(o)))}))}e.buffer=y}),define(te[246],ne([0,1,67,133]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,k.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=L}),define(te[247],ne([0,1,16,5,9,2,18,10,4,20,62,7,29,22,67,134,14,30,31,156,61,15,8,27]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let r=class extends T.Disposable{constructor(o,s,a,u,g){super();this.beforeRemovingExtension=o,this.fileService=s,this.logService=a,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(o){const s=[];(o===null||o===0)&&s.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(a).message,l.ExtensionManagementErrorCode.Internal)))),(o===null||o===1)&&s.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(a).message,l.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(s);return(0,k.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(o){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(u=>!s[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),o&&(a=(0,w.groupByExtension)(a,g=>g.identifier).map(g=>g.sort((I,_)=>P.rcompare(I.manifest.version,_.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(o,s,a,u){const g=o.key(),I=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),_=R.join(this.extensionsPath,g);try{await p.Promises.rm(_)}catch{try{await p.Promises.rm(_)}catch{}throw new l.ExtensionManagementError((0,m.localize)(0,null,_,o.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(o,s,I,u);let O=await this.scanExtension(E.URI.file(I),1);if(!O)throw new Error((0,m.localize)(1,null,I));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(o,I,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(M){try{await p.Promises.rm(I)}catch{}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",o.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(M)}. Deleted from extracted location`,I),M}try{O=await this.scanExtension(E.URI.file(_),1)}catch{}if(O)return O;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(o,s){return this.setMetadata(o,s),await this.storeMetadata(o,{...s,installedTimestamp:o.installedTimestamp}),o}async storeMetadata(o,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=R.join(o.location.fsPath,"package.json"),u=await p.Promises.readFile(a,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=s,await p.Promises.writeFile(a,JSON.stringify(g,null,"	")),o}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...o){const s=o.map(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{s.forEach(u=>a[u.key()]=!0)})}async setInstalled(o){await this.withUninstalledExtensions(u=>delete u[o.key()]);const a=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(o))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(o){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let a={};if(s)try{a=JSON.parse(s)}catch{}return o&&(o(a),Object.keys(a).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await p.Promises.rm(this.uninstalledPath)),a})}async removeExtension(o,s){this.logService.trace(`Deleting ${s} extension from disk`,o.identifier.id,o.location.fsPath),await p.Promises.rm(o.location.fsPath),this.logService.info("Deleted from disk",o.identifier.id,o.location.fsPath)}async removeUninstalledExtension(o){await this.removeExtension(o,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version).key()])}async extractAtLocation(o,s,a,u){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await p.Promises.rm(a)}catch(g){throw new l.ExtensionManagementError(this.joinErrors(g).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,a,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${a}:`,o.id)}catch(g){try{await p.Promises.rm(a)}catch{}let I=l.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?I=l.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(I=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(g.message,I)}}async rename(o,s,a,u){try{await p.Promises.rename(s,a)}catch(g){if(C.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,o.id),this.rename(o,s,a,u);throw new l.ExtensionManagementError(g.message||(0,m.localize)(3,null,s,a),g.code||l.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const o=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return o;const s=this.scanDevSystemExtensions(),[a,u]=await Promise.all([o,s]);return[...a,...u]}async scanExtensionsInDir(o,s){const a=new t.Limiter(10),u=await this.fileService.resolve(E.URI.file(o));return u.children?(await Promise.all(u.children.filter(I=>I.isDirectory).map(I=>a.queue(async()=>s===1&&(0,b.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,s))))).filter(I=>I&&I.identifier):[]}async scanExtension(o,s){try{const a=await this.fileService.resolve(o);if(a.children){const{manifest:u,metadata:g}=await this.readManifest(o.fsPath),I=a.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,_=a.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource,O={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},M={type:s,identifier:O,manifest:u,location:o,readmeUrl:I,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(M,g),M}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const o=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",o.length),o}async scanDevSystemExtensions(){const o=this.getDevSystemExtensionsList();if(o.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>o.some(u=>(0,w.areSameExtensions)(a.identifier,{id:u})))}else return[]}setMetadata(o,s){o.publisherDisplayName=s?.publisherDisplayName||null,o.publisherId=s?.publisherId||null,o.identifier.uuid=s?.id,o.isMachineScoped=!!s?.isMachineScoped,o.isPreReleaseVersion=!!s?.isPreReleaseVersion,o.preRelease=!!s?.preRelease,o.isBuiltin=o.type===0||!!s?.isBuiltin,o.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const o=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),a=new Set;for(const I of s)o[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||a.add(I.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(s,I=>I.identifier);await t.Promises.settled(u.map(async I=>{const _=I.sort((O,M)=>P.rcompare(O.manifest.version,M.manifest.version))[0];a.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(_)}));const g=s.filter(I=>o[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await t.Promises.settled(g.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const o=await this.scanAllUserExtensions(),s=[],a=(0,w.groupByExtension)(o,u=>u.identifier);s.push(...(0,k.flatten)(a.map(u=>u.sort((g,I)=>P.rcompare(g.manifest.version,I.manifest.version)).slice(1)))),await t.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(o=>o.name)}joinErrors(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,u)=>new Error(`${a.message}${a.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(A.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(o){const s=[p.Promises.readFile(R.join(o,"package.json"),"utf8").then(I=>this.parseManifest(I)),p.Promises.readFile(R.join(o,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:a,metadata:u},g]=await Promise.all(s);return{manifest:(0,S.localizeManifest)(a,g),metadata:u}}parseManifest(o){return new Promise((s,a)=>{try{const u=JSON.parse(o);u.publisher||(u.publisher=y.UNDEFINED_PUBLISHER);const g=u.__metadata||null;s({manifest:u,metadata:g})}catch{a(new Error((0,m.localize)(4,null)))}})}};r=he([K(1,d.IFileService),K(2,i.ILogService),K(3,v.INativeEnvironmentService),K(4,c.IProductService)],r),e.ExtensionsScanner=r}),define(te[248],ne([0,1,37,9,18,10,4,33,20,62,11,7,29,22,67,132,82,14,205,30,31,188,173,246,189,247,222,79,15,6,8,27,21,32]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d,i,c,r,n,o,s,a,u,g,I,_,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let M=class extends w.AbstractExtensionManagementService{constructor(G,re,H,j,Q,x,J,Z,W){super(G,re,H,Z);this.environmentService=j,this.downloadService=Q,this.fileService=J;const F=this._register(x.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(n.ExtensionsScanner,$=>F.postUninstall($))),this.manifestCache=this._register(new r.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(x.createInstance(d.ExtensionsDownloader));const N=this._register(new o.ExtensionsWatcher(this,J,j,H,W));this._register(N.onDidChangeExtensionsByAnotherSource(({added:$,removed:V})=>{$.length&&this._onDidInstallExtensions.fire($.map(ee=>({identifier:ee.identifier,operation:1,local:ee}))),V.forEach(ee=>this._onDidUninstallExtension.fire({identifier:ee}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const G=await this.isAlpineLinux(),re=(0,S.getTargetPlatform)(G?"alpine":A.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",re),re})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let G;try{G=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{G=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(H){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(H))}}return!!G&&(G.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const re=await this.collectFiles(G),H=await(0,h.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,re);return E.URI.file(H)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const re=await this.downloadVsix(G),H=T.resolve(re.fsPath);return(0,c.getManifest)(H)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async install(G,re={}){this.logService.trace("ExtensionManagementService#install",G.toString());const H=await this.downloadVsix(G),j=await(0,c.getManifest)(T.resolve(H.fsPath));if(j.engines&&j.engines.vscode&&!(0,s.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(m.localize(0,null,(0,y.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return this.installExtension(j,H,re)}async updateMetadata(G,re){this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id);const H={...G.manifest.__metadata||{},...re};return re.isPreReleaseVersion&&(H.preRelease=!0),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,H),this.manifestCache.invalidate(),G}async updateExtensionScope(G,re){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:re}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===L.Schemas.file)return G;const re=(0,C.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(G,re),re}createInstallExtensionTask(G,re,H){return E.URI.isUri(re)?new z(G,re,H,this.galleryService,this.extensionsScanner,this.logService):new U(re,H,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,re){return new B(G,re,this.extensionsScanner)}async collectFiles(G){const re=async j=>{let Q=await p.Promises.readdir(j);Q=Q.map(Z=>T.join(j,Z));const x=await Promise.all(Q.map(Z=>p.Promises.stat(Z)));let J=Promise.resolve([]);return x.forEach((Z,W)=>{const F=Q[W];Z.isFile()&&(J=J.then(N=>[...N,F])),Z.isDirectory()&&(J=J.then(N=>re(F).then($=>[...N,...$])))}),J};return(await re(G.location.fsPath)).map(j=>({path:`extension/${T.relative(G.location.fsPath,j)}`,localPath:j}))}};M=he([K(0,S.IExtensionGalleryService),K(1,_.ITelemetryService),K(2,g.ILogService),K(3,l.INativeEnvironmentService),K(4,v.IDownloadService),K(5,u.IInstantiationService),K(6,a.IFileService),K(7,I.IProductService),K(8,O.IUriIdentityService)],M),e.ExtensionManagementService=M;class D extends w.AbstractExtensionTask{constructor(G,re,H,j){super();this.identifier=G,this.source=re,this.extensionsScanner=H,this.logService=j,this._operation=2}get operation(){return this._operation}async installExtension(G,re){try{const H=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(H)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(H,{...H.manifest.__metadata||{},...G.metadata}):H}catch{throw A.isMacintosh?new S.ExtensionManagementError(m.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(m.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(G,re)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const H=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),H}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:re,metadata:H},j){let Q=await this.extensionsScanner.extractUserExtension(re,G,H,j);return this.logService.info("Extracting completed.",re.id),Q}}class U extends D{constructor(G,re,H,j,Q){super(G.identifier,G,j,Q);this.gallery=G,this.options=re,this.extensionsDownloader=H}async doRun(G){const H=(await this.extensionsScanner.scanExtensions(null)).find(Q=>(0,y.areSameExtensions)(Q.identifier,this.gallery.identifier));H&&(this._operation=3);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||H?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||H?.isBuiltin,j.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,j.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:H?.preRelease);try{const Q=await this.installExtension(j,G);return H&&b.neq(H.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(H),Q}catch(Q){throw await this.deleteDownloadedVSIX(j.zipPath),Q}}async deleteDownloadedVSIX(G){try{await this.extensionsDownloader.delete(E.URI.file(G))}catch(re){this.logService.warn("Error while deleting the downloaded vsix",G.toString(),(0,t.getErrorMessage)(re))}}async downloadInstallableExtension(G,re){const H={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",G.identifier.id),j=(await this.extensionsDownloader.downloadExtension(G,re)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,j)}catch(Q){throw new S.ExtensionManagementError((0,w.joinErrors)(Q).message,S.ExtensionManagementErrorCode.Download)}try{const Q=await(0,c.getManifest)(j);return{zipPath:j,identifierWithVersion:new y.ExtensionIdentifierWithVersion(G.identifier,Q.version),metadata:H}}catch(Q){throw await this.deleteDownloadedVSIX(j),new S.ExtensionManagementError((0,w.joinErrors)(Q).message,S.ExtensionManagementErrorCode.Invalid)}}}class z extends D{constructor(G,re,H,j,Q,x){super({id:(0,y.getGalleryExtensionId)(G.publisher,G.name)},re,Q,x);this.manifest=G,this.location=re,this.options=H,this.galleryService=j}async doRun(G){const re=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(x=>(0,y.areSameExtensions)(this.identifier,x.identifier)),Q=await this.getMetadata(this.identifier.id,this.manifest.version,G);if(Q.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,Q.isBuiltin=this.options.isBuiltin||j?.isBuiltin,j)if(this._operation=3,re.equals(new y.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(m.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const x=await this.unsetUninstalledAndGetLocal(re);if(x)try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(m.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:re,metadata:Q},G)}async getMetadata(G,re,H){try{let[j]=await this.galleryService.getExtensions([{id:G,version:re}],H);if(j||([j]=await this.galleryService.getExtensions([{id:G}],H)),j)return{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B extends w.AbstractExtensionTask{constructor(G,re,H){super();this.extension=G,this.options=re,this.extensionsScanner=H}async doRun(G){const re=[],H=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);re.push(...H.filter(Q=>j.equals(new y.ExtensionIdentifierWithVersion(Q.identifier,Q.manifest.version))))}else re.push(...H.filter(j=>(0,y.areSameExtensions)(j.identifier,this.extension.identifier)));if(!re.length)throw new Error(m.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...re),this.options.remove)for(const j of re)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(Q){throw new Error(m.localize(6,null,(0,k.toErrorMessage)(Q)))}}}}),define(te[249],ne([0,1,84,56,34,17,9,3,2,10,4,29,36,74,260]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=O=>{this.traceSocketEvent("read",O),I(T.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=m;var v;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var l;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(l||(l={}));class w extends C.Disposable{constructor(I,_,O,M){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new S(this,_,O,M,this._onData,(D,U)=>this._write(D,U))),this._register(this._flowManager.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const M=T.VSBuffer.alloc(O);if(_?M.writeUInt8(194,0):M.writeUInt8(130,0),I.byteLength<126)M.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){M.writeUInt8(126,1);let D=1;M.writeUInt8(I.byteLength>>>8&255,++D),M.writeUInt8(I.byteLength>>>0&255,++D)}else{M.writeUInt8(127,1);let D=1;M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(I.byteLength>>>24&255,++D),M.writeUInt8(I.byteLength>>>16&255,++D),M.writeUInt8(I.byteLength>>>8&255,++D),M.writeUInt8(I.byteLength>>>0&255,++D)}this.socket.write(T.VSBuffer.concat([M,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),M=(O&128)>>>7,D=(O&64)>>>6,U=_.readUInt8(1),z=(U&128)>>>7,B=U&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),M=(O&128)>>>7;let D=O&127,U=1;D===126?D=_.readUInt8(++U)*2**8+_.readUInt8(++U):D===127&&(D=_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*2**24+_.readUInt8(++U)*2**16+_.readUInt8(++U)*2**8+_.readUInt8(++U));let z=0;M&&(z=_.readUInt8(++U)*2**24+_.readUInt8(++U)*2**16+_.readUInt8(++U)*2**8+_.readUInt8(++U)),this._state.state=3,this._state.readLen=D,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),i(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class S extends C.Disposable{constructor(I,_,O,M,D,U){super();this._tracer=I,this._onData=D,this._writeFn=U,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new y(this._tracer,M,O,{windowBits:15})),this._zlibDeflateStream=this._register(new d(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((O,M)=>{I.write(_),I.flush(D=>O(D))})}acceptFrame(I,_,O){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,O){return new Promise((M,D)=>{I.write(_),O&&I.write(T.VSBuffer.fromByteArray([0,0,255,255])),I.flush(U=>M(U))})}}class y extends C.Disposable{constructor(I,_,O,M){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(M),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(T.VSBuffer.wrap(D))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class d extends C.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(T.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function i(g,I){if(I===0)return;let _=g.byteLength>>>2;for(let B=0;B<_;B++){const q=g.readUInt32BE(B*4);g.writeUInt32BE(q^I,B*4)}let O=_*4,M=g.byteLength-O;const D=I>>>24&255,U=I>>>16&255,z=I>>>8&255;M>=1&&g.writeUInt8(g.readUInt8(O)^D,O),M>=2&&g.writeUInt8(g.readUInt8(O+1)^U,O+1),M>=3&&g.writeUInt8(g.readUInt8(O+2)^z,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function r(){const g=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):I=(0,b.join)((0,L.tmpdir)(),`vscode-ipc-${g}.sock`),o(I),I}e.createRandomIPCHandle=r;function n(g,I,_){const O=(0,k.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${I}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${I}.sock`):M=(0,b.join)(g,`${_}-${I}.sock`),o(M),M}e.createStaticIPCHandle=n;function o(g){const I=c[P.platform];typeof I=="number"&&g.length>=I&&console.warn(`WARNING: IPC handle "${g}" is longer than ${I} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(I){super(s.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,O=>({protocol:new p.Protocol(new m(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(g){return new Promise((I,_)=>{const O=(0,t.createServer)();O.on("error",_),O.listen(g,()=>{O.removeListener("error",_),I(new s(O))})})}e.serve=a;function u(g,I){return new Promise((_,O)=>{const M=(0,t.createConnection)(g,()=>{M.removeListener("error",O),_(p.Client.fromSocket(new m(M,`ipc-client${I}`),I))});M.once("error",O)})}e.connect=u}),define(te[250],ne([0,1,56,249]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,R,C){const b=E=>C(E,void 0),P=k.createConnection({host:L,port:T},()=>{P.removeListener("error",b);const E=Buffer.alloc(16);for(let m=0;m<16;m++)E[m]=Math.round(Math.random()*256);const f=E.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(p.join(`\r
`)+`\r
\r
`);const h=m=>{m.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),C(void 0,new t.NodeSocket(P,R)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",b)}}}),define(te[251],ne([0,1,56,115,250,5,2,19,8,27,184,64,92]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,S,y,d,i){let c;for(let r=3;r&&(c&&c.dispose(),c=await new h(w,S,y,d,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));r--);return c}class h extends A.Disposable{constructor(S,y,d,i,c){super();this.defaultTunnelHost=y,this.suggestedLocalPort=c,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=S,this._server=k.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=d}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(y=>{y()})}async waitForReady(){let S=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),y=null;return this._server.listen(S,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address(),y||(S=0,this._server.listen(S,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address()),this.tunnelLocalPort=y.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${y.port}`,this}async _onConnection(S){S.pause();const y=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,d=await(0,P.connectRemoteAgentTunnel)(this._options,y,this.tunnelRemotePort),i=d.getSocket().socket,c=d.readEntireBuffer();d.dispose(),c.byteLength>0&&S.write(c.buffer),S.on("end",()=>{S.localAddress&&this._socketsDispose.delete(S.localAddress),i.end()}),S.on("close",()=>i.end()),S.on("error",()=>{S.localAddress&&this._socketsDispose.delete(S.localAddress),i.destroy()}),i.on("end",()=>S.end()),i.on("close",()=>S.end()),i.on("error",()=>{S.destroy()}),S.pipe(i),i.pipe(S),S.localAddress&&this._socketsDispose.set(S.localAddress,()=>{S.end(),i.end()})}}let m=class extends E.AbstractTunnelService{constructor(S,y,d,i,c){super(y);this.socketFactory=S,this.signService=d,this.productService=i,this.configurationService=c}get defaultTunnelHost(){const S=this.configurationService.getValue("remote.localPortHost");return!S||S==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(S,y,d,i,c,r,n){const o=this.getTunnelFromMap(y,d);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,y,d,i,c,r,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${y}:${d} on local port ${i}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:S,signService:this.signService,logService:this.logService,ipcLogger:null},a=p(s,this.defaultTunnelHost,y,d,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(y,d,a),a}}};m=he([K(1,C.ILogService),K(2,f.ISignService),K(3,b.IProductService),K(4,R.IConfigurationService)],m),e.BaseTunnelService=m;let v=class extends m{constructor(S,y,d,i){super(L.nodeSocketFactory,S,y,d,i)}};v=he([K(0,C.ILogService),K(1,f.ISignService),K(2,b.IProductService),K(3,R.IConfigurationService)],v),e.TunnelService=v;let l=class extends A.Disposable{constructor(S,y,d,i){super();this.logService=S,this.productService=y,this.signService=d,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(S,y,d,i,c,r,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${d}:${i} on local port ${c}.`),!this._tunnelServices.has(S)){const s=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(S,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(S))})}return this._tunnelServices.get(S).openTunnel(y,d,i,c,r,n,o)}};l=he([K(0,C.ILogService),K(1,b.IProductService),K(2,f.ISignService),K(3,R.IConfigurationService)],l),e.SharedTunnelsService=l}),define(te[261],ne([0,1,75,34,37,9,2,18,20,7,36,118,178,200,179,170,171,172,159,161,19,182,81,204,82,193,14,197,199,209,30,186,206,248,83,157,15,175,177,51,6,167,86,168,169,59,190,8,87,60,88,27,192,43,23,202,203,21,93,94,95,44,210,211,96,213,220,63,98,24,65,236,238,239,66,237,241,242,243,244,245,92,198,64,251,191,221,91,196,207,32,223,4,224,162,181,180]),function(Y,e,k,t,L,T,A,R,C,b,P,E,f,p,h,m,v,l,w,S,y,d,i,c,r,n,o,s,a,u,g,I,_,O,M,D,U,z,B,q,G,re,H,j,Q,x,J,Z,W,F,N,$,V,ee,se,ae,de,ge,Ee,Se,pe,Ie,Ce,De,Ue,je,Ge,Be,ie,ce,ue,we,be,Fe,Te,Oe,_e,X,oe,le,fe,me,Le,ye,Re,ke,Pe,Ae,Ne,We,qe,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",$e=(Ke,ze)=>this.onDisposeWorker(ze);k.ipcRenderer.on(Me,$e),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Me,$e)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ce.registerConfiguration)(),ve.invokeFunction(Me=>{const $e=Me.get(Z.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(l.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(m.LocalizationsUpdater),ve.createInstance(p.ExtensionsCleaner)))}async initServices(){const ve=new H.ServiceCollection,Me={_serviceBrand:void 0,...N.default};ve.set($.IProductService,Me);const $e=new P.StaticRouter(Ve=>Ve==="main"),Ke=new j.MessagePortMainProcessService(this.server,$e);ve.set(Q.IMainProcessService,Ke);const ze=new s.SharedProcessEnvironmentService(this.configuration.args,Me);ve.set(o.INativeEnvironmentService,ze);const nt=new W.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Xe=new W.LoggerChannelClient(this.configuration.logLevel,nt.onDidChangeLogLevel,Ke.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,C.joinPath)(b.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new W.FollowerLogService(nt,ot));ve.set(Z.ILogService,Ye),this.sharedProcessWorkerService=new Ne.SharedProcessWorkerService(Ye),ve.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new z.FileService(Ye));ve.set(U.IFileService,Je);const at=this._register(new B.DiskFileSystemProvider(Ye));Je.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ke.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ye));Je.registerProvider(R.Schemas.userData,ct);const xe=this._register(new d.ConfigurationService(ze.settingsResource,Je));ve.set(y.IConfigurationService,xe);const et=new ae.NativeStorageService(void 0,Ke,ze);ve.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([xe.initialize(),et.initialize()]),ve.set(qe.IUriIdentityService,new Pt.UriIdentityService(Je)),ve.set(ee.IRequestService,new q.SyncDescriptor(V.RequestService)),ve.set(w.IChecksumService,new q.SyncDescriptor(S.ChecksumService)),ve.set(St.IV8InspectProfilingService,new q.SyncDescriptor(kt.InspectProfilingService));const it=P.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(F.INativeHostService,it),ve.set(r.IDownloadService,new q.SyncDescriptor(n.DownloadService));const lt=this._register(new fe.ActiveWindowManager(it)),ut=new P.StaticRouter(Ve=>lt.getActiveClientId().then(dt=>Ve===dt));ve.set(M.IExtensionRecommendationNotificationService,new D.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new We.AssignmentService(this.configuration.machineId,xe,Me);let rt;const Qe=[];if((0,Ie.supportsTelemetry)(Me,ze)){const Ve=new Se.TelemetryLogAppender(Xe,ze);Qe.push(Ve);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=ze;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}rt=new pe.TelemetryService({appenders:Qe,commonProperties:(0,de.resolveCommonProperties)(Je,(0,t.release)(),(0,t.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},xe)}else{rt=Ie.NullTelemetryService;const Ve=Ie.NullAppender;Qe.push(Ve)}this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(Qe)),ve.set(ge.ITelemetryService,rt);const At=new De.CustomEndpointTelemetryService(xe,rt,Xe,ze);ve.set(ge.ICustomEndpointTelemetryService,At),ve.set(g.IExtensionManagementService,new q.SyncDescriptor(O.ExtensionManagementService)),ve.set(g.IExtensionGalleryService,new q.SyncDescriptor(u.ExtensionGalleryService)),ve.set(g.IExtensionTipsService,new q.SyncDescriptor(_.ExtensionTipsService)),ve.set(x.ILocalizationsService,new q.SyncDescriptor(J.LocalizationsService)),ve.set(i.IDiagnosticsService,new q.SyncDescriptor(c.DiagnosticsService)),ve.set(ue.IUserDataSyncAccountService,new q.SyncDescriptor(ue.UserDataSyncAccountService)),ve.set(ce.IUserDataSyncLogService,new q.SyncDescriptor(Fe.UserDataSyncLogService)),ve.set(ce.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),ve.set(g.IGlobalExtensionEnablementService,new q.SyncDescriptor(a.GlobalExtensionEnablementService)),ve.set(ie.IIgnoredExtensionsManagementService,new q.SyncDescriptor(ie.IgnoredExtensionsManagementService)),ve.set(Be.IExtensionStorageService,new q.SyncDescriptor(Be.ExtensionStorageService)),ve.set(ce.IUserDataSyncStoreManagementService,new q.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ce.IUserDataSyncStoreService,new q.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(Te.IUserDataSyncMachinesService,new q.SyncDescriptor(Te.UserDataSyncMachinesService)),ve.set(ce.IUserDataSyncBackupStoreService,new q.SyncDescriptor(we.UserDataSyncBackupStoreService)),ve.set(ce.IUserDataSyncEnablementService,new q.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ce.IUserDataSyncService,new q.SyncDescriptor(_e.UserDataSyncService));const wt=new Ge.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,ze,Ye);return await wt.initialize(),ve.set(je.ILocalPtyService,this._register(wt)),ve.set(me.ISignService,new q.SyncDescriptor(Le.SignService)),ve.set(ye.ISharedTunnelsService,new q.SyncDescriptor(Re.SharedTunnelsService)),ve.set(ke.ISharedProcessTunnelService,new q.SyncDescriptor(Pe.SharedProcessTunnelService)),new re.InstantiationService(ve)}initChannels(ve){const Me=new I.ExtensionManagementChannel(ve.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const $e=P.ProxyChannel.fromService(ve.get(x.ILocalizationsService));this.server.registerChannel("localizations",$e);const Ke=P.ProxyChannel.fromService(ve.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Ke);const ze=new I.ExtensionTipsChannel(ve.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const nt=P.ProxyChannel.fromService(ve.get(w.IChecksumService));this.server.registerChannel("checksum",nt);const Xe=P.ProxyChannel.fromService(ve.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new be.UserDataSyncMachinesServiceChannel(ve.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Ye=P.ProxyChannel.fromService(ve.get(ge.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ye);const Je=new be.UserDataSyncAccountServiceChannel(ve.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const at=new be.UserDataSyncStoreManagementServiceChannel(ve.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new X.UserDataSyncChannel(ve.get(ce.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(ve.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new be.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",et);const it=ve.get(je.ILocalPtyService),lt=P.ProxyChannel.fromService(it);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(ve.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(ve.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,T.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Me=>{const $e=(0,L.toErrorMessage)(Me,!0);!$e||ve.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Tt(yt){const ve=new Lt(yt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f90f60e956e725f98732c33dec3029087d0f19e4/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
