/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/node/shellEnv","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(j){for(var i=[],D=0,R=j.length;D<R;D++)i[D]=Y[j[D]];return i};define(Y[55],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function D(R,b){if(!R)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=D}),define(Y[44],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(L){return(P,c,v)=>{let C=null,T=null;if(typeof v.value=="function"?(C="value",T=v.value):typeof v.get=="function"&&(C="get",T=v.get),!T)throw new Error("not supported");v[C]=L(T,c)}}i.createDecorator=D;function R(L,P,c){let v=null,C=null;if(typeof c.value=="function"?(v="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(v="get",C=c.get),!C)throw new Error("not supported");const T=`$memoize$${P}`;c[v]=function(...d){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[T]}}i.memoize=R;function b(L,P,c){return D((v,C)=>{const T=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...y){this[d]||(this[d]=c?c():void 0),clearTimeout(this[T]),P&&(this[d]=P(this[d],...y),y=[this[d]]),this[T]=setTimeout(()=>{v.apply(this,y),this[d]=c?c():void 0},L)}})}i.debounce=b;function I(L,P,c){return D((v,C)=>{const T=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,w=`$throttle$pending$${C}`;return function(...g){if(this[d]||(this[d]=c?c():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...g)),this[w])return;const a=this[y]+L;a<=Date.now()?(this[y]=Date.now(),v.apply(this,[this[d]]),this[d]=c?c():void 0):(this[w]=!0,this[T]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),v.apply(this,[this[d]]),this[d]=c?c():void 0},a-Date.now()))}})}i.throttle=I}),define(Y[56],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=i.ParseOptions||(i.ParseOptions={}));function L(t,r=!1){let e=0,n=t.length,s="",l=0,u=16,h=0;function S(ie){let he=0,ue=0;for(;he<ie;){const x=t.charCodeAt(e);if(x>=48&&x<=57)ue=ue*16+x-48;else if(x>=65&&x<=70)ue=ue*16+x-65+10;else if(x>=97&&x<=102)ue=ue*16+x-97+10;else break;e++,he++}return he<ie&&(ue=-1),ue}function O(ie){e=ie,s="",l=0,u=16,h=0}function N(){const ie=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&v(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&v(t.charCodeAt(e)))for(e++;e<t.length&&v(t.charCodeAt(e));)e++;else return h=3,t.substring(ie,e);let he=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&v(t.charCodeAt(e))){for(e++;e<t.length&&v(t.charCodeAt(e));)e++;he=e}else h=3;return t.substring(ie,he)}function _(){let ie="",he=e;for(;;){if(e>=n){ie+=t.substring(he,e),h=2;break}const ue=t.charCodeAt(e);if(ue===34){ie+=t.substring(he,e),e++;break}if(ue===92){if(ie+=t.substring(he,e),e++,e>=n){h=2;break}switch(t.charCodeAt(e++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const te=S(4);te>=0?ie+=String.fromCharCode(te):h=4;break}default:h=5}he=e;continue}if(ue>=0&&ue<=31)if(c(ue)){ie+=t.substring(he,e),h=2;break}else h=6;e++}return ie}function J(){if(s="",h=0,l=e,e>=n)return l=n,u=17;let ie=t.charCodeAt(e);if(P(ie)){do e++,s+=String.fromCharCode(ie),ie=t.charCodeAt(e);while(P(ie));return u=15}if(c(ie))return e++,s+=String.fromCharCode(ie),ie===13&&t.charCodeAt(e)===10&&(e++,s+=`
`),u=14;switch(ie){case 123:return e++,u=1;case 125:return e++,u=2;case 91:return e++,u=3;case 93:return e++,u=4;case 58:return e++,u=6;case 44:return e++,u=5;case 34:return e++,s=_(),u=10;case 47:{const he=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!c(t.charCodeAt(e));)e++;return s=t.substring(he,e),u=12}if(t.charCodeAt(e+1)===42){e+=2;const ue=n-1;let x=!1;for(;e<ue;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,x=!0;break}e++}return x||(e++,h=1),s=t.substring(he,e),u=13}return s+=String.fromCharCode(ie),e++,u=16}case 45:if(s+=String.fromCharCode(ie),e++,e===n||!v(t.charCodeAt(e)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),u=11;default:for(;e<n&&re(ie);)e++,ie=t.charCodeAt(e);if(l!==e){switch(s=t.substring(l,e),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ie),e++,u=16}}function re(ie){if(P(ie)||c(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ie;do ie=J();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>e,scan:r?ee:J,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>e-l,getTokenError:()=>h}}i.createScanner=L;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function c(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function T(t,r){const e=[],n=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function h(S,O,N,_){l.value=S,l.offset=O,l.length=N,l.type=_,l.colonOffset=void 0,s=l}try{E(t,{onObjectBegin:(S,O)=>{if(r<=S)throw n;s=void 0,u=r>S,e.push("")},onObjectProperty:(S,O,N)=>{if(r<O||(h(S,O,N,"property"),e[e.length-1]=S,r<=O+N))throw n},onObjectEnd:(S,O)=>{if(r<=S)throw n;s=void 0,e.pop()},onArrayBegin:(S,O)=>{if(r<=S)throw n;s=void 0,e.push(0)},onArrayEnd:(S,O)=>{if(r<=S)throw n;s=void 0,e.pop()},onLiteralValue:(S,O,N)=>{if(r<O||(h(S,O,N,o(S)),r<=O+N))throw n},onSeparator:(S,O,N)=>{if(r<=O)throw n;if(S===":"&&s&&s.type==="property")s.colonOffset=O,u=!1,s=void 0;else if(S===","){const _=e[e.length-1];typeof _=="number"?e[e.length-1]=_+1:(u=!0,e[e.length-1]=""),s=void 0}}})}catch(S){if(S!==n)throw S}return{path:e,previousNode:s,isAtPropertyKey:u,matches:S=>{let O=0;for(let N=0;O<S.length&&N<e.length;N++)if(S[O]===e[N]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}i.getLocation=T;function d(t,r=[],e=I.DEFAULT){let n=null,s=[];const l=[];function u(S){Array.isArray(s)?s.push(S):n!==null&&(s[n]=S)}return E(t,{onObjectBegin:()=>{const S={};u(S),l.push(s),s=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const S=[];u(S),l.push(s),s=S,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:u,onError:(S,O,N)=>{r.push({error:S,offset:O,length:N})}},e),s[0]}i.parse=d;function y(t,r=[],e=I.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function l(S){return n.children.push(S),S}E(t,{onObjectBegin:S=>{n=l({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,O,N)=>{n=l({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:O,length:N,parent:n})},onObjectEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,s(S+O)},onArrayBegin:(S,O)=>{n=l({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,s(S+O)},onLiteralValue:(S,O,N)=>{l({type:o(S),offset:O,length:N,parent:n,value:S}),s(O+N)},onSeparator:(S,O,N)=>{n.type==="property"&&(S===":"?n.colonOffset=O:S===","&&s(O))},onError:(S,O,N)=>{r.push({error:S,offset:O,length:N})}},e);const h=n.children[0];return h&&delete h.parent,h}i.parseTree=y;function w(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const l of e.children)if(Array.isArray(l.children)&&l.children[0].value===n){e=l.children[1],s=!0;break}if(!s)return}else{const s=n;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}i.findNodeAtLocation=w;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=g;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=a(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=a;function f(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=f;function p(t,r,e=!1){if(f(t,r,e)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const l=p(n[s],r,e);if(l)return l}return t}}i.findNodeAtOffset=p;function E(t,r,e=I.DEFAULT){const n=L(t,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(K){return K?Z=>K(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),h=l(r.onObjectProperty),S=s(r.onObjectEnd),O=s(r.onArrayBegin),N=s(r.onArrayEnd),_=l(r.onLiteralValue),J=l(r.onSeparator),re=s(r.onComment),ee=l(r.onError),ie=e&&e.disallowComments,he=e&&e.allowTrailingComma;function ue(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:ie||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:ie?x(10):re();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,Z=[],q=[]){if(ee(K),Z.length+q.length>0){let M=n.getToken();for(;M!==17;){if(Z.indexOf(M)!==-1){ue();break}else if(q.indexOf(M)!==-1)break;M=ue()}}}function te(K){const Z=n.getTokenValue();return K?_(Z):h(Z),ue(),!0}function U(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}_(K);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return ue(),!0}function k(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(te(!1),n.getToken()===6?(J(":"),ue(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function z(){u(),ue();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===2&&he)break}else K&&x(6,[],[]);k()||x(4,[],[2,5]),K=!0}return S(),n.getToken()!==2?x(7,[2],[]):ue(),!0}function G(){O(),ue();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===4&&he)break}else K&&x(6,[],[]);ne()||x(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?x(8,[4],[]):ue(),!0}function ne(){switch(n.getToken()){case 3:return G();case 1:return z();case 10:return te(!0);default:return U()}}return ue(),n.getToken()===17?e.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}i.visit=E;function m(t,r){let e=L(t),n=[],s,l=0,u;do switch(u=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:l!==u&&n.push(t.substring(l,u)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),l=e.getPosition();break}while(s!==17);return n.join("")}i.stripComments=m;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=o}),function(){function j(b){const I=[];typeof b=="number"&&I.push("code/timeOrigin",b);function L(c){I.push(c,Date.now())}function P(){const c=[];for(let v=0;v<I.length;v+=2)c.push({name:I[v],startTime:I[v+1]});return c}return{mark:L,getMarks:P}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(b+L.startTime)});return I}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),define(Y[57],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var D;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(D=i.Source||(i.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(I,...L){const P=L.reduce((C,T)=>(C[T]=!0,C),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(C=>!P[C]).forEach(C=>{for(let T=0;T<c.length;T++)if(C.search(c[T])!==-1){delete I[C];break}})}i.sanitizeProcessEnvironment=b}),function(j,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var R in D)(typeof exports=="object"?exports:j)[R]=D[R]}}(typeof self!="undefined"?self:this,function(){return function(j){var i={};function D(R){if(i[R])return i[R].exports;var b=i[R]={i:R,l:!1,exports:{}};return j[R].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=j,D.c=i,D.d=function(R,b,I){D.o(R,b)||Object.defineProperty(R,b,{enumerable:!0,get:I})},D.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,b){if(1&b&&(R=D(R)),8&b||4&b&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&b&&typeof R!="string")for(var L in R)D.d(I,L,function(P){return R[P]}.bind(null,L));return I},D.n=function(R){var b=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(b,"a",b),b},D.o=function(R,b){return Object.prototype.hasOwnProperty.call(R,b)},D.p="",D(D.s=0)}([function(j,i,D){(function(R){var b;i=j.exports=q,b=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=i.re=[],c=i.src=[],v=0,C=v++;c[C]="0|[1-9]\\d*";var T=v++;c[T]="[0-9]+";var d=v++;c[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=v++;c[y]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var w=v++;c[w]="("+c[T]+")\\.("+c[T]+")\\.("+c[T]+")";var g=v++;c[g]="(?:"+c[C]+"|"+c[d]+")";var a=v++;c[a]="(?:"+c[T]+"|"+c[d]+")";var f=v++;c[f]="(?:-("+c[g]+"(?:\\."+c[g]+")*))";var p=v++;c[p]="(?:-?("+c[a]+"(?:\\."+c[a]+")*))";var E=v++;c[E]="[0-9A-Za-z-]+";var m=v++;c[m]="(?:\\+("+c[E]+"(?:\\."+c[E]+")*))";var o=v++,t="v?"+c[y]+c[f]+"?"+c[m]+"?";c[o]="^"+t+"$";var r="[v=\\s]*"+c[w]+c[p]+"?"+c[m]+"?",e=v++;c[e]="^"+r+"$";var n=v++;c[n]="((?:<|>)?=?)";var s=v++;c[s]=c[T]+"|x|X|\\*";var l=v++;c[l]=c[C]+"|x|X|\\*";var u=v++;c[u]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[f]+")?"+c[m]+"?)?)?";var h=v++;c[h]="[v=\\s]*("+c[s]+")(?:\\.("+c[s]+")(?:\\.("+c[s]+")(?:"+c[p]+")?"+c[m]+"?)?)?";var S=v++;c[S]="^"+c[n]+"\\s*"+c[u]+"$";var O=v++;c[O]="^"+c[n]+"\\s*"+c[h]+"$";var N=v++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;c[_]="(?:~>?)";var J=v++;c[J]="(\\s*)"+c[_]+"\\s+",P[J]=new RegExp(c[J],"g");var re=v++;c[re]="^"+c[_]+c[u]+"$";var ee=v++;c[ee]="^"+c[_]+c[h]+"$";var ie=v++;c[ie]="(?:\\^)";var he=v++;c[he]="(\\s*)"+c[ie]+"\\s+",P[he]=new RegExp(c[he],"g");var ue=v++;c[ue]="^"+c[ie]+c[u]+"$";var x=v++;c[x]="^"+c[ie]+c[h]+"$";var te=v++;c[te]="^"+c[n]+"\\s*("+r+")$|^$";var U=v++;c[U]="^"+c[n]+"\\s*("+t+")$|^$";var k=v++;c[k]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[u]+")",P[k]=new RegExp(c[k],"g");var z=v++;c[z]="^\\s*("+c[u]+")\\s+-\\s+("+c[u]+")\\s*$";var G=v++;c[G]="^\\s*("+c[h]+")\\s+-\\s+("+c[h]+")\\s*$";var ne=v++;c[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,c[K]),P[K]||(P[K]=new RegExp(c[K]));function Z(F,W){if(F instanceof q)return F;if(typeof F!="string"||F.length>I||!(W?P[e]:P[o]).test(F))return null;try{return new q(F,W)}catch{return null}}function q(F,W){if(F instanceof q){if(F.loose===W)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof q))return new q(F,W);b("SemVer",F,W),this.loose=W;var $=F.trim().match(W?P[e]:P[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var de=+le;if(de>=0&&de<L)return de}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,W){var $=Z(F,W);return $?$.version:null},i.clean=function(F,W){var $=Z(F.trim().replace(/^[=v]+/,""),W);return $?$.version:null},i.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof q||(F=new q(F,this.loose)),this.compareMain(F)||this.comparePre(F)},q.prototype.compareMain=function(F){return F instanceof q||(F=new q(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},q.prototype.comparePre=function(F){if(F instanceof q||(F=new q(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var W=0;do{var $=this.prerelease[W],le=F.prerelease[W];if(b("prerelease compare",W,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return A($,le)}while(++W)},q.prototype.inc=function(F,W){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,W,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new q(F,$).inc(W,le).version}catch{return null}},i.diff=function(F,W){if(X(F,W))return null;var $=Z(F),le=Z(W);if($.prerelease.length||le.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return de},i.compareIdentifiers=A;var M=/^[0-9]+$/;function A(F,W){var $=M.test(F),le=M.test(W);return $&&le&&(F=+F,W=+W),$&&!le?-1:le&&!$?1:F<W?-1:F>W?1:0}function V(F,W,$){return new q(F,$).compare(new q(W,$))}function B(F,W,$){return V(F,W,$)>0}function H(F,W,$){return V(F,W,$)<0}function X(F,W,$){return V(F,W,$)===0}function ae(F,W,$){return V(F,W,$)!==0}function ce(F,W,$){return V(F,W,$)>=0}function we(F,W,$){return V(F,W,$)<=0}function fe(F,W,$,le){var de;switch(W){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F!==$;break;case"":case"=":case"==":de=X(F,$,le);break;case"!=":de=ae(F,$,le);break;case">":de=B(F,$,le);break;case">=":de=ce(F,$,le);break;case"<":de=H(F,$,le);break;case"<=":de=we(F,$,le);break;default:throw new TypeError("Invalid operator: "+W)}return de}function se(F,W){if(F instanceof se){if(F.loose===W)return F;F=F.value}if(!(this instanceof se))return new se(F,W);b("comparator",F,W),this.loose=W,this.parse(F),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,W){return A(W,F)},i.major=function(F,W){return new q(F,W).major},i.minor=function(F,W){return new q(F,W).minor},i.patch=function(F,W){return new q(F,W).patch},i.compare=V,i.compareLoose=function(F,W){return V(F,W,!0)},i.rcompare=function(F,W,$){return V(W,F,$)},i.sort=function(F,W){return F.sort(function($,le){return i.compare($,le,W)})},i.rsort=function(F,W){return F.sort(function($,le){return i.rcompare($,le,W)})},i.gt=B,i.lt=H,i.eq=X,i.neq=ae,i.gte=ce,i.lte=we,i.cmp=fe,i.Comparator=se;var pe={};function me(F,W){if(F instanceof me)return F.loose===W?F:new me(F.raw,W);if(F instanceof se)return new me(F.value,W);if(!(this instanceof me))return new me(F,W);if(this.loose=W,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ie(F,W,$,le,de,Ce,Se,ke,Re,Oe,Ne,De,Le){return((W=Ee($)?"":Ee(le)?">="+$+".0.0":Ee(de)?">="+$+"."+le+".0":">="+W)+" "+(ke=Ee(Re)?"":Ee(Oe)?"<"+(+Re+1)+".0.0":Ee(Ne)?"<"+Re+"."+(+Oe+1)+".0":De?"<="+Re+"."+Oe+"."+Ne+"-"+De:"<="+ke)).trim()}function Me(F,W){for(var $=0;$<F.length;$++)if(!F[$].test(W))return!1;if(W.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==pe&&F[$].semver.prerelease.length>0){var le=F[$].semver;if(le.major===W.major&&le.minor===W.minor&&le.patch===W.patch)return!0}return!1}return!0}function xe(F,W,$){try{W=new me(W,$)}catch{return!1}return W.test(F)}function Ve(F,W,$,le){var de,Ce,Se,ke,Re;switch(F=new q(F,le),W=new me(W,le),$){case">":de=B,Ce=we,Se=H,ke=">",Re=">=";break;case"<":de=H,Ce=ce,Se=B,ke="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(F,W,le))return!1;for(var Oe=0;Oe<W.set.length;++Oe){var Ne=W.set[Oe],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===pe&&(Ae=new se(">=0.0.0")),De=De||Ae,Le=Le||Ae,de(Ae.semver,De.semver,le)?De=Ae:Se(Ae.semver,Le.semver,le)&&(Le=Ae)}),De.operator===ke||De.operator===Re||(!Le.operator||Le.operator===ke)&&Ce(F,Le.semver)||Le.operator===Re&&Se(F,Le.semver))return!1}return!0}se.prototype.parse=function(F){var W=this.loose?P[te]:P[U],$=F.match(W);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new q($[2],this.loose):this.semver=pe},se.prototype.toString=function(){return this.value},se.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===pe||(typeof F=="string"&&(F=new q(F,this.loose)),fe(F,this.operator,this.semver,this.loose))},se.prototype.intersects=function(F,W){if(!(F instanceof se))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new me(F.value,W),xe(this.value,$,W);if(F.operator==="")return $=new me(this.value,W),xe(F.semver,$,W);var le=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=fe(this.semver,"<",F.semver,W)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=fe(this.semver,">",F.semver,W)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return le||de||Ce&&Se||ke||Re},i.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(F){var W=this.loose;F=F.trim(),b("range",F,W);var $=W?P[G]:P[z];F=F.replace($,Ie),b("hyphen replace",F),F=F.replace(P[k],"$1$2$3"),b("comparator trim",F,P[k]),F=(F=(F=F.replace(P[J],"$1~")).replace(P[he],"$1^")).split(/\s+/).join(" ");var le=W?P[te]:P[U],de=F.split(" ").map(function(Ce){return function(Se,ke){return b("comp",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){b("caret",De,Le);var Ae=Le?P[x]:P[ue];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("caret",De,Fe,ve,ye,be,Pe),Ee(ve)?Te="":Ee(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=ve==="0"?">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+".0 <"+(+ve+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+Pe+" <"+(+ve+1)+".0.0"):(b("no pr"),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+" <"+(+ve+1)+".0.0"),b("caret return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?P[ee]:P[re];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("tilde",De,Fe,ve,ye,be,Pe),Ee(ve)?Te="":Ee(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0"):Te=">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0",b("tilde return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Re,Oe){return b("replaceXRanges",Re,Oe),Re.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?P[O]:P[S];return De.replace(Ae,function(Fe,ve,ye,be,Pe,Te){b("xRange",De,Fe,ve,ye,be,Pe,Te);var je=Ee(ye),Ue=je||Ee(be),ze=Ue||Ee(Pe);return ve==="="&&ze&&(ve=""),je?Fe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Ue&&(be=0),ze&&(Pe=0),ve===">"?(ve=">=",Ue?(ye=+ye+1,be=0,Pe=0):ze&&(be=+be+1,Pe=0)):ve==="<="&&(ve="<",Ue?ye=+ye+1:be=+be+1),Fe=ve+ye+"."+be+"."+Pe):Ue?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ze&&(Fe=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0"),b("xRange return",Fe),Fe})}(Ne,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Re,Oe){return b("replaceStars",Re,Oe),Re.trim().replace(P[ne],"")}(Se,ke),b("stars",Se),Se}(Ce,W)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ce){return!!Ce.match(le)})),de=de.map(function(Ce){return new se(Ce,W)})},me.prototype.intersects=function(F,W){if(!(F instanceof me))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return F.set.some(function(de){return de.every(function(Ce){return le.intersects(Ce,W)})})})})},i.toComparators=function(F,W){return new me(F,W).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},me.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new q(F,this.loose));for(var W=0;W<this.set.length;W++)if(Me(this.set[W],F))return!0;return!1},i.satisfies=xe,i.maxSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new me(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==-1||(de=new q(le=Se,$)))}),le},i.minSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new me(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==1||(de=new q(le=Se,$)))}),le},i.validRange=function(F,W){try{return new me(F,W).range||"*"}catch{return null}},i.ltr=function(F,W,$){return Ve(F,W,"<",$)},i.gtr=function(F,W,$){return Ve(F,W,">",$)},i.outside=Ve,i.prerelease=function(F,W){var $=Z(F,W);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,W,$){return F=new me(F,$),W=new me(W,$),F.intersects(W)},i.coerce=function(F){if(F instanceof q)return F;if(typeof F!="string")return null;var W=F.match(P[N]);return W==null?null:Z((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,D(1))},function(j,i){var D,R,b=j.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(a){if(D===setTimeout)return setTimeout(a,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(a,0);try{return D(a,0)}catch{try{return D.call(null,a,0)}catch{return D.call(this,a,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var c,v=[],C=!1,T=-1;function d(){C&&c&&(C=!1,c.length?v=c.concat(v):T=-1,v.length&&y())}function y(){if(!C){var a=P(d);C=!0;for(var f=v.length;f;){for(c=v,v=[];++T<f;)c&&c[T].run();T=-1,f=v.length}c=null,C=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}(a)}}function w(a,f){this.fun=a,this.array=f}function g(){}b.nextTick=function(a){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];v.push(new w(a,f)),v.length!==1||C||P(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(a){return[]},b.binding=function(a){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(a){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Y[58],Q([0,1]),function(j,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(P,c,v){this.level=P,this.key=c,this.value=v,this.forward=[]}}const b=void 0;class I{constructor(P,c=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new R(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,b,b)}has(P){return Boolean(I._search(this,P,this.comparator))}get(P){return I._search(this,P,this.comparator)?.value}set(P,c){return I._insert(this,P,c,this.comparator)&&(this._size+=1),this}delete(P){const c=I._delete(this,P,this.comparator);return c&&(this._size-=1),c}forEach(P,c){let v=this._header.forward[0];for(;v;)P.call(c,v.value,v.key,this),v=v.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",c=this._header.forward[0];for(;c;)P+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return P}static _search(P,c,v){let C=P._header;for(let T=P._level-1;T>=0;T--)for(;C.forward[T]&&v(C.forward[T].key,c)<0;)C=C.forward[T];if(C=C.forward[0],C&&v(C.key,c)===0)return C}static _insert(P,c,v,C){let T=[],d=P._header;for(let y=P._level-1;y>=0;y--){for(;d.forward[y]&&C(d.forward[y].key,c)<0;)d=d.forward[y];T[y]=d}if(d=d.forward[0],d&&C(d.key,c)===0)return d.value=v,!1;{let y=I._randomLevel(P);if(y>P._level){for(let w=P._level;w<y;w++)T[w]=P._header;P._level=y}d=new R(y,c,v);for(let w=0;w<y;w++)d.forward[w]=T[w].forward[w],T[w].forward[w]=d;return!0}}static _randomLevel(P,c=.5){let v=1;for(;Math.random()<c&&v<P._maxLevel;)v+=1;return v}static _delete(P,c,v){let C=[],T=P._header;for(let d=P._level-1;d>=0;d--){for(;T.forward[d]&&v(T.forward[d].key,c)<0;)T=T.forward[d];C[d]=T}if(T=T.forward[0],!T||v(T.key,c)!==0)return!1;for(let d=0;d<P._level&&C[d].forward[d]===T;d++)C[d].forward[d]=T.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===b;)P._level-=1;return!0}}i.SkipList=I}),define(Y[38],Q([0,1,8,2]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(E){const m=E;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}i.isReadableStream=b;function I(E){const m=E;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}i.isReadableBufferedStream=I;function L(E,m){return new P(E,m)}i.newWriteableStream=L;class P{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,D.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let t;switch(m){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(E,m){const o=[];let t;for(;(t=E.read())!==null;)o.push(t);return m(o)}i.consumeReadable=c;function v(E,m,o){const t=[];let r;for(;(r=E.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?m(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return E.read()}}}i.peekReadable=v;function C(E,m){return new Promise((o,t)=>{const r=[];T(E,{onData:e=>{m&&r.push(e)},onError:e=>{m?t(e):o(void 0)},onEnd:()=>{o(m?m(r):void 0)}})})}i.consumeStream=C;function T(E,m){let o=!1;return E.on("error",t=>{o||m.onError(t)}),E.on("end",()=>{o||m.onEnd()}),E.on("data",t=>{o||m.onData(t)}),(0,R.toDisposable)(()=>o=!0)}i.listenStream=T;function d(E,m){return new Promise((o,t)=>{const r=new R.DisposableStore,e=[],n=u=>{if(e.push(u),e.length>m)return r.dispose(),E.pause(),o({stream:E,buffer:e,ended:!1})},s=u=>t(u),l=()=>o({stream:E,buffer:e,ended:!0});r.add((0,R.toDisposable)(()=>E.removeListener("error",s))),E.on("error",s),r.add((0,R.toDisposable)(()=>E.removeListener("end",l))),E.on("end",l),r.add((0,R.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}i.peekStream=d;function y(E,m){const o=L(m);return o.end(E),o}i.toStream=y;function w(){const E=L(()=>{throw new Error("not supported")});return E.end(),E}i.emptyStream=w;function g(E){let m=!1;return{read:()=>m?null:(m=!0,E)}}i.toReadable=g;function a(E,m,o){const t=L(o);return T(E,{onData:r=>t.write(m.data(r)),onError:r=>t.error(m.error?m.error(r):r),onEnd:()=>t.end()}),t}i.transform=a;function f(E,m,o){let t=!1;return{read:()=>{const r=m.read();return t?r:(t=!0,r!==null?o([E,r]):E)}}}i.prefixedReadable=f;function p(E,m,o){let t=!1;const r=L(o);return T(m,{onData:e=>t?r.write(e):(t=!0,r.write(o([E,e]))),onError:e=>r.error(e),onEnd:()=>{t||(t=!0,r.write(E)),r.end()}}),r}i.prefixedStream=p}),define(Y[17],Q([0,1,38]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer!="undefined";let b,I;class L{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return R?new L(Buffer.allocUnsafe(h)):new L(new Uint8Array(h))}static wrap(h){return R&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new L(h)}static fromString(h,S){return!(S?.dontUseNodeBuffer||!1)&&R?new L(Buffer.from(h)):(b||(b=new TextEncoder),new L(b.encode(h)))}static fromByteArray(h){const S=L.alloc(h.length);for(let O=0,N=h.length;O<N;O++)S.buffer[O]=h[O];return S}static concat(h,S){if(typeof S=="undefined"){S=0;for(let _=0,J=h.length;_<J;_++)S+=h[_].byteLength}const O=L.alloc(S);let N=0;for(let _=0,J=h.length;_<J;_++){const re=h[_];O.set(re,N),N+=re.byteLength}return O}clone(){const h=L.alloc(this.byteLength);return h.set(this),h}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(h,S){return new L(this.buffer.subarray(h,S))}set(h,S){if(h instanceof L)this.buffer.set(h.buffer,S);else if(h instanceof Uint8Array)this.buffer.set(h,S);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),S);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return v(this.buffer,h)}writeUInt32BE(h,S){C(this.buffer,h,S)}readUInt32LE(h){return T(this.buffer,h)}writeUInt32LE(h,S){d(this.buffer,h,S)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,S){w(this.buffer,h,S)}}i.VSBuffer=L;function P(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}i.readUInt16LE=P;function c(u,h,S){u[S+0]=h&255,h=h>>>8,u[S+1]=h&255}i.writeUInt16LE=c;function v(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}i.readUInt32BE=v;function C(u,h,S){u[S+3]=h,h=h>>>8,u[S+2]=h,h=h>>>8,u[S+1]=h,h=h>>>8,u[S]=h}i.writeUInt32BE=C;function T(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}i.readUInt32LE=T;function d(u,h,S){u[S+0]=h&255,h=h>>>8,u[S+1]=h&255,h=h>>>8,u[S+2]=h&255,h=h>>>8,u[S+3]=h&255}i.writeUInt32LE=d;function y(u,h){return u[h]}i.readUInt8=y;function w(u,h,S){u[S]=h}i.writeUInt8=w;function g(u){return D.consumeReadable(u,h=>L.concat(h))}i.readableToBuffer=g;function a(u){return D.toReadable(u)}i.bufferToReadable=a;function f(u){return D.consumeStream(u,h=>L.concat(h))}i.streamToBuffer=f;async function p(u){return u.ended?L.concat(u.buffer):L.concat([...u.buffer,await f(u.stream)])}i.bufferedStreamToBuffer=p;function E(u){return D.toStream(u,h=>L.concat(h))}i.bufferToStream=E;function m(u){return D.transform(u,{data:h=>typeof h=="string"?L.fromString(h):L.wrap(h)},h=>L.concat(h))}i.streamToBufferReadableStream=m;function o(u){return D.newWriteableStream(h=>L.concat(h),u)}i.newWriteableBufferStream=o;function t(u,h){return D.prefixedReadable(u,h,S=>L.concat(S))}i.prefixedBufferReadable=t;function r(u,h){return D.prefixedStream(u,h,S=>L.concat(S))}i.prefixedBufferStream=r;function e(u){let h=0,S=0,O=0;const N=new Uint8Array(Math.floor(u.length/4*3)),_=re=>{switch(S){case 3:N[O++]=h|re,S=0;break;case 2:N[O++]=h|re>>>2,h=re<<6,S=3;break;case 1:N[O++]=h|re>>>4,h=re<<4,S=2;break;default:h=re<<2,S=1}};for(let re=0;re<u.length;re++){const ee=u.charCodeAt(re);if(ee>=65&&ee<=90)_(ee-65);else if(ee>=97&&ee<=122)_(ee-97+26);else if(ee>=48&&ee<=57)_(ee-48+52);else if(ee===43||ee===45)_(62);else if(ee===47||ee===95)_(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${u[re]}`)}}const J=O;for(;S>0;)_(0);return L.wrap(N).slice(0,J)}i.decodeBase64=e;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:u},h=!0,S=!1){const O=S?s:n;let N="";const _=u.byteLength%3;let J=0;for(;J<u.byteLength-_;J+=3){const re=u[J+0],ee=u[J+1],ie=u[J+2];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[(ee<<2|ie>>>6)&63],N+=O[ie&63]}if(_===1){const re=u[J+0];N+=O[re>>>2],N+=O[re<<4&63],h&&(N+="==")}else if(_===2){const re=u[J+0],ee=u[J+1];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[ee<<2&63],h&&(N+="=")}return N}i.encodeBase64=l}),define(Y[59],Q([0,1,26]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function R(f){return b(f,0)}i.hash=R;function b(f,p){switch(typeof f){case"object":return f===null?I(349,p):Array.isArray(f)?c(f,p):v(f,p);case"string":return P(f,p);case"boolean":return L(f,p);case"number":return I(f,p);case"undefined":return I(937,p);default:return I(617,p)}}i.doHash=b;function I(f,p){return(p<<5)-p+f|0}i.numberHash=I;function L(f,p){return I(f?433:863,p)}function P(f,p){p=I(149417,p);for(let E=0,m=f.length;E<m;E++)p=I(f.charCodeAt(E),p);return p}i.stringHash=P;function c(f,p){return p=I(104579,p),f.reduce((E,m)=>b(m,E),p)}function v(f,p){return p=I(181387,p),Object.keys(f).sort().reduce((E,m)=>(E=P(m,E),b(f[m],E)),p)}class C{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=b(p,this._value),this._value}}i.Hasher=C;var T;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function d(f,p,E=32){const m=E-p,o=~((1<<m)-1);return(f<<p|(o&f)>>>m)>>>0}function y(f,p=0,E=f.byteLength,m=0){for(let o=0;o<E;o++)f[p+o]=m}function w(f,p,E="0"){for(;f.length<p;)f=E+f;return f}function g(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(E=>E.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),p/4)}i.toHexString=g;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const E=p.length;if(E===0)return;const m=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,e;for(t!==0?(r=t,e=-1,t=0):(r=p.charCodeAt(0),e=0);;){let n=r;if(D.isHighSurrogate(r))if(e+1<E){const s=p.charCodeAt(e+1);D.isLowSurrogate(s)?(e++,n=D.computeCodePoint(r,s)):n=65533}else{t=r;break}else D.isLowSurrogate(r)&&(n=65533);if(o=this._push(m,o,n),e++,e<E)r=p.charCodeAt(e);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(p,E,m){return m<128?p[E++]=m:m<2048?(p[E++]=192|(m&1984)>>>6,p[E++]=128|(m&63)>>>0):m<65536?(p[E++]=224|(m&61440)>>>12,p[E++]=128|(m&4032)>>>6,p[E++]=128|(m&63)>>>0):(p[E++]=240|(m&1835008)>>>18,p[E++]=128|(m&258048)>>>12,p[E++]=128|(m&4032)>>>6,p[E++]=128|(m&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=a._bigBlock32,E=this._buffDV;for(let u=0;u<64;u+=4)p.setUint32(u,E.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,d(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let m=this._h0,o=this._h1,t=this._h2,r=this._h3,e=this._h4,n,s,l;for(let u=0;u<80;u++)u<20?(n=o&t|~o&r,s=1518500249):u<40?(n=o^t^r,s=1859775393):u<60?(n=o&t|o&r|t&r,s=2400959708):(n=o^t^r,s=3395469782),l=d(m,5)+n+e+s+p.getUint32(u*4,!1)&4294967295,e=r,r=t,t=d(o,30),o=m,m=l;this._h0=this._h0+m&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}i.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Y[22],Q([0,1,6]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const a=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?a[f]=R(g[f]):a[f]=g[f]}),a}i.deepClone=R;function b(g){if(!g||typeof g!="object")return g;const a=[g];for(;a.length>0;){const f=a.shift();Object.freeze(f);for(const p in f)if(I.call(f,p)){const E=f[p];typeof E=="object"&&!Object.isFrozen(E)&&a.push(E)}}return g}i.deepFreeze=b;const I=Object.prototype.hasOwnProperty;function L(g,a){return P(g,a,new Set)}i.cloneAndChange=L;function P(g,a,f){if((0,D.isUndefinedOrNull)(g))return g;const p=a(g);if(typeof p!="undefined")return p;if((0,D.isArray)(g)){const E=[];for(const m of g)E.push(P(m,a,f));return E}if((0,D.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const E={};for(let m in g)I.call(g,m)&&(E[m]=P(g[m],a,f));return f.delete(g),E}return g}function c(g,a,f=!0){return(0,D.isObject)(g)?((0,D.isObject)(a)&&Object.keys(a).forEach(p=>{p in g?f&&((0,D.isObject)(g[p])&&(0,D.isObject)(a[p])?c(g[p],a[p],f):g[p]=a[p]):g[p]=a[p]}),g):a}i.mixin=c;function v(g,a){if(g===a)return!0;if(g==null||a===null||a===void 0||typeof g!=typeof a||typeof g!="object"||Array.isArray(g)!==Array.isArray(a))return!1;let f,p;if(Array.isArray(g)){if(g.length!==a.length)return!1;for(f=0;f<g.length;f++)if(!v(g[f],a[f]))return!1}else{const E=[];for(p in g)E.push(p);E.sort();const m=[];for(p in a)m.push(p);if(m.sort(),!v(E,m))return!1;for(f=0;f<E.length;f++)if(!v(g[E[f]],a[E[f]]))return!1}return!0}i.equals=v;function C(g){const a=new Set;return JSON.stringify(g,(f,p)=>{if((0,D.isObject)(p)||Array.isArray(p)){if(a.has(p))return"[Circular]";a.add(p)}return p})}i.safeStringify=C;function T(g,a,f){const p=a(g);return typeof p=="undefined"?f:p}i.getOrDefault=T;function d(g,a){const f=Object.create(null);return!g||!a||Object.keys(a).forEach(E=>{const m=g[E],o=a[E];v(m,o)||(f[E]=o)}),f}i.distinct=d;function y(g,a){const f=a.toLowerCase(),p=Object.keys(g).find(E=>E.toLowerCase()===f);return p?g[p]:g[a]}i.getCaseInsensitive=y;function w(g,a){const f=Object.create(null);for(const[p,E]of Object.entries(g))a(p,E)&&(f[p]=E);return f}i.filter=w}),define(Y[60],Q([0,1,9]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(v){const C=v;return C&&typeof C.type=="string"&&typeof C.severity=="string"}i.isRemoteConsoleLog=R;function b(v){const C=[];let T;try{const d=JSON.parse(v.arguments),y=d[d.length-1];y&&y.__$stack&&(d.pop(),T=y.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",v.arguments)}return{args:C,stack:T}}i.parse=b;function I(v){if(typeof v!="string")return I(b(v).stack);const C=v;if(C){const T=L(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}i.getFirstFrame=I;function L(v){if(!v)return v;const C=v.indexOf(`
`);return C===-1?v:v.substring(0,C)}function P(v,C){const{args:T,stack:d}=b(v),y=typeof T[0]=="string"&&T.length===1;let w=L(d);w&&(w=`(${w.trim()})`);let g=[];if(typeof T[0]=="string"?w&&y?g=[`%c[${C}] %c${T[0]} %c${w}`,c("blue"),c(""),c("grey")]:g=[`%c[${C}] %c${T[0]}`,c("blue"),c(""),...T.slice(1)]:g=[`%c[${C}]%`,c("blue"),...T],w&&!y&&g.push(w),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,g)}i.log=P;function c(v){return`color: ${v}`}}),define(Y[61],Q([0,1,17,26,9]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function I(v){return JSON.stringify(v,P)}i.stringify=I;function L(v){let C=JSON.parse(v);return C=c(C),C}i.parse=L;function P(v,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function c(v,C=0){if(!v||C>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return b.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 14:return new Date(v.source)}if(v instanceof D.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let T=0;T<v.length;++T)v[T]=c(v[T],C+1);else for(const T in v)Object.hasOwnProperty.call(v,T)&&(v[T]=c(v[T],C+1))}return v}i.revive=c}),define(Y[62],Q([0,1,45,10,11,12,19,26,9]),function(j,i,D,R,b,I,L,P,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function v(n,s,l){if(typeof n=="string"&&(n=c.URI.file(n)),l){const h=l.getWorkspaceFolder(n);if(h){const S=l.getWorkspace().folders.length>1;let O;if((0,L.isEqual)(h.uri,n)?O="":O=(0,L.relativePath)(h.uri,n),S){const N=h.name?h.name:(0,L.basename)(h.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==R.Schemas.file&&n.scheme!==R.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,b.normalize)(T(n.fsPath));let u=(0,b.normalize)(n.fsPath);return!I.isWindows&&s?.userHome&&(u=y(u,s.userHome.fsPath)),u}i.getPathLabel=v;function C(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const s=(0,L.basename)(n)||(n.scheme===R.Schemas.file?n.fsPath:n.path);return I.isWindows&&(0,D.isRootOrDriveLetter)(s)?T(s):s}i.getBaseLabel=C;function T(n,s){return(0,D.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=T;let d=Object.create(null);function y(n,s){if(I.isWindows||!n||!s)return n;let l=d.original===s?d.normalized:void 0;return l||(l=`${(0,P.rtrim)(s,b.posix.sep)}${b.posix.sep}`,d={original:s,normalized:l}),(I.isLinux?n.startsWith(l):(0,P.startsWithIgnoreCase)(n,l))&&(n=`~/${n.substr(l.length)}`),n}i.tildify=y;function w(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=w;const g="\u2026",a="\\\\",f="~";function p(n,s=b.sep){const l=new Array(n.length);let u=!1;for(let h=0;h<n.length;h++){let S=n[h];if(S===""){l[h]=`.${s}`;continue}if(!S){l[h]=S;continue}u=!0;let O="";S.indexOf(a)===0?(O=S.substr(0,S.indexOf(a)+a.length),S=S.substr(S.indexOf(a)+a.length)):S.indexOf(s)===0?(O=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length)):S.indexOf(f)===0&&(O=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const N=S.split(s);for(let _=1;u&&_<=N.length;_++)for(let J=N.length-_;u&&J>=0;J--){u=!1;let re=N.slice(J,J+_).join(s);for(let ee=0;!u&&ee<n.length;ee++)if(ee!==h&&n[ee]&&n[ee].indexOf(re)>-1){const ie=J+_===N.length,he=J>0&&n[ee].indexOf(s)>-1?s+re:re,ue=n[ee].endsWith(he);u=!ie||ue}if(!u){let ee="";(N[0].endsWith(":")||O!=="")&&(J===1&&(J=0,_++,re=N[0]+s+re),J>0&&(ee=N[0]+s),ee=O+ee),J>0&&(ee=ee+g+s),ee=ee+re,J+_<N.length&&(ee=ee+s+g),l[h]=ee}}u&&(l[h]=S)}return l}i.shorten=p;var E;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function m(n,s=Object.create(null)){const l=[];let u=!1,h="";for(const S of n)if(S==="$"||u&&S==="{")h&&l.push({value:h,type:E.TEXT}),h="",u=!0;else if(S==="}"&&u){const O=s[h];if(typeof O=="string")O.length&&l.push({value:O,type:E.VARIABLE});else if(O){const N=l[l.length-1];(!N||N.type!==E.SEPARATOR)&&l.push({value:O.label,type:E.SEPARATOR})}h="",u=!1}else h+=S;return h&&!u&&l.push({value:h,type:E.TEXT}),l.filter((S,O)=>{if(S.type===E.SEPARATOR){const N=l[O-1],_=l[O+1];return[N,_].every(J=>J&&(J.type===E.VARIABLE||J.type===E.TEXT)&&J.value.length>0)}return!0}).map(S=>S.value).join("")}i.template=m;function o(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}i.mnemonicMenuLabel=o;function t(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(n){const s=n.indexOf("/")!==-1?b.posix:b.win32,l=s.basename(n),u=s.dirname(n);return l.length?{name:l,parentPath:u}:{name:u,parentPath:""}}i.splitName=e}),define(Y[27],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(c){return D.test(c)}i.isUUID=R;const b=new Uint8Array(16),I=[];for(let c=0;c<256;c++)I.push(c.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(c){for(let v=0;v<c.length;v++)c[v]=Math.floor(Math.random()*256);return c};function P(){L(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let c=0,v="";return v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v}i.generateUuid=P}),define(Y[63],Q([0,1,132]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class R{constructor(I="utf8"){this.stringDecoder=new D.StringDecoder(I),this.remaining=null}write(I){const L=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return L;let c=0,v,C=c;for(;C<P.length;)if(v=P.charCodeAt(C),v===13||v===10){if(L.push(P.substring(c,C)),C++,C<P.length){const T=v;v=P.charCodeAt(C),(T===13&&v===10||T===10&&v===13)&&C++}c=C}else C++;return this.remaining=c<P.length?P.substr(c):null,L}end(){return this.remaining}}i.LineDecoder=R}),define(Y[64],Q([0,1,33,11,15]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var c;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(c||(c={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class T{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:m=!1}={}){return m?v===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:o=!1}={}){const t=d({useAlternateBitness:m});if(!t)return null;const r=R.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const u of await b.Promises.readdir(r)){let h=-1;if(o){const O=u.indexOf("-");if(O<0)continue;const N=u.substring(0,O);if(!I.test(N)||u.substring(O+1)!=="preview")continue;h=parseInt(N,10)}else{if(!I.test(u))continue;h=parseInt(u,10)}if(h<=e)continue;const S=R.join(r,u,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(n=S,e=h)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new T(n,`PowerShell${l}${s}`,!0)}async function w({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const o=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(o))if(t.test(e)){const n=R.join(o,e,"pwsh.exe");return new T(n,r)}return null}function g(){const m=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new T(m,".NET Core PowerShell Global Tool")}function a(){const m=R.join(process.env.windir,v===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(m,"Windows PowerShell",!0)}async function*f(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await w(),m&&(yield m),m=g(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await w({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=a(),m&&(yield m)}async function*p(){for await(const m of f())await m.exists()&&(yield m)}i.enumeratePowerShellInstallations=p;async function E(){for await(const m of p())return m;return null}i.getFirstAvailablePowerShellInstallation=E});var ge=this&&this.__decorate||function(j,i,D,R){var b=arguments.length,I=b<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,D):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(j,i,D,R);else for(var P=j.length-1;P>=0;P--)(L=j[P])&&(I=(b<3?L(I):b>3?L(i,D,I):L(i,D))||I);return b>3&&I&&Object.defineProperty(i,D,I),I};define(Y[46],Q([0,1,18,3,17,24,44,8,7,2,61,26,6]),function(j,i,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var y;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(y=i.RequestType||(i.RequestType={}));function w(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function a(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(f||(f={}));class p{constructor(k){this.buffer=k,this.pos=0}read(k){const z=this.buffer.slice(this.pos,this.pos+k);return this.pos+=z.byteLength,z}}class E{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var m;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(m||(m={}));function o(U){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function t(U){return U.read(4).readUInt32BE(0)}function r(U){const k=b.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const e={Undefined:r(m.Undefined),String:r(m.String),Buffer:r(m.Buffer),VSBuffer:r(m.VSBuffer),Array:r(m.Array),Object:r(m.Object)},n=typeof Buffer!="undefined";function s(U,k){if(typeof k=="undefined")U.write(e.Undefined);else if(typeof k=="string"){const z=b.VSBuffer.fromString(k);U.write(e.String),U.write(o(z.byteLength)),U.write(z)}else if(n&&Buffer.isBuffer(k)){const z=b.VSBuffer.wrap(k);U.write(e.Buffer),U.write(o(z.byteLength)),U.write(z)}else if(k instanceof b.VSBuffer)U.write(e.VSBuffer),U.write(o(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(e.Array),U.write(o(k.length));for(const z of k)s(U,z)}else{const z=b.VSBuffer.fromString(JSON.stringify(k));U.write(e.Object),U.write(o(z.byteLength)),U.write(z)}}function l(U){switch(U.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return U.read(t(U)).toString();case m.Buffer:return U.read(t(U)).buffer;case m.VSBuffer:return U.read(t(U));case m.Array:{const z=t(U),G=[];for(let ne=0;ne<z;ne++)G.push(l(U));return G}case m.Object:return JSON.parse(U.read(t(U)).toString())}}class u{constructor(k,z,G=null,ne=1e3){this.protocol=k,this.ctx=z,this.logger=G,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,z){this.channels.set(k,z),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const z=this.send([k.type]);this.logger?.logOutgoing(z,0,1,a(k.type));return}case 201:case 202:case 204:case 203:{const z=this.send([k.type,k.id],k.data);this.logger?.logOutgoing(z,k.id,1,a(k.type),k.data);return}}}send(k,z=void 0){const G=new E;return s(G,k),s(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const z=new p(k),G=l(z),ne=l(z),K=G[0];switch(K){case 100:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}: ${G[2]}.${G[3]}`,ne),this.onPromise({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 102:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}: ${G[2]}.${G[3]}`,ne),this.onEventListen({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 101:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:G[1]});case 103:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:G[1]})}}onPromise(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=new I.CancellationTokenSource;let ne;try{ne=z.call(this.ctx,k.name,k.arg,G.token)}catch(q){ne=Promise.reject(q)}const K=k.id;ne.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(k.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(k.id)});const Z=(0,v.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=k.id,K=z.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const z=this.activeRequests.get(k.id);z&&(z.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let z=this.pendingRequests.get(k.channelName);z||(z=[],this.pendingRequests.set(k.channelName,z));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const z=this.pendingRequests.get(k);if(z){for(const G of z)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=u;var h;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(h=i.RequestInitiator||(i.RequestInitiator={}));class S{constructor(k,z=null){this.protocol=k,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=z}getChannel(k){const z=this;return{call(G,ne,K){return z.isDisposed?Promise.reject(P.canceled()):z.requestPromise(k,G,ne,K)},listen(G,ne){return z.isDisposed?c.Event.None:z.requestEvent(k,G,ne)}}}requestPromise(k,z,G,ne=I.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:k,name:z,arg:G};if(ne.isCancellationRequested)return Promise.reject(P.canceled());let M;return new Promise((V,B)=>{if(ne.isCancellationRequested)return B(P.canceled());const H=()=>{const we=fe=>{switch(fe.type){case 201:this.handlers.delete(K),V(fe.data);break;case 202:{this.handlers.delete(K);const se=new Error(fe.data.message);se.stack=fe.data.stack,se.name=fe.data.name,B(se);break}case 203:this.handlers.delete(K),B(fe.data);break}};this.handlers.set(K,we),this.sendRequest(q)};let X=null;this.state===f.Idle?H():(X=(0,R.createCancelablePromise)(we=>this.whenInitialized()),X.then(()=>{X=null,H()}));const ae=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),B(P.canceled())},ce=ne.onCancellationRequested(ae);M=(0,v.combinedDisposable)((0,v.toDisposable)(ae),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(k,z,G){const ne=this.lastRequestId++,Z={id:ne,type:102,channelName:k,name:z,arg:G};let q=null;const M=new c.Emitter({onFirstListenerAdd:()=>{q=(0,R.createCancelablePromise)(V=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(M),this.sendRequest(Z)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(M),this.sendRequest({id:ne,type:103}))}}),A=V=>M.fire(V.data);return this.handlers.set(ne,A),M.event}sendRequest(k){switch(k.type){case 100:case 102:{const z=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(z,k.id,0,`${w(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const z=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(z,k.id,0,w(k.type));return}}}send(k,z=void 0){const G=new E;return s(G,k),s(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const z=new p(k),G=l(z),ne=l(z),K=G[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,a(K)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,a(K),ne),this.onResponse({type:G[0],id:G[1],data:ne})}}onResponse(k){if(k.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(k.id);z&&z(k)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],S.prototype,"onDidInitializePromise",null),i.ChannelClient=S;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:z,onDidClientDisconnect:G})=>{c.Event.once(z.onMessage)(K=>{const Z=new p(K),q=l(Z),M=new u(z,q),A=new S(z);this.channels.forEach((B,H)=>M.registerChannel(H,B));const V={channelServer:M,channelClient:A,ctx:q};this._connections.add(V),this._onDidAddConnection.fire(V),G(()=>{M.dispose(),A.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const k=[];return this._connections.forEach(z=>k.push(z)),k}getChannel(k,z){const G=this;return{call(ne,K,Z){let q;if((0,d.isFunction)(z)){let A=(0,D.getRandomElement)(G.connections.filter(z));q=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(G.onDidAddConnection,z))}else q=z.routeCall(G,ne,K);const M=q.then(A=>A.channelClient.getChannel(k));return _(M).call(ne,K,Z)},listen(ne,K){if((0,d.isFunction)(z))return G.getMulticastEvent(k,z,ne,K);const Z=z.routeEvent(G,ne,K).then(q=>q.channelClient.getChannel(k));return _(Z).listen(ne,K)}}}getMulticastEvent(k,z,G,ne){const K=this;let Z=new v.DisposableStore;const q=new c.Emitter({onFirstListenerAdd:()=>{Z=new v.DisposableStore;const M=new c.EventMultiplexer,A=new Map,V=H=>{const ae=H.channelClient.getChannel(k).listen(G,ne),ce=M.add(ae);A.set(H,ce)},B=H=>{const X=A.get(H);!X||(X.dispose(),A.delete(H))};K.connections.filter(z).forEach(V),c.Event.filter(K.onDidAddConnection,z)(V,void 0,Z),K.onDidRemoveConnection(B,void 0,Z),M.event(q.fire,q,Z),Z.add(M)},onLastListenerRemove:()=>{Z.dispose()}});return q.event}registerChannel(k,z){this.channels.set(k,z),this._connections.forEach(G=>{G.channelServer.registerChannel(k,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,z,G=null){const ne=new E;s(ne,z),k.send(ne.buffer),this.channelClient=new S(k,G),this.channelServer=new u(k,z,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,z){this.channelServer.registerChannel(k,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function _(U){return{call(k,z,G){return U.then(ne=>ne.call(k,z,G))},listen(k,z){const G=new c.Relay;return U.then(ne=>G.input=ne.listen(k,z)),G.event}}}i.getDelayedChannel=_;function J(U){let k=!1;return{call(z,G,ne){return k?U.call(z,G,ne):(0,R.timeout)(0).then(()=>k=!0).then(()=>U.call(z,G,ne))},listen(z,G){if(k)return U.listen(z,G);const ne=new c.Relay;return(0,R.timeout)(0).then(()=>k=!0).then(()=>ne.input=U.listen(z,G)),ne.event}}}i.getNextTickChannel=J;class re{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const z of k.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=re;var ee;(function(U){function k(K,Z){const q=K,M=Z&&Z.disableMarshalling,A=new Map;for(const V in q)G(V)&&A.set(V,c.Event.buffer(q[V],!0));return new class{listen(V,B,H){const X=A.get(B);if(X)return X;if(ne(B)){const ae=q[B];if(typeof ae=="function")return ae.call(q,H)}throw new Error(`Event not found: ${B}`)}call(V,B,H){const X=q[B];if(typeof X=="function"){if(!M&&Array.isArray(H))for(let ae=0;ae<H.length;ae++)H[ae]=(0,C.revive)(H[ae]);return X.apply(q,H)}throw new Error(`Method not found: ${B}`)}}}U.fromService=k;function z(K,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):ne(A)?function(V){return K.listen(A,V)}:G(A)?K.listen(A):async function(...V){let B;Z&&!(0,d.isUndefinedOrNull)(Z.context)?B=[Z.context,...V]:B=V;const H=await K.call(A,B);return q?H:(0,C.revive)(H)};throw new Error(`Property not found: ${String(A)}`)}})}U.toService=z;function G(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(ee=i.ProxyChannel||(i.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function ue(U){return Array.isArray(U)?U.map(he):he(U)}function x(U,k,z,G,ne,K,Z){Z=ue(Z);const q=ie[ne],M=q[G%q.length];let A=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}i.logWithColors=x;class te{constructor(k,z){this._outgoingPrefix=k,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,z,G,ne,K){this._totalOutgoing+=k,x(this._outgoingPrefix,this._totalOutgoing,k,z,G,ne,K)}logIncoming(k,z,G,ne,K){this._totalIncoming+=k,x(this._incomingPrefix,this._totalIncoming,k,z,G,ne,K)}}i.IPCLogger=te}),define(Y[65],Q([0,1,3,7,2,6]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function P(T){const d=T;return d?.changed instanceof Map||d?.deleted instanceof Set}i.isStorageItemsChangeEvent=P;var c;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(c||(c={}));class v extends b.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((y,w)=>this.accept(w,y)),d.deleted?.forEach(y=>this.accept(y,void 0))}accept(d,y){if(this.state===c.Closed)return;let w=!1;(0,I.isUndefinedOrNull)(y)?w=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),w=!0),w&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const w=this.cache.get(d);return(0,I.isUndefinedOrNull)(w)?y:w}getBoolean(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:w==="true"}getNumber(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:parseInt(w,10)}async set(d,y){if(this.state===c.Closed)return;if((0,I.isUndefinedOrNull)(y))return this.delete(d);const w=String(y);if(this.cache.get(d)!==w)return this.cache.set(d,w),this.pendingInserts.set(d,w),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,w)=>this.items.set(w,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}i.InMemoryStorageDatabase=C}),define(Y[66],Q([4,5]),function(j,i){return j.create("vs/base/common/date",i)}),define(Y[67],Q([0,1,66]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,b=R*60,I=b*24,L=I*7,P=I*30,c=I*365;function v(T,d,y){typeof T!="number"&&(T=T.getTime());const w=Math.round((new Date().getTime()-T)/1e3);if(w<-30)return(0,D.localize)(0,null,v(new Date().getTime()+w*1e3,!1));if(w<30)return(0,D.localize)(1,null);let g;return w<R?(g=w,d?g===1?y?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):y?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?y?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):y?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):w<b?(g=Math.floor(w/R),d?g===1?y?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):y?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?y?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):y?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):w<I?(g=Math.floor(w/b),d?g===1?y?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):y?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?y?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):y?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):w<L?(g=Math.floor(w/I),d?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):w<P?(g=Math.floor(w/L),d?g===1?y?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):y?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?y?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):y?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):w<c?(g=Math.floor(w/P),d?g===1?y?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):y?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?y?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):y?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(w/c),d?g===1?y?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):y?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?y?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):y?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}i.fromNow=v;function C(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=C}),define(Y[68],Q([4,5]),function(j,i){return j.create("vs/base/common/errorMessage",i)}),define(Y[28],Q([0,1,18,6,68]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function I(T,d){return d&&(T.stack||T.stacktrace)?b.localize(0,null,P(T),L(T.stack)||L(T.stacktrace)):P(T)}function L(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?b.localize(1,null,T.message):T.message||b.localize(2,null)}function c(T=null,d=!1){if(!T)return b.localize(3,null);if(Array.isArray(T)){const y=D.coalesce(T),w=c(y[0],d);return y.length>1?b.localize(4,null,w,y.length):w}if(R.isString(T))return T;if(T.detail){const y=T.detail;if(y.error)return I(y.error,d);if(y.exception)return I(y.exception,d)}return T.stack?I(T,d):T.message?T.message:b.localize(5,null)}i.toErrorMessage=c;function v(T){const d=T;return d instanceof Error&&Array.isArray(d.actions)}i.isErrorWithActions=v;function C(T,d=Object.create(null)){const y=new Error(T);return d.actions&&(y.actions=d.actions),y}i.createErrorWithActions=C}),define(Y[69],Q([4,5]),function(j,i){return j.create("vs/base/node/processes",i)}),define(Y[47],Q([0,1,39,45,10,22,11,12,29,57,6,63,15,69]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function w(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(t,r){if(P.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=D.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(s=>{n.once("error",l=>{s({success:!1,error:l})}),n.once("exit",(l,u)=>{s(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?w(e.status):1})}else if(P.isLinux||P.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(n=>{D.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(s,l,u)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function a(t){!t||(delete t.DEBUG,P.isMacintosh&&delete t.DYLD_LIBRARY_PATH,P.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=a;function f(t=c.env){return t.comspec||"cmd.exe"}i.getWindowsShell=f;class p{constructor(r,e,n,s){if(e!==void 0&&n!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=s;else{const l=r;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(c.env).forEach(u=>{l[u]=c.env[u]}),Object.keys(this.options.env).forEach(u=>{l[u]=this.options.env[u]}),this.options.env=l}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(L.sep);return e!==-1&&(r=r.substring(e+1)),p.WellKnowCommands[r]?r:"other"}start(r){return P.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(c.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(e=>{let n,s;const l=new Promise((u,h)=>{n=u,s=h});if(e){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(h,S,O)=>{this.childProcess=null;const N=h;N&&N.killed?s({killed:this.terminateRequested,stdout:S.toString(),stderr:O.toString()}):this.handleExec(n,r,h,S,O)})}else{let u=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,n,r,s);const O={terminated:this.terminateRequested};C.isNumber(S)&&(O.cmdCode=S),n(O)};if(this.shell&&P.isWindows){const S=I.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let O=!1,N=!1;const _=[];let J=this.ensureQuotes(this.cmd);_.push(J.value),O=J.quoted,this.args&&this.args.forEach(ee=>{J=this.ensureQuotes(ee),_.push(J.value),N=N&&J.quoted});const re=["/s","/c"];O?N?re.push('"'+_.join(" ")+'"'):_.length>1?re.push('"'+_[0]+'" '+_.slice(1).join(" ")):re.push('"'+_[0]+'"'):re.push(_.join(" ")),u=D.spawn(f(),re,S)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",S=>{this.childProcess=null,s({terminated:this.terminateRequested,error:S})}),u.pid&&(this.childProcess.on("close",h),this.handleSpawn(u,n,r,s,!0)))}return l})}handleClose(r,e,n,s){}ensureQuotes(r){return p.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,g(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!P.isWindows)return r(!1);const e=D.spawn(f(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}i.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class E extends p{constructor(r,e,n,s){super(r,e,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,s,l){[s,l].forEach((u,h)=>{const S=new T.LineDecoder;S.write(u).forEach(_=>{e({line:_,source:h===0?0:1})});const N=S.end();N&&e({line:N,source:h===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,s,l){const u=new T.LineDecoder,h=new T.LineDecoder;r.stdout.on("data",S=>{u.write(S).forEach(N=>n({line:N,source:0}))}),r.stderr.on("data",S=>{h.write(S).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=h}handleClose(r,e,n,s){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}i.LineProcess=E;function m(t){let r=[],e=!1;const n=function(s){if(e){r.push(s);return}(!t.send(s,u=>{if(u&&console.error(u),e=!1,r.length>0){const h=r.slice(0);r=[],h.forEach(S=>n(S))}})||P.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=m;var o;(function(t){async function r(e,n,s){if(L.isAbsolute(e))return e;if(n===void 0&&(n=c.cwd()),L.dirname(e)!=="."||(s===void 0&&C.isString(c.env.PATH)&&(s=c.env.PATH.split(L.delimiter)),s===void 0||s.length===0))return L.join(n,e);async function u(h){if(await d.Promises.exists(h)){let S;try{S=await d.Promises.stat(h)}catch(O){O.message.startsWith("EACCES")&&(S=await d.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(let h of s){let S;if(L.isAbsolute(h)?S=L.join(h,e):S=L.join(n,h,e),await u(S))return S;let O=S+".com";if(await u(O)||(O=S+".exe",await u(O)))return O}return L.join(n,e)}t.findExecutable=r})(o=i.win32||(i.win32={}))}),define(Y[70],Q([0,1,33,12,64,47]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(y,w){return y===1?R.isWindows?T():I.getWindowsShell(w):v(y,w)}i.getSystemShell=L;function P(y,w){return y===1?R.isWindows?d(w):I.getWindowsShell(w):v(y,w)}i.getSystemShellSync=P;let c=null;function v(y,w){if(R.isLinux&&y===2||R.isMacintosh&&y===3)return"/bin/bash";if(!c){let g;if(R.isWindows)g="/bin/bash";else{if(g=w.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}c=g}return c}let C=null;async function T(){return C||(C=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),C}function d(y){if(C)return C;const w=R.isWindows&&parseFloat((0,D.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),a=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?a:I.getWindowsShell(y)}}),define(Y[71],Q([0,1,39,3,17,24,60,8,7,2,22,47,46]),function(j,i,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class y extends d.ChannelServer{constructor(a){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",f=>b.VSBuffer.wrap(Buffer.from(f,"base64")))},a);process.once("disconnect",()=>this.dispose())}}i.Server=y;class w{constructor(a,f){this.modulePath=a,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new R.Delayer(p),this.child=null,this._client=null}getChannel(a){const f=this;return{call(p,E,m){return f.requestPromise(a,p,E,m)},listen(p,E){return f.requestEvent(a,p,E)}}}requestPromise(a,f,p,E=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(a),o=(0,R.createCancelablePromise)(e=>m.call(f,p,e)),t=E.onCancellationRequested(()=>o.cancel()),r=(0,v.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{t.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(a,f,p){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let E;const m=new c.Emitter({onFirstListenerAdd:()=>{E=this.getCachedChannel(a).listen(f,p)(m.fire,m),this.activeRequests.add(E)},onLastListenerRemove:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,T.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,a,f);const p=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,L.isRemoteConsoleLog)(n)){(0,L.log)(n,`IPC Library: ${this.options.serverName}`);return}p.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const m=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&m.send(n.buffer.toString("base64")),t=p.event,r={send:o,onMessage:t};this._client=new d.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(l=>(0,v.dispose)(l)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(a){let f=this.channels.get(a);return f||(f=this.client.getChannel(a),this.channels.set(a,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=w}),define(Y[72],Q([4,5]),function(j,i){return j.create("vs/base/node/zip",i)}),define(Y[73],Q([4,5]),function(j,i){return j.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Y[74],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Y[75],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Y[76],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Y[77],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Y[78],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Y[79],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Y[80],Q([4,5]),function(j,i){return j.create("vs/platform/extensions/common/extensionValidator",i)}),define(Y[81],Q([4,5]),function(j,i){return j.create("vs/platform/files/common/fileService",i)}),define(Y[82],Q([4,5]),function(j,i){return j.create("vs/platform/files/common/io",i)}),define(Y[83],Q([4,5]),function(j,i){return j.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Y[84],Q([4,5]),function(j,i){return j.create("vs/platform/request/common/request",i)}),define(Y[85],Q([4,5]),function(j,i){return j.create("vs/platform/telemetry/common/telemetryService",i)}),define(Y[86],Q([4,5]),function(j,i){return j.create("vs/platform/terminal/node/shellEnv",i)}),define(Y[87],Q([0,1,67,44,10,11,29,19,9]),function(j,i,D,R,b,I,L,P,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class v{constructor(g,a,f){this._args=g,this.paths=a,this.productService=f}get appRoot(){return(0,I.dirname)(b.FileAccess.asFileUri("",j).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(c.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?c.URI.file((0,I.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(b.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,I.resolve)(g):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const a=L.env.VSCODE_EXTENSIONS;if(a)return a;const f=L.env.VSCODE_PORTABLE;return f?(0,I.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(a=>/^[^:/?#]+?:\/\//.test(a)?c.URI.parse(a):c.URI.file((0,I.normalize)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?c.URI.parse(g):c.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([R.memoize],v.prototype,"appRoot",null),ge([R.memoize],v.prototype,"userHome",null),ge([R.memoize],v.prototype,"userDataPath",null),ge([R.memoize],v.prototype,"appSettingsHome",null),ge([R.memoize],v.prototype,"tmpDir",null),ge([R.memoize],v.prototype,"cacheHome",null),ge([R.memoize],v.prototype,"userRoamingDataHome",null),ge([R.memoize],v.prototype,"settingsResource",null),ge([R.memoize],v.prototype,"userDataSyncHome",null),ge([R.memoize],v.prototype,"userDataSyncLogResource",null),ge([R.memoize],v.prototype,"sync",null),ge([R.memoize],v.prototype,"machineSettingsResource",null),ge([R.memoize],v.prototype,"globalStorageHome",null),ge([R.memoize],v.prototype,"workspaceStorageHome",null),ge([R.memoize],v.prototype,"keybindingsResource",null),ge([R.memoize],v.prototype,"keyboardLayoutResource",null),ge([R.memoize],v.prototype,"argvResource",null),ge([R.memoize],v.prototype,"snippetsHome",null),ge([R.memoize],v.prototype,"isExtensionDevelopment",null),ge([R.memoize],v.prototype,"untitledWorkspacesHome",null),ge([R.memoize],v.prototype,"installSourcePath",null),ge([R.memoize],v.prototype,"builtinExtensionsPath",null),ge([R.memoize],v.prototype,"extensionsPath",null),ge([R.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],v.prototype,"extensionDevelopmentKind",null),ge([R.memoize],v.prototype,"extensionTestsLocationURI",null),ge([R.memoize],v.prototype,"debugExtensionHost",null),ge([R.memoize],v.prototype,"serviceMachineIdResource",null),ge([R.memoize],v.prototype,"telemetryLogResource",null),ge([R.memoize],v.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=v;function C(w,g){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,g,w.debugId,w.extensionEnvironment)}i.parseExtensionHostPort=C;function T(w,g){return y(w["inspect-search"],w["inspect-brk-search"],5876,g,w.extensionEnvironment)}i.parseSearchPort=T;function d(w,g){return y(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,g,w.extensionEnvironment)}i.parsePtyHostPort=d;function y(w,g,a,f,p,E){const o=Number(g||w)||(f?null:a),t=o?Boolean(!!g):!1;let r;if(E)try{r=JSON.parse(E)}catch{}return{port:o,break:t,debugId:p,env:r}}}),function(){"use strict";function j(i,D,R,b){function I(P){const c=L(P),v=[c];return i.isAbsolute(c)||v.unshift(b),i.resolve(...v)}function L(P){const c=process.env.VSCODE_PORTABLE;if(c)return i.join(c,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return i.join(v,R);const C=P["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=i.join(T,"AppData","Roaming")}break;case"darwin":v=i.join(D.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(v,R)}return{getUserDataPath:I}}if(typeof define=="function")define(Y[88],Q([0,133,33,10,19,29]),function(i,D,R,b,I,L){const P=I.dirname(b.FileAccess.asFileUri("",i)),c=i.__$__nodeRequire(I.joinPath(P,"package.json").fsPath);return j(D,R,c.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),D=require("path"),R=require("os");module.exports=j(D,R,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],Q([0,1,33,87,88]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class I extends R.AbstractNativeEnvironmentService{constructor(P,c){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(P)},c)}}i.NativeEnvironmentService=I}),define(Y[90],Q([0,1,22]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function b(I,L){const P=c=>{if(typeof c!="string")return;const v=R.exec(c);if(!v)return;const C=L[v[1]]??c;return typeof C=="string"?C:typeof C.message=="string"?C.message:c};return(0,D.cloneAndChange)(I,P)}i.localizeManifest=b}),define(Y[48],Q([0,1,80]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function I(d){return d=d.trim(),d==="*"||R.test(d)}i.isValidVersionStr=I;function L(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(R);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}i.parseVersion=L;function P(d){if(!d)return null;let y=d.majorBase,w=d.majorMustEqual,g=d.minorBase,a=d.minorMustEqual,f=d.patchBase,p=d.patchMustEqual;d.hasCaret&&(y===0||(a=!1),p=!1);let E=0;if(d.preRelease){const m=b.exec(d.preRelease);if(m){const[,o,t,r]=m;E=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:y,majorMustEqual:w,minorBase:g,minorMustEqual:a,patchBase:f,patchMustEqual:p,isMinimum:d.hasGreaterEquals,notBefore:E}}i.normalizeVersion=P;function c(d,y,w){let g;typeof d=="string"?g=P(L(d)):g=d;let a;y instanceof Date?a=y.getTime():typeof y=="string"&&(a=new Date(y).getTime());let f;if(typeof w=="string"?f=P(L(w)):f=w,!g||!f)return!1;let p=g.majorBase,E=g.minorBase,m=g.patchBase,o=f.majorBase,t=f.minorBase,r=f.patchBase,e=f.notBefore,n=f.majorMustEqual,s=f.minorMustEqual,l=f.patchMustEqual;return f.isMinimum?p>o?!0:p<o?!1:E>t?!0:E<t||a&&a<e?!1:m>=r:(p===1&&o===0&&(!n||!s||!l)&&(o=1,t=0,r=0,n=!0,s=!1,l=!1),p<o?!1:p>o?!n:E<t?!1:E>t?!s:m<r?!1:m>r?!l:!(a&&a<e))}i.isValidVersion=c;function v(d,y,w,g){return w.isBuiltin||typeof w.main=="undefined"?!0:T(d,y,w.engines.vscode,g)}i.isValidExtensionVersion=v;function C(d,y,w){return d==="*"||T(y,w,d)}i.isEngineValid=C;function T(d,y,w,g=[]){let a=P(L(w));if(!a)return g.push(D.localize(0,null,w)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(D.localize(1,null,w)),!1}else if(!a.majorMustEqual)return g.push(D.localize(2,null,w)),!1;return c(d,y,a)?!0:(g.push(D.localize(3,null,d,w)),!1)}}),define(Y[91],Q([0,1,17,27]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(I,L,P){let c=P&&P.get("storage.serviceMachineId",0)||null;if(c)return c;try{const C=(await L.readFile(I.serviceMachineIdResource)).value.toString();c=(0,R.isUUID)(C)?C:null}catch{c=null}if(!c){c=(0,R.generateUuid)();try{await L.writeFile(I.serviceMachineIdResource,D.VSBuffer.fromString(c))}catch{}}return P&&P.store("storage.serviceMachineId",c,0,1),c}i.getServiceMachineId=b}),define(Y[40],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(b,I=[],L=!1){this.ctor=b,this.staticArguments=I,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=D}),define(Y[92],Q([0,1,40]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const R=[];function b(L,P,c){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],c)),R.push([L,P])}i.registerSingleton=b;function I(){return R}i.getSingletonServiceDescriptors=I}),define(Y[93],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}i.Node=D;class R{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let L of this._nodes.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const P=this.lookupOrInsertNode(I),c=this.lookupOrInsertNode(L);P.outgoing.set(this._hashFn(L),c),c.incoming.set(this._hashFn(I),P)}removeNode(I){const L=this._hashFn(I);this._nodes.delete(L);for(let P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(I){const L=this._hashFn(I);let P=this._nodes.get(L);return P||(P=new D(I),this._nodes.set(L,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[L,P]of this._nodes)I.push(`${L}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,L]of this._nodes){const P=new Set([I]),c=this._findCycle(L,P);if(c)return c}}_findCycle(I,L){for(let[P,c]of I.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const v=this._findCycle(c,L);if(v)return v;L.delete(P)}}}i.Graph=R}),define(Y[25],Q([0,1,6,9,13]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function I(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}i.isConfigurationOverrides=I;function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||D.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=L;var P;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(P=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=c;function v(a,f){const p=Object.create(null);for(let E in a)C(p,E,a[E],f);return p}i.toValuesTree=v;function C(a,f,p,E){const m=f.split("."),o=m.pop();let t=a;for(let r=0;r<m.length;r++){let e=m[r],n=t[e];switch(typeof n){case"undefined":n=t[e]=Object.create(null);break;case"object":break;default:E(`Ignoring ${f} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[o]=p}catch{E(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(t)}`)}i.addToValueTree=C;function T(a,f){const p=f.split(".");d(a,p)}i.removeFromValueTree=T;function d(a,f){const p=f.shift();if(f.length===0){delete a[p];return}if(Object.keys(a).indexOf(p)!==-1){const E=a[p];typeof E=="object"&&!Array.isArray(E)&&(d(E,f),Object.keys(E).length===0&&delete a[p])}}function y(a,f,p){function E(t,r){let e=t;for(const n of r){if(typeof e!="object"||e===null)return;e=e[n]}return e}const m=f.split("."),o=E(a,m);return typeof o=="undefined"?p:o}i.getConfigurationValue=y;function w(a,f,p){Object.keys(f).forEach(E=>{E!=="__proto__"&&(E in a?D.isObject(a[E])&&D.isObject(f[E])?w(a[E],f[E],p):p&&(a[E]=f[E]):a[E]=f[E])})}i.merge=w;function g(a,f,p){const E=a.inspect(f),m=a.inspect(p);return typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:E.defaultValue}i.getMigratedSettingValue=g}),define(Y[49],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Y[20],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Y[50],Q([0,1,17,8,82,16]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(C,T,d,y,w,g){let a;try{await P(C,T,d,y,w,g)}catch(f){a=f}finally{a&&w.errorTransformer&&(a=w.errorTransformer(a)),typeof a!="undefined"&&d.error(a),d.end()}}i.readFileIntoStream=L;async function P(C,T,d,y,w,g){c(g);const a=await C.open(T,{create:!1});try{c(g);let f=0,p=0,E=w&&typeof w.length=="number"?w.length:void 0,m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof E=="number"?E:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,t=0;do p=await C.read(a,o,m.buffer,t,m.byteLength-t),o+=p,t+=p,f+=p,typeof E=="number"&&(E-=p),t===m.byteLength&&(await d.write(y(m)),m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof E=="number"?E:w.bufferSize)),t=0);while(p>0&&(typeof E!="number"||E>0)&&c(g)&&v(f,w));if(t>0){let r=t;typeof E=="number"&&(r=Math.min(t,E)),d.write(y(m.slice(0,r)))}}catch(f){throw(0,I.ensureFileSystemProviderError)(f)}finally{await C.close(a)}}function c(C){if(C.isCancellationRequested)throw(0,R.canceled)();return!0}function v(C,T){if(T?.limits){if(typeof T.limits.memory=="number"&&C>T.limits.memory)throw(0,I.createFileSystemProviderError)((0,b.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&C>T.limits.size)throw(0,I.createFileSystemProviderError)((0,b.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[94],Q([0,1,18,7,2,12,134]),function(j,i,D,R,b,I,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class P extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const C=this.normalizeRequests(v),T=C.filter(y=>{const w=this.watchers.get(y.path);return w?!(0,D.equals)(w.request.excludes,y.excludes):!0}),d=Array.from(this.watchers.values()).filter(({request:y})=>!C.find(w=>w.path===y.path&&(0,D.equals)(w.excludes,y.excludes))).map(({request:y})=>y.path);T.length&&this.trace(`Request to start watching: ${T.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const y of d)this.stopWatching(y);for(const y of T)this.startWatching(y)}startWatching(v){const C=new L.NodeJSFileWatcherLibrary(v,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),T={request:v,instance:C};this.watchers.set(v.path,T)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const C=this.watchers.get(v);C&&(this.watchers.delete(v),C.instance.dispose())}normalizeRequests(v){const C=new Map;for(const T of v){const d=I.isLinux?T.path:T.path.toLowerCase();C.set(d,T)}return Array.from(C.values())}async setVerboseLogging(v){this.verboseLogging=v;for(const[,C]of this.watchers)C.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,C){return C?`[File Watcher (node.js)] ${v} (path: ${C.request.path})`:`[File Watcher (node.js)] ${v}`}}i.NodeJSWatcher=P}),define(Y[95],Q([0,1,51,94]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,c){super(L,P,c);this.init()}createWatcher(){return new R.NodeJSWatcher}}i.NodeJSWatcherClient=b}),define(Y[96],Q([0,1,10,46,71,51]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends I.AbstractUniversalWatcherClient{constructor(c,v,C){super(c,v,C);this.init()}createWatcher(c){const v=c.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(v.onDidProcessExit(({code:C,signal:T})=>this.onError(`terminated by itself with code ${C}, signal: ${T}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(v.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Y[52],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(let[I,L]of b)this.set(I,L)}set(b,I){const L=this._entries.get(b);return this._entries.set(b,I),L}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=D}),define(Y[97],Q([0,1,3,8,40,93,13,52]),function(j,i,D,R,b,I,L,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const c=!1;class v extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class C{constructor(w=new P.ServiceCollection,g=!1,a){this._activeInstantiations=new Set,this._services=w,this._strict=g,this._parent=a,this._services.set(L.IInstantiationService,this)}createChild(w){return new C(w,this._strict,this)}invokeFunction(w,...g){let a=d.traceInvocation(w),f=!1;try{return w({get:E=>{if(f)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(E,a);if(!m)throw new Error(`[invokeFunction] unknown service '${E}'`);return m}},...g)}finally{f=!0,a.stop()}}createInstance(w,...g){let a,f;return w instanceof b.SyncDescriptor?(a=d.traceCreation(w.ctor),f=this._createInstance(w.ctor,w.staticArguments.concat(g),a)):(a=d.traceCreation(w),f=this._createInstance(w,g,a)),a.stop(),f}_createInstance(w,g=[],a){let f=L._util.getServiceDependencies(w).sort((m,o)=>m.index-o.index),p=[];for(const m of f){let o=this._getOrCreateServiceInstance(m.id,a);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${m.id}.`,!1),p.push(o)}let E=f.length>0?f[0].index:g.length;if(g.length!==E){console.warn(`[createInstance] First service dependency of ${w.name} at position ${E+1} conflicts with ${g.length} static arguments`);let m=E-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,E)}return new w(...[...g,...p])}_setServiceInstance(w,g){if(this._services.get(w)instanceof b.SyncDescriptor)this._services.set(w,g);else if(this._parent)this._parent._setServiceInstance(w,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){let g=this._services.get(w);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):g}_getOrCreateServiceInstance(w,g){let a=this._getServiceInstanceOrDescriptor(w);return a instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,a,g.branch(w,!0)):(g.branch(w,!1),a)}_safeCreateAndCacheServiceInstance(w,g,a){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,g,a)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,g,a){const f=new I.Graph(m=>m.id.toString());let p=0;const E=[{id:w,desc:g,_trace:a}];for(;E.length;){const m=E.pop();if(f.lookupOrInsertNode(m),p++>1e3)throw new v(f);for(let o of L._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),t instanceof b.SyncDescriptor){const r={id:o.id,desc:t,_trace:m._trace.branch(o.id,!0)};f.insertEdge(m,r),E.push(r)}}}for(;;){const m=f.roots();if(m.length===0){if(!f.isEmpty())throw new v(f);break}for(const{data:o}of m){if(this._getServiceInstanceOrDescriptor(o.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,g,a=[],f,p){if(this._services.get(w)instanceof b.SyncDescriptor)return this._createServiceInstance(g,a,f,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,g,a,f,p);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(w,g=[],a,f){if(a){const p=new D.IdleValue(()=>this._createInstance(w,g,f));return new Proxy(Object.create(null),{get(E,m){if(m in E)return E[m];let o=p.value,t=o[m];return typeof t!="function"||(t=t.bind(o),E[m]=t),t},set(E,m,o){return p.value[m]=o,!0}})}else return this._createInstance(w,g,f)}_throwIfStrict(w,g){if(g&&console.warn(g),this._strict)throw new Error(w)}}i.InstantiationService=C;var T;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(T||(T={}));class d{constructor(w,g){this.type=w,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return c?new d(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(w){return c?new d(0,w.name):d._None}branch(w,g){let a=new d(2,w.toString());return this._dep.push([w,g,a]),a}stop(){let w=Date.now()-this._start;d._totals+=w;let g=!1;function a(p,E){let m=[],o=new Array(p+1).join("	");for(const[t,r,e]of E._dep)if(r&&e){g=!0,m.push(`${o}CREATES -> ${t}`);let n=a(p+1,e);n&&m.push(n)}else m.push(`${o}uses -> ${t}`);return m.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(w>2||g)&&console.log(f.join(`
`))}}i.Trace=d,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Y[53],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,D.createDecorator)("localizationsService");function R(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const I of b.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=R}),define(Y[14],Q([0,1,28,7,2,12,13]),function(j,i,D,R,b,I,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function P(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function v(r,e,n){switch(e){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=v;function C(r){let e="";for(let n=0;n<r.length;n++){let s=r[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(n>0?" ":"")+s}return e}i.format=C;class T extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=T;class d extends T{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,C([e,...n]))}debug(e,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,C([e,...n]))}info(e,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,C([e,...n]))}warn(e,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,C([e,...n]))}error(e,...n){if(this.checkLogLevel(c.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(c.Error,C(s))}else this.log(c.Error,C([e,...n]))}critical(e,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,C([e,...n]))}flush(){}}i.AbstractMessageLogger=d;class y extends T{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,e,...n):console.log(`[main ${P()}]`,e,...n))}debug(e,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,e,...n):console.log(`[main ${P()}]`,e,...n))}info(e,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,e,...n):console.log(`[main ${P()}]`,e,...n))}warn(e,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,e,...n):console.warn(`[main ${P()}]`,e,...n))}error(e,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,e,...n):console.error(`[main ${P()}]`,e,...n))}critical(e,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,e,...n):console.error(`[main ${P()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=y;class w extends T{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=w;class g extends T{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,D.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class a extends T{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const s of this.logServices)s.trace(e,...n)}debug(e,...n){for(const s of this.logServices)s.debug(e,...n)}info(e,...n){for(const s of this.logServices)s.info(e,...n)}warn(e,...n){for(const s of this.logServices)s.warn(e,...n)}error(e,...n){for(const s of this.logServices)s.error(e,...n)}critical(e,...n){for(const s of this.logServices)s.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=a;class f extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=f;class p extends b.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,n?.always?c.Trace:this.logLevel,n),this.loggers.set(e.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=p;class E{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=E;function m(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=o(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=m;function o(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=o;function t(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=t});var oe=this&&this.__param||function(j,i){return function(D,R){i(D,R,j)}};define(Y[98],Q([0,1,39,3,28,7,2,10,11,15,20,14]),function(j,i,D,R,b,I,L,P,c,v,C,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let d=class extends L.Disposable{constructor(w,g){super();this.environmentService=w,this.logService=g,this.processesLimiter=new R.Limiter(5)}async postUninstall(w){const g=this.parseScript(w,"uninstall");return g&&(this.logService.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,w).then(()=>this.logService.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),a=>this.logService.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${a}`)))),v.Promises.rm(this.getExtensionStoragePath(w)).then(void 0,a=>this.logService.error("Error while removing extension storage path",a))}parseScript(w,g){const a=`vscode:${g}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[a]=="string"){const f=w.manifest.scripts[a].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(w.identifier.id,w.manifest.version,`${a} should be a node script`),null):{script:(0,c.join)(w.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(w,g,a,f,p){return new Promise((E,m)=>{const o=this.start(w,g,a,p);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?m(e):E(void 0)};o.on("error",e=>{r((0,b.toErrorMessage)(e)||"Unknown")}),o.on("exit",(e,n)=>{r(e?`post-${g} process exited with code ${e}`:void 0)}),f&&(t=setTimeout(()=>{t=null,o.kill(),m("timed out")},5e3))})}start(w,g,a,f){const p={silent:!0,execArgv:void 0},E=(0,D.fork)(w,[`--type=extension-post-${g}`,...a],p);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const m=I.Event.fromNodeEventEmitter(E.stdout,"data"),o=I.Event.fromNodeEventEmitter(E.stderr,"data");m(e=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,e)),o(e=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,e));const t=I.Event.any(I.Event.map(m,e=>({data:`%c${e}`,format:[""]})),I.Event.map(o,e=>({data:`%c${e}`,format:["color: red"]})));return I.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(f.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),E}getExtensionStoragePath(w){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};d=ge([oe(0,C.IEnvironmentService),oe(1,T.ILogService)],d),i.ExtensionsLifecycle=d}),define(Y[99],Q([0,1,18,3,8,7,2,11,51,14]),function(j,i,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class C extends L.Disposable{constructor(d,y){super();this.logService=d,this.options=y,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(d,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,y):this.watchNonRecursive(d,y)}watchUniversal(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:y.recursive},g=(0,D.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,c.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const y of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const y of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(y)&&d.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:!1},g=(0,D.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,c.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}i.AbstractDiskFileSystemProvider=C}),define(Y[100],Q([0,1,18,3,17,24,7,59,135,2,54,10,101,19,38,81,16,50,14]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a,f,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let E=class extends v.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(o,t){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const r=new v.DisposableStore;return this.provider.set(o,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:t}),r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new a.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:o}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:t}),this.provider.delete(o),(0,v.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){t.push(r)}}),!this.provider.has(o)&&await R.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,t){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return c.Iterable.map(this.provider,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async withProvider(o){if(!(0,y.isAbsolutePath)(o))throw new a.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const t=this.provider.get(o.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,o.toString()),r}return t}async withReadProvider(o){const t=await this.withProvider(o);if((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t)||(0,a.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const t=await this.withProvider(o);if((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.doResolveFile(o,t)}catch(r){throw(0,a.toFileSystemProviderErrorCode)(r)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,a.ensureFileSystemProviderError)(r)}}async doResolveFile(o,t){const r=await this.withProvider(o),e=this.isPathCaseSensitive(r),n=t?.resolveTo,s=t?.resolveSingleChildDescendants,l=t?.resolveMetadata,u=await r.stat(o);let h;return this.toFileStat(r,o,u,void 0,!!l,(S,O)=>(h||(h=C.TernarySearchTree.forUris(()=>!e),h.set(o,!0),n&&h.fill(!0,n)),h.get(S.resource)||h.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&s?O===1:!1))}async toFileStat(o,t,r,e,n,s){const{providerExtUri:l}=this.getExtUri(o),u={resource:t,name:l.basename(t),isFile:(r.type&a.FileType.File)!=0,isDirectory:(r.type&a.FileType.Directory)!=0,isSymbolicLink:(r.type&a.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&a.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,a.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(u.isDirectory&&s(u,e)){try{const h=await o.readdir(t),S=await R.Promises.settled(h.map(async([O,N])=>{try{const _=l.joinPath(t,O),J=n?await o.stat(_):{type:N};return await this.toFileStat(o,_,J,h.length,n,s)}catch(_){return this.logService.trace(_),null}}));u.children=(0,D.coalesce)(S)}catch(h){this.logService.trace(h),u.children=[]}return u}return u}async resolveAll(o){return R.Promises.settled(o.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.withProvider(o),r=await t.stat(o);return this.toFileStat(t,o,r,void 0,!0,()=>!1)}async exists(o){const t=await this.withProvider(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.doValidateCreateFile(o,t)}catch(r){return r}return!0}async doValidateCreateFile(o,t){if(!t?.overwrite&&await this.exists(o))throw new a.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,t)}async createFile(o,t=b.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const e=await this.writeFile(o,t);return this._onDidRunOperation.fire(new a.FileOperationEvent(o,0,e)),e}async writeFile(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(e);try{await this.validateWriteFile(e,o,r)||await this.mkdirp(e,n.dirname(o));let l;if((0,a.hasReadWriteCapability)(e)&&!(t instanceof b.VSBuffer))if((0,w.isReadableStream)(t)){const u=await(0,w.peekStream)(t,3);u.ended?l=b.VSBuffer.concat(u.buffer):l=u}else l=(0,w.peekReadable)(t,u=>b.VSBuffer.concat(u),3);else l=t;!(0,a.hasOpenReadWriteCloseCapability)(e)||(0,a.hasReadWriteCapability)(e)&&l instanceof b.VSBuffer?await this.doWriteUnbuffered(e,o,r,l):await this.doWriteBuffered(e,o,r,l instanceof b.VSBuffer?(0,b.bufferToReadable)(l):l),this._onDidRunOperation.fire(new a.FileOperationEvent(o,4))}catch(s){throw new a.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,t,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(t)));let n;try{n=await o.stat(t)}catch{return}if((n.type&a.FileType.Directory)!=0)throw new a.FileOperationError((0,g.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==a.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,a.etag)({mtime:r.mtime,size:n.size}))throw new a.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(o,t,r){const e=await this.withReadProvider(o);return t?.atomic?this.doReadFileAtomic(e,o,t,r):this.doReadFile(e,o,t,r)}async doReadFileAtomic(o,t,r,e){return new Promise((n,s)=>{this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(o,t,r,e);n(l)}catch(l){s(l)}})})}async doReadFile(o,t,r,e){const n=await this.doReadFileStream(o,t,{...r,preferUnbuffered:!0},e);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(o,t,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,t,r)}async doReadFileStream(o,t,r,e){const n=new I.CancellationTokenSource(e),s=this.validateReadFile(t,r).then(u=>u,u=>{throw n.cancel(),u});let l;try{return typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&await s,r?.atomic&&(0,a.hasFileAtomicReadCapability)(o)||!((0,a.hasOpenReadWriteCloseCapability)(o)||(0,a.hasFileReadStreamCapability)(o))||(0,a.hasReadWriteCapability)(o)&&r?.preferUnbuffered?l=this.readFileUnbuffered(o,t,r):(0,a.hasFileReadStreamCapability)(o)?l=this.readFileStreamed(o,t,n.token,r):l=this.readFileBuffered(o,t,n.token,r),{...await s,value:l}}catch(u){l&&await(0,w.consumeStream)(l);const h=(0,g.localize)(8,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(u).toString());throw u instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(h,u.stat,r):new a.FileOperationError(h,(0,a.toFileOperationResult)(u),r)}}readFileStreamed(o,t,r,e=Object.create(null)){const n=o.readFileStream(t,e,r);return(0,w.transform)(n,{data:s=>s instanceof b.VSBuffer?s:b.VSBuffer.wrap(s),error:s=>new a.FileOperationError((0,g.localize)(9,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),e)},s=>b.VSBuffer.concat(s))}readFileBuffered(o,t,r,e=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,f.readFileIntoStream)(o,t,n,s=>s,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new a.FileOperationError((0,g.localize)(10,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),e)},r),n}readFileUnbuffered(o,t,r){const e=(0,w.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,a.hasFileAtomicReadCapability)(o)?n=await o.readFile(t,{atomic:!0}):n=await o.readFile(t),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(t,n.byteLength,r),e.end(b.VSBuffer.wrap(n))}catch(n){e.error(n),e.end()}})(),e}async validateReadFile(o,t){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new a.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&t.etag===r.etag)throw new a.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,t);return this.validateReadFileLimits(o,r.size,t),r}validateReadFileLimits(o,t,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&t>r.limits.size&&(e=7),typeof e=="number")throw new a.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),e)}}async canMove(o,t,r){return this.doCanMoveCopy(o,t,"move",r)}async canCopy(o,t,r){return this.doCanMoveCopy(o,t,"copy",r)}async doCanMoveCopy(o,t,r,e){if(o.toString()!==t.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,o,s,t,r,e)}catch(n){return n}return!0}async move(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"move",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,t,r){const e=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"copy",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,t,r,e,n,s){if(t.toString()===e.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,t,r,e,n,s);if(l&&!u&&s&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),n==="copy"){if(o===r&&(0,a.hasFileFolderCopyCapability)(o))await o.copy(t,e,{overwrite:s});else{const h=await this.resolve(t);h.isDirectory?await this.doCopyFolder(o,h,r,e):await this.doCopyFile(o,t,r,e)}return n}else return o===r?(await o.rename(t,e,{overwrite:s}),n):(await this.doMoveCopy(o,t,r,e,"copy",s),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(o,t,r,e){if((0,a.hasOpenReadWriteCloseCapability)(o)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,t,r,e);if((0,a.hasOpenReadWriteCloseCapability)(o)&&(0,a.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,t,r,e);if((0,a.hasReadWriteCapability)(o)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,t,r,e);if((0,a.hasReadWriteCapability)(o)&&(0,a.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,t,r,e)}async doCopyFolder(o,t,r,e){await r.mkdir(e),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async n=>{const s=this.getExtUri(r).providerExtUri.joinPath(e,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),r,s):this.doCopyFile(o,n.resource,r,s)}))}async doValidateMoveCopy(o,t,r,e,n,s){let l=!1;if(o===r){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(l=h.isEqual(t,e)),l&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(t),this.resourceForError(e)));if(!l&&h.isEqualOrParent(e,t))throw new Error((0,g.localize)(15,null,this.resourceForError(t),this.resourceForError(e)))}const u=await this.exists(e);if(u&&!l){if(!s)throw new a.FileOperationError((0,g.localize)(16,null,this.resourceForError(t),this.resourceForError(e)),4);if(o===r){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(t,e))throw new Error((0,g.localize)(17,null,this.resourceForError(t),this.resourceForError(e)))}}return{exists:u,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const t=this.isPathCaseSensitive(o);return{providerExtUri:t?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(t,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,0,r)),r}async mkdirp(o,t){const r=[],{providerExtUri:e}=this.getExtUri(o);for(;!e.isEqual(t,e.dirname(t));)try{if(((await o.stat(t)).type&a.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(t)));break}catch(n){if((0,a.toFileSystemProviderErrorCode)(n)!==a.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(e.basename(t)),t=e.dirname(t)}for(let n=r.length-1;n>=0;n--){t=e.joinPath(t,r[n]);try{await o.mkdir(t)}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,t){try{await this.doValidateDelete(o,t)}catch(r){return r}return!0}async doValidateDelete(o,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new a.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!t?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return r}async del(o,t){const r=await this.doValidateDelete(o,t),e=!!t?.useTrash,n=!!t?.recursive;await r.delete(o,{recursive:n,useTrash:e}),this._onDidRunOperation.fire(new a.FileOperationEvent(o,1))}watch(o,t={recursive:!1,excludes:[]}){const r=new v.DisposableStore;let e=!1,n=()=>{e=!0};return r.add((0,v.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(o,t);e?(0,v.dispose)(s):n=()=>(0,v.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,t){const r=await this.withProvider(o),e=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),t]);let n=this.activeWatchers.get(e);return n||(n={count:0,disposable:r.watch(o,t)},this.activeWatchers.set(e,n)),n.count+=1,(0,v.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,v.dispose)(n.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,v.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,w.isReadableStream)(e)||(0,w.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,n,e):await this.doWriteReadableBufferedQueued(o,n,e)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,t,r){let e=0,n;if((0,w.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=b.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,t,s,s.byteLength,e,0),e+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,l)=>{(0,w.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(o,t,u,u.byteLength,e,0)}catch(h){return l(h)}e+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>l(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,t,r){let e=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(o,t,n,n.byteLength,e,0),e+=n.byteLength}async doWriteBuffer(o,t,r,e,n,s){let l=0;for(;l<e;)l+=await o.write(t,n+l,r.buffer,s+l,e-l)}async doWriteUnbuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,t,r,e))}async doWriteUnbufferedQueued(o,t,r,e){let n;e instanceof b.VSBuffer?n=e:(0,w.isReadableStream)(e)?n=await(0,b.streamToBuffer)(e):(0,w.isReadableBufferedStream)(e)?n=await(0,b.bufferedStreamToBuffer)(e):n=(0,b.readableToBuffer)(e),await o.writeFile(t,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,t,r,e))}async doPipeBufferedQueued(o,t,r,e){let n,s;try{n=await o.open(t,{create:!1}),s=await r.open(e,{create:!0,unlock:!1});const l=b.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,h=0,S=0;do S=await o.read(n,u,l.buffer,h,l.byteLength-h),await this.doWriteBuffer(r,s,l,S,u,h),u+=S,h+=S,h===l.byteLength&&(h=0);while(S>0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await R.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,t,r,e))}async doPipeUnbufferedQueued(o,t,r,e){return r.writeFile(e,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,t,r,e))}async doPipeUnbufferedToBufferedQueued(o,t,r,e){const n=await r.open(e,{create:!0,unlock:!1});try{const s=await o.readFile(t);await this.doWriteBuffer(r,n,b.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(o,t,r,e){const n=await(0,b.streamToBuffer)(this.readFileBuffered(o,t,I.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,n)}throwIfFileSystemIsReadonly(o,t){if(o.capabilities&2048)throw new a.FileOperationError((0,g.localize)(22,null,this.resourceForError(t)),6);return o}throwIfFileIsReadonly(o,t){if((t.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===T.Schemas.file?o.fsPath:o.toString(!0)}};E=ge([oe(0,p.ILogService)],E),i.FileService=E}),define(Y[102],Q([0,1,103,136,3,54,17,7,45,2,11,12,19,38,15,83,16,50,99,28,96,95]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a,f,p,E,m,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(r)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(e,n){super(e,n);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new I.ResourceMap(s=>d.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(e){try{const n=await w.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async l=>{try{let u;l.isSymbolicLink()?u=(await this.stat((0,d.joinPath)(e,l.name))).type:u=this.toType(l),s.push([l.name,u])}catch(u){this.logService.trace(u)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(e,n){let s;return n?.dangling?s=a.FileType.Unknown:e.isFile()?s=a.FileType.File:e.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,n&&(s|=a.FileType.SymbolicLink),s}async createResourceLock(e){const n=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const l=new b.Barrier;return this.resourceLocks.set(e,l),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(e)===l&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(e,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const l=this.toFilePath(e);return await w.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}readFileStream(e,n,s){const l=(0,y.newWriteableStream)(u=>L.VSBuffer.concat(u.map(h=>L.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,e,l,u=>u.buffer,{...n,bufferSize:256*1024},s),l}async writeFile(e,n,s){let l;try{const u=this.toFilePath(e);if(!s.create||!s.overwrite){if(await w.Promises.exists(u)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,g.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,g.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(e,u)}finally{typeof l=="number"&&await this.close(l)}}async open(e,n){const s=this.toFilePath(e);let l;(0,a.isFileOpenForWriteOptions)(n)&&(l=await this.createResourceLock(e));let u;try{if((0,a.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await w.SymlinkSupport.stat(s);S.mode&128||await w.Promises.chmod(s,S.mode|128)}catch(S){this.logService.trace(S)}let h;if((0,a.isFileOpenForWriteOptions)(n)){if(T.isWindows)try{await w.Promises.truncate(s,0),h="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}h||(h="w")}else h="r";u=await w.Promises.open(s,h)}catch(h){throw l?.dispose(),(0,a.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(e,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(u,0),(0,a.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(u,e),l){const h=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,l),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),h.dispose())}return u}async close(e){const n=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await w.Promises.fdatasync(e)}catch(s){this.canFlush=!1,this.logService.error(s)}return await w.Promises.close(e)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(e)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),n.dispose())}}async read(e,n,s,l,u){const h=this.normalizePos(e,n);let S=null;try{S=(await w.Promises.read(e,s,l,u,h)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(e,h,S)}return S}normalizePos(e,n){return n===this.mapHandleToPos.get(e)?null:n}updatePos(e,n,s){const l=this.mapHandleToPos.get(e);typeof l=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,l+s):this.mapHandleToPos.delete(e)))}async write(e,n,s,l,u){return(0,b.retry)(()=>this.doWrite(e,n,s,l,u),100,3)}async doWrite(e,n,s,l,u){const h=this.normalizePos(e,n);let S=null;try{S=(await w.Promises.write(e,s,l,u,h)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),O)}finally{this.updatePos(e,h,S)}return S}async mkdir(e){try{await w.Promises.mkdir(this.toFilePath(e))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(e,n){try{const s=this.toFilePath(e);n.recursive?await w.Promises.rm(s,w.RimRafMode.MOVE):await w.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n);if(l!==u)try{await this.validateTargetDeleted(e,n,"move",s.overwrite),await w.Promises.move(l,u)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(2,null,(0,C.basename)(l),(0,C.basename)((0,C.dirname)(u)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n);if(l!==u)try{await this.validateTargetDeleted(e,n,"copy",s.overwrite),await w.Promises.copy(l,u,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(3,null,(0,C.basename)(l),(0,C.basename)((0,C.dirname)(u)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(e,n,s,l){const u=this.toFilePath(e),h=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,c.isEqual)(u,h,!0)),S&&s==="copy")throw(0,a.createFileSystemProviderError)((0,g.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!S&&await w.Promises.exists(h)){if(!l)throw(0,a.createFileSystemProviderError)((0,g.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(e,n,s){return new m.UniversalWatcherClient(l=>e(l),l=>n(l),s)}createNonRecursiveWatcher(e,n,s){return new o.NodeJSWatcherClient(l=>e(l),l=>n(l),s)}toFileSystemProviderError(e){if(e instanceof a.FileSystemProviderError)return e;let n;switch(e.code){case"ENOENT":n=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=a.FileSystemProviderErrorCode.NoPermissions;break;default:n=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(e,n){let s=this.toFileSystemProviderError(n);if(e&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await w.SymlinkSupport.stat(this.toFilePath(e));l.mode&128||(s=(0,a.createFileSystemProviderError)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}i.DiskFileSystemProvider=t}),define(Y[104],Q([0,1,16,14]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(P,c,v,C,T){try{const d=await new Promise((w,g)=>{j(["spdlog"],w,g)});d.setFlushOn(R.LogLevel.Trace);const y=await d.createAsyncRotatingLogger(P,c,v,C);return T&&y.clearFormatters(),y}catch(d){console.error(d)}return null}function I(P,c,v){switch(c){case R.LogLevel.Trace:P.trace(v);break;case R.LogLevel.Debug:P.debug(v);break;case R.LogLevel.Info:P.info(v);break;case R.LogLevel.Warning:P.warn(v);break;case R.LogLevel.Error:P.error(v);break;case R.LogLevel.Critical:P.critical(v);break;default:throw new Error("Invalid log level")}}class L extends R.AbstractMessageLogger{constructor(c,v,C,T,d){super();this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(c,v,C,T),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(c,v,C,T){const d=C?6:1,y=30/d*D.ByteSize.MB,w=await b(c,v,y,d,T);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:g,message:a}of this.buffer)I(this._logger,g,a);this.buffer=[]}}log(c,v){this._logger?I(this._logger,c,v):this.getLevel()<=c&&this.buffer.push({level:c,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Y[32],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Y[30],Q([0,1,55,6]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(L,P){D.ok(R.isString(L)),D.ok(R.isObject(P)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new b}),define(Y[105],Q([0,1,7,30]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,v){this.schemasById[b(c)]=v,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new I;R.Registry.add(i.Extensions.JSONContribution,L)}),define(Y[34],Q([0,1,18,7,6,73,105,30]),function(j,i,D,R,b,I,L,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var c;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(c=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var v;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=P.Registry.as(L.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,t=!0){this.registerConfigurations([o],t)}registerConfigurations(o,t=!0){const r=this.doRegisterConfigurations(o,t);C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const t=this.doDeregisterConfigurations(o);C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:o,remove:t}){const r=[];r.push(...this.doDeregisterConfigurations(t)),r.push(...this.doRegisterConfigurations(o,!1)),C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(r)})}registerDefaultConfigurations(o){const t=[],r=[];for(const{overrides:e,source:n}of o)for(const s in e)if(t.push(s),i.OVERRIDE_PROPERTY_REGEX.test(s)){const l={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:l});const u={type:"object",default:l,description:I.localize(1,null,s),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:b.isString(n)?void 0:n};r.push(...w(s)),this.configurationProperties[s]=u,this.defaultLanguageConfigurationOverridesNode.properties[s]=u}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:n});const l=this.configurationProperties[s];l&&(this.updatePropertyDefaultValue(s,l),this.updateSchema(s,l))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const t=[];for(const{overrides:r,source:e}of o)for(const n in r){const s=this.configurationDefaultsOverrides.get(n),l=b.isString(e)?e:e?.id,u=b.isString(s?.source)?s?.source:s?.source?.id;if(l===u)if(t.push(n),this.configurationDefaultsOverrides.delete(n),i.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const t of o)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,t){const r=[];return o.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,t,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(o){const t=[],r=e=>{if(e.properties)for(const n in e.properties)t.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>r(n))};for(const e of o){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return t}validateAndRegisterProperties(o,t=!0,r,e,n=3){n=b.isUndefinedOrNull(o.scope)?n:o.scope;let s=[],l=o.properties;if(l)for(let h in l){if(t&&p(h)){delete l[h];continue}const S=l[h];if(S.source=r,S.defaultDefaultValue=l[h].default,this.updatePropertyDefaultValue(h,S),i.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=b.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=b.isUndefinedOrNull(S.restricted)?!!e?.includes(h):S.restricted),l[h].hasOwnProperty("included")&&!l[h].included){this.excludedConfigurationProperties[h]=l[h],delete l[h];continue}else this.configurationProperties[h]=l[h];!l[h].deprecationMessage&&l[h].markdownDeprecationMessage&&(l[h].deprecationMessage=l[h].markdownDeprecationMessage),s.push(h)}let u=o.allOf;if(u)for(let h of u)s.push(...this.validateAndRegisterProperties(h,t,r,e,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const t=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let n=r.allOf;n&&n.forEach(t)};t(o)}updateSchema(o,t){switch(i.allSettings.properties[o]=t,t.scope){case 1:i.applicationSettings.properties[o]=t;break;case 2:i.machineSettings.properties[o]=t;break;case 6:i.machineOverridableSettings.properties[o]=t;break;case 3:i.windowSettings.properties[o]=t;break;case 4:i.resourceSettings.properties[o]=t;break;case 5:i.resourceSettings.properties[o]=t,this.resourceLanguageSettingsSchema.properties[o]=t;break}}removeFromSchema(o,t){switch(delete i.allSettings.properties[o],t.scope){case 1:delete i.applicationSettings.properties[o];break;case 2:delete i.machineSettings.properties[o];break;case 6:delete i.machineOverridableSettings.properties[o];break;case 3:delete i.windowSettings.properties[o];break;case 4:case 5:delete i.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const t=`[${o}]`,r={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,r),i.allSettings.properties[t]=r,i.applicationSettings.properties[t]=r,i.machineSettings.properties[t]=r,i.machineOverridableSettings.properties[t]=r,i.windowSettings.properties[t]=r,i.resourceSettings.properties[t]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,t){const r=this.configurationDefaultsOverrides.get(o);let e=r?.value,n=r?.source;b.isUndefined(e)&&(e=t.defaultDefaultValue,n=void 0),b.isUndefined(e)&&(e=a(t.type)),t.default=e,t.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function w(m){const o=[];if(i.OVERRIDE_PROPERTY_REGEX.test(m)){let t=y.exec(m);for(;t?.length;){const r=t[1].trim();r&&o.push(r),t=y.exec(m)}}return(0,D.distinct)(o)}i.overrideIdentifiersFromKey=w;function g(m){return m.reduce((o,t)=>`${o}[${t}]`,"")}i.keyFromOverrideIdentifiers=g;function a(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const f=new T;P.Registry.add(i.Extensions.Configuration,f);function p(m){return m.trim()?i.OVERRIDE_PROPERTY_REGEX.test(m)?I.localize(7,null,m):f.getConfigurationProperties()[m]!==void 0?I.localize(8,null,m):null:I.localize(6,null)}i.validateProperty=p;function E(){const m=[],o=f.getConfigurationProperties();for(const t of Object.keys(o))m.push([t,o[t].scope]);return m.push(["launch",4]),m.push(["task",4]),m}i.getScopes=E}),define(Y[106],Q([0,1,18,7,56,2,54,22,6,9,25,34,30]),function(j,i,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class y{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,C.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,C.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const s of this.overrides)s.identifiers.includes(e)&&n.push(...s.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return D.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=P.deepClone(this.contents),s=P.deepClone(this.overrides),l=[...this.keys];for(const u of e){this.mergeContents(n,u.contents);for(const h of u.overrides){const[S]=s.filter(O=>D.equals(O.identifiers,h.identifiers));S?(this.mergeContents(S.contents,h.contents),S.keys.push(...h.keys),S.keys=D.distinct(S.keys)):s.push(P.deepClone(h))}for(const h of u.keys)l.indexOf(h)===-1&&l.push(h)}return new y(n,l,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const l of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[l],h=n[l];h&&(typeof u=="object"&&typeof h=="object"?(u=P.deepClone(u),this.mergeContents(u,h)):u=h),s[l]=u}return new y(s,this.keys,this.overrides)}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&c.isObject(e[s])&&c.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=P.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?P.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,s=null;const l=u=>{u&&(s?this.mergeContents(s,u):s=P.deepClone(u))};for(const u of this.overrides)D.equals(u.identifiers,[e])?n=u.contents:u.identifiers.includes(e)&&l(u.contents);return l(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,C.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,C.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=y;class w extends y{constructor(e={}){const n=d.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),l=Object.create(null),u=[];for(const h in n){const S=e[h],O=S!==void 0?S:n[h].default;(0,C.addToValueTree)(l,h,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const h of Object.keys(l))T.OVERRIDE_PROPERTY_REGEX.test(h)&&u.push({identifiers:(0,T.overrideIdentifiersFromKey)(h),keys:Object.keys(l[h]),contents:(0,C.toValuesTree)(l[h],S=>console.error(`Conflict in default settings file: ${S}`))});super(l,s,u)}}i.DefaultConfigurationModel=w;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:s,keys:l,overrides:u,restricted:h}=this.doParseRaw(e,n);this._configurationModel=new y(s,l,u),this._restrictedConfigurations=h||[]}doParseContent(e){let n={},s=null,l=[],u=[],h=[];function S(N){Array.isArray(l)?l.push(N):s!==null&&(l[s]=N)}let O={onObjectBegin:()=>{let N={};S(N),u.push(l),l=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{let N=[];S(N),u.push(l),l=N,s=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:S,onError:(N,_,J)=>{h.push({error:N,offset:_,length:J})}};if(e)try{b.visit(e,O),n=l[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e,n){const s=d.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),l=this.filter(e,s,!0,n);e=l.raw;const u=(0,C.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),h=Object.keys(e),S=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:u,keys:h,overrides:S,restricted:l.restricted}}filter(e,n,s,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:e,restricted:[]};const u={},h=[];for(let S in e)if(T.OVERRIDE_PROPERTY_REGEX.test(S)&&s){const O=this.filter(e[S],n,!1,l);u[S]=O.raw,h.push(...O.restricted)}else{const O=n[S],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&h.push(S),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&(l.skipRestricted&&O?.restricted||(u[S]=e[S]))}return{raw:u,restricted:h}}toOverrides(e,n){const s=[];for(const l of Object.keys(e))if(T.OVERRIDE_PROPERTY_REGEX.test(l)){const u={};for(const h in e[l])u[h]=e[l][h];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(l),keys:Object.keys(u),contents:(0,C.toValuesTree)(u,n)})}return s}}i.ConfigurationModelParser=g;class a extends I.Disposable{constructor(e,n,s,l){super();this.userSettingsResource=e,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(1)||u.isOperation(4))&&s.isEqual(u.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=a;class f{constructor(e,n,s=new y,l=new y,u=new L.ResourceMap,h=new y,S=new L.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let l;s.resource?(l=this._memoryConfigurationByResource.get(s.resource),l||(l=new y,this._memoryConfigurationByResource.set(s.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(e):l.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const l=this.getConsolidateConfigurationModel(n,s),u=this.getFolderConfigurationModelForResource(n.resource,s),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),J=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,re=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,ee=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(e):h.getValue(e),ie=l.getValue(e),he=D.distinct(D.flatten(l.overrides.map(ue=>ue.identifiers))).filter(ue=>l.getOverrideValue(e,ue)!==void 0);return{defaultValue:S,userValue:O,userLocalValue:N,userRemoteValue:_,workspaceValue:J,workspaceFolderValue:re,memoryValue:ee,value:ie,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:u?.freeze().getValue(e),override:n.overrideIdentifier?u?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:h.getValue(e),override:n.overrideIdentifier?h.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=[];if(!n){const{added:l,updated:u,removed:h}=o(this._defaultConfiguration,e);n=[...l,...u,...h]}for(const l of n)for(const u of(0,T.overrideIdentifiersFromKey)(l)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(u),S=e.getKeysForOverrideIdentifier(u),O=[...S.filter(N=>h.indexOf(N)===-1),...h.filter(N=>S.indexOf(N)===-1),...h.filter(N=>!P.equals(this._defaultConfiguration.override(u).getValue(N),e.override(u).getValue(N)))];s.push([u,O])}return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.localUserConfiguration,e),h=[...n,...s,...l];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.remoteUserConfiguration,e);let h=[...n,...s,...l];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.workspaceConfiguration,e);let h=[...n,...s,...l];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:u}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:l,updated:u,removed:h,overrides:S}=o(s,n);let O=[...l,...u,...h];return(O.length||!s)&&this.updateFolderConfiguration(e,n),{keys:O,overrides:S}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:l,removed:u,overrides:h}=o(n,void 0);return{keys:[...s,...l,...u],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const l=n.getFolder(e);l&&(s=this.getFolderConsolidatedConfiguration(l.uri)||s);const u=this._memoryConfigurationByResource.get(e);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(e);l?(n=s.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:l,keys:u}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:l,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(l=>n.add(l))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),l=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((h,S)=>(h.set(v.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new L.ResourceMap);return new f(n,s,new y,l,u,new y,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new y(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=f;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const l of r)l.keys.forEach(u=>e.add(u)),l.overrides.forEach(([u,h])=>{const S=(0,L.getOrSet)(n,u,new Set);h.forEach(O=>S.add(O))});const s=[];return n.forEach((l,u)=>s.push([u,[...l.values()]])),{keys:[...e.values()],overrides:s}}i.mergeChanges=p;class E{constructor(e,n,s,l){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=l,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(S=>u.add(S)),e.overrides.forEach(([,S])=>S.forEach(O=>u.add(O))),this.affectedKeys=[...u.values()];const h=new y;this.affectedKeys.forEach(S=>h.setValue(S,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!P.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,C.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof s=="object"&&(l=Object.keys(s)[0]);){if(e=e[l],!e)return!1;s=s[l]}return!0}}i.ConfigurationChangeEvent=E;class m extends E{constructor(e,n,s,l){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=l}}i.AllKeysConfigurationChangeEvent=m;function o(r,e){const{added:n,removed:s,updated:l}=t(e,r),u=[],h=r?.getAllOverrideIdentifiers()||[],S=e?.getAllOverrideIdentifiers()||[];if(e){const O=S.filter(N=>!h.includes(N));for(const N of O)u.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const O=h.filter(N=>!S.includes(N));for(const N of O)u.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const O of h)if(S.includes(O)){const N=t({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});u.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:l,overrides:u}}function t(r,e){const n=r?e?r.keys.filter(u=>e.keys.indexOf(u)===-1):[...r.keys]:[],s=e?r?e.keys.filter(u=>r.keys.indexOf(u)===-1):[...e.keys]:[],l=[];if(r&&e){for(const u of e.keys)if(r.keys.indexOf(u)!==-1){const h=(0,C.getConfigurationValue)(e.contents,u),S=(0,C.getConfigurationValue)(r.contents,u);P.equals(h,S)||l.push(u)}}return{added:n,removed:s,updated:l}}}),define(Y[107],Q([0,1,3,7,2,19,25,106,34,30]),function(j,i,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class C extends b.Disposable{constructor(d,y){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:w})=>this.onDidDefaultConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,y){const w=typeof d=="string"?d:void 0,g=(0,L.isConfigurationOverrides)(d)?d:(0,L.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(w,g,void 0)}updateValue(d,y,w,g){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(w,y,1)}onDidDefaultConfigurationChange(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(w,y,6)}trigger(d,y,w){const g=new P.ConfigurationChangeEvent(d,{data:y},this.configuration);g.source=w,g.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=C}),define(Y[108],Q([0,1,10]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteName=i.getRemoteAuthority=void 0;function R(I){return I.scheme===D.Schemas.vscodeRemote?I.authority:void 0}i.getRemoteAuthority=R;function b(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}i.getRemoteName=b}),define(Y[35],Q([0,1,26,13,108]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}i.getWorkspaceSupportTypeMessage=I;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=i.ExtensionType||(i.ExtensionType={}));class c{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y=="undefined"||y===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){let g=typeof y=="string"?y:y.value,a=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(g,a)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}i.ExtensionIdentifier=c;function v(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}i.isLanguagePackExtension=v;function C(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=C;function T(d,y){if(y){const w=`onResolveRemoteAuthority:${(0,b.getRemoteName)(y)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}i.isResolverExtension=T,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[21],Q([0,1,26,35]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(w,g){return w.uuid&&g.uuid?w.uuid===g.uuid:w.id===g.id?!0:(0,D.compareIgnoreCase)(w.id,g.id)===0}i.areSameExtensions=b;class I{constructor(g,a){this.version=a,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof I?b(this,g)&&this.version===g.version:!1}}i.ExtensionIdentifierWithVersion=I;function L(w,g){return`${w}.${g}`}i.getExtensionId=L;function P(w){return w.toLocaleLowerCase()}i.adoptToGalleryExtensionId=P;function c(w,g){return P(L(w,g))}i.getGalleryExtensionId=c;function v(w,g){const a=[],f=p=>{for(const E of a)if(E.some(m=>b(g(m),g(p))))return E;return null};for(const p of w){const E=f(p);E?E.push(p):a.push([p])}return a}i.groupByExtension=v;function C(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=C;function T(w){return{id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,isPreReleaseVersion:w.properties.isPreReleaseVersion,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0),...w.telemetryData}}i.getGalleryExtensionTelemetryData=T,i.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(w){const g=new Set;if(w.malicious)for(const a of w.malicious)g.add(a.id);return g}i.getMaliciousExtensionsSet=d;function y(w,g){const a=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const p=f.shift();if(p&&a.every(E=>!b(E.identifier,{id:p}))){const E=w.filter(m=>b(m.identifier,{id:p}));E.length===1&&(a.push(E[0]),f.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}i.getExtensionDependencies=y}),define(Y[23],Q([0,1,10,75,21,13]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.getIdAndVersion=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";const L=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(t){const r=L.exec(t);return r&&r[1]?[(0,b.adoptToGalleryExtensionId)(r[1]),r[2]]:[(0,b.adoptToGalleryExtensionId)(t),void 0]}i.getIdAndVersion=P;var c;(function(t){t.WIN32_X64="win32-x64",t.WIN32_IA32="win32-ia32",t.WIN32_ARM64="win32-arm64",t.LINUX_X64="linux-x64",t.LINUX_ARM64="linux-arm64",t.LINUX_ARMHF="linux-armhf",t.ALPINE_X64="alpine-x64",t.ALPINE_ARM64="alpine-arm64",t.DARWIN_X64="darwin-x64",t.DARWIN_ARM64="darwin-arm64",t.WEB="web",t.UNIVERSAL="universal",t.UNKNOWN="unknown",t.UNDEFINED="undefined"})(c=i.TargetPlatform||(i.TargetPlatform={}));function v(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=v;function C(t){switch(t){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=C;function T(t,r){switch(t){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function d(t,r){return r==="web"&&!t.includes("web")}i.isNotWebExtensionInWebTargetPlatform=d;function y(t,r,e){return d(r,e)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===e?!0:w(e).includes(t)}i.isTargetPlatformCompatible=y;function w(t){switch(t){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=w;function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}i.isIExtensionIdentifier=g;var a;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(a=i.SortBy||(i.SortBy={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f=i.SortOrder||(i.SortOrder={}));var p;(function(t){t.Install="install",t.Uninstall="uninstall"})(p=i.StatisticType||(i.StatisticType={}));var E;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(E=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.UnsupportedPreRelease="UnsupportedPreRelease",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatiblePreRelease="IncompatiblePreRelease",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class o extends Error{constructor(r,e){super(r);this.code=e,this.name=e}}i.ExtensionManagementError=o,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),i.ExtensionsLabel=(0,R.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,R.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(Y[109],Q([0,1,24,8,62,10,41,9,76,23,21,35]),function(j,i,D,R,b,I,L,P,c,v,C,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const d=a=>(0,c.localize)(0,null,a),y=(0,c.localize)(1,null,"ms-dotnettools.csharp");function w(a,f){return f?`${a.publisher}.${a.name}@${a.version}`:`${a.publisher}.${a.name}`}let g=class{constructor(f,p){this.extensionManagementService=f,this.extensionGalleryService=p}get location(){}async listExtensions(f,p,E=console){let m=await this.extensionManagementService.getInstalled(1);const o=T.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(p&&p!==""){if(o.indexOf(p.toLowerCase())<0){E.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){E.log("Possible Categories: "),o.forEach(r=>{E.log(r)});return}this.location&&E.log((0,c.localize)(2,null,this.location)),m=m.sort((r,e)=>r.identifier.id.localeCompare(e.identifier.id));let t;for(let r of m)t!==r.identifier.id&&(t=r.identifier.id,E.log(w(r.manifest,f)))}async installExtensions(f,p,E,m,o=console){const t=[],r=[];f.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),n=(u,h)=>{const S=e.find(O=>(0,C.areSameExtensions)(O.identifier,{id:u}));if(S){if(!h&&!m)return o.log((0,c.localize)(5,null,u,S.manifest.version,u)),!1;if(h&&S.manifest.version===h)return o.log((0,c.localize)(6,null,`${u}@${h}`)),!1}return!0},s=[],l=[];for(const u of f)if(u instanceof P.URI)s.push(u);else{const[h,S]=(0,v.getIdAndVersion)(u);n(h,S)&&l.push({id:h,version:S,installOptions:{...E,isBuiltin:!1}})}for(const u of p){const[h,S]=(0,v.getIdAndVersion)(u);n(h,S)&&l.push({id:h,version:S,installOptions:{...E,isBuiltin:!0}})}if(s.length&&await Promise.all(s.map(async u=>{try{const h=await this.installVSIX(u,{...E,isBuiltin:!1},m,o);h&&r.push(h)}catch(h){o.error(h.message||h.stack||h),t.push(u.toString())}})),l.length){const u=await this.getGalleryExtensions(l);await Promise.all(l.map(async h=>{const S=u.get(h.id.toLowerCase());if(S)try{const O=await this.installFromGallery(h,S,e,m,o);O&&r.push(O)}catch(O){o.error(O.message||O.stack||O),t.push(h.id)}else o.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${y}`),t.push(h.id)}))}if(t.length)throw new Error((0,c.localize)(7,null,t.join(", ")))}async installVSIX(f,p,E,m){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,E,m))try{return await this.extensionManagementService.install(f,p),m.log((0,c.localize)(8,null,(0,b.getBaseLabel)(f))),o}catch(r){if((0,R.isCancellationError)(r))return m.log((0,c.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const p=new Map,E=f.some(o=>o.installOptions.installPreReleaseVersion),m=await this.extensionGalleryService.getExtensions(f.map(o=>({...o,preRelease:E})),D.CancellationToken.None);for(const o of m)p.set(o.identifier.id.toLowerCase(),o);return p}async installFromGallery({id:f,version:p,installOptions:E},m,o,t,r){const e=await this.extensionGalleryService.getManifest(m,D.CancellationToken.None);if(e&&!this.validateExtensionKind(e,r))return null;const n=o.find(s=>(0,C.areSameExtensions)(s.identifier,m.identifier));if(n){if(m.version===n.manifest.version)return r.log((0,c.localize)(10,null,p?`${f}@${p}`:f)),null;r.log((0,c.localize)(11,null,f,m.version))}try{return E.isBuiltin?r.log(p?(0,c.localize)(12,null,f,p):(0,c.localize)(13,null,f)):r.log(p?(0,c.localize)(14,null,f,p):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(m,{...E,installGivenVersion:!!p}),r.log((0,c.localize)(16,null,f,m.version)),e}catch(s){if((0,R.isCancellationError)(s))return r.log((0,c.localize)(17,null,f)),null;throw s}}validateExtensionKind(f,p){return!0}async validateVSIX(f,p,E){const m={id:(0,C.getGalleryExtensionId)(f.publisher,f.name)},t=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,C.areSameExtensions)(m,r.identifier)&&(0,L.gt)(r.manifest.version,f.version));return t&&!p?(E.log((0,c.localize)(18,null,t.identifier.id,t.manifest.version,f.version)),!1):this.validateExtensionKind(f,E)}async uninstallExtensions(f,p,E=console){const m=async t=>{if(t instanceof P.URI){const r=await this.extensionManagementService.getManifest(t);return w(r)}return t},o=[];for(const t of f){const r=await m(t),n=(await this.extensionManagementService.getInstalled()).filter(s=>(0,C.areSameExtensions)(s.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${y}`);if(n.some(s=>s.type===0)){E.log((0,c.localize)(19,null,r));return}if(!p&&n.some(s=>s.isBuiltin)){E.log((0,c.localize)(20,null,r));return}E.log((0,c.localize)(21,null,r));for(const s of n)await this.extensionManagementService.uninstall(s),o.push(s);this.location?E.log((0,c.localize)(22,null,r,this.location)):E.log((0,c.localize)(23,null,r))}}async locateExtension(f,p=console){const E=await this.extensionManagementService.getInstalled();f.forEach(m=>{E.forEach(o=>{if(o.identifier.id===m&&o.location.scheme===I.Schemas.file){p.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};g=ge([oe(0,v.IExtensionManagementService),oe(1,v.IExtensionGalleryService)],g),i.ExtensionManagementCLIService=g}),define(Y[110],Q([0,1,3,8,2,12,19,41,9,27,15,20,23,21,16,14]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const a=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends b.Disposable{constructor(E,m,o,t){super();this.fileService=m,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=c.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,m){await this.cleanUpPromise;const o=this.getName(E),t=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const r=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(E,r,m);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",E.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return t}async delete(E){await this.cleanUpPromise,await this.fileService.del(E)}async rename(E,m,o){try{await C.Promises.rename(E.fsPath,m.fsPath)}catch(t){if(I.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${E} to ${m} with 'EPERM' error. Trying again...`),this.rename(E,m,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const m=[],o=[];for(const e of E.children){const n=this.parse(e.name);n&&o.push([n,e])}const t=(0,y.groupByExtension)(o,([e])=>e),r=[];for(const e of t)e.sort((n,s)=>P.rcompare(n[0].version,s[0].version)),m.push(...e.slice(1).map(n=>n[1].resource)),r.push(e[0][1]);r.sort((e,n)=>e.mtime-n.mtime),m.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await D.Promises.settled(m.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?`${new y.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase()}${E.properties.targetPlatform!=="undefined"?`-${E.properties.targetPlatform}`:""}`:(0,v.generateUuid)()}parse(E){const m=a.exec(E);return m&&m[1]&&m[2]?new y.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};f=ge([oe(0,T.INativeEnvironmentService),oe(1,w.IFileService),oe(2,d.IExtensionGalleryService),oe(3,g.ILogService)],f),i.ExtensionsDownloader=f}),define(Y[111],Q([0,1,2,11,15,35]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(c,v){super();this.environmentService=c,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(v.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(c){c.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Y[112],Q([0,1,137,18,3,2,10,11,15,20,23,21,53,14]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let w=class extends I.Disposable{constructor(f,p,E){super();this.extensionManagementService=f,this.logService=E,this.cache=this._register(new g(p,E)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),p=["en",...Object.keys(f)];return(0,R.distinct)(p)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const p=await this.cache.getLanguagePacks();Object.keys(p).some(E=>p[E]&&p[E].extensions.some(m=>(0,T.areSameExtensions)(m.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),E=await this.cache.update(p);return!(0,R.equals)(Object.keys(f),Object.keys(E))}};w=ge([oe(0,C.IExtensionManagementService),oe(1,v.INativeEnvironmentService),oe(2,y.ILogService)],w),i.LocalizationsService=w;let g=class extends I.Disposable{constructor(f,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(p=>{Object.keys(p).forEach(E=>delete p[E]),this.createLanguagePacksFromExtensions(p,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...p){for(const E of p)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,E);Object.keys(f).forEach(E=>this.updateHash(f[E]))}createLanguagePacksFromExtension(f,p){const E=p.identifier,m=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of m)if(p.location.scheme===L.Schemas.file&&(0,d.isValidLocalization)(o)){let t=f[o.languageId];t||(t={hash:"",extensions:[],translations:{}},f[o.languageId]=t);let r=t.extensions.filter(e=>(0,T.areSameExtensions)(e.extensionIdentifier,E))[0];r?r.version=p.manifest.version:t.extensions.push({extensionIdentifier:E,version:p.manifest.version});for(const e of o.translations)t.translations[e.id]=(0,P.join)(p.location.fsPath,e.path)}}updateHash(f){if(f){const p=(0,D.createHash)("md5");for(const E of f.extensions)p.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);f.hash=p.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(p=f(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.languagePacks=E,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),c.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>p,E=>this.logService.error(E))})}};g=ge([oe(0,v.INativeEnvironmentService),oe(1,y.ILogService)],g)}),define(Y[42],Q([0,1,17,84,34,13,30]),function(j,i,D,R,b,I,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,I.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}i.isSuccess=P;function c(w){return w.res.statusCode===204}async function v(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return c(w)?null:(await(0,D.streamToBuffer)(w.stream)).toString()}i.asText=v;async function C(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(c(w))return null;const a=(await(0,D.streamToBuffer)(w.stream)).toString();try{return JSON.parse(a)}catch(f){throw f.message+=`:
`+a,f}}i.asJson=C;function T(w){y(w)}i.updateProxyConfigurationsScope=T;let d;function y(w){const g=L.Registry.as(b.Extensions.Configuration),a=d;d={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:a?[a]:[]})}y(2)}),define(Y[113],Q([0,1,24,10,16,42]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(c,v){this.requestService=c,this.fileService=v}async download(c,v,C=D.CancellationToken.None){if(c.scheme===R.Schemas.file||c.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(c,v);return}const T={type:"GET",url:c.toString()},d=await this.requestService.request(T,C);if(d.res.statusCode===200)await this.fileService.writeFile(v,d.stream);else{const y=await(0,I.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${y}`)}}};L=ge([oe(0,I.IRequestService),oe(1,b.IFileService)],L),i.DownloadService=L}),define(Y[114],Q([0,1,115,6]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(L,P){return L.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:L.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function I(L,P,c={}){const v=(0,D.parse)(L),C=c.proxyUrl||b(v,P);if(!C)return null;const T=(0,D.parse)(C);if(!/^https?:$/.test(T.protocol||""))return null;const d={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((y,w)=>{j(["http-proxy-agent"],y,w)}))(d):new(await new Promise((y,w)=>{j(["https-proxy-agent"],y,w)}))(d)}i.getProxyAgent=I}),define(Y[116],Q([0,1,3,7,2,101,6,65,13]),function(j,i,D,R,b,I,L,P,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var C;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(C=i.WillSaveStateReason||(i.WillSaveStateReason={}));var T;(function(a){a[a.GLOBAL=0]="GLOBAL",a[a.WORKSPACE=1]="WORKSPACE"})(T=i.StorageScope||(i.StorageScope={}));var d;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(d=i.StorageTarget||(i.StorageTarget={}));class y extends b.Disposable{constructor(f={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,p){p===v?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:p,target:this.getKeyTargets(f)[p]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,p,E){return this.getStorage(p)?.get(f,E)}getBoolean(f,p,E){return this.getStorage(p)?.getBoolean(f,E)}getNumber(f,p,E){return this.getStorage(p)?.getNumber(f,E)}store(f,p,E,m){if((0,L.isUndefinedOrNull)(p)){this.remove(f,E);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,E,m),this.getStorage(E)?.set(f,p)})}remove(f,p){this.withPausedEmitters(()=>{this.updateKeyTarget(f,p,void 0),this.getStorage(p)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,p){const E=[],m=this.getKeyTargets(f);for(const o of Object.keys(m))m[o]===p&&E.push(o);return E}updateKeyTarget(f,p,E){const m=this.getKeyTargets(p);typeof E=="number"?m[f]!==E&&(m[f]=E,this.getStorage(p)?.set(v,JSON.stringify(m))):typeof m[f]=="number"&&(delete m[f],this.getStorage(p)?.set(v,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const p=this.get(v,f);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(i.IS_NEW_KEY,f)===!0}async flush(f=C.NONE){this._onWillSaveState.fire({reason:f});const p=this.getStorage(0),E=this.getStorage(1);switch(f){case C.NONE:await D.Promises.settled([p?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([p?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve()]);break}}async logStorage(){const f=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return g(f,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}i.InMemoryStorageService=w;async function g(a,f,p,E){const m=l=>{try{return JSON.parse(l)}catch{return l}},o=new Map,t=new Map;a.forEach((l,u)=>{o.set(u,l),t.set(u,m(l))});const r=new Map,e=new Map;f.forEach((l,u)=>{r.set(u,l),e.set(u,m(l))}),console.group(`Storage: Global (path: ${p})`);let n=[];o.forEach((l,u)=>{n.push({key:u,value:l})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${E})`);let s=[];r.forEach((l,u)=>{s.push({key:u,value:l})}),console.table(s),console.groupEnd(),console.log(e)}i.logStorage=g}),define(Y[117],Q([0,1,12,29,9,27]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(v){if(D.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function P(v,C,T,d,y,w,g,a,f,p){const E=Object.create(null);E["common.machineId"]=g,E.sessionID=(0,I.generateUuid)()+Date.now(),E.commitHash=y,E.version=w,E["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,D.PlatformToString)(D.platform),E["common.nodePlatform"]=R.platform,E["common.nodeArch"]=d,E["common.product"]=p||"desktop";const m=c(a||[]);m&&(E["common.msftInternal"]=m);let o=0;const t=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),D.isLinuxSnap&&(E["common.snap"]="true");const r=L(T);r&&(E["common.platformDetail"]=r);try{const e=await v.readFile(b.URI.file(f));E["common.source"]=e.value.toString().slice(0,30)}catch{}return E}i.resolveCommonProperties=P;function c(v){const C=R.env.USERDNSDOMAIN;if(!C)return!1;const T=C.toLowerCase();return v.some(d=>T===d)}i.verifyMicrosoftInternalDomain=c}),define(Y[31],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Y[118],Q([0,1,18,3,24,8,7,2,12,6,9,74,23,21,14,32,31]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{constructor(r,e,n,s){super();this.galleryService=r,this.telemetryService=e,this.logService=n,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,d.isTargetPlatformCompatible)(n,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(T.localize(0,null),d.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,e)}catch(n){throw m(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),E(n)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const e=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...r.identifier,preRelease:r.preRelease}],{targetPlatform:e,compatible:!0},b.CancellationToken.None);if(!n)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,n){if(!C.URI.isUri(e)){let S=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(S)return this.logService.info("Extensions is already requested to install",e.identifier.id),S.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],l=[],u=this.createInstallExtensionTask(r,e,n);C.URI.isUri(e)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(u.identifier,r.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:e}),this.logService.info("Installing extension:",u.identifier.id),s.push({task:u,manifest:r});let h=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:N,manifest:_}of O)if(h=h||!!_.extensionDependencies?.some(J=>(0,y.areSameExtensions)({id:J},u.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const J=this.createInstallExtensionTask(_,N,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(J.identifier,_.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:N}),this.logService.info("Installing extension:",J.identifier.id),s.push({task:J,manifest:_})}}catch(O){if(C.URI.isUri(u.source))(0,D.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,O.message),(0,D.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),O}const S=s.reduce((O,{task:N,manifest:_})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:_}),O),new Map);for(;S.size;){let O;const N=[...S.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(J=>S.has(J.toLowerCase())));N.length?O=S.size===1?N:N.filter(({task:_})=>!(_===u&&!h)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:_})=>_.identifier.id)),O=[...S.values()]),await this.joinAllSettled(O.map(async({task:_})=>{const J=new Date().getTime(),re=(0,v.isUndefined)(n.operation)?_.operation:n.operation;try{const ee=await _.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(ee,_.source,n,b.CancellationToken.None))),!C.URI.isUri(_.source)&&(m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,void 0),c.isWeb&&re!==3))try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}l.push({local:ee,identifier:_.identifier,operation:re,source:_.source})}catch(ee){throw C.URI.isUri(_.source)||m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,ee),this.logService.error("Error while installing the extension:",_.identifier.id),ee}finally{S.delete(_.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:O})=>(0,y.areSameExtensions)(O,u.identifier))[0].local}catch(S){if(s.forEach(({task:O})=>O.cancel()),l.length)try{const O=await Promise.allSettled(l.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const _=O[N],{identifier:J}=l[N];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,I.getErrorMessage)(_.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(O),l.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(s.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),S}finally{for(const{task:S,manifest:O}of s)if(!C.URI.isUri(S.source)){const N=new y.ExtensionIdentifierWithVersion(S.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const e=[],n=[],s=await Promise.allSettled(r);for(const l of s)l.status==="fulfilled"?e.push(l.value):n.push(l.reason);if(n.length)throw p(n);return e}async getAllDepsAndPackExtensionsToInstall(r,e,n,s){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled();const u=[r,...l.map(O=>O.identifier)],h=[],S=async(O,N)=>{const _=N.extensionDependencies||[],J=[..._];if(N.extensionPack){const re=n?l.find(ee=>(0,y.areSameExtensions)(ee.identifier,O)):void 0;for(const ee of N.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ie=>(0,y.areSameExtensions)({id:ie},{id:ee}))||J.every(ie=>!(0,y.areSameExtensions)({id:ie},{id:ee}))&&J.push(ee)}if(J.length){const re=[...u,...h.map(ie=>ie.gallery.identifier)],ee=J.filter(ie=>re.every(he=>!(0,y.areSameExtensions)(he,{id:ie})));if(ee.length){const ie=await this.galleryService.getExtensions(ee.map(he=>({id:he,preRelease:s})),b.CancellationToken.None);for(const he of ie){if(re.find(te=>(0,y.areSameExtensions)(te,he.identifier)))continue;const ue=_.some(te=>(0,y.areSameExtensions)({id:te},he.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(he,!0,s)}catch(te){if(te instanceof d.ExtensionManagementError&&te.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ue){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw te}h.push({gallery:x.extension,manifest:x.manifest}),await S(x.extension.identifier,x.manifest)}}}};return await S(r,e),l=await this.getInstalled(),h.filter(O=>!l.some(N=>(0,y.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,n){const s=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new d.ExtensionManagementError(T.localize(3,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new d.ExtensionManagementError(T.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const h=await this.getTargetPlatform();throw new d.ExtensionManagementError(T.localize(5,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(h)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(r,e,n);if(l){if(n&&e&&r.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(T.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],b.CancellationToken.None))[0]?new d.ExtensionManagementError(T.localize(7,null,r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(T.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const u=await this.galleryService.getManifest(l,b.CancellationToken.None);if(u===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(u.version!==l.version)throw new d.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:u}}async getCompatibleVersion(r,e,n){const s=await this.getTargetPlatform();let l=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(l=(await this.galleryService.getExtensions([{...r.identifier,preRelease:n}],{targetPlatform:s,compatible:!0},b.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(r,n,s)&&(l=r),!l&&e&&(l=await this.galleryService.getCompatibleExtension(r,n,s)),l}async unininstallExtension(r,e){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const s=(S,O)=>{const N=this.createUninstallExtensionTask(S,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),N},l=(S,O)=>{O?this.logService.error("Failed to uninstall extension:",S.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(S),void 0,O),this._onDidUninstallExtension.fire({identifier:S.identifier,error:O?.code})},u=[],h=[];try{u.push(s(r,{}));const S=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(r,S);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):u.push(s(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(u.map(O=>O.extension),S,r),await this.joinAllSettled(u.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,e,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}l(O.extension)}catch(N){const _=N instanceof d.ExtensionManagementError?N:new d.ExtensionManagementError((0,I.getErrorMessage)(N),d.ExtensionManagementErrorCode.Internal);throw l(O.extension,_),_}finally{h.push(O)}}))}catch(S){const O=S instanceof d.ExtensionManagementError?S:new d.ExtensionManagementError((0,I.getErrorMessage)(S),d.ExtensionManagementErrorCode.Internal);for(const N of u){try{N.cancel()}catch{}h.includes(N)||l(N.extension,O)}throw O}finally{for(const S of u)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(r,e,n){for(const s of r){const l=this.getDependents(s,e);if(l.length){const u=l.filter(h=>!r.some(S=>(0,y.areSameExtensions)(S.identifier,h.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(s,u,n))}}}getDependentsErrorMessage(r,e,n){return n===r?e.length===1?T.localize(9,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?T.localize(10,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):T.localize(11,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?T.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?T.localize(13,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):T.localize(14,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const l=e.filter(h=>!h.isBuiltin&&s.some(S=>(0,y.areSameExtensions)({id:S},h.identifier))),u=[];for(const h of l)u.push(...this.getAllPackExtensionsToUninstall(h,e,n));return[...l,...u]}return[]}getDependents(r,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(s=>(0,y.areSameExtensions)({id:s},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=ge([oe(0,d.IExtensionGalleryService),oe(1,a.ITelemetryService),oe(2,w.ILogService),oe(3,g.IProductService)],f),i.AbstractExtensionManagementService=f;function p(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}i.joinErrors=p;function E(t){if(t instanceof d.ExtensionManagementError)return t;const r=new d.ExtensionManagementError(t.message,d.ExtensionManagementErrorCode.Internal);return r.stack=t.stack,r}function m(t,r,e,n,s){const l=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;t.publicLogError(r,{...e,success:!s,duration:n,errorcode:l})}i.reportTelemetry=m;class o{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(r=>new Promise((e,n)=>{const s=r.onCancellationRequested(()=>{s.dispose(),n((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=o}),define(Y[36],Q([0,1,22,6,25,31]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(f,p){return Promise.resolve(void 0)}publicLog2(f,p){return this.publicLog(f,p)}publicLogError(f,p){return Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=L,i.NullTelemetryService=new L;class P{async publicLog(f,p,E){}async publicLogError(f,p,E){}}i.NullEndpointTelemetryService=P,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,f){return f.onDidChangeConfiguration(p=>{p.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(p.source),configurationKeys:w(p.sourceConfig)})})}i.configurationTelemetry=c;function v(a,f){return!(f.disableTelemetry||!a.enableTelemetry||f.extensionTestsLocationURI)}i.supportsTelemetry=v;function C(a){const f=a.getValue(I.TELEMETRY_SETTING_ID),p=a.getValue("telemetry.enableCrashReporter");if(a.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||p===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=C;function T(a){const f=Object.create(null),p=Object.create(null),E=Object.create(null);y(a,E);for(let m in E){m=m.length>150?m.substr(m.length-149):m;const o=E[m];typeof o=="number"?p[m]=o:typeof o=="boolean"?p[m]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${o.length}`),f[m]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(f[m]=o)}return{properties:f,measurements:p}}i.validateTelemetryData=T;function d(a){if(!a)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{a.indexOf(`${E}+`)===0&&(f=E)}),f}i.cleanRemoteAuthority=d;function y(a,f,p=0,E){if(!!a)for(let m of Object.getOwnPropertyNames(a)){const o=a[m],t=E?E+m:m;Array.isArray(o)?f[t]=(0,D.safeStringify)(o):o instanceof Date?f[t]=o.toISOString():(0,R.isObject)(o)?p<2?y(o,f,p+1,t+"."):f[t]=(0,D.safeStringify)(o):f[t]=o}}function w(a){if(!a)return[];const f=[];return g(f,"",a),f}function g(a,f,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(E=>g(a,f?`${f}.${E}`:E,p[E])):a.push(f)}}),define(Y[119],Q([0,1,91,36]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function b(I,L,P,c,v,C){const T={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${L.nameShort})`},d=await(0,D.getServiceMachineId)(P,v,C);return(0,R.supportsTelemetry)(L,P)&&(0,R.getTelemetryLevel)(c)===3&&(T["X-Market-User-Id"]=d),T}i.resolveMarketplaceHeaders=b}),define(Y[120],Q([0,1,18,24,8,22,12,29,6,9,25,20,23,21,48,16,14,32,42,119,116,31]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a,f,p,E,m,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const t=L.isWeb?"web":(0,d.getTargetPlatform)(L.platform,P.arch);var r;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function e(...M){return String(M.reduce((A,V)=>A|V,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class S{constructor(A=h){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,V=this.state.pageSize){return new S({...this.state,pageNumber:A,pageSize:V})}withFilter(A,...V){const B=[...this.state.criteria,...V.length?V.map(H=>({filterType:A,value:H})):[{filterType:A}]];return new S({...this.state,criteria:B})}withSortBy(A){return new S({...this.state,sortBy:A})}withSortOrder(A){return new S({...this.state,sortOrder:A})}withFlags(...A){return new S({...this.state,flags:A.reduce((V,B)=>V|B,0)})}withAssetTypes(...A){return new S({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X}],assetTypes:ce,flags:ae}}get searchText(){const A=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(M,A){const V=(M||[]).filter(B=>B.statisticName===A)[0];return V?V.value:0}function N(M){const A="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(B=>B.assetType.indexOf(A)===0).reduce((B,H)=>{const X=ee(M,H.assetType);return X&&B.push([H.assetType.substring(A.length),X]),B},[])}function _(M){if(M.properties){const A=M.properties.filter(H=>H.key===s.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=A.filter(H=>V.test(H.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return ee(M,s.Repository)}function J(M){return{uri:`${M.fallbackAssetUri}/${s.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${s.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function re(M){const A=ee(M,s.Icon);if(A)return A;const V=d.DefaultIconPath;return{uri:V,fallbackUri:V}}function ee(M,A){return M.files.filter(B=>B.assetType===A)[0]?{uri:`${M.assetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function ie(M,A){const V=M.properties?M.properties.filter(H=>H.key===A):[],B=V.length>0&&V[0].value;return B?B.split(",").map(H=>(0,y.adoptToGalleryExtensionId)(H)):[]}function he(M){const A=M.properties?M.properties.filter(V=>V.key===l.Engine):[];return A.length>0&&A[0].value||""}function ue(M){const A=M.properties?M.properties.filter(V=>V.key===l.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(M){const A=M.properties?M.properties.filter(B=>B.key===l.LocalizedLanguages):[],V=A.length>0&&A[0].value||"";return V?V.split(","):[]}function te(M){return M.indexOf("preview")!==-1}function U(M){return M.targetPlatform?(0,d.toTargetPlatform)(M.targetPlatform):"undefined"}function k(M){const A=(0,D.distinct)(M.versions.map(U)),V=!!M.tags?.includes(d.WEB_EXTENSION_TAG),B=A.indexOf("web");return V?B===-1&&A.push("web"):B!==-1&&A.splice(B,1),A}function z(M,A){const V=(0,d.getFallbackTargetPlarforms)(A);for(let B=0;B<M.length;B++){const H=M[B];if(H.version===M[B-1]?.version){let X=B;const ae=U(H);if(ae===A)for(;X>0&&M[X-1].version===H.version;)X--;else if(V.includes(ae))for(;X>0&&M[X-1].version===H.version&&U(M[X-1])!==A;)X--;X!==B&&(M.splice(B,1),M.splice(X,0,H))}}return M}i.sortExtensionVersions=z;function G(M,A,V){M.telemetryData={index:A,querySource:V}}function ne(M,A,V){const B=M.versions[0],H={manifest:ee(A,s.Manifest),readme:ee(A,s.Details),changelog:ee(A,s.Changelog),license:ee(A,s.License),repository:_(A),download:J(A),icon:re(A),coreTranslations:N(A)};return{identifier:{id:(0,y.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:A.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:O(M.statistics,"install"),rating:O(M.statistics,"averagerating"),ratingCount:O(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:V,assets:H,properties:{dependencies:ie(A,l.Dependency),extensionPack:ie(A,l.ExtensionPack),engine:he(A),localizedLanguages:x(A),targetPlatform:U(A),isPreReleaseVersion:ue(A)},hasPreReleaseVersion:ue(B),hasReleaseVersion:!0,preview:te(M.flags)}}let K=class{constructor(A,V,B,H,X,ae,ce,we){this.requestService=V,this.logService=B,this.environmentService=H,this.telemetryService=X,this.fileService=ae,this.productService=ce,this.configurationService=we;const fe=ce.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,V,B){const H=R.CancellationToken.isCancellationToken(V)?{}:V,X=R.CancellationToken.isCancellationToken(V)?V:B,ae=[],ce=[],we=[],fe=[];let se=!0;for(const Ee of A){Ee.uuid?ce.push(Ee.uuid):ae.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);we.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&fe.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),se=se&&!!Ee.hasPreRelease&&!Ie}if(!ce.length&&!ae.length)return[];let pe=new S().withPage(1,A.length);ce.length&&(pe=pe.withFilter(n.ExtensionId,...ce)),ae.length&&(pe=pe.withFilter(n.ExtensionName,...ae)),(H.queryAllVersions||se)&&(pe=pe.withFlags(pe.flags,r.IncludeVersions));const{extensions:me}=await this.queryGalleryExtensions(pe,{targetPlatform:H.targetPlatform??t,includePreRelease:we,versions:fe,compatible:!!H.compatible},X);return H.source&&me.forEach((Ee,Ie)=>G(Ee,Ie,H.source)),me}async getCompatibleExtension(A,V,B){if((0,d.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(A,V,B))return A;const H=new S().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,A.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:B,compatible:!0,includePreRelease:V},R.CancellationToken.None);return X[0]||null}async isExtensionCompatible(A,V,B){if(!(0,d.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B)||!V&&A.properties.isPreReleaseVersion)return!1;let H=A.properties.engine;if(!H){const X=await this.getManifest(A,R.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,w.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(A,V,B,H,X){if(!(0,d.isTargetPlatformCompatible)(U(A),H,X)||V!=="any"&&ue(A)!==(V==="prerelease"))return!1;if(B){const ae=await this.getEngine(A);if(!(0,w.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}return!0}async query(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=A.text||"";const H=(0,I.getOrDefault)(A,se=>se.pageSize,50);let X=new S().withPage(1,H);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,pe,me)=>(X=X.withFilter(n.Category,me||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,pe,me)=>(X=X.withFilter(n.Tag,me||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(n.SearchText,B)),X=X.withSortBy(0)):A.ids?X=X.withFilter(n.ExtensionId,...A.ids):A.names?X=X.withFilter(n.ExtensionName,...A.names):X=X.withSortBy(4),typeof A.sortBy=="number"&&(X=X.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(X=X.withSortOrder(A.sortOrder));const ae=async(se,pe)=>{const{extensions:me,total:Ee}=await this.queryGalleryExtensions(se,{targetPlatform:t,compatible:!1,includePreRelease:!!A.includePreRelease},pe);return me.forEach((Ie,Me)=>G(Ie,(se.pageNumber-1)*se.pageSize+Me,A.source)),{extensions:me,total:Ee}},{extensions:ce,total:we}=await ae(X,V),fe=async(se,pe)=>{if(pe.isCancellationRequested)throw new b.CancellationError;const{extensions:me}=await ae(X.withPage(se+1),pe);return me};return{firstPage:ce,total:we,pageSize:X.pageSize,getPage:fe}}async queryGalleryExtensions(A,V,B){const H=A.flags;!!(A.flags&r.IncludeLatestVersionOnly)&&!!(A.flags&r.IncludeVersions)&&(A=A.withFlags(A.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(A.flags&r.IncludeLatestVersionOnly)&&!(A.flags&r.IncludeVersions)&&(A=A.withFlags(A.flags,r.IncludeLatestVersionOnly)),V.versions?.length&&(A=A.withFlags(A.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),A=A.withFlags(A.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:X,total:ae}=await this.queryRawGalleryExtensions(A,B);if(!(A.flags&r.IncludeLatestVersionOnly)){const se=[];for(const pe of X){const me=await this.toGalleryExtensionWithCriteria(pe,V,!0);me&&se.push(me)}return{extensions:se,total:ae}}const we=[],fe=new Map;for(let se=0;se<X.length;se++){const pe=X[se],me={id:(0,y.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ee=(0,c.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Me=>(0,y.areSameExtensions)(Me,me))?.includePreRelease;let Ie=await this.toGalleryExtensionWithCriteria(pe,V,!1);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==V.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(pe.extensionId,se):we.push([se,Ie])}if(fe.size){const se=new Date().getTime(),pe=new S().withFlags(H&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:me}=await this.queryGalleryExtensions(pe,V,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-se,count:fe.size});for(const Ee of me){const Ie=fe.get(Ee.identifier.uuid);we.push([Ie,Ee])}}return{extensions:we.sort((se,pe)=>se[0]-pe[0]).map(([,se])=>se),total:ae}}async toGalleryExtensionWithCriteria(A,V,B){const H={id:(0,y.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},X=V.versions?.find(fe=>(0,y.areSameExtensions)(fe,H))?.version,ae=(0,c.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(fe=>(0,y.areSameExtensions)(fe,H))?.includePreRelease,ce=k(A),we=z(A.versions,V.targetPlatform);if(V.compatible&&B&&(0,d.isNotWebExtensionInWebTargetPlatform)(ce,V.targetPlatform))return null;for(let fe=0;fe<we.length;fe++){const se=we[fe];if(!(X&&se.version!==X)){if(await this.isValidVersion(se,ae?"any":"release",V.compatible,ce,V.targetPlatform))return ne(A,se,ce);if(X&&se.version===X)return null}}return X||V.compatible?null:ne(A,A.versions[0],ce)}async queryRawGalleryExtensions(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,e(r.Unpublished));const B=await this.commonHeadersPromise,H=JSON.stringify(A.raw),X={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ae=new Date().getTime();let ce,we,fe=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},V),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:fe};const se=await(0,p.asJson)(ce);if(se){const pe=se.results[0],me=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return fe=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:fe}}return{galleryExtensions:[],total:fe}}catch(se){throw we=se,se}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-ae,success:!!ce&&(0,p.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:we?(0,b.isCancellationError)(we)?"canceled":(0,b.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,V,B,H){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${A}.${V}/version/${B}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${V}/${B}/stats?statType=${H}`),ae=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:X,headers:we},R.CancellationToken.None)}catch{}}async download(A,V,B){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const H=(0,y.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),ae=se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:se}),ce=B===2?"install":B===3?"update":"",we=ce?{uri:`${A.assets.download.uri}${v.URI.parse(A.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${A.assets.download.fallbackUri}${v.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:A.assets.download,fe=await this.getAsset(we);await this.fileService.writeFile(V,fe.stream),ae(new Date().getTime()-X)}async getReadme(A,V){if(A.assets.readme){const B=await this.getAsset(A.assets.readme,{},V);return await(0,p.asText)(B)||""}return""}async getManifest(A,V){if(A.assets.manifest){const B=await this.getAsset(A.assets.manifest,{},V),H=await(0,p.asText)(B);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(A,V){const B=ee(A,s.Manifest);if(!B)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(B,{headers:H});return await(0,p.asJson)(X)}async getCoreTranslation(A,V){const B=A.assets.coreTranslations.filter(H=>H[0]===V.toUpperCase())[0];if(B){const H=await this.getAsset(B[1]),X=await(0,p.asText)(H);return X?JSON.parse(X):null}return null}async getChangelog(A,V){if(A.assets.changelog){const B=await this.getAsset(A.assets.changelog,{},V);return await(0,p.asText)(B)||""}return""}async getAllCompatibleVersions(A,V,B){let H=new S().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?H=H.withFilter(n.ExtensionId,A.identifier.uuid):H=H.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,R.CancellationToken.None);if(!X.length)return[];const ae=k(X[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(ae,B))return[];const ce=[],we=new Set;return await Promise.all(X[0].versions.map(async fe=>{try{if(we.has(fe.version))return;await this.isValidVersion(fe,V?"any":"release",!0,ae,B)&&(ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}),we.add(fe.version))}catch{}})),ce}async getAsset(A,V={},B=R.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},ae={...H,...V.headers||{}};V={...V,...X,headers:ae};const ce=A.uri,we=A.fallbackUri,fe={...V,url:ce};try{const se=await this.requestService.request(fe,B);if(se.res.statusCode===200)return se;const pe=await(0,p.asText)(se);throw new Error(`Expected 200, got back ${se.res.statusCode} instead.

${pe}`)}catch(se){if((0,b.isCancellationError)(se))throw se;const pe=(0,b.getErrorMessage)(se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:pe});const me={...V,url:we};return this.requestService.request(me,B)}}async getEngine(A){let V=he(A);if(!V){const B=await this.getManifestFromRawExtensionVersion(A,R.CancellationToken.None);if(!B)throw new Error("Manifest was not found");V=B.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,p.asJson)(A),B=[],H={};if(V){for(const X of V.malicious)B.push({id:X});if(V.unsupported)for(const X of Object.keys(V.unsupported)){const ae=V.unsupported[X];(0,c.isBoolean)(ae)||(H[X.toLowerCase()]=ae.preReleaseExtension)}if(V.migrateToPreRelease)for(const[X,ae]of Object.entries(V.migrateToPreRelease))(!ae.engine||(0,w.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]=ae)}return{malicious:B,unsupportedPreReleaseExtensions:H}}};K=ge([oe(1,p.IRequestService),oe(2,a.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],K);let Z=class extends K{constructor(A,V,B,H,X,ae,ce,we){super(A,V,B,H,X,ae,ce,we)}};Z=ge([oe(0,m.IStorageService),oe(1,p.IRequestService),oe(2,a.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let q=class extends K{constructor(A,V,B,H,X,ae,ce){super(void 0,A,V,B,H,X,ae,ce)}};q=ge([oe(0,p.IRequestService),oe(1,a.ILogService),oe(2,T.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,g.IFileService),oe(5,f.IProductService),oe(6,C.IConfigurationService)],q),i.ExtensionGalleryServiceWithNoStorageService=q}),define(Y[121],Q([0,1,2,22,12,26,85,25,34,122,30,31,36]),function(j,i,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let y=class{constructor(a,f){this._configurationService=f,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=a.appenders,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(p),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(a,f){this._experimentProperties[a]=f}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const a=await this._commonProperties;let f=a.sessionID,p=a["common.machineId"],E=a["common.firstSessionDate"],m=a["common.msftInternal"];return{sessionId:f,machineId:p,firstSessionDate:E,msftInternal:m}}dispose(){this._disposables.dispose()}_log(a,f,p,E){return this.telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(m=>{p=(0,R.mixin)(p,m),p=(0,R.mixin)(p,this._experimentProperties),p=(0,R.cloneAndChange)(p,o=>{if(typeof o=="string")return this._cleanupInfo(o,E)}),this._appenders.forEach(o=>o.log(a,p))},m=>{console.error(m)})}publicLog(a,f,p){return this._log(a,3,f,p)}publicLog2(a,f,p){return this.publicLog(a,f,p)}publicLogError(a,f){return this.sendErrorTelemetry?this._log(a,2,f,!0):Promise.resolve(void 0)}publicLogError2(a,f){return this.publicLogError(a,f)}_anonymizeFilePaths(a){let f=a;const p=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(a);if(!r)break;p.push([r.index,t.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const t=m.exec(a);if(!t)break;!E.test(t[0])&&p.every(([r,e])=>t.index<r||t.index>=e)&&(f+=a.substring(o,t.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}return o<a.length&&(f+=a.substr(o)),f}_removePropertiesWithPossibleUserInfo(a){if(!a)return a;const f=a.toLowerCase(),p=/@[a-zA-Z0-9-.]+/,E=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,m=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return E.test(f)?"<REDACTED: secret>":p.test(f)?"<REDACTED: email>":m.test(f)?"<REDACTED: token>":a}_cleanupInfo(a,f){let p=a;f&&(p=this._anonymizeFilePaths(p));for(let E of this._cleanupPatterns)p=p.replace(E,"");return p=this._removePropertiesWithPossibleUserInfo(p),p}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ge([oe(1,P.IConfigurationService)],y),i.TelemetryService=y;function w(){const g=(0,L.localize)(0,null,v.default.nameLong),a=v.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=b.isWeb?"":(0,L.localize)(3,null),p=(0,L.localize)(4,null),E=(0,L.localize)(5,null),m=(0,L.localize)(6,null),o=(0,L.localize)(7,null),t=`
|       | ${p} | ${E} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${g} ${a} ${f}

&nbsp;

${o}
${t}

&nbsp;

${r}
`}C.Registry.as(c.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[T.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(c.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[T.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,L.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,L.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${T.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[123],Q([0,1,8,22,36]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function I(P,c){const v=await new Promise((T,d)=>{j(["applicationinsights"],T,d)});let C;return v.defaultClient?(C=new v.TelemetryClient(P),C.channel.setUseDiskRetryCaching(!0)):(v.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=v.defaultClient),P.indexOf("AIF-")===0&&(C.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),C}class L{constructor(c,v,C,T,d){this._eventPrefix=c,this._defaultData=v,this.testCollector=T,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(v=>{c(v)},v=>{(0,D.onUnexpectedError)(v),console.error(v)})}}log(c,v){if(!!this._aiClient){v=(0,R.mixin)(v,this._defaultData),v=(0,b.validateTelemetryData)(v),this.testCollector&&(v.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+c,properties:v.properties,measurements:v.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(v=>{try{v.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=L}),define(Y[124],Q([0,1,11,15]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(I,L){const P=Object.create(null),c=(C,T)=>{const d=JSON.parse(C);P[T]=d};if(L){const C=[],T=await R.Promises.readdir(L);for(const y of T)try{(await R.Promises.stat((0,D.join)(L,y))).isDirectory()&&C.push(y)}catch{}const d=[];for(const y of C)(await R.Promises.readdir((0,D.join)(L,y))).filter(g=>g==="telemetry.json").length===1&&d.push(y);for(const y of d){const w=(await R.Promises.readFile((0,D.join)(L,y,"telemetry.json"))).toString();c(w,y)}}let v=(await R.Promises.readFile((0,D.join)(I,"telemetry-core.json"))).toString();return c(v,"vscode-core"),v=(await R.Promises.readFile((0,D.join)(I,"telemetry-extensions.json"))).toString(),c(v,"vscode-extensions"),JSON.stringify(P,null,4)}i.buildTelemetryMessage=b}),define(Y[125],Q([0,1,39,11,86,24,28,8,12,27,70,138,3]),function(j,i,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const y=1e4;let w;async function g(f,p,E){return p["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(E)&&!p["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(E)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(m,o)=>{const t=new I.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),o(new Error((0,b.localize)(0,null)))},y);try{m(await a(f,t.token))}catch(e){!(0,P.isCancellationError)(e)&&!t.token.isCancellationRequested?o(new Error((0,b.localize)(1,null,(0,L.toErrorMessage)(e)))):m({})}finally{clearTimeout(r),t.dispose()}})),w)}i.getResolvedShellEnv=g;async function a(f,p){const E=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",E);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",m);const o=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",r);const e=await(0,C.getSystemShell)(c.OS,r);return f.trace("getUnixShellEnvironment#shell",e),new Promise((n,s)=>{if(p.isCancellationRequested)return s((0,P.canceled)());const l=(0,R.basename)(e);let u,h;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(u=`& '${process.execPath}' ${S} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,h=["-Login","-Command"]):(u=`'${process.execPath}' ${S} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?h=["-ic"]:h=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),u);const O=(0,D.spawn)(e,[...h,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(O.kill(),s((0,P.canceled)()))),O.on("error",J=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),s(J)});const N=[];O.stdout.on("data",J=>N.push(J));const _=[];O.stderr.on("data",J=>_.push(J)),O.on("close",(J,re)=>{const ee=Buffer.concat(N).toString("utf8");f.trace("getUnixShellEnvironment#raw",ee);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),J||re)return s(new Error((0,b.localize)(2,null,J,re)));const he=t.exec(ee),ue=he?he[1]:"{}";try{const x=JSON.parse(ue);E?x.ELECTRON_RUN_AS_NODE=E:delete x.ELECTRON_RUN_AS_NODE,m?x.ELECTRON_NO_ATTACH_CONSOLE=m:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",x),n(x)}catch(x){f.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(x)),s(x)}})})}}),define(Y[37],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Y[126],Q([0,1,7,2,9,20,21,16,14,37]),function(j,i,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let C=class extends R.Disposable{constructor(d,y,w,g,a){super();this.extensionsManagementService=d,this.logService=g,this.uriIdentityService=a,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(p=>{this.installedExtensions=p.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(p=>this.onInstallExtension(p))),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const f=b.URI.file(w.extensionsPath);this._register(y.watch(f)),this._register(D.Event.filter(y.onDidFilesChange,p=>p.rawChanges.some(E=>this.doesChangeAffects(E,f)))(()=>this.onDidChange()))}doesChangeAffects(d,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),y)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const y of d)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(y=>!(0,L.areSameExtensions)(y,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,L.areSameExtensions)(y,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),y=d.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(a=>(0,L.areSameExtensions)(a,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),w=this.installedExtensions.filter(g=>this.installingExtensions.some(a=>(0,L.areSameExtensions)(a,g))?!1:d.every(a=>!(0,L.areSameExtensions)(a.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=d.map(g=>g.identifier),(y.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:w})}}};C=ge([oe(1,P.IFileService),oe(2,I.INativeEnvironmentService),oe(3,c.ILogService),oe(4,v.IUriIdentityService)],C),i.ExtensionsWatcher=C}),define(Y[127],Q([0,1,37,92,16,19,58,7,2]),function(j,i,D,R,b,I,L,P,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class v{constructor(d){this.uri=d,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let C=class{constructor(d){this._fileService=d,this._dispooables=new c.DisposableStore,this._limit=2**16;const y=new Map,w=g=>{let a=y.get(g.scheme);return a===void 0&&(a=d.hasProvider(g)&&!this._fileService.hasCapability(g,1024),y.set(g.scheme,a)),a};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new I.ExtUri(w),this._canonicalUris=new L.SkipList((g,a)=>this.extUri.compare(g,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,I.normalizePath)(d));let y=this._canonicalUris.get(d);return y?y.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new v(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((w,g)=>w[1].touch<g[1].touch?1:w[1].touch>g[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let w=0;w<y;w++)this._canonicalUris.set(d[w][0],d[w][1].touch())}};C=ge([oe(0,b.IFileService)],C),i.UriIdentityService=C,(0,R.registerSingleton)(D.IUriIdentityService,C,!0)}),define(Y[43],Q([0,1,103,3,11,6,15,72,139,140]),function(j,i,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class C extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=C;function T(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function d(o){if(o instanceof C)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new C(t,o)}function y(o,t,r,e,n,s){const l=b.dirname(t),u=b.join(e,l);if(!u.startsWith(e))return Promise.reject(new Error(P.localize(0,null,t)));const h=b.join(e,t);let S;return s.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(L.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!s.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:r}),S.once("close",()=>O()),S.once("error",N),o.once("error",N),o.pipe(S)}catch(_){N(_)}}))}function w(o,t,r,e){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((l,u)=>{const h=new R.Sequencer,S=O=>{O.isCancellationRequested||(s++,o.readEntry())};o.once("error",u),o.once("close",()=>n.then(()=>{e.isCancellationRequested||o.entryCount===s?l():u(new C("Incomplete",new Error(P.localize(1,null,s,o.entryCount))))},u)),o.readEntry(),o.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){S(e);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const re=b.join(t,N);n=(0,R.createCancelablePromise)(ee=>L.Promises.mkdir(re,{recursive:!0}).then(()=>S(ee)).then(void 0,u));return}const _=a(o,O),J=T(O);n=(0,R.createCancelablePromise)(re=>h.queue(()=>_.then(ee=>y(ee,N,J,t,r,re).then(()=>S(re)))).then(null,u))})})}function g(o,t=!1){return new Promise((r,e)=>{(0,c.open)(o,t?{lazyEntries:!0}:void 0,(n,s)=>{n?e(d(n)):r((0,I.assertIsDefined)(s))})})}function a(o,t){return new Promise((r,e)=>{o.openReadStream(t,(n,s)=>{n?e(d(n)):r((0,I.assertIsDefined)(s))})})}function f(o,t){return new Promise((r,e)=>{const n=new v.ZipFile;t.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const s=(0,D.createWriteStream)(o);n.outputStream.pipe(s),n.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(o))})}i.zip=f;function p(o,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=g(o,!0);return r.overwrite&&(s=s.then(l=>L.Promises.rm(t).then(()=>l))),s.then(l=>w(l,t,{sourcePathRegex:n},e))}i.extract=p;function E(o,t){return g(o).then(r=>new Promise((e,n)=>{r.on("entry",s=>{s.fileName===t&&a(r,s).then(l=>e(l),l=>n(l))}),r.once("close",()=>n(new Error(P.localize(2,null,t))))}))}function m(o,t){return E(o,t).then(r=>new Promise((e,n)=>{const s=[];r.once("error",n),r.on("data",l=>s.push(l)),r.on("end",()=>e(Buffer.concat(s)))}))}i.buffer=m}),define(Y[128],Q([0,1,43,78]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(I){return(0,D.buffer)(I,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=b}),define(Y[129],Q([0,1,18,3,8,2,10,11,12,19,41,9,27,15,43,79,20,23,21,90,35,16,14,32]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a,f,p,E,m,o,t,r){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let e=class extends I.Disposable{constructor(s,l,u,h,S){super();this.beforeRemovingExtension=s,this.fileService=l,this.logService=u,this.environmentService=h,this.productService=S,this._devSystemExtensionsPath=null,this.systemExtensionsPath=h.builtinExtensionsPath,this.extensionsPath=h.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const l=[];(s===null||s===0)&&l.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal)))),(s===null||s===1)&&l.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal))));try{const u=await Promise.all(l);return(0,D.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[l,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(h=>!l[new p.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]),s&&(u=(0,p.groupByExtension)(u,S=>S.identifier).map(S=>S.sort((O,N)=>C.rcompare(O.manifest.version,N.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(s,l,u,h){const S=s.key(),O=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),N=P.join(this.extensionsPath,S);try{await y.Promises.rm(N)}catch{try{await y.Promises.rm(N)}catch{}throw new f.ExtensionManagementError((0,g.localize)(0,null,N,s.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(s,l,O,h);let _=await this.scanExtension(T.URI.file(O),1);if(!_)throw new Error((0,g.localize)(1,null,O));await this.storeMetadata(_,{...u,installedTimestamp:Date.now()});try{await this.rename(s,O,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(J){try{await y.Promises.rm(O)}catch{}if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",s.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(J)}. Deleted from extracted location`,O),J}try{_=await this.scanExtension(T.URI.file(N),1)}catch{}if(_)return _;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(s,l){return this.setMetadata(s,l),await this.storeMetadata(s,{...l,installedTimestamp:s.installedTimestamp}),s}async storeMetadata(s,l){l.isMachineScoped=l.isMachineScoped||void 0,l.isBuiltin=l.isBuiltin||void 0,l.installedTimestamp=l.installedTimestamp||void 0;const u=P.join(s.location.fsPath,"package.json"),h=await y.Promises.readFile(u,"utf8"),{manifest:S}=await this.parseManifest(h);return S.__metadata=l,await y.Promises.writeFile(u,JSON.stringify(S,null,"	")),s}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...s){const l=s.map(u=>new p.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version));await this.withUninstalledExtensions(u=>{l.forEach(h=>u[h.key()]=!0)})}async setInstalled(s){await this.withUninstalledExtensions(h=>delete h[s.key()]);const u=(await this.scanExtensions(1)).find(h=>new p.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).equals(s))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,1)):null}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let l;try{l=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(h){if(h.code!=="ENOENT")throw h}let u={};if(l)try{u=JSON.parse(l)}catch{}return s&&(s(u),Object.keys(u).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await y.Promises.rm(this.uninstalledPath)),u})}async removeExtension(s,l){this.logService.trace(`Deleting ${l} extension from disk`,s.identifier.id,s.location.fsPath),await y.Promises.rm(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(l=>delete l[new p.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version).key()])}async extractAtLocation(s,l,u,h){this.logService.trace(`Started extracting the extension from ${l} to ${u}`);try{await y.Promises.rm(u)}catch(S){throw new f.ExtensionManagementError(this.joinErrors(S).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(l,u,{sourcePath:"extension",overwrite:!0},h),this.logService.info(`Extracted extension to ${u}:`,s.id)}catch(S){try{await y.Promises.rm(u)}catch{}let O=f.ExtensionManagementErrorCode.Extract;throw S instanceof w.ExtractError&&(S.type==="CorruptZip"?O=f.ExtensionManagementErrorCode.CorruptZip:S.type==="Incomplete"&&(O=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(S.message,O)}}async rename(s,l,u,h){try{await y.Promises.rename(l,u)}catch(S){if(c.isWindows&&S&&S.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${l} to ${u} with 'EPERM' error. Trying again...`,s.id),this.rename(s,l,u,h);throw new f.ExtensionManagementError(S.message||(0,g.localize)(3,null,l,u),S.code||f.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return s;const l=this.scanDevSystemExtensions(),[u,h]=await Promise.all([s,l]);return[...u,...h]}async scanExtensionsInDir(s,l){const u=new R.Limiter(10),h=await this.fileService.resolve(T.URI.file(s));return h.children?(await Promise.all(h.children.filter(O=>O.isDirectory).map(O=>u.queue(async()=>l===1&&(0,v.basename)(O.resource).indexOf(".")===0?null:this.scanExtension(O.resource,l))))).filter(O=>O&&O.identifier):[]}async scanExtension(s,l){try{const u=await this.fileService.resolve(s);if(u.children){const{manifest:h,metadata:S}=await this.readManifest(s.fsPath),O=u.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,N=u.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource,_={id:(0,p.getGalleryExtensionId)(h.publisher,h.name)},J={type:l,identifier:_,manifest:h,location:s,readmeUrl:O,changelogUrl:N,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:l===0};return this.setMetadata(J,S),J}}catch(u){l!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){const s=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){const s=this.getDevSystemExtensionsList();if(s.length){const l=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",l.length),l.filter(u=>s.some(h=>(0,p.areSameExtensions)(u.identifier,{id:h})))}else return[]}setMetadata(s,l){s.publisherDisplayName=l?.publisherDisplayName||null,s.publisherId=l?.publisherId||null,s.identifier.uuid=l?.id,s.isMachineScoped=!!l?.isMachineScoped,s.isPreReleaseVersion=!!l?.isPreReleaseVersion,s.preRelease=!!l?.preRelease,s.isBuiltin=s.type===0||!!l?.isBuiltin,s.installedTimestamp=l?.installedTimestamp}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),l=await this.scanAllUserExtensions(),u=new Set;for(const O of l)s[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]||u.add(O.identifier.id.toLowerCase());const h=(0,p.groupByExtension)(l,O=>O.identifier);await R.Promises.settled(h.map(async O=>{const N=O.sort((_,J)=>C.rcompare(_.manifest.version,J.manifest.version))[0];u.has(N.identifier.id.toLowerCase())||await this.beforeRemovingExtension(N)}));const S=l.filter(O=>s[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]);await R.Promises.settled(S.map(O=>this.removeUninstalledExtension(O)))}async removeOutdatedExtensions(){const s=await this.scanAllUserExtensions(),l=[],u=(0,p.groupByExtension)(s,h=>h.identifier);l.push(...(0,D.flatten)(u.map(h=>h.sort((S,O)=>C.rcompare(S.manifest.version,O.manifest.version)).slice(1)))),await R.Promises.settled(l.map(h=>this.removeExtension(h,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const l=Array.isArray(s)?s:[s];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((u,h)=>new Error(`${u.message}${u.message?",":""}${h instanceof Error?h.message:h}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(L.FileAccess.asFileUri("",j).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(s){const l=[y.Promises.readFile(P.join(s,"package.json"),"utf8").then(O=>this.parseManifest(O)),y.Promises.readFile(P.join(s,"package.nls.json"),"utf8").then(void 0,O=>O.code!=="ENOENT"?Promise.reject(O):"{}").then(O=>JSON.parse(O))],[{manifest:u,metadata:h},S]=await Promise.all(l);return{manifest:(0,E.localizeManifest)(u,S),metadata:h}}parseManifest(s){return new Promise((l,u)=>{try{const h=JSON.parse(s);h.publisher||(h.publisher=m.UNDEFINED_PUBLISHER);const S=h.__metadata||null;l({manifest:h,metadata:S})}catch{u(new Error((0,g.localize)(4,null)))}})}};e=ge([oe(1,o.IFileService),oe(2,t.ILogService),oe(3,a.INativeEnvironmentService),oe(4,r.IProductService)],e),i.ExtensionsScanner=e}),define(Y[130],Q([0,1,28,8,10,11,12,29,19,41,6,9,27,15,43,77,49,20,118,23,21,110,98,128,111,129,126,48,16,13,14,32,31,37]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a,f,p,E,m,o,t,r,e,n,s,l,u,h,S,O,N,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let J=class extends p.AbstractExtensionManagementService{constructor(x,te,U,k,z,G,ne,K,Z){super(x,te,U,K);this.environmentService=k,this.downloadService=z,this.fileService=ne;const q=this._register(G.createInstance(t.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,A=>q.postUninstall(A))),this.manifestCache=this._register(new e.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const M=this._register(new s.ExtensionsWatcher(this,ne,k,U,Z));this._register(M.onDidChangeExtensionsByAnotherSource(({added:A,removed:V})=>{A.length&&this._onDidInstallExtensions.fire(A.map(B=>({identifier:B.identifier,operation:1,local:B}))),V.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const x=await this.isAlpineLinux(),te=(0,E.getTargetPlatform)(x?"alpine":L.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",te),te})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let x;try{x=(await this.fileService.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{x=(await this.fileService.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(U){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(U))}}return!!x&&(x.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const te=await this.collectFiles(x),U=await(0,w.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,te);return T.URI.file(U)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const te=await this.downloadVsix(x),U=I.resolve(te.fsPath);return(0,r.getManifest)(U)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,te={}){this.logService.trace("ExtensionManagementService#install",x.toString());const U=await this.downloadVsix(x),k=await(0,r.getManifest)(I.resolve(U.fsPath));if(k.engines&&k.engines.vscode&&!(0,l.isEngineValid)(k.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,(0,m.getGalleryExtensionId)(k.publisher,k.name),this.productService.version));return this.installExtension(k,U,te)}async updateMetadata(x,te){this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id);const U={...x.manifest.__metadata||{},...te};return te.isPreReleaseVersion&&(U.preRelease=!0),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,U),this.manifestCache.invalidate(),x}async updateExtensionScope(x,te){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:te}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===b.Schemas.file)return x;const te=(0,c.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(x,te),te}createInstallExtensionTask(x,te,U){return T.URI.isUri(te)?new ie(x,te,U,this.galleryService,this.extensionsScanner,this.logService):new ee(te,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,te){return new he(x,te,this.extensionsScanner)}async collectFiles(x){const te=async k=>{let z=await y.Promises.readdir(k);z=z.map(K=>I.join(k,K));const G=await Promise.all(z.map(K=>y.Promises.stat(K)));let ne=Promise.resolve([]);return G.forEach((K,Z)=>{const q=z[Z];K.isFile()&&(ne=ne.then(M=>[...M,q])),K.isDirectory()&&(ne=ne.then(M=>te(q).then(A=>[...M,...A])))}),ne};return(await te(x.location.fsPath)).map(k=>({path:`extension/${I.relative(x.location.fsPath,k)}`,localPath:k}))}};J=ge([oe(0,E.IExtensionGalleryService),oe(1,N.ITelemetryService),oe(2,S.ILogService),oe(3,f.INativeEnvironmentService),oe(4,a.IDownloadService),oe(5,h.IInstantiationService),oe(6,u.IFileService),oe(7,O.IProductService),oe(8,_.IUriIdentityService)],J),i.ExtensionManagementService=J;class re extends p.AbstractExtensionTask{constructor(x,te,U,k){super();this.identifier=x,this.source=te,this.extensionsScanner=U,this.logService=k,this._operation=2}get operation(){return this._operation}async installExtension(x,te){try{const U=await this.unsetUninstalledAndGetLocal(x.identifierWithVersion);if(U)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...x.metadata}):U}catch{throw L.isMacintosh?new E.ExtensionManagementError(g.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(g.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(x,te)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const U=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),U}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.key()]}async extract({zipPath:x,identifierWithVersion:te,metadata:U},k){let z=await this.extensionsScanner.extractUserExtension(te,x,U,k);return this.logService.info("Extracting completed.",te.id),z}}class ee extends re{constructor(x,te,U,k,z){super(x.identifier,x,k,z);this.gallery=x,this.options=te,this.extensionsDownloader=U}async doRun(x){const U=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,m.areSameExtensions)(z.identifier,this.gallery.identifier));U&&(this._operation=3);const k=await this.downloadInstallableExtension(this.gallery,this._operation);k.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin,k.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,k.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease);try{const z=await this.installExtension(k,x);return U&&v.neq(U.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(U),z}catch(z){throw await this.deleteDownloadedVSIX(k.zipPath),z}}async deleteDownloadedVSIX(x){try{await this.extensionsDownloader.delete(T.URI.file(x))}catch(te){this.logService.warn("Error while deleting the downloaded vsix",x.toString(),(0,R.getErrorMessage)(te))}}async downloadInstallableExtension(x,te){const U={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName};let k;try{this.logService.trace("Started downloading extension:",x.identifier.id),k=(await this.extensionsDownloader.downloadExtension(x,te)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,k)}catch(z){throw new E.ExtensionManagementError((0,p.joinErrors)(z).message,E.ExtensionManagementErrorCode.Download)}try{const z=await(0,r.getManifest)(k);return{zipPath:k,identifierWithVersion:new m.ExtensionIdentifierWithVersion(x.identifier,z.version),metadata:U}}catch(z){throw await this.deleteDownloadedVSIX(k),new E.ExtensionManagementError((0,p.joinErrors)(z).message,E.ExtensionManagementErrorCode.Invalid)}}}class ie extends re{constructor(x,te,U,k,z,G){super({id:(0,m.getGalleryExtensionId)(x.publisher,x.name)},te,z,G);this.manifest=x,this.location=te,this.options=U,this.galleryService=k}async doRun(x){const te=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),k=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,m.areSameExtensions)(this.identifier,G.identifier)),z=await this.getMetadata(this.identifier.id,this.manifest.version,x);if(z.isMachineScoped=this.options.isMachineScoped||k?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||k?.isBuiltin,k)if(this._operation=3,te.equals(new m.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version)))try{await this.extensionsScanner.removeExtension(k,"existing")}catch{throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(k.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(k);else{const G=await this.unsetUninstalledAndGetLocal(te);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:te,metadata:z},x)}async getMetadata(x,te,U){try{let[k]=await this.galleryService.getExtensions([{id:x,version:te}],U);if(k||([k]=await this.galleryService.getExtensions([{id:x}],U)),k)return{id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class he extends p.AbstractExtensionTask{constructor(x,te,U){super();this.extension=x,this.options=te,this.extensionsScanner=U}async doRun(x){const te=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const k=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);te.push(...U.filter(z=>k.equals(new m.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else te.push(...U.filter(k=>(0,m.areSameExtensions)(k.identifier,this.extension.identifier)));if(!te.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...te),this.options.remove)for(const k of te)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(k)}catch(z){throw new Error(g.localize(6,null,(0,D.toErrorMessage)(z)))}}}}),define(Y[131],Q([0,1,115,3,17,8,2,6,25,20,125,14,114,141]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let w=class extends L.Disposable{constructor(a,f,p){super();this.environmentService=f,this.logService=p,this.configure(a.getValue()),this._register(a.onDidChangeConfiguration(()=>this.configure(a.getValue()),this))}configure(a){this.proxyUrl=a.http&&a.http.proxy,this.strictSSL=!!(a.http&&a.http.proxyStrictSSL),this.authorization=a.http&&a.http.proxyAuthorization}async request(a,f){this.logService.trace("RequestService#request",a.url);const{proxyUrl:p,strictSSL:E}=this;let m;try{m=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...m},t=a.agent?a.agent:await(0,d.getProxyAgent)(a.url||"",o,{proxyUrl:p,strictSSL:E});return a.agent=t,a.strictSSL=E,this.authorization&&(a.headers={...a.headers||{},"Proxy-Authorization":this.authorization}),this._request(a,f)}async getNodeRequest(a){return((0,D.parse)(a.url).protocol==="https:"?await new Promise((E,m)=>{j(["https"],E,m)}):await new Promise((E,m)=>{j(["http"],E,m)})).request}_request(a,f){return R.Promises.withAsyncBody(async(p,E)=>{let m;const o=(0,D.parse)(a.url),t=a.getRawRequest?a.getRawRequest(a):await this.getNodeRequest(a),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,P.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(r.auth=a.user+":"+a.password),m=t(r,e=>{const n=(0,P.isNumber)(a.followRedirects)?a.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...a,url:e.headers.location,followRedirects:n-1},f).then(p,E);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,y.createGunzip)())),p({res:e,stream:(0,b.streamToBufferReadableStream)(s)})}}),m.on("error",E),a.timeout&&m.setTimeout(a.timeout),a.data&&typeof a.data=="string"&&m.write(a.data),m.end(),f.onCancellationRequested(()=>{m.abort(),E((0,I.canceled)())})})}async resolveProxy(a){}};w=ge([oe(0,c.IConfigurationService),oe(1,v.INativeEnvironmentService),oe(2,T.ILogService)],w),i.RequestService=w}),define(Y[142],Q([0,1,33,3,17,28,8,2,10,11,29,9,15,25,107,49,113,20,89,120,23,109,130,16,100,102,40,97,52,53,112,14,104,122,32,42,131,117,31,121,36,123,124,37,127]),function(j,i,D,R,b,I,L,P,c,v,C,T,d,y,w,g,a,f,p,E,m,o,t,r,e,n,s,l,u,h,S,O,N,_,J,re,ee,ie,he,ue,x,te,U,k,z){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class G extends P.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,q]=await this.initServices();return Z.invokeFunction(async M=>{const A=M.get(O.ILogService),V=M.get(r.IFileService),B=M.get(f.INativeEnvironmentService),H=M.get(m.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(B,H,V),await Promise.all(q.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new u.ServiceCollection,q={_serviceBrand:void 0,..._.default};Z.set(J.IProductService,q);const M=new p.NativeEnvironmentService(this.argv,q);Z.set(f.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(we=>we?d.Promises.mkdir(we,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(M),V=[];V.push(new N.SpdLogLogger("cli",(0,v.join)(M.logsPath,"cli.log"),!0,!1,A)),A===O.LogLevel.Trace&&V.push(new O.ConsoleLogger(A));const B=this._register(new O.MultiplexLogService(V));Z.set(O.ILogService,B);const H=this._register(new e.FileService(B));Z.set(r.IFileService,H);const X=this._register(new n.DiskFileSystemProvider(B));H.registerProvider(c.Schemas.file,X);const ae=this._register(new w.ConfigurationService(M.settingsResource,H));Z.set(y.IConfigurationService,ae),await ae.initialize(),Z.set(k.IUriIdentityService,new z.UriIdentityService(H)),Z.set(re.IRequestService,new s.SyncDescriptor(ee.RequestService)),Z.set(g.IDownloadService,new s.SyncDescriptor(a.DownloadService)),Z.set(m.IExtensionManagementService,new s.SyncDescriptor(t.ExtensionManagementService)),Z.set(m.IExtensionGalleryService,new s.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),Z.set(m.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(h.ILocalizationsService,new s.SyncDescriptor(S.LocalizationsService));const ce=[];if((0,x.supportsTelemetry)(q,M)){q.aiConfig&&q.aiConfig.asimovKey&&ce.push(new te.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:we,extensionsPath:fe,installSourcePath:se}=M,pe={appenders:ce,sendErrorTelemetry:!1,commonProperties:(async()=>{let me;try{const Ee=await d.Promises.readFile((0,v.join)(M.userDataPath,"storage.json"));me=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&B.error(Ee)}return(0,ie.resolveCommonProperties)(H,(0,D.release)(),(0,D.hostname)(),process.arch,q.commit,q.version,me,q.msftInternalDomains,se)})(),piiPaths:[we,fe]};Z.set(he.ITelemetryService,new s.SyncDescriptor(ue.TelemetryService,[pe]))}else Z.set(he.ITelemetryService,x.NullTelemetryService);return[new l.InstantiationService(Z),ce]}registerErrorHandler(Z){(0,L.setUnexpectedErrorHandler)(q=>{const M=(0,I.toErrorMessage)(q,!0);!M||Z.error(`[uncaught exception in CLI]: ${M}`)}),process.on("uncaughtException",q=>(0,L.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,L.onUnexpectedError)(q))}async doRun(Z,q,M){if(this.argv["install-source"])return this.setInstallSource(Z,M,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const A={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],A,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(q=>/\.vsix$/i.test(q)?T.URI.file((0,v.isAbsolute)(q)?q:(0,v.join)((0,C.cwd)(),q)):q)}async setInstallSource(Z,q,M){await q.writeFile(T.URI.file(Z.installSourcePath),b.VSBuffer.fromString(M.slice(0,30)))}}async function ne(K){const Z=new G(K);try{await Z.run()}finally{Z.dispose()}}i.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f90f60e956e725f98732c33dec3029087d0f19e4/core/vs/code/node/cliProcessMain.js.map
